class Ae {
  /**
  Get the line description around the given position.
  */
  lineAt(e) {
    if (e < 0 || e > this.length)
      throw new RangeError(`Invalid position ${e} in document of length ${this.length}`);
    return this.lineInner(e, !1, 1, 0);
  }
  /**
  Get the description for the given (1-based) line number.
  */
  line(e) {
    if (e < 1 || e > this.lines)
      throw new RangeError(`Invalid line number ${e} in ${this.lines}-line document`);
    return this.lineInner(e, !0, 1, 0);
  }
  /**
  Replace a range of the text with the given content.
  */
  replace(e, t, r) {
    [e, t] = Ui(this, e, t);
    let i = [];
    return this.decompose(
      0,
      e,
      i,
      2
      /* Open.To */
    ), r.length && r.decompose(
      0,
      r.length,
      i,
      3
      /* Open.To */
    ), this.decompose(
      t,
      this.length,
      i,
      1
      /* Open.From */
    ), ho.from(i, this.length - (t - e) + r.length);
  }
  /**
  Append another document to this one.
  */
  append(e) {
    return this.replace(this.length, this.length, e);
  }
  /**
  Retrieve the text between the given points.
  */
  slice(e, t = this.length) {
    [e, t] = Ui(this, e, t);
    let r = [];
    return this.decompose(e, t, r, 0), ho.from(r, t - e);
  }
  /**
  Test whether this text is equal to another instance.
  */
  eq(e) {
    if (e == this)
      return !0;
    if (e.length != this.length || e.lines != this.lines)
      return !1;
    let t = this.scanIdentical(e, 1), r = this.length - this.scanIdentical(e, -1), i = new Rs(this), s = new Rs(e);
    for (let l = t, o = t; ; ) {
      if (i.next(l), s.next(l), l = 0, i.lineBreak != s.lineBreak || i.done != s.done || i.value != s.value)
        return !1;
      if (o += i.value.length, i.done || o >= r)
        return !0;
    }
  }
  /**
  Iterate over the text. When `dir` is `-1`, iteration happens
  from end to start. This will return lines and the breaks between
  them as separate strings.
  */
  iter(e = 1) {
    return new Rs(this, e);
  }
  /**
  Iterate over a range of the text. When `from` > `to`, the
  iterator will run in reverse.
  */
  iterRange(e, t = this.length) {
    return new Wm(this, e, t);
  }
  /**
  Return a cursor that iterates over the given range of lines,
  _without_ returning the line breaks between, and yielding empty
  strings for empty lines.
  
  When `from` and `to` are given, they should be 1-based line numbers.
  */
  iterLines(e, t) {
    let r;
    if (e == null)
      r = this.iter();
    else {
      t == null && (t = this.lines + 1);
      let i = this.line(e).from;
      r = this.iterRange(i, Math.max(i, t == this.lines + 1 ? this.length : t <= 1 ? 0 : this.line(t - 1).to));
    }
    return new Um(r);
  }
  /**
  Return the document as a string, using newline characters to
  separate lines.
  */
  toString() {
    return this.sliceString(0);
  }
  /**
  Convert the document to an array of lines (which can be
  deserialized again via [`Text.of`](https://codemirror.net/6/docs/ref/#state.Text^of)).
  */
  toJSON() {
    let e = [];
    return this.flatten(e), e;
  }
  /**
  @internal
  */
  constructor() {
  }
  /**
  Create a `Text` instance for the given array of lines.
  */
  static of(e) {
    if (e.length == 0)
      throw new RangeError("A document must have at least one line");
    return e.length == 1 && !e[0] ? Ae.empty : e.length <= 32 ? new Ke(e) : ho.from(Ke.split(e, []));
  }
}
class Ke extends Ae {
  constructor(e, t = C5(e)) {
    super(), this.text = e, this.length = t;
  }
  get lines() {
    return this.text.length;
  }
  get children() {
    return null;
  }
  lineInner(e, t, r, i) {
    for (let s = 0; ; s++) {
      let l = this.text[s], o = i + l.length;
      if ((t ? r : o) >= e)
        return new _5(i, o, r, l);
      i = o + 1, r++;
    }
  }
  decompose(e, t, r, i) {
    let s = e <= 0 && t >= this.length ? this : new Ke(Ic(this.text, e, t), Math.min(t, this.length) - Math.max(0, e));
    if (i & 1) {
      let l = r.pop(), o = co(s.text, l.text.slice(), 0, s.length);
      if (o.length <= 32)
        r.push(new Ke(o, l.length + s.length));
      else {
        let a = o.length >> 1;
        r.push(new Ke(o.slice(0, a)), new Ke(o.slice(a)));
      }
    } else
      r.push(s);
  }
  replace(e, t, r) {
    if (!(r instanceof Ke))
      return super.replace(e, t, r);
    [e, t] = Ui(this, e, t);
    let i = co(this.text, co(r.text, Ic(this.text, 0, e)), t), s = this.length + r.length - (t - e);
    return i.length <= 32 ? new Ke(i, s) : ho.from(Ke.split(i, []), s);
  }
  sliceString(e, t = this.length, r = `
`) {
    [e, t] = Ui(this, e, t);
    let i = "";
    for (let s = 0, l = 0; s <= t && l < this.text.length; l++) {
      let o = this.text[l], a = s + o.length;
      s > e && l && (i += r), e < a && t > s && (i += o.slice(Math.max(0, e - s), t - s)), s = a + 1;
    }
    return i;
  }
  flatten(e) {
    for (let t of this.text)
      e.push(t);
  }
  scanIdentical() {
    return 0;
  }
  static split(e, t) {
    let r = [], i = -1;
    for (let s of e)
      r.push(s), i += s.length + 1, r.length == 32 && (t.push(new Ke(r, i)), r = [], i = -1);
    return i > -1 && t.push(new Ke(r, i)), t;
  }
}
let ho = class Ei extends Ae {
  constructor(e, t) {
    super(), this.children = e, this.length = t, this.lines = 0;
    for (let r of e)
      this.lines += r.lines;
  }
  lineInner(e, t, r, i) {
    for (let s = 0; ; s++) {
      let l = this.children[s], o = i + l.length, a = r + l.lines - 1;
      if ((t ? a : o) >= e)
        return l.lineInner(e, t, r, i);
      i = o + 1, r = a + 1;
    }
  }
  decompose(e, t, r, i) {
    for (let s = 0, l = 0; l <= t && s < this.children.length; s++) {
      let o = this.children[s], a = l + o.length;
      if (e <= a && t >= l) {
        let u = i & ((l <= e ? 1 : 0) | (a >= t ? 2 : 0));
        l >= e && a <= t && !u ? r.push(o) : o.decompose(e - l, t - l, r, u);
      }
      l = a + 1;
    }
  }
  replace(e, t, r) {
    if ([e, t] = Ui(this, e, t), r.lines < this.lines)
      for (let i = 0, s = 0; i < this.children.length; i++) {
        let l = this.children[i], o = s + l.length;
        if (e >= s && t <= o) {
          let a = l.replace(e - s, t - s, r), u = this.lines - l.lines + a.lines;
          if (a.lines < u >> 4 && a.lines > u >> 6) {
            let h = this.children.slice();
            return h[i] = a, new Ei(h, this.length - (t - e) + r.length);
          }
          return super.replace(s, o, a);
        }
        s = o + 1;
      }
    return super.replace(e, t, r);
  }
  sliceString(e, t = this.length, r = `
`) {
    [e, t] = Ui(this, e, t);
    let i = "";
    for (let s = 0, l = 0; s < this.children.length && l <= t; s++) {
      let o = this.children[s], a = l + o.length;
      l > e && s && (i += r), e < a && t > l && (i += o.sliceString(e - l, t - l, r)), l = a + 1;
    }
    return i;
  }
  flatten(e) {
    for (let t of this.children)
      t.flatten(e);
  }
  scanIdentical(e, t) {
    if (!(e instanceof Ei))
      return 0;
    let r = 0, [i, s, l, o] = t > 0 ? [0, 0, this.children.length, e.children.length] : [this.children.length - 1, e.children.length - 1, -1, -1];
    for (; ; i += t, s += t) {
      if (i == l || s == o)
        return r;
      let a = this.children[i], u = e.children[s];
      if (a != u)
        return r + a.scanIdentical(u, t);
      r += a.length + 1;
    }
  }
  static from(e, t = e.reduce((r, i) => r + i.length + 1, -1)) {
    let r = 0;
    for (let m of e)
      r += m.lines;
    if (r < 32) {
      let m = [];
      for (let g of e)
        g.flatten(m);
      return new Ke(m, t);
    }
    let i = Math.max(
      32,
      r >> 5
      /* Tree.BranchShift */
    ), s = i << 1, l = i >> 1, o = [], a = 0, u = -1, h = [];
    function c(m) {
      let g;
      if (m.lines > s && m instanceof Ei)
        for (let v of m.children)
          c(v);
      else m.lines > l && (a > l || !a) ? (f(), o.push(m)) : m instanceof Ke && a && (g = h[h.length - 1]) instanceof Ke && m.lines + g.lines <= 32 ? (a += m.lines, u += m.length + 1, h[h.length - 1] = new Ke(g.text.concat(m.text), g.length + 1 + m.length)) : (a + m.lines > i && f(), a += m.lines, u += m.length + 1, h.push(m));
    }
    function f() {
      a != 0 && (o.push(h.length == 1 ? h[0] : Ei.from(h, u)), u = -1, a = h.length = 0);
    }
    for (let m of e)
      c(m);
    return f(), o.length == 1 ? o[0] : new Ei(o, t);
  }
};
Ae.empty = /* @__PURE__ */ new Ke([""], 0);
function C5(n) {
  let e = -1;
  for (let t of n)
    e += t.length + 1;
  return e;
}
function co(n, e, t = 0, r = 1e9) {
  for (let i = 0, s = 0, l = !0; s < n.length && i <= r; s++) {
    let o = n[s], a = i + o.length;
    a >= t && (a > r && (o = o.slice(0, r - i)), i < t && (o = o.slice(t - i)), l ? (e[e.length - 1] += o, l = !1) : e.push(o)), i = a + 1;
  }
  return e;
}
function Ic(n, e, t) {
  return co(n, [""], e, t);
}
class Rs {
  constructor(e, t = 1) {
    this.dir = t, this.done = !1, this.lineBreak = !1, this.value = "", this.nodes = [e], this.offsets = [t > 0 ? 1 : (e instanceof Ke ? e.text.length : e.children.length) << 1];
  }
  nextInner(e, t) {
    for (this.done = this.lineBreak = !1; ; ) {
      let r = this.nodes.length - 1, i = this.nodes[r], s = this.offsets[r], l = s >> 1, o = i instanceof Ke ? i.text.length : i.children.length;
      if (l == (t > 0 ? o : 0)) {
        if (r == 0)
          return this.done = !0, this.value = "", this;
        t > 0 && this.offsets[r - 1]++, this.nodes.pop(), this.offsets.pop();
      } else if ((s & 1) == (t > 0 ? 0 : 1)) {
        if (this.offsets[r] += t, e == 0)
          return this.lineBreak = !0, this.value = `
`, this;
        e--;
      } else if (i instanceof Ke) {
        let a = i.text[l + (t < 0 ? -1 : 0)];
        if (this.offsets[r] += t, a.length > Math.max(0, e))
          return this.value = e == 0 ? a : t > 0 ? a.slice(e) : a.slice(0, a.length - e), this;
        e -= a.length;
      } else {
        let a = i.children[l + (t < 0 ? -1 : 0)];
        e > a.length ? (e -= a.length, this.offsets[r] += t) : (t < 0 && this.offsets[r]--, this.nodes.push(a), this.offsets.push(t > 0 ? 1 : (a instanceof Ke ? a.text.length : a.children.length) << 1));
      }
    }
  }
  next(e = 0) {
    return e < 0 && (this.nextInner(-e, -this.dir), e = this.value.length), this.nextInner(e, this.dir);
  }
}
class Wm {
  constructor(e, t, r) {
    this.value = "", this.done = !1, this.cursor = new Rs(e, t > r ? -1 : 1), this.pos = t > r ? e.length : 0, this.from = Math.min(t, r), this.to = Math.max(t, r);
  }
  nextInner(e, t) {
    if (t < 0 ? this.pos <= this.from : this.pos >= this.to)
      return this.value = "", this.done = !0, this;
    e += Math.max(0, t < 0 ? this.pos - this.to : this.from - this.pos);
    let r = t < 0 ? this.pos - this.from : this.to - this.pos;
    e > r && (e = r), r -= e;
    let { value: i } = this.cursor.next(e);
    return this.pos += (i.length + e) * t, this.value = i.length <= r ? i : t < 0 ? i.slice(i.length - r) : i.slice(0, r), this.done = !this.value, this;
  }
  next(e = 0) {
    return e < 0 ? e = Math.max(e, this.from - this.pos) : e > 0 && (e = Math.min(e, this.to - this.pos)), this.nextInner(e, this.cursor.dir);
  }
  get lineBreak() {
    return this.cursor.lineBreak && this.value != "";
  }
}
class Um {
  constructor(e) {
    this.inner = e, this.afterBreak = !0, this.value = "", this.done = !1;
  }
  next(e = 0) {
    let { done: t, lineBreak: r, value: i } = this.inner.next(e);
    return t && this.afterBreak ? (this.value = "", this.afterBreak = !1) : t ? (this.done = !0, this.value = "") : r ? this.afterBreak ? this.value = "" : (this.afterBreak = !0, this.next()) : (this.value = i, this.afterBreak = !1), this;
  }
  get lineBreak() {
    return !1;
  }
}
typeof Symbol < "u" && (Ae.prototype[Symbol.iterator] = function() {
  return this.iter();
}, Rs.prototype[Symbol.iterator] = Wm.prototype[Symbol.iterator] = Um.prototype[Symbol.iterator] = function() {
  return this;
});
class _5 {
  /**
  @internal
  */
  constructor(e, t, r, i) {
    this.from = e, this.to = t, this.number = r, this.text = i;
  }
  /**
  The length of the line (not including any line break after it).
  */
  get length() {
    return this.to - this.from;
  }
}
function Ui(n, e, t) {
  return e = Math.max(0, Math.min(n.length, e)), [e, Math.max(e, Math.min(n.length, t))];
}
let Ii = /* @__PURE__ */ "lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((n) => n ? parseInt(n, 36) : 1);
for (let n = 1; n < Ii.length; n++)
  Ii[n] += Ii[n - 1];
function M5(n) {
  for (let e = 1; e < Ii.length; e += 2)
    if (Ii[e] > n)
      return Ii[e - 1] <= n;
  return !1;
}
function zc(n) {
  return n >= 127462 && n <= 127487;
}
const Pc = 8205;
function kt(n, e, t = !0, r = !0) {
  return (t ? Gm : T5)(n, e, r);
}
function Gm(n, e, t) {
  if (e == n.length)
    return e;
  e && jm(n.charCodeAt(e)) && $m(n.charCodeAt(e - 1)) && e--;
  let r = ft(n, e);
  for (e += vr(r); e < n.length; ) {
    let i = ft(n, e);
    if (r == Pc || i == Pc || t && M5(i))
      e += vr(i), r = i;
    else if (zc(i)) {
      let s = 0, l = e - 2;
      for (; l >= 0 && zc(ft(n, l)); )
        s++, l -= 2;
      if (s % 2 == 0)
        break;
      e += 2;
    } else
      break;
  }
  return e;
}
function T5(n, e, t) {
  for (; e > 0; ) {
    let r = Gm(n, e - 2, t);
    if (r < e)
      return r;
    e--;
  }
  return 0;
}
function jm(n) {
  return n >= 56320 && n < 57344;
}
function $m(n) {
  return n >= 55296 && n < 56320;
}
function ft(n, e) {
  let t = n.charCodeAt(e);
  if (!$m(t) || e + 1 == n.length)
    return t;
  let r = n.charCodeAt(e + 1);
  return jm(r) ? (t - 55296 << 10) + (r - 56320) + 65536 : t;
}
function Ym(n) {
  return n <= 65535 ? String.fromCharCode(n) : (n -= 65536, String.fromCharCode((n >> 10) + 55296, (n & 1023) + 56320));
}
function vr(n) {
  return n < 65536 ? 1 : 2;
}
const V0 = /\r\n?|\n/;
var at = /* @__PURE__ */ function(n) {
  return n[n.Simple = 0] = "Simple", n[n.TrackDel = 1] = "TrackDel", n[n.TrackBefore = 2] = "TrackBefore", n[n.TrackAfter = 3] = "TrackAfter", n;
}(at || (at = {}));
class $r {
  // Sections are encoded as pairs of integers. The first is the
  // length in the current document, and the second is -1 for
  // unaffected sections, and the length of the replacement content
  // otherwise. So an insertion would be (0, n>0), a deletion (n>0,
  // 0), and a replacement two positive numbers.
  /**
  @internal
  */
  constructor(e) {
    this.sections = e;
  }
  /**
  The length of the document before the change.
  */
  get length() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2)
      e += this.sections[t];
    return e;
  }
  /**
  The length of the document after the change.
  */
  get newLength() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2) {
      let r = this.sections[t + 1];
      e += r < 0 ? this.sections[t] : r;
    }
    return e;
  }
  /**
  False when there are actual changes in this set.
  */
  get empty() {
    return this.sections.length == 0 || this.sections.length == 2 && this.sections[1] < 0;
  }
  /**
  Iterate over the unchanged parts left by these changes. `posA`
  provides the position of the range in the old document, `posB`
  the new position in the changed document.
  */
  iterGaps(e) {
    for (let t = 0, r = 0, i = 0; t < this.sections.length; ) {
      let s = this.sections[t++], l = this.sections[t++];
      l < 0 ? (e(r, i, s), i += s) : i += l, r += s;
    }
  }
  /**
  Iterate over the ranges changed by these changes. (See
  [`ChangeSet.iterChanges`](https://codemirror.net/6/docs/ref/#state.ChangeSet.iterChanges) for a
  variant that also provides you with the inserted text.)
  `fromA`/`toA` provides the extent of the change in the starting
  document, `fromB`/`toB` the extent of the replacement in the
  changed document.
  
  When `individual` is true, adjacent changes (which are kept
  separate for [position mapping](https://codemirror.net/6/docs/ref/#state.ChangeDesc.mapPos)) are
  reported separately.
  */
  iterChangedRanges(e, t = !1) {
    W0(this, e, t);
  }
  /**
  Get a description of the inverted form of these changes.
  */
  get invertedDesc() {
    let e = [];
    for (let t = 0; t < this.sections.length; ) {
      let r = this.sections[t++], i = this.sections[t++];
      i < 0 ? e.push(r, i) : e.push(i, r);
    }
    return new $r(e);
  }
  /**
  Compute the combined effect of applying another set of changes
  after this one. The length of the document after this set should
  match the length before `other`.
  */
  composeDesc(e) {
    return this.empty ? e : e.empty ? this : Km(this, e);
  }
  /**
  Map this description, which should start with the same document
  as `other`, over another set of changes, so that it can be
  applied after it. When `before` is true, map as if the changes
  in `other` happened before the ones in `this`.
  */
  mapDesc(e, t = !1) {
    return e.empty ? this : U0(this, e, t);
  }
  mapPos(e, t = -1, r = at.Simple) {
    let i = 0, s = 0;
    for (let l = 0; l < this.sections.length; ) {
      let o = this.sections[l++], a = this.sections[l++], u = i + o;
      if (a < 0) {
        if (u > e)
          return s + (e - i);
        s += o;
      } else {
        if (r != at.Simple && u >= e && (r == at.TrackDel && i < e && u > e || r == at.TrackBefore && i < e || r == at.TrackAfter && u > e))
          return null;
        if (u > e || u == e && t < 0 && !o)
          return e == i || t < 0 ? s : s + a;
        s += a;
      }
      i = u;
    }
    if (e > i)
      throw new RangeError(`Position ${e} is out of range for changeset of length ${i}`);
    return s;
  }
  /**
  Check whether these changes touch a given range. When one of the
  changes entirely covers the range, the string `"cover"` is
  returned.
  */
  touchesRange(e, t = e) {
    for (let r = 0, i = 0; r < this.sections.length && i <= t; ) {
      let s = this.sections[r++], l = this.sections[r++], o = i + s;
      if (l >= 0 && i <= t && o >= e)
        return i < e && o > t ? "cover" : !0;
      i = o;
    }
    return !1;
  }
  /**
  @internal
  */
  toString() {
    let e = "";
    for (let t = 0; t < this.sections.length; ) {
      let r = this.sections[t++], i = this.sections[t++];
      e += (e ? " " : "") + r + (i >= 0 ? ":" + i : "");
    }
    return e;
  }
  /**
  Serialize this change desc to a JSON-representable value.
  */
  toJSON() {
    return this.sections;
  }
  /**
  Create a change desc from its JSON representation (as produced
  by [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeDesc.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e) || e.length % 2 || e.some((t) => typeof t != "number"))
      throw new RangeError("Invalid JSON representation of ChangeDesc");
    return new $r(e);
  }
  /**
  @internal
  */
  static create(e) {
    return new $r(e);
  }
}
class tt extends $r {
  constructor(e, t) {
    super(e), this.inserted = t;
  }
  /**
  Apply the changes to a document, returning the modified
  document.
  */
  apply(e) {
    if (this.length != e.length)
      throw new RangeError("Applying change set to a document with the wrong length");
    return W0(this, (t, r, i, s, l) => e = e.replace(i, i + (r - t), l), !1), e;
  }
  mapDesc(e, t = !1) {
    return U0(this, e, t, !0);
  }
  /**
  Given the document as it existed _before_ the changes, return a
  change set that represents the inverse of this set, which could
  be used to go from the document created by the changes back to
  the document as it existed before the changes.
  */
  invert(e) {
    let t = this.sections.slice(), r = [];
    for (let i = 0, s = 0; i < t.length; i += 2) {
      let l = t[i], o = t[i + 1];
      if (o >= 0) {
        t[i] = o, t[i + 1] = l;
        let a = i >> 1;
        for (; r.length < a; )
          r.push(Ae.empty);
        r.push(l ? e.slice(s, s + l) : Ae.empty);
      }
      s += l;
    }
    return new tt(t, r);
  }
  /**
  Combine two subsequent change sets into a single set. `other`
  must start in the document produced by `this`. If `this` goes
  `docA` → `docB` and `other` represents `docB` → `docC`, the
  returned value will represent the change `docA` → `docC`.
  */
  compose(e) {
    return this.empty ? e : e.empty ? this : Km(this, e, !0);
  }
  /**
  Given another change set starting in the same document, maps this
  change set over the other, producing a new change set that can be
  applied to the document produced by applying `other`. When
  `before` is `true`, order changes as if `this` comes before
  `other`, otherwise (the default) treat `other` as coming first.
  
  Given two changes `A` and `B`, `A.compose(B.map(A))` and
  `B.compose(A.map(B, true))` will produce the same document. This
  provides a basic form of [operational
  transformation](https://en.wikipedia.org/wiki/Operational_transformation),
  and can be used for collaborative editing.
  */
  map(e, t = !1) {
    return e.empty ? this : U0(this, e, t, !0);
  }
  /**
  Iterate over the changed ranges in the document, calling `f` for
  each, with the range in the original document (`fromA`-`toA`)
  and the range that replaces it in the new document
  (`fromB`-`toB`).
  
  When `individual` is true, adjacent changes are reported
  separately.
  */
  iterChanges(e, t = !1) {
    W0(this, e, t);
  }
  /**
  Get a [change description](https://codemirror.net/6/docs/ref/#state.ChangeDesc) for this change
  set.
  */
  get desc() {
    return $r.create(this.sections);
  }
  /**
  @internal
  */
  filter(e) {
    let t = [], r = [], i = [], s = new js(this);
    e: for (let l = 0, o = 0; ; ) {
      let a = l == e.length ? 1e9 : e[l++];
      for (; o < a || o == a && s.len == 0; ) {
        if (s.done)
          break e;
        let h = Math.min(s.len, a - o);
        ct(i, h, -1);
        let c = s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0;
        ct(t, h, c), c > 0 && Tn(r, t, s.text), s.forward(h), o += h;
      }
      let u = e[l++];
      for (; o < u; ) {
        if (s.done)
          break e;
        let h = Math.min(s.len, u - o);
        ct(t, h, -1), ct(i, h, s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0), s.forward(h), o += h;
      }
    }
    return {
      changes: new tt(t, r),
      filtered: $r.create(i)
    };
  }
  /**
  Serialize this change set to a JSON-representable value.
  */
  toJSON() {
    let e = [];
    for (let t = 0; t < this.sections.length; t += 2) {
      let r = this.sections[t], i = this.sections[t + 1];
      i < 0 ? e.push(r) : i == 0 ? e.push([r]) : e.push([r].concat(this.inserted[t >> 1].toJSON()));
    }
    return e;
  }
  /**
  Create a change set for the given changes, for a document of the
  given length, using `lineSep` as line separator.
  */
  static of(e, t, r) {
    let i = [], s = [], l = 0, o = null;
    function a(h = !1) {
      if (!h && !i.length)
        return;
      l < t && ct(i, t - l, -1);
      let c = new tt(i, s);
      o = o ? o.compose(c.map(o)) : c, i = [], s = [], l = 0;
    }
    function u(h) {
      if (Array.isArray(h))
        for (let c of h)
          u(c);
      else if (h instanceof tt) {
        if (h.length != t)
          throw new RangeError(`Mismatched change set length (got ${h.length}, expected ${t})`);
        a(), o = o ? o.compose(h.map(o)) : h;
      } else {
        let { from: c, to: f = c, insert: m } = h;
        if (c > f || c < 0 || f > t)
          throw new RangeError(`Invalid change range ${c} to ${f} (in doc of length ${t})`);
        let g = m ? typeof m == "string" ? Ae.of(m.split(r || V0)) : m : Ae.empty, v = g.length;
        if (c == f && v == 0)
          return;
        c < l && a(), c > l && ct(i, c - l, -1), ct(i, f - c, v), Tn(s, i, g), l = f;
      }
    }
    return u(e), a(!o), o;
  }
  /**
  Create an empty changeset of the given length.
  */
  static empty(e) {
    return new tt(e ? [e, -1] : [], []);
  }
  /**
  Create a changeset from its JSON representation (as produced by
  [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeSet.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e))
      throw new RangeError("Invalid JSON representation of ChangeSet");
    let t = [], r = [];
    for (let i = 0; i < e.length; i++) {
      let s = e[i];
      if (typeof s == "number")
        t.push(s, -1);
      else {
        if (!Array.isArray(s) || typeof s[0] != "number" || s.some((l, o) => o && typeof l != "string"))
          throw new RangeError("Invalid JSON representation of ChangeSet");
        if (s.length == 1)
          t.push(s[0], 0);
        else {
          for (; r.length < i; )
            r.push(Ae.empty);
          r[i] = Ae.of(s.slice(1)), t.push(s[0], r[i].length);
        }
      }
    }
    return new tt(t, r);
  }
  /**
  @internal
  */
  static createSet(e, t) {
    return new tt(e, t);
  }
}
function ct(n, e, t, r = !1) {
  if (e == 0 && t <= 0)
    return;
  let i = n.length - 2;
  i >= 0 && t <= 0 && t == n[i + 1] ? n[i] += e : e == 0 && n[i] == 0 ? n[i + 1] += t : r ? (n[i] += e, n[i + 1] += t) : n.push(e, t);
}
function Tn(n, e, t) {
  if (t.length == 0)
    return;
  let r = e.length - 2 >> 1;
  if (r < n.length)
    n[n.length - 1] = n[n.length - 1].append(t);
  else {
    for (; n.length < r; )
      n.push(Ae.empty);
    n.push(t);
  }
}
function W0(n, e, t) {
  let r = n.inserted;
  for (let i = 0, s = 0, l = 0; l < n.sections.length; ) {
    let o = n.sections[l++], a = n.sections[l++];
    if (a < 0)
      i += o, s += o;
    else {
      let u = i, h = s, c = Ae.empty;
      for (; u += o, h += a, a && r && (c = c.append(r[l - 2 >> 1])), !(t || l == n.sections.length || n.sections[l + 1] < 0); )
        o = n.sections[l++], a = n.sections[l++];
      e(i, u, s, h, c), i = u, s = h;
    }
  }
}
function U0(n, e, t, r = !1) {
  let i = [], s = r ? [] : null, l = new js(n), o = new js(e);
  for (let a = -1; ; )
    if (l.ins == -1 && o.ins == -1) {
      let u = Math.min(l.len, o.len);
      ct(i, u, -1), l.forward(u), o.forward(u);
    } else if (o.ins >= 0 && (l.ins < 0 || a == l.i || l.off == 0 && (o.len < l.len || o.len == l.len && !t))) {
      let u = o.len;
      for (ct(i, o.ins, -1); u; ) {
        let h = Math.min(l.len, u);
        l.ins >= 0 && a < l.i && l.len <= h && (ct(i, 0, l.ins), s && Tn(s, i, l.text), a = l.i), l.forward(h), u -= h;
      }
      o.next();
    } else if (l.ins >= 0) {
      let u = 0, h = l.len;
      for (; h; )
        if (o.ins == -1) {
          let c = Math.min(h, o.len);
          u += c, h -= c, o.forward(c);
        } else if (o.ins == 0 && o.len < h)
          h -= o.len, o.next();
        else
          break;
      ct(i, u, a < l.i ? l.ins : 0), s && a < l.i && Tn(s, i, l.text), a = l.i, l.forward(l.len - h);
    } else {
      if (l.done && o.done)
        return s ? tt.createSet(i, s) : $r.create(i);
      throw new Error("Mismatched change set lengths");
    }
}
function Km(n, e, t = !1) {
  let r = [], i = t ? [] : null, s = new js(n), l = new js(e);
  for (let o = !1; ; ) {
    if (s.done && l.done)
      return i ? tt.createSet(r, i) : $r.create(r);
    if (s.ins == 0)
      ct(r, s.len, 0, o), s.next();
    else if (l.len == 0 && !l.done)
      ct(r, 0, l.ins, o), i && Tn(i, r, l.text), l.next();
    else {
      if (s.done || l.done)
        throw new Error("Mismatched change set lengths");
      {
        let a = Math.min(s.len2, l.len), u = r.length;
        if (s.ins == -1) {
          let h = l.ins == -1 ? -1 : l.off ? 0 : l.ins;
          ct(r, a, h, o), i && h && Tn(i, r, l.text);
        } else l.ins == -1 ? (ct(r, s.off ? 0 : s.len, a, o), i && Tn(i, r, s.textBit(a))) : (ct(r, s.off ? 0 : s.len, l.off ? 0 : l.ins, o), i && !l.off && Tn(i, r, l.text));
        o = (s.ins > a || l.ins >= 0 && l.len > a) && (o || r.length > u), s.forward2(a), l.forward(a);
      }
    }
  }
}
class js {
  constructor(e) {
    this.set = e, this.i = 0, this.next();
  }
  next() {
    let { sections: e } = this.set;
    this.i < e.length ? (this.len = e[this.i++], this.ins = e[this.i++]) : (this.len = 0, this.ins = -2), this.off = 0;
  }
  get done() {
    return this.ins == -2;
  }
  get len2() {
    return this.ins < 0 ? this.len : this.ins;
  }
  get text() {
    let { inserted: e } = this.set, t = this.i - 2 >> 1;
    return t >= e.length ? Ae.empty : e[t];
  }
  textBit(e) {
    let { inserted: t } = this.set, r = this.i - 2 >> 1;
    return r >= t.length && !e ? Ae.empty : t[r].slice(this.off, e == null ? void 0 : this.off + e);
  }
  forward(e) {
    e == this.len ? this.next() : (this.len -= e, this.off += e);
  }
  forward2(e) {
    this.ins == -1 ? this.forward(e) : e == this.ins ? this.next() : (this.ins -= e, this.off += e);
  }
}
class Zn {
  constructor(e, t, r) {
    this.from = e, this.to = t, this.flags = r;
  }
  /**
  The anchor of the range—the side that doesn't move when you
  extend it.
  */
  get anchor() {
    return this.flags & 32 ? this.to : this.from;
  }
  /**
  The head of the range, which is moved when the range is
  [extended](https://codemirror.net/6/docs/ref/#state.SelectionRange.extend).
  */
  get head() {
    return this.flags & 32 ? this.from : this.to;
  }
  /**
  True when `anchor` and `head` are at the same position.
  */
  get empty() {
    return this.from == this.to;
  }
  /**
  If this is a cursor that is explicitly associated with the
  character on one of its sides, this returns the side. -1 means
  the character before its position, 1 the character after, and 0
  means no association.
  */
  get assoc() {
    return this.flags & 8 ? -1 : this.flags & 16 ? 1 : 0;
  }
  /**
  The bidirectional text level associated with this cursor, if
  any.
  */
  get bidiLevel() {
    let e = this.flags & 7;
    return e == 7 ? null : e;
  }
  /**
  The goal column (stored vertical offset) associated with a
  cursor. This is used to preserve the vertical position when
  [moving](https://codemirror.net/6/docs/ref/#view.EditorView.moveVertically) across
  lines of different length.
  */
  get goalColumn() {
    let e = this.flags >> 6;
    return e == 16777215 ? void 0 : e;
  }
  /**
  Map this range through a change, producing a valid range in the
  updated document.
  */
  map(e, t = -1) {
    let r, i;
    return this.empty ? r = i = e.mapPos(this.from, t) : (r = e.mapPos(this.from, 1), i = e.mapPos(this.to, -1)), r == this.from && i == this.to ? this : new Zn(r, i, this.flags);
  }
  /**
  Extend this range to cover at least `from` to `to`.
  */
  extend(e, t = e) {
    if (e <= this.anchor && t >= this.anchor)
      return I.range(e, t);
    let r = Math.abs(e - this.anchor) > Math.abs(t - this.anchor) ? e : t;
    return I.range(this.anchor, r);
  }
  /**
  Compare this range to another range.
  */
  eq(e, t = !1) {
    return this.anchor == e.anchor && this.head == e.head && (!t || !this.empty || this.assoc == e.assoc);
  }
  /**
  Return a JSON-serializable object representing the range.
  */
  toJSON() {
    return { anchor: this.anchor, head: this.head };
  }
  /**
  Convert a JSON representation of a range to a `SelectionRange`
  instance.
  */
  static fromJSON(e) {
    if (!e || typeof e.anchor != "number" || typeof e.head != "number")
      throw new RangeError("Invalid JSON representation for SelectionRange");
    return I.range(e.anchor, e.head);
  }
  /**
  @internal
  */
  static create(e, t, r) {
    return new Zn(e, t, r);
  }
}
class I {
  constructor(e, t) {
    this.ranges = e, this.mainIndex = t;
  }
  /**
  Map a selection through a change. Used to adjust the selection
  position for changes.
  */
  map(e, t = -1) {
    return e.empty ? this : I.create(this.ranges.map((r) => r.map(e, t)), this.mainIndex);
  }
  /**
  Compare this selection to another selection. By default, ranges
  are compared only by position. When `includeAssoc` is true,
  cursor ranges must also have the same
  [`assoc`](https://codemirror.net/6/docs/ref/#state.SelectionRange.assoc) value.
  */
  eq(e, t = !1) {
    if (this.ranges.length != e.ranges.length || this.mainIndex != e.mainIndex)
      return !1;
    for (let r = 0; r < this.ranges.length; r++)
      if (!this.ranges[r].eq(e.ranges[r], t))
        return !1;
    return !0;
  }
  /**
  Get the primary selection range. Usually, you should make sure
  your code applies to _all_ ranges, by using methods like
  [`changeByRange`](https://codemirror.net/6/docs/ref/#state.EditorState.changeByRange).
  */
  get main() {
    return this.ranges[this.mainIndex];
  }
  /**
  Make sure the selection only has one range. Returns a selection
  holding only the main range from this selection.
  */
  asSingle() {
    return this.ranges.length == 1 ? this : new I([this.main], 0);
  }
  /**
  Extend this selection with an extra range.
  */
  addRange(e, t = !0) {
    return I.create([e].concat(this.ranges), t ? 0 : this.mainIndex + 1);
  }
  /**
  Replace a given range with another range, and then normalize the
  selection to merge and sort ranges if necessary.
  */
  replaceRange(e, t = this.mainIndex) {
    let r = this.ranges.slice();
    return r[t] = e, I.create(r, this.mainIndex);
  }
  /**
  Convert this selection to an object that can be serialized to
  JSON.
  */
  toJSON() {
    return { ranges: this.ranges.map((e) => e.toJSON()), main: this.mainIndex };
  }
  /**
  Create a selection from a JSON representation.
  */
  static fromJSON(e) {
    if (!e || !Array.isArray(e.ranges) || typeof e.main != "number" || e.main >= e.ranges.length)
      throw new RangeError("Invalid JSON representation for EditorSelection");
    return new I(e.ranges.map((t) => Zn.fromJSON(t)), e.main);
  }
  /**
  Create a selection holding a single range.
  */
  static single(e, t = e) {
    return new I([I.range(e, t)], 0);
  }
  /**
  Sort and merge the given set of ranges, creating a valid
  selection.
  */
  static create(e, t = 0) {
    if (e.length == 0)
      throw new RangeError("A selection needs at least one range");
    for (let r = 0, i = 0; i < e.length; i++) {
      let s = e[i];
      if (s.empty ? s.from <= r : s.from < r)
        return I.normalized(e.slice(), t);
      r = s.to;
    }
    return new I(e, t);
  }
  /**
  Create a cursor selection range at the given position. You can
  safely ignore the optional arguments in most situations.
  */
  static cursor(e, t = 0, r, i) {
    return Zn.create(e, e, (t == 0 ? 0 : t < 0 ? 8 : 16) | (r == null ? 7 : Math.min(6, r)) | (i ?? 16777215) << 6);
  }
  /**
  Create a selection range.
  */
  static range(e, t, r, i) {
    let s = (r ?? 16777215) << 6 | (i == null ? 7 : Math.min(6, i));
    return t < e ? Zn.create(t, e, 48 | s) : Zn.create(e, t, (t > e ? 8 : 0) | s);
  }
  /**
  @internal
  */
  static normalized(e, t = 0) {
    let r = e[t];
    e.sort((i, s) => i.from - s.from), t = e.indexOf(r);
    for (let i = 1; i < e.length; i++) {
      let s = e[i], l = e[i - 1];
      if (s.empty ? s.from <= l.to : s.from < l.to) {
        let o = l.from, a = Math.max(s.to, l.to);
        i <= t && t--, e.splice(--i, 2, s.anchor > s.head ? I.range(a, o) : I.range(o, a));
      }
    }
    return new I(e, t);
  }
}
function Xm(n, e) {
  for (let t of n.ranges)
    if (t.to > e)
      throw new RangeError("Selection points outside of document");
}
let rh = 0;
class X {
  constructor(e, t, r, i, s) {
    this.combine = e, this.compareInput = t, this.compare = r, this.isStatic = i, this.id = rh++, this.default = e([]), this.extensions = typeof s == "function" ? s(this) : s;
  }
  /**
  Returns a facet reader for this facet, which can be used to
  [read](https://codemirror.net/6/docs/ref/#state.EditorState.facet) it but not to define values for it.
  */
  get reader() {
    return this;
  }
  /**
  Define a new facet.
  */
  static define(e = {}) {
    return new X(e.combine || ((t) => t), e.compareInput || ((t, r) => t === r), e.compare || (e.combine ? (t, r) => t === r : nh), !!e.static, e.enables);
  }
  /**
  Returns an extension that adds the given value to this facet.
  */
  of(e) {
    return new fo([], this, 0, e);
  }
  /**
  Create an extension that computes a value for the facet from a
  state. You must take care to declare the parts of the state that
  this value depends on, since your function is only called again
  for a new state when one of those parts changed.
  
  In cases where your value depends only on a single field, you'll
  want to use the [`from`](https://codemirror.net/6/docs/ref/#state.Facet.from) method instead.
  */
  compute(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new fo(e, this, 1, t);
  }
  /**
  Create an extension that computes zero or more values for this
  facet from a state.
  */
  computeN(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new fo(e, this, 2, t);
  }
  from(e, t) {
    return t || (t = (r) => r), this.compute([e], (r) => t(r.field(e)));
  }
}
function nh(n, e) {
  return n == e || n.length == e.length && n.every((t, r) => t === e[r]);
}
class fo {
  constructor(e, t, r, i) {
    this.dependencies = e, this.facet = t, this.type = r, this.value = i, this.id = rh++;
  }
  dynamicSlot(e) {
    var t;
    let r = this.value, i = this.facet.compareInput, s = this.id, l = e[s] >> 1, o = this.type == 2, a = !1, u = !1, h = [];
    for (let c of this.dependencies)
      c == "doc" ? a = !0 : c == "selection" ? u = !0 : ((t = e[c.id]) !== null && t !== void 0 ? t : 1) & 1 || h.push(e[c.id]);
    return {
      create(c) {
        return c.values[l] = r(c), 1;
      },
      update(c, f) {
        if (a && f.docChanged || u && (f.docChanged || f.selection) || G0(c, h)) {
          let m = r(c);
          if (o ? !Hc(m, c.values[l], i) : !i(m, c.values[l]))
            return c.values[l] = m, 1;
        }
        return 0;
      },
      reconfigure: (c, f) => {
        let m, g = f.config.address[s];
        if (g != null) {
          let v = Mo(f, g);
          if (this.dependencies.every((k) => k instanceof X ? f.facet(k) === c.facet(k) : k instanceof Lt ? f.field(k, !1) == c.field(k, !1) : !0) || (o ? Hc(m = r(c), v, i) : i(m = r(c), v)))
            return c.values[l] = v, 0;
        } else
          m = r(c);
        return c.values[l] = m, 1;
      }
    };
  }
}
function Hc(n, e, t) {
  if (n.length != e.length)
    return !1;
  for (let r = 0; r < n.length; r++)
    if (!t(n[r], e[r]))
      return !1;
  return !0;
}
function G0(n, e) {
  let t = !1;
  for (let r of e)
    Ls(n, r) & 1 && (t = !0);
  return t;
}
function E5(n, e, t) {
  let r = t.map((a) => n[a.id]), i = t.map((a) => a.type), s = r.filter((a) => !(a & 1)), l = n[e.id] >> 1;
  function o(a) {
    let u = [];
    for (let h = 0; h < r.length; h++) {
      let c = Mo(a, r[h]);
      if (i[h] == 2)
        for (let f of c)
          u.push(f);
      else
        u.push(c);
    }
    return e.combine(u);
  }
  return {
    create(a) {
      for (let u of r)
        Ls(a, u);
      return a.values[l] = o(a), 1;
    },
    update(a, u) {
      if (!G0(a, s))
        return 0;
      let h = o(a);
      return e.compare(h, a.values[l]) ? 0 : (a.values[l] = h, 1);
    },
    reconfigure(a, u) {
      let h = G0(a, r), c = u.config.facets[e.id], f = u.facet(e);
      if (c && !h && nh(t, c))
        return a.values[l] = f, 0;
      let m = o(a);
      return e.compare(m, f) ? (a.values[l] = f, 0) : (a.values[l] = m, 1);
    }
  };
}
const qc = /* @__PURE__ */ X.define({ static: !0 });
class Lt {
  constructor(e, t, r, i, s) {
    this.id = e, this.createF = t, this.updateF = r, this.compareF = i, this.spec = s, this.provides = void 0;
  }
  /**
  Define a state field.
  */
  static define(e) {
    let t = new Lt(rh++, e.create, e.update, e.compare || ((r, i) => r === i), e);
    return e.provide && (t.provides = e.provide(t)), t;
  }
  create(e) {
    let t = e.facet(qc).find((r) => r.field == this);
    return (t?.create || this.createF)(e);
  }
  /**
  @internal
  */
  slot(e) {
    let t = e[this.id] >> 1;
    return {
      create: (r) => (r.values[t] = this.create(r), 1),
      update: (r, i) => {
        let s = r.values[t], l = this.updateF(s, i);
        return this.compareF(s, l) ? 0 : (r.values[t] = l, 1);
      },
      reconfigure: (r, i) => i.config.address[this.id] != null ? (r.values[t] = i.field(this), 0) : (r.values[t] = this.create(r), 1)
    };
  }
  /**
  Returns an extension that enables this field and overrides the
  way it is initialized. Can be useful when you need to provide a
  non-default starting value for the field.
  */
  init(e) {
    return [this, qc.of({ field: this, create: e })];
  }
  /**
  State field instances can be used as
  [`Extension`](https://codemirror.net/6/docs/ref/#state.Extension) values to enable the field in a
  given state.
  */
  get extension() {
    return this;
  }
}
const Kn = { lowest: 4, low: 3, default: 2, high: 1, highest: 0 };
function fs(n) {
  return (e) => new Zm(e, n);
}
const al = {
  /**
  The highest precedence level, for extensions that should end up
  near the start of the precedence ordering.
  */
  highest: /* @__PURE__ */ fs(Kn.highest),
  /**
  A higher-than-default precedence, for extensions that should
  come before those with default precedence.
  */
  high: /* @__PURE__ */ fs(Kn.high),
  /**
  The default precedence, which is also used for extensions
  without an explicit precedence.
  */
  default: /* @__PURE__ */ fs(Kn.default),
  /**
  A lower-than-default precedence.
  */
  low: /* @__PURE__ */ fs(Kn.low),
  /**
  The lowest precedence level. Meant for things that should end up
  near the end of the extension order.
  */
  lowest: /* @__PURE__ */ fs(Kn.lowest)
};
class Zm {
  constructor(e, t) {
    this.inner = e, this.prec = t;
  }
}
class ia {
  /**
  Create an instance of this compartment to add to your [state
  configuration](https://codemirror.net/6/docs/ref/#state.EditorStateConfig.extensions).
  */
  of(e) {
    return new j0(this, e);
  }
  /**
  Create an [effect](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) that
  reconfigures this compartment.
  */
  reconfigure(e) {
    return ia.reconfigure.of({ compartment: this, extension: e });
  }
  /**
  Get the current content of the compartment in the state, or
  `undefined` if it isn't present.
  */
  get(e) {
    return e.config.compartments.get(this);
  }
}
class j0 {
  constructor(e, t) {
    this.compartment = e, this.inner = t;
  }
}
class _o {
  constructor(e, t, r, i, s, l) {
    for (this.base = e, this.compartments = t, this.dynamicSlots = r, this.address = i, this.staticValues = s, this.facets = l, this.statusTemplate = []; this.statusTemplate.length < r.length; )
      this.statusTemplate.push(
        0
        /* SlotStatus.Unresolved */
      );
  }
  staticFacet(e) {
    let t = this.address[e.id];
    return t == null ? e.default : this.staticValues[t >> 1];
  }
  static resolve(e, t, r) {
    let i = [], s = /* @__PURE__ */ Object.create(null), l = /* @__PURE__ */ new Map();
    for (let f of F5(e, t, l))
      f instanceof Lt ? i.push(f) : (s[f.facet.id] || (s[f.facet.id] = [])).push(f);
    let o = /* @__PURE__ */ Object.create(null), a = [], u = [];
    for (let f of i)
      o[f.id] = u.length << 1, u.push((m) => f.slot(m));
    let h = r?.config.facets;
    for (let f in s) {
      let m = s[f], g = m[0].facet, v = h && h[f] || [];
      if (m.every(
        (k) => k.type == 0
        /* Provider.Static */
      ))
        if (o[g.id] = a.length << 1 | 1, nh(v, m))
          a.push(r.facet(g));
        else {
          let k = g.combine(m.map((S) => S.value));
          a.push(r && g.compare(k, r.facet(g)) ? r.facet(g) : k);
        }
      else {
        for (let k of m)
          k.type == 0 ? (o[k.id] = a.length << 1 | 1, a.push(k.value)) : (o[k.id] = u.length << 1, u.push((S) => k.dynamicSlot(S)));
        o[g.id] = u.length << 1, u.push((k) => E5(k, g, m));
      }
    }
    let c = u.map((f) => f(o));
    return new _o(e, l, c, o, a, s);
  }
}
function F5(n, e, t) {
  let r = [[], [], [], [], []], i = /* @__PURE__ */ new Map();
  function s(l, o) {
    let a = i.get(l);
    if (a != null) {
      if (a <= o)
        return;
      let u = r[a].indexOf(l);
      u > -1 && r[a].splice(u, 1), l instanceof j0 && t.delete(l.compartment);
    }
    if (i.set(l, o), Array.isArray(l))
      for (let u of l)
        s(u, o);
    else if (l instanceof j0) {
      if (t.has(l.compartment))
        throw new RangeError("Duplicate use of compartment in extensions");
      let u = e.get(l.compartment) || l.inner;
      t.set(l.compartment, u), s(u, o);
    } else if (l instanceof Zm)
      s(l.inner, l.prec);
    else if (l instanceof Lt)
      r[o].push(l), l.provides && s(l.provides, o);
    else if (l instanceof fo)
      r[o].push(l), l.facet.extensions && s(l.facet.extensions, Kn.default);
    else {
      let u = l.extension;
      if (!u)
        throw new Error(`Unrecognized extension value in extension set (${l}). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks.`);
      s(u, o);
    }
  }
  return s(n, Kn.default), r.reduce((l, o) => l.concat(o));
}
function Ls(n, e) {
  if (e & 1)
    return 2;
  let t = e >> 1, r = n.status[t];
  if (r == 4)
    throw new Error("Cyclic dependency between fields and/or facets");
  if (r & 2)
    return r;
  n.status[t] = 4;
  let i = n.computeSlot(n, n.config.dynamicSlots[t]);
  return n.status[t] = 2 | i;
}
function Mo(n, e) {
  return e & 1 ? n.config.staticValues[e >> 1] : n.values[e >> 1];
}
const Jm = /* @__PURE__ */ X.define(), $0 = /* @__PURE__ */ X.define({
  combine: (n) => n.some((e) => e),
  static: !0
}), Qm = /* @__PURE__ */ X.define({
  combine: (n) => n.length ? n[0] : void 0,
  static: !0
}), ep = /* @__PURE__ */ X.define(), tp = /* @__PURE__ */ X.define(), rp = /* @__PURE__ */ X.define(), np = /* @__PURE__ */ X.define({
  combine: (n) => n.length ? n[0] : !1
});
class vn {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Define a new type of annotation.
  */
  static define() {
    return new B5();
  }
}
class B5 {
  /**
  Create an instance of this annotation.
  */
  of(e) {
    return new vn(this, e);
  }
}
class O5 {
  /**
  @internal
  */
  constructor(e) {
    this.map = e;
  }
  /**
  Create a [state effect](https://codemirror.net/6/docs/ref/#state.StateEffect) instance of this
  type.
  */
  of(e) {
    return new ye(this, e);
  }
}
class ye {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Map this effect through a position mapping. Will return
  `undefined` when that ends up deleting the effect.
  */
  map(e) {
    let t = this.type.map(this.value, e);
    return t === void 0 ? void 0 : t == this.value ? this : new ye(this.type, t);
  }
  /**
  Tells you whether this effect object is of a given
  [type](https://codemirror.net/6/docs/ref/#state.StateEffectType).
  */
  is(e) {
    return this.type == e;
  }
  /**
  Define a new effect type. The type parameter indicates the type
  of values that his effect holds. It should be a type that
  doesn't include `undefined`, since that is used in
  [mapping](https://codemirror.net/6/docs/ref/#state.StateEffect.map) to indicate that an effect is
  removed.
  */
  static define(e = {}) {
    return new O5(e.map || ((t) => t));
  }
  /**
  Map an array of effects through a change set.
  */
  static mapEffects(e, t) {
    if (!e.length)
      return e;
    let r = [];
    for (let i of e) {
      let s = i.map(t);
      s && r.push(s);
    }
    return r;
  }
}
ye.reconfigure = /* @__PURE__ */ ye.define();
ye.appendConfig = /* @__PURE__ */ ye.define();
class Qe {
  constructor(e, t, r, i, s, l) {
    this.startState = e, this.changes = t, this.selection = r, this.effects = i, this.annotations = s, this.scrollIntoView = l, this._doc = null, this._state = null, r && Xm(r, t.newLength), s.some((o) => o.type == Qe.time) || (this.annotations = s.concat(Qe.time.of(Date.now())));
  }
  /**
  @internal
  */
  static create(e, t, r, i, s, l) {
    return new Qe(e, t, r, i, s, l);
  }
  /**
  The new document produced by the transaction. Contrary to
  [`.state`](https://codemirror.net/6/docs/ref/#state.Transaction.state)`.doc`, accessing this won't
  force the entire new state to be computed right away, so it is
  recommended that [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) use this getter
  when they need to look at the new document.
  */
  get newDoc() {
    return this._doc || (this._doc = this.changes.apply(this.startState.doc));
  }
  /**
  The new selection produced by the transaction. If
  [`this.selection`](https://codemirror.net/6/docs/ref/#state.Transaction.selection) is undefined,
  this will [map](https://codemirror.net/6/docs/ref/#state.EditorSelection.map) the start state's
  current selection through the changes made by the transaction.
  */
  get newSelection() {
    return this.selection || this.startState.selection.map(this.changes);
  }
  /**
  The new state created by the transaction. Computed on demand
  (but retained for subsequent access), so it is recommended not to
  access it in [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) when possible.
  */
  get state() {
    return this._state || this.startState.applyTransaction(this), this._state;
  }
  /**
  Get the value of the given annotation type, if any.
  */
  annotation(e) {
    for (let t of this.annotations)
      if (t.type == e)
        return t.value;
  }
  /**
  Indicates whether the transaction changed the document.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Indicates whether this transaction reconfigures the state
  (through a [configuration compartment](https://codemirror.net/6/docs/ref/#state.Compartment) or
  with a top-level configuration
  [effect](https://codemirror.net/6/docs/ref/#state.StateEffect^reconfigure).
  */
  get reconfigured() {
    return this.startState.config != this.state.config;
  }
  /**
  Returns true if the transaction has a [user
  event](https://codemirror.net/6/docs/ref/#state.Transaction^userEvent) annotation that is equal to
  or more specific than `event`. For example, if the transaction
  has `"select.pointer"` as user event, `"select"` and
  `"select.pointer"` will match it.
  */
  isUserEvent(e) {
    let t = this.annotation(Qe.userEvent);
    return !!(t && (t == e || t.length > e.length && t.slice(0, e.length) == e && t[e.length] == "."));
  }
}
Qe.time = /* @__PURE__ */ vn.define();
Qe.userEvent = /* @__PURE__ */ vn.define();
Qe.addToHistory = /* @__PURE__ */ vn.define();
Qe.remote = /* @__PURE__ */ vn.define();
function R5(n, e) {
  let t = [];
  for (let r = 0, i = 0; ; ) {
    let s, l;
    if (r < n.length && (i == e.length || e[i] >= n[r]))
      s = n[r++], l = n[r++];
    else if (i < e.length)
      s = e[i++], l = e[i++];
    else
      return t;
    !t.length || t[t.length - 1] < s ? t.push(s, l) : t[t.length - 1] < l && (t[t.length - 1] = l);
  }
}
function ip(n, e, t) {
  var r;
  let i, s, l;
  return t ? (i = e.changes, s = tt.empty(e.changes.length), l = n.changes.compose(e.changes)) : (i = e.changes.map(n.changes), s = n.changes.mapDesc(e.changes, !0), l = n.changes.compose(i)), {
    changes: l,
    selection: e.selection ? e.selection.map(s) : (r = n.selection) === null || r === void 0 ? void 0 : r.map(i),
    effects: ye.mapEffects(n.effects, i).concat(ye.mapEffects(e.effects, s)),
    annotations: n.annotations.length ? n.annotations.concat(e.annotations) : e.annotations,
    scrollIntoView: n.scrollIntoView || e.scrollIntoView
  };
}
function Y0(n, e, t) {
  let r = e.selection, i = zi(e.annotations);
  return e.userEvent && (i = i.concat(Qe.userEvent.of(e.userEvent))), {
    changes: e.changes instanceof tt ? e.changes : tt.of(e.changes || [], t, n.facet(Qm)),
    selection: r && (r instanceof I ? r : I.single(r.anchor, r.head)),
    effects: zi(e.effects),
    annotations: i,
    scrollIntoView: !!e.scrollIntoView
  };
}
function sp(n, e, t) {
  let r = Y0(n, e.length ? e[0] : {}, n.doc.length);
  e.length && e[0].filter === !1 && (t = !1);
  for (let s = 1; s < e.length; s++) {
    e[s].filter === !1 && (t = !1);
    let l = !!e[s].sequential;
    r = ip(r, Y0(n, e[s], l ? r.changes.newLength : n.doc.length), l);
  }
  let i = Qe.create(n, r.changes, r.selection, r.effects, r.annotations, r.scrollIntoView);
  return N5(t ? L5(i) : i);
}
function L5(n) {
  let e = n.startState, t = !0;
  for (let i of e.facet(ep)) {
    let s = i(n);
    if (s === !1) {
      t = !1;
      break;
    }
    Array.isArray(s) && (t = t === !0 ? s : R5(t, s));
  }
  if (t !== !0) {
    let i, s;
    if (t === !1)
      s = n.changes.invertedDesc, i = tt.empty(e.doc.length);
    else {
      let l = n.changes.filter(t);
      i = l.changes, s = l.filtered.mapDesc(l.changes).invertedDesc;
    }
    n = Qe.create(e, i, n.selection && n.selection.map(s), ye.mapEffects(n.effects, s), n.annotations, n.scrollIntoView);
  }
  let r = e.facet(tp);
  for (let i = r.length - 1; i >= 0; i--) {
    let s = r[i](n);
    s instanceof Qe ? n = s : Array.isArray(s) && s.length == 1 && s[0] instanceof Qe ? n = s[0] : n = sp(e, zi(s), !1);
  }
  return n;
}
function N5(n) {
  let e = n.startState, t = e.facet(rp), r = n;
  for (let i = t.length - 1; i >= 0; i--) {
    let s = t[i](n);
    s && Object.keys(s).length && (r = ip(r, Y0(e, s, n.changes.newLength), !0));
  }
  return r == n ? n : Qe.create(e, n.changes, n.selection, r.effects, r.annotations, r.scrollIntoView);
}
const I5 = [];
function zi(n) {
  return n == null ? I5 : Array.isArray(n) ? n : [n];
}
var Kt = /* @__PURE__ */ function(n) {
  return n[n.Word = 0] = "Word", n[n.Space = 1] = "Space", n[n.Other = 2] = "Other", n;
}(Kt || (Kt = {}));
const z5 = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
let K0;
try {
  K0 = /* @__PURE__ */ new RegExp("[\\p{Alphabetic}\\p{Number}_]", "u");
} catch {
}
function P5(n) {
  if (K0)
    return K0.test(n);
  for (let e = 0; e < n.length; e++) {
    let t = n[e];
    if (/\w/.test(t) || t > "" && (t.toUpperCase() != t.toLowerCase() || z5.test(t)))
      return !0;
  }
  return !1;
}
function H5(n) {
  return (e) => {
    if (!/\S/.test(e))
      return Kt.Space;
    if (P5(e))
      return Kt.Word;
    for (let t = 0; t < n.length; t++)
      if (e.indexOf(n[t]) > -1)
        return Kt.Word;
    return Kt.Other;
  };
}
class Se {
  constructor(e, t, r, i, s, l) {
    this.config = e, this.doc = t, this.selection = r, this.values = i, this.status = e.statusTemplate.slice(), this.computeSlot = s, l && (l._state = this);
    for (let o = 0; o < this.config.dynamicSlots.length; o++)
      Ls(this, o << 1);
    this.computeSlot = null;
  }
  field(e, t = !0) {
    let r = this.config.address[e.id];
    if (r == null) {
      if (t)
        throw new RangeError("Field is not present in this state");
      return;
    }
    return Ls(this, r), Mo(this, r);
  }
  /**
  Create a [transaction](https://codemirror.net/6/docs/ref/#state.Transaction) that updates this
  state. Any number of [transaction specs](https://codemirror.net/6/docs/ref/#state.TransactionSpec)
  can be passed. Unless
  [`sequential`](https://codemirror.net/6/docs/ref/#state.TransactionSpec.sequential) is set, the
  [changes](https://codemirror.net/6/docs/ref/#state.TransactionSpec.changes) (if any) of each spec
  are assumed to start in the _current_ document (not the document
  produced by previous specs), and its
  [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection) and
  [effects](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) are assumed to refer
  to the document created by its _own_ changes. The resulting
  transaction contains the combined effect of all the different
  specs. For [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection), later
  specs take precedence over earlier ones.
  */
  update(...e) {
    return sp(this, e, !0);
  }
  /**
  @internal
  */
  applyTransaction(e) {
    let t = this.config, { base: r, compartments: i } = t;
    for (let o of e.effects)
      o.is(ia.reconfigure) ? (t && (i = /* @__PURE__ */ new Map(), t.compartments.forEach((a, u) => i.set(u, a)), t = null), i.set(o.value.compartment, o.value.extension)) : o.is(ye.reconfigure) ? (t = null, r = o.value) : o.is(ye.appendConfig) && (t = null, r = zi(r).concat(o.value));
    let s;
    t ? s = e.startState.values.slice() : (t = _o.resolve(r, i, this), s = new Se(t, this.doc, this.selection, t.dynamicSlots.map(() => null), (a, u) => u.reconfigure(a, this), null).values);
    let l = e.startState.facet($0) ? e.newSelection : e.newSelection.asSingle();
    new Se(t, e.newDoc, l, s, (o, a) => a.update(o, e), e);
  }
  /**
  Create a [transaction spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec) that
  replaces every selection range with the given content.
  */
  replaceSelection(e) {
    return typeof e == "string" && (e = this.toText(e)), this.changeByRange((t) => ({
      changes: { from: t.from, to: t.to, insert: e },
      range: I.cursor(t.from + e.length)
    }));
  }
  /**
  Create a set of changes and a new selection by running the given
  function for each range in the active selection. The function
  can return an optional set of changes (in the coordinate space
  of the start document), plus an updated range (in the coordinate
  space of the document produced by the call's own changes). This
  method will merge all the changes and ranges into a single
  changeset and selection, and return it as a [transaction
  spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec), which can be passed to
  [`update`](https://codemirror.net/6/docs/ref/#state.EditorState.update).
  */
  changeByRange(e) {
    let t = this.selection, r = e(t.ranges[0]), i = this.changes(r.changes), s = [r.range], l = zi(r.effects);
    for (let o = 1; o < t.ranges.length; o++) {
      let a = e(t.ranges[o]), u = this.changes(a.changes), h = u.map(i);
      for (let f = 0; f < o; f++)
        s[f] = s[f].map(h);
      let c = i.mapDesc(u, !0);
      s.push(a.range.map(c)), i = i.compose(h), l = ye.mapEffects(l, h).concat(ye.mapEffects(zi(a.effects), c));
    }
    return {
      changes: i,
      selection: I.create(s, t.mainIndex),
      effects: l
    };
  }
  /**
  Create a [change set](https://codemirror.net/6/docs/ref/#state.ChangeSet) from the given change
  description, taking the state's document length and line
  separator into account.
  */
  changes(e = []) {
    return e instanceof tt ? e : tt.of(e, this.doc.length, this.facet(Se.lineSeparator));
  }
  /**
  Using the state's [line
  separator](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator), create a
  [`Text`](https://codemirror.net/6/docs/ref/#state.Text) instance from the given string.
  */
  toText(e) {
    return Ae.of(e.split(this.facet(Se.lineSeparator) || V0));
  }
  /**
  Return the given range of the document as a string.
  */
  sliceDoc(e = 0, t = this.doc.length) {
    return this.doc.sliceString(e, t, this.lineBreak);
  }
  /**
  Get the value of a state [facet](https://codemirror.net/6/docs/ref/#state.Facet).
  */
  facet(e) {
    let t = this.config.address[e.id];
    return t == null ? e.default : (Ls(this, t), Mo(this, t));
  }
  /**
  Convert this state to a JSON-serializable object. When custom
  fields should be serialized, you can pass them in as an object
  mapping property names (in the resulting object, which should
  not use `doc` or `selection`) to fields.
  */
  toJSON(e) {
    let t = {
      doc: this.sliceDoc(),
      selection: this.selection.toJSON()
    };
    if (e)
      for (let r in e) {
        let i = e[r];
        i instanceof Lt && this.config.address[i.id] != null && (t[r] = i.spec.toJSON(this.field(e[r]), this));
      }
    return t;
  }
  /**
  Deserialize a state from its JSON representation. When custom
  fields should be deserialized, pass the same object you passed
  to [`toJSON`](https://codemirror.net/6/docs/ref/#state.EditorState.toJSON) when serializing as
  third argument.
  */
  static fromJSON(e, t = {}, r) {
    if (!e || typeof e.doc != "string")
      throw new RangeError("Invalid JSON representation for EditorState");
    let i = [];
    if (r) {
      for (let s in r)
        if (Object.prototype.hasOwnProperty.call(e, s)) {
          let l = r[s], o = e[s];
          i.push(l.init((a) => l.spec.fromJSON(o, a)));
        }
    }
    return Se.create({
      doc: e.doc,
      selection: I.fromJSON(e.selection),
      extensions: t.extensions ? i.concat([t.extensions]) : i
    });
  }
  /**
  Create a new state. You'll usually only need this when
  initializing an editor—updated states are created by applying
  transactions.
  */
  static create(e = {}) {
    let t = _o.resolve(e.extensions || [], /* @__PURE__ */ new Map()), r = e.doc instanceof Ae ? e.doc : Ae.of((e.doc || "").split(t.staticFacet(Se.lineSeparator) || V0)), i = e.selection ? e.selection instanceof I ? e.selection : I.single(e.selection.anchor, e.selection.head) : I.single(0);
    return Xm(i, r.length), t.staticFacet($0) || (i = i.asSingle()), new Se(t, r, i, t.dynamicSlots.map(() => null), (s, l) => l.create(s), null);
  }
  /**
  The size (in columns) of a tab in the document, determined by
  the [`tabSize`](https://codemirror.net/6/docs/ref/#state.EditorState^tabSize) facet.
  */
  get tabSize() {
    return this.facet(Se.tabSize);
  }
  /**
  Get the proper [line-break](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator)
  string for this state.
  */
  get lineBreak() {
    return this.facet(Se.lineSeparator) || `
`;
  }
  /**
  Returns true when the editor is
  [configured](https://codemirror.net/6/docs/ref/#state.EditorState^readOnly) to be read-only.
  */
  get readOnly() {
    return this.facet(np);
  }
  /**
  Look up a translation for the given phrase (via the
  [`phrases`](https://codemirror.net/6/docs/ref/#state.EditorState^phrases) facet), or return the
  original string if no translation is found.
  
  If additional arguments are passed, they will be inserted in
  place of markers like `$1` (for the first value) and `$2`, etc.
  A single `$` is equivalent to `$1`, and `$$` will produce a
  literal dollar sign.
  */
  phrase(e, ...t) {
    for (let r of this.facet(Se.phrases))
      if (Object.prototype.hasOwnProperty.call(r, e)) {
        e = r[e];
        break;
      }
    return t.length && (e = e.replace(/\$(\$|\d*)/g, (r, i) => {
      if (i == "$")
        return "$";
      let s = +(i || 1);
      return !s || s > t.length ? r : t[s - 1];
    })), e;
  }
  /**
  Find the values for a given language data field, provided by the
  the [`languageData`](https://codemirror.net/6/docs/ref/#state.EditorState^languageData) facet.
  
  Examples of language data fields are...
  
  - [`"commentTokens"`](https://codemirror.net/6/docs/ref/#commands.CommentTokens) for specifying
    comment syntax.
  - [`"autocomplete"`](https://codemirror.net/6/docs/ref/#autocomplete.autocompletion^config.override)
    for providing language-specific completion sources.
  - [`"wordChars"`](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) for adding
    characters that should be considered part of words in this
    language.
  - [`"closeBrackets"`](https://codemirror.net/6/docs/ref/#autocomplete.CloseBracketConfig) controls
    bracket closing behavior.
  */
  languageDataAt(e, t, r = -1) {
    let i = [];
    for (let s of this.facet(Jm))
      for (let l of s(this, t, r))
        Object.prototype.hasOwnProperty.call(l, e) && i.push(l[e]);
    return i;
  }
  /**
  Return a function that can categorize strings (expected to
  represent a single [grapheme cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak))
  into one of:
  
   - Word (contains an alphanumeric character or a character
     explicitly listed in the local language's `"wordChars"`
     language data, which should be a string)
   - Space (contains only whitespace)
   - Other (anything else)
  */
  charCategorizer(e) {
    return H5(this.languageDataAt("wordChars", e).join(""));
  }
  /**
  Find the word at the given position, meaning the range
  containing all [word](https://codemirror.net/6/docs/ref/#state.CharCategory.Word) characters
  around it. If no word characters are adjacent to the position,
  this returns null.
  */
  wordAt(e) {
    let { text: t, from: r, length: i } = this.doc.lineAt(e), s = this.charCategorizer(e), l = e - r, o = e - r;
    for (; l > 0; ) {
      let a = kt(t, l, !1);
      if (s(t.slice(a, l)) != Kt.Word)
        break;
      l = a;
    }
    for (; o < i; ) {
      let a = kt(t, o);
      if (s(t.slice(o, a)) != Kt.Word)
        break;
      o = a;
    }
    return l == o ? null : I.range(l + r, o + r);
  }
}
Se.allowMultipleSelections = $0;
Se.tabSize = /* @__PURE__ */ X.define({
  combine: (n) => n.length ? n[0] : 4
});
Se.lineSeparator = Qm;
Se.readOnly = np;
Se.phrases = /* @__PURE__ */ X.define({
  compare(n, e) {
    let t = Object.keys(n), r = Object.keys(e);
    return t.length == r.length && t.every((i) => n[i] == e[i]);
  }
});
Se.languageData = Jm;
Se.changeFilter = ep;
Se.transactionFilter = tp;
Se.transactionExtender = rp;
ia.reconfigure = /* @__PURE__ */ ye.define();
function bi(n, e, t = {}) {
  let r = {};
  for (let i of n)
    for (let s of Object.keys(i)) {
      let l = i[s], o = r[s];
      if (o === void 0)
        r[s] = l;
      else if (!(o === l || l === void 0)) if (Object.hasOwnProperty.call(t, s))
        r[s] = t[s](o, l);
      else
        throw new Error("Config merge conflict for field " + s);
    }
  for (let i in e)
    r[i] === void 0 && (r[i] = e[i]);
  return r;
}
class ri {
  /**
  Compare this value with another value. Used when comparing
  rangesets. The default implementation compares by identity.
  Unless you are only creating a fixed number of unique instances
  of your value type, it is a good idea to implement this
  properly.
  */
  eq(e) {
    return this == e;
  }
  /**
  Create a [range](https://codemirror.net/6/docs/ref/#state.Range) with this value.
  */
  range(e, t = e) {
    return X0.create(e, t, this);
  }
}
ri.prototype.startSide = ri.prototype.endSide = 0;
ri.prototype.point = !1;
ri.prototype.mapMode = at.TrackDel;
let X0 = class lp {
  constructor(e, t, r) {
    this.from = e, this.to = t, this.value = r;
  }
  /**
  @internal
  */
  static create(e, t, r) {
    return new lp(e, t, r);
  }
};
function Z0(n, e) {
  return n.from - e.from || n.value.startSide - e.value.startSide;
}
class ih {
  constructor(e, t, r, i) {
    this.from = e, this.to = t, this.value = r, this.maxPoint = i;
  }
  get length() {
    return this.to[this.to.length - 1];
  }
  // Find the index of the given position and side. Use the ranges'
  // `from` pos when `end == false`, `to` when `end == true`.
  findIndex(e, t, r, i = 0) {
    let s = r ? this.to : this.from;
    for (let l = i, o = s.length; ; ) {
      if (l == o)
        return l;
      let a = l + o >> 1, u = s[a] - e || (r ? this.value[a].endSide : this.value[a].startSide) - t;
      if (a == l)
        return u >= 0 ? l : o;
      u >= 0 ? o = a : l = a + 1;
    }
  }
  between(e, t, r, i) {
    for (let s = this.findIndex(t, -1e9, !0), l = this.findIndex(r, 1e9, !1, s); s < l; s++)
      if (i(this.from[s] + e, this.to[s] + e, this.value[s]) === !1)
        return !1;
  }
  map(e, t) {
    let r = [], i = [], s = [], l = -1, o = -1;
    for (let a = 0; a < this.value.length; a++) {
      let u = this.value[a], h = this.from[a] + e, c = this.to[a] + e, f, m;
      if (h == c) {
        let g = t.mapPos(h, u.startSide, u.mapMode);
        if (g == null || (f = m = g, u.startSide != u.endSide && (m = t.mapPos(h, u.endSide), m < f)))
          continue;
      } else if (f = t.mapPos(h, u.startSide), m = t.mapPos(c, u.endSide), f > m || f == m && u.startSide > 0 && u.endSide <= 0)
        continue;
      (m - f || u.endSide - u.startSide) < 0 || (l < 0 && (l = f), u.point && (o = Math.max(o, m - f)), r.push(u), i.push(f - l), s.push(m - l));
    }
    return { mapped: r.length ? new ih(i, s, r, o) : null, pos: l };
  }
}
class Ce {
  constructor(e, t, r, i) {
    this.chunkPos = e, this.chunk = t, this.nextLayer = r, this.maxPoint = i;
  }
  /**
  @internal
  */
  static create(e, t, r, i) {
    return new Ce(e, t, r, i);
  }
  /**
  @internal
  */
  get length() {
    let e = this.chunk.length - 1;
    return e < 0 ? 0 : Math.max(this.chunkEnd(e), this.nextLayer.length);
  }
  /**
  The number of ranges in the set.
  */
  get size() {
    if (this.isEmpty)
      return 0;
    let e = this.nextLayer.size;
    for (let t of this.chunk)
      e += t.value.length;
    return e;
  }
  /**
  @internal
  */
  chunkEnd(e) {
    return this.chunkPos[e] + this.chunk[e].length;
  }
  /**
  Update the range set, optionally adding new ranges or filtering
  out existing ones.
  
  (Note: The type parameter is just there as a kludge to work
  around TypeScript variance issues that prevented `RangeSet<X>`
  from being a subtype of `RangeSet<Y>` when `X` is a subtype of
  `Y`.)
  */
  update(e) {
    let { add: t = [], sort: r = !1, filterFrom: i = 0, filterTo: s = this.length } = e, l = e.filter;
    if (t.length == 0 && !l)
      return this;
    if (r && (t = t.slice().sort(Z0)), this.isEmpty)
      return t.length ? Ce.of(t) : this;
    let o = new op(this, null, -1).goto(0), a = 0, u = [], h = new ni();
    for (; o.value || a < t.length; )
      if (a < t.length && (o.from - t[a].from || o.startSide - t[a].value.startSide) >= 0) {
        let c = t[a++];
        h.addInner(c.from, c.to, c.value) || u.push(c);
      } else o.rangeIndex == 1 && o.chunkIndex < this.chunk.length && (a == t.length || this.chunkEnd(o.chunkIndex) < t[a].from) && (!l || i > this.chunkEnd(o.chunkIndex) || s < this.chunkPos[o.chunkIndex]) && h.addChunk(this.chunkPos[o.chunkIndex], this.chunk[o.chunkIndex]) ? o.nextChunk() : ((!l || i > o.to || s < o.from || l(o.from, o.to, o.value)) && (h.addInner(o.from, o.to, o.value) || u.push(X0.create(o.from, o.to, o.value))), o.next());
    return h.finishInner(this.nextLayer.isEmpty && !u.length ? Ce.empty : this.nextLayer.update({ add: u, filter: l, filterFrom: i, filterTo: s }));
  }
  /**
  Map this range set through a set of changes, return the new set.
  */
  map(e) {
    if (e.empty || this.isEmpty)
      return this;
    let t = [], r = [], i = -1;
    for (let l = 0; l < this.chunk.length; l++) {
      let o = this.chunkPos[l], a = this.chunk[l], u = e.touchesRange(o, o + a.length);
      if (u === !1)
        i = Math.max(i, a.maxPoint), t.push(a), r.push(e.mapPos(o));
      else if (u === !0) {
        let { mapped: h, pos: c } = a.map(o, e);
        h && (i = Math.max(i, h.maxPoint), t.push(h), r.push(c));
      }
    }
    let s = this.nextLayer.map(e);
    return t.length == 0 ? s : new Ce(r, t, s || Ce.empty, i);
  }
  /**
  Iterate over the ranges that touch the region `from` to `to`,
  calling `f` for each. There is no guarantee that the ranges will
  be reported in any specific order. When the callback returns
  `false`, iteration stops.
  */
  between(e, t, r) {
    if (!this.isEmpty) {
      for (let i = 0; i < this.chunk.length; i++) {
        let s = this.chunkPos[i], l = this.chunk[i];
        if (t >= s && e <= s + l.length && l.between(s, e - s, t - s, r) === !1)
          return;
      }
      this.nextLayer.between(e, t, r);
    }
  }
  /**
  Iterate over the ranges in this set, in order, including all
  ranges that end at or after `from`.
  */
  iter(e = 0) {
    return $s.from([this]).goto(e);
  }
  /**
  @internal
  */
  get isEmpty() {
    return this.nextLayer == this;
  }
  /**
  Iterate over the ranges in a collection of sets, in order,
  starting from `from`.
  */
  static iter(e, t = 0) {
    return $s.from(e).goto(t);
  }
  /**
  Iterate over two groups of sets, calling methods on `comparator`
  to notify it of possible differences.
  */
  static compare(e, t, r, i, s = -1) {
    let l = e.filter((c) => c.maxPoint > 0 || !c.isEmpty && c.maxPoint >= s), o = t.filter((c) => c.maxPoint > 0 || !c.isEmpty && c.maxPoint >= s), a = Vc(l, o, r), u = new ds(l, a, s), h = new ds(o, a, s);
    r.iterGaps((c, f, m) => Wc(u, c, h, f, m, i)), r.empty && r.length == 0 && Wc(u, 0, h, 0, 0, i);
  }
  /**
  Compare the contents of two groups of range sets, returning true
  if they are equivalent in the given range.
  */
  static eq(e, t, r = 0, i) {
    i == null && (i = 999999999);
    let s = e.filter((h) => !h.isEmpty && t.indexOf(h) < 0), l = t.filter((h) => !h.isEmpty && e.indexOf(h) < 0);
    if (s.length != l.length)
      return !1;
    if (!s.length)
      return !0;
    let o = Vc(s, l), a = new ds(s, o, 0).goto(r), u = new ds(l, o, 0).goto(r);
    for (; ; ) {
      if (a.to != u.to || !J0(a.active, u.active) || a.point && (!u.point || !a.point.eq(u.point)))
        return !1;
      if (a.to > i)
        return !0;
      a.next(), u.next();
    }
  }
  /**
  Iterate over a group of range sets at the same time, notifying
  the iterator about the ranges covering every given piece of
  content. Returns the open count (see
  [`SpanIterator.span`](https://codemirror.net/6/docs/ref/#state.SpanIterator.span)) at the end
  of the iteration.
  */
  static spans(e, t, r, i, s = -1) {
    let l = new ds(e, null, s).goto(t), o = t, a = l.openStart;
    for (; ; ) {
      let u = Math.min(l.to, r);
      if (l.point) {
        let h = l.activeForPoint(l.to), c = l.pointFrom < t ? h.length + 1 : l.point.startSide < 0 ? h.length : Math.min(h.length, a);
        i.point(o, u, l.point, h, c, l.pointRank), a = Math.min(l.openEnd(u), h.length);
      } else u > o && (i.span(o, u, l.active, a), a = l.openEnd(u));
      if (l.to > r)
        return a + (l.point && l.to > r ? 1 : 0);
      o = l.to, l.next();
    }
  }
  /**
  Create a range set for the given range or array of ranges. By
  default, this expects the ranges to be _sorted_ (by start
  position and, if two start at the same position,
  `value.startSide`). You can pass `true` as second argument to
  cause the method to sort them.
  */
  static of(e, t = !1) {
    let r = new ni();
    for (let i of e instanceof X0 ? [e] : t ? q5(e) : e)
      r.add(i.from, i.to, i.value);
    return r.finish();
  }
  /**
  Join an array of range sets into a single set.
  */
  static join(e) {
    if (!e.length)
      return Ce.empty;
    let t = e[e.length - 1];
    for (let r = e.length - 2; r >= 0; r--)
      for (let i = e[r]; i != Ce.empty; i = i.nextLayer)
        t = new Ce(i.chunkPos, i.chunk, t, Math.max(i.maxPoint, t.maxPoint));
    return t;
  }
}
Ce.empty = /* @__PURE__ */ new Ce([], [], null, -1);
function q5(n) {
  if (n.length > 1)
    for (let e = n[0], t = 1; t < n.length; t++) {
      let r = n[t];
      if (Z0(e, r) > 0)
        return n.slice().sort(Z0);
      e = r;
    }
  return n;
}
Ce.empty.nextLayer = Ce.empty;
class ni {
  finishChunk(e) {
    this.chunks.push(new ih(this.from, this.to, this.value, this.maxPoint)), this.chunkPos.push(this.chunkStart), this.chunkStart = -1, this.setMaxPoint = Math.max(this.setMaxPoint, this.maxPoint), this.maxPoint = -1, e && (this.from = [], this.to = [], this.value = []);
  }
  /**
  Create an empty builder.
  */
  constructor() {
    this.chunks = [], this.chunkPos = [], this.chunkStart = -1, this.last = null, this.lastFrom = -1e9, this.lastTo = -1e9, this.from = [], this.to = [], this.value = [], this.maxPoint = -1, this.setMaxPoint = -1, this.nextLayer = null;
  }
  /**
  Add a range. Ranges should be added in sorted (by `from` and
  `value.startSide`) order.
  */
  add(e, t, r) {
    this.addInner(e, t, r) || (this.nextLayer || (this.nextLayer = new ni())).add(e, t, r);
  }
  /**
  @internal
  */
  addInner(e, t, r) {
    let i = e - this.lastTo || r.startSide - this.last.endSide;
    if (i <= 0 && (e - this.lastFrom || r.startSide - this.last.startSide) < 0)
      throw new Error("Ranges must be added sorted by `from` position and `startSide`");
    return i < 0 ? !1 : (this.from.length == 250 && this.finishChunk(!0), this.chunkStart < 0 && (this.chunkStart = e), this.from.push(e - this.chunkStart), this.to.push(t - this.chunkStart), this.last = r, this.lastFrom = e, this.lastTo = t, this.value.push(r), r.point && (this.maxPoint = Math.max(this.maxPoint, t - e)), !0);
  }
  /**
  @internal
  */
  addChunk(e, t) {
    if ((e - this.lastTo || t.value[0].startSide - this.last.endSide) < 0)
      return !1;
    this.from.length && this.finishChunk(!0), this.setMaxPoint = Math.max(this.setMaxPoint, t.maxPoint), this.chunks.push(t), this.chunkPos.push(e);
    let r = t.value.length - 1;
    return this.last = t.value[r], this.lastFrom = t.from[r] + e, this.lastTo = t.to[r] + e, !0;
  }
  /**
  Finish the range set. Returns the new set. The builder can't be
  used anymore after this has been called.
  */
  finish() {
    return this.finishInner(Ce.empty);
  }
  /**
  @internal
  */
  finishInner(e) {
    if (this.from.length && this.finishChunk(!1), this.chunks.length == 0)
      return e;
    let t = Ce.create(this.chunkPos, this.chunks, this.nextLayer ? this.nextLayer.finishInner(e) : e, this.setMaxPoint);
    return this.from = null, t;
  }
}
function Vc(n, e, t) {
  let r = /* @__PURE__ */ new Map();
  for (let s of n)
    for (let l = 0; l < s.chunk.length; l++)
      s.chunk[l].maxPoint <= 0 && r.set(s.chunk[l], s.chunkPos[l]);
  let i = /* @__PURE__ */ new Set();
  for (let s of e)
    for (let l = 0; l < s.chunk.length; l++) {
      let o = r.get(s.chunk[l]);
      o != null && (t ? t.mapPos(o) : o) == s.chunkPos[l] && !t?.touchesRange(o, o + s.chunk[l].length) && i.add(s.chunk[l]);
    }
  return i;
}
class op {
  constructor(e, t, r, i = 0) {
    this.layer = e, this.skip = t, this.minPoint = r, this.rank = i;
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  get endSide() {
    return this.value ? this.value.endSide : 0;
  }
  goto(e, t = -1e9) {
    return this.chunkIndex = this.rangeIndex = 0, this.gotoInner(e, t, !1), this;
  }
  gotoInner(e, t, r) {
    for (; this.chunkIndex < this.layer.chunk.length; ) {
      let i = this.layer.chunk[this.chunkIndex];
      if (!(this.skip && this.skip.has(i) || this.layer.chunkEnd(this.chunkIndex) < e || i.maxPoint < this.minPoint))
        break;
      this.chunkIndex++, r = !1;
    }
    if (this.chunkIndex < this.layer.chunk.length) {
      let i = this.layer.chunk[this.chunkIndex].findIndex(e - this.layer.chunkPos[this.chunkIndex], t, !0);
      (!r || this.rangeIndex < i) && this.setRangeIndex(i);
    }
    this.next();
  }
  forward(e, t) {
    (this.to - e || this.endSide - t) < 0 && this.gotoInner(e, t, !0);
  }
  next() {
    for (; ; )
      if (this.chunkIndex == this.layer.chunk.length) {
        this.from = this.to = 1e9, this.value = null;
        break;
      } else {
        let e = this.layer.chunkPos[this.chunkIndex], t = this.layer.chunk[this.chunkIndex], r = e + t.from[this.rangeIndex];
        if (this.from = r, this.to = e + t.to[this.rangeIndex], this.value = t.value[this.rangeIndex], this.setRangeIndex(this.rangeIndex + 1), this.minPoint < 0 || this.value.point && this.to - this.from >= this.minPoint)
          break;
      }
  }
  setRangeIndex(e) {
    if (e == this.layer.chunk[this.chunkIndex].value.length) {
      if (this.chunkIndex++, this.skip)
        for (; this.chunkIndex < this.layer.chunk.length && this.skip.has(this.layer.chunk[this.chunkIndex]); )
          this.chunkIndex++;
      this.rangeIndex = 0;
    } else
      this.rangeIndex = e;
  }
  nextChunk() {
    this.chunkIndex++, this.rangeIndex = 0, this.next();
  }
  compare(e) {
    return this.from - e.from || this.startSide - e.startSide || this.rank - e.rank || this.to - e.to || this.endSide - e.endSide;
  }
}
class $s {
  constructor(e) {
    this.heap = e;
  }
  static from(e, t = null, r = -1) {
    let i = [];
    for (let s = 0; s < e.length; s++)
      for (let l = e[s]; !l.isEmpty; l = l.nextLayer)
        l.maxPoint >= r && i.push(new op(l, t, r, s));
    return i.length == 1 ? i[0] : new $s(i);
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  goto(e, t = -1e9) {
    for (let r of this.heap)
      r.goto(e, t);
    for (let r = this.heap.length >> 1; r >= 0; r--)
      Fa(this.heap, r);
    return this.next(), this;
  }
  forward(e, t) {
    for (let r of this.heap)
      r.forward(e, t);
    for (let r = this.heap.length >> 1; r >= 0; r--)
      Fa(this.heap, r);
    (this.to - e || this.value.endSide - t) < 0 && this.next();
  }
  next() {
    if (this.heap.length == 0)
      this.from = this.to = 1e9, this.value = null, this.rank = -1;
    else {
      let e = this.heap[0];
      this.from = e.from, this.to = e.to, this.value = e.value, this.rank = e.rank, e.value && e.next(), Fa(this.heap, 0);
    }
  }
}
function Fa(n, e) {
  for (let t = n[e]; ; ) {
    let r = (e << 1) + 1;
    if (r >= n.length)
      break;
    let i = n[r];
    if (r + 1 < n.length && i.compare(n[r + 1]) >= 0 && (i = n[r + 1], r++), t.compare(i) < 0)
      break;
    n[r] = t, n[e] = i, e = r;
  }
}
class ds {
  constructor(e, t, r) {
    this.minPoint = r, this.active = [], this.activeTo = [], this.activeRank = [], this.minActive = -1, this.point = null, this.pointFrom = 0, this.pointRank = 0, this.to = -1e9, this.endSide = 0, this.openStart = -1, this.cursor = $s.from(e, t, r);
  }
  goto(e, t = -1e9) {
    return this.cursor.goto(e, t), this.active.length = this.activeTo.length = this.activeRank.length = 0, this.minActive = -1, this.to = e, this.endSide = t, this.openStart = -1, this.next(), this;
  }
  forward(e, t) {
    for (; this.minActive > -1 && (this.activeTo[this.minActive] - e || this.active[this.minActive].endSide - t) < 0; )
      this.removeActive(this.minActive);
    this.cursor.forward(e, t);
  }
  removeActive(e) {
    Sl(this.active, e), Sl(this.activeTo, e), Sl(this.activeRank, e), this.minActive = Uc(this.active, this.activeTo);
  }
  addActive(e) {
    let t = 0, { value: r, to: i, rank: s } = this.cursor;
    for (; t < this.activeRank.length && (s - this.activeRank[t] || i - this.activeTo[t]) > 0; )
      t++;
    Al(this.active, t, r), Al(this.activeTo, t, i), Al(this.activeRank, t, s), e && Al(e, t, this.cursor.from), this.minActive = Uc(this.active, this.activeTo);
  }
  // After calling this, if `this.point` != null, the next range is a
  // point. Otherwise, it's a regular range, covered by `this.active`.
  next() {
    let e = this.to, t = this.point;
    this.point = null;
    let r = this.openStart < 0 ? [] : null;
    for (; ; ) {
      let i = this.minActive;
      if (i > -1 && (this.activeTo[i] - this.cursor.from || this.active[i].endSide - this.cursor.startSide) < 0) {
        if (this.activeTo[i] > e) {
          this.to = this.activeTo[i], this.endSide = this.active[i].endSide;
          break;
        }
        this.removeActive(i), r && Sl(r, i);
      } else if (this.cursor.value)
        if (this.cursor.from > e) {
          this.to = this.cursor.from, this.endSide = this.cursor.startSide;
          break;
        } else {
          let s = this.cursor.value;
          if (!s.point)
            this.addActive(r), this.cursor.next();
          else if (t && this.cursor.to == this.to && this.cursor.from < this.cursor.to)
            this.cursor.next();
          else {
            this.point = s, this.pointFrom = this.cursor.from, this.pointRank = this.cursor.rank, this.to = this.cursor.to, this.endSide = s.endSide, this.cursor.next(), this.forward(this.to, this.endSide);
            break;
          }
        }
      else {
        this.to = this.endSide = 1e9;
        break;
      }
    }
    if (r) {
      this.openStart = 0;
      for (let i = r.length - 1; i >= 0 && r[i] < e; i--)
        this.openStart++;
    }
  }
  activeForPoint(e) {
    if (!this.active.length)
      return this.active;
    let t = [];
    for (let r = this.active.length - 1; r >= 0 && !(this.activeRank[r] < this.pointRank); r--)
      (this.activeTo[r] > e || this.activeTo[r] == e && this.active[r].endSide >= this.point.endSide) && t.push(this.active[r]);
    return t.reverse();
  }
  openEnd(e) {
    let t = 0;
    for (let r = this.activeTo.length - 1; r >= 0 && this.activeTo[r] > e; r--)
      t++;
    return t;
  }
}
function Wc(n, e, t, r, i, s) {
  n.goto(e), t.goto(r);
  let l = r + i, o = r, a = r - e;
  for (; ; ) {
    let u = n.to + a - t.to || n.endSide - t.endSide, h = u < 0 ? n.to + a : t.to, c = Math.min(h, l);
    if (n.point || t.point ? n.point && t.point && (n.point == t.point || n.point.eq(t.point)) && J0(n.activeForPoint(n.to), t.activeForPoint(t.to)) || s.comparePoint(o, c, n.point, t.point) : c > o && !J0(n.active, t.active) && s.compareRange(o, c, n.active, t.active), h > l)
      break;
    o = h, u <= 0 && n.next(), u >= 0 && t.next();
  }
}
function J0(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (n[t] != e[t] && !n[t].eq(e[t]))
      return !1;
  return !0;
}
function Sl(n, e) {
  for (let t = e, r = n.length - 1; t < r; t++)
    n[t] = n[t + 1];
  n.pop();
}
function Al(n, e, t) {
  for (let r = n.length - 1; r >= e; r--)
    n[r + 1] = n[r];
  n[e] = t;
}
function Uc(n, e) {
  let t = -1, r = 1e9;
  for (let i = 0; i < e.length; i++)
    (e[i] - r || n[i].endSide - n[t].endSide) < 0 && (t = i, r = e[i]);
  return t;
}
function rs(n, e, t = n.length) {
  let r = 0;
  for (let i = 0; i < t; )
    n.charCodeAt(i) == 9 ? (r += e - r % e, i++) : (r++, i = kt(n, i));
  return r;
}
function Q0(n, e, t, r) {
  for (let i = 0, s = 0; ; ) {
    if (s >= e)
      return i;
    if (i == n.length)
      break;
    s += n.charCodeAt(i) == 9 ? t - s % t : 1, i = kt(n, i);
  }
  return r === !0 ? -1 : n.length;
}
const eu = "ͼ", Gc = typeof Symbol > "u" ? "__" + eu : Symbol.for(eu), tu = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), jc = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class On {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(e, t) {
    this.rules = [];
    let { finish: r } = t || {};
    function i(l) {
      return /^@/.test(l) ? [l] : l.split(/,\s*/);
    }
    function s(l, o, a, u) {
      let h = [], c = /^@(\w+)\b/.exec(l[0]), f = c && c[1] == "keyframes";
      if (c && o == null) return a.push(l[0] + ";");
      for (let m in o) {
        let g = o[m];
        if (/&/.test(m))
          s(
            m.split(/,\s*/).map((v) => l.map((k) => v.replace(/&/, k))).reduce((v, k) => v.concat(k)),
            g,
            a
          );
        else if (g && typeof g == "object") {
          if (!c) throw new RangeError("The value of a property (" + m + ") should be a primitive value.");
          s(i(m), g, h, f);
        } else g != null && h.push(m.replace(/_.*/, "").replace(/[A-Z]/g, (v) => "-" + v.toLowerCase()) + ": " + g + ";");
      }
      (h.length || f) && a.push((r && !c && !u ? l.map(r) : l).join(", ") + " {" + h.join(" ") + "}");
    }
    for (let l in e) s(i(l), e[l], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let e = jc[Gc] || 1;
    return jc[Gc] = e + 1, eu + e.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(e, t, r) {
    let i = e[tu], s = r && r.nonce;
    i ? s && i.setNonce(s) : i = new V5(e, s), i.mount(Array.isArray(t) ? t : [t], e);
  }
}
let $c = /* @__PURE__ */ new Map();
class V5 {
  constructor(e, t) {
    let r = e.ownerDocument || e, i = r.defaultView;
    if (!e.head && e.adoptedStyleSheets && i.CSSStyleSheet) {
      let s = $c.get(r);
      if (s) return e[tu] = s;
      this.sheet = new i.CSSStyleSheet(), $c.set(r, this);
    } else
      this.styleTag = r.createElement("style"), t && this.styleTag.setAttribute("nonce", t);
    this.modules = [], e[tu] = this;
  }
  mount(e, t) {
    let r = this.sheet, i = 0, s = 0;
    for (let l = 0; l < e.length; l++) {
      let o = e[l], a = this.modules.indexOf(o);
      if (a < s && a > -1 && (this.modules.splice(a, 1), s--, a = -1), a == -1) {
        if (this.modules.splice(s++, 0, o), r) for (let u = 0; u < o.rules.length; u++)
          r.insertRule(o.rules[u], i++);
      } else {
        for (; s < a; ) i += this.modules[s++].rules.length;
        i += o.rules.length, s++;
      }
    }
    if (r)
      t.adoptedStyleSheets.indexOf(this.sheet) < 0 && (t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets]);
    else {
      let l = "";
      for (let a = 0; a < this.modules.length; a++)
        l += this.modules[a].getRules() + `
`;
      this.styleTag.textContent = l;
      let o = t.head || t;
      this.styleTag.parentNode != o && o.insertBefore(this.styleTag, o.firstChild);
    }
  }
  setNonce(e) {
    this.styleTag && this.styleTag.getAttribute("nonce") != e && this.styleTag.setAttribute("nonce", e);
  }
}
var Rn = {
  8: "Backspace",
  9: "Tab",
  10: "Enter",
  12: "NumLock",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  44: "PrintScreen",
  45: "Insert",
  46: "Delete",
  59: ";",
  61: "=",
  91: "Meta",
  92: "Meta",
  106: "*",
  107: "+",
  108: ",",
  109: "-",
  110: ".",
  111: "/",
  144: "NumLock",
  145: "ScrollLock",
  160: "Shift",
  161: "Shift",
  162: "Control",
  163: "Control",
  164: "Alt",
  165: "Alt",
  173: "-",
  186: ";",
  187: "=",
  188: ",",
  189: "-",
  190: ".",
  191: "/",
  192: "`",
  219: "[",
  220: "\\",
  221: "]",
  222: "'"
}, Ys = {
  48: ")",
  49: "!",
  50: "@",
  51: "#",
  52: "$",
  53: "%",
  54: "^",
  55: "&",
  56: "*",
  57: "(",
  59: ":",
  61: "+",
  173: "_",
  186: ":",
  187: "+",
  188: "<",
  189: "_",
  190: ">",
  191: "?",
  192: "~",
  219: "{",
  220: "|",
  221: "}",
  222: '"'
}, W5 = typeof navigator < "u" && /Mac/.test(navigator.platform), U5 = typeof navigator < "u" && /MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent);
for (var ot = 0; ot < 10; ot++) Rn[48 + ot] = Rn[96 + ot] = String(ot);
for (var ot = 1; ot <= 24; ot++) Rn[ot + 111] = "F" + ot;
for (var ot = 65; ot <= 90; ot++)
  Rn[ot] = String.fromCharCode(ot + 32), Ys[ot] = String.fromCharCode(ot);
for (var Ba in Rn) Ys.hasOwnProperty(Ba) || (Ys[Ba] = Rn[Ba]);
function G5(n) {
  var e = W5 && n.metaKey && n.shiftKey && !n.ctrlKey && !n.altKey || U5 && n.shiftKey && n.key && n.key.length == 1 || n.key == "Unidentified", t = !e && n.key || (n.shiftKey ? Ys : Rn)[n.keyCode] || n.key || "Unidentified";
  return t == "Esc" && (t = "Escape"), t == "Del" && (t = "Delete"), t == "Left" && (t = "ArrowLeft"), t == "Up" && (t = "ArrowUp"), t == "Right" && (t = "ArrowRight"), t == "Down" && (t = "ArrowDown"), t;
}
function Ks(n) {
  let e;
  return n.nodeType == 11 ? e = n.getSelection ? n : n.ownerDocument : e = n, e.getSelection();
}
function ru(n, e) {
  return e ? n == e || n.contains(e.nodeType != 1 ? e.parentNode : e) : !1;
}
function mo(n, e) {
  if (!e.anchorNode)
    return !1;
  try {
    return ru(n, e.anchorNode);
  } catch {
    return !1;
  }
}
function Gi(n) {
  return n.nodeType == 3 ? si(n, 0, n.nodeValue.length).getClientRects() : n.nodeType == 1 ? n.getClientRects() : [];
}
function Ns(n, e, t, r) {
  return t ? Yc(n, e, t, r, -1) || Yc(n, e, t, r, 1) : !1;
}
function ii(n) {
  for (var e = 0; ; e++)
    if (n = n.previousSibling, !n)
      return e;
}
function To(n) {
  return n.nodeType == 1 && /^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(n.nodeName);
}
function Yc(n, e, t, r, i) {
  for (; ; ) {
    if (n == t && e == r)
      return !0;
    if (e == (i < 0 ? 0 : Yr(n))) {
      if (n.nodeName == "DIV")
        return !1;
      let s = n.parentNode;
      if (!s || s.nodeType != 1)
        return !1;
      e = ii(n) + (i < 0 ? 0 : 1), n = s;
    } else if (n.nodeType == 1) {
      if (n = n.childNodes[e + (i < 0 ? -1 : 0)], n.nodeType == 1 && n.contentEditable == "false")
        return !1;
      e = i < 0 ? Yr(n) : 0;
    } else
      return !1;
  }
}
function Yr(n) {
  return n.nodeType == 3 ? n.nodeValue.length : n.childNodes.length;
}
function ul(n, e) {
  let t = e ? n.left : n.right;
  return { left: t, right: t, top: n.top, bottom: n.bottom };
}
function j5(n) {
  let e = n.visualViewport;
  return e ? {
    left: 0,
    right: e.width,
    top: 0,
    bottom: e.height
  } : {
    left: 0,
    right: n.innerWidth,
    top: 0,
    bottom: n.innerHeight
  };
}
function ap(n, e) {
  let t = e.width / n.offsetWidth, r = e.height / n.offsetHeight;
  return (t > 0.995 && t < 1.005 || !isFinite(t) || Math.abs(e.width - n.offsetWidth) < 1) && (t = 1), (r > 0.995 && r < 1.005 || !isFinite(r) || Math.abs(e.height - n.offsetHeight) < 1) && (r = 1), { scaleX: t, scaleY: r };
}
function $5(n, e, t, r, i, s, l, o) {
  let a = n.ownerDocument, u = a.defaultView || window;
  for (let h = n, c = !1; h && !c; )
    if (h.nodeType == 1) {
      let f, m = h == a.body, g = 1, v = 1;
      if (m)
        f = j5(u);
      else {
        if (/^(fixed|sticky)$/.test(getComputedStyle(h).position) && (c = !0), h.scrollHeight <= h.clientHeight && h.scrollWidth <= h.clientWidth) {
          h = h.assignedSlot || h.parentNode;
          continue;
        }
        let x = h.getBoundingClientRect();
        ({ scaleX: g, scaleY: v } = ap(h, x)), f = {
          left: x.left,
          right: x.left + h.clientWidth * g,
          top: x.top,
          bottom: x.top + h.clientHeight * v
        };
      }
      let k = 0, S = 0;
      if (i == "nearest")
        e.top < f.top ? (S = -(f.top - e.top + l), t > 0 && e.bottom > f.bottom + S && (S = e.bottom - f.bottom + S + l)) : e.bottom > f.bottom && (S = e.bottom - f.bottom + l, t < 0 && e.top - S < f.top && (S = -(f.top + S - e.top + l)));
      else {
        let x = e.bottom - e.top, y = f.bottom - f.top;
        S = (i == "center" && x <= y ? e.top + x / 2 - y / 2 : i == "start" || i == "center" && t < 0 ? e.top - l : e.bottom - y + l) - f.top;
      }
      if (r == "nearest" ? e.left < f.left ? (k = -(f.left - e.left + s), t > 0 && e.right > f.right + k && (k = e.right - f.right + k + s)) : e.right > f.right && (k = e.right - f.right + s, t < 0 && e.left < f.left + k && (k = -(f.left + k - e.left + s))) : k = (r == "center" ? e.left + (e.right - e.left) / 2 - (f.right - f.left) / 2 : r == "start" == o ? e.left - s : e.right - (f.right - f.left) + s) - f.left, k || S)
        if (m)
          u.scrollBy(k, S);
        else {
          let x = 0, y = 0;
          if (S) {
            let A = h.scrollTop;
            h.scrollTop += S / v, y = (h.scrollTop - A) * v;
          }
          if (k) {
            let A = h.scrollLeft;
            h.scrollLeft += k / g, x = (h.scrollLeft - A) * g;
          }
          e = {
            left: e.left - x,
            top: e.top - y,
            right: e.right - x,
            bottom: e.bottom - y
          }, x && Math.abs(x - k) < 1 && (r = "nearest"), y && Math.abs(y - S) < 1 && (i = "nearest");
        }
      if (m)
        break;
      h = h.assignedSlot || h.parentNode;
    } else if (h.nodeType == 11)
      h = h.host;
    else
      break;
}
function Y5(n) {
  let e = n.ownerDocument, t, r;
  for (let i = n.parentNode; i && !(i == e.body || t && r); )
    if (i.nodeType == 1)
      !r && i.scrollHeight > i.clientHeight && (r = i), !t && i.scrollWidth > i.clientWidth && (t = i), i = i.assignedSlot || i.parentNode;
    else if (i.nodeType == 11)
      i = i.host;
    else
      break;
  return { x: t, y: r };
}
class K5 {
  constructor() {
    this.anchorNode = null, this.anchorOffset = 0, this.focusNode = null, this.focusOffset = 0;
  }
  eq(e) {
    return this.anchorNode == e.anchorNode && this.anchorOffset == e.anchorOffset && this.focusNode == e.focusNode && this.focusOffset == e.focusOffset;
  }
  setRange(e) {
    let { anchorNode: t, focusNode: r } = e;
    this.set(t, Math.min(e.anchorOffset, t ? Yr(t) : 0), r, Math.min(e.focusOffset, r ? Yr(r) : 0));
  }
  set(e, t, r, i) {
    this.anchorNode = e, this.anchorOffset = t, this.focusNode = r, this.focusOffset = i;
  }
}
let Ai = null;
function up(n) {
  if (n.setActive)
    return n.setActive();
  if (Ai)
    return n.focus(Ai);
  let e = [];
  for (let t = n; t && (e.push(t, t.scrollTop, t.scrollLeft), t != t.ownerDocument); t = t.parentNode)
    ;
  if (n.focus(Ai == null ? {
    get preventScroll() {
      return Ai = { preventScroll: !0 }, !0;
    }
  } : void 0), !Ai) {
    Ai = !1;
    for (let t = 0; t < e.length; ) {
      let r = e[t++], i = e[t++], s = e[t++];
      r.scrollTop != i && (r.scrollTop = i), r.scrollLeft != s && (r.scrollLeft = s);
    }
  }
}
let Kc;
function si(n, e, t = e) {
  let r = Kc || (Kc = document.createRange());
  return r.setEnd(n, t), r.setStart(n, e), r;
}
function Pi(n, e, t, r) {
  let i = { key: e, code: e, keyCode: t, which: t, cancelable: !0 };
  r && ({ altKey: i.altKey, ctrlKey: i.ctrlKey, shiftKey: i.shiftKey, metaKey: i.metaKey } = r);
  let s = new KeyboardEvent("keydown", i);
  s.synthetic = !0, n.dispatchEvent(s);
  let l = new KeyboardEvent("keyup", i);
  return l.synthetic = !0, n.dispatchEvent(l), s.defaultPrevented || l.defaultPrevented;
}
function X5(n) {
  for (; n; ) {
    if (n && (n.nodeType == 9 || n.nodeType == 11 && n.host))
      return n;
    n = n.assignedSlot || n.parentNode;
  }
  return null;
}
function hp(n) {
  for (; n.attributes.length; )
    n.removeAttributeNode(n.attributes[0]);
}
function Z5(n, e) {
  let t = e.focusNode, r = e.focusOffset;
  if (!t || e.anchorNode != t || e.anchorOffset != r)
    return !1;
  for (r = Math.min(r, Yr(t)); ; )
    if (r) {
      if (t.nodeType != 1)
        return !1;
      let i = t.childNodes[r - 1];
      i.contentEditable == "false" ? r-- : (t = i, r = Yr(t));
    } else {
      if (t == n)
        return !0;
      r = ii(t), t = t.parentNode;
    }
}
function cp(n) {
  return n.scrollTop > Math.max(1, n.scrollHeight - n.clientHeight - 4);
}
function fp(n, e) {
  for (let t = n, r = e; ; ) {
    if (t.nodeType == 3 && r > 0)
      return { node: t, offset: r };
    if (t.nodeType == 1 && r > 0) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[r - 1], r = Yr(t);
    } else if (t.parentNode && !To(t))
      r = ii(t), t = t.parentNode;
    else
      return null;
  }
}
function dp(n, e) {
  for (let t = n, r = e; ; ) {
    if (t.nodeType == 3 && r < t.nodeValue.length)
      return { node: t, offset: r };
    if (t.nodeType == 1 && r < t.childNodes.length) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[r], r = 0;
    } else if (t.parentNode && !To(t))
      r = ii(t) + 1, t = t.parentNode;
    else
      return null;
  }
}
class dt {
  constructor(e, t, r = !0) {
    this.node = e, this.offset = t, this.precise = r;
  }
  static before(e, t) {
    return new dt(e.parentNode, ii(e), t);
  }
  static after(e, t) {
    return new dt(e.parentNode, ii(e) + 1, t);
  }
}
const sh = [];
class Be {
  constructor() {
    this.parent = null, this.dom = null, this.flags = 2;
  }
  get overrideDOMText() {
    return null;
  }
  get posAtStart() {
    return this.parent ? this.parent.posBefore(this) : 0;
  }
  get posAtEnd() {
    return this.posAtStart + this.length;
  }
  posBefore(e) {
    let t = this.posAtStart;
    for (let r of this.children) {
      if (r == e)
        return t;
      t += r.length + r.breakAfter;
    }
    throw new RangeError("Invalid child in posBefore");
  }
  posAfter(e) {
    return this.posBefore(e) + e.length;
  }
  sync(e, t) {
    if (this.flags & 2) {
      let r = this.dom, i = null, s;
      for (let l of this.children) {
        if (l.flags & 7) {
          if (!l.dom && (s = i ? i.nextSibling : r.firstChild)) {
            let o = Be.get(s);
            (!o || !o.parent && o.canReuseDOM(l)) && l.reuseDOM(s);
          }
          l.sync(e, t), l.flags &= -8;
        }
        if (s = i ? i.nextSibling : r.firstChild, t && !t.written && t.node == r && s != l.dom && (t.written = !0), l.dom.parentNode == r)
          for (; s && s != l.dom; )
            s = Xc(s);
        else
          r.insertBefore(l.dom, s);
        i = l.dom;
      }
      for (s = i ? i.nextSibling : r.firstChild, s && t && t.node == r && (t.written = !0); s; )
        s = Xc(s);
    } else if (this.flags & 1)
      for (let r of this.children)
        r.flags & 7 && (r.sync(e, t), r.flags &= -8);
  }
  reuseDOM(e) {
  }
  localPosFromDOM(e, t) {
    let r;
    if (e == this.dom)
      r = this.dom.childNodes[t];
    else {
      let i = Yr(e) == 0 ? 0 : t == 0 ? -1 : 1;
      for (; ; ) {
        let s = e.parentNode;
        if (s == this.dom)
          break;
        i == 0 && s.firstChild != s.lastChild && (e == s.firstChild ? i = -1 : i = 1), e = s;
      }
      i < 0 ? r = e : r = e.nextSibling;
    }
    if (r == this.dom.firstChild)
      return 0;
    for (; r && !Be.get(r); )
      r = r.nextSibling;
    if (!r)
      return this.length;
    for (let i = 0, s = 0; ; i++) {
      let l = this.children[i];
      if (l.dom == r)
        return s;
      s += l.length + l.breakAfter;
    }
  }
  domBoundsAround(e, t, r = 0) {
    let i = -1, s = -1, l = -1, o = -1;
    for (let a = 0, u = r, h = r; a < this.children.length; a++) {
      let c = this.children[a], f = u + c.length;
      if (u < e && f > t)
        return c.domBoundsAround(e, t, u);
      if (f >= e && i == -1 && (i = a, s = u), u > t && c.dom.parentNode == this.dom) {
        l = a, o = h;
        break;
      }
      h = f, u = f + c.breakAfter;
    }
    return {
      from: s,
      to: o < 0 ? r + this.length : o,
      startDOM: (i ? this.children[i - 1].dom.nextSibling : null) || this.dom.firstChild,
      endDOM: l < this.children.length && l >= 0 ? this.children[l].dom : null
    };
  }
  markDirty(e = !1) {
    this.flags |= 2, this.markParentsDirty(e);
  }
  markParentsDirty(e) {
    for (let t = this.parent; t; t = t.parent) {
      if (e && (t.flags |= 2), t.flags & 1)
        return;
      t.flags |= 1, e = !1;
    }
  }
  setParent(e) {
    this.parent != e && (this.parent = e, this.flags & 7 && this.markParentsDirty(!0));
  }
  setDOM(e) {
    this.dom != e && (this.dom && (this.dom.cmView = null), this.dom = e, e.cmView = this);
  }
  get rootView() {
    for (let e = this; ; ) {
      let t = e.parent;
      if (!t)
        return e;
      e = t;
    }
  }
  replaceChildren(e, t, r = sh) {
    this.markDirty();
    for (let i = e; i < t; i++) {
      let s = this.children[i];
      s.parent == this && r.indexOf(s) < 0 && s.destroy();
    }
    r.length < 250 ? this.children.splice(e, t - e, ...r) : this.children = [].concat(this.children.slice(0, e), r, this.children.slice(t));
    for (let i = 0; i < r.length; i++)
      r[i].setParent(this);
  }
  ignoreMutation(e) {
    return !1;
  }
  ignoreEvent(e) {
    return !1;
  }
  childCursor(e = this.length) {
    return new mp(this.children, e, this.children.length);
  }
  childPos(e, t = 1) {
    return this.childCursor().findPos(e, t);
  }
  toString() {
    let e = this.constructor.name.replace("View", "");
    return e + (this.children.length ? "(" + this.children.join() + ")" : this.length ? "[" + (e == "Text" ? this.text : this.length) + "]" : "") + (this.breakAfter ? "#" : "");
  }
  static get(e) {
    return e.cmView;
  }
  get isEditable() {
    return !0;
  }
  get isWidget() {
    return !1;
  }
  get isHidden() {
    return !1;
  }
  merge(e, t, r, i, s, l) {
    return !1;
  }
  become(e) {
    return !1;
  }
  canReuseDOM(e) {
    return e.constructor == this.constructor && !((this.flags | e.flags) & 8);
  }
  // When this is a zero-length view with a side, this should return a
  // number <= 0 to indicate it is before its position, or a
  // number > 0 when after its position.
  getSide() {
    return 0;
  }
  destroy() {
    for (let e of this.children)
      e.parent == this && e.destroy();
    this.parent = null;
  }
}
Be.prototype.breakAfter = 0;
function Xc(n) {
  let e = n.nextSibling;
  return n.parentNode.removeChild(n), e;
}
class mp {
  constructor(e, t, r) {
    this.children = e, this.pos = t, this.i = r, this.off = 0;
  }
  findPos(e, t = 1) {
    for (; ; ) {
      if (e > this.pos || e == this.pos && (t > 0 || this.i == 0 || this.children[this.i - 1].breakAfter))
        return this.off = e - this.pos, this;
      let r = this.children[--this.i];
      this.pos -= r.length + r.breakAfter;
    }
  }
}
function pp(n, e, t, r, i, s, l, o, a) {
  let { children: u } = n, h = u.length ? u[e] : null, c = s.length ? s[s.length - 1] : null, f = c ? c.breakAfter : l;
  if (!(e == r && h && !l && !f && s.length < 2 && h.merge(t, i, s.length ? c : null, t == 0, o, a))) {
    if (r < u.length) {
      let m = u[r];
      m && (i < m.length || m.breakAfter && c?.breakAfter) ? (e == r && (m = m.split(i), i = 0), !f && c && m.merge(0, i, c, !0, 0, a) ? s[s.length - 1] = m : ((i || m.children.length && !m.children[0].length) && m.merge(0, i, null, !1, 0, a), s.push(m))) : m?.breakAfter && (c ? c.breakAfter = 1 : l = 1), r++;
    }
    for (h && (h.breakAfter = l, t > 0 && (!l && s.length && h.merge(t, h.length, s[0], !1, o, 0) ? h.breakAfter = s.shift().breakAfter : (t < h.length || h.children.length && h.children[h.children.length - 1].length == 0) && h.merge(t, h.length, null, !1, o, 0), e++)); e < r && s.length; )
      if (u[r - 1].become(s[s.length - 1]))
        r--, s.pop(), a = s.length ? 0 : o;
      else if (u[e].become(s[0]))
        e++, s.shift(), o = s.length ? 0 : a;
      else
        break;
    !s.length && e && r < u.length && !u[e - 1].breakAfter && u[r].merge(0, 0, u[e - 1], !1, o, a) && e--, (e < r || s.length) && n.replaceChildren(e, r, s);
  }
}
function gp(n, e, t, r, i, s) {
  let l = n.childCursor(), { i: o, off: a } = l.findPos(t, 1), { i: u, off: h } = l.findPos(e, -1), c = e - t;
  for (let f of r)
    c += f.length;
  n.length += c, pp(n, u, h, o, a, r, 0, i, s);
}
let Ot = typeof navigator < "u" ? navigator : { userAgent: "", vendor: "", platform: "" }, nu = typeof document < "u" ? document : { documentElement: { style: {} } };
const iu = /* @__PURE__ */ /Edge\/(\d+)/.exec(Ot.userAgent), bp = /* @__PURE__ */ /MSIE \d/.test(Ot.userAgent), su = /* @__PURE__ */ /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(Ot.userAgent), sa = !!(bp || su || iu), Zc = !sa && /* @__PURE__ */ /gecko\/(\d+)/i.test(Ot.userAgent), Oa = !sa && /* @__PURE__ */ /Chrome\/(\d+)/.exec(Ot.userAgent), Jc = "webkitFontSmoothing" in nu.documentElement.style, vp = !sa && /* @__PURE__ */ /Apple Computer/.test(Ot.vendor), Qc = vp && (/* @__PURE__ */ /Mobile\/\w+/.test(Ot.userAgent) || Ot.maxTouchPoints > 2);
var K = {
  mac: Qc || /* @__PURE__ */ /Mac/.test(Ot.platform),
  windows: /* @__PURE__ */ /Win/.test(Ot.platform),
  linux: /* @__PURE__ */ /Linux|X11/.test(Ot.platform),
  ie: sa,
  ie_version: bp ? nu.documentMode || 6 : su ? +su[1] : iu ? +iu[1] : 0,
  gecko: Zc,
  gecko_version: Zc ? +(/* @__PURE__ */ /Firefox\/(\d+)/.exec(Ot.userAgent) || [0, 0])[1] : 0,
  chrome: !!Oa,
  chrome_version: Oa ? +Oa[1] : 0,
  ios: Qc,
  android: /* @__PURE__ */ /Android\b/.test(Ot.userAgent),
  webkit: Jc,
  safari: vp,
  webkit_version: Jc ? +(/* @__PURE__ */ /\bAppleWebKit\/(\d+)/.exec(Ot.userAgent) || [0, 0])[1] : 0,
  tabSize: nu.documentElement.style.tabSize != null ? "tab-size" : "-moz-tab-size"
};
const J5 = 256;
class xr extends Be {
  constructor(e) {
    super(), this.text = e;
  }
  get length() {
    return this.text.length;
  }
  createDOM(e) {
    this.setDOM(e || document.createTextNode(this.text));
  }
  sync(e, t) {
    this.dom || this.createDOM(), this.dom.nodeValue != this.text && (t && t.node == this.dom && (t.written = !0), this.dom.nodeValue = this.text);
  }
  reuseDOM(e) {
    e.nodeType == 3 && this.createDOM(e);
  }
  merge(e, t, r) {
    return this.flags & 8 || r && (!(r instanceof xr) || this.length - (t - e) + r.length > J5 || r.flags & 8) ? !1 : (this.text = this.text.slice(0, e) + (r ? r.text : "") + this.text.slice(t), this.markDirty(), !0);
  }
  split(e) {
    let t = new xr(this.text.slice(e));
    return this.text = this.text.slice(0, e), this.markDirty(), t.flags |= this.flags & 8, t;
  }
  localPosFromDOM(e, t) {
    return e == this.dom ? t : t ? this.text.length : 0;
  }
  domAtPos(e) {
    return new dt(this.dom, e);
  }
  domBoundsAround(e, t, r) {
    return { from: r, to: r + this.length, startDOM: this.dom, endDOM: this.dom.nextSibling };
  }
  coordsAt(e, t) {
    return Q5(this.dom, e, t);
  }
}
class gn extends Be {
  constructor(e, t = [], r = 0) {
    super(), this.mark = e, this.children = t, this.length = r;
    for (let i of t)
      i.setParent(this);
  }
  setAttrs(e) {
    if (hp(e), this.mark.class && (e.className = this.mark.class), this.mark.attrs)
      for (let t in this.mark.attrs)
        e.setAttribute(t, this.mark.attrs[t]);
    return e;
  }
  canReuseDOM(e) {
    return super.canReuseDOM(e) && !((this.flags | e.flags) & 8);
  }
  reuseDOM(e) {
    e.nodeName == this.mark.tagName.toUpperCase() && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    this.dom ? this.flags & 4 && this.setAttrs(this.dom) : this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))), super.sync(e, t);
  }
  merge(e, t, r, i, s, l) {
    return r && (!(r instanceof gn && r.mark.eq(this.mark)) || e && s <= 0 || t < this.length && l <= 0) ? !1 : (gp(this, e, t, r ? r.children.slice() : [], s - 1, l - 1), this.markDirty(), !0);
  }
  split(e) {
    let t = [], r = 0, i = -1, s = 0;
    for (let o of this.children) {
      let a = r + o.length;
      a > e && t.push(r < e ? o.split(e - r) : o), i < 0 && r >= e && (i = s), r = a, s++;
    }
    let l = this.length - e;
    return this.length = e, i > -1 && (this.children.length = i, this.markDirty()), new gn(this.mark, t, l);
  }
  domAtPos(e) {
    return yp(this, e);
  }
  coordsAt(e, t) {
    return kp(this, e, t);
  }
}
function Q5(n, e, t) {
  let r = n.nodeValue.length;
  e > r && (e = r);
  let i = e, s = e, l = 0;
  e == 0 && t < 0 || e == r && t >= 0 ? K.chrome || K.gecko || (e ? (i--, l = 1) : s < r && (s++, l = -1)) : t < 0 ? i-- : s < r && s++;
  let o = si(n, i, s).getClientRects();
  if (!o.length)
    return null;
  let a = o[(l ? l < 0 : t >= 0) ? 0 : o.length - 1];
  return K.safari && !l && a.width == 0 && (a = Array.prototype.find.call(o, (u) => u.width) || a), l ? ul(a, l < 0) : a || null;
}
class En extends Be {
  static create(e, t, r) {
    return new En(e, t, r);
  }
  constructor(e, t, r) {
    super(), this.widget = e, this.length = t, this.side = r, this.prevWidget = null;
  }
  split(e) {
    let t = En.create(this.widget, this.length - e, this.side);
    return this.length -= e, t;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  getSide() {
    return this.side;
  }
  merge(e, t, r, i, s, l) {
    return r && (!(r instanceof En) || !this.widget.compare(r.widget) || e > 0 && s <= 0 || t < this.length && l <= 0) ? !1 : (this.length = e + (r ? r.length : 0) + (this.length - t), !0);
  }
  become(e) {
    return e instanceof En && e.side == this.side && this.widget.constructor == e.widget.constructor ? (this.widget.compare(e.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get overrideDOMText() {
    if (this.length == 0)
      return Ae.empty;
    let e = this;
    for (; e.parent; )
      e = e.parent;
    let { view: t } = e, r = t && t.state.doc, i = this.posAtStart;
    return r ? r.slice(i, i + this.length) : Ae.empty;
  }
  domAtPos(e) {
    return (this.length ? e == 0 : this.side > 0) ? dt.before(this.dom) : dt.after(this.dom, e == this.length);
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e, t) {
    let r = this.widget.coordsAt(this.dom, e, t);
    if (r)
      return r;
    let i = this.dom.getClientRects(), s = null;
    if (!i.length)
      return null;
    let l = this.side ? this.side < 0 : e > 0;
    for (let o = l ? i.length - 1 : 0; s = i[o], !(e > 0 ? o == 0 : o == i.length - 1 || s.top < s.bottom); o += l ? -1 : 1)
      ;
    return ul(s, !l);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  get isHidden() {
    return this.widget.isHidden;
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
}
class ji extends Be {
  constructor(e) {
    super(), this.side = e;
  }
  get length() {
    return 0;
  }
  merge() {
    return !1;
  }
  become(e) {
    return e instanceof ji && e.side == this.side;
  }
  split() {
    return new ji(this.side);
  }
  sync() {
    if (!this.dom) {
      let e = document.createElement("img");
      e.className = "cm-widgetBuffer", e.setAttribute("aria-hidden", "true"), this.setDOM(e);
    }
  }
  getSide() {
    return this.side;
  }
  domAtPos(e) {
    return this.side > 0 ? dt.before(this.dom) : dt.after(this.dom);
  }
  localPosFromDOM() {
    return 0;
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e) {
    return this.dom.getBoundingClientRect();
  }
  get overrideDOMText() {
    return Ae.empty;
  }
  get isHidden() {
    return !0;
  }
}
xr.prototype.children = En.prototype.children = ji.prototype.children = sh;
function yp(n, e) {
  let t = n.dom, { children: r } = n, i = 0;
  for (let s = 0; i < r.length; i++) {
    let l = r[i], o = s + l.length;
    if (!(o == s && l.getSide() <= 0)) {
      if (e > s && e < o && l.dom.parentNode == t)
        return l.domAtPos(e - s);
      if (e <= s)
        break;
      s = o;
    }
  }
  for (let s = i; s > 0; s--) {
    let l = r[s - 1];
    if (l.dom.parentNode == t)
      return l.domAtPos(l.length);
  }
  for (let s = i; s < r.length; s++) {
    let l = r[s];
    if (l.dom.parentNode == t)
      return l.domAtPos(0);
  }
  return new dt(t, 0);
}
function wp(n, e, t) {
  let r, { children: i } = n;
  t > 0 && e instanceof gn && i.length && (r = i[i.length - 1]) instanceof gn && r.mark.eq(e.mark) ? wp(r, e.children[0], t - 1) : (i.push(e), e.setParent(n)), n.length += e.length;
}
function kp(n, e, t) {
  let r = null, i = -1, s = null, l = -1;
  function o(u, h) {
    for (let c = 0, f = 0; c < u.children.length && f <= h; c++) {
      let m = u.children[c], g = f + m.length;
      g >= h && (m.children.length ? o(m, h - f) : (!s || s.isHidden && t > 0) && (g > h || f == g && m.getSide() > 0) ? (s = m, l = h - f) : (f < h || f == g && m.getSide() < 0 && !m.isHidden) && (r = m, i = h - f)), f = g;
    }
  }
  o(n, e);
  let a = (t < 0 ? r : s) || r || s;
  return a ? a.coordsAt(Math.max(0, a == r ? i : l), t) : e3(n);
}
function e3(n) {
  let e = n.dom.lastChild;
  if (!e)
    return n.dom.getBoundingClientRect();
  let t = Gi(e);
  return t[t.length - 1] || null;
}
function lu(n, e) {
  for (let t in n)
    t == "class" && e.class ? e.class += " " + n.class : t == "style" && e.style ? e.style += ";" + n.style : e[t] = n[t];
  return e;
}
const ef = /* @__PURE__ */ Object.create(null);
function Eo(n, e, t) {
  if (n == e)
    return !0;
  n || (n = ef), e || (e = ef);
  let r = Object.keys(n), i = Object.keys(e);
  if (r.length - (t && r.indexOf(t) > -1 ? 1 : 0) != i.length - (t && i.indexOf(t) > -1 ? 1 : 0))
    return !1;
  for (let s of r)
    if (s != t && (i.indexOf(s) == -1 || n[s] !== e[s]))
      return !1;
  return !0;
}
function ou(n, e, t) {
  let r = !1;
  if (e)
    for (let i in e)
      t && i in t || (r = !0, i == "style" ? n.style.cssText = "" : n.removeAttribute(i));
  if (t)
    for (let i in t)
      e && e[i] == t[i] || (r = !0, i == "style" ? n.style.cssText = t[i] : n.setAttribute(i, t[i]));
  return r;
}
function t3(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t = 0; t < n.attributes.length; t++) {
    let r = n.attributes[t];
    e[r.name] = r.value;
  }
  return e;
}
class Xr {
  /**
  Compare this instance to another instance of the same type.
  (TypeScript can't express this, but only instances of the same
  specific class will be passed to this method.) This is used to
  avoid redrawing widgets when they are replaced by a new
  decoration of the same type. The default implementation just
  returns `false`, which will cause new instances of the widget to
  always be redrawn.
  */
  eq(e) {
    return !1;
  }
  /**
  Update a DOM element created by a widget of the same type (but
  different, non-`eq` content) to reflect this widget. May return
  true to indicate that it could update, false to indicate it
  couldn't (in which case the widget will be redrawn). The default
  implementation just returns false.
  */
  updateDOM(e, t) {
    return !1;
  }
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  The estimated height this widget will have, to be used when
  estimating the height of content that hasn't been drawn. May
  return -1 to indicate you don't know. The default implementation
  returns -1.
  */
  get estimatedHeight() {
    return -1;
  }
  /**
  For inline widgets that are displayed inline (as opposed to
  `inline-block`) and introduce line breaks (through `<br>` tags
  or textual newlines), this must indicate the amount of line
  breaks they introduce. Defaults to 0.
  */
  get lineBreaks() {
    return 0;
  }
  /**
  Can be used to configure which kinds of events inside the widget
  should be ignored by the editor. The default is to ignore all
  events.
  */
  ignoreEvent(e) {
    return !0;
  }
  /**
  Override the way screen coordinates for positions at/in the
  widget are found. `pos` will be the offset into the widget, and
  `side` the side of the position that is being queried—less than
  zero for before, greater than zero for after, and zero for
  directly at that position.
  */
  coordsAt(e, t, r) {
    return null;
  }
  /**
  @internal
  */
  get isHidden() {
    return !1;
  }
  /**
  @internal
  */
  get editable() {
    return !1;
  }
  /**
  This is called when the an instance of the widget is removed
  from the editor view.
  */
  destroy(e) {
  }
}
var St = /* @__PURE__ */ function(n) {
  return n[n.Text = 0] = "Text", n[n.WidgetBefore = 1] = "WidgetBefore", n[n.WidgetAfter = 2] = "WidgetAfter", n[n.WidgetRange = 3] = "WidgetRange", n;
}(St || (St = {}));
class be extends ri {
  constructor(e, t, r, i) {
    super(), this.startSide = e, this.endSide = t, this.widget = r, this.spec = i;
  }
  /**
  @internal
  */
  get heightRelevant() {
    return !1;
  }
  /**
  Create a mark decoration, which influences the styling of the
  content in its range. Nested mark decorations will cause nested
  DOM elements to be created. Nesting order is determined by
  precedence of the [facet](https://codemirror.net/6/docs/ref/#view.EditorView^decorations), with
  the higher-precedence decorations creating the inner DOM nodes.
  Such elements are split on line boundaries and on the boundaries
  of lower-precedence decorations.
  */
  static mark(e) {
    return new hl(e);
  }
  /**
  Create a widget decoration, which displays a DOM element at the
  given position.
  */
  static widget(e) {
    let t = Math.max(-1e4, Math.min(1e4, e.side || 0)), r = !!e.block;
    return t += r && !e.inlineOrder ? t > 0 ? 3e8 : -4e8 : t > 0 ? 1e8 : -1e8, new Ln(e, t, t, r, e.widget || null, !1);
  }
  /**
  Create a replace decoration which replaces the given range with
  a widget, or simply hides it.
  */
  static replace(e) {
    let t = !!e.block, r, i;
    if (e.isBlockGap)
      r = -5e8, i = 4e8;
    else {
      let { start: s, end: l } = xp(e, t);
      r = (s ? t ? -3e8 : -1 : 5e8) - 1, i = (l ? t ? 2e8 : 1 : -6e8) + 1;
    }
    return new Ln(e, r, i, t, e.widget || null, !0);
  }
  /**
  Create a line decoration, which can add DOM attributes to the
  line starting at the given position.
  */
  static line(e) {
    return new cl(e);
  }
  /**
  Build a [`DecorationSet`](https://codemirror.net/6/docs/ref/#view.DecorationSet) from the given
  decorated range or ranges. If the ranges aren't already sorted,
  pass `true` for `sort` to make the library sort them for you.
  */
  static set(e, t = !1) {
    return Ce.of(e, t);
  }
  /**
  @internal
  */
  hasHeight() {
    return this.widget ? this.widget.estimatedHeight > -1 : !1;
  }
}
be.none = Ce.empty;
class hl extends be {
  constructor(e) {
    let { start: t, end: r } = xp(e);
    super(t ? -1 : 5e8, r ? 1 : -6e8, null, e), this.tagName = e.tagName || "span", this.class = e.class || "", this.attrs = e.attributes || null;
  }
  eq(e) {
    var t, r;
    return this == e || e instanceof hl && this.tagName == e.tagName && (this.class || ((t = this.attrs) === null || t === void 0 ? void 0 : t.class)) == (e.class || ((r = e.attrs) === null || r === void 0 ? void 0 : r.class)) && Eo(this.attrs, e.attrs, "class");
  }
  range(e, t = e) {
    if (e >= t)
      throw new RangeError("Mark decorations may not be empty");
    return super.range(e, t);
  }
}
hl.prototype.point = !1;
class cl extends be {
  constructor(e) {
    super(-2e8, -2e8, null, e);
  }
  eq(e) {
    return e instanceof cl && this.spec.class == e.spec.class && Eo(this.spec.attributes, e.spec.attributes);
  }
  range(e, t = e) {
    if (t != e)
      throw new RangeError("Line decoration ranges must be zero-length");
    return super.range(e, t);
  }
}
cl.prototype.mapMode = at.TrackBefore;
cl.prototype.point = !0;
class Ln extends be {
  constructor(e, t, r, i, s, l) {
    super(t, r, s, e), this.block = i, this.isReplace = l, this.mapMode = i ? t <= 0 ? at.TrackBefore : at.TrackAfter : at.TrackDel;
  }
  // Only relevant when this.block == true
  get type() {
    return this.startSide != this.endSide ? St.WidgetRange : this.startSide <= 0 ? St.WidgetBefore : St.WidgetAfter;
  }
  get heightRelevant() {
    return this.block || !!this.widget && (this.widget.estimatedHeight >= 5 || this.widget.lineBreaks > 0);
  }
  eq(e) {
    return e instanceof Ln && r3(this.widget, e.widget) && this.block == e.block && this.startSide == e.startSide && this.endSide == e.endSide;
  }
  range(e, t = e) {
    if (this.isReplace && (e > t || e == t && this.startSide > 0 && this.endSide <= 0))
      throw new RangeError("Invalid range for replacement decoration");
    if (!this.isReplace && t != e)
      throw new RangeError("Widget decorations can only have zero-length ranges");
    return super.range(e, t);
  }
}
Ln.prototype.point = !0;
function xp(n, e = !1) {
  let { inclusiveStart: t, inclusiveEnd: r } = n;
  return t == null && (t = n.inclusive), r == null && (r = n.inclusive), { start: t ?? e, end: r ?? e };
}
function r3(n, e) {
  return n == e || !!(n && e && n.compare(e));
}
function au(n, e, t, r = 0) {
  let i = t.length - 1;
  i >= 0 && t[i] + r >= n ? t[i] = Math.max(t[i], e) : t.push(n, e);
}
class Je extends Be {
  constructor() {
    super(...arguments), this.children = [], this.length = 0, this.prevAttrs = void 0, this.attrs = null, this.breakAfter = 0;
  }
  // Consumes source
  merge(e, t, r, i, s, l) {
    if (r) {
      if (!(r instanceof Je))
        return !1;
      this.dom || r.transferDOM(this);
    }
    return i && this.setDeco(r ? r.attrs : null), gp(this, e, t, r ? r.children.slice() : [], s, l), !0;
  }
  split(e) {
    let t = new Je();
    if (t.breakAfter = this.breakAfter, this.length == 0)
      return t;
    let { i: r, off: i } = this.childPos(e);
    i && (t.append(this.children[r].split(i), 0), this.children[r].merge(i, this.children[r].length, null, !1, 0, 0), r++);
    for (let s = r; s < this.children.length; s++)
      t.append(this.children[s], 0);
    for (; r > 0 && this.children[r - 1].length == 0; )
      this.children[--r].destroy();
    return this.children.length = r, this.markDirty(), this.length = e, t;
  }
  transferDOM(e) {
    this.dom && (this.markDirty(), e.setDOM(this.dom), e.prevAttrs = this.prevAttrs === void 0 ? this.attrs : this.prevAttrs, this.prevAttrs = void 0, this.dom = null);
  }
  setDeco(e) {
    Eo(this.attrs, e) || (this.dom && (this.prevAttrs = this.attrs, this.markDirty()), this.attrs = e);
  }
  append(e, t) {
    wp(this, e, t);
  }
  // Only called when building a line view in ContentBuilder
  addLineDeco(e) {
    let t = e.spec.attributes, r = e.spec.class;
    t && (this.attrs = lu(t, this.attrs || {})), r && (this.attrs = lu({ class: r }, this.attrs || {}));
  }
  domAtPos(e) {
    return yp(this, e);
  }
  reuseDOM(e) {
    e.nodeName == "DIV" && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    var r;
    this.dom ? this.flags & 4 && (hp(this.dom), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0) : (this.setDOM(document.createElement("div")), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0), this.prevAttrs !== void 0 && (ou(this.dom, this.prevAttrs, this.attrs), this.dom.classList.add("cm-line"), this.prevAttrs = void 0), super.sync(e, t);
    let i = this.dom.lastChild;
    for (; i && Be.get(i) instanceof gn; )
      i = i.lastChild;
    if (!i || !this.length || i.nodeName != "BR" && ((r = Be.get(i)) === null || r === void 0 ? void 0 : r.isEditable) == !1 && (!K.ios || !this.children.some((s) => s instanceof xr))) {
      let s = document.createElement("BR");
      s.cmIgnore = !0, this.dom.appendChild(s);
    }
  }
  measureTextSize() {
    if (this.children.length == 0 || this.length > 20)
      return null;
    let e = 0, t;
    for (let r of this.children) {
      if (!(r instanceof xr) || /[^ -~]/.test(r.text))
        return null;
      let i = Gi(r.dom);
      if (i.length != 1)
        return null;
      e += i[0].width, t = i[0].height;
    }
    return e ? {
      lineHeight: this.dom.getBoundingClientRect().height,
      charWidth: e / this.length,
      textHeight: t
    } : null;
  }
  coordsAt(e, t) {
    let r = kp(this, e, t);
    if (!this.children.length && r && this.parent) {
      let { heightOracle: i } = this.parent.view.viewState, s = r.bottom - r.top;
      if (Math.abs(s - i.lineHeight) < 2 && i.textHeight < s) {
        let l = (s - i.textHeight) / 2;
        return { top: r.top + l, bottom: r.bottom - l, left: r.left, right: r.left };
      }
    }
    return r;
  }
  become(e) {
    return e instanceof Je && this.children.length == 0 && e.children.length == 0 && Eo(this.attrs, e.attrs) && this.breakAfter == e.breakAfter;
  }
  covers() {
    return !0;
  }
  static find(e, t) {
    for (let r = 0, i = 0; r < e.children.length; r++) {
      let s = e.children[r], l = i + s.length;
      if (l >= t) {
        if (s instanceof Je)
          return s;
        if (l > t)
          break;
      }
      i = l + s.breakAfter;
    }
    return null;
  }
}
class fn extends Be {
  constructor(e, t, r) {
    super(), this.widget = e, this.length = t, this.deco = r, this.breakAfter = 0, this.prevWidget = null;
  }
  merge(e, t, r, i, s, l) {
    return r && (!(r instanceof fn) || !this.widget.compare(r.widget) || e > 0 && s <= 0 || t < this.length && l <= 0) ? !1 : (this.length = e + (r ? r.length : 0) + (this.length - t), !0);
  }
  domAtPos(e) {
    return e == 0 ? dt.before(this.dom) : dt.after(this.dom, e == this.length);
  }
  split(e) {
    let t = this.length - e;
    this.length = e;
    let r = new fn(this.widget, t, this.deco);
    return r.breakAfter = this.breakAfter, r;
  }
  get children() {
    return sh;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  get overrideDOMText() {
    return this.parent ? this.parent.view.state.doc.slice(this.posAtStart, this.posAtEnd) : Ae.empty;
  }
  domBoundsAround() {
    return null;
  }
  become(e) {
    return e instanceof fn && e.widget.constructor == this.widget.constructor ? (e.widget.compare(this.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, this.deco = e.deco, this.breakAfter = e.breakAfter, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  coordsAt(e, t) {
    let r = this.widget.coordsAt(this.dom, e, t);
    return r || (this.widget instanceof uu ? null : ul(this.dom.getBoundingClientRect(), this.length ? e == 0 : t <= 0));
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
  covers(e) {
    let { startSide: t, endSide: r } = this.deco;
    return t == r ? !1 : e < 0 ? t < 0 : r > 0;
  }
}
class uu extends Xr {
  constructor(e) {
    super(), this.height = e;
  }
  toDOM() {
    let e = document.createElement("div");
    return e.className = "cm-gap", this.updateDOM(e), e;
  }
  eq(e) {
    return e.height == this.height;
  }
  updateDOM(e) {
    return e.style.height = this.height + "px", !0;
  }
  get editable() {
    return !0;
  }
  get estimatedHeight() {
    return this.height;
  }
  ignoreEvent() {
    return !1;
  }
}
class Is {
  constructor(e, t, r, i) {
    this.doc = e, this.pos = t, this.end = r, this.disallowBlockEffectsFor = i, this.content = [], this.curLine = null, this.breakAtStart = 0, this.pendingBuffer = 0, this.bufferMarks = [], this.atCursorPos = !0, this.openStart = -1, this.openEnd = -1, this.text = "", this.textOff = 0, this.cursor = e.iter(), this.skip = t;
  }
  posCovered() {
    if (this.content.length == 0)
      return !this.breakAtStart && this.doc.lineAt(this.pos).from != this.pos;
    let e = this.content[this.content.length - 1];
    return !(e.breakAfter || e instanceof fn && e.deco.endSide < 0);
  }
  getLine() {
    return this.curLine || (this.content.push(this.curLine = new Je()), this.atCursorPos = !0), this.curLine;
  }
  flushBuffer(e = this.bufferMarks) {
    this.pendingBuffer && (this.curLine.append(Dl(new ji(-1), e), e.length), this.pendingBuffer = 0);
  }
  addBlockWidget(e) {
    this.flushBuffer(), this.curLine = null, this.content.push(e);
  }
  finish(e) {
    this.pendingBuffer && e <= this.bufferMarks.length ? this.flushBuffer() : this.pendingBuffer = 0, !this.posCovered() && !(e && this.content.length && this.content[this.content.length - 1] instanceof fn) && this.getLine();
  }
  buildText(e, t, r) {
    for (; e > 0; ) {
      if (this.textOff == this.text.length) {
        let { value: s, lineBreak: l, done: o } = this.cursor.next(this.skip);
        if (this.skip = 0, o)
          throw new Error("Ran out of text content when drawing inline views");
        if (l) {
          this.posCovered() || this.getLine(), this.content.length ? this.content[this.content.length - 1].breakAfter = 1 : this.breakAtStart = 1, this.flushBuffer(), this.curLine = null, this.atCursorPos = !0, e--;
          continue;
        } else
          this.text = s, this.textOff = 0;
      }
      let i = Math.min(
        this.text.length - this.textOff,
        e,
        512
        /* T.Chunk */
      );
      this.flushBuffer(t.slice(t.length - r)), this.getLine().append(Dl(new xr(this.text.slice(this.textOff, this.textOff + i)), t), r), this.atCursorPos = !0, this.textOff += i, e -= i, r = 0;
    }
  }
  span(e, t, r, i) {
    this.buildText(t - e, r, i), this.pos = t, this.openStart < 0 && (this.openStart = i);
  }
  point(e, t, r, i, s, l) {
    if (this.disallowBlockEffectsFor[l] && r instanceof Ln) {
      if (r.block)
        throw new RangeError("Block decorations may not be specified via plugins");
      if (t > this.doc.lineAt(this.pos).to)
        throw new RangeError("Decorations that replace line breaks may not be specified via plugins");
    }
    let o = t - e;
    if (r instanceof Ln)
      if (r.block)
        r.startSide > 0 && !this.posCovered() && this.getLine(), this.addBlockWidget(new fn(r.widget || $i.block, o, r));
      else {
        let a = En.create(r.widget || $i.inline, o, o ? 0 : r.startSide), u = this.atCursorPos && !a.isEditable && s <= i.length && (e < t || r.startSide > 0), h = !a.isEditable && (e < t || s > i.length || r.startSide <= 0), c = this.getLine();
        this.pendingBuffer == 2 && !u && !a.isEditable && (this.pendingBuffer = 0), this.flushBuffer(i), u && (c.append(Dl(new ji(1), i), s), s = i.length + Math.max(0, s - i.length)), c.append(Dl(a, i), s), this.atCursorPos = h, this.pendingBuffer = h ? e < t || s > i.length ? 1 : 2 : 0, this.pendingBuffer && (this.bufferMarks = i.slice());
      }
    else this.doc.lineAt(this.pos).from == this.pos && this.getLine().addLineDeco(r);
    o && (this.textOff + o <= this.text.length ? this.textOff += o : (this.skip += o - (this.text.length - this.textOff), this.text = "", this.textOff = 0), this.pos = t), this.openStart < 0 && (this.openStart = s);
  }
  static build(e, t, r, i, s) {
    let l = new Is(e, t, r, s);
    return l.openEnd = Ce.spans(i, t, r, l), l.openStart < 0 && (l.openStart = l.openEnd), l.finish(l.openEnd), l;
  }
}
function Dl(n, e) {
  for (let t of e)
    n = new gn(t, [n], n.length);
  return n;
}
class $i extends Xr {
  constructor(e) {
    super(), this.tag = e;
  }
  eq(e) {
    return e.tag == this.tag;
  }
  toDOM() {
    return document.createElement(this.tag);
  }
  updateDOM(e) {
    return e.nodeName.toLowerCase() == this.tag;
  }
  get isHidden() {
    return !0;
  }
}
$i.inline = /* @__PURE__ */ new $i("span");
$i.block = /* @__PURE__ */ new $i("div");
var Ie = /* @__PURE__ */ function(n) {
  return n[n.LTR = 0] = "LTR", n[n.RTL = 1] = "RTL", n;
}(Ie || (Ie = {}));
const li = Ie.LTR, lh = Ie.RTL;
function Sp(n) {
  let e = [];
  for (let t = 0; t < n.length; t++)
    e.push(1 << +n[t]);
  return e;
}
const n3 = /* @__PURE__ */ Sp("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"), i3 = /* @__PURE__ */ Sp("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"), hu = /* @__PURE__ */ Object.create(null), Tr = [];
for (let n of ["()", "[]", "{}"]) {
  let e = /* @__PURE__ */ n.charCodeAt(0), t = /* @__PURE__ */ n.charCodeAt(1);
  hu[e] = t, hu[t] = -e;
}
function Ap(n) {
  return n <= 247 ? n3[n] : 1424 <= n && n <= 1524 ? 2 : 1536 <= n && n <= 1785 ? i3[n - 1536] : 1774 <= n && n <= 2220 ? 4 : 8192 <= n && n <= 8204 ? 256 : 64336 <= n && n <= 65023 ? 4 : 1;
}
const s3 = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac\ufb50-\ufdff]/;
class Fn {
  /**
  The direction of this span.
  */
  get dir() {
    return this.level % 2 ? lh : li;
  }
  /**
  @internal
  */
  constructor(e, t, r) {
    this.from = e, this.to = t, this.level = r;
  }
  /**
  @internal
  */
  side(e, t) {
    return this.dir == t == e ? this.to : this.from;
  }
  /**
  @internal
  */
  forward(e, t) {
    return e == (this.dir == t);
  }
  /**
  @internal
  */
  static find(e, t, r, i) {
    let s = -1;
    for (let l = 0; l < e.length; l++) {
      let o = e[l];
      if (o.from <= t && o.to >= t) {
        if (o.level == r)
          return l;
        (s < 0 || (i != 0 ? i < 0 ? o.from < t : o.to > t : e[s].level > o.level)) && (s = l);
      }
    }
    if (s < 0)
      throw new RangeError("Index out of range");
    return s;
  }
}
function Dp(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++) {
    let r = n[t], i = e[t];
    if (r.from != i.from || r.to != i.to || r.direction != i.direction || !Dp(r.inner, i.inner))
      return !1;
  }
  return !0;
}
const Fe = [];
function l3(n, e, t, r, i) {
  for (let s = 0; s <= r.length; s++) {
    let l = s ? r[s - 1].to : e, o = s < r.length ? r[s].from : t, a = s ? 256 : i;
    for (let u = l, h = a, c = a; u < o; u++) {
      let f = Ap(n.charCodeAt(u));
      f == 512 ? f = h : f == 8 && c == 4 && (f = 16), Fe[u] = f == 4 ? 2 : f, f & 7 && (c = f), h = f;
    }
    for (let u = l, h = a, c = a; u < o; u++) {
      let f = Fe[u];
      if (f == 128)
        u < o - 1 && h == Fe[u + 1] && h & 24 ? f = Fe[u] = h : Fe[u] = 256;
      else if (f == 64) {
        let m = u + 1;
        for (; m < o && Fe[m] == 64; )
          m++;
        let g = u && h == 8 || m < t && Fe[m] == 8 ? c == 1 ? 1 : 8 : 256;
        for (let v = u; v < m; v++)
          Fe[v] = g;
        u = m - 1;
      } else f == 8 && c == 1 && (Fe[u] = 1);
      h = f, f & 7 && (c = f);
    }
  }
}
function o3(n, e, t, r, i) {
  let s = i == 1 ? 2 : 1;
  for (let l = 0, o = 0, a = 0; l <= r.length; l++) {
    let u = l ? r[l - 1].to : e, h = l < r.length ? r[l].from : t;
    for (let c = u, f, m, g; c < h; c++)
      if (m = hu[f = n.charCodeAt(c)])
        if (m < 0) {
          for (let v = o - 3; v >= 0; v -= 3)
            if (Tr[v + 1] == -m) {
              let k = Tr[v + 2], S = k & 2 ? i : k & 4 ? k & 1 ? s : i : 0;
              S && (Fe[c] = Fe[Tr[v]] = S), o = v;
              break;
            }
        } else {
          if (Tr.length == 189)
            break;
          Tr[o++] = c, Tr[o++] = f, Tr[o++] = a;
        }
      else if ((g = Fe[c]) == 2 || g == 1) {
        let v = g == i;
        a = v ? 0 : 1;
        for (let k = o - 3; k >= 0; k -= 3) {
          let S = Tr[k + 2];
          if (S & 2)
            break;
          if (v)
            Tr[k + 2] |= 2;
          else {
            if (S & 4)
              break;
            Tr[k + 2] |= 4;
          }
        }
      }
  }
}
function a3(n, e, t, r) {
  for (let i = 0, s = r; i <= t.length; i++) {
    let l = i ? t[i - 1].to : n, o = i < t.length ? t[i].from : e;
    for (let a = l; a < o; ) {
      let u = Fe[a];
      if (u == 256) {
        let h = a + 1;
        for (; ; )
          if (h == o) {
            if (i == t.length)
              break;
            h = t[i++].to, o = i < t.length ? t[i].from : e;
          } else if (Fe[h] == 256)
            h++;
          else
            break;
        let c = s == 1, f = (h < e ? Fe[h] : r) == 1, m = c == f ? c ? 1 : 2 : r;
        for (let g = h, v = i, k = v ? t[v - 1].to : n; g > a; )
          g == k && (g = t[--v].from, k = v ? t[v - 1].to : n), Fe[--g] = m;
        a = h;
      } else
        s = u, a++;
    }
  }
}
function cu(n, e, t, r, i, s, l) {
  let o = r % 2 ? 2 : 1;
  if (r % 2 == i % 2)
    for (let a = e, u = 0; a < t; ) {
      let h = !0, c = !1;
      if (u == s.length || a < s[u].from) {
        let v = Fe[a];
        v != o && (h = !1, c = v == 16);
      }
      let f = !h && o == 1 ? [] : null, m = h ? r : r + 1, g = a;
      e: for (; ; )
        if (u < s.length && g == s[u].from) {
          if (c)
            break e;
          let v = s[u];
          if (!h)
            for (let k = v.to, S = u + 1; ; ) {
              if (k == t)
                break e;
              if (S < s.length && s[S].from == k)
                k = s[S++].to;
              else {
                if (Fe[k] == o)
                  break e;
                break;
              }
            }
          if (u++, f)
            f.push(v);
          else {
            v.from > a && l.push(new Fn(a, v.from, m));
            let k = v.direction == li != !(m % 2);
            fu(n, k ? r + 1 : r, i, v.inner, v.from, v.to, l), a = v.to;
          }
          g = v.to;
        } else {
          if (g == t || (h ? Fe[g] != o : Fe[g] == o))
            break;
          g++;
        }
      f ? cu(n, a, g, r + 1, i, f, l) : a < g && l.push(new Fn(a, g, m)), a = g;
    }
  else
    for (let a = t, u = s.length; a > e; ) {
      let h = !0, c = !1;
      if (!u || a > s[u - 1].to) {
        let v = Fe[a - 1];
        v != o && (h = !1, c = v == 16);
      }
      let f = !h && o == 1 ? [] : null, m = h ? r : r + 1, g = a;
      e: for (; ; )
        if (u && g == s[u - 1].to) {
          if (c)
            break e;
          let v = s[--u];
          if (!h)
            for (let k = v.from, S = u; ; ) {
              if (k == e)
                break e;
              if (S && s[S - 1].to == k)
                k = s[--S].from;
              else {
                if (Fe[k - 1] == o)
                  break e;
                break;
              }
            }
          if (f)
            f.push(v);
          else {
            v.to < a && l.push(new Fn(v.to, a, m));
            let k = v.direction == li != !(m % 2);
            fu(n, k ? r + 1 : r, i, v.inner, v.from, v.to, l), a = v.from;
          }
          g = v.from;
        } else {
          if (g == e || (h ? Fe[g - 1] != o : Fe[g - 1] == o))
            break;
          g--;
        }
      f ? cu(n, g, a, r + 1, i, f, l) : g < a && l.push(new Fn(g, a, m)), a = g;
    }
}
function fu(n, e, t, r, i, s, l) {
  let o = e % 2 ? 2 : 1;
  l3(n, i, s, r, o), o3(n, i, s, r, o), a3(i, s, r, o), cu(n, i, s, e, t, r, l);
}
function u3(n, e, t) {
  if (!n)
    return [new Fn(0, 0, e == lh ? 1 : 0)];
  if (e == li && !t.length && !s3.test(n))
    return Cp(n.length);
  if (t.length)
    for (; n.length > Fe.length; )
      Fe[Fe.length] = 256;
  let r = [], i = e == li ? 0 : 1;
  return fu(n, i, i, t, 0, n.length, r), r;
}
function Cp(n) {
  return [new Fn(0, n, 0)];
}
let _p = "";
function h3(n, e, t, r, i) {
  var s;
  let l = r.head - n.from, o = Fn.find(e, l, (s = r.bidiLevel) !== null && s !== void 0 ? s : -1, r.assoc), a = e[o], u = a.side(i, t);
  if (l == u) {
    let f = o += i ? 1 : -1;
    if (f < 0 || f >= e.length)
      return null;
    a = e[o = f], l = a.side(!i, t), u = a.side(i, t);
  }
  let h = kt(n.text, l, a.forward(i, t));
  (h < a.from || h > a.to) && (h = u), _p = n.text.slice(Math.min(l, h), Math.max(l, h));
  let c = o == (i ? e.length - 1 : 0) ? null : e[o + (i ? 1 : -1)];
  return c && h == u && c.level + (i ? 0 : 1) < a.level ? I.cursor(c.side(!i, t) + n.from, c.forward(i, t) ? 1 : -1, c.level) : I.cursor(h + n.from, a.forward(i, t) ? -1 : 1, a.level);
}
function c3(n, e, t) {
  for (let r = e; r < t; r++) {
    let i = Ap(n.charCodeAt(r));
    if (i == 1)
      return li;
    if (i == 2 || i == 4)
      return lh;
  }
  return li;
}
const Mp = /* @__PURE__ */ X.define(), Tp = /* @__PURE__ */ X.define(), Ep = /* @__PURE__ */ X.define(), Fp = /* @__PURE__ */ X.define(), du = /* @__PURE__ */ X.define(), Bp = /* @__PURE__ */ X.define(), Op = /* @__PURE__ */ X.define(), oh = /* @__PURE__ */ X.define(), ah = /* @__PURE__ */ X.define(), Rp = /* @__PURE__ */ X.define({
  combine: (n) => n.some((e) => e)
}), Lp = /* @__PURE__ */ X.define({
  combine: (n) => n.some((e) => e)
}), Np = /* @__PURE__ */ X.define();
class Hi {
  constructor(e, t = "nearest", r = "nearest", i = 5, s = 5, l = !1) {
    this.range = e, this.y = t, this.x = r, this.yMargin = i, this.xMargin = s, this.isSnapshot = l;
  }
  map(e) {
    return e.empty ? this : new Hi(this.range.map(e), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
  clip(e) {
    return this.range.to <= e.doc.length ? this : new Hi(I.cursor(e.doc.length), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
}
const Cl = /* @__PURE__ */ ye.define({ map: (n, e) => n.map(e) }), Ip = /* @__PURE__ */ ye.define();
function Xt(n, e, t) {
  let r = n.facet(Fp);
  r.length ? r[0](e) : window.onerror ? window.onerror(String(e), t, void 0, void 0, e) : t ? console.error(t + ":", e) : console.error(e);
}
const _n = /* @__PURE__ */ X.define({ combine: (n) => n.length ? n[0] : !0 });
let f3 = 0;
const Ms = /* @__PURE__ */ X.define();
class pt {
  constructor(e, t, r, i, s) {
    this.id = e, this.create = t, this.domEventHandlers = r, this.domEventObservers = i, this.extension = s(this);
  }
  /**
  Define a plugin from a constructor function that creates the
  plugin's value, given an editor view.
  */
  static define(e, t) {
    const { eventHandlers: r, eventObservers: i, provide: s, decorations: l } = t || {};
    return new pt(f3++, e, r, i, (o) => {
      let a = [Ms.of(o)];
      return l && a.push(Xs.of((u) => {
        let h = u.plugin(o);
        return h ? l(h) : be.none;
      })), s && a.push(s(o)), a;
    });
  }
  /**
  Create a plugin for a class whose constructor takes a single
  editor view as argument.
  */
  static fromClass(e, t) {
    return pt.define((r) => new e(r), t);
  }
}
class Ra {
  constructor(e) {
    this.spec = e, this.mustUpdate = null, this.value = null;
  }
  update(e) {
    if (this.value) {
      if (this.mustUpdate) {
        let t = this.mustUpdate;
        if (this.mustUpdate = null, this.value.update)
          try {
            this.value.update(t);
          } catch (r) {
            if (Xt(t.state, r, "CodeMirror plugin crashed"), this.value.destroy)
              try {
                this.value.destroy();
              } catch {
              }
            this.deactivate();
          }
      }
    } else if (this.spec)
      try {
        this.value = this.spec.create(e);
      } catch (t) {
        Xt(e.state, t, "CodeMirror plugin crashed"), this.deactivate();
      }
    return this;
  }
  destroy(e) {
    var t;
    if (!((t = this.value) === null || t === void 0) && t.destroy)
      try {
        this.value.destroy();
      } catch (r) {
        Xt(e.state, r, "CodeMirror plugin crashed");
      }
  }
  deactivate() {
    this.spec = this.value = null;
  }
}
const zp = /* @__PURE__ */ X.define(), uh = /* @__PURE__ */ X.define(), Xs = /* @__PURE__ */ X.define(), Pp = /* @__PURE__ */ X.define(), hh = /* @__PURE__ */ X.define(), Hp = /* @__PURE__ */ X.define();
function tf(n, e) {
  let t = n.state.facet(Hp);
  if (!t.length)
    return t;
  let r = t.map((s) => s instanceof Function ? s(n) : s), i = [];
  return Ce.spans(r, e.from, e.to, {
    point() {
    },
    span(s, l, o, a) {
      let u = s - e.from, h = l - e.from, c = i;
      for (let f = o.length - 1; f >= 0; f--, a--) {
        let m = o[f].spec.bidiIsolate, g;
        if (m == null && (m = c3(e.text, u, h)), a > 0 && c.length && (g = c[c.length - 1]).to == u && g.direction == m)
          g.to = h, c = g.inner;
        else {
          let v = { from: u, to: h, direction: m, inner: [] };
          c.push(v), c = v.inner;
        }
      }
    }
  }), i;
}
const qp = /* @__PURE__ */ X.define();
function Vp(n) {
  let e = 0, t = 0, r = 0, i = 0;
  for (let s of n.state.facet(qp)) {
    let l = s(n);
    l && (l.left != null && (e = Math.max(e, l.left)), l.right != null && (t = Math.max(t, l.right)), l.top != null && (r = Math.max(r, l.top)), l.bottom != null && (i = Math.max(i, l.bottom)));
  }
  return { left: e, right: t, top: r, bottom: i };
}
const Ts = /* @__PURE__ */ X.define();
class nr {
  constructor(e, t, r, i) {
    this.fromA = e, this.toA = t, this.fromB = r, this.toB = i;
  }
  join(e) {
    return new nr(Math.min(this.fromA, e.fromA), Math.max(this.toA, e.toA), Math.min(this.fromB, e.fromB), Math.max(this.toB, e.toB));
  }
  addToSet(e) {
    let t = e.length, r = this;
    for (; t > 0; t--) {
      let i = e[t - 1];
      if (!(i.fromA > r.toA)) {
        if (i.toA < r.fromA)
          break;
        r = r.join(i), e.splice(t - 1, 1);
      }
    }
    return e.splice(t, 0, r), e;
  }
  static extendWithRanges(e, t) {
    if (t.length == 0)
      return e;
    let r = [];
    for (let i = 0, s = 0, l = 0, o = 0; ; i++) {
      let a = i == e.length ? null : e[i], u = l - o, h = a ? a.fromB : 1e9;
      for (; s < t.length && t[s] < h; ) {
        let c = t[s], f = t[s + 1], m = Math.max(o, c), g = Math.min(h, f);
        if (m <= g && new nr(m + u, g + u, m, g).addToSet(r), f > h)
          break;
        s += 2;
      }
      if (!a)
        return r;
      new nr(a.fromA, a.toA, a.fromB, a.toB).addToSet(r), l = a.toA, o = a.toB;
    }
  }
}
class Fo {
  constructor(e, t, r) {
    this.view = e, this.state = t, this.transactions = r, this.flags = 0, this.startState = e.state, this.changes = tt.empty(this.startState.doc.length);
    for (let s of r)
      this.changes = this.changes.compose(s.changes);
    let i = [];
    this.changes.iterChangedRanges((s, l, o, a) => i.push(new nr(s, l, o, a))), this.changedRanges = i;
  }
  /**
  @internal
  */
  static create(e, t, r) {
    return new Fo(e, t, r);
  }
  /**
  Tells you whether the [viewport](https://codemirror.net/6/docs/ref/#view.EditorView.viewport) or
  [visible ranges](https://codemirror.net/6/docs/ref/#view.EditorView.visibleRanges) changed in this
  update.
  */
  get viewportChanged() {
    return (this.flags & 4) > 0;
  }
  /**
  Indicates whether the height of a block element in the editor
  changed in this update.
  */
  get heightChanged() {
    return (this.flags & 2) > 0;
  }
  /**
  Returns true when the document was modified or the size of the
  editor, or elements within the editor, changed.
  */
  get geometryChanged() {
    return this.docChanged || (this.flags & 10) > 0;
  }
  /**
  True when this update indicates a focus change.
  */
  get focusChanged() {
    return (this.flags & 1) > 0;
  }
  /**
  Whether the document changed in this update.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Whether the selection was explicitly set in this update.
  */
  get selectionSet() {
    return this.transactions.some((e) => e.selection);
  }
  /**
  @internal
  */
  get empty() {
    return this.flags == 0 && this.transactions.length == 0;
  }
}
class rf extends Be {
  get length() {
    return this.view.state.doc.length;
  }
  constructor(e) {
    super(), this.view = e, this.decorations = [], this.dynamicDecorationMap = [!1], this.domChanged = null, this.hasComposition = null, this.markedForComposition = /* @__PURE__ */ new Set(), this.editContextFormatting = be.none, this.lastCompositionAfterCursor = !1, this.minWidth = 0, this.minWidthFrom = 0, this.minWidthTo = 0, this.impreciseAnchor = null, this.impreciseHead = null, this.forceSelection = !1, this.lastUpdate = Date.now(), this.setDOM(e.contentDOM), this.children = [new Je()], this.children[0].setParent(this), this.updateDeco(), this.updateInner([new nr(0, 0, 0, e.state.doc.length)], 0, null);
  }
  // Update the document view to a given state.
  update(e) {
    var t;
    let r = e.changedRanges;
    this.minWidth > 0 && r.length && (r.every(({ fromA: u, toA: h }) => h < this.minWidthFrom || u > this.minWidthTo) ? (this.minWidthFrom = e.changes.mapPos(this.minWidthFrom, 1), this.minWidthTo = e.changes.mapPos(this.minWidthTo, 1)) : this.minWidth = this.minWidthFrom = this.minWidthTo = 0), this.updateEditContextFormatting(e);
    let i = -1;
    this.view.inputState.composing >= 0 && !this.view.observer.editContext && (!((t = this.domChanged) === null || t === void 0) && t.newSel ? i = this.domChanged.newSel.head : !y3(e.changes, this.hasComposition) && !e.selectionSet && (i = e.state.selection.main.head));
    let s = i > -1 ? m3(this.view, e.changes, i) : null;
    if (this.domChanged = null, this.hasComposition) {
      this.markedForComposition.clear();
      let { from: u, to: h } = this.hasComposition;
      r = new nr(u, h, e.changes.mapPos(u, -1), e.changes.mapPos(h, 1)).addToSet(r.slice());
    }
    this.hasComposition = s ? { from: s.range.fromB, to: s.range.toB } : null, (K.ie || K.chrome) && !s && e && e.state.doc.lines != e.startState.doc.lines && (this.forceSelection = !0);
    let l = this.decorations, o = this.updateDeco(), a = b3(l, o, e.changes);
    return r = nr.extendWithRanges(r, a), !(this.flags & 7) && r.length == 0 ? !1 : (this.updateInner(r, e.startState.doc.length, s), e.transactions.length && (this.lastUpdate = Date.now()), !0);
  }
  // Used by update and the constructor do perform the actual DOM
  // update
  updateInner(e, t, r) {
    this.view.viewState.mustMeasureContent = !0, this.updateChildren(e, t, r);
    let { observer: i } = this.view;
    i.ignore(() => {
      this.dom.style.height = this.view.viewState.contentHeight / this.view.scaleY + "px", this.dom.style.flexBasis = this.minWidth ? this.minWidth + "px" : "";
      let l = K.chrome || K.ios ? { node: i.selectionRange.focusNode, written: !1 } : void 0;
      this.sync(this.view, l), this.flags &= -8, l && (l.written || i.selectionRange.focusNode != l.node) && (this.forceSelection = !0), this.dom.style.height = "";
    }), this.markedForComposition.forEach(
      (l) => l.flags &= -9
      /* ViewFlag.Composition */
    );
    let s = [];
    if (this.view.viewport.from || this.view.viewport.to < this.view.state.doc.length)
      for (let l of this.children)
        l instanceof fn && l.widget instanceof uu && s.push(l.dom);
    i.updateGaps(s);
  }
  updateChildren(e, t, r) {
    let i = r ? r.range.addToSet(e.slice()) : e, s = this.childCursor(t);
    for (let l = i.length - 1; ; l--) {
      let o = l >= 0 ? i[l] : null;
      if (!o)
        break;
      let { fromA: a, toA: u, fromB: h, toB: c } = o, f, m, g, v;
      if (r && r.range.fromB < c && r.range.toB > h) {
        let A = Is.build(this.view.state.doc, h, r.range.fromB, this.decorations, this.dynamicDecorationMap), C = Is.build(this.view.state.doc, r.range.toB, c, this.decorations, this.dynamicDecorationMap);
        m = A.breakAtStart, g = A.openStart, v = C.openEnd;
        let T = this.compositionView(r);
        C.breakAtStart ? T.breakAfter = 1 : C.content.length && T.merge(T.length, T.length, C.content[0], !1, C.openStart, 0) && (T.breakAfter = C.content[0].breakAfter, C.content.shift()), A.content.length && T.merge(0, 0, A.content[A.content.length - 1], !0, 0, A.openEnd) && A.content.pop(), f = A.content.concat(T).concat(C.content);
      } else
        ({ content: f, breakAtStart: m, openStart: g, openEnd: v } = Is.build(this.view.state.doc, h, c, this.decorations, this.dynamicDecorationMap));
      let { i: k, off: S } = s.findPos(u, 1), { i: x, off: y } = s.findPos(a, -1);
      pp(this, x, y, k, S, f, m, g, v);
    }
    r && this.fixCompositionDOM(r);
  }
  updateEditContextFormatting(e) {
    this.editContextFormatting = this.editContextFormatting.map(e.changes);
    for (let t of e.transactions)
      for (let r of t.effects)
        r.is(Ip) && (this.editContextFormatting = r.value);
  }
  compositionView(e) {
    let t = new xr(e.text.nodeValue);
    t.flags |= 8;
    for (let { deco: i } of e.marks)
      t = new gn(i, [t], t.length);
    let r = new Je();
    return r.append(t, 0), r;
  }
  fixCompositionDOM(e) {
    let t = (s, l) => {
      l.flags |= 8 | (l.children.some(
        (a) => a.flags & 7
        /* ViewFlag.Dirty */
      ) ? 1 : 0), this.markedForComposition.add(l);
      let o = Be.get(s);
      o && o != l && (o.dom = null), l.setDOM(s);
    }, r = this.childPos(e.range.fromB, 1), i = this.children[r.i];
    t(e.line, i);
    for (let s = e.marks.length - 1; s >= -1; s--)
      r = i.childPos(r.off, 1), i = i.children[r.i], t(s >= 0 ? e.marks[s].node : e.text, i);
  }
  // Sync the DOM selection to this.state.selection
  updateSelection(e = !1, t = !1) {
    (e || !this.view.observer.selectionRange.focusNode) && this.view.observer.readSelectionRange();
    let r = this.view.root.activeElement, i = r == this.dom, s = !i && mo(this.dom, this.view.observer.selectionRange) && !(r && this.dom.contains(r));
    if (!(i || t || s))
      return;
    let l = this.forceSelection;
    this.forceSelection = !1;
    let o = this.view.state.selection.main, a = this.moveToLine(this.domAtPos(o.anchor)), u = o.empty ? a : this.moveToLine(this.domAtPos(o.head));
    if (K.gecko && o.empty && !this.hasComposition && d3(a)) {
      let c = document.createTextNode("");
      this.view.observer.ignore(() => a.node.insertBefore(c, a.node.childNodes[a.offset] || null)), a = u = new dt(c, 0), l = !0;
    }
    let h = this.view.observer.selectionRange;
    (l || !h.focusNode || (!Ns(a.node, a.offset, h.anchorNode, h.anchorOffset) || !Ns(u.node, u.offset, h.focusNode, h.focusOffset)) && !this.suppressWidgetCursorChange(h, o)) && (this.view.observer.ignore(() => {
      K.android && K.chrome && this.dom.contains(h.focusNode) && v3(h.focusNode, this.dom) && (this.dom.blur(), this.dom.focus({ preventScroll: !0 }));
      let c = Ks(this.view.root);
      if (c) if (o.empty) {
        if (K.gecko) {
          let f = p3(a.node, a.offset);
          if (f && f != 3) {
            let m = (f == 1 ? fp : dp)(a.node, a.offset);
            m && (a = new dt(m.node, m.offset));
          }
        }
        c.collapse(a.node, a.offset), o.bidiLevel != null && c.caretBidiLevel !== void 0 && (c.caretBidiLevel = o.bidiLevel);
      } else if (c.extend) {
        c.collapse(a.node, a.offset);
        try {
          c.extend(u.node, u.offset);
        } catch {
        }
      } else {
        let f = document.createRange();
        o.anchor > o.head && ([a, u] = [u, a]), f.setEnd(u.node, u.offset), f.setStart(a.node, a.offset), c.removeAllRanges(), c.addRange(f);
      }
      s && this.view.root.activeElement == this.dom && (this.dom.blur(), r && r.focus());
    }), this.view.observer.setSelectionRange(a, u)), this.impreciseAnchor = a.precise ? null : new dt(h.anchorNode, h.anchorOffset), this.impreciseHead = u.precise ? null : new dt(h.focusNode, h.focusOffset);
  }
  // If a zero-length widget is inserted next to the cursor during
  // composition, avoid moving it across it and disrupting the
  // composition.
  suppressWidgetCursorChange(e, t) {
    return this.hasComposition && t.empty && Ns(e.focusNode, e.focusOffset, e.anchorNode, e.anchorOffset) && this.posFromDOM(e.focusNode, e.focusOffset) == t.head;
  }
  enforceCursorAssoc() {
    if (this.hasComposition)
      return;
    let { view: e } = this, t = e.state.selection.main, r = Ks(e.root), { anchorNode: i, anchorOffset: s } = e.observer.selectionRange;
    if (!r || !t.empty || !t.assoc || !r.modify)
      return;
    let l = Je.find(this, t.head);
    if (!l)
      return;
    let o = l.posAtStart;
    if (t.head == o || t.head == o + l.length)
      return;
    let a = this.coordsAt(t.head, -1), u = this.coordsAt(t.head, 1);
    if (!a || !u || a.bottom > u.top)
      return;
    let h = this.domAtPos(t.head + t.assoc);
    r.collapse(h.node, h.offset), r.modify("move", t.assoc < 0 ? "forward" : "backward", "lineboundary"), e.observer.readSelectionRange();
    let c = e.observer.selectionRange;
    e.docView.posFromDOM(c.anchorNode, c.anchorOffset) != t.from && r.collapse(i, s);
  }
  // If a position is in/near a block widget, move it to a nearby text
  // line, since we don't want the cursor inside a block widget.
  moveToLine(e) {
    let t = this.dom, r;
    if (e.node != t)
      return e;
    for (let i = e.offset; !r && i < t.childNodes.length; i++) {
      let s = Be.get(t.childNodes[i]);
      s instanceof Je && (r = s.domAtPos(0));
    }
    for (let i = e.offset - 1; !r && i >= 0; i--) {
      let s = Be.get(t.childNodes[i]);
      s instanceof Je && (r = s.domAtPos(s.length));
    }
    return r ? new dt(r.node, r.offset, !0) : e;
  }
  nearest(e) {
    for (let t = e; t; ) {
      let r = Be.get(t);
      if (r && r.rootView == this)
        return r;
      t = t.parentNode;
    }
    return null;
  }
  posFromDOM(e, t) {
    let r = this.nearest(e);
    if (!r)
      throw new RangeError("Trying to find position for a DOM position outside of the document");
    return r.localPosFromDOM(e, t) + r.posAtStart;
  }
  domAtPos(e) {
    let { i: t, off: r } = this.childCursor().findPos(e, -1);
    for (; t < this.children.length - 1; ) {
      let i = this.children[t];
      if (r < i.length || i instanceof Je)
        break;
      t++, r = 0;
    }
    return this.children[t].domAtPos(r);
  }
  coordsAt(e, t) {
    let r = null, i = 0;
    for (let s = this.length, l = this.children.length - 1; l >= 0; l--) {
      let o = this.children[l], a = s - o.breakAfter, u = a - o.length;
      if (a < e)
        break;
      if (u <= e && (u < e || o.covers(-1)) && (a > e || o.covers(1)) && (!r || o instanceof Je && !(r instanceof Je && t >= 0)))
        r = o, i = u;
      else if (r && u == e && a == e && o instanceof fn && Math.abs(t) < 2) {
        if (o.deco.startSide < 0)
          break;
        l && (r = null);
      }
      s = u;
    }
    return r ? r.coordsAt(e - i, t) : null;
  }
  coordsForChar(e) {
    let { i: t, off: r } = this.childPos(e, 1), i = this.children[t];
    if (!(i instanceof Je))
      return null;
    for (; i.children.length; ) {
      let { i: o, off: a } = i.childPos(r, 1);
      for (; ; o++) {
        if (o == i.children.length)
          return null;
        if ((i = i.children[o]).length)
          break;
      }
      r = a;
    }
    if (!(i instanceof xr))
      return null;
    let s = kt(i.text, r);
    if (s == r)
      return null;
    let l = si(i.dom, r, s).getClientRects();
    for (let o = 0; o < l.length; o++) {
      let a = l[o];
      if (o == l.length - 1 || a.top < a.bottom && a.left < a.right)
        return a;
    }
    return null;
  }
  measureVisibleLineHeights(e) {
    let t = [], { from: r, to: i } = e, s = this.view.contentDOM.clientWidth, l = s > Math.max(this.view.scrollDOM.clientWidth, this.minWidth) + 1, o = -1, a = this.view.textDirection == Ie.LTR;
    for (let u = 0, h = 0; h < this.children.length; h++) {
      let c = this.children[h], f = u + c.length;
      if (f > i)
        break;
      if (u >= r) {
        let m = c.dom.getBoundingClientRect();
        if (t.push(m.height), l) {
          let g = c.dom.lastChild, v = g ? Gi(g) : [];
          if (v.length) {
            let k = v[v.length - 1], S = a ? k.right - m.left : m.right - k.left;
            S > o && (o = S, this.minWidth = s, this.minWidthFrom = u, this.minWidthTo = f);
          }
        }
      }
      u = f + c.breakAfter;
    }
    return t;
  }
  textDirectionAt(e) {
    let { i: t } = this.childPos(e, 1);
    return getComputedStyle(this.children[t].dom).direction == "rtl" ? Ie.RTL : Ie.LTR;
  }
  measureTextSize() {
    for (let s of this.children)
      if (s instanceof Je) {
        let l = s.measureTextSize();
        if (l)
          return l;
      }
    let e = document.createElement("div"), t, r, i;
    return e.className = "cm-line", e.style.width = "99999px", e.style.position = "absolute", e.textContent = "abc def ghi jkl mno pqr stu", this.view.observer.ignore(() => {
      this.dom.appendChild(e);
      let s = Gi(e.firstChild)[0];
      t = e.getBoundingClientRect().height, r = s ? s.width / 27 : 7, i = s ? s.height : t, e.remove();
    }), { lineHeight: t, charWidth: r, textHeight: i };
  }
  childCursor(e = this.length) {
    let t = this.children.length;
    return t && (e -= this.children[--t].length), new mp(this.children, e, t);
  }
  computeBlockGapDeco() {
    let e = [], t = this.view.viewState;
    for (let r = 0, i = 0; ; i++) {
      let s = i == t.viewports.length ? null : t.viewports[i], l = s ? s.from - 1 : this.length;
      if (l > r) {
        let o = (t.lineBlockAt(l).bottom - t.lineBlockAt(r).top) / this.view.scaleY;
        e.push(be.replace({
          widget: new uu(o),
          block: !0,
          inclusive: !0,
          isBlockGap: !0
        }).range(r, l));
      }
      if (!s)
        break;
      r = s.to + 1;
    }
    return be.set(e);
  }
  updateDeco() {
    let e = 1, t = this.view.state.facet(Xs).map((s) => (this.dynamicDecorationMap[e++] = typeof s == "function") ? s(this.view) : s), r = !1, i = this.view.state.facet(Pp).map((s, l) => {
      let o = typeof s == "function";
      return o && (r = !0), o ? s(this.view) : s;
    });
    for (i.length && (this.dynamicDecorationMap[e++] = r, t.push(Ce.join(i))), this.decorations = [
      this.editContextFormatting,
      ...t,
      this.computeBlockGapDeco(),
      this.view.viewState.lineGapDeco
    ]; e < this.decorations.length; )
      this.dynamicDecorationMap[e++] = !1;
    return this.decorations;
  }
  scrollIntoView(e) {
    if (e.isSnapshot) {
      let u = this.view.viewState.lineBlockAt(e.range.head);
      this.view.scrollDOM.scrollTop = u.top - e.yMargin, this.view.scrollDOM.scrollLeft = e.xMargin;
      return;
    }
    for (let u of this.view.state.facet(Np))
      try {
        if (u(this.view, e.range, e))
          return !0;
      } catch (h) {
        Xt(this.view.state, h, "scroll handler");
      }
    let { range: t } = e, r = this.coordsAt(t.head, t.empty ? t.assoc : t.head > t.anchor ? -1 : 1), i;
    if (!r)
      return;
    !t.empty && (i = this.coordsAt(t.anchor, t.anchor > t.head ? -1 : 1)) && (r = {
      left: Math.min(r.left, i.left),
      top: Math.min(r.top, i.top),
      right: Math.max(r.right, i.right),
      bottom: Math.max(r.bottom, i.bottom)
    });
    let s = Vp(this.view), l = {
      left: r.left - s.left,
      top: r.top - s.top,
      right: r.right + s.right,
      bottom: r.bottom + s.bottom
    }, { offsetWidth: o, offsetHeight: a } = this.view.scrollDOM;
    $5(this.view.scrollDOM, l, t.head < t.anchor ? -1 : 1, e.x, e.y, Math.max(Math.min(e.xMargin, o), -o), Math.max(Math.min(e.yMargin, a), -a), this.view.textDirection == Ie.LTR);
  }
}
function d3(n) {
  return n.node.nodeType == 1 && n.node.firstChild && (n.offset == 0 || n.node.childNodes[n.offset - 1].contentEditable == "false") && (n.offset == n.node.childNodes.length || n.node.childNodes[n.offset].contentEditable == "false");
}
function Wp(n, e) {
  let t = n.observer.selectionRange;
  if (!t.focusNode)
    return null;
  let r = fp(t.focusNode, t.focusOffset), i = dp(t.focusNode, t.focusOffset), s = r || i;
  if (i && r && i.node != r.node) {
    let o = Be.get(i.node);
    if (!o || o instanceof xr && o.text != i.node.nodeValue)
      s = i;
    else if (n.docView.lastCompositionAfterCursor) {
      let a = Be.get(r.node);
      !a || a instanceof xr && a.text != r.node.nodeValue || (s = i);
    }
  }
  if (n.docView.lastCompositionAfterCursor = s != r, !s)
    return null;
  let l = e - s.offset;
  return { from: l, to: l + s.node.nodeValue.length, node: s.node };
}
function m3(n, e, t) {
  let r = Wp(n, t);
  if (!r)
    return null;
  let { node: i, from: s, to: l } = r, o = i.nodeValue;
  if (/[\n\r]/.test(o) || n.state.doc.sliceString(r.from, r.to) != o)
    return null;
  let a = e.invertedDesc, u = new nr(a.mapPos(s), a.mapPos(l), s, l), h = [];
  for (let c = i.parentNode; ; c = c.parentNode) {
    let f = Be.get(c);
    if (f instanceof gn)
      h.push({ node: c, deco: f.mark });
    else {
      if (f instanceof Je || c.nodeName == "DIV" && c.parentNode == n.contentDOM)
        return { range: u, text: i, marks: h, line: c };
      if (c != n.contentDOM)
        h.push({ node: c, deco: new hl({
          inclusive: !0,
          attributes: t3(c),
          tagName: c.tagName.toLowerCase()
        }) });
      else
        return null;
    }
  }
}
function p3(n, e) {
  return n.nodeType != 1 ? 0 : (e && n.childNodes[e - 1].contentEditable == "false" ? 1 : 0) | (e < n.childNodes.length && n.childNodes[e].contentEditable == "false" ? 2 : 0);
}
let g3 = class {
  constructor() {
    this.changes = [];
  }
  compareRange(e, t) {
    au(e, t, this.changes);
  }
  comparePoint(e, t) {
    au(e, t, this.changes);
  }
};
function b3(n, e, t) {
  let r = new g3();
  return Ce.compare(n, e, t, r), r.changes;
}
function v3(n, e) {
  for (let t = n; t && t != e; t = t.assignedSlot || t.parentNode)
    if (t.nodeType == 1 && t.contentEditable == "false")
      return !0;
  return !1;
}
function y3(n, e) {
  let t = !1;
  return e && n.iterChangedRanges((r, i) => {
    r < e.to && i > e.from && (t = !0);
  }), t;
}
function w3(n, e, t = 1) {
  let r = n.charCategorizer(e), i = n.doc.lineAt(e), s = e - i.from;
  if (i.length == 0)
    return I.cursor(e);
  s == 0 ? t = 1 : s == i.length && (t = -1);
  let l = s, o = s;
  t < 0 ? l = kt(i.text, s, !1) : o = kt(i.text, s);
  let a = r(i.text.slice(l, o));
  for (; l > 0; ) {
    let u = kt(i.text, l, !1);
    if (r(i.text.slice(u, l)) != a)
      break;
    l = u;
  }
  for (; o < i.length; ) {
    let u = kt(i.text, o);
    if (r(i.text.slice(o, u)) != a)
      break;
    o = u;
  }
  return I.range(l + i.from, o + i.from);
}
function k3(n, e) {
  return e.left > n ? e.left - n : Math.max(0, n - e.right);
}
function x3(n, e) {
  return e.top > n ? e.top - n : Math.max(0, n - e.bottom);
}
function La(n, e) {
  return n.top < e.bottom - 1 && n.bottom > e.top + 1;
}
function nf(n, e) {
  return e < n.top ? { top: e, left: n.left, right: n.right, bottom: n.bottom } : n;
}
function sf(n, e) {
  return e > n.bottom ? { top: n.top, left: n.left, right: n.right, bottom: e } : n;
}
function mu(n, e, t) {
  let r, i, s, l, o = !1, a, u, h, c;
  for (let g = n.firstChild; g; g = g.nextSibling) {
    let v = Gi(g);
    for (let k = 0; k < v.length; k++) {
      let S = v[k];
      i && La(i, S) && (S = nf(sf(S, i.bottom), i.top));
      let x = k3(e, S), y = x3(t, S);
      if (x == 0 && y == 0)
        return g.nodeType == 3 ? lf(g, e, t) : mu(g, e, t);
      if (!r || l > y || l == y && s > x) {
        r = g, i = S, s = x, l = y;
        let A = y ? t < S.top ? -1 : 1 : x ? e < S.left ? -1 : 1 : 0;
        o = !A || (A > 0 ? k < v.length - 1 : k > 0);
      }
      x == 0 ? t > S.bottom && (!h || h.bottom < S.bottom) ? (a = g, h = S) : t < S.top && (!c || c.top > S.top) && (u = g, c = S) : h && La(h, S) ? h = sf(h, S.bottom) : c && La(c, S) && (c = nf(c, S.top));
    }
  }
  if (h && h.bottom >= t ? (r = a, i = h) : c && c.top <= t && (r = u, i = c), !r)
    return { node: n, offset: 0 };
  let f = Math.max(i.left, Math.min(i.right, e));
  if (r.nodeType == 3)
    return lf(r, f, t);
  if (o && r.contentEditable != "false")
    return mu(r, f, t);
  let m = Array.prototype.indexOf.call(n.childNodes, r) + (e >= (i.left + i.right) / 2 ? 1 : 0);
  return { node: n, offset: m };
}
function lf(n, e, t) {
  let r = n.nodeValue.length, i = -1, s = 1e9, l = 0;
  for (let o = 0; o < r; o++) {
    let a = si(n, o, o + 1).getClientRects();
    for (let u = 0; u < a.length; u++) {
      let h = a[u];
      if (h.top == h.bottom)
        continue;
      l || (l = e - h.left);
      let c = (h.top > t ? h.top - t : t - h.bottom) - 1;
      if (h.left - 1 <= e && h.right + 1 >= e && c < s) {
        let f = e >= (h.left + h.right) / 2, m = f;
        if ((K.chrome || K.gecko) && si(n, o).getBoundingClientRect().left == h.right && (m = !f), c <= 0)
          return { node: n, offset: o + (m ? 1 : 0) };
        i = o + (m ? 1 : 0), s = c;
      }
    }
  }
  return { node: n, offset: i > -1 ? i : l > 0 ? n.nodeValue.length : 0 };
}
function Up(n, e, t, r = -1) {
  var i, s;
  let l = n.contentDOM.getBoundingClientRect(), o = l.top + n.viewState.paddingTop, a, { docHeight: u } = n.viewState, { x: h, y: c } = e, f = c - o;
  if (f < 0)
    return 0;
  if (f > u)
    return n.state.doc.length;
  for (let A = n.viewState.heightOracle.textHeight / 2, C = !1; a = n.elementAtHeight(f), a.type != St.Text; )
    for (; f = r > 0 ? a.bottom + A : a.top - A, !(f >= 0 && f <= u); ) {
      if (C)
        return t ? null : 0;
      C = !0, r = -r;
    }
  c = o + f;
  let m = a.from;
  if (m < n.viewport.from)
    return n.viewport.from == 0 ? 0 : t ? null : of(n, l, a, h, c);
  if (m > n.viewport.to)
    return n.viewport.to == n.state.doc.length ? n.state.doc.length : t ? null : of(n, l, a, h, c);
  let g = n.dom.ownerDocument, v = n.root.elementFromPoint ? n.root : g, k = v.elementFromPoint(h, c);
  k && !n.contentDOM.contains(k) && (k = null), k || (h = Math.max(l.left + 1, Math.min(l.right - 1, h)), k = v.elementFromPoint(h, c), k && !n.contentDOM.contains(k) && (k = null));
  let S, x = -1;
  if (k && ((i = n.docView.nearest(k)) === null || i === void 0 ? void 0 : i.isEditable) != !1) {
    if (g.caretPositionFromPoint) {
      let A = g.caretPositionFromPoint(h, c);
      A && ({ offsetNode: S, offset: x } = A);
    } else if (g.caretRangeFromPoint) {
      let A = g.caretRangeFromPoint(h, c);
      A && ({ startContainer: S, startOffset: x } = A, (!n.contentDOM.contains(S) || K.safari && S3(S, x, h) || K.chrome && A3(S, x, h)) && (S = void 0));
    }
    S && (x = Math.min(Yr(S), x));
  }
  if (!S || !n.docView.dom.contains(S)) {
    let A = Je.find(n.docView, m);
    if (!A)
      return f > a.top + a.height / 2 ? a.to : a.from;
    ({ node: S, offset: x } = mu(A.dom, h, c));
  }
  let y = n.docView.nearest(S);
  if (!y)
    return null;
  if (y.isWidget && ((s = y.dom) === null || s === void 0 ? void 0 : s.nodeType) == 1) {
    let A = y.dom.getBoundingClientRect();
    return e.y < A.top || e.y <= A.bottom && e.x <= (A.left + A.right) / 2 ? y.posAtStart : y.posAtEnd;
  } else
    return y.localPosFromDOM(S, x) + y.posAtStart;
}
function of(n, e, t, r, i) {
  let s = Math.round((r - e.left) * n.defaultCharacterWidth);
  if (n.lineWrapping && t.height > n.defaultLineHeight * 1.5) {
    let o = n.viewState.heightOracle.textHeight, a = Math.floor((i - t.top - (n.defaultLineHeight - o) * 0.5) / o);
    s += a * n.viewState.heightOracle.lineLength;
  }
  let l = n.state.sliceDoc(t.from, t.to);
  return t.from + Q0(l, s, n.state.tabSize);
}
function S3(n, e, t) {
  let r;
  if (n.nodeType != 3 || e != (r = n.nodeValue.length))
    return !1;
  for (let i = n.nextSibling; i; i = i.nextSibling)
    if (i.nodeType != 1 || i.nodeName != "BR")
      return !1;
  return si(n, r - 1, r).getBoundingClientRect().left > t;
}
function A3(n, e, t) {
  if (e != 0)
    return !1;
  for (let i = n; ; ) {
    let s = i.parentNode;
    if (!s || s.nodeType != 1 || s.firstChild != i)
      return !1;
    if (s.classList.contains("cm-line"))
      break;
    i = s;
  }
  let r = n.nodeType == 1 ? n.getBoundingClientRect() : si(n, 0, Math.max(n.nodeValue.length, 1)).getBoundingClientRect();
  return t - r.left > 5;
}
function pu(n, e) {
  let t = n.lineBlockAt(e);
  if (Array.isArray(t.type)) {
    for (let r of t.type)
      if (r.to > e || r.to == e && (r.to == t.to || r.type == St.Text))
        return r;
  }
  return t;
}
function D3(n, e, t, r) {
  let i = pu(n, e.head), s = !r || i.type != St.Text || !(n.lineWrapping || i.widgetLineBreaks) ? null : n.coordsAtPos(e.assoc < 0 && e.head > i.from ? e.head - 1 : e.head);
  if (s) {
    let l = n.dom.getBoundingClientRect(), o = n.textDirectionAt(i.from), a = n.posAtCoords({
      x: t == (o == Ie.LTR) ? l.right - 1 : l.left + 1,
      y: (s.top + s.bottom) / 2
    });
    if (a != null)
      return I.cursor(a, t ? -1 : 1);
  }
  return I.cursor(t ? i.to : i.from, t ? -1 : 1);
}
function af(n, e, t, r) {
  let i = n.state.doc.lineAt(e.head), s = n.bidiSpans(i), l = n.textDirectionAt(i.from);
  for (let o = e, a = null; ; ) {
    let u = h3(i, s, l, o, t), h = _p;
    if (!u) {
      if (i.number == (t ? n.state.doc.lines : 1))
        return o;
      h = `
`, i = n.state.doc.line(i.number + (t ? 1 : -1)), s = n.bidiSpans(i), u = n.visualLineSide(i, !t);
    }
    if (a) {
      if (!a(h))
        return o;
    } else {
      if (!r)
        return u;
      a = r(h);
    }
    o = u;
  }
}
function C3(n, e, t) {
  let r = n.state.charCategorizer(e), i = r(t);
  return (s) => {
    let l = r(s);
    return i == Kt.Space && (i = l), i == l;
  };
}
function _3(n, e, t, r) {
  let i = e.head, s = t ? 1 : -1;
  if (i == (t ? n.state.doc.length : 0))
    return I.cursor(i, e.assoc);
  let l = e.goalColumn, o, a = n.contentDOM.getBoundingClientRect(), u = n.coordsAtPos(i, e.assoc || -1), h = n.documentTop;
  if (u)
    l == null && (l = u.left - a.left), o = s < 0 ? u.top : u.bottom;
  else {
    let m = n.viewState.lineBlockAt(i);
    l == null && (l = Math.min(a.right - a.left, n.defaultCharacterWidth * (i - m.from))), o = (s < 0 ? m.top : m.bottom) + h;
  }
  let c = a.left + l, f = r ?? n.viewState.heightOracle.textHeight >> 1;
  for (let m = 0; ; m += 10) {
    let g = o + (f + m) * s, v = Up(n, { x: c, y: g }, !1, s);
    if (g < a.top || g > a.bottom || (s < 0 ? v < i : v > i)) {
      let k = n.docView.coordsForChar(v), S = !k || g < k.top ? -1 : 1;
      return I.cursor(v, S, void 0, l);
    }
  }
}
function po(n, e, t) {
  for (; ; ) {
    let r = 0;
    for (let i of n)
      i.between(e - 1, e + 1, (s, l, o) => {
        if (e > s && e < l) {
          let a = r || t || (e - s < l - e ? -1 : 1);
          e = a < 0 ? s : l, r = a;
        }
      });
    if (!r)
      return e;
  }
}
function Na(n, e, t) {
  let r = po(n.state.facet(hh).map((i) => i(n)), t.from, e.head > t.from ? -1 : 1);
  return r == t.from ? t : I.cursor(r, r < t.from ? 1 : -1);
}
const Es = "￿";
class M3 {
  constructor(e, t) {
    this.points = e, this.text = "", this.lineSeparator = t.facet(Se.lineSeparator);
  }
  append(e) {
    this.text += e;
  }
  lineBreak() {
    this.text += Es;
  }
  readRange(e, t) {
    if (!e)
      return this;
    let r = e.parentNode;
    for (let i = e; ; ) {
      this.findPointBefore(r, i);
      let s = this.text.length;
      this.readNode(i);
      let l = i.nextSibling;
      if (l == t)
        break;
      let o = Be.get(i), a = Be.get(l);
      (o && a ? o.breakAfter : (o ? o.breakAfter : To(i)) || To(l) && (i.nodeName != "BR" || i.cmIgnore) && this.text.length > s) && this.lineBreak(), i = l;
    }
    return this.findPointBefore(r, t), this;
  }
  readTextNode(e) {
    let t = e.nodeValue;
    for (let r of this.points)
      r.node == e && (r.pos = this.text.length + Math.min(r.offset, t.length));
    for (let r = 0, i = this.lineSeparator ? null : /\r\n?|\n/g; ; ) {
      let s = -1, l = 1, o;
      if (this.lineSeparator ? (s = t.indexOf(this.lineSeparator, r), l = this.lineSeparator.length) : (o = i.exec(t)) && (s = o.index, l = o[0].length), this.append(t.slice(r, s < 0 ? t.length : s)), s < 0)
        break;
      if (this.lineBreak(), l > 1)
        for (let a of this.points)
          a.node == e && a.pos > this.text.length && (a.pos -= l - 1);
      r = s + l;
    }
  }
  readNode(e) {
    if (e.cmIgnore)
      return;
    let t = Be.get(e), r = t && t.overrideDOMText;
    if (r != null) {
      this.findPointInside(e, r.length);
      for (let i = r.iter(); !i.next().done; )
        i.lineBreak ? this.lineBreak() : this.append(i.value);
    } else e.nodeType == 3 ? this.readTextNode(e) : e.nodeName == "BR" ? e.nextSibling && this.lineBreak() : e.nodeType == 1 && this.readRange(e.firstChild, null);
  }
  findPointBefore(e, t) {
    for (let r of this.points)
      r.node == e && e.childNodes[r.offset] == t && (r.pos = this.text.length);
  }
  findPointInside(e, t) {
    for (let r of this.points)
      (e.nodeType == 3 ? r.node == e : e.contains(r.node)) && (r.pos = this.text.length + (T3(e, r.node, r.offset) ? t : 0));
  }
}
function T3(n, e, t) {
  for (; ; ) {
    if (!e || t < Yr(e))
      return !1;
    if (e == n)
      return !0;
    t = ii(e) + 1, e = e.parentNode;
  }
}
class uf {
  constructor(e, t) {
    this.node = e, this.offset = t, this.pos = -1;
  }
}
class E3 {
  constructor(e, t, r, i) {
    this.typeOver = i, this.bounds = null, this.text = "", this.domChanged = t > -1;
    let { impreciseHead: s, impreciseAnchor: l } = e.docView;
    if (e.state.readOnly && t > -1)
      this.newSel = null;
    else if (t > -1 && (this.bounds = e.docView.domBoundsAround(t, r, 0))) {
      let o = s || l ? [] : O3(e), a = new M3(o, e.state);
      a.readRange(this.bounds.startDOM, this.bounds.endDOM), this.text = a.text, this.newSel = R3(o, this.bounds.from);
    } else {
      let o = e.observer.selectionRange, a = s && s.node == o.focusNode && s.offset == o.focusOffset || !ru(e.contentDOM, o.focusNode) ? e.state.selection.main.head : e.docView.posFromDOM(o.focusNode, o.focusOffset), u = l && l.node == o.anchorNode && l.offset == o.anchorOffset || !ru(e.contentDOM, o.anchorNode) ? e.state.selection.main.anchor : e.docView.posFromDOM(o.anchorNode, o.anchorOffset), h = e.viewport;
      if ((K.ios || K.chrome) && e.state.selection.main.empty && a != u && (h.from > 0 || h.to < e.state.doc.length)) {
        let c = Math.min(a, u), f = Math.max(a, u), m = h.from - c, g = h.to - f;
        (m == 0 || m == 1 || c == 0) && (g == 0 || g == -1 || f == e.state.doc.length) && (a = 0, u = e.state.doc.length);
      }
      this.newSel = I.single(u, a);
    }
  }
}
function Gp(n, e) {
  let t, { newSel: r } = e, i = n.state.selection.main, s = n.inputState.lastKeyTime > Date.now() - 100 ? n.inputState.lastKeyCode : -1;
  if (e.bounds) {
    let { from: l, to: o } = e.bounds, a = i.from, u = null;
    (s === 8 || K.android && e.text.length < o - l) && (a = i.to, u = "end");
    let h = B3(n.state.doc.sliceString(l, o, Es), e.text, a - l, u);
    h && (K.chrome && s == 13 && h.toB == h.from + 2 && e.text.slice(h.from, h.toB) == Es + Es && h.toB--, t = {
      from: l + h.from,
      to: l + h.toA,
      insert: Ae.of(e.text.slice(h.from, h.toB).split(Es))
    });
  } else r && (!n.hasFocus && n.state.facet(_n) || r.main.eq(i)) && (r = null);
  if (!t && !r)
    return !1;
  if (!t && e.typeOver && !i.empty && r && r.main.empty ? t = { from: i.from, to: i.to, insert: n.state.doc.slice(i.from, i.to) } : t && t.from >= i.from && t.to <= i.to && (t.from != i.from || t.to != i.to) && i.to - i.from - (t.to - t.from) <= 4 ? t = {
    from: i.from,
    to: i.to,
    insert: n.state.doc.slice(i.from, t.from).append(t.insert).append(n.state.doc.slice(t.to, i.to))
  } : (K.mac || K.android) && t && t.from == t.to && t.from == i.head - 1 && /^\. ?$/.test(t.insert.toString()) && n.contentDOM.getAttribute("autocorrect") == "off" ? (r && t.insert.length == 2 && (r = I.single(r.main.anchor - 1, r.main.head - 1)), t = { from: i.from, to: i.to, insert: Ae.of([" "]) }) : K.chrome && t && t.from == t.to && t.from == i.head && t.insert.toString() == `
 ` && n.lineWrapping && (r && (r = I.single(r.main.anchor - 1, r.main.head - 1)), t = { from: i.from, to: i.to, insert: Ae.of([" "]) }), t)
    return ch(n, t, r, s);
  if (r && !r.main.eq(i)) {
    let l = !1, o = "select";
    return n.inputState.lastSelectionTime > Date.now() - 50 && (n.inputState.lastSelectionOrigin == "select" && (l = !0), o = n.inputState.lastSelectionOrigin), n.dispatch({ selection: r, scrollIntoView: l, userEvent: o }), !0;
  } else
    return !1;
}
function ch(n, e, t, r = -1) {
  if (K.ios && n.inputState.flushIOSKey(e))
    return !0;
  let i = n.state.selection.main;
  if (K.android && (e.to == i.to && // GBoard will sometimes remove a space it just inserted
  // after a completion when you press enter
  (e.from == i.from || e.from == i.from - 1 && n.state.sliceDoc(e.from, i.from) == " ") && e.insert.length == 1 && e.insert.lines == 2 && Pi(n.contentDOM, "Enter", 13) || (e.from == i.from - 1 && e.to == i.to && e.insert.length == 0 || r == 8 && e.insert.length < e.to - e.from && e.to > i.head) && Pi(n.contentDOM, "Backspace", 8) || e.from == i.from && e.to == i.to + 1 && e.insert.length == 0 && Pi(n.contentDOM, "Delete", 46)))
    return !0;
  let s = e.insert.toString();
  n.inputState.composing >= 0 && n.inputState.composing++;
  let l, o = () => l || (l = F3(n, e, t));
  return n.state.facet(Bp).some((a) => a(n, e.from, e.to, s, o)) || n.dispatch(o()), !0;
}
function F3(n, e, t) {
  let r, i = n.state, s = i.selection.main;
  if (e.from >= s.from && e.to <= s.to && e.to - e.from >= (s.to - s.from) / 3 && (!t || t.main.empty && t.main.from == e.from + e.insert.length) && n.inputState.composing < 0) {
    let o = s.from < e.from ? i.sliceDoc(s.from, e.from) : "", a = s.to > e.to ? i.sliceDoc(e.to, s.to) : "";
    r = i.replaceSelection(n.state.toText(o + e.insert.sliceString(0, void 0, n.state.lineBreak) + a));
  } else {
    let o = i.changes(e), a = t && t.main.to <= o.newLength ? t.main : void 0;
    if (i.selection.ranges.length > 1 && n.inputState.composing >= 0 && e.to <= s.to && e.to >= s.to - 10) {
      let u = n.state.sliceDoc(e.from, e.to), h, c = t && Wp(n, t.main.head);
      if (c) {
        let g = e.insert.length - (e.to - e.from);
        h = { from: c.from, to: c.to - g };
      } else
        h = n.state.doc.lineAt(s.head);
      let f = s.to - e.to, m = s.to - s.from;
      r = i.changeByRange((g) => {
        if (g.from == s.from && g.to == s.to)
          return { changes: o, range: a || g.map(o) };
        let v = g.to - f, k = v - u.length;
        if (g.to - g.from != m || n.state.sliceDoc(k, v) != u || // Unfortunately, there's no way to make multiple
        // changes in the same node work without aborting
        // composition, so cursors in the composition range are
        // ignored.
        g.to >= h.from && g.from <= h.to)
          return { range: g };
        let S = i.changes({ from: k, to: v, insert: e.insert }), x = g.to - s.to;
        return {
          changes: S,
          range: a ? I.range(Math.max(0, a.anchor + x), Math.max(0, a.head + x)) : g.map(S)
        };
      });
    } else
      r = {
        changes: o,
        selection: a && i.selection.replaceRange(a)
      };
  }
  let l = "input.type";
  return (n.composing || n.inputState.compositionPendingChange && n.inputState.compositionEndedAt > Date.now() - 50) && (n.inputState.compositionPendingChange = !1, l += ".compose", n.inputState.compositionFirstChange && (l += ".start", n.inputState.compositionFirstChange = !1)), i.update(r, { userEvent: l, scrollIntoView: !0 });
}
function B3(n, e, t, r) {
  let i = Math.min(n.length, e.length), s = 0;
  for (; s < i && n.charCodeAt(s) == e.charCodeAt(s); )
    s++;
  if (s == i && n.length == e.length)
    return null;
  let l = n.length, o = e.length;
  for (; l > 0 && o > 0 && n.charCodeAt(l - 1) == e.charCodeAt(o - 1); )
    l--, o--;
  if (r == "end") {
    let a = Math.max(0, s - Math.min(l, o));
    t -= l + a - s;
  }
  if (l < s && n.length < e.length) {
    let a = t <= s && t >= l ? s - t : 0;
    s -= a, o = s + (o - l), l = s;
  } else if (o < s) {
    let a = t <= s && t >= o ? s - t : 0;
    s -= a, l = s + (l - o), o = s;
  }
  return { from: s, toA: l, toB: o };
}
function O3(n) {
  let e = [];
  if (n.root.activeElement != n.contentDOM)
    return e;
  let { anchorNode: t, anchorOffset: r, focusNode: i, focusOffset: s } = n.observer.selectionRange;
  return t && (e.push(new uf(t, r)), (i != t || s != r) && e.push(new uf(i, s))), e;
}
function R3(n, e) {
  if (n.length == 0)
    return null;
  let t = n[0].pos, r = n.length == 2 ? n[1].pos : t;
  return t > -1 && r > -1 ? I.single(t + e, r + e) : null;
}
class L3 {
  setSelectionOrigin(e) {
    this.lastSelectionOrigin = e, this.lastSelectionTime = Date.now();
  }
  constructor(e) {
    this.view = e, this.lastKeyCode = 0, this.lastKeyTime = 0, this.lastTouchTime = 0, this.lastFocusTime = 0, this.lastScrollTop = 0, this.lastScrollLeft = 0, this.pendingIOSKey = void 0, this.tabFocusMode = -1, this.lastSelectionOrigin = null, this.lastSelectionTime = 0, this.lastContextMenu = 0, this.scrollHandlers = [], this.handlers = /* @__PURE__ */ Object.create(null), this.composing = -1, this.compositionFirstChange = null, this.compositionEndedAt = 0, this.compositionPendingKey = !1, this.compositionPendingChange = !1, this.mouseSelection = null, this.draggedContent = null, this.handleEvent = this.handleEvent.bind(this), this.notifiedFocused = e.hasFocus, K.safari && e.contentDOM.addEventListener("input", () => null), K.gecko && Z3(e.contentDOM.ownerDocument);
  }
  handleEvent(e) {
    !W3(this.view, e) || this.ignoreDuringComposition(e) || e.type == "keydown" && this.keydown(e) || this.runHandlers(e.type, e);
  }
  runHandlers(e, t) {
    let r = this.handlers[e];
    if (r) {
      for (let i of r.observers)
        i(this.view, t);
      for (let i of r.handlers) {
        if (t.defaultPrevented)
          break;
        if (i(this.view, t)) {
          t.preventDefault();
          break;
        }
      }
    }
  }
  ensureHandlers(e) {
    let t = N3(e), r = this.handlers, i = this.view.contentDOM;
    for (let s in t)
      if (s != "scroll") {
        let l = !t[s].handlers.length, o = r[s];
        o && l != !o.handlers.length && (i.removeEventListener(s, this.handleEvent), o = null), o || i.addEventListener(s, this.handleEvent, { passive: l });
      }
    for (let s in r)
      s != "scroll" && !t[s] && i.removeEventListener(s, this.handleEvent);
    this.handlers = t;
  }
  keydown(e) {
    if (this.lastKeyCode = e.keyCode, this.lastKeyTime = Date.now(), e.keyCode == 9 && this.tabFocusMode > -1 && (!this.tabFocusMode || Date.now() <= this.tabFocusMode))
      return !0;
    if (this.tabFocusMode > 0 && e.keyCode != 27 && $p.indexOf(e.keyCode) < 0 && (this.tabFocusMode = -1), K.android && K.chrome && !e.synthetic && (e.keyCode == 13 || e.keyCode == 8))
      return this.view.observer.delayAndroidKey(e.key, e.keyCode), !0;
    let t;
    return K.ios && !e.synthetic && !e.altKey && !e.metaKey && ((t = jp.find((r) => r.keyCode == e.keyCode)) && !e.ctrlKey || I3.indexOf(e.key) > -1 && e.ctrlKey && !e.shiftKey) ? (this.pendingIOSKey = t || e, setTimeout(() => this.flushIOSKey(), 250), !0) : (e.keyCode != 229 && this.view.observer.forceFlush(), !1);
  }
  flushIOSKey(e) {
    let t = this.pendingIOSKey;
    return !t || t.key == "Enter" && e && e.from < e.to && /^\S+$/.test(e.insert.toString()) ? !1 : (this.pendingIOSKey = void 0, Pi(this.view.contentDOM, t.key, t.keyCode, t instanceof KeyboardEvent ? t : void 0));
  }
  ignoreDuringComposition(e) {
    return /^key/.test(e.type) ? this.composing > 0 ? !0 : K.safari && !K.ios && this.compositionPendingKey && Date.now() - this.compositionEndedAt < 100 ? (this.compositionPendingKey = !1, !0) : !1 : !1;
  }
  startMouseSelection(e) {
    this.mouseSelection && this.mouseSelection.destroy(), this.mouseSelection = e;
  }
  update(e) {
    this.view.observer.update(e), this.mouseSelection && this.mouseSelection.update(e), this.draggedContent && e.docChanged && (this.draggedContent = this.draggedContent.map(e.changes)), e.transactions.length && (this.lastKeyCode = this.lastSelectionTime = 0);
  }
  destroy() {
    this.mouseSelection && this.mouseSelection.destroy();
  }
}
function hf(n, e) {
  return (t, r) => {
    try {
      return e.call(n, r, t);
    } catch (i) {
      Xt(t.state, i);
    }
  };
}
function N3(n) {
  let e = /* @__PURE__ */ Object.create(null);
  function t(r) {
    return e[r] || (e[r] = { observers: [], handlers: [] });
  }
  for (let r of n) {
    let i = r.spec;
    if (i && i.domEventHandlers)
      for (let s in i.domEventHandlers) {
        let l = i.domEventHandlers[s];
        l && t(s).handlers.push(hf(r.value, l));
      }
    if (i && i.domEventObservers)
      for (let s in i.domEventObservers) {
        let l = i.domEventObservers[s];
        l && t(s).observers.push(hf(r.value, l));
      }
  }
  for (let r in Sr)
    t(r).handlers.push(Sr[r]);
  for (let r in ir)
    t(r).observers.push(ir[r]);
  return e;
}
const jp = [
  { key: "Backspace", keyCode: 8, inputType: "deleteContentBackward" },
  { key: "Enter", keyCode: 13, inputType: "insertParagraph" },
  { key: "Enter", keyCode: 13, inputType: "insertLineBreak" },
  { key: "Delete", keyCode: 46, inputType: "deleteContentForward" }
], I3 = "dthko", $p = [16, 17, 18, 20, 91, 92, 224, 225], _l = 6;
function Ml(n) {
  return Math.max(0, n) * 0.7 + 8;
}
function z3(n, e) {
  return Math.max(Math.abs(n.clientX - e.clientX), Math.abs(n.clientY - e.clientY));
}
class P3 {
  constructor(e, t, r, i) {
    this.view = e, this.startEvent = t, this.style = r, this.mustSelect = i, this.scrollSpeed = { x: 0, y: 0 }, this.scrolling = -1, this.lastEvent = t, this.scrollParents = Y5(e.contentDOM), this.atoms = e.state.facet(hh).map((l) => l(e));
    let s = e.contentDOM.ownerDocument;
    s.addEventListener("mousemove", this.move = this.move.bind(this)), s.addEventListener("mouseup", this.up = this.up.bind(this)), this.extend = t.shiftKey, this.multiple = e.state.facet(Se.allowMultipleSelections) && H3(e, t), this.dragging = V3(e, t) && Xp(t) == 1 ? null : !1;
  }
  start(e) {
    this.dragging === !1 && this.select(e);
  }
  move(e) {
    if (e.buttons == 0)
      return this.destroy();
    if (this.dragging || this.dragging == null && z3(this.startEvent, e) < 10)
      return;
    this.select(this.lastEvent = e);
    let t = 0, r = 0, i = 0, s = 0, l = this.view.win.innerWidth, o = this.view.win.innerHeight;
    this.scrollParents.x && ({ left: i, right: l } = this.scrollParents.x.getBoundingClientRect()), this.scrollParents.y && ({ top: s, bottom: o } = this.scrollParents.y.getBoundingClientRect());
    let a = Vp(this.view);
    e.clientX - a.left <= i + _l ? t = -Ml(i - e.clientX) : e.clientX + a.right >= l - _l && (t = Ml(e.clientX - l)), e.clientY - a.top <= s + _l ? r = -Ml(s - e.clientY) : e.clientY + a.bottom >= o - _l && (r = Ml(e.clientY - o)), this.setScrollSpeed(t, r);
  }
  up(e) {
    this.dragging == null && this.select(this.lastEvent), this.dragging || e.preventDefault(), this.destroy();
  }
  destroy() {
    this.setScrollSpeed(0, 0);
    let e = this.view.contentDOM.ownerDocument;
    e.removeEventListener("mousemove", this.move), e.removeEventListener("mouseup", this.up), this.view.inputState.mouseSelection = this.view.inputState.draggedContent = null;
  }
  setScrollSpeed(e, t) {
    this.scrollSpeed = { x: e, y: t }, e || t ? this.scrolling < 0 && (this.scrolling = setInterval(() => this.scroll(), 50)) : this.scrolling > -1 && (clearInterval(this.scrolling), this.scrolling = -1);
  }
  scroll() {
    let { x: e, y: t } = this.scrollSpeed;
    e && this.scrollParents.x && (this.scrollParents.x.scrollLeft += e, e = 0), t && this.scrollParents.y && (this.scrollParents.y.scrollTop += t, t = 0), (e || t) && this.view.win.scrollBy(e, t), this.dragging === !1 && this.select(this.lastEvent);
  }
  skipAtoms(e) {
    let t = null;
    for (let r = 0; r < e.ranges.length; r++) {
      let i = e.ranges[r], s = null;
      if (i.empty) {
        let l = po(this.atoms, i.from, 0);
        l != i.from && (s = I.cursor(l, -1));
      } else {
        let l = po(this.atoms, i.from, -1), o = po(this.atoms, i.to, 1);
        (l != i.from || o != i.to) && (s = I.range(i.from == i.anchor ? l : o, i.from == i.head ? l : o));
      }
      s && (t || (t = e.ranges.slice()), t[r] = s);
    }
    return t ? I.create(t, e.mainIndex) : e;
  }
  select(e) {
    let { view: t } = this, r = this.skipAtoms(this.style.get(e, this.extend, this.multiple));
    (this.mustSelect || !r.eq(t.state.selection, this.dragging === !1)) && this.view.dispatch({
      selection: r,
      userEvent: "select.pointer"
    }), this.mustSelect = !1;
  }
  update(e) {
    e.transactions.some((t) => t.isUserEvent("input.type")) ? this.destroy() : this.style.update(e) && setTimeout(() => this.select(this.lastEvent), 20);
  }
}
function H3(n, e) {
  let t = n.state.facet(Mp);
  return t.length ? t[0](e) : K.mac ? e.metaKey : e.ctrlKey;
}
function q3(n, e) {
  let t = n.state.facet(Tp);
  return t.length ? t[0](e) : K.mac ? !e.altKey : !e.ctrlKey;
}
function V3(n, e) {
  let { main: t } = n.state.selection;
  if (t.empty)
    return !1;
  let r = Ks(n.root);
  if (!r || r.rangeCount == 0)
    return !0;
  let i = r.getRangeAt(0).getClientRects();
  for (let s = 0; s < i.length; s++) {
    let l = i[s];
    if (l.left <= e.clientX && l.right >= e.clientX && l.top <= e.clientY && l.bottom >= e.clientY)
      return !0;
  }
  return !1;
}
function W3(n, e) {
  if (!e.bubbles)
    return !0;
  if (e.defaultPrevented)
    return !1;
  for (let t = e.target, r; t != n.contentDOM; t = t.parentNode)
    if (!t || t.nodeType == 11 || (r = Be.get(t)) && r.ignoreEvent(e))
      return !1;
  return !0;
}
const Sr = /* @__PURE__ */ Object.create(null), ir = /* @__PURE__ */ Object.create(null), Yp = K.ie && K.ie_version < 15 || K.ios && K.webkit_version < 604;
function U3(n) {
  let e = n.dom.parentNode;
  if (!e)
    return;
  let t = e.appendChild(document.createElement("textarea"));
  t.style.cssText = "position: fixed; left: -10000px; top: 10px", t.focus(), setTimeout(() => {
    n.focus(), t.remove(), Kp(n, t.value);
  }, 50);
}
function la(n, e, t) {
  for (let r of n.facet(e))
    t = r(t, n);
  return t;
}
function Kp(n, e) {
  e = la(n.state, oh, e);
  let { state: t } = n, r, i = 1, s = t.toText(e), l = s.lines == t.selection.ranges.length;
  if (gu != null && t.selection.ranges.every((a) => a.empty) && gu == s.toString()) {
    let a = -1;
    r = t.changeByRange((u) => {
      let h = t.doc.lineAt(u.from);
      if (h.from == a)
        return { range: u };
      a = h.from;
      let c = t.toText((l ? s.line(i++).text : e) + t.lineBreak);
      return {
        changes: { from: h.from, insert: c },
        range: I.cursor(u.from + c.length)
      };
    });
  } else l ? r = t.changeByRange((a) => {
    let u = s.line(i++);
    return {
      changes: { from: a.from, to: a.to, insert: u.text },
      range: I.cursor(a.from + u.length)
    };
  }) : r = t.replaceSelection(s);
  n.dispatch(r, {
    userEvent: "input.paste",
    scrollIntoView: !0
  });
}
ir.scroll = (n) => {
  n.inputState.lastScrollTop = n.scrollDOM.scrollTop, n.inputState.lastScrollLeft = n.scrollDOM.scrollLeft;
};
Sr.keydown = (n, e) => (n.inputState.setSelectionOrigin("select"), e.keyCode == 27 && n.inputState.tabFocusMode != 0 && (n.inputState.tabFocusMode = Date.now() + 2e3), !1);
ir.touchstart = (n, e) => {
  n.inputState.lastTouchTime = Date.now(), n.inputState.setSelectionOrigin("select.pointer");
};
ir.touchmove = (n) => {
  n.inputState.setSelectionOrigin("select.pointer");
};
Sr.mousedown = (n, e) => {
  if (n.observer.flush(), n.inputState.lastTouchTime > Date.now() - 2e3)
    return !1;
  let t = null;
  for (let r of n.state.facet(Ep))
    if (t = r(n, e), t)
      break;
  if (!t && e.button == 0 && (t = $3(n, e)), t) {
    let r = !n.hasFocus;
    n.inputState.startMouseSelection(new P3(n, e, t, r)), r && n.observer.ignore(() => {
      up(n.contentDOM);
      let s = n.root.activeElement;
      s && !s.contains(n.contentDOM) && s.blur();
    });
    let i = n.inputState.mouseSelection;
    if (i)
      return i.start(e), i.dragging === !1;
  }
  return !1;
};
function cf(n, e, t, r) {
  if (r == 1)
    return I.cursor(e, t);
  if (r == 2)
    return w3(n.state, e, t);
  {
    let i = Je.find(n.docView, e), s = n.state.doc.lineAt(i ? i.posAtEnd : e), l = i ? i.posAtStart : s.from, o = i ? i.posAtEnd : s.to;
    return o < n.state.doc.length && o == s.to && o++, I.range(l, o);
  }
}
let ff = (n, e, t) => e >= t.top && e <= t.bottom && n >= t.left && n <= t.right;
function G3(n, e, t, r) {
  let i = Je.find(n.docView, e);
  if (!i)
    return 1;
  let s = e - i.posAtStart;
  if (s == 0)
    return 1;
  if (s == i.length)
    return -1;
  let l = i.coordsAt(s, -1);
  if (l && ff(t, r, l))
    return -1;
  let o = i.coordsAt(s, 1);
  return o && ff(t, r, o) ? 1 : l && l.bottom >= r ? -1 : 1;
}
function df(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1);
  return { pos: t, bias: G3(n, t, e.clientX, e.clientY) };
}
const j3 = K.ie && K.ie_version <= 11;
let mf = null, pf = 0, gf = 0;
function Xp(n) {
  if (!j3)
    return n.detail;
  let e = mf, t = gf;
  return mf = n, gf = Date.now(), pf = !e || t > Date.now() - 400 && Math.abs(e.clientX - n.clientX) < 2 && Math.abs(e.clientY - n.clientY) < 2 ? (pf + 1) % 3 : 1;
}
function $3(n, e) {
  let t = df(n, e), r = Xp(e), i = n.state.selection;
  return {
    update(s) {
      s.docChanged && (t.pos = s.changes.mapPos(t.pos), i = i.map(s.changes));
    },
    get(s, l, o) {
      let a = df(n, s), u, h = cf(n, a.pos, a.bias, r);
      if (t.pos != a.pos && !l) {
        let c = cf(n, t.pos, t.bias, r), f = Math.min(c.from, h.from), m = Math.max(c.to, h.to);
        h = f < h.from ? I.range(f, m) : I.range(m, f);
      }
      return l ? i.replaceRange(i.main.extend(h.from, h.to)) : o && r == 1 && i.ranges.length > 1 && (u = Y3(i, a.pos)) ? u : o ? i.addRange(h) : I.create([h]);
    }
  };
}
function Y3(n, e) {
  for (let t = 0; t < n.ranges.length; t++) {
    let { from: r, to: i } = n.ranges[t];
    if (r <= e && i >= e)
      return I.create(n.ranges.slice(0, t).concat(n.ranges.slice(t + 1)), n.mainIndex == t ? 0 : n.mainIndex - (n.mainIndex > t ? 1 : 0));
  }
  return null;
}
Sr.dragstart = (n, e) => {
  let { selection: { main: t } } = n.state;
  if (e.target.draggable) {
    let i = n.docView.nearest(e.target);
    if (i && i.isWidget) {
      let s = i.posAtStart, l = s + i.length;
      (s >= t.to || l <= t.from) && (t = I.range(s, l));
    }
  }
  let { inputState: r } = n;
  return r.mouseSelection && (r.mouseSelection.dragging = !0), r.draggedContent = t, e.dataTransfer && (e.dataTransfer.setData("Text", la(n.state, ah, n.state.sliceDoc(t.from, t.to))), e.dataTransfer.effectAllowed = "copyMove"), !1;
};
Sr.dragend = (n) => (n.inputState.draggedContent = null, !1);
function bf(n, e, t, r) {
  if (t = la(n.state, oh, t), !t)
    return;
  let i = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), { draggedContent: s } = n.inputState, l = r && s && q3(n, e) ? { from: s.from, to: s.to } : null, o = { from: i, insert: t }, a = n.state.changes(l ? [l, o] : o);
  n.focus(), n.dispatch({
    changes: a,
    selection: { anchor: a.mapPos(i, -1), head: a.mapPos(i, 1) },
    userEvent: l ? "move.drop" : "input.drop"
  }), n.inputState.draggedContent = null;
}
Sr.drop = (n, e) => {
  if (!e.dataTransfer)
    return !1;
  if (n.state.readOnly)
    return !0;
  let t = e.dataTransfer.files;
  if (t && t.length) {
    let r = Array(t.length), i = 0, s = () => {
      ++i == t.length && bf(n, e, r.filter((l) => l != null).join(n.state.lineBreak), !1);
    };
    for (let l = 0; l < t.length; l++) {
      let o = new FileReader();
      o.onerror = s, o.onload = () => {
        /[\x00-\x08\x0e-\x1f]{2}/.test(o.result) || (r[l] = o.result), s();
      }, o.readAsText(t[l]);
    }
    return !0;
  } else {
    let r = e.dataTransfer.getData("Text");
    if (r)
      return bf(n, e, r, !0), !0;
  }
  return !1;
};
Sr.paste = (n, e) => {
  if (n.state.readOnly)
    return !0;
  n.observer.flush();
  let t = Yp ? null : e.clipboardData;
  return t ? (Kp(n, t.getData("text/plain") || t.getData("text/uri-list")), !0) : (U3(n), !1);
};
function K3(n, e) {
  let t = n.dom.parentNode;
  if (!t)
    return;
  let r = t.appendChild(document.createElement("textarea"));
  r.style.cssText = "position: fixed; left: -10000px; top: 10px", r.value = e, r.focus(), r.selectionEnd = e.length, r.selectionStart = 0, setTimeout(() => {
    r.remove(), n.focus();
  }, 50);
}
function X3(n) {
  let e = [], t = [], r = !1;
  for (let i of n.selection.ranges)
    i.empty || (e.push(n.sliceDoc(i.from, i.to)), t.push(i));
  if (!e.length) {
    let i = -1;
    for (let { from: s } of n.selection.ranges) {
      let l = n.doc.lineAt(s);
      l.number > i && (e.push(l.text), t.push({ from: l.from, to: Math.min(n.doc.length, l.to + 1) })), i = l.number;
    }
    r = !0;
  }
  return { text: la(n, ah, e.join(n.lineBreak)), ranges: t, linewise: r };
}
let gu = null;
Sr.copy = Sr.cut = (n, e) => {
  let { text: t, ranges: r, linewise: i } = X3(n.state);
  if (!t && !i)
    return !1;
  gu = i ? t : null, e.type == "cut" && !n.state.readOnly && n.dispatch({
    changes: r,
    scrollIntoView: !0,
    userEvent: "delete.cut"
  });
  let s = Yp ? null : e.clipboardData;
  return s ? (s.clearData(), s.setData("text/plain", t), !0) : (K3(n, t), !1);
};
const Zp = /* @__PURE__ */ vn.define();
function Jp(n, e) {
  let t = [];
  for (let r of n.facet(Op)) {
    let i = r(n, e);
    i && t.push(i);
  }
  return t ? n.update({ effects: t, annotations: Zp.of(!0) }) : null;
}
function Qp(n) {
  setTimeout(() => {
    let e = n.hasFocus;
    if (e != n.inputState.notifiedFocused) {
      let t = Jp(n.state, e);
      t ? n.dispatch(t) : n.update([]);
    }
  }, 10);
}
ir.focus = (n) => {
  n.inputState.lastFocusTime = Date.now(), !n.scrollDOM.scrollTop && (n.inputState.lastScrollTop || n.inputState.lastScrollLeft) && (n.scrollDOM.scrollTop = n.inputState.lastScrollTop, n.scrollDOM.scrollLeft = n.inputState.lastScrollLeft), Qp(n);
};
ir.blur = (n) => {
  n.observer.clearSelectionRange(), Qp(n);
};
ir.compositionstart = ir.compositionupdate = (n) => {
  n.observer.editContext || (n.inputState.compositionFirstChange == null && (n.inputState.compositionFirstChange = !0), n.inputState.composing < 0 && (n.inputState.composing = 0));
};
ir.compositionend = (n) => {
  n.observer.editContext || (n.inputState.composing = -1, n.inputState.compositionEndedAt = Date.now(), n.inputState.compositionPendingKey = !0, n.inputState.compositionPendingChange = n.observer.pendingRecords().length > 0, n.inputState.compositionFirstChange = null, K.chrome && K.android ? n.observer.flushSoon() : n.inputState.compositionPendingChange ? Promise.resolve().then(() => n.observer.flush()) : setTimeout(() => {
    n.inputState.composing < 0 && n.docView.hasComposition && n.update([]);
  }, 50));
};
ir.contextmenu = (n) => {
  n.inputState.lastContextMenu = Date.now();
};
Sr.beforeinput = (n, e) => {
  var t, r;
  if (e.inputType == "insertReplacementText" && n.observer.editContext) {
    let s = (t = e.dataTransfer) === null || t === void 0 ? void 0 : t.getData("text/plain"), l = e.getTargetRanges();
    if (s && l.length) {
      let o = l[0], a = n.posAtDOM(o.startContainer, o.startOffset), u = n.posAtDOM(o.endContainer, o.endOffset);
      return ch(n, { from: a, to: u, insert: n.state.toText(s) }, null), !0;
    }
  }
  let i;
  if (K.chrome && K.android && (i = jp.find((s) => s.inputType == e.inputType)) && (n.observer.delayAndroidKey(i.key, i.keyCode), i.key == "Backspace" || i.key == "Delete")) {
    let s = ((r = window.visualViewport) === null || r === void 0 ? void 0 : r.height) || 0;
    setTimeout(() => {
      var l;
      (((l = window.visualViewport) === null || l === void 0 ? void 0 : l.height) || 0) > s + 10 && n.hasFocus && (n.contentDOM.blur(), n.focus());
    }, 100);
  }
  return K.ios && e.inputType == "deleteContentForward" && n.observer.flushSoon(), K.safari && e.inputType == "insertText" && n.inputState.composing >= 0 && setTimeout(() => ir.compositionend(n, e), 20), !1;
};
const vf = /* @__PURE__ */ new Set();
function Z3(n) {
  vf.has(n) || (vf.add(n), n.addEventListener("copy", () => {
  }), n.addEventListener("cut", () => {
  }));
}
const yf = ["pre-wrap", "normal", "pre-line", "break-spaces"];
let Yi = !1;
function wf() {
  Yi = !1;
}
class J3 {
  constructor(e) {
    this.lineWrapping = e, this.doc = Ae.empty, this.heightSamples = {}, this.lineHeight = 14, this.charWidth = 7, this.textHeight = 14, this.lineLength = 30;
  }
  heightForGap(e, t) {
    let r = this.doc.lineAt(t).number - this.doc.lineAt(e).number + 1;
    return this.lineWrapping && (r += Math.max(0, Math.ceil((t - e - r * this.lineLength * 0.5) / this.lineLength))), this.lineHeight * r;
  }
  heightForLine(e) {
    return this.lineWrapping ? (1 + Math.max(0, Math.ceil((e - this.lineLength) / (this.lineLength - 5)))) * this.lineHeight : this.lineHeight;
  }
  setDoc(e) {
    return this.doc = e, this;
  }
  mustRefreshForWrapping(e) {
    return yf.indexOf(e) > -1 != this.lineWrapping;
  }
  mustRefreshForHeights(e) {
    let t = !1;
    for (let r = 0; r < e.length; r++) {
      let i = e[r];
      i < 0 ? r++ : this.heightSamples[Math.floor(i * 10)] || (t = !0, this.heightSamples[Math.floor(i * 10)] = !0);
    }
    return t;
  }
  refresh(e, t, r, i, s, l) {
    let o = yf.indexOf(e) > -1, a = Math.round(t) != Math.round(this.lineHeight) || this.lineWrapping != o;
    if (this.lineWrapping = o, this.lineHeight = t, this.charWidth = r, this.textHeight = i, this.lineLength = s, a) {
      this.heightSamples = {};
      for (let u = 0; u < l.length; u++) {
        let h = l[u];
        h < 0 ? u++ : this.heightSamples[Math.floor(h * 10)] = !0;
      }
    }
    return a;
  }
}
class Q3 {
  constructor(e, t) {
    this.from = e, this.heights = t, this.index = 0;
  }
  get more() {
    return this.index < this.heights.length;
  }
}
class Nr {
  /**
  @internal
  */
  constructor(e, t, r, i, s) {
    this.from = e, this.length = t, this.top = r, this.height = i, this._content = s;
  }
  /**
  The type of element this is. When querying lines, this may be
  an array of all the blocks that make up the line.
  */
  get type() {
    return typeof this._content == "number" ? St.Text : Array.isArray(this._content) ? this._content : this._content.type;
  }
  /**
  The end of the element as a document position.
  */
  get to() {
    return this.from + this.length;
  }
  /**
  The bottom position of the element.
  */
  get bottom() {
    return this.top + this.height;
  }
  /**
  If this is a widget block, this will return the widget
  associated with it.
  */
  get widget() {
    return this._content instanceof Ln ? this._content.widget : null;
  }
  /**
  If this is a textblock, this holds the number of line breaks
  that appear in widgets inside the block.
  */
  get widgetLineBreaks() {
    return typeof this._content == "number" ? this._content : 0;
  }
  /**
  @internal
  */
  join(e) {
    let t = (Array.isArray(this._content) ? this._content : [this]).concat(Array.isArray(e._content) ? e._content : [e]);
    return new Nr(this.from, this.length + e.length, this.top, this.height + e.height, t);
  }
}
var Ne = /* @__PURE__ */ function(n) {
  return n[n.ByPos = 0] = "ByPos", n[n.ByHeight = 1] = "ByHeight", n[n.ByPosNoHeight = 2] = "ByPosNoHeight", n;
}(Ne || (Ne = {}));
const go = 1e-3;
class At {
  constructor(e, t, r = 2) {
    this.length = e, this.height = t, this.flags = r;
  }
  get outdated() {
    return (this.flags & 2) > 0;
  }
  set outdated(e) {
    this.flags = (e ? 2 : 0) | this.flags & -3;
  }
  setHeight(e) {
    this.height != e && (Math.abs(this.height - e) > go && (Yi = !0), this.height = e);
  }
  // Base case is to replace a leaf node, which simply builds a tree
  // from the new nodes and returns that (HeightMapBranch and
  // HeightMapGap override this to actually use from/to)
  replace(e, t, r) {
    return At.of(r);
  }
  // Again, these are base cases, and are overridden for branch and gap nodes.
  decomposeLeft(e, t) {
    t.push(this);
  }
  decomposeRight(e, t) {
    t.push(this);
  }
  applyChanges(e, t, r, i) {
    let s = this, l = r.doc;
    for (let o = i.length - 1; o >= 0; o--) {
      let { fromA: a, toA: u, fromB: h, toB: c } = i[o], f = s.lineAt(a, Ne.ByPosNoHeight, r.setDoc(t), 0, 0), m = f.to >= u ? f : s.lineAt(u, Ne.ByPosNoHeight, r, 0, 0);
      for (c += m.to - u, u = m.to; o > 0 && f.from <= i[o - 1].toA; )
        a = i[o - 1].fromA, h = i[o - 1].fromB, o--, a < f.from && (f = s.lineAt(a, Ne.ByPosNoHeight, r, 0, 0));
      h += f.from - a, a = f.from;
      let g = fh.build(r.setDoc(l), e, h, c);
      s = Bo(s, s.replace(a, u, g));
    }
    return s.updateHeight(r, 0);
  }
  static empty() {
    return new It(0, 0);
  }
  // nodes uses null values to indicate the position of line breaks.
  // There are never line breaks at the start or end of the array, or
  // two line breaks next to each other, and the array isn't allowed
  // to be empty (same restrictions as return value from the builder).
  static of(e) {
    if (e.length == 1)
      return e[0];
    let t = 0, r = e.length, i = 0, s = 0;
    for (; ; )
      if (t == r)
        if (i > s * 2) {
          let o = e[t - 1];
          o.break ? e.splice(--t, 1, o.left, null, o.right) : e.splice(--t, 1, o.left, o.right), r += 1 + o.break, i -= o.size;
        } else if (s > i * 2) {
          let o = e[r];
          o.break ? e.splice(r, 1, o.left, null, o.right) : e.splice(r, 1, o.left, o.right), r += 2 + o.break, s -= o.size;
        } else
          break;
      else if (i < s) {
        let o = e[t++];
        o && (i += o.size);
      } else {
        let o = e[--r];
        o && (s += o.size);
      }
    let l = 0;
    return e[t - 1] == null ? (l = 1, t--) : e[t] == null && (l = 1, r++), new e6(At.of(e.slice(0, t)), l, At.of(e.slice(r)));
  }
}
function Bo(n, e) {
  return n == e ? n : (n.constructor != e.constructor && (Yi = !0), e);
}
At.prototype.size = 1;
class eg extends At {
  constructor(e, t, r) {
    super(e, t), this.deco = r;
  }
  blockAt(e, t, r, i) {
    return new Nr(i, this.length, r, this.height, this.deco || 0);
  }
  lineAt(e, t, r, i, s) {
    return this.blockAt(0, r, i, s);
  }
  forEachLine(e, t, r, i, s, l) {
    e <= s + this.length && t >= s && l(this.blockAt(0, r, i, s));
  }
  updateHeight(e, t = 0, r = !1, i) {
    return i && i.from <= t && i.more && this.setHeight(i.heights[i.index++]), this.outdated = !1, this;
  }
  toString() {
    return `block(${this.length})`;
  }
}
class It extends eg {
  constructor(e, t) {
    super(e, t, null), this.collapsed = 0, this.widgetHeight = 0, this.breaks = 0;
  }
  blockAt(e, t, r, i) {
    return new Nr(i, this.length, r, this.height, this.breaks);
  }
  replace(e, t, r) {
    let i = r[0];
    return r.length == 1 && (i instanceof It || i instanceof lt && i.flags & 4) && Math.abs(this.length - i.length) < 10 ? (i instanceof lt ? i = new It(i.length, this.height) : i.height = this.height, this.outdated || (i.outdated = !1), i) : At.of(r);
  }
  updateHeight(e, t = 0, r = !1, i) {
    return i && i.from <= t && i.more ? this.setHeight(i.heights[i.index++]) : (r || this.outdated) && this.setHeight(Math.max(this.widgetHeight, e.heightForLine(this.length - this.collapsed)) + this.breaks * e.lineHeight), this.outdated = !1, this;
  }
  toString() {
    return `line(${this.length}${this.collapsed ? -this.collapsed : ""}${this.widgetHeight ? ":" + this.widgetHeight : ""})`;
  }
}
class lt extends At {
  constructor(e) {
    super(e, 0);
  }
  heightMetrics(e, t) {
    let r = e.doc.lineAt(t).number, i = e.doc.lineAt(t + this.length).number, s = i - r + 1, l, o = 0;
    if (e.lineWrapping) {
      let a = Math.min(this.height, e.lineHeight * s);
      l = a / s, this.length > s + 1 && (o = (this.height - a) / (this.length - s - 1));
    } else
      l = this.height / s;
    return { firstLine: r, lastLine: i, perLine: l, perChar: o };
  }
  blockAt(e, t, r, i) {
    let { firstLine: s, lastLine: l, perLine: o, perChar: a } = this.heightMetrics(t, i);
    if (t.lineWrapping) {
      let u = i + (e < t.lineHeight ? 0 : Math.round(Math.max(0, Math.min(1, (e - r) / this.height)) * this.length)), h = t.doc.lineAt(u), c = o + h.length * a, f = Math.max(r, e - c / 2);
      return new Nr(h.from, h.length, f, c, 0);
    } else {
      let u = Math.max(0, Math.min(l - s, Math.floor((e - r) / o))), { from: h, length: c } = t.doc.line(s + u);
      return new Nr(h, c, r + o * u, o, 0);
    }
  }
  lineAt(e, t, r, i, s) {
    if (t == Ne.ByHeight)
      return this.blockAt(e, r, i, s);
    if (t == Ne.ByPosNoHeight) {
      let { from: m, to: g } = r.doc.lineAt(e);
      return new Nr(m, g - m, 0, 0, 0);
    }
    let { firstLine: l, perLine: o, perChar: a } = this.heightMetrics(r, s), u = r.doc.lineAt(e), h = o + u.length * a, c = u.number - l, f = i + o * c + a * (u.from - s - c);
    return new Nr(u.from, u.length, Math.max(i, Math.min(f, i + this.height - h)), h, 0);
  }
  forEachLine(e, t, r, i, s, l) {
    e = Math.max(e, s), t = Math.min(t, s + this.length);
    let { firstLine: o, perLine: a, perChar: u } = this.heightMetrics(r, s);
    for (let h = e, c = i; h <= t; ) {
      let f = r.doc.lineAt(h);
      if (h == e) {
        let g = f.number - o;
        c += a * g + u * (e - s - g);
      }
      let m = a + u * f.length;
      l(new Nr(f.from, f.length, c, m, 0)), c += m, h = f.to + 1;
    }
  }
  replace(e, t, r) {
    let i = this.length - t;
    if (i > 0) {
      let s = r[r.length - 1];
      s instanceof lt ? r[r.length - 1] = new lt(s.length + i) : r.push(null, new lt(i - 1));
    }
    if (e > 0) {
      let s = r[0];
      s instanceof lt ? r[0] = new lt(e + s.length) : r.unshift(new lt(e - 1), null);
    }
    return At.of(r);
  }
  decomposeLeft(e, t) {
    t.push(new lt(e - 1), null);
  }
  decomposeRight(e, t) {
    t.push(null, new lt(this.length - e - 1));
  }
  updateHeight(e, t = 0, r = !1, i) {
    let s = t + this.length;
    if (i && i.from <= t + this.length && i.more) {
      let l = [], o = Math.max(t, i.from), a = -1;
      for (i.from > t && l.push(new lt(i.from - t - 1).updateHeight(e, t)); o <= s && i.more; ) {
        let h = e.doc.lineAt(o).length;
        l.length && l.push(null);
        let c = i.heights[i.index++];
        a == -1 ? a = c : Math.abs(c - a) >= go && (a = -2);
        let f = new It(h, c);
        f.outdated = !1, l.push(f), o += h + 1;
      }
      o <= s && l.push(null, new lt(s - o).updateHeight(e, o));
      let u = At.of(l);
      return (a < 0 || Math.abs(u.height - this.height) >= go || Math.abs(a - this.heightMetrics(e, t).perLine) >= go) && (Yi = !0), Bo(this, u);
    } else (r || this.outdated) && (this.setHeight(e.heightForGap(t, t + this.length)), this.outdated = !1);
    return this;
  }
  toString() {
    return `gap(${this.length})`;
  }
}
class e6 extends At {
  constructor(e, t, r) {
    super(e.length + t + r.length, e.height + r.height, t | (e.outdated || r.outdated ? 2 : 0)), this.left = e, this.right = r, this.size = e.size + r.size;
  }
  get break() {
    return this.flags & 1;
  }
  blockAt(e, t, r, i) {
    let s = r + this.left.height;
    return e < s ? this.left.blockAt(e, t, r, i) : this.right.blockAt(e, t, s, i + this.left.length + this.break);
  }
  lineAt(e, t, r, i, s) {
    let l = i + this.left.height, o = s + this.left.length + this.break, a = t == Ne.ByHeight ? e < l : e < o, u = a ? this.left.lineAt(e, t, r, i, s) : this.right.lineAt(e, t, r, l, o);
    if (this.break || (a ? u.to < o : u.from > o))
      return u;
    let h = t == Ne.ByPosNoHeight ? Ne.ByPosNoHeight : Ne.ByPos;
    return a ? u.join(this.right.lineAt(o, h, r, l, o)) : this.left.lineAt(o, h, r, i, s).join(u);
  }
  forEachLine(e, t, r, i, s, l) {
    let o = i + this.left.height, a = s + this.left.length + this.break;
    if (this.break)
      e < a && this.left.forEachLine(e, t, r, i, s, l), t >= a && this.right.forEachLine(e, t, r, o, a, l);
    else {
      let u = this.lineAt(a, Ne.ByPos, r, i, s);
      e < u.from && this.left.forEachLine(e, u.from - 1, r, i, s, l), u.to >= e && u.from <= t && l(u), t > u.to && this.right.forEachLine(u.to + 1, t, r, o, a, l);
    }
  }
  replace(e, t, r) {
    let i = this.left.length + this.break;
    if (t < i)
      return this.balanced(this.left.replace(e, t, r), this.right);
    if (e > this.left.length)
      return this.balanced(this.left, this.right.replace(e - i, t - i, r));
    let s = [];
    e > 0 && this.decomposeLeft(e, s);
    let l = s.length;
    for (let o of r)
      s.push(o);
    if (e > 0 && kf(s, l - 1), t < this.length) {
      let o = s.length;
      this.decomposeRight(t, s), kf(s, o);
    }
    return At.of(s);
  }
  decomposeLeft(e, t) {
    let r = this.left.length;
    if (e <= r)
      return this.left.decomposeLeft(e, t);
    t.push(this.left), this.break && (r++, e >= r && t.push(null)), e > r && this.right.decomposeLeft(e - r, t);
  }
  decomposeRight(e, t) {
    let r = this.left.length, i = r + this.break;
    if (e >= i)
      return this.right.decomposeRight(e - i, t);
    e < r && this.left.decomposeRight(e, t), this.break && e < i && t.push(null), t.push(this.right);
  }
  balanced(e, t) {
    return e.size > 2 * t.size || t.size > 2 * e.size ? At.of(this.break ? [e, null, t] : [e, t]) : (this.left = Bo(this.left, e), this.right = Bo(this.right, t), this.setHeight(e.height + t.height), this.outdated = e.outdated || t.outdated, this.size = e.size + t.size, this.length = e.length + this.break + t.length, this);
  }
  updateHeight(e, t = 0, r = !1, i) {
    let { left: s, right: l } = this, o = t + s.length + this.break, a = null;
    return i && i.from <= t + s.length && i.more ? a = s = s.updateHeight(e, t, r, i) : s.updateHeight(e, t, r), i && i.from <= o + l.length && i.more ? a = l = l.updateHeight(e, o, r, i) : l.updateHeight(e, o, r), a ? this.balanced(s, l) : (this.height = this.left.height + this.right.height, this.outdated = !1, this);
  }
  toString() {
    return this.left + (this.break ? " " : "-") + this.right;
  }
}
function kf(n, e) {
  let t, r;
  n[e] == null && (t = n[e - 1]) instanceof lt && (r = n[e + 1]) instanceof lt && n.splice(e - 1, 3, new lt(t.length + 1 + r.length));
}
const t6 = 5;
class fh {
  constructor(e, t) {
    this.pos = e, this.oracle = t, this.nodes = [], this.lineStart = -1, this.lineEnd = -1, this.covering = null, this.writtenTo = e;
  }
  get isCovered() {
    return this.covering && this.nodes[this.nodes.length - 1] == this.covering;
  }
  span(e, t) {
    if (this.lineStart > -1) {
      let r = Math.min(t, this.lineEnd), i = this.nodes[this.nodes.length - 1];
      i instanceof It ? i.length += r - this.pos : (r > this.pos || !this.isCovered) && this.nodes.push(new It(r - this.pos, -1)), this.writtenTo = r, t > r && (this.nodes.push(null), this.writtenTo++, this.lineStart = -1);
    }
    this.pos = t;
  }
  point(e, t, r) {
    if (e < t || r.heightRelevant) {
      let i = r.widget ? r.widget.estimatedHeight : 0, s = r.widget ? r.widget.lineBreaks : 0;
      i < 0 && (i = this.oracle.lineHeight);
      let l = t - e;
      r.block ? this.addBlock(new eg(l, i, r)) : (l || s || i >= t6) && this.addLineDeco(i, s, l);
    } else t > e && this.span(e, t);
    this.lineEnd > -1 && this.lineEnd < this.pos && (this.lineEnd = this.oracle.doc.lineAt(this.pos).to);
  }
  enterLine() {
    if (this.lineStart > -1)
      return;
    let { from: e, to: t } = this.oracle.doc.lineAt(this.pos);
    this.lineStart = e, this.lineEnd = t, this.writtenTo < e && ((this.writtenTo < e - 1 || this.nodes[this.nodes.length - 1] == null) && this.nodes.push(this.blankContent(this.writtenTo, e - 1)), this.nodes.push(null)), this.pos > e && this.nodes.push(new It(this.pos - e, -1)), this.writtenTo = this.pos;
  }
  blankContent(e, t) {
    let r = new lt(t - e);
    return this.oracle.doc.lineAt(e).to == t && (r.flags |= 4), r;
  }
  ensureLine() {
    this.enterLine();
    let e = this.nodes.length ? this.nodes[this.nodes.length - 1] : null;
    if (e instanceof It)
      return e;
    let t = new It(0, -1);
    return this.nodes.push(t), t;
  }
  addBlock(e) {
    this.enterLine();
    let t = e.deco;
    t && t.startSide > 0 && !this.isCovered && this.ensureLine(), this.nodes.push(e), this.writtenTo = this.pos = this.pos + e.length, t && t.endSide > 0 && (this.covering = e);
  }
  addLineDeco(e, t, r) {
    let i = this.ensureLine();
    i.length += r, i.collapsed += r, i.widgetHeight = Math.max(i.widgetHeight, e), i.breaks += t, this.writtenTo = this.pos = this.pos + r;
  }
  finish(e) {
    let t = this.nodes.length == 0 ? null : this.nodes[this.nodes.length - 1];
    this.lineStart > -1 && !(t instanceof It) && !this.isCovered ? this.nodes.push(new It(0, -1)) : (this.writtenTo < this.pos || t == null) && this.nodes.push(this.blankContent(this.writtenTo, this.pos));
    let r = e;
    for (let i of this.nodes)
      i instanceof It && i.updateHeight(this.oracle, r), r += i ? i.length : 1;
    return this.nodes;
  }
  // Always called with a region that on both sides either stretches
  // to a line break or the end of the document.
  // The returned array uses null to indicate line breaks, but never
  // starts or ends in a line break, or has multiple line breaks next
  // to each other.
  static build(e, t, r, i) {
    let s = new fh(r, e);
    return Ce.spans(t, r, i, s, 0), s.finish(r);
  }
}
function r6(n, e, t) {
  let r = new n6();
  return Ce.compare(n, e, t, r, 0), r.changes;
}
class n6 {
  constructor() {
    this.changes = [];
  }
  compareRange() {
  }
  comparePoint(e, t, r, i) {
    (e < t || r && r.heightRelevant || i && i.heightRelevant) && au(e, t, this.changes, 5);
  }
}
function i6(n, e) {
  let t = n.getBoundingClientRect(), r = n.ownerDocument, i = r.defaultView || window, s = Math.max(0, t.left), l = Math.min(i.innerWidth, t.right), o = Math.max(0, t.top), a = Math.min(i.innerHeight, t.bottom);
  for (let u = n.parentNode; u && u != r.body; )
    if (u.nodeType == 1) {
      let h = u, c = window.getComputedStyle(h);
      if ((h.scrollHeight > h.clientHeight || h.scrollWidth > h.clientWidth) && c.overflow != "visible") {
        let f = h.getBoundingClientRect();
        s = Math.max(s, f.left), l = Math.min(l, f.right), o = Math.max(o, f.top), a = Math.min(u == n.parentNode ? i.innerHeight : a, f.bottom);
      }
      u = c.position == "absolute" || c.position == "fixed" ? h.offsetParent : h.parentNode;
    } else if (u.nodeType == 11)
      u = u.host;
    else
      break;
  return {
    left: s - t.left,
    right: Math.max(s, l) - t.left,
    top: o - (t.top + e),
    bottom: Math.max(o, a) - (t.top + e)
  };
}
function s6(n, e) {
  let t = n.getBoundingClientRect();
  return {
    left: 0,
    right: t.right - t.left,
    top: e,
    bottom: t.bottom - (t.top + e)
  };
}
class Ia {
  constructor(e, t, r, i) {
    this.from = e, this.to = t, this.size = r, this.displaySize = i;
  }
  static same(e, t) {
    if (e.length != t.length)
      return !1;
    for (let r = 0; r < e.length; r++) {
      let i = e[r], s = t[r];
      if (i.from != s.from || i.to != s.to || i.size != s.size)
        return !1;
    }
    return !0;
  }
  draw(e, t) {
    return be.replace({
      widget: new l6(this.displaySize * (t ? e.scaleY : e.scaleX), t)
    }).range(this.from, this.to);
  }
}
class l6 extends Xr {
  constructor(e, t) {
    super(), this.size = e, this.vertical = t;
  }
  eq(e) {
    return e.size == this.size && e.vertical == this.vertical;
  }
  toDOM() {
    let e = document.createElement("div");
    return this.vertical ? e.style.height = this.size + "px" : (e.style.width = this.size + "px", e.style.height = "2px", e.style.display = "inline-block"), e;
  }
  get estimatedHeight() {
    return this.vertical ? this.size : -1;
  }
}
class xf {
  constructor(e) {
    this.state = e, this.pixelViewport = { left: 0, right: window.innerWidth, top: 0, bottom: 0 }, this.inView = !0, this.paddingTop = 0, this.paddingBottom = 0, this.contentDOMWidth = 0, this.contentDOMHeight = 0, this.editorHeight = 0, this.editorWidth = 0, this.scrollTop = 0, this.scrolledToBottom = !1, this.scaleX = 1, this.scaleY = 1, this.scrollAnchorPos = 0, this.scrollAnchorHeight = -1, this.scaler = Sf, this.scrollTarget = null, this.printing = !1, this.mustMeasureContent = !0, this.defaultTextDirection = Ie.LTR, this.visibleRanges = [], this.mustEnforceCursorAssoc = !1;
    let t = e.facet(uh).some((r) => typeof r != "function" && r.class == "cm-lineWrapping");
    this.heightOracle = new J3(t), this.stateDeco = e.facet(Xs).filter((r) => typeof r != "function"), this.heightMap = At.empty().applyChanges(this.stateDeco, Ae.empty, this.heightOracle.setDoc(e.doc), [new nr(0, 0, 0, e.doc.length)]);
    for (let r = 0; r < 2 && (this.viewport = this.getViewport(0, null), !!this.updateForViewport()); r++)
      ;
    this.updateViewportLines(), this.lineGaps = this.ensureLineGaps([]), this.lineGapDeco = be.set(this.lineGaps.map((r) => r.draw(this, !1))), this.computeVisibleRanges();
  }
  updateForViewport() {
    let e = [this.viewport], { main: t } = this.state.selection;
    for (let r = 0; r <= 1; r++) {
      let i = r ? t.head : t.anchor;
      if (!e.some(({ from: s, to: l }) => i >= s && i <= l)) {
        let { from: s, to: l } = this.lineBlockAt(i);
        e.push(new Tl(s, l));
      }
    }
    return this.viewports = e.sort((r, i) => r.from - i.from), this.updateScaler();
  }
  updateScaler() {
    let e = this.scaler;
    return this.scaler = this.heightMap.height <= 7e6 ? Sf : new dh(this.heightOracle, this.heightMap, this.viewports), e.eq(this.scaler) ? 0 : 2;
  }
  updateViewportLines() {
    this.viewportLines = [], this.heightMap.forEachLine(this.viewport.from, this.viewport.to, this.heightOracle.setDoc(this.state.doc), 0, 0, (e) => {
      this.viewportLines.push(Fs(e, this.scaler));
    });
  }
  update(e, t = null) {
    this.state = e.state;
    let r = this.stateDeco;
    this.stateDeco = this.state.facet(Xs).filter((h) => typeof h != "function");
    let i = e.changedRanges, s = nr.extendWithRanges(i, r6(r, this.stateDeco, e ? e.changes : tt.empty(this.state.doc.length))), l = this.heightMap.height, o = this.scrolledToBottom ? null : this.scrollAnchorAt(this.scrollTop);
    wf(), this.heightMap = this.heightMap.applyChanges(this.stateDeco, e.startState.doc, this.heightOracle.setDoc(this.state.doc), s), (this.heightMap.height != l || Yi) && (e.flags |= 2), o ? (this.scrollAnchorPos = e.changes.mapPos(o.from, -1), this.scrollAnchorHeight = o.top) : (this.scrollAnchorPos = -1, this.scrollAnchorHeight = this.heightMap.height);
    let a = s.length ? this.mapViewport(this.viewport, e.changes) : this.viewport;
    (t && (t.range.head < a.from || t.range.head > a.to) || !this.viewportIsAppropriate(a)) && (a = this.getViewport(0, t));
    let u = a.from != this.viewport.from || a.to != this.viewport.to;
    this.viewport = a, e.flags |= this.updateForViewport(), (u || !e.changes.empty || e.flags & 2) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps, e.changes))), e.flags |= this.computeVisibleRanges(), t && (this.scrollTarget = t), !this.mustEnforceCursorAssoc && e.selectionSet && e.view.lineWrapping && e.state.selection.main.empty && e.state.selection.main.assoc && !e.state.facet(Lp) && (this.mustEnforceCursorAssoc = !0);
  }
  measure(e) {
    let t = e.contentDOM, r = window.getComputedStyle(t), i = this.heightOracle, s = r.whiteSpace;
    this.defaultTextDirection = r.direction == "rtl" ? Ie.RTL : Ie.LTR;
    let l = this.heightOracle.mustRefreshForWrapping(s), o = t.getBoundingClientRect(), a = l || this.mustMeasureContent || this.contentDOMHeight != o.height;
    this.contentDOMHeight = o.height, this.mustMeasureContent = !1;
    let u = 0, h = 0;
    if (o.width && o.height) {
      let { scaleX: A, scaleY: C } = ap(t, o);
      (A > 5e-3 && Math.abs(this.scaleX - A) > 5e-3 || C > 5e-3 && Math.abs(this.scaleY - C) > 5e-3) && (this.scaleX = A, this.scaleY = C, u |= 8, l = a = !0);
    }
    let c = (parseInt(r.paddingTop) || 0) * this.scaleY, f = (parseInt(r.paddingBottom) || 0) * this.scaleY;
    (this.paddingTop != c || this.paddingBottom != f) && (this.paddingTop = c, this.paddingBottom = f, u |= 10), this.editorWidth != e.scrollDOM.clientWidth && (i.lineWrapping && (a = !0), this.editorWidth = e.scrollDOM.clientWidth, u |= 8);
    let m = e.scrollDOM.scrollTop * this.scaleY;
    this.scrollTop != m && (this.scrollAnchorHeight = -1, this.scrollTop = m), this.scrolledToBottom = cp(e.scrollDOM);
    let g = (this.printing ? s6 : i6)(t, this.paddingTop), v = g.top - this.pixelViewport.top, k = g.bottom - this.pixelViewport.bottom;
    this.pixelViewport = g;
    let S = this.pixelViewport.bottom > this.pixelViewport.top && this.pixelViewport.right > this.pixelViewport.left;
    if (S != this.inView && (this.inView = S, S && (a = !0)), !this.inView && !this.scrollTarget)
      return 0;
    let x = o.width;
    if ((this.contentDOMWidth != x || this.editorHeight != e.scrollDOM.clientHeight) && (this.contentDOMWidth = o.width, this.editorHeight = e.scrollDOM.clientHeight, u |= 8), a) {
      let A = e.docView.measureVisibleLineHeights(this.viewport);
      if (i.mustRefreshForHeights(A) && (l = !0), l || i.lineWrapping && Math.abs(x - this.contentDOMWidth) > i.charWidth) {
        let { lineHeight: C, charWidth: T, textHeight: M } = e.docView.measureTextSize();
        l = C > 0 && i.refresh(s, C, T, M, x / T, A), l && (e.docView.minWidth = 0, u |= 8);
      }
      v > 0 && k > 0 ? h = Math.max(v, k) : v < 0 && k < 0 && (h = Math.min(v, k)), wf();
      for (let C of this.viewports) {
        let T = C.from == this.viewport.from ? A : e.docView.measureVisibleLineHeights(C);
        this.heightMap = (l ? At.empty().applyChanges(this.stateDeco, Ae.empty, this.heightOracle, [new nr(0, 0, 0, e.state.doc.length)]) : this.heightMap).updateHeight(i, 0, l, new Q3(C.from, T));
      }
      Yi && (u |= 2);
    }
    let y = !this.viewportIsAppropriate(this.viewport, h) || this.scrollTarget && (this.scrollTarget.range.head < this.viewport.from || this.scrollTarget.range.head > this.viewport.to);
    return y && (u & 2 && (u |= this.updateScaler()), this.viewport = this.getViewport(h, this.scrollTarget), u |= this.updateForViewport()), (u & 2 || y) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(l ? [] : this.lineGaps, e)), u |= this.computeVisibleRanges(), this.mustEnforceCursorAssoc && (this.mustEnforceCursorAssoc = !1, e.docView.enforceCursorAssoc()), u;
  }
  get visibleTop() {
    return this.scaler.fromDOM(this.pixelViewport.top);
  }
  get visibleBottom() {
    return this.scaler.fromDOM(this.pixelViewport.bottom);
  }
  getViewport(e, t) {
    let r = 0.5 - Math.max(-0.5, Math.min(0.5, e / 1e3 / 2)), i = this.heightMap, s = this.heightOracle, { visibleTop: l, visibleBottom: o } = this, a = new Tl(i.lineAt(l - r * 1e3, Ne.ByHeight, s, 0, 0).from, i.lineAt(o + (1 - r) * 1e3, Ne.ByHeight, s, 0, 0).to);
    if (t) {
      let { head: u } = t.range;
      if (u < a.from || u > a.to) {
        let h = Math.min(this.editorHeight, this.pixelViewport.bottom - this.pixelViewport.top), c = i.lineAt(u, Ne.ByPos, s, 0, 0), f;
        t.y == "center" ? f = (c.top + c.bottom) / 2 - h / 2 : t.y == "start" || t.y == "nearest" && u < a.from ? f = c.top : f = c.bottom - h, a = new Tl(i.lineAt(f - 1e3 / 2, Ne.ByHeight, s, 0, 0).from, i.lineAt(f + h + 1e3 / 2, Ne.ByHeight, s, 0, 0).to);
      }
    }
    return a;
  }
  mapViewport(e, t) {
    let r = t.mapPos(e.from, -1), i = t.mapPos(e.to, 1);
    return new Tl(this.heightMap.lineAt(r, Ne.ByPos, this.heightOracle, 0, 0).from, this.heightMap.lineAt(i, Ne.ByPos, this.heightOracle, 0, 0).to);
  }
  // Checks if a given viewport covers the visible part of the
  // document and not too much beyond that.
  viewportIsAppropriate({ from: e, to: t }, r = 0) {
    if (!this.inView)
      return !0;
    let { top: i } = this.heightMap.lineAt(e, Ne.ByPos, this.heightOracle, 0, 0), { bottom: s } = this.heightMap.lineAt(t, Ne.ByPos, this.heightOracle, 0, 0), { visibleTop: l, visibleBottom: o } = this;
    return (e == 0 || i <= l - Math.max(10, Math.min(
      -r,
      250
      /* VP.MaxCoverMargin */
    ))) && (t == this.state.doc.length || s >= o + Math.max(10, Math.min(
      r,
      250
      /* VP.MaxCoverMargin */
    ))) && i > l - 2 * 1e3 && s < o + 2 * 1e3;
  }
  mapLineGaps(e, t) {
    if (!e.length || t.empty)
      return e;
    let r = [];
    for (let i of e)
      t.touchesRange(i.from, i.to) || r.push(new Ia(t.mapPos(i.from), t.mapPos(i.to), i.size, i.displaySize));
    return r;
  }
  // Computes positions in the viewport where the start or end of a
  // line should be hidden, trying to reuse existing line gaps when
  // appropriate to avoid unneccesary redraws.
  // Uses crude character-counting for the positioning and sizing,
  // since actual DOM coordinates aren't always available and
  // predictable. Relies on generous margins (see LG.Margin) to hide
  // the artifacts this might produce from the user.
  ensureLineGaps(e, t) {
    let r = this.heightOracle.lineWrapping, i = r ? 1e4 : 2e3, s = i >> 1, l = i << 1;
    if (this.defaultTextDirection != Ie.LTR && !r)
      return [];
    let o = [], a = (h, c, f, m) => {
      if (c - h < s)
        return;
      let g = this.state.selection.main, v = [g.from];
      g.empty || v.push(g.to);
      for (let S of v)
        if (S > h && S < c) {
          a(h, S - 10, f, m), a(S + 10, c, f, m);
          return;
        }
      let k = a6(e, (S) => S.from >= f.from && S.to <= f.to && Math.abs(S.from - h) < s && Math.abs(S.to - c) < s && !v.some((x) => S.from < x && S.to > x));
      if (!k) {
        if (c < f.to && t && r && t.visibleRanges.some((y) => y.from <= c && y.to >= c)) {
          let y = t.moveToLineBoundary(I.cursor(c), !1, !0).head;
          y > h && (c = y);
        }
        let S = this.gapSize(f, h, c, m), x = r || S < 2e6 ? S : 2e6;
        k = new Ia(h, c, S, x);
      }
      o.push(k);
    }, u = (h) => {
      if (h.length < l || h.type != St.Text)
        return;
      let c = o6(h.from, h.to, this.stateDeco);
      if (c.total < l)
        return;
      let f = this.scrollTarget ? this.scrollTarget.range.head : null, m, g;
      if (r) {
        let v = i / this.heightOracle.lineLength * this.heightOracle.lineHeight, k, S;
        if (f != null) {
          let x = Fl(c, f), y = ((this.visibleBottom - this.visibleTop) / 2 + v) / h.height;
          k = x - y, S = x + y;
        } else
          k = (this.visibleTop - h.top - v) / h.height, S = (this.visibleBottom - h.top + v) / h.height;
        m = El(c, k), g = El(c, S);
      } else {
        let v = c.total * this.heightOracle.charWidth, k = i * this.heightOracle.charWidth, S = 0;
        if (v > 2e6)
          for (let T of e)
            T.from >= h.from && T.from < h.to && T.size != T.displaySize && T.from * this.heightOracle.charWidth + S < this.pixelViewport.left && (S = T.size - T.displaySize);
        let x = this.pixelViewport.left + S, y = this.pixelViewport.right + S, A, C;
        if (f != null) {
          let T = Fl(c, f), M = ((y - x) / 2 + k) / v;
          A = T - M, C = T + M;
        } else
          A = (x - k) / v, C = (y + k) / v;
        m = El(c, A), g = El(c, C);
      }
      m > h.from && a(h.from, m, h, c), g < h.to && a(g, h.to, h, c);
    };
    for (let h of this.viewportLines)
      Array.isArray(h.type) ? h.type.forEach(u) : u(h);
    return o;
  }
  gapSize(e, t, r, i) {
    let s = Fl(i, r) - Fl(i, t);
    return this.heightOracle.lineWrapping ? e.height * s : i.total * this.heightOracle.charWidth * s;
  }
  updateLineGaps(e) {
    Ia.same(e, this.lineGaps) || (this.lineGaps = e, this.lineGapDeco = be.set(e.map((t) => t.draw(this, this.heightOracle.lineWrapping))));
  }
  computeVisibleRanges() {
    let e = this.stateDeco;
    this.lineGaps.length && (e = e.concat(this.lineGapDeco));
    let t = [];
    Ce.spans(e, this.viewport.from, this.viewport.to, {
      span(i, s) {
        t.push({ from: i, to: s });
      },
      point() {
      }
    }, 20);
    let r = t.length != this.visibleRanges.length || this.visibleRanges.some((i, s) => i.from != t[s].from || i.to != t[s].to);
    return this.visibleRanges = t, r ? 4 : 0;
  }
  lineBlockAt(e) {
    return e >= this.viewport.from && e <= this.viewport.to && this.viewportLines.find((t) => t.from <= e && t.to >= e) || Fs(this.heightMap.lineAt(e, Ne.ByPos, this.heightOracle, 0, 0), this.scaler);
  }
  lineBlockAtHeight(e) {
    return e >= this.viewportLines[0].top && e <= this.viewportLines[this.viewportLines.length - 1].bottom && this.viewportLines.find((t) => t.top <= e && t.bottom >= e) || Fs(this.heightMap.lineAt(this.scaler.fromDOM(e), Ne.ByHeight, this.heightOracle, 0, 0), this.scaler);
  }
  scrollAnchorAt(e) {
    let t = this.lineBlockAtHeight(e + 8);
    return t.from >= this.viewport.from || this.viewportLines[0].top - e > 200 ? t : this.viewportLines[0];
  }
  elementAtHeight(e) {
    return Fs(this.heightMap.blockAt(this.scaler.fromDOM(e), this.heightOracle, 0, 0), this.scaler);
  }
  get docHeight() {
    return this.scaler.toDOM(this.heightMap.height);
  }
  get contentHeight() {
    return this.docHeight + this.paddingTop + this.paddingBottom;
  }
}
class Tl {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
function o6(n, e, t) {
  let r = [], i = n, s = 0;
  return Ce.spans(t, n, e, {
    span() {
    },
    point(l, o) {
      l > i && (r.push({ from: i, to: l }), s += l - i), i = o;
    }
  }, 20), i < e && (r.push({ from: i, to: e }), s += e - i), { total: s, ranges: r };
}
function El({ total: n, ranges: e }, t) {
  if (t <= 0)
    return e[0].from;
  if (t >= 1)
    return e[e.length - 1].to;
  let r = Math.floor(n * t);
  for (let i = 0; ; i++) {
    let { from: s, to: l } = e[i], o = l - s;
    if (r <= o)
      return s + r;
    r -= o;
  }
}
function Fl(n, e) {
  let t = 0;
  for (let { from: r, to: i } of n.ranges) {
    if (e <= i) {
      t += e - r;
      break;
    }
    t += i - r;
  }
  return t / n.total;
}
function a6(n, e) {
  for (let t of n)
    if (e(t))
      return t;
}
const Sf = {
  toDOM(n) {
    return n;
  },
  fromDOM(n) {
    return n;
  },
  scale: 1,
  eq(n) {
    return n == this;
  }
};
class dh {
  constructor(e, t, r) {
    let i = 0, s = 0, l = 0;
    this.viewports = r.map(({ from: o, to: a }) => {
      let u = t.lineAt(o, Ne.ByPos, e, 0, 0).top, h = t.lineAt(a, Ne.ByPos, e, 0, 0).bottom;
      return i += h - u, { from: o, to: a, top: u, bottom: h, domTop: 0, domBottom: 0 };
    }), this.scale = (7e6 - i) / (t.height - i);
    for (let o of this.viewports)
      o.domTop = l + (o.top - s) * this.scale, l = o.domBottom = o.domTop + (o.bottom - o.top), s = o.bottom;
  }
  toDOM(e) {
    for (let t = 0, r = 0, i = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.top)
        return i + (e - r) * this.scale;
      if (e <= s.bottom)
        return s.domTop + (e - s.top);
      r = s.bottom, i = s.domBottom;
    }
  }
  fromDOM(e) {
    for (let t = 0, r = 0, i = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.domTop)
        return r + (e - i) / this.scale;
      if (e <= s.domBottom)
        return s.top + (e - s.domTop);
      r = s.bottom, i = s.domBottom;
    }
  }
  eq(e) {
    return e instanceof dh ? this.scale == e.scale && this.viewports.length == e.viewports.length && this.viewports.every((t, r) => t.from == e.viewports[r].from && t.to == e.viewports[r].to) : !1;
  }
}
function Fs(n, e) {
  if (e.scale == 1)
    return n;
  let t = e.toDOM(n.top), r = e.toDOM(n.bottom);
  return new Nr(n.from, n.length, t, r - t, Array.isArray(n._content) ? n._content.map((i) => Fs(i, e)) : n._content);
}
const Bl = /* @__PURE__ */ X.define({ combine: (n) => n.join(" ") }), bu = /* @__PURE__ */ X.define({ combine: (n) => n.indexOf(!0) > -1 }), vu = /* @__PURE__ */ On.newName(), tg = /* @__PURE__ */ On.newName(), rg = /* @__PURE__ */ On.newName(), ng = { "&light": "." + tg, "&dark": "." + rg };
function yu(n, e, t) {
  return new On(e, {
    finish(r) {
      return /&/.test(r) ? r.replace(/&\w*/, (i) => {
        if (i == "&")
          return n;
        if (!t || !t[i])
          throw new RangeError(`Unsupported selector: ${i}`);
        return t[i];
      }) : n + " " + r;
    }
  });
}
const u6 = /* @__PURE__ */ yu("." + vu, {
  "&": {
    position: "relative !important",
    boxSizing: "border-box",
    "&.cm-focused": {
      // Provide a simple default outline to make sure a focused
      // editor is visually distinct. Can't leave the default behavior
      // because that will apply to the content element, which is
      // inside the scrollable container and doesn't include the
      // gutters. We also can't use an 'auto' outline, since those
      // are, for some reason, drawn behind the element content, which
      // will cause things like the active line background to cover
      // the outline (#297).
      outline: "1px dotted #212121"
    },
    display: "flex !important",
    flexDirection: "column"
  },
  ".cm-scroller": {
    display: "flex !important",
    alignItems: "flex-start !important",
    fontFamily: "monospace",
    lineHeight: 1.4,
    height: "100%",
    overflowX: "auto",
    position: "relative",
    zIndex: 0,
    overflowAnchor: "none"
  },
  ".cm-content": {
    margin: 0,
    flexGrow: 2,
    flexShrink: 0,
    display: "block",
    whiteSpace: "pre",
    wordWrap: "normal",
    // https://github.com/codemirror/dev/issues/456
    boxSizing: "border-box",
    minHeight: "100%",
    padding: "4px 0",
    outline: "none",
    "&[contenteditable=true]": {
      WebkitUserModify: "read-write-plaintext-only"
    }
  },
  ".cm-lineWrapping": {
    whiteSpace_fallback: "pre-wrap",
    // For IE
    whiteSpace: "break-spaces",
    wordBreak: "break-word",
    // For Safari, which doesn't support overflow-wrap: anywhere
    overflowWrap: "anywhere",
    flexShrink: 1
  },
  "&light .cm-content": { caretColor: "black" },
  "&dark .cm-content": { caretColor: "white" },
  ".cm-line": {
    display: "block",
    padding: "0 2px 0 6px"
  },
  ".cm-layer": {
    position: "absolute",
    left: 0,
    top: 0,
    contain: "size style",
    "& > *": {
      position: "absolute"
    }
  },
  "&light .cm-selectionBackground": {
    background: "#d9d9d9"
  },
  "&dark .cm-selectionBackground": {
    background: "#222"
  },
  "&light.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#d7d4f0"
  },
  "&dark.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#233"
  },
  ".cm-cursorLayer": {
    pointerEvents: "none"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer": {
    animation: "steps(1) cm-blink 1.2s infinite"
  },
  // Two animations defined so that we can switch between them to
  // restart the animation without forcing another style
  // recomputation.
  "@keyframes cm-blink": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  "@keyframes cm-blink2": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  ".cm-cursor, .cm-dropCursor": {
    borderLeft: "1.2px solid black",
    marginLeft: "-0.6px",
    pointerEvents: "none"
  },
  ".cm-cursor": {
    display: "none"
  },
  "&dark .cm-cursor": {
    borderLeftColor: "#444"
  },
  ".cm-dropCursor": {
    position: "absolute"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer .cm-cursor": {
    display: "block"
  },
  ".cm-iso": {
    unicodeBidi: "isolate"
  },
  ".cm-announced": {
    position: "fixed",
    top: "-10000px"
  },
  "@media print": {
    ".cm-announced": { display: "none" }
  },
  "&light .cm-activeLine": { backgroundColor: "#cceeff44" },
  "&dark .cm-activeLine": { backgroundColor: "#99eeff33" },
  "&light .cm-specialChar": { color: "red" },
  "&dark .cm-specialChar": { color: "#f78" },
  ".cm-gutters": {
    flexShrink: 0,
    display: "flex",
    height: "100%",
    boxSizing: "border-box",
    insetInlineStart: 0,
    zIndex: 200
  },
  "&light .cm-gutters": {
    backgroundColor: "#f5f5f5",
    color: "#6c6c6c",
    borderRight: "1px solid #ddd"
  },
  "&dark .cm-gutters": {
    backgroundColor: "#333338",
    color: "#ccc"
  },
  ".cm-gutter": {
    display: "flex !important",
    // Necessary -- prevents margin collapsing
    flexDirection: "column",
    flexShrink: 0,
    boxSizing: "border-box",
    minHeight: "100%",
    overflow: "hidden"
  },
  ".cm-gutterElement": {
    boxSizing: "border-box"
  },
  ".cm-lineNumbers .cm-gutterElement": {
    padding: "0 3px 0 5px",
    minWidth: "20px",
    textAlign: "right",
    whiteSpace: "nowrap"
  },
  "&light .cm-activeLineGutter": {
    backgroundColor: "#e2f2ff"
  },
  "&dark .cm-activeLineGutter": {
    backgroundColor: "#222227"
  },
  ".cm-panels": {
    boxSizing: "border-box",
    position: "sticky",
    left: 0,
    right: 0,
    zIndex: 300
  },
  "&light .cm-panels": {
    backgroundColor: "#f5f5f5",
    color: "black"
  },
  "&light .cm-panels-top": {
    borderBottom: "1px solid #ddd"
  },
  "&light .cm-panels-bottom": {
    borderTop: "1px solid #ddd"
  },
  "&dark .cm-panels": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tab": {
    display: "inline-block",
    overflow: "hidden",
    verticalAlign: "bottom"
  },
  ".cm-widgetBuffer": {
    verticalAlign: "text-top",
    height: "1em",
    width: 0,
    display: "inline"
  },
  ".cm-placeholder": {
    color: "#888",
    display: "inline-block",
    verticalAlign: "top"
  },
  ".cm-highlightSpace": {
    backgroundImage: "radial-gradient(circle at 50% 55%, #aaa 20%, transparent 5%)",
    backgroundPosition: "center"
  },
  ".cm-highlightTab": {
    backgroundImage: `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="200" height="20"><path stroke="%23888" stroke-width="1" fill="none" d="M1 10H196L190 5M190 15L196 10M197 4L197 16"/></svg>')`,
    backgroundSize: "auto 100%",
    backgroundPosition: "right 90%",
    backgroundRepeat: "no-repeat"
  },
  ".cm-trailingSpace": {
    backgroundColor: "#ff332255"
  },
  ".cm-button": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    padding: ".2em 1em",
    borderRadius: "1px"
  },
  "&light .cm-button": {
    backgroundImage: "linear-gradient(#eff1f5, #d9d9df)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#b4b4b4, #d0d3d6)"
    }
  },
  "&dark .cm-button": {
    backgroundImage: "linear-gradient(#393939, #111)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#111, #333)"
    }
  },
  ".cm-textfield": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    border: "1px solid silver",
    padding: ".2em .5em"
  },
  "&light .cm-textfield": {
    backgroundColor: "white"
  },
  "&dark .cm-textfield": {
    border: "1px solid #555",
    backgroundColor: "inherit"
  }
}, ng), h6 = {
  childList: !0,
  characterData: !0,
  subtree: !0,
  attributes: !0,
  characterDataOldValue: !0
}, za = K.ie && K.ie_version <= 11;
class c6 {
  constructor(e) {
    this.view = e, this.active = !1, this.editContext = null, this.selectionRange = new K5(), this.selectionChanged = !1, this.delayedFlush = -1, this.resizeTimeout = -1, this.queue = [], this.delayedAndroidKey = null, this.flushingAndroidKey = -1, this.lastChange = 0, this.scrollTargets = [], this.intersection = null, this.resizeScroll = null, this.intersecting = !1, this.gapIntersection = null, this.gaps = [], this.printQuery = null, this.parentCheck = -1, this.dom = e.contentDOM, this.observer = new MutationObserver((t) => {
      for (let r of t)
        this.queue.push(r);
      (K.ie && K.ie_version <= 11 || K.ios && e.composing) && t.some((r) => r.type == "childList" && r.removedNodes.length || r.type == "characterData" && r.oldValue.length > r.target.nodeValue.length) ? this.flushSoon() : this.flush();
    }), window.EditContext && e.constructor.EDIT_CONTEXT !== !1 && // Chrome <126 doesn't support inverted selections in edit context (#1392)
    !(K.chrome && K.chrome_version < 126) && (this.editContext = new d6(e), e.state.facet(_n) && (e.contentDOM.editContext = this.editContext.editContext)), za && (this.onCharData = (t) => {
      this.queue.push({
        target: t.target,
        type: "characterData",
        oldValue: t.prevValue
      }), this.flushSoon();
    }), this.onSelectionChange = this.onSelectionChange.bind(this), this.onResize = this.onResize.bind(this), this.onPrint = this.onPrint.bind(this), this.onScroll = this.onScroll.bind(this), window.matchMedia && (this.printQuery = window.matchMedia("print")), typeof ResizeObserver == "function" && (this.resizeScroll = new ResizeObserver(() => {
      var t;
      ((t = this.view.docView) === null || t === void 0 ? void 0 : t.lastUpdate) < Date.now() - 75 && this.onResize();
    }), this.resizeScroll.observe(e.scrollDOM)), this.addWindowListeners(this.win = e.win), this.start(), typeof IntersectionObserver == "function" && (this.intersection = new IntersectionObserver((t) => {
      this.parentCheck < 0 && (this.parentCheck = setTimeout(this.listenForScroll.bind(this), 1e3)), t.length > 0 && t[t.length - 1].intersectionRatio > 0 != this.intersecting && (this.intersecting = !this.intersecting, this.intersecting != this.view.inView && this.onScrollChanged(document.createEvent("Event")));
    }, { threshold: [0, 1e-3] }), this.intersection.observe(this.dom), this.gapIntersection = new IntersectionObserver((t) => {
      t.length > 0 && t[t.length - 1].intersectionRatio > 0 && this.onScrollChanged(document.createEvent("Event"));
    }, {})), this.listenForScroll(), this.readSelectionRange();
  }
  onScrollChanged(e) {
    this.view.inputState.runHandlers("scroll", e), this.intersecting && this.view.measure();
  }
  onScroll(e) {
    this.intersecting && this.flush(!1), this.editContext && this.view.requestMeasure(this.editContext.measureReq), this.onScrollChanged(e);
  }
  onResize() {
    this.resizeTimeout < 0 && (this.resizeTimeout = setTimeout(() => {
      this.resizeTimeout = -1, this.view.requestMeasure();
    }, 50));
  }
  onPrint(e) {
    (e.type == "change" || !e.type) && !e.matches || (this.view.viewState.printing = !0, this.view.measure(), setTimeout(() => {
      this.view.viewState.printing = !1, this.view.requestMeasure();
    }, 500));
  }
  updateGaps(e) {
    if (this.gapIntersection && (e.length != this.gaps.length || this.gaps.some((t, r) => t != e[r]))) {
      this.gapIntersection.disconnect();
      for (let t of e)
        this.gapIntersection.observe(t);
      this.gaps = e;
    }
  }
  onSelectionChange(e) {
    let t = this.selectionChanged;
    if (!this.readSelectionRange() || this.delayedAndroidKey)
      return;
    let { view: r } = this, i = this.selectionRange;
    if (r.state.facet(_n) ? r.root.activeElement != this.dom : !mo(this.dom, i))
      return;
    let s = i.anchorNode && r.docView.nearest(i.anchorNode);
    if (s && s.ignoreEvent(e)) {
      t || (this.selectionChanged = !1);
      return;
    }
    (K.ie && K.ie_version <= 11 || K.android && K.chrome) && !r.state.selection.main.empty && // (Selection.isCollapsed isn't reliable on IE)
    i.focusNode && Ns(i.focusNode, i.focusOffset, i.anchorNode, i.anchorOffset) ? this.flushSoon() : this.flush(!1);
  }
  readSelectionRange() {
    let { view: e } = this, t = Ks(e.root);
    if (!t)
      return !1;
    let r = K.safari && e.root.nodeType == 11 && e.root.activeElement == this.dom && f6(this.view, t) || t;
    if (!r || this.selectionRange.eq(r))
      return !1;
    let i = mo(this.dom, r);
    return i && !this.selectionChanged && e.inputState.lastFocusTime > Date.now() - 200 && e.inputState.lastTouchTime < Date.now() - 300 && Z5(this.dom, r) ? (this.view.inputState.lastFocusTime = 0, e.docView.updateSelection(), !1) : (this.selectionRange.setRange(r), i && (this.selectionChanged = !0), !0);
  }
  setSelectionRange(e, t) {
    this.selectionRange.set(e.node, e.offset, t.node, t.offset), this.selectionChanged = !1;
  }
  clearSelectionRange() {
    this.selectionRange.set(null, 0, null, 0);
  }
  listenForScroll() {
    this.parentCheck = -1;
    let e = 0, t = null;
    for (let r = this.dom; r; )
      if (r.nodeType == 1)
        !t && e < this.scrollTargets.length && this.scrollTargets[e] == r ? e++ : t || (t = this.scrollTargets.slice(0, e)), t && t.push(r), r = r.assignedSlot || r.parentNode;
      else if (r.nodeType == 11)
        r = r.host;
      else
        break;
    if (e < this.scrollTargets.length && !t && (t = this.scrollTargets.slice(0, e)), t) {
      for (let r of this.scrollTargets)
        r.removeEventListener("scroll", this.onScroll);
      for (let r of this.scrollTargets = t)
        r.addEventListener("scroll", this.onScroll);
    }
  }
  ignore(e) {
    if (!this.active)
      return e();
    try {
      return this.stop(), e();
    } finally {
      this.start(), this.clear();
    }
  }
  start() {
    this.active || (this.observer.observe(this.dom, h6), za && this.dom.addEventListener("DOMCharacterDataModified", this.onCharData), this.active = !0);
  }
  stop() {
    this.active && (this.active = !1, this.observer.disconnect(), za && this.dom.removeEventListener("DOMCharacterDataModified", this.onCharData));
  }
  // Throw away any pending changes
  clear() {
    this.processRecords(), this.queue.length = 0, this.selectionChanged = !1;
  }
  // Chrome Android, especially in combination with GBoard, not only
  // doesn't reliably fire regular key events, but also often
  // surrounds the effect of enter or backspace with a bunch of
  // composition events that, when interrupted, cause text duplication
  // or other kinds of corruption. This hack makes the editor back off
  // from handling DOM changes for a moment when such a key is
  // detected (via beforeinput or keydown), and then tries to flush
  // them or, if that has no effect, dispatches the given key.
  delayAndroidKey(e, t) {
    var r;
    if (!this.delayedAndroidKey) {
      let i = () => {
        let s = this.delayedAndroidKey;
        s && (this.clearDelayedAndroidKey(), this.view.inputState.lastKeyCode = s.keyCode, this.view.inputState.lastKeyTime = Date.now(), !this.flush() && s.force && Pi(this.dom, s.key, s.keyCode));
      };
      this.flushingAndroidKey = this.view.win.requestAnimationFrame(i);
    }
    (!this.delayedAndroidKey || e == "Enter") && (this.delayedAndroidKey = {
      key: e,
      keyCode: t,
      // Only run the key handler when no changes are detected if
      // this isn't coming right after another change, in which case
      // it is probably part of a weird chain of updates, and should
      // be ignored if it returns the DOM to its previous state.
      force: this.lastChange < Date.now() - 50 || !!(!((r = this.delayedAndroidKey) === null || r === void 0) && r.force)
    });
  }
  clearDelayedAndroidKey() {
    this.win.cancelAnimationFrame(this.flushingAndroidKey), this.delayedAndroidKey = null, this.flushingAndroidKey = -1;
  }
  flushSoon() {
    this.delayedFlush < 0 && (this.delayedFlush = this.view.win.requestAnimationFrame(() => {
      this.delayedFlush = -1, this.flush();
    }));
  }
  forceFlush() {
    this.delayedFlush >= 0 && (this.view.win.cancelAnimationFrame(this.delayedFlush), this.delayedFlush = -1), this.flush();
  }
  pendingRecords() {
    for (let e of this.observer.takeRecords())
      this.queue.push(e);
    return this.queue;
  }
  processRecords() {
    let e = this.pendingRecords();
    e.length && (this.queue = []);
    let t = -1, r = -1, i = !1;
    for (let s of e) {
      let l = this.readMutation(s);
      l && (l.typeOver && (i = !0), t == -1 ? { from: t, to: r } = l : (t = Math.min(l.from, t), r = Math.max(l.to, r)));
    }
    return { from: t, to: r, typeOver: i };
  }
  readChange() {
    let { from: e, to: t, typeOver: r } = this.processRecords(), i = this.selectionChanged && mo(this.dom, this.selectionRange);
    if (e < 0 && !i)
      return null;
    e > -1 && (this.lastChange = Date.now()), this.view.inputState.lastFocusTime = 0, this.selectionChanged = !1;
    let s = new E3(this.view, e, t, r);
    return this.view.docView.domChanged = { newSel: s.newSel ? s.newSel.main : null }, s;
  }
  // Apply pending changes, if any
  flush(e = !0) {
    if (this.delayedFlush >= 0 || this.delayedAndroidKey)
      return !1;
    e && this.readSelectionRange();
    let t = this.readChange();
    if (!t)
      return this.view.requestMeasure(), !1;
    let r = this.view.state, i = Gp(this.view, t);
    return this.view.state == r && (t.domChanged || t.newSel && !t.newSel.main.eq(this.view.state.selection.main)) && this.view.update([]), i;
  }
  readMutation(e) {
    let t = this.view.docView.nearest(e.target);
    if (!t || t.ignoreMutation(e))
      return null;
    if (t.markDirty(e.type == "attributes"), e.type == "attributes" && (t.flags |= 4), e.type == "childList") {
      let r = Af(t, e.previousSibling || e.target.previousSibling, -1), i = Af(t, e.nextSibling || e.target.nextSibling, 1);
      return {
        from: r ? t.posAfter(r) : t.posAtStart,
        to: i ? t.posBefore(i) : t.posAtEnd,
        typeOver: !1
      };
    } else return e.type == "characterData" ? { from: t.posAtStart, to: t.posAtEnd, typeOver: e.target.nodeValue == e.oldValue } : null;
  }
  setWindow(e) {
    e != this.win && (this.removeWindowListeners(this.win), this.win = e, this.addWindowListeners(this.win));
  }
  addWindowListeners(e) {
    e.addEventListener("resize", this.onResize), this.printQuery ? this.printQuery.addEventListener ? this.printQuery.addEventListener("change", this.onPrint) : this.printQuery.addListener(this.onPrint) : e.addEventListener("beforeprint", this.onPrint), e.addEventListener("scroll", this.onScroll), e.document.addEventListener("selectionchange", this.onSelectionChange);
  }
  removeWindowListeners(e) {
    e.removeEventListener("scroll", this.onScroll), e.removeEventListener("resize", this.onResize), this.printQuery ? this.printQuery.removeEventListener ? this.printQuery.removeEventListener("change", this.onPrint) : this.printQuery.removeListener(this.onPrint) : e.removeEventListener("beforeprint", this.onPrint), e.document.removeEventListener("selectionchange", this.onSelectionChange);
  }
  update(e) {
    this.editContext && (this.editContext.update(e), e.startState.facet(_n) != e.state.facet(_n) && (e.view.contentDOM.editContext = e.state.facet(_n) ? this.editContext.editContext : null));
  }
  destroy() {
    var e, t, r;
    this.stop(), (e = this.intersection) === null || e === void 0 || e.disconnect(), (t = this.gapIntersection) === null || t === void 0 || t.disconnect(), (r = this.resizeScroll) === null || r === void 0 || r.disconnect();
    for (let i of this.scrollTargets)
      i.removeEventListener("scroll", this.onScroll);
    this.removeWindowListeners(this.win), clearTimeout(this.parentCheck), clearTimeout(this.resizeTimeout), this.win.cancelAnimationFrame(this.delayedFlush), this.win.cancelAnimationFrame(this.flushingAndroidKey), this.editContext && (this.view.contentDOM.editContext = null, this.editContext.destroy());
  }
}
function Af(n, e, t) {
  for (; e; ) {
    let r = Be.get(e);
    if (r && r.parent == n)
      return r;
    let i = e.parentNode;
    e = i != n.dom ? i : t > 0 ? e.nextSibling : e.previousSibling;
  }
  return null;
}
function Df(n, e) {
  let t = e.startContainer, r = e.startOffset, i = e.endContainer, s = e.endOffset, l = n.docView.domAtPos(n.state.selection.main.anchor);
  return Ns(l.node, l.offset, i, s) && ([t, r, i, s] = [i, s, t, r]), { anchorNode: t, anchorOffset: r, focusNode: i, focusOffset: s };
}
function f6(n, e) {
  if (e.getComposedRanges) {
    let i = e.getComposedRanges(n.root)[0];
    if (i)
      return Df(n, i);
  }
  let t = null;
  function r(i) {
    i.preventDefault(), i.stopImmediatePropagation(), t = i.getTargetRanges()[0];
  }
  return n.contentDOM.addEventListener("beforeinput", r, !0), n.dom.ownerDocument.execCommand("indent"), n.contentDOM.removeEventListener("beforeinput", r, !0), t ? Df(n, t) : null;
}
class d6 {
  constructor(e) {
    this.from = 0, this.to = 0, this.pendingContextChange = null, this.handlers = /* @__PURE__ */ Object.create(null), this.resetRange(e.state);
    let t = this.editContext = new window.EditContext({
      text: e.state.doc.sliceString(this.from, this.to),
      selectionStart: this.toContextPos(Math.max(this.from, Math.min(this.to, e.state.selection.main.anchor))),
      selectionEnd: this.toContextPos(e.state.selection.main.head)
    });
    this.handlers.textupdate = (r) => {
      let { anchor: i } = e.state.selection.main, s = {
        from: this.toEditorPos(r.updateRangeStart),
        to: this.toEditorPos(r.updateRangeEnd),
        insert: Ae.of(r.text.split(`
`))
      };
      s.from == this.from && i < this.from ? s.from = i : s.to == this.to && i > this.to && (s.to = i), !(s.from == s.to && !s.insert.length) && (this.pendingContextChange = s, e.state.readOnly || ch(e, s, I.single(this.toEditorPos(r.selectionStart), this.toEditorPos(r.selectionEnd))), this.pendingContextChange && (this.revertPending(e.state), this.setSelection(e.state)));
    }, this.handlers.characterboundsupdate = (r) => {
      let i = [], s = null;
      for (let l = this.toEditorPos(r.rangeStart), o = this.toEditorPos(r.rangeEnd); l < o; l++) {
        let a = e.coordsForChar(l);
        s = a && new DOMRect(a.left, a.top, a.right - a.left, a.bottom - a.top) || s || new DOMRect(), i.push(s);
      }
      t.updateCharacterBounds(r.rangeStart, i);
    }, this.handlers.textformatupdate = (r) => {
      let i = [];
      for (let s of r.getTextFormats()) {
        let l = s.underlineStyle, o = s.underlineThickness;
        if (l != "None" && o != "None") {
          let a = `text-decoration: underline ${l == "Dashed" ? "dashed " : l == "Squiggle" ? "wavy " : ""}${o == "Thin" ? 1 : 2}px`;
          i.push(be.mark({ attributes: { style: a } }).range(this.toEditorPos(s.rangeStart), this.toEditorPos(s.rangeEnd)));
        }
      }
      e.dispatch({ effects: Ip.of(be.set(i)) });
    }, this.handlers.compositionstart = () => {
      e.inputState.composing < 0 && (e.inputState.composing = 0, e.inputState.compositionFirstChange = !0);
    }, this.handlers.compositionend = () => {
      e.inputState.composing = -1, e.inputState.compositionFirstChange = null;
    };
    for (let r in this.handlers)
      t.addEventListener(r, this.handlers[r]);
    this.measureReq = { read: (r) => {
      this.editContext.updateControlBounds(r.contentDOM.getBoundingClientRect());
      let i = Ks(r.root);
      i && i.rangeCount && this.editContext.updateSelectionBounds(i.getRangeAt(0).getBoundingClientRect());
    } };
  }
  applyEdits(e) {
    let t = 0, r = !1, i = this.pendingContextChange;
    return e.changes.iterChanges((s, l, o, a, u) => {
      if (r)
        return;
      let h = u.length - (l - s);
      if (i && l >= i.to)
        if (i.from == s && i.to == l && i.insert.eq(u)) {
          i = this.pendingContextChange = null, t += h, this.to += h;
          return;
        } else
          i = null, this.revertPending(e.state);
      if (s += t, l += t, l <= this.from)
        this.from += h, this.to += h;
      else if (s < this.to) {
        if (s < this.from || l > this.to || this.to - this.from + u.length > 3e4) {
          r = !0;
          return;
        }
        this.editContext.updateText(this.toContextPos(s), this.toContextPos(l), u.toString()), this.to += h;
      }
      t += h;
    }), i && !r && this.revertPending(e.state), !r;
  }
  update(e) {
    let t = this.pendingContextChange;
    !this.applyEdits(e) || !this.rangeIsValid(e.state) ? (this.pendingContextChange = null, this.resetRange(e.state), this.editContext.updateText(0, this.editContext.text.length, e.state.doc.sliceString(this.from, this.to)), this.setSelection(e.state)) : (e.docChanged || e.selectionSet || t) && this.setSelection(e.state), (e.geometryChanged || e.docChanged || e.selectionSet) && e.view.requestMeasure(this.measureReq);
  }
  resetRange(e) {
    let { head: t } = e.selection.main;
    this.from = Math.max(
      0,
      t - 1e4
      /* CxVp.Margin */
    ), this.to = Math.min(
      e.doc.length,
      t + 1e4
      /* CxVp.Margin */
    );
  }
  revertPending(e) {
    let t = this.pendingContextChange;
    this.pendingContextChange = null, this.editContext.updateText(this.toContextPos(t.from), this.toContextPos(t.from + t.insert.length), e.doc.sliceString(t.from, t.to));
  }
  setSelection(e) {
    let { main: t } = e.selection, r = this.toContextPos(Math.max(this.from, Math.min(this.to, t.anchor))), i = this.toContextPos(t.head);
    (this.editContext.selectionStart != r || this.editContext.selectionEnd != i) && this.editContext.updateSelection(r, i);
  }
  rangeIsValid(e) {
    let { head: t } = e.selection.main;
    return !(this.from > 0 && t - this.from < 500 || this.to < e.doc.length && this.to - t < 500 || this.to - this.from > 1e4 * 3);
  }
  toEditorPos(e) {
    return e + this.from;
  }
  toContextPos(e) {
    return e - this.from;
  }
  destroy() {
    for (let e in this.handlers)
      this.editContext.removeEventListener(e, this.handlers[e]);
  }
}
class Q {
  /**
  The current editor state.
  */
  get state() {
    return this.viewState.state;
  }
  /**
  To be able to display large documents without consuming too much
  memory or overloading the browser, CodeMirror only draws the
  code that is visible (plus a margin around it) to the DOM. This
  property tells you the extent of the current drawn viewport, in
  document positions.
  */
  get viewport() {
    return this.viewState.viewport;
  }
  /**
  When there are, for example, large collapsed ranges in the
  viewport, its size can be a lot bigger than the actual visible
  content. Thus, if you are doing something like styling the
  content in the viewport, it is preferable to only do so for
  these ranges, which are the subset of the viewport that is
  actually drawn.
  */
  get visibleRanges() {
    return this.viewState.visibleRanges;
  }
  /**
  Returns false when the editor is entirely scrolled out of view
  or otherwise hidden.
  */
  get inView() {
    return this.viewState.inView;
  }
  /**
  Indicates whether the user is currently composing text via
  [IME](https://en.wikipedia.org/wiki/Input_method), and at least
  one change has been made in the current composition.
  */
  get composing() {
    return this.inputState.composing > 0;
  }
  /**
  Indicates whether the user is currently in composing state. Note
  that on some platforms, like Android, this will be the case a
  lot, since just putting the cursor on a word starts a
  composition there.
  */
  get compositionStarted() {
    return this.inputState.composing >= 0;
  }
  /**
  The document or shadow root that the view lives in.
  */
  get root() {
    return this._root;
  }
  /**
  @internal
  */
  get win() {
    return this.dom.ownerDocument.defaultView || window;
  }
  /**
  Construct a new view. You'll want to either provide a `parent`
  option, or put `view.dom` into your document after creating a
  view, so that the user can see the editor.
  */
  constructor(e = {}) {
    var t;
    this.plugins = [], this.pluginMap = /* @__PURE__ */ new Map(), this.editorAttrs = {}, this.contentAttrs = {}, this.bidiCache = [], this.destroyed = !1, this.updateState = 2, this.measureScheduled = -1, this.measureRequests = [], this.contentDOM = document.createElement("div"), this.scrollDOM = document.createElement("div"), this.scrollDOM.tabIndex = -1, this.scrollDOM.className = "cm-scroller", this.scrollDOM.appendChild(this.contentDOM), this.announceDOM = document.createElement("div"), this.announceDOM.className = "cm-announced", this.announceDOM.setAttribute("aria-live", "polite"), this.dom = document.createElement("div"), this.dom.appendChild(this.announceDOM), this.dom.appendChild(this.scrollDOM), e.parent && e.parent.appendChild(this.dom);
    let { dispatch: r } = e;
    this.dispatchTransactions = e.dispatchTransactions || r && ((i) => i.forEach((s) => r(s, this))) || ((i) => this.update(i)), this.dispatch = this.dispatch.bind(this), this._root = e.root || X5(e.parent) || document, this.viewState = new xf(e.state || Se.create(e)), e.scrollTo && e.scrollTo.is(Cl) && (this.viewState.scrollTarget = e.scrollTo.value.clip(this.viewState.state)), this.plugins = this.state.facet(Ms).map((i) => new Ra(i));
    for (let i of this.plugins)
      i.update(this);
    this.observer = new c6(this), this.inputState = new L3(this), this.inputState.ensureHandlers(this.plugins), this.docView = new rf(this), this.mountStyles(), this.updateAttrs(), this.updateState = 0, this.requestMeasure(), !((t = document.fonts) === null || t === void 0) && t.ready && document.fonts.ready.then(() => this.requestMeasure());
  }
  dispatch(...e) {
    let t = e.length == 1 && e[0] instanceof Qe ? e : e.length == 1 && Array.isArray(e[0]) ? e[0] : [this.state.update(...e)];
    this.dispatchTransactions(t, this);
  }
  /**
  Update the view for the given array of transactions. This will
  update the visible document and selection to match the state
  produced by the transactions, and notify view plugins of the
  change. You should usually call
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead, which uses this
  as a primitive.
  */
  update(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.update are not allowed while an update is in progress");
    let t = !1, r = !1, i, s = this.state;
    for (let f of e) {
      if (f.startState != s)
        throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");
      s = f.state;
    }
    if (this.destroyed) {
      this.viewState.state = s;
      return;
    }
    let l = this.hasFocus, o = 0, a = null;
    e.some((f) => f.annotation(Zp)) ? (this.inputState.notifiedFocused = l, o = 1) : l != this.inputState.notifiedFocused && (this.inputState.notifiedFocused = l, a = Jp(s, l), a || (o = 1));
    let u = this.observer.delayedAndroidKey, h = null;
    if (u ? (this.observer.clearDelayedAndroidKey(), h = this.observer.readChange(), (h && !this.state.doc.eq(s.doc) || !this.state.selection.eq(s.selection)) && (h = null)) : this.observer.clear(), s.facet(Se.phrases) != this.state.facet(Se.phrases))
      return this.setState(s);
    i = Fo.create(this, s, e), i.flags |= o;
    let c = this.viewState.scrollTarget;
    try {
      this.updateState = 2;
      for (let f of e) {
        if (c && (c = c.map(f.changes)), f.scrollIntoView) {
          let { main: m } = f.state.selection;
          c = new Hi(m.empty ? m : I.cursor(m.head, m.head > m.anchor ? -1 : 1));
        }
        for (let m of f.effects)
          m.is(Cl) && (c = m.value.clip(this.state));
      }
      this.viewState.update(i, c), this.bidiCache = Oo.update(this.bidiCache, i.changes), i.empty || (this.updatePlugins(i), this.inputState.update(i)), t = this.docView.update(i), this.state.facet(Ts) != this.styleModules && this.mountStyles(), r = this.updateAttrs(), this.showAnnouncements(e), this.docView.updateSelection(t, e.some((f) => f.isUserEvent("select.pointer")));
    } finally {
      this.updateState = 0;
    }
    if (i.startState.facet(Bl) != i.state.facet(Bl) && (this.viewState.mustMeasureContent = !0), (t || r || c || this.viewState.mustEnforceCursorAssoc || this.viewState.mustMeasureContent) && this.requestMeasure(), t && this.docViewUpdate(), !i.empty)
      for (let f of this.state.facet(du))
        try {
          f(i);
        } catch (m) {
          Xt(this.state, m, "update listener");
        }
    (a || h) && Promise.resolve().then(() => {
      a && this.state == a.startState && this.dispatch(a), h && !Gp(this, h) && u.force && Pi(this.contentDOM, u.key, u.keyCode);
    });
  }
  /**
  Reset the view to the given state. (This will cause the entire
  document to be redrawn and all view plugins to be reinitialized,
  so you should probably only use it when the new state isn't
  derived from the old state. Otherwise, use
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead.)
  */
  setState(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");
    if (this.destroyed) {
      this.viewState.state = e;
      return;
    }
    this.updateState = 2;
    let t = this.hasFocus;
    try {
      for (let r of this.plugins)
        r.destroy(this);
      this.viewState = new xf(e), this.plugins = e.facet(Ms).map((r) => new Ra(r)), this.pluginMap.clear();
      for (let r of this.plugins)
        r.update(this);
      this.docView.destroy(), this.docView = new rf(this), this.inputState.ensureHandlers(this.plugins), this.mountStyles(), this.updateAttrs(), this.bidiCache = [];
    } finally {
      this.updateState = 0;
    }
    t && this.focus(), this.requestMeasure();
  }
  updatePlugins(e) {
    let t = e.startState.facet(Ms), r = e.state.facet(Ms);
    if (t != r) {
      let i = [];
      for (let s of r) {
        let l = t.indexOf(s);
        if (l < 0)
          i.push(new Ra(s));
        else {
          let o = this.plugins[l];
          o.mustUpdate = e, i.push(o);
        }
      }
      for (let s of this.plugins)
        s.mustUpdate != e && s.destroy(this);
      this.plugins = i, this.pluginMap.clear();
    } else
      for (let i of this.plugins)
        i.mustUpdate = e;
    for (let i = 0; i < this.plugins.length; i++)
      this.plugins[i].update(this);
    t != r && this.inputState.ensureHandlers(this.plugins);
  }
  docViewUpdate() {
    for (let e of this.plugins) {
      let t = e.value;
      if (t && t.docViewUpdate)
        try {
          t.docViewUpdate(this);
        } catch (r) {
          Xt(this.state, r, "doc view update listener");
        }
    }
  }
  /**
  @internal
  */
  measure(e = !0) {
    if (this.destroyed)
      return;
    if (this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.observer.delayedAndroidKey) {
      this.measureScheduled = -1, this.requestMeasure();
      return;
    }
    this.measureScheduled = 0, e && this.observer.forceFlush();
    let t = null, r = this.scrollDOM, i = r.scrollTop * this.scaleY, { scrollAnchorPos: s, scrollAnchorHeight: l } = this.viewState;
    Math.abs(i - this.viewState.scrollTop) > 1 && (l = -1), this.viewState.scrollAnchorHeight = -1;
    try {
      for (let o = 0; ; o++) {
        if (l < 0)
          if (cp(r))
            s = -1, l = this.viewState.heightMap.height;
          else {
            let m = this.viewState.scrollAnchorAt(i);
            s = m.from, l = m.top;
          }
        this.updateState = 1;
        let a = this.viewState.measure(this);
        if (!a && !this.measureRequests.length && this.viewState.scrollTarget == null)
          break;
        if (o > 5) {
          console.warn(this.measureRequests.length ? "Measure loop restarted more than 5 times" : "Viewport failed to stabilize");
          break;
        }
        let u = [];
        a & 4 || ([this.measureRequests, u] = [u, this.measureRequests]);
        let h = u.map((m) => {
          try {
            return m.read(this);
          } catch (g) {
            return Xt(this.state, g), Cf;
          }
        }), c = Fo.create(this, this.state, []), f = !1;
        c.flags |= a, t ? t.flags |= a : t = c, this.updateState = 2, c.empty || (this.updatePlugins(c), this.inputState.update(c), this.updateAttrs(), f = this.docView.update(c), f && this.docViewUpdate());
        for (let m = 0; m < u.length; m++)
          if (h[m] != Cf)
            try {
              let g = u[m];
              g.write && g.write(h[m], this);
            } catch (g) {
              Xt(this.state, g);
            }
        if (f && this.docView.updateSelection(!0), !c.viewportChanged && this.measureRequests.length == 0) {
          if (this.viewState.editorHeight)
            if (this.viewState.scrollTarget) {
              this.docView.scrollIntoView(this.viewState.scrollTarget), this.viewState.scrollTarget = null, l = -1;
              continue;
            } else {
              let g = (s < 0 ? this.viewState.heightMap.height : this.viewState.lineBlockAt(s).top) - l;
              if (g > 1 || g < -1) {
                i = i + g, r.scrollTop = i / this.scaleY, l = -1;
                continue;
              }
            }
          break;
        }
      }
    } finally {
      this.updateState = 0, this.measureScheduled = -1;
    }
    if (t && !t.empty)
      for (let o of this.state.facet(du))
        o(t);
  }
  /**
  Get the CSS classes for the currently active editor themes.
  */
  get themeClasses() {
    return vu + " " + (this.state.facet(bu) ? rg : tg) + " " + this.state.facet(Bl);
  }
  updateAttrs() {
    let e = _f(this, zp, {
      class: "cm-editor" + (this.hasFocus ? " cm-focused " : " ") + this.themeClasses
    }), t = {
      spellcheck: "false",
      autocorrect: "off",
      autocapitalize: "off",
      translate: "no",
      contenteditable: this.state.facet(_n) ? "true" : "false",
      class: "cm-content",
      style: `${K.tabSize}: ${this.state.tabSize}`,
      role: "textbox",
      "aria-multiline": "true"
    };
    this.state.readOnly && (t["aria-readonly"] = "true"), _f(this, uh, t);
    let r = this.observer.ignore(() => {
      let i = ou(this.contentDOM, this.contentAttrs, t), s = ou(this.dom, this.editorAttrs, e);
      return i || s;
    });
    return this.editorAttrs = e, this.contentAttrs = t, r;
  }
  showAnnouncements(e) {
    let t = !0;
    for (let r of e)
      for (let i of r.effects)
        if (i.is(Q.announce)) {
          t && (this.announceDOM.textContent = ""), t = !1;
          let s = this.announceDOM.appendChild(document.createElement("div"));
          s.textContent = i.value;
        }
  }
  mountStyles() {
    this.styleModules = this.state.facet(Ts);
    let e = this.state.facet(Q.cspNonce);
    On.mount(this.root, this.styleModules.concat(u6).reverse(), e ? { nonce: e } : void 0);
  }
  readMeasured() {
    if (this.updateState == 2)
      throw new Error("Reading the editor layout isn't allowed during an update");
    this.updateState == 0 && this.measureScheduled > -1 && this.measure(!1);
  }
  /**
  Schedule a layout measurement, optionally providing callbacks to
  do custom DOM measuring followed by a DOM write phase. Using
  this is preferable reading DOM layout directly from, for
  example, an event handler, because it'll make sure measuring and
  drawing done by other components is synchronized, avoiding
  unnecessary DOM layout computations.
  */
  requestMeasure(e) {
    if (this.measureScheduled < 0 && (this.measureScheduled = this.win.requestAnimationFrame(() => this.measure())), e) {
      if (this.measureRequests.indexOf(e) > -1)
        return;
      if (e.key != null) {
        for (let t = 0; t < this.measureRequests.length; t++)
          if (this.measureRequests[t].key === e.key) {
            this.measureRequests[t] = e;
            return;
          }
      }
      this.measureRequests.push(e);
    }
  }
  /**
  Get the value of a specific plugin, if present. Note that
  plugins that crash can be dropped from a view, so even when you
  know you registered a given plugin, it is recommended to check
  the return value of this method.
  */
  plugin(e) {
    let t = this.pluginMap.get(e);
    return (t === void 0 || t && t.spec != e) && this.pluginMap.set(e, t = this.plugins.find((r) => r.spec == e) || null), t && t.update(this).value;
  }
  /**
  The top position of the document, in screen coordinates. This
  may be negative when the editor is scrolled down. Points
  directly to the top of the first line, not above the padding.
  */
  get documentTop() {
    return this.contentDOM.getBoundingClientRect().top + this.viewState.paddingTop;
  }
  /**
  Reports the padding above and below the document.
  */
  get documentPadding() {
    return { top: this.viewState.paddingTop, bottom: this.viewState.paddingBottom };
  }
  /**
  If the editor is transformed with CSS, this provides the scale
  along the X axis. Otherwise, it will just be 1. Note that
  transforms other than translation and scaling are not supported.
  */
  get scaleX() {
    return this.viewState.scaleX;
  }
  /**
  Provide the CSS transformed scale along the Y axis.
  */
  get scaleY() {
    return this.viewState.scaleY;
  }
  /**
  Find the text line or block widget at the given vertical
  position (which is interpreted as relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop)).
  */
  elementAtHeight(e) {
    return this.readMeasured(), this.viewState.elementAtHeight(e);
  }
  /**
  Find the line block (see
  [`lineBlockAt`](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) at the given
  height, again interpreted relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop).
  */
  lineBlockAtHeight(e) {
    return this.readMeasured(), this.viewState.lineBlockAtHeight(e);
  }
  /**
  Get the extent and vertical position of all [line
  blocks](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) in the viewport. Positions
  are relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop);
  */
  get viewportLineBlocks() {
    return this.viewState.viewportLines;
  }
  /**
  Find the line block around the given document position. A line
  block is a range delimited on both sides by either a
  non-[hidden](https://codemirror.net/6/docs/ref/#view.Decoration^replace) line break, or the
  start/end of the document. It will usually just hold a line of
  text, but may be broken into multiple textblocks by block
  widgets.
  */
  lineBlockAt(e) {
    return this.viewState.lineBlockAt(e);
  }
  /**
  The editor's total content height.
  */
  get contentHeight() {
    return this.viewState.contentHeight;
  }
  /**
  Move a cursor position by [grapheme
  cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak). `forward` determines whether
  the motion is away from the line start, or towards it. In
  bidirectional text, the line is traversed in visual order, using
  the editor's [text direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection).
  When the start position was the last one on the line, the
  returned position will be across the line break. If there is no
  further line, the original position is returned.
  
  By default, this method moves over a single cluster. The
  optional `by` argument can be used to move across more. It will
  be called with the first cluster as argument, and should return
  a predicate that determines, for each subsequent cluster,
  whether it should also be moved over.
  */
  moveByChar(e, t, r) {
    return Na(this, e, af(this, e, t, r));
  }
  /**
  Move a cursor position across the next group of either
  [letters](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) or non-letter
  non-whitespace characters.
  */
  moveByGroup(e, t) {
    return Na(this, e, af(this, e, t, (r) => C3(this, e.head, r)));
  }
  /**
  Get the cursor position visually at the start or end of a line.
  Note that this may differ from the _logical_ position at its
  start or end (which is simply at `line.from`/`line.to`) if text
  at the start or end goes against the line's base text direction.
  */
  visualLineSide(e, t) {
    let r = this.bidiSpans(e), i = this.textDirectionAt(e.from), s = r[t ? r.length - 1 : 0];
    return I.cursor(s.side(t, i) + e.from, s.forward(!t, i) ? 1 : -1);
  }
  /**
  Move to the next line boundary in the given direction. If
  `includeWrap` is true, line wrapping is on, and there is a
  further wrap point on the current line, the wrap point will be
  returned. Otherwise this function will return the start or end
  of the line.
  */
  moveToLineBoundary(e, t, r = !0) {
    return D3(this, e, t, r);
  }
  /**
  Move a cursor position vertically. When `distance` isn't given,
  it defaults to moving to the next line (including wrapped
  lines). Otherwise, `distance` should provide a positive distance
  in pixels.
  
  When `start` has a
  [`goalColumn`](https://codemirror.net/6/docs/ref/#state.SelectionRange.goalColumn), the vertical
  motion will use that as a target horizontal position. Otherwise,
  the cursor's own horizontal position is used. The returned
  cursor will have its goal column set to whichever column was
  used.
  */
  moveVertically(e, t, r) {
    return Na(this, e, _3(this, e, t, r));
  }
  /**
  Find the DOM parent node and offset (child offset if `node` is
  an element, character offset when it is a text node) at the
  given document position.
  
  Note that for positions that aren't currently in
  `visibleRanges`, the resulting DOM position isn't necessarily
  meaningful (it may just point before or after a placeholder
  element).
  */
  domAtPos(e) {
    return this.docView.domAtPos(e);
  }
  /**
  Find the document position at the given DOM node. Can be useful
  for associating positions with DOM events. Will raise an error
  when `node` isn't part of the editor content.
  */
  posAtDOM(e, t = 0) {
    return this.docView.posFromDOM(e, t);
  }
  posAtCoords(e, t = !0) {
    return this.readMeasured(), Up(this, e, t);
  }
  /**
  Get the screen coordinates at the given document position.
  `side` determines whether the coordinates are based on the
  element before (-1) or after (1) the position (if no element is
  available on the given side, the method will transparently use
  another strategy to get reasonable coordinates).
  */
  coordsAtPos(e, t = 1) {
    this.readMeasured();
    let r = this.docView.coordsAt(e, t);
    if (!r || r.left == r.right)
      return r;
    let i = this.state.doc.lineAt(e), s = this.bidiSpans(i), l = s[Fn.find(s, e - i.from, -1, t)];
    return ul(r, l.dir == Ie.LTR == t > 0);
  }
  /**
  Return the rectangle around a given character. If `pos` does not
  point in front of a character that is in the viewport and
  rendered (i.e. not replaced, not a line break), this will return
  null. For space characters that are a line wrap point, this will
  return the position before the line break.
  */
  coordsForChar(e) {
    return this.readMeasured(), this.docView.coordsForChar(e);
  }
  /**
  The default width of a character in the editor. May not
  accurately reflect the width of all characters (given variable
  width fonts or styling of invididual ranges).
  */
  get defaultCharacterWidth() {
    return this.viewState.heightOracle.charWidth;
  }
  /**
  The default height of a line in the editor. May not be accurate
  for all lines.
  */
  get defaultLineHeight() {
    return this.viewState.heightOracle.lineHeight;
  }
  /**
  The text direction
  ([`direction`](https://developer.mozilla.org/en-US/docs/Web/CSS/direction)
  CSS property) of the editor's content element.
  */
  get textDirection() {
    return this.viewState.defaultTextDirection;
  }
  /**
  Find the text direction of the block at the given position, as
  assigned by CSS. If
  [`perLineTextDirection`](https://codemirror.net/6/docs/ref/#view.EditorView^perLineTextDirection)
  isn't enabled, or the given position is outside of the viewport,
  this will always return the same as
  [`textDirection`](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection). Note that
  this may trigger a DOM layout.
  */
  textDirectionAt(e) {
    return !this.state.facet(Rp) || e < this.viewport.from || e > this.viewport.to ? this.textDirection : (this.readMeasured(), this.docView.textDirectionAt(e));
  }
  /**
  Whether this editor [wraps lines](https://codemirror.net/6/docs/ref/#view.EditorView.lineWrapping)
  (as determined by the
  [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space)
  CSS property of its content element).
  */
  get lineWrapping() {
    return this.viewState.heightOracle.lineWrapping;
  }
  /**
  Returns the bidirectional text structure of the given line
  (which should be in the current document) as an array of span
  objects. The order of these spans matches the [text
  direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection)—if that is
  left-to-right, the leftmost spans come first, otherwise the
  rightmost spans come first.
  */
  bidiSpans(e) {
    if (e.length > m6)
      return Cp(e.length);
    let t = this.textDirectionAt(e.from), r;
    for (let s of this.bidiCache)
      if (s.from == e.from && s.dir == t && (s.fresh || Dp(s.isolates, r = tf(this, e))))
        return s.order;
    r || (r = tf(this, e));
    let i = u3(e.text, t, r);
    return this.bidiCache.push(new Oo(e.from, e.to, t, r, !0, i)), i;
  }
  /**
  Check whether the editor has focus.
  */
  get hasFocus() {
    var e;
    return (this.dom.ownerDocument.hasFocus() || K.safari && ((e = this.inputState) === null || e === void 0 ? void 0 : e.lastContextMenu) > Date.now() - 3e4) && this.root.activeElement == this.contentDOM;
  }
  /**
  Put focus on the editor.
  */
  focus() {
    this.observer.ignore(() => {
      up(this.contentDOM), this.docView.updateSelection();
    });
  }
  /**
  Update the [root](https://codemirror.net/6/docs/ref/##view.EditorViewConfig.root) in which the editor lives. This is only
  necessary when moving the editor's existing DOM to a new window or shadow root.
  */
  setRoot(e) {
    this._root != e && (this._root = e, this.observer.setWindow((e.nodeType == 9 ? e : e.ownerDocument).defaultView || window), this.mountStyles());
  }
  /**
  Clean up this editor view, removing its element from the
  document, unregistering event handlers, and notifying
  plugins. The view instance can no longer be used after
  calling this.
  */
  destroy() {
    this.root.activeElement == this.contentDOM && this.contentDOM.blur();
    for (let e of this.plugins)
      e.destroy(this);
    this.plugins = [], this.inputState.destroy(), this.docView.destroy(), this.dom.remove(), this.observer.destroy(), this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.destroyed = !0;
  }
  /**
  Returns an effect that can be
  [added](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) to a transaction to
  cause it to scroll the given position or range into view.
  */
  static scrollIntoView(e, t = {}) {
    return Cl.of(new Hi(typeof e == "number" ? I.cursor(e) : e, t.y, t.x, t.yMargin, t.xMargin));
  }
  /**
  Return an effect that resets the editor to its current (at the
  time this method was called) scroll position. Note that this
  only affects the editor's own scrollable element, not parents.
  See also
  [`EditorViewConfig.scrollTo`](https://codemirror.net/6/docs/ref/#view.EditorViewConfig.scrollTo).
  
  The effect should be used with a document identical to the one
  it was created for. Failing to do so is not an error, but may
  not scroll to the expected position. You can
  [map](https://codemirror.net/6/docs/ref/#state.StateEffect.map) the effect to account for changes.
  */
  scrollSnapshot() {
    let { scrollTop: e, scrollLeft: t } = this.scrollDOM, r = this.viewState.scrollAnchorAt(e);
    return Cl.of(new Hi(I.cursor(r.from), "start", "start", r.top - e, t, !0));
  }
  /**
  Enable or disable tab-focus mode, which disables key bindings
  for Tab and Shift-Tab, letting the browser's default
  focus-changing behavior go through instead. This is useful to
  prevent trapping keyboard users in your editor.
  
  Without argument, this toggles the mode. With a boolean, it
  enables (true) or disables it (false). Given a number, it
  temporarily enables the mode until that number of milliseconds
  have passed or another non-Tab key is pressed.
  */
  setTabFocusMode(e) {
    e == null ? this.inputState.tabFocusMode = this.inputState.tabFocusMode < 0 ? 0 : -1 : typeof e == "boolean" ? this.inputState.tabFocusMode = e ? 0 : -1 : this.inputState.tabFocusMode != 0 && (this.inputState.tabFocusMode = Date.now() + e);
  }
  /**
  Returns an extension that can be used to add DOM event handlers.
  The value should be an object mapping event names to handler
  functions. For any given event, such functions are ordered by
  extension precedence, and the first handler to return true will
  be assumed to have handled that event, and no other handlers or
  built-in behavior will be activated for it. These are registered
  on the [content element](https://codemirror.net/6/docs/ref/#view.EditorView.contentDOM), except
  for `scroll` handlers, which will be called any time the
  editor's [scroll element](https://codemirror.net/6/docs/ref/#view.EditorView.scrollDOM) or one of
  its parent nodes is scrolled.
  */
  static domEventHandlers(e) {
    return pt.define(() => ({}), { eventHandlers: e });
  }
  /**
  Create an extension that registers DOM event observers. Contrary
  to event [handlers](https://codemirror.net/6/docs/ref/#view.EditorView^domEventHandlers),
  observers can't be prevented from running by a higher-precedence
  handler returning true. They also don't prevent other handlers
  and observers from running when they return true, and should not
  call `preventDefault`.
  */
  static domEventObservers(e) {
    return pt.define(() => ({}), { eventObservers: e });
  }
  /**
  Create a theme extension. The first argument can be a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)
  style spec providing the styles for the theme. These will be
  prefixed with a generated class for the style.
  
  Because the selectors will be prefixed with a scope class, rule
  that directly match the editor's [wrapper
  element](https://codemirror.net/6/docs/ref/#view.EditorView.dom)—to which the scope class will be
  added—need to be explicitly differentiated by adding an `&` to
  the selector for that element—for example
  `&.cm-focused`.
  
  When `dark` is set to true, the theme will be marked as dark,
  which will cause the `&dark` rules from [base
  themes](https://codemirror.net/6/docs/ref/#view.EditorView^baseTheme) to be used (as opposed to
  `&light` when a light theme is active).
  */
  static theme(e, t) {
    let r = On.newName(), i = [Bl.of(r), Ts.of(yu(`.${r}`, e))];
    return t && t.dark && i.push(bu.of(!0)), i;
  }
  /**
  Create an extension that adds styles to the base theme. Like
  with [`theme`](https://codemirror.net/6/docs/ref/#view.EditorView^theme), use `&` to indicate the
  place of the editor wrapper element when directly targeting
  that. You can also use `&dark` or `&light` instead to only
  target editors with a dark or light theme.
  */
  static baseTheme(e) {
    return al.lowest(Ts.of(yu("." + vu, e, ng)));
  }
  /**
  Retrieve an editor view instance from the view's DOM
  representation.
  */
  static findFromDOM(e) {
    var t;
    let r = e.querySelector(".cm-content"), i = r && Be.get(r) || Be.get(e);
    return ((t = i?.rootView) === null || t === void 0 ? void 0 : t.view) || null;
  }
}
Q.styleModule = Ts;
Q.inputHandler = Bp;
Q.clipboardInputFilter = oh;
Q.clipboardOutputFilter = ah;
Q.scrollHandler = Np;
Q.focusChangeEffect = Op;
Q.perLineTextDirection = Rp;
Q.exceptionSink = Fp;
Q.updateListener = du;
Q.editable = _n;
Q.mouseSelectionStyle = Ep;
Q.dragMovesSelection = Tp;
Q.clickAddsSelectionRange = Mp;
Q.decorations = Xs;
Q.outerDecorations = Pp;
Q.atomicRanges = hh;
Q.bidiIsolatedRanges = Hp;
Q.scrollMargins = qp;
Q.darkTheme = bu;
Q.cspNonce = /* @__PURE__ */ X.define({ combine: (n) => n.length ? n[0] : "" });
Q.contentAttributes = uh;
Q.editorAttributes = zp;
Q.lineWrapping = /* @__PURE__ */ Q.contentAttributes.of({ class: "cm-lineWrapping" });
Q.announce = /* @__PURE__ */ ye.define();
const m6 = 4096, Cf = {};
class Oo {
  constructor(e, t, r, i, s, l) {
    this.from = e, this.to = t, this.dir = r, this.isolates = i, this.fresh = s, this.order = l;
  }
  static update(e, t) {
    if (t.empty && !e.some((s) => s.fresh))
      return e;
    let r = [], i = e.length ? e[e.length - 1].dir : Ie.LTR;
    for (let s = Math.max(0, e.length - 10); s < e.length; s++) {
      let l = e[s];
      l.dir == i && !t.touchesRange(l.from, l.to) && r.push(new Oo(t.mapPos(l.from, 1), t.mapPos(l.to, -1), l.dir, l.isolates, !1, l.order));
    }
    return r;
  }
}
function _f(n, e, t) {
  for (let r = n.state.facet(e), i = r.length - 1; i >= 0; i--) {
    let s = r[i], l = typeof s == "function" ? s(n) : s;
    l && lu(l, t);
  }
  return t;
}
const p6 = K.mac ? "mac" : K.windows ? "win" : K.linux ? "linux" : "key";
function g6(n, e) {
  const t = n.split(/-(?!$)/);
  let r = t[t.length - 1];
  r == "Space" && (r = " ");
  let i, s, l, o;
  for (let a = 0; a < t.length - 1; ++a) {
    const u = t[a];
    if (/^(cmd|meta|m)$/i.test(u))
      o = !0;
    else if (/^a(lt)?$/i.test(u))
      i = !0;
    else if (/^(c|ctrl|control)$/i.test(u))
      s = !0;
    else if (/^s(hift)?$/i.test(u))
      l = !0;
    else if (/^mod$/i.test(u))
      e == "mac" ? o = !0 : s = !0;
    else
      throw new Error("Unrecognized modifier name: " + u);
  }
  return i && (r = "Alt-" + r), s && (r = "Ctrl-" + r), o && (r = "Meta-" + r), l && (r = "Shift-" + r), r;
}
function Ol(n, e, t) {
  return e.altKey && (n = "Alt-" + n), e.ctrlKey && (n = "Ctrl-" + n), e.metaKey && (n = "Meta-" + n), t !== !1 && e.shiftKey && (n = "Shift-" + n), n;
}
const b6 = /* @__PURE__ */ al.default(/* @__PURE__ */ Q.domEventHandlers({
  keydown(n, e) {
    return k6(v6(e.state), n, e, "editor");
  }
})), oa = /* @__PURE__ */ X.define({ enables: b6 }), Mf = /* @__PURE__ */ new WeakMap();
function v6(n) {
  let e = n.facet(oa), t = Mf.get(e);
  return t || Mf.set(e, t = w6(e.reduce((r, i) => r.concat(i), []))), t;
}
let Mn = null;
const y6 = 4e3;
function w6(n, e = p6) {
  let t = /* @__PURE__ */ Object.create(null), r = /* @__PURE__ */ Object.create(null), i = (l, o) => {
    let a = r[l];
    if (a == null)
      r[l] = o;
    else if (a != o)
      throw new Error("Key binding " + l + " is used both as a regular binding and as a multi-stroke prefix");
  }, s = (l, o, a, u, h) => {
    var c, f;
    let m = t[l] || (t[l] = /* @__PURE__ */ Object.create(null)), g = o.split(/ (?!$)/).map((S) => g6(S, e));
    for (let S = 1; S < g.length; S++) {
      let x = g.slice(0, S).join(" ");
      i(x, !0), m[x] || (m[x] = {
        preventDefault: !0,
        stopPropagation: !1,
        run: [(y) => {
          let A = Mn = { view: y, prefix: x, scope: l };
          return setTimeout(() => {
            Mn == A && (Mn = null);
          }, y6), !0;
        }]
      });
    }
    let v = g.join(" ");
    i(v, !1);
    let k = m[v] || (m[v] = {
      preventDefault: !1,
      stopPropagation: !1,
      run: ((f = (c = m._any) === null || c === void 0 ? void 0 : c.run) === null || f === void 0 ? void 0 : f.slice()) || []
    });
    a && k.run.push(a), u && (k.preventDefault = !0), h && (k.stopPropagation = !0);
  };
  for (let l of n) {
    let o = l.scope ? l.scope.split(" ") : ["editor"];
    if (l.any)
      for (let u of o) {
        let h = t[u] || (t[u] = /* @__PURE__ */ Object.create(null));
        h._any || (h._any = { preventDefault: !1, stopPropagation: !1, run: [] });
        let { any: c } = l;
        for (let f in h)
          h[f].run.push((m) => c(m, wu));
      }
    let a = l[e] || l.key;
    if (a)
      for (let u of o)
        s(u, a, l.run, l.preventDefault, l.stopPropagation), l.shift && s(u, "Shift-" + a, l.shift, l.preventDefault, l.stopPropagation);
  }
  return t;
}
let wu = null;
function k6(n, e, t, r) {
  wu = e;
  let i = G5(e), s = ft(i, 0), l = vr(s) == i.length && i != " ", o = "", a = !1, u = !1, h = !1;
  Mn && Mn.view == t && Mn.scope == r && (o = Mn.prefix + " ", $p.indexOf(e.keyCode) < 0 && (u = !0, Mn = null));
  let c = /* @__PURE__ */ new Set(), f = (k) => {
    if (k) {
      for (let S of k.run)
        if (!c.has(S) && (c.add(S), S(t)))
          return k.stopPropagation && (h = !0), !0;
      k.preventDefault && (k.stopPropagation && (h = !0), u = !0);
    }
    return !1;
  }, m = n[r], g, v;
  return m && (f(m[o + Ol(i, e, !l)]) ? a = !0 : l && (e.altKey || e.metaKey || e.ctrlKey) && // Ctrl-Alt may be used for AltGr on Windows
  !(K.windows && e.ctrlKey && e.altKey) && (g = Rn[e.keyCode]) && g != i ? (f(m[o + Ol(g, e, !0)]) || e.shiftKey && (v = Ys[e.keyCode]) != i && v != g && f(m[o + Ol(v, e, !1)])) && (a = !0) : l && e.shiftKey && f(m[o + Ol(i, e, !0)]) && (a = !0), !a && f(m._any) && (a = !0)), u && (a = !0), a && h && e.stopPropagation(), wu = null, a;
}
class fl {
  /**
  Create a marker with the given class and dimensions. If `width`
  is null, the DOM element will get no width style.
  */
  constructor(e, t, r, i, s) {
    this.className = e, this.left = t, this.top = r, this.width = i, this.height = s;
  }
  draw() {
    let e = document.createElement("div");
    return e.className = this.className, this.adjust(e), e;
  }
  update(e, t) {
    return t.className != this.className ? !1 : (this.adjust(e), !0);
  }
  adjust(e) {
    e.style.left = this.left + "px", e.style.top = this.top + "px", this.width != null && (e.style.width = this.width + "px"), e.style.height = this.height + "px";
  }
  eq(e) {
    return this.left == e.left && this.top == e.top && this.width == e.width && this.height == e.height && this.className == e.className;
  }
  /**
  Create a set of rectangles for the given selection range,
  assigning them theclass`className`. Will create a single
  rectangle for empty ranges, and a set of selection-style
  rectangles covering the range's content (in a bidi-aware
  way) for non-empty ones.
  */
  static forRange(e, t, r) {
    if (r.empty) {
      let i = e.coordsAtPos(r.head, r.assoc || 1);
      if (!i)
        return [];
      let s = ig(e);
      return [new fl(t, i.left - s.left, i.top - s.top, null, i.bottom - i.top)];
    } else
      return x6(e, t, r);
  }
}
function ig(n) {
  let e = n.scrollDOM.getBoundingClientRect();
  return { left: (n.textDirection == Ie.LTR ? e.left : e.right - n.scrollDOM.clientWidth * n.scaleX) - n.scrollDOM.scrollLeft * n.scaleX, top: e.top - n.scrollDOM.scrollTop * n.scaleY };
}
function Tf(n, e, t, r) {
  let i = n.coordsAtPos(e, t * 2);
  if (!i)
    return r;
  let s = n.dom.getBoundingClientRect(), l = (i.top + i.bottom) / 2, o = n.posAtCoords({ x: s.left + 1, y: l }), a = n.posAtCoords({ x: s.right - 1, y: l });
  return o == null || a == null ? r : { from: Math.max(r.from, Math.min(o, a)), to: Math.min(r.to, Math.max(o, a)) };
}
function x6(n, e, t) {
  if (t.to <= n.viewport.from || t.from >= n.viewport.to)
    return [];
  let r = Math.max(t.from, n.viewport.from), i = Math.min(t.to, n.viewport.to), s = n.textDirection == Ie.LTR, l = n.contentDOM, o = l.getBoundingClientRect(), a = ig(n), u = l.querySelector(".cm-line"), h = u && window.getComputedStyle(u), c = o.left + (h ? parseInt(h.paddingLeft) + Math.min(0, parseInt(h.textIndent)) : 0), f = o.right - (h ? parseInt(h.paddingRight) : 0), m = pu(n, r), g = pu(n, i), v = m.type == St.Text ? m : null, k = g.type == St.Text ? g : null;
  if (v && (n.lineWrapping || m.widgetLineBreaks) && (v = Tf(n, r, 1, v)), k && (n.lineWrapping || g.widgetLineBreaks) && (k = Tf(n, i, -1, k)), v && k && v.from == k.from && v.to == k.to)
    return x(y(t.from, t.to, v));
  {
    let C = v ? y(t.from, null, v) : A(m, !1), T = k ? y(null, t.to, k) : A(g, !0), M = [];
    return (v || m).to < (k || g).from - (v && k ? 1 : 0) || m.widgetLineBreaks > 1 && C.bottom + n.defaultLineHeight / 2 < T.top ? M.push(S(c, C.bottom, f, T.top)) : C.bottom < T.top && n.elementAtHeight((C.bottom + T.top) / 2).type == St.Text && (C.bottom = T.top = (C.bottom + T.top) / 2), x(C).concat(M).concat(x(T));
  }
  function S(C, T, M, L) {
    return new fl(
      e,
      C - a.left,
      T - a.top - 0.01,
      M - C,
      L - T + 0.01
      /* C.Epsilon */
    );
  }
  function x({ top: C, bottom: T, horizontal: M }) {
    let L = [];
    for (let R = 0; R < M.length; R += 2)
      L.push(S(M[R], C, M[R + 1], T));
    return L;
  }
  function y(C, T, M) {
    let L = 1e9, R = -1e9, N = [];
    function W(Z, oe, ve, _e, pe) {
      let H = n.coordsAtPos(Z, Z == M.to ? -2 : 2), fe = n.coordsAtPos(ve, ve == M.from ? 2 : -2);
      !H || !fe || (L = Math.min(H.top, fe.top, L), R = Math.max(H.bottom, fe.bottom, R), pe == Ie.LTR ? N.push(s && oe ? c : H.left, s && _e ? f : fe.right) : N.push(!s && _e ? c : fe.left, !s && oe ? f : H.right));
    }
    let q = C ?? M.from, he = T ?? M.to;
    for (let Z of n.visibleRanges)
      if (Z.to > q && Z.from < he)
        for (let oe = Math.max(Z.from, q), ve = Math.min(Z.to, he); ; ) {
          let _e = n.state.doc.lineAt(oe);
          for (let pe of n.bidiSpans(_e)) {
            let H = pe.from + _e.from, fe = pe.to + _e.from;
            if (H >= ve)
              break;
            fe > oe && W(Math.max(H, oe), C == null && H <= q, Math.min(fe, ve), T == null && fe >= he, pe.dir);
          }
          if (oe = _e.to + 1, oe >= ve)
            break;
        }
    return N.length == 0 && W(q, C == null, he, T == null, n.textDirection), { top: L, bottom: R, horizontal: N };
  }
  function A(C, T) {
    let M = o.top + (T ? C.top : C.bottom);
    return { top: M, bottom: M, horizontal: [] };
  }
}
function S6(n, e) {
  return n.constructor == e.constructor && n.eq(e);
}
class A6 {
  constructor(e, t) {
    this.view = e, this.layer = t, this.drawn = [], this.scaleX = 1, this.scaleY = 1, this.measureReq = { read: this.measure.bind(this), write: this.draw.bind(this) }, this.dom = e.scrollDOM.appendChild(document.createElement("div")), this.dom.classList.add("cm-layer"), t.above && this.dom.classList.add("cm-layer-above"), t.class && this.dom.classList.add(t.class), this.scale(), this.dom.setAttribute("aria-hidden", "true"), this.setOrder(e.state), e.requestMeasure(this.measureReq), t.mount && t.mount(this.dom, e);
  }
  update(e) {
    e.startState.facet(bo) != e.state.facet(bo) && this.setOrder(e.state), (this.layer.update(e, this.dom) || e.geometryChanged) && (this.scale(), e.view.requestMeasure(this.measureReq));
  }
  docViewUpdate(e) {
    this.layer.updateOnDocViewUpdate !== !1 && e.requestMeasure(this.measureReq);
  }
  setOrder(e) {
    let t = 0, r = e.facet(bo);
    for (; t < r.length && r[t] != this.layer; )
      t++;
    this.dom.style.zIndex = String((this.layer.above ? 150 : -1) - t);
  }
  measure() {
    return this.layer.markers(this.view);
  }
  scale() {
    let { scaleX: e, scaleY: t } = this.view;
    (e != this.scaleX || t != this.scaleY) && (this.scaleX = e, this.scaleY = t, this.dom.style.transform = `scale(${1 / e}, ${1 / t})`);
  }
  draw(e) {
    if (e.length != this.drawn.length || e.some((t, r) => !S6(t, this.drawn[r]))) {
      let t = this.dom.firstChild, r = 0;
      for (let i of e)
        i.update && t && i.constructor && this.drawn[r].constructor && i.update(t, this.drawn[r]) ? (t = t.nextSibling, r++) : this.dom.insertBefore(i.draw(), t);
      for (; t; ) {
        let i = t.nextSibling;
        t.remove(), t = i;
      }
      this.drawn = e;
    }
  }
  destroy() {
    this.layer.destroy && this.layer.destroy(this.dom, this.view), this.dom.remove();
  }
}
const bo = /* @__PURE__ */ X.define();
function sg(n) {
  return [
    pt.define((e) => new A6(e, n)),
    bo.of(n)
  ];
}
const lg = !K.ios, Zs = /* @__PURE__ */ X.define({
  combine(n) {
    return bi(n, {
      cursorBlinkRate: 1200,
      drawRangeCursor: !0
    }, {
      cursorBlinkRate: (e, t) => Math.min(e, t),
      drawRangeCursor: (e, t) => e || t
    });
  }
});
function D6(n = {}) {
  return [
    Zs.of(n),
    C6,
    _6,
    M6,
    Lp.of(!0)
  ];
}
function og(n) {
  return n.startState.facet(Zs) != n.state.facet(Zs);
}
const C6 = /* @__PURE__ */ sg({
  above: !0,
  markers(n) {
    let { state: e } = n, t = e.facet(Zs), r = [];
    for (let i of e.selection.ranges) {
      let s = i == e.selection.main;
      if (i.empty ? !s || lg : t.drawRangeCursor) {
        let l = s ? "cm-cursor cm-cursor-primary" : "cm-cursor cm-cursor-secondary", o = i.empty ? i : I.cursor(i.head, i.head > i.anchor ? -1 : 1);
        for (let a of fl.forRange(n, l, o))
          r.push(a);
      }
    }
    return r;
  },
  update(n, e) {
    n.transactions.some((r) => r.selection) && (e.style.animationName = e.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink");
    let t = og(n);
    return t && Ef(n.state, e), n.docChanged || n.selectionSet || t;
  },
  mount(n, e) {
    Ef(e.state, n);
  },
  class: "cm-cursorLayer"
});
function Ef(n, e) {
  e.style.animationDuration = n.facet(Zs).cursorBlinkRate + "ms";
}
const _6 = /* @__PURE__ */ sg({
  above: !1,
  markers(n) {
    return n.state.selection.ranges.map((e) => e.empty ? [] : fl.forRange(n, "cm-selectionBackground", e)).reduce((e, t) => e.concat(t));
  },
  update(n, e) {
    return n.docChanged || n.selectionSet || n.viewportChanged || og(n);
  },
  class: "cm-selectionLayer"
}), ku = {
  ".cm-line": {
    "& ::selection, &::selection": { backgroundColor: "transparent !important" }
  },
  ".cm-content": {
    "& :focus": {
      caretColor: "initial !important",
      "&::selection, & ::selection": {
        backgroundColor: "Highlight !important"
      }
    }
  }
};
lg && (ku[".cm-line"].caretColor = ku[".cm-content"].caretColor = "transparent !important");
const M6 = /* @__PURE__ */ al.highest(/* @__PURE__ */ Q.theme(ku));
function Ff(n, e, t, r, i) {
  e.lastIndex = 0;
  for (let s = n.iterRange(t, r), l = t, o; !s.next().done; l += s.value.length)
    if (!s.lineBreak)
      for (; o = e.exec(s.value); )
        i(l + o.index, o);
}
function T6(n, e) {
  let t = n.visibleRanges;
  if (t.length == 1 && t[0].from == n.viewport.from && t[0].to == n.viewport.to)
    return t;
  let r = [];
  for (let { from: i, to: s } of t)
    i = Math.max(n.state.doc.lineAt(i).from, i - e), s = Math.min(n.state.doc.lineAt(s).to, s + e), r.length && r[r.length - 1].to >= i ? r[r.length - 1].to = s : r.push({ from: i, to: s });
  return r;
}
class E6 {
  /**
  Create a decorator.
  */
  constructor(e) {
    const { regexp: t, decoration: r, decorate: i, boundary: s, maxLength: l = 1e3 } = e;
    if (!t.global)
      throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");
    if (this.regexp = t, i)
      this.addMatch = (o, a, u, h) => i(h, u, u + o[0].length, o, a);
    else if (typeof r == "function")
      this.addMatch = (o, a, u, h) => {
        let c = r(o, a, u);
        c && h(u, u + o[0].length, c);
      };
    else if (r)
      this.addMatch = (o, a, u, h) => h(u, u + o[0].length, r);
    else
      throw new RangeError("Either 'decorate' or 'decoration' should be provided to MatchDecorator");
    this.boundary = s, this.maxLength = l;
  }
  /**
  Compute the full set of decorations for matches in the given
  view's viewport. You'll want to call this when initializing your
  plugin.
  */
  createDeco(e) {
    let t = new ni(), r = t.add.bind(t);
    for (let { from: i, to: s } of T6(e, this.maxLength))
      Ff(e.state.doc, this.regexp, i, s, (l, o) => this.addMatch(o, e, l, r));
    return t.finish();
  }
  /**
  Update a set of decorations for a view update. `deco` _must_ be
  the set of decorations produced by _this_ `MatchDecorator` for
  the view state before the update.
  */
  updateDeco(e, t) {
    let r = 1e9, i = -1;
    return e.docChanged && e.changes.iterChanges((s, l, o, a) => {
      a > e.view.viewport.from && o < e.view.viewport.to && (r = Math.min(o, r), i = Math.max(a, i));
    }), e.viewportChanged || i - r > 1e3 ? this.createDeco(e.view) : i > -1 ? this.updateRange(e.view, t.map(e.changes), r, i) : t;
  }
  updateRange(e, t, r, i) {
    for (let s of e.visibleRanges) {
      let l = Math.max(s.from, r), o = Math.min(s.to, i);
      if (o > l) {
        let a = e.state.doc.lineAt(l), u = a.to < o ? e.state.doc.lineAt(o) : a, h = Math.max(s.from, a.from), c = Math.min(s.to, u.to);
        if (this.boundary) {
          for (; l > a.from; l--)
            if (this.boundary.test(a.text[l - 1 - a.from])) {
              h = l;
              break;
            }
          for (; o < u.to; o++)
            if (this.boundary.test(u.text[o - u.from])) {
              c = o;
              break;
            }
        }
        let f = [], m, g = (v, k, S) => f.push(S.range(v, k));
        if (a == u)
          for (this.regexp.lastIndex = h - a.from; (m = this.regexp.exec(a.text)) && m.index < c - a.from; )
            this.addMatch(m, e, m.index + a.from, g);
        else
          Ff(e.state.doc, this.regexp, h, c, (v, k) => this.addMatch(k, e, v, g));
        t = t.update({ filterFrom: h, filterTo: c, filter: (v, k) => v < h || k > c, add: f });
      }
    }
    return t;
  }
}
const xu = /x/.unicode != null ? "gu" : "g", F6 = /* @__PURE__ */ new RegExp(`[\0-\b
--­؜​‎‏\u2028\u2029‭‮⁦⁧⁩\uFEFF￹-￼]`, xu), B6 = {
  0: "null",
  7: "bell",
  8: "backspace",
  10: "newline",
  11: "vertical tab",
  13: "carriage return",
  27: "escape",
  8203: "zero width space",
  8204: "zero width non-joiner",
  8205: "zero width joiner",
  8206: "left-to-right mark",
  8207: "right-to-left mark",
  8232: "line separator",
  8237: "left-to-right override",
  8238: "right-to-left override",
  8294: "left-to-right isolate",
  8295: "right-to-left isolate",
  8297: "pop directional isolate",
  8233: "paragraph separator",
  65279: "zero width no-break space",
  65532: "object replacement"
};
let Pa = null;
function O6() {
  var n;
  if (Pa == null && typeof document < "u" && document.body) {
    let e = document.body.style;
    Pa = ((n = e.tabSize) !== null && n !== void 0 ? n : e.MozTabSize) != null;
  }
  return Pa || !1;
}
const vo = /* @__PURE__ */ X.define({
  combine(n) {
    let e = bi(n, {
      render: null,
      specialChars: F6,
      addSpecialChars: null
    });
    return (e.replaceTabs = !O6()) && (e.specialChars = new RegExp("	|" + e.specialChars.source, xu)), e.addSpecialChars && (e.specialChars = new RegExp(e.specialChars.source + "|" + e.addSpecialChars.source, xu)), e;
  }
});
function R6(n = {}) {
  return [vo.of(n), L6()];
}
let Bf = null;
function L6() {
  return Bf || (Bf = pt.fromClass(class {
    constructor(n) {
      this.view = n, this.decorations = be.none, this.decorationCache = /* @__PURE__ */ Object.create(null), this.decorator = this.makeDecorator(n.state.facet(vo)), this.decorations = this.decorator.createDeco(n);
    }
    makeDecorator(n) {
      return new E6({
        regexp: n.specialChars,
        decoration: (e, t, r) => {
          let { doc: i } = t.state, s = ft(e[0], 0);
          if (s == 9) {
            let l = i.lineAt(r), o = t.state.tabSize, a = rs(l.text, o, r - l.from);
            return be.replace({
              widget: new P6((o - a % o) * this.view.defaultCharacterWidth / this.view.scaleX)
            });
          }
          return this.decorationCache[s] || (this.decorationCache[s] = be.replace({ widget: new z6(n, s) }));
        },
        boundary: n.replaceTabs ? void 0 : /[^]/
      });
    }
    update(n) {
      let e = n.state.facet(vo);
      n.startState.facet(vo) != e ? (this.decorator = this.makeDecorator(e), this.decorations = this.decorator.createDeco(n.view)) : this.decorations = this.decorator.updateDeco(n, this.decorations);
    }
  }, {
    decorations: (n) => n.decorations
  }));
}
const N6 = "•";
function I6(n) {
  return n >= 32 ? N6 : n == 10 ? "␤" : String.fromCharCode(9216 + n);
}
class z6 extends Xr {
  constructor(e, t) {
    super(), this.options = e, this.code = t;
  }
  eq(e) {
    return e.code == this.code;
  }
  toDOM(e) {
    let t = I6(this.code), r = e.state.phrase("Control character") + " " + (B6[this.code] || "0x" + this.code.toString(16)), i = this.options.render && this.options.render(this.code, r, t);
    if (i)
      return i;
    let s = document.createElement("span");
    return s.textContent = t, s.title = r, s.setAttribute("aria-label", r), s.className = "cm-specialChar", s;
  }
  ignoreEvent() {
    return !1;
  }
}
class P6 extends Xr {
  constructor(e) {
    super(), this.width = e;
  }
  eq(e) {
    return e.width == this.width;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.textContent = "	", e.className = "cm-tab", e.style.width = this.width + "px", e;
  }
  ignoreEvent() {
    return !1;
  }
}
class H6 extends Xr {
  constructor(e) {
    super(), this.content = e;
  }
  toDOM(e) {
    let t = document.createElement("span");
    return t.className = "cm-placeholder", t.style.pointerEvents = "none", t.appendChild(typeof this.content == "string" ? document.createTextNode(this.content) : typeof this.content == "function" ? this.content(e) : this.content.cloneNode(!0)), typeof this.content == "string" ? t.setAttribute("aria-label", "placeholder " + this.content) : t.setAttribute("aria-hidden", "true"), t;
  }
  coordsAt(e) {
    let t = e.firstChild ? Gi(e.firstChild) : [];
    if (!t.length)
      return null;
    let r = window.getComputedStyle(e.parentNode), i = ul(t[0], r.direction != "rtl"), s = parseInt(r.lineHeight);
    return i.bottom - i.top > s * 1.5 ? { left: i.left, right: i.right, top: i.top, bottom: i.top + s } : i;
  }
  ignoreEvent() {
    return !1;
  }
}
function q6(n) {
  return pt.fromClass(class {
    constructor(e) {
      this.view = e, this.placeholder = n ? be.set([be.widget({ widget: new H6(n), side: 1 }).range(0)]) : be.none;
    }
    get decorations() {
      return this.view.state.doc.length ? be.none : this.placeholder;
    }
  }, { decorations: (e) => e.decorations });
}
const Su = 2e3;
function V6(n, e, t) {
  let r = Math.min(e.line, t.line), i = Math.max(e.line, t.line), s = [];
  if (e.off > Su || t.off > Su || e.col < 0 || t.col < 0) {
    let l = Math.min(e.off, t.off), o = Math.max(e.off, t.off);
    for (let a = r; a <= i; a++) {
      let u = n.doc.line(a);
      u.length <= o && s.push(I.range(u.from + l, u.to + o));
    }
  } else {
    let l = Math.min(e.col, t.col), o = Math.max(e.col, t.col);
    for (let a = r; a <= i; a++) {
      let u = n.doc.line(a), h = Q0(u.text, l, n.tabSize, !0);
      if (h < 0)
        s.push(I.cursor(u.to));
      else {
        let c = Q0(u.text, o, n.tabSize);
        s.push(I.range(u.from + h, u.from + c));
      }
    }
  }
  return s;
}
function W6(n, e) {
  let t = n.coordsAtPos(n.viewport.from);
  return t ? Math.round(Math.abs((t.left - e) / n.defaultCharacterWidth)) : -1;
}
function Of(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), r = n.state.doc.lineAt(t), i = t - r.from, s = i > Su ? -1 : i == r.length ? W6(n, e.clientX) : rs(r.text, n.state.tabSize, t - r.from);
  return { line: r.number, col: s, off: i };
}
function U6(n, e) {
  let t = Of(n, e), r = n.state.selection;
  return t ? {
    update(i) {
      if (i.docChanged) {
        let s = i.changes.mapPos(i.startState.doc.line(t.line).from), l = i.state.doc.lineAt(s);
        t = { line: l.number, col: t.col, off: Math.min(t.off, l.length) }, r = r.map(i.changes);
      }
    },
    get(i, s, l) {
      let o = Of(n, i);
      if (!o)
        return r;
      let a = V6(n.state, t, o);
      return a.length ? l ? I.create(a.concat(r.ranges)) : I.create(a) : r;
    }
  } : null;
}
function G6(n) {
  let e = (t) => t.altKey && t.button == 0;
  return Q.mouseSelectionStyle.of((t, r) => e(r) ? U6(t, r) : null);
}
const j6 = {
  Alt: [18, (n) => !!n.altKey],
  Control: [17, (n) => !!n.ctrlKey],
  Shift: [16, (n) => !!n.shiftKey],
  Meta: [91, (n) => !!n.metaKey]
}, $6 = { style: "cursor: crosshair" };
function Y6(n = {}) {
  let [e, t] = j6[n.key || "Alt"], r = pt.fromClass(class {
    constructor(i) {
      this.view = i, this.isDown = !1;
    }
    set(i) {
      this.isDown != i && (this.isDown = i, this.view.update([]));
    }
  }, {
    eventObservers: {
      keydown(i) {
        this.set(i.keyCode == e || t(i));
      },
      keyup(i) {
        (i.keyCode == e || !t(i)) && this.set(!1);
      },
      mousemove(i) {
        this.set(t(i));
      }
    }
  });
  return [
    r,
    Q.contentAttributes.of((i) => {
      var s;
      return !((s = i.plugin(r)) === null || s === void 0) && s.isDown ? $6 : null;
    })
  ];
}
const ms = "-10000px";
class ag {
  constructor(e, t, r, i) {
    this.facet = t, this.createTooltipView = r, this.removeTooltipView = i, this.input = e.state.facet(t), this.tooltips = this.input.filter((l) => l);
    let s = null;
    this.tooltipViews = this.tooltips.map((l) => s = r(l, s));
  }
  update(e, t) {
    var r;
    let i = e.state.facet(this.facet), s = i.filter((a) => a);
    if (i === this.input) {
      for (let a of this.tooltipViews)
        a.update && a.update(e);
      return !1;
    }
    let l = [], o = t ? [] : null;
    for (let a = 0; a < s.length; a++) {
      let u = s[a], h = -1;
      if (u) {
        for (let c = 0; c < this.tooltips.length; c++) {
          let f = this.tooltips[c];
          f && f.create == u.create && (h = c);
        }
        if (h < 0)
          l[a] = this.createTooltipView(u, a ? l[a - 1] : null), o && (o[a] = !!u.above);
        else {
          let c = l[a] = this.tooltipViews[h];
          o && (o[a] = t[h]), c.update && c.update(e);
        }
      }
    }
    for (let a of this.tooltipViews)
      l.indexOf(a) < 0 && (this.removeTooltipView(a), (r = a.destroy) === null || r === void 0 || r.call(a));
    return t && (o.forEach((a, u) => t[u] = a), t.length = o.length), this.input = i, this.tooltips = s, this.tooltipViews = l, !0;
  }
}
function K6(n) {
  let { win: e } = n;
  return { top: 0, left: 0, bottom: e.innerHeight, right: e.innerWidth };
}
const Ha = /* @__PURE__ */ X.define({
  combine: (n) => {
    var e, t, r;
    return {
      position: K.ios ? "absolute" : ((e = n.find((i) => i.position)) === null || e === void 0 ? void 0 : e.position) || "fixed",
      parent: ((t = n.find((i) => i.parent)) === null || t === void 0 ? void 0 : t.parent) || null,
      tooltipSpace: ((r = n.find((i) => i.tooltipSpace)) === null || r === void 0 ? void 0 : r.tooltipSpace) || K6
    };
  }
}), Rf = /* @__PURE__ */ new WeakMap(), mh = /* @__PURE__ */ pt.fromClass(class {
  constructor(n) {
    this.view = n, this.above = [], this.inView = !0, this.madeAbsolute = !1, this.lastTransaction = 0, this.measureTimeout = -1;
    let e = n.state.facet(Ha);
    this.position = e.position, this.parent = e.parent, this.classes = n.themeClasses, this.createContainer(), this.measureReq = { read: this.readMeasure.bind(this), write: this.writeMeasure.bind(this), key: this }, this.resizeObserver = typeof ResizeObserver == "function" ? new ResizeObserver(() => this.measureSoon()) : null, this.manager = new ag(n, ph, (t, r) => this.createTooltip(t, r), (t) => {
      this.resizeObserver && this.resizeObserver.unobserve(t.dom), t.dom.remove();
    }), this.above = this.manager.tooltips.map((t) => !!t.above), this.intersectionObserver = typeof IntersectionObserver == "function" ? new IntersectionObserver((t) => {
      Date.now() > this.lastTransaction - 50 && t.length > 0 && t[t.length - 1].intersectionRatio < 1 && this.measureSoon();
    }, { threshold: [1] }) : null, this.observeIntersection(), n.win.addEventListener("resize", this.measureSoon = this.measureSoon.bind(this)), this.maybeMeasure();
  }
  createContainer() {
    this.parent ? (this.container = document.createElement("div"), this.container.style.position = "relative", this.container.className = this.view.themeClasses, this.parent.appendChild(this.container)) : this.container = this.view.dom;
  }
  observeIntersection() {
    if (this.intersectionObserver) {
      this.intersectionObserver.disconnect();
      for (let n of this.manager.tooltipViews)
        this.intersectionObserver.observe(n.dom);
    }
  }
  measureSoon() {
    this.measureTimeout < 0 && (this.measureTimeout = setTimeout(() => {
      this.measureTimeout = -1, this.maybeMeasure();
    }, 50));
  }
  update(n) {
    n.transactions.length && (this.lastTransaction = Date.now());
    let e = this.manager.update(n, this.above);
    e && this.observeIntersection();
    let t = e || n.geometryChanged, r = n.state.facet(Ha);
    if (r.position != this.position && !this.madeAbsolute) {
      this.position = r.position;
      for (let i of this.manager.tooltipViews)
        i.dom.style.position = this.position;
      t = !0;
    }
    if (r.parent != this.parent) {
      this.parent && this.container.remove(), this.parent = r.parent, this.createContainer();
      for (let i of this.manager.tooltipViews)
        this.container.appendChild(i.dom);
      t = !0;
    } else this.parent && this.view.themeClasses != this.classes && (this.classes = this.container.className = this.view.themeClasses);
    t && this.maybeMeasure();
  }
  createTooltip(n, e) {
    let t = n.create(this.view), r = e ? e.dom : null;
    if (t.dom.classList.add("cm-tooltip"), n.arrow && !t.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")) {
      let i = document.createElement("div");
      i.className = "cm-tooltip-arrow", t.dom.appendChild(i);
    }
    return t.dom.style.position = this.position, t.dom.style.top = ms, t.dom.style.left = "0px", this.container.insertBefore(t.dom, r), t.mount && t.mount(this.view), this.resizeObserver && this.resizeObserver.observe(t.dom), t;
  }
  destroy() {
    var n, e, t;
    this.view.win.removeEventListener("resize", this.measureSoon);
    for (let r of this.manager.tooltipViews)
      r.dom.remove(), (n = r.destroy) === null || n === void 0 || n.call(r);
    this.parent && this.container.remove(), (e = this.resizeObserver) === null || e === void 0 || e.disconnect(), (t = this.intersectionObserver) === null || t === void 0 || t.disconnect(), clearTimeout(this.measureTimeout);
  }
  readMeasure() {
    let n = this.view.dom.getBoundingClientRect(), e = 1, t = 1, r = !1;
    if (this.position == "fixed" && this.manager.tooltipViews.length) {
      let { dom: i } = this.manager.tooltipViews[0];
      if (K.gecko)
        r = i.offsetParent != this.container.ownerDocument.body;
      else if (i.style.top == ms && i.style.left == "0px") {
        let s = i.getBoundingClientRect();
        r = Math.abs(s.top + 1e4) > 1 || Math.abs(s.left) > 1;
      }
    }
    if (r || this.position == "absolute")
      if (this.parent) {
        let i = this.parent.getBoundingClientRect();
        i.width && i.height && (e = i.width / this.parent.offsetWidth, t = i.height / this.parent.offsetHeight);
      } else
        ({ scaleX: e, scaleY: t } = this.view.viewState);
    return {
      editor: n,
      parent: this.parent ? this.container.getBoundingClientRect() : n,
      pos: this.manager.tooltips.map((i, s) => {
        let l = this.manager.tooltipViews[s];
        return l.getCoords ? l.getCoords(i.pos) : this.view.coordsAtPos(i.pos);
      }),
      size: this.manager.tooltipViews.map(({ dom: i }) => i.getBoundingClientRect()),
      space: this.view.state.facet(Ha).tooltipSpace(this.view),
      scaleX: e,
      scaleY: t,
      makeAbsolute: r
    };
  }
  writeMeasure(n) {
    var e;
    if (n.makeAbsolute) {
      this.madeAbsolute = !0, this.position = "absolute";
      for (let o of this.manager.tooltipViews)
        o.dom.style.position = "absolute";
    }
    let { editor: t, space: r, scaleX: i, scaleY: s } = n, l = [];
    for (let o = 0; o < this.manager.tooltips.length; o++) {
      let a = this.manager.tooltips[o], u = this.manager.tooltipViews[o], { dom: h } = u, c = n.pos[o], f = n.size[o];
      if (!c || c.bottom <= Math.max(t.top, r.top) || c.top >= Math.min(t.bottom, r.bottom) || c.right < Math.max(t.left, r.left) - 0.1 || c.left > Math.min(t.right, r.right) + 0.1) {
        h.style.top = ms;
        continue;
      }
      let m = a.arrow ? u.dom.querySelector(".cm-tooltip-arrow") : null, g = m ? 7 : 0, v = f.right - f.left, k = (e = Rf.get(u)) !== null && e !== void 0 ? e : f.bottom - f.top, S = u.offset || Z6, x = this.view.textDirection == Ie.LTR, y = f.width > r.right - r.left ? x ? r.left : r.right - f.width : x ? Math.max(r.left, Math.min(c.left - (m ? 14 : 0) + S.x, r.right - v)) : Math.min(Math.max(r.left, c.left - v + (m ? 14 : 0) - S.x), r.right - v), A = this.above[o];
      !a.strictSide && (A ? c.top - (f.bottom - f.top) - S.y < r.top : c.bottom + (f.bottom - f.top) + S.y > r.bottom) && A == r.bottom - c.bottom > c.top - r.top && (A = this.above[o] = !A);
      let C = (A ? c.top - r.top : r.bottom - c.bottom) - g;
      if (C < k && u.resize !== !1) {
        if (C < this.view.defaultLineHeight) {
          h.style.top = ms;
          continue;
        }
        Rf.set(u, k), h.style.height = (k = C) / s + "px";
      } else h.style.height && (h.style.height = "");
      let T = A ? c.top - k - g - S.y : c.bottom + g + S.y, M = y + v;
      if (u.overlap !== !0)
        for (let L of l)
          L.left < M && L.right > y && L.top < T + k && L.bottom > T && (T = A ? L.top - k - 2 - g : L.bottom + g + 2);
      if (this.position == "absolute" ? (h.style.top = (T - n.parent.top) / s + "px", h.style.left = (y - n.parent.left) / i + "px") : (h.style.top = T / s + "px", h.style.left = y / i + "px"), m) {
        let L = c.left + (x ? S.x : -S.x) - (y + 14 - 7);
        m.style.left = L / i + "px";
      }
      u.overlap !== !0 && l.push({ left: y, top: T, right: M, bottom: T + k }), h.classList.toggle("cm-tooltip-above", A), h.classList.toggle("cm-tooltip-below", !A), u.positioned && u.positioned(n.space);
    }
  }
  maybeMeasure() {
    if (this.manager.tooltips.length && (this.view.inView && this.view.requestMeasure(this.measureReq), this.inView != this.view.inView && (this.inView = this.view.inView, !this.inView)))
      for (let n of this.manager.tooltipViews)
        n.dom.style.top = ms;
  }
}, {
  eventObservers: {
    scroll() {
      this.maybeMeasure();
    }
  }
}), X6 = /* @__PURE__ */ Q.baseTheme({
  ".cm-tooltip": {
    zIndex: 100,
    boxSizing: "border-box"
  },
  "&light .cm-tooltip": {
    border: "1px solid #bbb",
    backgroundColor: "#f5f5f5"
  },
  "&light .cm-tooltip-section:not(:first-child)": {
    borderTop: "1px solid #bbb"
  },
  "&dark .cm-tooltip": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tooltip-arrow": {
    height: "7px",
    width: `${7 * 2}px`,
    position: "absolute",
    zIndex: -1,
    overflow: "hidden",
    "&:before, &:after": {
      content: "''",
      position: "absolute",
      width: 0,
      height: 0,
      borderLeft: "7px solid transparent",
      borderRight: "7px solid transparent"
    },
    ".cm-tooltip-above &": {
      bottom: "-7px",
      "&:before": {
        borderTop: "7px solid #bbb"
      },
      "&:after": {
        borderTop: "7px solid #f5f5f5",
        bottom: "1px"
      }
    },
    ".cm-tooltip-below &": {
      top: "-7px",
      "&:before": {
        borderBottom: "7px solid #bbb"
      },
      "&:after": {
        borderBottom: "7px solid #f5f5f5",
        top: "1px"
      }
    }
  },
  "&dark .cm-tooltip .cm-tooltip-arrow": {
    "&:before": {
      borderTopColor: "#333338",
      borderBottomColor: "#333338"
    },
    "&:after": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    }
  }
}), Z6 = { x: 0, y: 0 }, ph = /* @__PURE__ */ X.define({
  enables: [mh, X6]
}), Ro = /* @__PURE__ */ X.define({
  combine: (n) => n.reduce((e, t) => e.concat(t), [])
});
class aa {
  // Needs to be static so that host tooltip instances always match
  static create(e) {
    return new aa(e);
  }
  constructor(e) {
    this.view = e, this.mounted = !1, this.dom = document.createElement("div"), this.dom.classList.add("cm-tooltip-hover"), this.manager = new ag(e, Ro, (t, r) => this.createHostedView(t, r), (t) => t.dom.remove());
  }
  createHostedView(e, t) {
    let r = e.create(this.view);
    return r.dom.classList.add("cm-tooltip-section"), this.dom.insertBefore(r.dom, t ? t.dom.nextSibling : this.dom.firstChild), this.mounted && r.mount && r.mount(this.view), r;
  }
  mount(e) {
    for (let t of this.manager.tooltipViews)
      t.mount && t.mount(e);
    this.mounted = !0;
  }
  positioned(e) {
    for (let t of this.manager.tooltipViews)
      t.positioned && t.positioned(e);
  }
  update(e) {
    this.manager.update(e);
  }
  destroy() {
    var e;
    for (let t of this.manager.tooltipViews)
      (e = t.destroy) === null || e === void 0 || e.call(t);
  }
  passProp(e) {
    let t;
    for (let r of this.manager.tooltipViews) {
      let i = r[e];
      if (i !== void 0) {
        if (t === void 0)
          t = i;
        else if (t !== i)
          return;
      }
    }
    return t;
  }
  get offset() {
    return this.passProp("offset");
  }
  get getCoords() {
    return this.passProp("getCoords");
  }
  get overlap() {
    return this.passProp("overlap");
  }
  get resize() {
    return this.passProp("resize");
  }
}
const J6 = /* @__PURE__ */ ph.compute([Ro], (n) => {
  let e = n.facet(Ro);
  return e.length === 0 ? null : {
    pos: Math.min(...e.map((t) => t.pos)),
    end: Math.max(...e.map((t) => {
      var r;
      return (r = t.end) !== null && r !== void 0 ? r : t.pos;
    })),
    create: aa.create,
    above: e[0].above,
    arrow: e.some((t) => t.arrow)
  };
});
class Q6 {
  constructor(e, t, r, i, s) {
    this.view = e, this.source = t, this.field = r, this.setHover = i, this.hoverTime = s, this.hoverTimeout = -1, this.restartTimeout = -1, this.pending = null, this.lastMove = { x: 0, y: 0, target: e.dom, time: 0 }, this.checkHover = this.checkHover.bind(this), e.dom.addEventListener("mouseleave", this.mouseleave = this.mouseleave.bind(this)), e.dom.addEventListener("mousemove", this.mousemove = this.mousemove.bind(this));
  }
  update() {
    this.pending && (this.pending = null, clearTimeout(this.restartTimeout), this.restartTimeout = setTimeout(() => this.startHover(), 20));
  }
  get active() {
    return this.view.state.field(this.field);
  }
  checkHover() {
    if (this.hoverTimeout = -1, this.active.length)
      return;
    let e = Date.now() - this.lastMove.time;
    e < this.hoverTime ? this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime - e) : this.startHover();
  }
  startHover() {
    clearTimeout(this.restartTimeout);
    let { view: e, lastMove: t } = this, r = e.docView.nearest(t.target);
    if (!r)
      return;
    let i, s = 1;
    if (r instanceof En)
      i = r.posAtStart;
    else {
      if (i = e.posAtCoords(t), i == null)
        return;
      let o = e.coordsAtPos(i);
      if (!o || t.y < o.top || t.y > o.bottom || t.x < o.left - e.defaultCharacterWidth || t.x > o.right + e.defaultCharacterWidth)
        return;
      let a = e.bidiSpans(e.state.doc.lineAt(i)).find((h) => h.from <= i && h.to >= i), u = a && a.dir == Ie.RTL ? -1 : 1;
      s = t.x < o.left ? -u : u;
    }
    let l = this.source(e, i, s);
    if (l?.then) {
      let o = this.pending = { pos: i };
      l.then((a) => {
        this.pending == o && (this.pending = null, a && !(Array.isArray(a) && !a.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(a) ? a : [a]) }));
      }, (a) => Xt(e.state, a, "hover tooltip"));
    } else l && !(Array.isArray(l) && !l.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(l) ? l : [l]) });
  }
  get tooltip() {
    let e = this.view.plugin(mh), t = e ? e.manager.tooltips.findIndex((r) => r.create == aa.create) : -1;
    return t > -1 ? e.manager.tooltipViews[t] : null;
  }
  mousemove(e) {
    var t, r;
    this.lastMove = { x: e.clientX, y: e.clientY, target: e.target, time: Date.now() }, this.hoverTimeout < 0 && (this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime));
    let { active: i, tooltip: s } = this;
    if (i.length && s && !e7(s.dom, e) || this.pending) {
      let { pos: l } = i[0] || this.pending, o = (r = (t = i[0]) === null || t === void 0 ? void 0 : t.end) !== null && r !== void 0 ? r : l;
      (l == o ? this.view.posAtCoords(this.lastMove) != l : !t7(this.view, l, o, e.clientX, e.clientY)) && (this.view.dispatch({ effects: this.setHover.of([]) }), this.pending = null);
    }
  }
  mouseleave(e) {
    clearTimeout(this.hoverTimeout), this.hoverTimeout = -1;
    let { active: t } = this;
    if (t.length) {
      let { tooltip: r } = this;
      r && r.dom.contains(e.relatedTarget) ? this.watchTooltipLeave(r.dom) : this.view.dispatch({ effects: this.setHover.of([]) });
    }
  }
  watchTooltipLeave(e) {
    let t = (r) => {
      e.removeEventListener("mouseleave", t), this.active.length && !this.view.dom.contains(r.relatedTarget) && this.view.dispatch({ effects: this.setHover.of([]) });
    };
    e.addEventListener("mouseleave", t);
  }
  destroy() {
    clearTimeout(this.hoverTimeout), this.view.dom.removeEventListener("mouseleave", this.mouseleave), this.view.dom.removeEventListener("mousemove", this.mousemove);
  }
}
const Rl = 4;
function e7(n, e) {
  let { left: t, right: r, top: i, bottom: s } = n.getBoundingClientRect(), l;
  if (l = n.querySelector(".cm-tooltip-arrow")) {
    let o = l.getBoundingClientRect();
    i = Math.min(o.top, i), s = Math.max(o.bottom, s);
  }
  return e.clientX >= t - Rl && e.clientX <= r + Rl && e.clientY >= i - Rl && e.clientY <= s + Rl;
}
function t7(n, e, t, r, i, s) {
  let l = n.scrollDOM.getBoundingClientRect(), o = n.documentTop + n.documentPadding.top + n.contentHeight;
  if (l.left > r || l.right < r || l.top > i || Math.min(l.bottom, o) < i)
    return !1;
  let a = n.posAtCoords({ x: r, y: i }, !1);
  return a >= e && a <= t;
}
function r7(n, e = {}) {
  let t = ye.define(), r = Lt.define({
    create() {
      return [];
    },
    update(i, s) {
      if (i.length && (e.hideOnChange && (s.docChanged || s.selection) ? i = [] : e.hideOn && (i = i.filter((l) => !e.hideOn(s, l))), s.docChanged)) {
        let l = [];
        for (let o of i) {
          let a = s.changes.mapPos(o.pos, -1, at.TrackDel);
          if (a != null) {
            let u = Object.assign(/* @__PURE__ */ Object.create(null), o);
            u.pos = a, u.end != null && (u.end = s.changes.mapPos(u.end)), l.push(u);
          }
        }
        i = l;
      }
      for (let l of s.effects)
        l.is(t) && (i = l.value), l.is(i7) && (i = []);
      return i;
    },
    provide: (i) => Ro.from(i)
  });
  return {
    active: r,
    extension: [
      r,
      pt.define((i) => new Q6(
        i,
        n,
        r,
        t,
        e.hoverTime || 300
        /* Hover.Time */
      )),
      J6
    ]
  };
}
function n7(n, e) {
  let t = n.plugin(mh);
  if (!t)
    return null;
  let r = t.manager.tooltips.indexOf(e);
  return r < 0 ? null : t.manager.tooltipViews[r];
}
const i7 = /* @__PURE__ */ ye.define(), Lf = /* @__PURE__ */ X.define({
  combine(n) {
    let e, t;
    for (let r of n)
      e = e || r.topContainer, t = t || r.bottomContainer;
    return { topContainer: e, bottomContainer: t };
  }
});
function s7(n, e) {
  let t = n.plugin(ug), r = t ? t.specs.indexOf(e) : -1;
  return r > -1 ? t.panels[r] : null;
}
const ug = /* @__PURE__ */ pt.fromClass(class {
  constructor(n) {
    this.input = n.state.facet(Au), this.specs = this.input.filter((t) => t), this.panels = this.specs.map((t) => t(n));
    let e = n.state.facet(Lf);
    this.top = new Ll(n, !0, e.topContainer), this.bottom = new Ll(n, !1, e.bottomContainer), this.top.sync(this.panels.filter((t) => t.top)), this.bottom.sync(this.panels.filter((t) => !t.top));
    for (let t of this.panels)
      t.dom.classList.add("cm-panel"), t.mount && t.mount();
  }
  update(n) {
    let e = n.state.facet(Lf);
    this.top.container != e.topContainer && (this.top.sync([]), this.top = new Ll(n.view, !0, e.topContainer)), this.bottom.container != e.bottomContainer && (this.bottom.sync([]), this.bottom = new Ll(n.view, !1, e.bottomContainer)), this.top.syncClasses(), this.bottom.syncClasses();
    let t = n.state.facet(Au);
    if (t != this.input) {
      let r = t.filter((a) => a), i = [], s = [], l = [], o = [];
      for (let a of r) {
        let u = this.specs.indexOf(a), h;
        u < 0 ? (h = a(n.view), o.push(h)) : (h = this.panels[u], h.update && h.update(n)), i.push(h), (h.top ? s : l).push(h);
      }
      this.specs = r, this.panels = i, this.top.sync(s), this.bottom.sync(l);
      for (let a of o)
        a.dom.classList.add("cm-panel"), a.mount && a.mount();
    } else
      for (let r of this.panels)
        r.update && r.update(n);
  }
  destroy() {
    this.top.sync([]), this.bottom.sync([]);
  }
}, {
  provide: (n) => Q.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return t && { top: t.top.scrollMargin(), bottom: t.bottom.scrollMargin() };
  })
});
class Ll {
  constructor(e, t, r) {
    this.view = e, this.top = t, this.container = r, this.dom = void 0, this.classes = "", this.panels = [], this.syncClasses();
  }
  sync(e) {
    for (let t of this.panels)
      t.destroy && e.indexOf(t) < 0 && t.destroy();
    this.panels = e, this.syncDOM();
  }
  syncDOM() {
    if (this.panels.length == 0) {
      this.dom && (this.dom.remove(), this.dom = void 0);
      return;
    }
    if (!this.dom) {
      this.dom = document.createElement("div"), this.dom.className = this.top ? "cm-panels cm-panels-top" : "cm-panels cm-panels-bottom", this.dom.style[this.top ? "top" : "bottom"] = "0";
      let t = this.container || this.view.dom;
      t.insertBefore(this.dom, this.top ? t.firstChild : null);
    }
    let e = this.dom.firstChild;
    for (let t of this.panels)
      if (t.dom.parentNode == this.dom) {
        for (; e != t.dom; )
          e = Nf(e);
        e = e.nextSibling;
      } else
        this.dom.insertBefore(t.dom, e);
    for (; e; )
      e = Nf(e);
  }
  scrollMargin() {
    return !this.dom || this.container ? 0 : Math.max(0, this.top ? this.dom.getBoundingClientRect().bottom - Math.max(0, this.view.scrollDOM.getBoundingClientRect().top) : Math.min(innerHeight, this.view.scrollDOM.getBoundingClientRect().bottom) - this.dom.getBoundingClientRect().top);
  }
  syncClasses() {
    if (!(!this.container || this.classes == this.view.themeClasses)) {
      for (let e of this.classes.split(" "))
        e && this.container.classList.remove(e);
      for (let e of (this.classes = this.view.themeClasses).split(" "))
        e && this.container.classList.add(e);
    }
  }
}
function Nf(n) {
  let e = n.nextSibling;
  return n.remove(), e;
}
const Au = /* @__PURE__ */ X.define({
  enables: ug
});
class Nn extends ri {
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  Compare this marker to another marker of the same type.
  */
  eq(e) {
    return !1;
  }
  /**
  Called if the marker has a `toDOM` method and its representation
  was removed from a gutter.
  */
  destroy(e) {
  }
}
Nn.prototype.elementClass = "";
Nn.prototype.toDOM = void 0;
Nn.prototype.mapMode = at.TrackBefore;
Nn.prototype.startSide = Nn.prototype.endSide = -1;
Nn.prototype.point = !0;
const qa = /* @__PURE__ */ X.define(), l7 = /* @__PURE__ */ X.define(), o7 = {
  class: "",
  renderEmptyElements: !1,
  elementStyle: "",
  markers: () => Ce.empty,
  lineMarker: () => null,
  widgetMarker: () => null,
  lineMarkerChange: null,
  initialSpacer: null,
  updateSpacer: null,
  domEventHandlers: {}
}, zs = /* @__PURE__ */ X.define();
function a7(n) {
  return [hg(), zs.of(Object.assign(Object.assign({}, o7), n))];
}
const If = /* @__PURE__ */ X.define({
  combine: (n) => n.some((e) => e)
});
function hg(n) {
  return [
    u7
  ];
}
const u7 = /* @__PURE__ */ pt.fromClass(class {
  constructor(n) {
    this.view = n, this.prevViewport = n.viewport, this.dom = document.createElement("div"), this.dom.className = "cm-gutters", this.dom.setAttribute("aria-hidden", "true"), this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px", this.gutters = n.state.facet(zs).map((e) => new Pf(n, e));
    for (let e of this.gutters)
      this.dom.appendChild(e.dom);
    this.fixed = !n.state.facet(If), this.fixed && (this.dom.style.position = "sticky"), this.syncGutters(!1), n.scrollDOM.insertBefore(this.dom, n.contentDOM);
  }
  update(n) {
    if (this.updateGutters(n)) {
      let e = this.prevViewport, t = n.view.viewport, r = Math.min(e.to, t.to) - Math.max(e.from, t.from);
      this.syncGutters(r < (t.to - t.from) * 0.8);
    }
    n.geometryChanged && (this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px"), this.view.state.facet(If) != !this.fixed && (this.fixed = !this.fixed, this.dom.style.position = this.fixed ? "sticky" : ""), this.prevViewport = n.view.viewport;
  }
  syncGutters(n) {
    let e = this.dom.nextSibling;
    n && this.dom.remove();
    let t = Ce.iter(this.view.state.facet(qa), this.view.viewport.from), r = [], i = this.gutters.map((s) => new h7(s, this.view.viewport, -this.view.documentPadding.top));
    for (let s of this.view.viewportLineBlocks)
      if (r.length && (r = []), Array.isArray(s.type)) {
        let l = !0;
        for (let o of s.type)
          if (o.type == St.Text && l) {
            Du(t, r, o.from);
            for (let a of i)
              a.line(this.view, o, r);
            l = !1;
          } else if (o.widget)
            for (let a of i)
              a.widget(this.view, o);
      } else if (s.type == St.Text) {
        Du(t, r, s.from);
        for (let l of i)
          l.line(this.view, s, r);
      } else if (s.widget)
        for (let l of i)
          l.widget(this.view, s);
    for (let s of i)
      s.finish();
    n && this.view.scrollDOM.insertBefore(this.dom, e);
  }
  updateGutters(n) {
    let e = n.startState.facet(zs), t = n.state.facet(zs), r = n.docChanged || n.heightChanged || n.viewportChanged || !Ce.eq(n.startState.facet(qa), n.state.facet(qa), n.view.viewport.from, n.view.viewport.to);
    if (e == t)
      for (let i of this.gutters)
        i.update(n) && (r = !0);
    else {
      r = !0;
      let i = [];
      for (let s of t) {
        let l = e.indexOf(s);
        l < 0 ? i.push(new Pf(this.view, s)) : (this.gutters[l].update(n), i.push(this.gutters[l]));
      }
      for (let s of this.gutters)
        s.dom.remove(), i.indexOf(s) < 0 && s.destroy();
      for (let s of i)
        this.dom.appendChild(s.dom);
      this.gutters = i;
    }
    return r;
  }
  destroy() {
    for (let n of this.gutters)
      n.destroy();
    this.dom.remove();
  }
}, {
  provide: (n) => Q.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return !t || t.gutters.length == 0 || !t.fixed ? null : e.textDirection == Ie.LTR ? { left: t.dom.offsetWidth * e.scaleX } : { right: t.dom.offsetWidth * e.scaleX };
  })
});
function zf(n) {
  return Array.isArray(n) ? n : [n];
}
function Du(n, e, t) {
  for (; n.value && n.from <= t; )
    n.from == t && e.push(n.value), n.next();
}
class h7 {
  constructor(e, t, r) {
    this.gutter = e, this.height = r, this.i = 0, this.cursor = Ce.iter(e.markers, t.from);
  }
  addElement(e, t, r) {
    let { gutter: i } = this, s = (t.top - this.height) / e.scaleY, l = t.height / e.scaleY;
    if (this.i == i.elements.length) {
      let o = new cg(e, l, s, r);
      i.elements.push(o), i.dom.appendChild(o.dom);
    } else
      i.elements[this.i].update(e, l, s, r);
    this.height = t.bottom, this.i++;
  }
  line(e, t, r) {
    let i = [];
    Du(this.cursor, i, t.from), r.length && (i = i.concat(r));
    let s = this.gutter.config.lineMarker(e, t, i);
    s && i.unshift(s);
    let l = this.gutter;
    i.length == 0 && !l.config.renderEmptyElements || this.addElement(e, t, i);
  }
  widget(e, t) {
    let r = this.gutter.config.widgetMarker(e, t.widget, t), i = r ? [r] : null;
    for (let s of e.state.facet(l7)) {
      let l = s(e, t.widget, t);
      l && (i || (i = [])).push(l);
    }
    i && this.addElement(e, t, i);
  }
  finish() {
    let e = this.gutter;
    for (; e.elements.length > this.i; ) {
      let t = e.elements.pop();
      e.dom.removeChild(t.dom), t.destroy();
    }
  }
}
class Pf {
  constructor(e, t) {
    this.view = e, this.config = t, this.elements = [], this.spacer = null, this.dom = document.createElement("div"), this.dom.className = "cm-gutter" + (this.config.class ? " " + this.config.class : "");
    for (let r in t.domEventHandlers)
      this.dom.addEventListener(r, (i) => {
        let s = i.target, l;
        if (s != this.dom && this.dom.contains(s)) {
          for (; s.parentNode != this.dom; )
            s = s.parentNode;
          let a = s.getBoundingClientRect();
          l = (a.top + a.bottom) / 2;
        } else
          l = i.clientY;
        let o = e.lineBlockAtHeight(l - e.documentTop);
        t.domEventHandlers[r](e, o, i) && i.preventDefault();
      });
    this.markers = zf(t.markers(e)), t.initialSpacer && (this.spacer = new cg(e, 0, 0, [t.initialSpacer(e)]), this.dom.appendChild(this.spacer.dom), this.spacer.dom.style.cssText += "visibility: hidden; pointer-events: none");
  }
  update(e) {
    let t = this.markers;
    if (this.markers = zf(this.config.markers(e.view)), this.spacer && this.config.updateSpacer) {
      let i = this.config.updateSpacer(this.spacer.markers[0], e);
      i != this.spacer.markers[0] && this.spacer.update(e.view, 0, 0, [i]);
    }
    let r = e.view.viewport;
    return !Ce.eq(this.markers, t, r.from, r.to) || (this.config.lineMarkerChange ? this.config.lineMarkerChange(e) : !1);
  }
  destroy() {
    for (let e of this.elements)
      e.destroy();
  }
}
class cg {
  constructor(e, t, r, i) {
    this.height = -1, this.above = 0, this.markers = [], this.dom = document.createElement("div"), this.dom.className = "cm-gutterElement", this.update(e, t, r, i);
  }
  update(e, t, r, i) {
    this.height != t && (this.height = t, this.dom.style.height = t + "px"), this.above != r && (this.dom.style.marginTop = (this.above = r) ? r + "px" : ""), c7(this.markers, i) || this.setMarkers(e, i);
  }
  setMarkers(e, t) {
    let r = "cm-gutterElement", i = this.dom.firstChild;
    for (let s = 0, l = 0; ; ) {
      let o = l, a = s < t.length ? t[s++] : null, u = !1;
      if (a) {
        let h = a.elementClass;
        h && (r += " " + h);
        for (let c = l; c < this.markers.length; c++)
          if (this.markers[c].compare(a)) {
            o = c, u = !0;
            break;
          }
      } else
        o = this.markers.length;
      for (; l < o; ) {
        let h = this.markers[l++];
        if (h.toDOM) {
          h.destroy(i);
          let c = i.nextSibling;
          i.remove(), i = c;
        }
      }
      if (!a)
        break;
      a.toDOM && (u ? i = i.nextSibling : this.dom.insertBefore(a.toDOM(e), i)), u && l++;
    }
    this.dom.className = r, this.markers = t;
  }
  destroy() {
    this.setMarkers(null, []);
  }
}
function c7(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (!n[t].compare(e[t]))
      return !1;
  return !0;
}
const f7 = /* @__PURE__ */ X.define(), d7 = /* @__PURE__ */ X.define(), Fi = /* @__PURE__ */ X.define({
  combine(n) {
    return bi(n, { formatNumber: String, domEventHandlers: {} }, {
      domEventHandlers(e, t) {
        let r = Object.assign({}, e);
        for (let i in t) {
          let s = r[i], l = t[i];
          r[i] = s ? (o, a, u) => s(o, a, u) || l(o, a, u) : l;
        }
        return r;
      }
    });
  }
});
class Va extends Nn {
  constructor(e) {
    super(), this.number = e;
  }
  eq(e) {
    return this.number == e.number;
  }
  toDOM() {
    return document.createTextNode(this.number);
  }
}
function Wa(n, e) {
  return n.state.facet(Fi).formatNumber(e, n.state);
}
const m7 = /* @__PURE__ */ zs.compute([Fi], (n) => ({
  class: "cm-lineNumbers",
  renderEmptyElements: !1,
  markers(e) {
    return e.state.facet(f7);
  },
  lineMarker(e, t, r) {
    return r.some((i) => i.toDOM) ? null : new Va(Wa(e, e.state.doc.lineAt(t.from).number));
  },
  widgetMarker: (e, t, r) => {
    for (let i of e.state.facet(d7)) {
      let s = i(e, t, r);
      if (s)
        return s;
    }
    return null;
  },
  lineMarkerChange: (e) => e.startState.facet(Fi) != e.state.facet(Fi),
  initialSpacer(e) {
    return new Va(Wa(e, Hf(e.state.doc.lines)));
  },
  updateSpacer(e, t) {
    let r = Wa(t.view, Hf(t.view.state.doc.lines));
    return r == e.number ? e : new Va(r);
  },
  domEventHandlers: n.facet(Fi).domEventHandlers
}));
function p7(n = {}) {
  return [
    Fi.of(n),
    hg(),
    m7
  ];
}
function Hf(n) {
  let e = 9;
  for (; e < n; )
    e = e * 10 + 9;
  return e;
}
const g7 = 1024;
let b7 = 0;
class Zt {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
class we {
  /**
  Create a new node prop type.
  */
  constructor(e = {}) {
    this.id = b7++, this.perNode = !!e.perNode, this.deserialize = e.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(e) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e != "function" && (e = Dt.match(e)), (t) => {
      let r = e(t);
      return r === void 0 ? null : [this, r];
    };
  }
}
we.closedBy = new we({ deserialize: (n) => n.split(" ") });
we.openedBy = new we({ deserialize: (n) => n.split(" ") });
we.group = new we({ deserialize: (n) => n.split(" ") });
we.isolate = new we({ deserialize: (n) => {
  if (n && n != "rtl" && n != "ltr" && n != "auto")
    throw new RangeError("Invalid value for isolate: " + n);
  return n || "auto";
} });
we.contextHash = new we({ perNode: !0 });
we.lookAhead = new we({ perNode: !0 });
we.mounted = new we({ perNode: !0 });
class Js {
  constructor(e, t, r) {
    this.tree = e, this.overlay = t, this.parser = r;
  }
  /**
  @internal
  */
  static get(e) {
    return e && e.props && e.props[we.mounted.id];
  }
}
const v7 = /* @__PURE__ */ Object.create(null);
class Dt {
  /**
  @internal
  */
  constructor(e, t, r, i = 0) {
    this.name = e, this.props = t, this.id = r, this.flags = i;
  }
  /**
  Define a node type.
  */
  static define(e) {
    let t = e.props && e.props.length ? /* @__PURE__ */ Object.create(null) : v7, r = (e.top ? 1 : 0) | (e.skipped ? 2 : 0) | (e.error ? 4 : 0) | (e.name == null ? 8 : 0), i = new Dt(e.name || "", t, e.id, r);
    if (e.props) {
      for (let s of e.props)
        if (Array.isArray(s) || (s = s(i)), s) {
          if (s[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          t[s[0].id] = s[1];
        }
    }
    return i;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(e) {
    return this.props[e.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(e) {
    if (typeof e == "string") {
      if (this.name == e)
        return !0;
      let t = this.prop(we.group);
      return t ? t.indexOf(e) > -1 : !1;
    }
    return this.id == e;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(e) {
    let t = /* @__PURE__ */ Object.create(null);
    for (let r in e)
      for (let i of r.split(" "))
        t[i] = e[r];
    return (r) => {
      for (let i = r.prop(we.group), s = -1; s < (i ? i.length : 0); s++) {
        let l = t[s < 0 ? r.name : i[s]];
        if (l)
          return l;
      }
    };
  }
}
Dt.none = new Dt(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class gh {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(e) {
    this.types = e;
    for (let t = 0; t < e.length; t++)
      if (e[t].id != t)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...e) {
    let t = [];
    for (let r of this.types) {
      let i = null;
      for (let s of e) {
        let l = s(r);
        l && (i || (i = Object.assign({}, r.props)), i[l[0].id] = l[1]);
      }
      t.push(i ? new Dt(r.name, i, r.id, r.flags) : r);
    }
    return new gh(t);
  }
}
const Nl = /* @__PURE__ */ new WeakMap(), qf = /* @__PURE__ */ new WeakMap();
var Ve;
(function(n) {
  n[n.ExcludeBuffers = 1] = "ExcludeBuffers", n[n.IncludeAnonymous = 2] = "IncludeAnonymous", n[n.IgnoreMounts = 4] = "IgnoreMounts", n[n.IgnoreOverlays = 8] = "IgnoreOverlays";
})(Ve || (Ve = {}));
class Le {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(e, t, r, i, s) {
    if (this.type = e, this.children = t, this.positions = r, this.length = i, this.props = null, s && s.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [l, o] of s)
        this.props[typeof l == "number" ? l : l.id] = o;
    }
  }
  /**
  @internal
  */
  toString() {
    let e = Js.get(this);
    if (e && !e.overlay)
      return e.tree.toString();
    let t = "";
    for (let r of this.children) {
      let i = r.toString();
      i && (t && (t += ","), t += i);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (t.length ? "(" + t + ")" : "") : t;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(e = 0) {
    return new Lo(this.topNode, e);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(e, t = 0, r = 0) {
    let i = Nl.get(this) || this.topNode, s = new Lo(i);
    return s.moveTo(e, t), Nl.set(this, s._tree), s;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new mt(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(e, t = 0) {
    let r = Qs(Nl.get(this) || this.topNode, e, t, !1);
    return Nl.set(this, r), r;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(e, t = 0) {
    let r = Qs(qf.get(this) || this.topNode, e, t, !0);
    return qf.set(this, r), r;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(e, t = 0) {
    return k7(this, e, t);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(e) {
    let { enter: t, leave: r, from: i = 0, to: s = this.length } = e, l = e.mode || 0, o = (l & Ve.IncludeAnonymous) > 0;
    for (let a = this.cursor(l | Ve.IncludeAnonymous); ; ) {
      let u = !1;
      if (a.from <= s && a.to >= i && (!o && a.type.isAnonymous || t(a) !== !1)) {
        if (a.firstChild())
          continue;
        u = !0;
      }
      for (; u && r && (o || !a.type.isAnonymous) && r(a), !a.nextSibling(); ) {
        if (!a.parent())
          return;
        u = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(e) {
    return e.perNode ? this.props ? this.props[e.id] : void 0 : this.type.prop(e);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let e = [];
    if (this.props)
      for (let t in this.props)
        e.push([+t, this.props[t]]);
    return e;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(e = {}) {
    return this.children.length <= 8 ? this : yh(Dt.none, this.children, this.positions, 0, this.children.length, 0, this.length, (t, r, i) => new Le(this.type, t, r, i, this.propValues), e.makeTree || ((t, r, i) => new Le(Dt.none, t, r, i)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(e) {
    return x7(e);
  }
}
Le.empty = new Le(Dt.none, [], [], 0);
class bh {
  constructor(e, t) {
    this.buffer = e, this.index = t;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new bh(this.buffer, this.index);
  }
}
class In {
  /**
  Create a tree buffer.
  */
  constructor(e, t, r) {
    this.buffer = e, this.length = t, this.set = r;
  }
  /**
  @internal
  */
  get type() {
    return Dt.none;
  }
  /**
  @internal
  */
  toString() {
    let e = [];
    for (let t = 0; t < this.buffer.length; )
      e.push(this.childString(t)), t = this.buffer[t + 3];
    return e.join(",");
  }
  /**
  @internal
  */
  childString(e) {
    let t = this.buffer[e], r = this.buffer[e + 3], i = this.set.types[t], s = i.name;
    if (/\W/.test(s) && !i.isError && (s = JSON.stringify(s)), e += 4, r == e)
      return s;
    let l = [];
    for (; e < r; )
      l.push(this.childString(e)), e = this.buffer[e + 3];
    return s + "(" + l.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(e, t, r, i, s) {
    let { buffer: l } = this, o = -1;
    for (let a = e; a != t && !(fg(s, i, l[a + 1], l[a + 2]) && (o = a, r > 0)); a = l[a + 3])
      ;
    return o;
  }
  /**
  @internal
  */
  slice(e, t, r) {
    let i = this.buffer, s = new Uint16Array(t - e), l = 0;
    for (let o = e, a = 0; o < t; ) {
      s[a++] = i[o++], s[a++] = i[o++] - r;
      let u = s[a++] = i[o++] - r;
      s[a++] = i[o++] - e, l = Math.max(l, u);
    }
    return new In(s, l, this.set);
  }
}
function fg(n, e, t, r) {
  switch (n) {
    case -2:
      return t < e;
    case -1:
      return r >= e && t < e;
    case 0:
      return t < e && r > e;
    case 1:
      return t <= e && r > e;
    case 2:
      return r > e;
    case 4:
      return !0;
  }
}
function Qs(n, e, t, r) {
  for (var i; n.from == n.to || (t < 1 ? n.from >= e : n.from > e) || (t > -1 ? n.to <= e : n.to < e); ) {
    let l = !r && n instanceof mt && n.index < 0 ? null : n.parent;
    if (!l)
      return n;
    n = l;
  }
  let s = r ? 0 : Ve.IgnoreOverlays;
  if (r)
    for (let l = n, o = l.parent; o; l = o, o = l.parent)
      l instanceof mt && l.index < 0 && ((i = o.enter(e, t, s)) === null || i === void 0 ? void 0 : i.from) != l.from && (n = o);
  for (; ; ) {
    let l = n.enter(e, t, s);
    if (!l)
      return n;
    n = l;
  }
}
class dg {
  cursor(e = 0) {
    return new Lo(this, e);
  }
  getChild(e, t = null, r = null) {
    let i = Vf(this, e, t, r);
    return i.length ? i[0] : null;
  }
  getChildren(e, t = null, r = null) {
    return Vf(this, e, t, r);
  }
  resolve(e, t = 0) {
    return Qs(this, e, t, !1);
  }
  resolveInner(e, t = 0) {
    return Qs(this, e, t, !0);
  }
  matchContext(e) {
    return Cu(this.parent, e);
  }
  enterUnfinishedNodesBefore(e) {
    let t = this.childBefore(e), r = this;
    for (; t; ) {
      let i = t.lastChild;
      if (!i || i.to != t.to)
        break;
      i.type.isError && i.from == i.to ? (r = t, t = i.prevSibling) : t = i;
    }
    return r;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class mt extends dg {
  constructor(e, t, r, i) {
    super(), this._tree = e, this.from = t, this.index = r, this._parent = i;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(e, t, r, i, s = 0) {
    for (let l = this; ; ) {
      for (let { children: o, positions: a } = l._tree, u = t > 0 ? o.length : -1; e != u; e += t) {
        let h = o[e], c = a[e] + l.from;
        if (fg(i, r, c, c + h.length)) {
          if (h instanceof In) {
            if (s & Ve.ExcludeBuffers)
              continue;
            let f = h.findChild(0, h.buffer.length, t, r - c, i);
            if (f > -1)
              return new Pr(new y7(l, h, e, c), null, f);
          } else if (s & Ve.IncludeAnonymous || !h.type.isAnonymous || vh(h)) {
            let f;
            if (!(s & Ve.IgnoreMounts) && (f = Js.get(h)) && !f.overlay)
              return new mt(f.tree, c, e, l);
            let m = new mt(h, c, e, l);
            return s & Ve.IncludeAnonymous || !m.type.isAnonymous ? m : m.nextChild(t < 0 ? h.children.length - 1 : 0, t, r, i);
          }
        }
      }
      if (s & Ve.IncludeAnonymous || !l.type.isAnonymous || (l.index >= 0 ? e = l.index + t : e = t < 0 ? -1 : l._parent._tree.children.length, l = l._parent, !l))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.nextChild(
      0,
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, r = 0) {
    let i;
    if (!(r & Ve.IgnoreOverlays) && (i = Js.get(this._tree)) && i.overlay) {
      let s = e - this.from;
      for (let { from: l, to: o } of i.overlay)
        if ((t > 0 ? l <= s : l < s) && (t < 0 ? o >= s : o > s))
          return new mt(i.tree, i.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, e, t, r);
  }
  nextSignificantParent() {
    let e = this;
    for (; e.type.isAnonymous && e._parent; )
      e = e._parent;
    return e;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function Vf(n, e, t, r) {
  let i = n.cursor(), s = [];
  if (!i.firstChild())
    return s;
  if (t != null) {
    for (let l = !1; !l; )
      if (l = i.type.is(t), !i.nextSibling())
        return s;
  }
  for (; ; ) {
    if (r != null && i.type.is(r))
      return s;
    if (i.type.is(e) && s.push(i.node), !i.nextSibling())
      return r == null ? s : [];
  }
}
function Cu(n, e, t = e.length - 1) {
  for (let r = n; t >= 0; r = r.parent) {
    if (!r)
      return !1;
    if (!r.type.isAnonymous) {
      if (e[t] && e[t] != r.name)
        return !1;
      t--;
    }
  }
  return !0;
}
class y7 {
  constructor(e, t, r, i) {
    this.parent = e, this.buffer = t, this.index = r, this.start = i;
  }
}
class Pr extends dg {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(e, t, r) {
    super(), this.context = e, this._parent = t, this.index = r, this.type = e.buffer.set.types[e.buffer.buffer[r]];
  }
  child(e, t, r) {
    let { buffer: i } = this.context, s = i.findChild(this.index + 4, i.buffer[this.index + 3], e, t - this.context.start, r);
    return s < 0 ? null : new Pr(this.context, this, s);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.child(
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.child(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, r = 0) {
    if (r & Ve.ExcludeBuffers)
      return null;
    let { buffer: i } = this.context, s = i.findChild(this.index + 4, i.buffer[this.index + 3], t > 0 ? 1 : -1, e - this.context.start, t);
    return s < 0 ? null : new Pr(this.context, this, s);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(e) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + e,
      e,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: e } = this.context, t = e.buffer[this.index + 3];
    return t < (this._parent ? e.buffer[this._parent.index + 3] : e.buffer.length) ? new Pr(this.context, this._parent, t) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: e } = this.context, t = this._parent ? this._parent.index + 4 : 0;
    return this.index == t ? this.externalSibling(-1) : new Pr(this.context, this._parent, e.findChild(
      t,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let e = [], t = [], { buffer: r } = this.context, i = this.index + 4, s = r.buffer[this.index + 3];
    if (s > i) {
      let l = r.buffer[this.index + 1];
      e.push(r.slice(i, s, l)), t.push(0);
    }
    return new Le(this.type, e, t, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function mg(n) {
  if (!n.length)
    return null;
  let e = 0, t = n[0];
  for (let s = 1; s < n.length; s++) {
    let l = n[s];
    (l.from > t.from || l.to < t.to) && (t = l, e = s);
  }
  let r = t instanceof mt && t.index < 0 ? null : t.parent, i = n.slice();
  return r ? i[e] = r : i.splice(e, 1), new w7(i, t);
}
class w7 {
  constructor(e, t) {
    this.heads = e, this.node = t;
  }
  get next() {
    return mg(this.heads);
  }
}
function k7(n, e, t) {
  let r = n.resolveInner(e, t), i = null;
  for (let s = r instanceof mt ? r : r.context.parent; s; s = s.parent)
    if (s.index < 0) {
      let l = s.parent;
      (i || (i = [r])).push(l.resolve(e, t)), s = l;
    } else {
      let l = Js.get(s.tree);
      if (l && l.overlay && l.overlay[0].from <= e && l.overlay[l.overlay.length - 1].to >= e) {
        let o = new mt(l.tree, l.overlay[0].from + s.from, -1, s);
        (i || (i = [r])).push(Qs(o, e, t, !1));
      }
    }
  return i ? mg(i) : r;
}
class Lo {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(e, t = 0) {
    if (this.mode = t, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, e instanceof mt)
      this.yieldNode(e);
    else {
      this._tree = e.context.parent, this.buffer = e.context;
      for (let r = e._parent; r; r = r._parent)
        this.stack.unshift(r.index);
      this.bufferNode = e, this.yieldBuf(e.index);
    }
  }
  yieldNode(e) {
    return e ? (this._tree = e, this.type = e.type, this.from = e.from, this.to = e.to, !0) : !1;
  }
  yieldBuf(e, t) {
    this.index = e;
    let { start: r, buffer: i } = this.buffer;
    return this.type = t || i.set.types[i.buffer[e]], this.from = r + i.buffer[e + 1], this.to = r + i.buffer[e + 2], !0;
  }
  /**
  @internal
  */
  yield(e) {
    return e ? e instanceof mt ? (this.buffer = null, this.yieldNode(e)) : (this.buffer = e.context, this.yieldBuf(e.index, e.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(e, t, r) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e < 0 ? this._tree._tree.children.length - 1 : 0, e, t, r, this.mode));
    let { buffer: i } = this.buffer, s = i.findChild(this.index + 4, i.buffer[this.index + 3], e, t - this.buffer.start, r);
    return s < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(s));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(e) {
    return this.enterChild(
      1,
      e,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(e) {
    return this.enterChild(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(e, t, r = this.mode) {
    return this.buffer ? r & Ve.ExcludeBuffers ? !1 : this.enterChild(1, e, t) : this.yield(this._tree.enter(e, t, r));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & Ve.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let e = this.mode & Ve.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e);
  }
  /**
  @internal
  */
  sibling(e) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e, e, 0, 4, this.mode)) : !1;
    let { buffer: t } = this.buffer, r = this.stack.length - 1;
    if (e < 0) {
      let i = r < 0 ? 0 : this.stack[r] + 4;
      if (this.index != i)
        return this.yieldBuf(t.findChild(
          i,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let i = t.buffer[this.index + 3];
      if (i < (r < 0 ? t.buffer.length : t.buffer[this.stack[r] + 3]))
        return this.yieldBuf(i);
    }
    return r < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + e, e, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(e) {
    let t, r, { buffer: i } = this;
    if (i) {
      if (e > 0) {
        if (this.index < i.buffer.buffer.length)
          return !1;
      } else
        for (let s = 0; s < this.index; s++)
          if (i.buffer.buffer[s + 3] < this.index)
            return !1;
      ({ index: t, parent: r } = i);
    } else
      ({ index: t, _parent: r } = this._tree);
    for (; r; { index: t, _parent: r } = r)
      if (t > -1)
        for (let s = t + e, l = e < 0 ? -1 : r._tree.children.length; s != l; s += e) {
          let o = r._tree.children[s];
          if (this.mode & Ve.IncludeAnonymous || o instanceof In || !o.type.isAnonymous || vh(o))
            return !1;
        }
    return !0;
  }
  move(e, t) {
    if (t && this.enterChild(
      e,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(e))
        return !0;
      if (this.atLastNode(e) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(e = !0) {
    return this.move(1, e);
  }
  /**
  Move to the next node in a last-to-first pre-order traversal. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(e = !0) {
    return this.move(-1, e);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(e, t = 0) {
    for (; (this.from == this.to || (t < 1 ? this.from >= e : this.from > e) || (t > -1 ? this.to <= e : this.to < e)) && this.parent(); )
      ;
    for (; this.enterChild(1, e, t); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let e = this.bufferNode, t = null, r = 0;
    if (e && e.context == this.buffer)
      e: for (let i = this.index, s = this.stack.length; s >= 0; ) {
        for (let l = e; l; l = l._parent)
          if (l.index == i) {
            if (i == this.index)
              return l;
            t = l, r = s + 1;
            break e;
          }
        i = this.stack[--s];
      }
    for (let i = r; i < this.stack.length; i++)
      t = new Pr(this.buffer, t, this.stack[i]);
    return this.bufferNode = new Pr(this.buffer, t, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(e, t) {
    for (let r = 0; ; ) {
      let i = !1;
      if (this.type.isAnonymous || e(this) !== !1) {
        if (this.firstChild()) {
          r++;
          continue;
        }
        this.type.isAnonymous || (i = !0);
      }
      for (; ; ) {
        if (i && t && t(this), i = this.type.isAnonymous, !r)
          return;
        if (this.nextSibling())
          break;
        this.parent(), r--, i = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(e) {
    if (!this.buffer)
      return Cu(this.node.parent, e);
    let { buffer: t } = this.buffer, { types: r } = t.set;
    for (let i = e.length - 1, s = this.stack.length - 1; i >= 0; s--) {
      if (s < 0)
        return Cu(this._tree, e, i);
      let l = r[t.buffer[this.stack[s]]];
      if (!l.isAnonymous) {
        if (e[i] && e[i] != l.name)
          return !1;
        i--;
      }
    }
    return !0;
  }
}
function vh(n) {
  return n.children.some((e) => e instanceof In || !e.type.isAnonymous || vh(e));
}
function x7(n) {
  var e;
  let { buffer: t, nodeSet: r, maxBufferLength: i = g7, reused: s = [], minRepeatType: l = r.types.length } = n, o = Array.isArray(t) ? new bh(t, t.length) : t, a = r.types, u = 0, h = 0;
  function c(C, T, M, L, R, N) {
    let { id: W, start: q, end: he, size: Z } = o, oe = h, ve = u;
    for (; Z < 0; )
      if (o.next(), Z == -1) {
        let J = s[W];
        M.push(J), L.push(q - C);
        return;
      } else if (Z == -3) {
        u = W;
        return;
      } else if (Z == -4) {
        h = W;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${Z}`);
    let _e = a[W], pe, H, fe = q - C;
    if (he - q <= i && (H = k(o.pos - T, R))) {
      let J = new Uint16Array(H.size - H.skip), re = o.pos - H.size, ae = J.length;
      for (; o.pos > re; )
        ae = S(H.start, J, ae);
      pe = new In(J, he - H.start, r), fe = H.start - C;
    } else {
      let J = o.pos - Z;
      o.next();
      let re = [], ae = [], de = W >= l ? W : -1, P = 0, ze = he;
      for (; o.pos > J; )
        de >= 0 && o.id == de && o.size >= 0 ? (o.end <= ze - i && (g(re, ae, q, P, o.end, ze, de, oe, ve), P = re.length, ze = o.end), o.next()) : N > 2500 ? f(q, J, re, ae) : c(q, J, re, ae, de, N + 1);
      if (de >= 0 && P > 0 && P < re.length && g(re, ae, q, P, q, ze, de, oe, ve), re.reverse(), ae.reverse(), de > -1 && P > 0) {
        let Me = m(_e, ve);
        pe = yh(_e, re, ae, 0, re.length, 0, he - q, Me, Me);
      } else
        pe = v(_e, re, ae, he - q, oe - he, ve);
    }
    M.push(pe), L.push(fe);
  }
  function f(C, T, M, L) {
    let R = [], N = 0, W = -1;
    for (; o.pos > T; ) {
      let { id: q, start: he, end: Z, size: oe } = o;
      if (oe > 4)
        o.next();
      else {
        if (W > -1 && he < W)
          break;
        W < 0 && (W = Z - i), R.push(q, he, Z), N++, o.next();
      }
    }
    if (N) {
      let q = new Uint16Array(N * 4), he = R[R.length - 2];
      for (let Z = R.length - 3, oe = 0; Z >= 0; Z -= 3)
        q[oe++] = R[Z], q[oe++] = R[Z + 1] - he, q[oe++] = R[Z + 2] - he, q[oe++] = oe;
      M.push(new In(q, R[2] - he, r)), L.push(he - C);
    }
  }
  function m(C, T) {
    return (M, L, R) => {
      let N = 0, W = M.length - 1, q, he;
      if (W >= 0 && (q = M[W]) instanceof Le) {
        if (!W && q.type == C && q.length == R)
          return q;
        (he = q.prop(we.lookAhead)) && (N = L[W] + q.length + he);
      }
      return v(C, M, L, R, N, T);
    };
  }
  function g(C, T, M, L, R, N, W, q, he) {
    let Z = [], oe = [];
    for (; C.length > L; )
      Z.push(C.pop()), oe.push(T.pop() + M - R);
    C.push(v(r.types[W], Z, oe, N - R, q - N, he)), T.push(R - M);
  }
  function v(C, T, M, L, R, N, W) {
    if (N) {
      let q = [we.contextHash, N];
      W = W ? [q].concat(W) : [q];
    }
    if (R > 25) {
      let q = [we.lookAhead, R];
      W = W ? [q].concat(W) : [q];
    }
    return new Le(C, T, M, L, W);
  }
  function k(C, T) {
    let M = o.fork(), L = 0, R = 0, N = 0, W = M.end - i, q = { size: 0, start: 0, skip: 0 };
    e: for (let he = M.pos - C; M.pos > he; ) {
      let Z = M.size;
      if (M.id == T && Z >= 0) {
        q.size = L, q.start = R, q.skip = N, N += 4, L += 4, M.next();
        continue;
      }
      let oe = M.pos - Z;
      if (Z < 0 || oe < he || M.start < W)
        break;
      let ve = M.id >= l ? 4 : 0, _e = M.start;
      for (M.next(); M.pos > oe; ) {
        if (M.size < 0)
          if (M.size == -3)
            ve += 4;
          else
            break e;
        else M.id >= l && (ve += 4);
        M.next();
      }
      R = _e, L += Z, N += ve;
    }
    return (T < 0 || L == C) && (q.size = L, q.start = R, q.skip = N), q.size > 4 ? q : void 0;
  }
  function S(C, T, M) {
    let { id: L, start: R, end: N, size: W } = o;
    if (o.next(), W >= 0 && L < l) {
      let q = M;
      if (W > 4) {
        let he = o.pos - (W - 4);
        for (; o.pos > he; )
          M = S(C, T, M);
      }
      T[--M] = q, T[--M] = N - C, T[--M] = R - C, T[--M] = L;
    } else W == -3 ? u = L : W == -4 && (h = L);
    return M;
  }
  let x = [], y = [];
  for (; o.pos > 0; )
    c(n.start || 0, n.bufferStart || 0, x, y, -1, 0);
  let A = (e = n.length) !== null && e !== void 0 ? e : x.length ? y[0] + x[0].length : 0;
  return new Le(a[n.topID], x.reverse(), y.reverse(), A);
}
const Wf = /* @__PURE__ */ new WeakMap();
function yo(n, e) {
  if (!n.isAnonymous || e instanceof In || e.type != n)
    return 1;
  let t = Wf.get(e);
  if (t == null) {
    t = 1;
    for (let r of e.children) {
      if (r.type != n || !(r instanceof Le)) {
        t = 1;
        break;
      }
      t += yo(n, r);
    }
    Wf.set(e, t);
  }
  return t;
}
function yh(n, e, t, r, i, s, l, o, a) {
  let u = 0;
  for (let g = r; g < i; g++)
    u += yo(n, e[g]);
  let h = Math.ceil(
    u * 1.5 / 8
    /* Balance.BranchFactor */
  ), c = [], f = [];
  function m(g, v, k, S, x) {
    for (let y = k; y < S; ) {
      let A = y, C = v[y], T = yo(n, g[y]);
      for (y++; y < S; y++) {
        let M = yo(n, g[y]);
        if (T + M >= h)
          break;
        T += M;
      }
      if (y == A + 1) {
        if (T > h) {
          let M = g[A];
          m(M.children, M.positions, 0, M.children.length, v[A] + x);
          continue;
        }
        c.push(g[A]);
      } else {
        let M = v[y - 1] + g[y - 1].length - C;
        c.push(yh(n, g, v, A, y, C, M, null, a));
      }
      f.push(C + x - s);
    }
  }
  return m(e, t, r, i, 0), (o || a)(c, f, l);
}
class ED {
  constructor() {
    this.map = /* @__PURE__ */ new WeakMap();
  }
  setBuffer(e, t, r) {
    let i = this.map.get(e);
    i || this.map.set(e, i = /* @__PURE__ */ new Map()), i.set(t, r);
  }
  getBuffer(e, t) {
    let r = this.map.get(e);
    return r && r.get(t);
  }
  /**
  Set the value for this syntax node.
  */
  set(e, t) {
    e instanceof Pr ? this.setBuffer(e.context.buffer, e.index, t) : e instanceof mt && this.map.set(e.tree, t);
  }
  /**
  Retrieve value for this syntax node, if it exists in the map.
  */
  get(e) {
    return e instanceof Pr ? this.getBuffer(e.context.buffer, e.index) : e instanceof mt ? this.map.get(e.tree) : void 0;
  }
  /**
  Set the value for the node that a cursor currently points to.
  */
  cursorSet(e, t) {
    e.buffer ? this.setBuffer(e.buffer.buffer, e.index, t) : this.map.set(e.tree, t);
  }
  /**
  Retrieve the value for the node that a cursor currently points
  to.
  */
  cursorGet(e) {
    return e.buffer ? this.getBuffer(e.buffer.buffer, e.index) : this.map.get(e.tree);
  }
}
class dn {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(e, t, r, i, s = !1, l = !1) {
    this.from = e, this.to = t, this.tree = r, this.offset = i, this.open = (s ? 1 : 0) | (l ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(e, t = [], r = !1) {
    let i = [new dn(0, e.length, e, 0, !1, r)];
    for (let s of t)
      s.to > e.length && i.push(s);
    return i;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(e, t, r = 128) {
    if (!t.length)
      return e;
    let i = [], s = 1, l = e.length ? e[0] : null;
    for (let o = 0, a = 0, u = 0; ; o++) {
      let h = o < t.length ? t[o] : null, c = h ? h.fromA : 1e9;
      if (c - a >= r)
        for (; l && l.from < c; ) {
          let f = l;
          if (a >= f.from || c <= f.to || u) {
            let m = Math.max(f.from, a) - u, g = Math.min(f.to, c) - u;
            f = m >= g ? null : new dn(m, g, f.tree, f.offset + u, o > 0, !!h);
          }
          if (f && i.push(f), l.to > c)
            break;
          l = s < e.length ? e[s++] : null;
        }
      if (!h)
        break;
      a = h.toA, u = h.toA - h.toB;
    }
    return i;
  }
}
class pg {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(e, t, r) {
    return typeof e == "string" && (e = new S7(e)), r = r ? r.length ? r.map((i) => new Zt(i.from, i.to)) : [new Zt(0, 0)] : [new Zt(0, e.length)], this.createParse(e, t || [], r);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(e, t, r) {
    let i = this.startParse(e, t, r);
    for (; ; ) {
      let s = i.advance();
      if (s)
        return s;
    }
  }
}
class S7 {
  constructor(e) {
    this.string = e;
  }
  get length() {
    return this.string.length;
  }
  chunk(e) {
    return this.string.slice(e);
  }
  get lineChunks() {
    return !1;
  }
  read(e, t) {
    return this.string.slice(e, t);
  }
}
function FD(n) {
  return (e, t, r, i) => new D7(e, n, t, r, i);
}
class Uf {
  constructor(e, t, r, i, s) {
    this.parser = e, this.parse = t, this.overlay = r, this.target = i, this.from = s;
  }
}
function Gf(n) {
  if (!n.length || n.some((e) => e.from >= e.to))
    throw new RangeError("Invalid inner parse ranges given: " + JSON.stringify(n));
}
class A7 {
  constructor(e, t, r, i, s, l, o) {
    this.parser = e, this.predicate = t, this.mounts = r, this.index = i, this.start = s, this.target = l, this.prev = o, this.depth = 0, this.ranges = [];
  }
}
const _u = new we({ perNode: !0 });
class D7 {
  constructor(e, t, r, i, s) {
    this.nest = t, this.input = r, this.fragments = i, this.ranges = s, this.inner = [], this.innerDone = 0, this.baseTree = null, this.stoppedAt = null, this.baseParse = e;
  }
  advance() {
    if (this.baseParse) {
      let r = this.baseParse.advance();
      if (!r)
        return null;
      if (this.baseParse = null, this.baseTree = r, this.startInner(), this.stoppedAt != null)
        for (let i of this.inner)
          i.parse.stopAt(this.stoppedAt);
    }
    if (this.innerDone == this.inner.length) {
      let r = this.baseTree;
      return this.stoppedAt != null && (r = new Le(r.type, r.children, r.positions, r.length, r.propValues.concat([[_u, this.stoppedAt]]))), r;
    }
    let e = this.inner[this.innerDone], t = e.parse.advance();
    if (t) {
      this.innerDone++;
      let r = Object.assign(/* @__PURE__ */ Object.create(null), e.target.props);
      r[we.mounted.id] = new Js(t, e.overlay, e.parser), e.target.props = r;
    }
    return null;
  }
  get parsedPos() {
    if (this.baseParse)
      return 0;
    let e = this.input.length;
    for (let t = this.innerDone; t < this.inner.length; t++)
      this.inner[t].from < e && (e = Math.min(e, this.inner[t].parse.parsedPos));
    return e;
  }
  stopAt(e) {
    if (this.stoppedAt = e, this.baseParse)
      this.baseParse.stopAt(e);
    else
      for (let t = this.innerDone; t < this.inner.length; t++)
        this.inner[t].parse.stopAt(e);
  }
  startInner() {
    let e = new M7(this.fragments), t = null, r = null, i = new Lo(new mt(this.baseTree, this.ranges[0].from, 0, null), Ve.IncludeAnonymous | Ve.IgnoreMounts);
    e: for (let s, l; ; ) {
      let o = !0, a;
      if (this.stoppedAt != null && i.from >= this.stoppedAt)
        o = !1;
      else if (e.hasNode(i)) {
        if (t) {
          let u = t.mounts.find((h) => h.frag.from <= i.from && h.frag.to >= i.to && h.mount.overlay);
          if (u)
            for (let h of u.mount.overlay) {
              let c = h.from + u.pos, f = h.to + u.pos;
              c >= i.from && f <= i.to && !t.ranges.some((m) => m.from < f && m.to > c) && t.ranges.push({ from: c, to: f });
            }
        }
        o = !1;
      } else if (r && (l = C7(r.ranges, i.from, i.to)))
        o = l != 2;
      else if (!i.type.isAnonymous && (s = this.nest(i, this.input)) && (i.from < i.to || !s.overlay)) {
        i.tree || _7(i);
        let u = e.findMounts(i.from, s.parser);
        if (typeof s.overlay == "function")
          t = new A7(s.parser, s.overlay, u, this.inner.length, i.from, i.tree, t);
        else {
          let h = Yf(this.ranges, s.overlay || (i.from < i.to ? [new Zt(i.from, i.to)] : []));
          h.length && Gf(h), (h.length || !s.overlay) && this.inner.push(new Uf(s.parser, h.length ? s.parser.startParse(this.input, Kf(u, h), h) : s.parser.startParse(""), s.overlay ? s.overlay.map((c) => new Zt(c.from - i.from, c.to - i.from)) : null, i.tree, h.length ? h[0].from : i.from)), s.overlay ? h.length && (r = { ranges: h, depth: 0, prev: r }) : o = !1;
        }
      } else if (t && (a = t.predicate(i)) && (a === !0 && (a = new Zt(i.from, i.to)), a.from < a.to)) {
        let u = t.ranges.length - 1;
        u >= 0 && t.ranges[u].to == a.from ? t.ranges[u] = { from: t.ranges[u].from, to: a.to } : t.ranges.push(a);
      }
      if (o && i.firstChild())
        t && t.depth++, r && r.depth++;
      else
        for (; !i.nextSibling(); ) {
          if (!i.parent())
            break e;
          if (t && !--t.depth) {
            let u = Yf(this.ranges, t.ranges);
            u.length && (Gf(u), this.inner.splice(t.index, 0, new Uf(t.parser, t.parser.startParse(this.input, Kf(t.mounts, u), u), t.ranges.map((h) => new Zt(h.from - t.start, h.to - t.start)), t.target, u[0].from))), t = t.prev;
          }
          r && !--r.depth && (r = r.prev);
        }
    }
  }
}
function C7(n, e, t) {
  for (let r of n) {
    if (r.from >= t)
      break;
    if (r.to > e)
      return r.from <= e && r.to >= t ? 2 : 1;
  }
  return 0;
}
function jf(n, e, t, r, i, s) {
  if (e < t) {
    let l = n.buffer[e + 1];
    r.push(n.slice(e, t, l)), i.push(l - s);
  }
}
function _7(n) {
  let { node: e } = n, t = [], r = e.context.buffer;
  do
    t.push(n.index), n.parent();
  while (!n.tree);
  let i = n.tree, s = i.children.indexOf(r), l = i.children[s], o = l.buffer, a = [s];
  function u(h, c, f, m, g, v) {
    let k = t[v], S = [], x = [];
    jf(l, h, k, S, x, m);
    let y = o[k + 1], A = o[k + 2];
    a.push(S.length);
    let C = v ? u(k + 4, o[k + 3], l.set.types[o[k]], y, A - y, v - 1) : e.toTree();
    return S.push(C), x.push(y - m), jf(l, o[k + 3], c, S, x, m), new Le(f, S, x, g);
  }
  i.children[s] = u(0, o.length, Dt.none, 0, l.length, t.length - 1);
  for (let h of a) {
    let c = n.tree.children[h], f = n.tree.positions[h];
    n.yield(new mt(c, f + n.from, h, n._tree));
  }
}
class $f {
  constructor(e, t) {
    this.offset = t, this.done = !1, this.cursor = e.cursor(Ve.IncludeAnonymous | Ve.IgnoreMounts);
  }
  // Move to the first node (in pre-order) that starts at or after `pos`.
  moveTo(e) {
    let { cursor: t } = this, r = e - this.offset;
    for (; !this.done && t.from < r; )
      t.to >= e && t.enter(r, 1, Ve.IgnoreOverlays | Ve.ExcludeBuffers) || t.next(!1) || (this.done = !0);
  }
  hasNode(e) {
    if (this.moveTo(e.from), !this.done && this.cursor.from + this.offset == e.from && this.cursor.tree)
      for (let t = this.cursor.tree; ; ) {
        if (t == e.tree)
          return !0;
        if (t.children.length && t.positions[0] == 0 && t.children[0] instanceof Le)
          t = t.children[0];
        else
          break;
      }
    return !1;
  }
}
class M7 {
  constructor(e) {
    var t;
    if (this.fragments = e, this.curTo = 0, this.fragI = 0, e.length) {
      let r = this.curFrag = e[0];
      this.curTo = (t = r.tree.prop(_u)) !== null && t !== void 0 ? t : r.to, this.inner = new $f(r.tree, -r.offset);
    } else
      this.curFrag = this.inner = null;
  }
  hasNode(e) {
    for (; this.curFrag && e.from >= this.curTo; )
      this.nextFrag();
    return this.curFrag && this.curFrag.from <= e.from && this.curTo >= e.to && this.inner.hasNode(e);
  }
  nextFrag() {
    var e;
    if (this.fragI++, this.fragI == this.fragments.length)
      this.curFrag = this.inner = null;
    else {
      let t = this.curFrag = this.fragments[this.fragI];
      this.curTo = (e = t.tree.prop(_u)) !== null && e !== void 0 ? e : t.to, this.inner = new $f(t.tree, -t.offset);
    }
  }
  findMounts(e, t) {
    var r;
    let i = [];
    if (this.inner) {
      this.inner.cursor.moveTo(e, 1);
      for (let s = this.inner.cursor.node; s; s = s.parent) {
        let l = (r = s.tree) === null || r === void 0 ? void 0 : r.prop(we.mounted);
        if (l && l.parser == t)
          for (let o = this.fragI; o < this.fragments.length; o++) {
            let a = this.fragments[o];
            if (a.from >= s.to)
              break;
            a.tree == this.curFrag.tree && i.push({
              frag: a,
              pos: s.from - a.offset,
              mount: l
            });
          }
      }
    }
    return i;
  }
}
function Yf(n, e) {
  let t = null, r = e;
  for (let i = 1, s = 0; i < n.length; i++) {
    let l = n[i - 1].to, o = n[i].from;
    for (; s < r.length; s++) {
      let a = r[s];
      if (a.from >= o)
        break;
      a.to <= l || (t || (r = t = e.slice()), a.from < l ? (t[s] = new Zt(a.from, l), a.to > o && t.splice(s + 1, 0, new Zt(o, a.to))) : a.to > o ? t[s--] = new Zt(o, a.to) : t.splice(s--, 1));
    }
  }
  return r;
}
function T7(n, e, t, r) {
  let i = 0, s = 0, l = !1, o = !1, a = -1e9, u = [];
  for (; ; ) {
    let h = i == n.length ? 1e9 : l ? n[i].to : n[i].from, c = s == e.length ? 1e9 : o ? e[s].to : e[s].from;
    if (l != o) {
      let f = Math.max(a, t), m = Math.min(h, c, r);
      f < m && u.push(new Zt(f, m));
    }
    if (a = Math.min(h, c), a == 1e9)
      break;
    h == a && (l ? (l = !1, i++) : l = !0), c == a && (o ? (o = !1, s++) : o = !0);
  }
  return u;
}
function Kf(n, e) {
  let t = [];
  for (let { pos: r, mount: i, frag: s } of n) {
    let l = r + (i.overlay ? i.overlay[0].from : 0), o = l + i.tree.length, a = Math.max(s.from, l), u = Math.min(s.to, o);
    if (i.overlay) {
      let h = i.overlay.map((f) => new Zt(f.from + r, f.to + r)), c = T7(e, h, a, u);
      for (let f = 0, m = a; ; f++) {
        let g = f == c.length, v = g ? u : c[f].from;
        if (v > m && t.push(new dn(m, v, i.tree, -l, s.from >= m || s.openStart, s.to <= v || s.openEnd)), g)
          break;
        m = c[f].to;
      }
    } else
      t.push(new dn(a, u, i.tree, -l, s.from >= l || s.openStart, s.to <= o || s.openEnd));
  }
  return t;
}
let E7 = 0;
class $t {
  /**
  @internal
  */
  constructor(e, t, r, i) {
    this.name = e, this.set = t, this.base = r, this.modified = i, this.id = E7++;
  }
  toString() {
    let { name: e } = this;
    for (let t of this.modified)
      t.name && (e = `${t.name}(${e})`);
    return e;
  }
  static define(e, t) {
    let r = typeof e == "string" ? e : "?";
    if (e instanceof $t && (t = e), t?.base)
      throw new Error("Can not derive from a modified tag");
    let i = new $t(r, [], null, []);
    if (i.set.push(i), t)
      for (let s of t.set)
        i.set.push(s);
    return i;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier(e) {
    let t = new No(e);
    return (r) => r.modified.indexOf(t) > -1 ? r : No.get(r.base || r, r.modified.concat(t).sort((i, s) => i.id - s.id));
  }
}
let F7 = 0;
class No {
  constructor(e) {
    this.name = e, this.instances = [], this.id = F7++;
  }
  static get(e, t) {
    if (!t.length)
      return e;
    let r = t[0].instances.find((o) => o.base == e && B7(t, o.modified));
    if (r)
      return r;
    let i = [], s = new $t(e.name, i, e, t);
    for (let o of t)
      o.instances.push(s);
    let l = O7(t);
    for (let o of e.set)
      if (!o.modified.length)
        for (let a of l)
          i.push(No.get(o, a));
    return s;
  }
}
function B7(n, e) {
  return n.length == e.length && n.every((t, r) => t == e[r]);
}
function O7(n) {
  let e = [[]];
  for (let t = 0; t < n.length; t++)
    for (let r = 0, i = e.length; r < i; r++)
      e.push(e[r].concat(n[t]));
  return e.sort((t, r) => r.length - t.length);
}
function R7(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t in n) {
    let r = n[t];
    Array.isArray(r) || (r = [r]);
    for (let i of t.split(" "))
      if (i) {
        let s = [], l = 2, o = i;
        for (let c = 0; ; ) {
          if (o == "..." && c > 0 && c + 3 == i.length) {
            l = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(o);
          if (!f)
            throw new RangeError("Invalid path: " + i);
          if (s.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), c += f[0].length, c == i.length)
            break;
          let m = i[c++];
          if (c == i.length && m == "!") {
            l = 0;
            break;
          }
          if (m != "/")
            throw new RangeError("Invalid path: " + i);
          o = i.slice(c);
        }
        let a = s.length - 1, u = s[a];
        if (!u)
          throw new RangeError("Invalid path: " + i);
        let h = new Io(r, l, a > 0 ? s.slice(0, a) : null);
        e[u] = h.sort(e[u]);
      }
  }
  return gg.add(e);
}
const gg = new we();
class Io {
  constructor(e, t, r, i) {
    this.tags = e, this.mode = t, this.context = r, this.next = i;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(e) {
    return !e || e.depth < this.depth ? (this.next = e, this) : (e.next = this.sort(e.next), e);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
Io.empty = new Io([], 2, null);
function bg(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let s of n)
    if (!Array.isArray(s.tag))
      t[s.tag.id] = s.class;
    else
      for (let l of s.tag)
        t[l.id] = s.class;
  let { scope: r, all: i = null } = e || {};
  return {
    style: (s) => {
      let l = i;
      for (let o of s)
        for (let a of o.set) {
          let u = t[a.id];
          if (u) {
            l = l ? l + " " + u : u;
            break;
          }
        }
      return l;
    },
    scope: r
  };
}
function L7(n, e) {
  let t = null;
  for (let r of n) {
    let i = r.style(e);
    i && (t = t ? t + " " + i : i);
  }
  return t;
}
function N7(n, e, t, r = 0, i = n.length) {
  let s = new I7(r, Array.isArray(e) ? e : [e], t);
  s.highlightRange(n.cursor(), r, i, "", s.highlighters), s.flush(i);
}
class I7 {
  constructor(e, t, r) {
    this.at = e, this.highlighters = t, this.span = r, this.class = "";
  }
  startSpan(e, t) {
    t != this.class && (this.flush(e), e > this.at && (this.at = e), this.class = t);
  }
  flush(e) {
    e > this.at && this.class && this.span(this.at, e, this.class);
  }
  highlightRange(e, t, r, i, s) {
    let { type: l, from: o, to: a } = e;
    if (o >= r || a <= t)
      return;
    l.isTop && (s = this.highlighters.filter((m) => !m.scope || m.scope(l)));
    let u = i, h = z7(e) || Io.empty, c = L7(s, h.tags);
    if (c && (u && (u += " "), u += c, h.mode == 1 && (i += (i ? " " : "") + c)), this.startSpan(Math.max(t, o), u), h.opaque)
      return;
    let f = e.tree && e.tree.prop(we.mounted);
    if (f && f.overlay) {
      let m = e.node.enter(f.overlay[0].from + o, 1), g = this.highlighters.filter((k) => !k.scope || k.scope(f.tree.type)), v = e.firstChild();
      for (let k = 0, S = o; ; k++) {
        let x = k < f.overlay.length ? f.overlay[k] : null, y = x ? x.from + o : a, A = Math.max(t, S), C = Math.min(r, y);
        if (A < C && v)
          for (; e.from < C && (this.highlightRange(e, A, C, i, s), this.startSpan(Math.min(C, e.to), u), !(e.to >= y || !e.nextSibling())); )
            ;
        if (!x || y > r)
          break;
        S = x.to + o, S > t && (this.highlightRange(m.cursor(), Math.max(t, x.from + o), Math.min(r, S), "", g), this.startSpan(Math.min(r, S), u));
      }
      v && e.parent();
    } else if (e.firstChild()) {
      f && (i = "");
      do
        if (!(e.to <= t)) {
          if (e.from >= r)
            break;
          this.highlightRange(e, t, r, i, s), this.startSpan(Math.min(r, e.to), u);
        }
      while (e.nextSibling());
      e.parent();
    }
  }
}
function z7(n) {
  let e = n.type.prop(gg);
  for (; e && e.context && !n.matchContext(e.context); )
    e = e.next;
  return e || null;
}
const j = $t.define, Il = j(), Dn = j(), Xf = j(Dn), Zf = j(Dn), Cn = j(), zl = j(Cn), Ua = j(Cn), Or = j(), Un = j(Or), Er = j(), Fr = j(), Mu = j(), ps = j(Mu), Pl = j(), E = {
  /**
  A comment.
  */
  comment: Il,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: j(Il),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: j(Il),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: j(Il),
  /**
  Any kind of identifier.
  */
  name: Dn,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: j(Dn),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Xf,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: j(Xf),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: Zf,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: j(Zf),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: j(Dn),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: j(Dn),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: j(Dn),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: j(Dn),
  /**
  A literal value.
  */
  literal: Cn,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: zl,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: j(zl),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: j(zl),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: j(zl),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: Ua,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: j(Ua),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: j(Ua),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: j(Cn),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: j(Cn),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: j(Cn),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: j(Cn),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: j(Cn),
  /**
  A language keyword.
  */
  keyword: Er,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: j(Er),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: j(Er),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: j(Er),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: j(Er),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: j(Er),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: j(Er),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: j(Er),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: j(Er),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: j(Er),
  /**
  An operator.
  */
  operator: Fr,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: j(Fr),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: j(Fr),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: j(Fr),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: j(Fr),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: j(Fr),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: j(Fr),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: j(Fr),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: j(Fr),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: j(Fr),
  /**
  Program or markup punctuation.
  */
  punctuation: Mu,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: j(Mu),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: ps,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: j(ps),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: j(ps),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: j(ps),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: j(ps),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: Or,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: Un,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: j(Un),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: j(Un),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: j(Un),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: j(Un),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: j(Un),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: j(Un),
  /**
  A prose [content](#highlight.tags.content) separator (such as a horizontal rule).
  */
  contentSeparator: j(Or),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: j(Or),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: j(Or),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: j(Or),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: j(Or),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: j(Or),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: j(Or),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: j(Or),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: j(),
  /**
  Deleted text.
  */
  deleted: j(),
  /**
  Changed text.
  */
  changed: j(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: j(),
  /**
  Metadata or meta-instruction.
  */
  meta: Pl,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: j(Pl),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: j(Pl),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: j(Pl),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: $t.defineModifier("definition"),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: $t.defineModifier("constant"),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: $t.defineModifier("function"),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: $t.defineModifier("standard"),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: $t.defineModifier("local"),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: $t.defineModifier("special")
};
for (let n in E) {
  let e = E[n];
  e instanceof $t && (e.name = n);
}
bg([
  { tag: E.link, class: "tok-link" },
  { tag: E.heading, class: "tok-heading" },
  { tag: E.emphasis, class: "tok-emphasis" },
  { tag: E.strong, class: "tok-strong" },
  { tag: E.keyword, class: "tok-keyword" },
  { tag: E.atom, class: "tok-atom" },
  { tag: E.bool, class: "tok-bool" },
  { tag: E.url, class: "tok-url" },
  { tag: E.labelName, class: "tok-labelName" },
  { tag: E.inserted, class: "tok-inserted" },
  { tag: E.deleted, class: "tok-deleted" },
  { tag: E.literal, class: "tok-literal" },
  { tag: E.string, class: "tok-string" },
  { tag: E.number, class: "tok-number" },
  { tag: [E.regexp, E.escape, E.special(E.string)], class: "tok-string2" },
  { tag: E.variableName, class: "tok-variableName" },
  { tag: E.local(E.variableName), class: "tok-variableName tok-local" },
  { tag: E.definition(E.variableName), class: "tok-variableName tok-definition" },
  { tag: E.special(E.variableName), class: "tok-variableName2" },
  { tag: E.definition(E.propertyName), class: "tok-propertyName tok-definition" },
  { tag: E.typeName, class: "tok-typeName" },
  { tag: E.namespace, class: "tok-namespace" },
  { tag: E.className, class: "tok-className" },
  { tag: E.macroName, class: "tok-macroName" },
  { tag: E.propertyName, class: "tok-propertyName" },
  { tag: E.operator, class: "tok-operator" },
  { tag: E.comment, class: "tok-comment" },
  { tag: E.meta, class: "tok-meta" },
  { tag: E.invalid, class: "tok-invalid" },
  { tag: E.punctuation, class: "tok-punctuation" }
]);
var Ga;
const Jn = /* @__PURE__ */ new we();
function vg(n) {
  return X.define({
    combine: n ? (e) => e.concat(n) : void 0
  });
}
const P7 = /* @__PURE__ */ new we();
class Jt {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(e, t, r = [], i = "") {
    this.data = e, this.name = i, Se.prototype.hasOwnProperty("tree") || Object.defineProperty(Se.prototype, "tree", { get() {
      return nt(this);
    } }), this.parser = t, this.extension = [
      zn.of(this),
      Se.languageData.of((s, l, o) => {
        let a = Jf(s, l, o), u = a.type.prop(Jn);
        if (!u)
          return [];
        let h = s.facet(u), c = a.type.prop(P7);
        if (c) {
          let f = a.resolve(l - a.from, o);
          for (let m of c)
            if (m.test(f, s)) {
              let g = s.facet(m.facet);
              return m.type == "replace" ? g : g.concat(h);
            }
        }
        return h;
      })
    ].concat(r);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(e, t, r = -1) {
    return Jf(e, t, r).type.prop(Jn) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(e) {
    let t = e.facet(zn);
    if (t?.data == this.data)
      return [{ from: 0, to: e.doc.length }];
    if (!t || !t.allowsNesting)
      return [];
    let r = [], i = (s, l) => {
      if (s.prop(Jn) == this.data) {
        r.push({ from: l, to: l + s.length });
        return;
      }
      let o = s.prop(we.mounted);
      if (o) {
        if (o.tree.prop(Jn) == this.data) {
          if (o.overlay)
            for (let a of o.overlay)
              r.push({ from: a.from + l, to: a.to + l });
          else
            r.push({ from: l, to: l + s.length });
          return;
        } else if (o.overlay) {
          let a = r.length;
          if (i(o.tree, o.overlay[0].from + l), r.length > a)
            return;
        }
      }
      for (let a = 0; a < s.children.length; a++) {
        let u = s.children[a];
        u instanceof Le && i(u, s.positions[a] + l);
      }
    };
    return i(nt(e), 0), r;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
Jt.setState = /* @__PURE__ */ ye.define();
function Jf(n, e, t) {
  let r = n.facet(zn), i = nt(n).topNode;
  if (!r || r.allowsNesting)
    for (let s = i; s; s = s.enter(e, t, Ve.ExcludeBuffers))
      s.type.isTop && (i = s);
  return i;
}
class Tu extends Jt {
  constructor(e, t, r) {
    super(e, t, [], r), this.parser = t;
  }
  /**
  Define a language from a parser.
  */
  static define(e) {
    let t = vg(e.languageData);
    return new Tu(t, e.parser.configure({
      props: [Jn.add((r) => r.isTop ? t : void 0)]
    }), e.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(e, t) {
    return new Tu(this.data, this.parser.configure(e), t || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function nt(n) {
  let e = n.field(Jt.state, !1);
  return e ? e.tree : Le.empty;
}
class H7 {
  /**
  Create an input object for the given document.
  */
  constructor(e) {
    this.doc = e, this.cursorPos = 0, this.string = "", this.cursor = e.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(e) {
    return this.string = this.cursor.next(e - this.cursorPos).value, this.cursorPos = e + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(e) {
    return this.syncTo(e), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(e, t) {
    let r = this.cursorPos - this.string.length;
    return e < r || t >= this.cursorPos ? this.doc.sliceString(e, t) : this.string.slice(e - r, t - r);
  }
}
let gs = null;
class Ki {
  constructor(e, t, r = [], i, s, l, o, a) {
    this.parser = e, this.state = t, this.fragments = r, this.tree = i, this.treeLen = s, this.viewport = l, this.skipped = o, this.scheduleOn = a, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(e, t, r) {
    return new Ki(e, t, [], Le.empty, 0, r, [], null);
  }
  startParse() {
    return this.parser.startParse(new H7(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(e, t) {
    return t != null && t >= this.state.doc.length && (t = void 0), this.tree != Le.empty && this.isDone(t ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var r;
      if (typeof e == "number") {
        let i = Date.now() + e;
        e = () => Date.now() > i;
      }
      for (this.parse || (this.parse = this.startParse()), t != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > t) && t < this.state.doc.length && this.parse.stopAt(t); ; ) {
        let i = this.parse.advance();
        if (i)
          if (this.fragments = this.withoutTempSkipped(dn.addTree(i, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (r = this.parse.stoppedAt) !== null && r !== void 0 ? r : this.state.doc.length, this.tree = i, this.parse = null, this.treeLen < (t ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (e())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let e, t;
    this.parse && (e = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e) && this.parse.stopAt(e), this.withContext(() => {
      for (; !(t = this.parse.advance()); )
        ;
    }), this.treeLen = e, this.tree = t, this.fragments = this.withoutTempSkipped(dn.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(e) {
    let t = gs;
    gs = this;
    try {
      return e();
    } finally {
      gs = t;
    }
  }
  withoutTempSkipped(e) {
    for (let t; t = this.tempSkipped.pop(); )
      e = Qf(e, t.from, t.to);
    return e;
  }
  /**
  @internal
  */
  changes(e, t) {
    let { fragments: r, tree: i, treeLen: s, viewport: l, skipped: o } = this;
    if (this.takeTree(), !e.empty) {
      let a = [];
      if (e.iterChangedRanges((u, h, c, f) => a.push({ fromA: u, toA: h, fromB: c, toB: f })), r = dn.applyChanges(r, a), i = Le.empty, s = 0, l = { from: e.mapPos(l.from, -1), to: e.mapPos(l.to, 1) }, this.skipped.length) {
        o = [];
        for (let u of this.skipped) {
          let h = e.mapPos(u.from, 1), c = e.mapPos(u.to, -1);
          h < c && o.push({ from: h, to: c });
        }
      }
    }
    return new Ki(this.parser, t, r, i, s, l, o, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(e) {
    if (this.viewport.from == e.from && this.viewport.to == e.to)
      return !1;
    this.viewport = e;
    let t = this.skipped.length;
    for (let r = 0; r < this.skipped.length; r++) {
      let { from: i, to: s } = this.skipped[r];
      i < e.to && s > e.from && (this.fragments = Qf(this.fragments, i, s), this.skipped.splice(r--, 1));
    }
    return this.skipped.length >= t ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(e, t) {
    this.skipped.push({ from: e, to: t });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(e) {
    return new class extends pg {
      createParse(t, r, i) {
        let s = i[0].from, l = i[i.length - 1].to;
        return {
          parsedPos: s,
          advance() {
            let a = gs;
            if (a) {
              for (let u of i)
                a.tempSkipped.push(u);
              e && (a.scheduleOn = a.scheduleOn ? Promise.all([a.scheduleOn, e]) : e);
            }
            return this.parsedPos = l, new Le(Dt.none, [], [], l - s);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(e) {
    e = Math.min(e, this.state.doc.length);
    let t = this.fragments;
    return this.treeLen >= e && t.length && t[0].from == 0 && t[0].to >= e;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return gs;
  }
}
function Qf(n, e, t) {
  return dn.applyChanges(n, [{ fromA: e, toA: t, fromB: e, toB: t }]);
}
class Xi {
  constructor(e) {
    this.context = e, this.tree = e.tree;
  }
  apply(e) {
    if (!e.docChanged && this.tree == this.context.tree)
      return this;
    let t = this.context.changes(e.changes, e.state), r = this.context.treeLen == e.startState.doc.length ? void 0 : Math.max(e.changes.mapPos(this.context.treeLen), t.viewport.to);
    return t.work(20, r) || t.takeTree(), new Xi(t);
  }
  static init(e) {
    let t = Math.min(3e3, e.doc.length), r = Ki.create(e.facet(zn).parser, e, { from: 0, to: t });
    return r.work(20, t) || r.takeTree(), new Xi(r);
  }
}
Jt.state = /* @__PURE__ */ Lt.define({
  create: Xi.init,
  update(n, e) {
    for (let t of e.effects)
      if (t.is(Jt.setState))
        return t.value;
    return e.startState.facet(zn) != e.state.facet(zn) ? Xi.init(e.state) : n.apply(e);
  }
});
let yg = (n) => {
  let e = setTimeout(
    () => n(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(e);
};
typeof requestIdleCallback < "u" && (yg = (n) => {
  let e = -1, t = setTimeout(
    () => {
      e = requestIdleCallback(n, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => e < 0 ? clearTimeout(t) : cancelIdleCallback(e);
});
const ja = typeof navigator < "u" && (!((Ga = navigator.scheduling) === null || Ga === void 0) && Ga.isInputPending) ? () => navigator.scheduling.isInputPending() : null, q7 = /* @__PURE__ */ pt.fromClass(class {
  constructor(e) {
    this.view = e, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(e) {
    let t = this.view.state.field(Jt.state).context;
    (t.updateViewport(e.view.viewport) || this.view.viewport.to > t.treeLen) && this.scheduleWork(), (e.docChanged || e.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(t);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: e } = this.view, t = e.field(Jt.state);
    (t.tree != t.context.tree || !t.context.isDone(e.doc.length)) && (this.working = yg(this.work));
  }
  work(e) {
    this.working = null;
    let t = Date.now();
    if (this.chunkEnd < t && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = t + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: r, viewport: { to: i } } = this.view, s = r.field(Jt.state);
    if (s.tree == s.context.tree && s.context.isDone(
      i + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let l = Date.now() + Math.min(this.chunkBudget, 100, e && !ja ? Math.max(25, e.timeRemaining() - 5) : 1e9), o = s.context.treeLen < i && r.doc.length > i + 1e3, a = s.context.work(() => ja && ja() || Date.now() > l, i + (o ? 0 : 1e5));
    this.chunkBudget -= Date.now() - t, (a || this.chunkBudget <= 0) && (s.context.takeTree(), this.view.dispatch({ effects: Jt.setState.of(new Xi(s.context)) })), this.chunkBudget > 0 && !(a && !o) && this.scheduleWork(), this.checkAsyncSchedule(s.context);
  }
  checkAsyncSchedule(e) {
    e.scheduleOn && (this.workScheduled++, e.scheduleOn.then(() => this.scheduleWork()).catch((t) => Xt(this.view.state, t)).then(() => this.workScheduled--), e.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), zn = /* @__PURE__ */ X.define({
  combine(n) {
    return n.length ? n[0] : null;
  },
  enables: (n) => [
    Jt.state,
    q7,
    Q.contentAttributes.compute([n], (e) => {
      let t = e.facet(n);
      return t && t.name ? { "data-language": t.name } : {};
    })
  ]
});
class OD {
  /**
  Create a language support object.
  */
  constructor(e, t = []) {
    this.language = e, this.support = t, this.extension = [e, t];
  }
}
class wg {
  constructor(e, t, r, i, s, l = void 0) {
    this.name = e, this.alias = t, this.extensions = r, this.filename = i, this.loadFunc = s, this.support = l, this.loading = null;
  }
  /**
  Start loading the the language. Will return a promise that
  resolves to a [`LanguageSupport`](https://codemirror.net/6/docs/ref/#language.LanguageSupport)
  object when the language successfully loads.
  */
  load() {
    return this.loading || (this.loading = this.loadFunc().then((e) => this.support = e, (e) => {
      throw this.loading = null, e;
    }));
  }
  /**
  Create a language description.
  */
  static of(e) {
    let { load: t, support: r } = e;
    if (!t) {
      if (!r)
        throw new RangeError("Must pass either 'load' or 'support' to LanguageDescription.of");
      t = () => Promise.resolve(r);
    }
    return new wg(e.name, (e.alias || []).concat(e.name).map((i) => i.toLowerCase()), e.extensions || [], e.filename, t, r);
  }
  /**
  Look for a language in the given array of descriptions that
  matches the filename. Will first match
  [`filename`](https://codemirror.net/6/docs/ref/#language.LanguageDescription.filename) patterns,
  and then [extensions](https://codemirror.net/6/docs/ref/#language.LanguageDescription.extensions),
  and return the first language that matches.
  */
  static matchFilename(e, t) {
    for (let i of e)
      if (i.filename && i.filename.test(t))
        return i;
    let r = /\.([^.]+)$/.exec(t);
    if (r) {
      for (let i of e)
        if (i.extensions.indexOf(r[1]) > -1)
          return i;
    }
    return null;
  }
  /**
  Look for a language whose name or alias matches the the given
  name (case-insensitively). If `fuzzy` is true, and no direct
  matchs is found, this'll also search for a language whose name
  or alias occurs in the string (for names shorter than three
  characters, only when surrounded by non-word characters).
  */
  static matchLanguageName(e, t, r = !0) {
    t = t.toLowerCase();
    for (let i of e)
      if (i.alias.some((s) => s == t))
        return i;
    if (r)
      for (let i of e)
        for (let s of i.alias) {
          let l = t.indexOf(s);
          if (l > -1 && (s.length > 2 || !/\w/.test(t[l - 1]) && !/\w/.test(t[l + s.length])))
            return i;
        }
    return null;
  }
}
const kg = /* @__PURE__ */ X.define(), ua = /* @__PURE__ */ X.define({
  combine: (n) => {
    if (!n.length)
      return "  ";
    let e = n[0];
    if (!e || /\S/.test(e) || Array.from(e).some((t) => t != e[0]))
      throw new Error("Invalid indent unit: " + JSON.stringify(n[0]));
    return e;
  }
});
function oi(n) {
  let e = n.facet(ua);
  return e.charCodeAt(0) == 9 ? n.tabSize * e.length : e.length;
}
function el(n, e) {
  let t = "", r = n.tabSize, i = n.facet(ua)[0];
  if (i == "	") {
    for (; e >= r; )
      t += "	", e -= r;
    i = " ";
  }
  for (let s = 0; s < e; s++)
    t += i;
  return t;
}
function wh(n, e) {
  n instanceof Se && (n = new ha(n));
  for (let r of n.state.facet(kg)) {
    let i = r(n, e);
    if (i !== void 0)
      return i;
  }
  let t = nt(n.state);
  return t.length >= e ? W7(n, t, e) : null;
}
class ha {
  /**
  Create an indent context.
  */
  constructor(e, t = {}) {
    this.state = e, this.options = t, this.unit = oi(e);
  }
  /**
  Get a description of the line at the given position, taking
  [simulated line
  breaks](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  into account. If there is such a break at `pos`, the `bias`
  argument determines whether the part of the line line before or
  after the break is used.
  */
  lineAt(e, t = 1) {
    let r = this.state.doc.lineAt(e), { simulateBreak: i, simulateDoubleBreak: s } = this.options;
    return i != null && i >= r.from && i <= r.to ? s && i == e ? { text: "", from: e } : (t < 0 ? i < e : i <= e) ? { text: r.text.slice(i - r.from), from: i } : { text: r.text.slice(0, i - r.from), from: r.from } : r;
  }
  /**
  Get the text directly after `pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  textAfterPos(e, t = 1) {
    if (this.options.simulateDoubleBreak && e == this.options.simulateBreak)
      return "";
    let { text: r, from: i } = this.lineAt(e, t);
    return r.slice(e - i, Math.min(r.length, e + 100 - i));
  }
  /**
  Find the column for the given position.
  */
  column(e, t = 1) {
    let { text: r, from: i } = this.lineAt(e, t), s = this.countColumn(r, e - i), l = this.options.overrideIndentation ? this.options.overrideIndentation(i) : -1;
    return l > -1 && (s += l - this.countColumn(r, r.search(/\S|$/))), s;
  }
  /**
  Find the column position (taking tabs into account) of the given
  position in the given string.
  */
  countColumn(e, t = e.length) {
    return rs(e, this.state.tabSize, t);
  }
  /**
  Find the indentation column of the line at the given point.
  */
  lineIndent(e, t = 1) {
    let { text: r, from: i } = this.lineAt(e, t), s = this.options.overrideIndentation;
    if (s) {
      let l = s(i);
      if (l > -1)
        return l;
    }
    return this.countColumn(r, r.search(/\S|$/));
  }
  /**
  Returns the [simulated line
  break](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  for this context, if any.
  */
  get simulatedBreak() {
    return this.options.simulateBreak || null;
  }
}
const V7 = /* @__PURE__ */ new we();
function W7(n, e, t) {
  let r = e.resolveStack(t), i = r.node.enterUnfinishedNodesBefore(t);
  if (i != r.node) {
    let s = [];
    for (let l = i; l != r.node; l = l.parent)
      s.push(l);
    for (let l = s.length - 1; l >= 0; l--)
      r = { node: s[l], next: r };
  }
  return xg(r, n, t);
}
function xg(n, e, t) {
  for (let r = n; r; r = r.next) {
    let i = G7(r.node);
    if (i)
      return i(kh.create(e, t, r));
  }
  return 0;
}
function U7(n) {
  return n.pos == n.options.simulateBreak && n.options.simulateDoubleBreak;
}
function G7(n) {
  let e = n.type.prop(V7);
  if (e)
    return e;
  let t = n.firstChild, r;
  if (t && (r = t.type.prop(we.closedBy))) {
    let i = n.lastChild, s = i && r.indexOf(i.name) > -1;
    return (l) => Sg(l, !0, 1, void 0, s && !U7(l) ? i.from : void 0);
  }
  return n.parent == null ? j7 : null;
}
function j7() {
  return 0;
}
class kh extends ha {
  constructor(e, t, r) {
    super(e.state, e.options), this.base = e, this.pos = t, this.context = r;
  }
  /**
  The syntax tree node to which the indentation strategy
  applies.
  */
  get node() {
    return this.context.node;
  }
  /**
  @internal
  */
  static create(e, t, r) {
    return new kh(e, t, r);
  }
  /**
  Get the text directly after `this.pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  get textAfter() {
    return this.textAfterPos(this.pos);
  }
  /**
  Get the indentation at the reference line for `this.node`, which
  is the line on which it starts, unless there is a node that is
  _not_ a parent of this node covering the start of that line. If
  so, the line at the start of that node is tried, again skipping
  on if it is covered by another such node.
  */
  get baseIndent() {
    return this.baseIndentFor(this.node);
  }
  /**
  Get the indentation for the reference line of the given node
  (see [`baseIndent`](https://codemirror.net/6/docs/ref/#language.TreeIndentContext.baseIndent)).
  */
  baseIndentFor(e) {
    let t = this.state.doc.lineAt(e.from);
    for (; ; ) {
      let r = e.resolve(t.from);
      for (; r.parent && r.parent.from == r.from; )
        r = r.parent;
      if ($7(r, e))
        break;
      t = this.state.doc.lineAt(r.from);
    }
    return this.lineIndent(t.from);
  }
  /**
  Continue looking for indentations in the node's parent nodes,
  and return the result of that.
  */
  continue() {
    return xg(this.context.next, this.base, this.pos);
  }
}
function $7(n, e) {
  for (let t = e; t; t = t.parent)
    if (n == t)
      return !0;
  return !1;
}
function Y7(n) {
  let e = n.node, t = e.childAfter(e.from), r = e.lastChild;
  if (!t)
    return null;
  let i = n.options.simulateBreak, s = n.state.doc.lineAt(t.from), l = i == null || i <= s.from ? s.to : Math.min(s.to, i);
  for (let o = t.to; ; ) {
    let a = e.childAfter(o);
    if (!a || a == r)
      return null;
    if (!a.type.isSkipped) {
      if (a.from >= l)
        return null;
      let u = /^ */.exec(s.text.slice(t.to - s.from))[0].length;
      return { from: t.from, to: t.to + u };
    }
    o = a.to;
  }
}
function RD({ closing: n, align: e = !0, units: t = 1 }) {
  return (r) => Sg(r, e, t, n);
}
function Sg(n, e, t, r, i) {
  let s = n.textAfter, l = s.match(/^\s*/)[0].length, o = r && s.slice(l, l + r.length) == r || i == n.pos + l, a = e ? Y7(n) : null;
  return a ? o ? n.column(a.from) : n.column(a.to) : n.baseIndent + (o ? 0 : n.unit * t);
}
const LD = (n) => n.baseIndent;
function ND({ except: n, units: e = 1 } = {}) {
  return (t) => {
    let r = n && n.test(t.textAfter);
    return t.baseIndent + (r ? 0 : e * t.unit);
  };
}
const K7 = 200;
function X7() {
  return Se.transactionFilter.of((n) => {
    if (!n.docChanged || !n.isUserEvent("input.type") && !n.isUserEvent("input.complete"))
      return n;
    let e = n.startState.languageDataAt("indentOnInput", n.startState.selection.main.head);
    if (!e.length)
      return n;
    let t = n.newDoc, { head: r } = n.newSelection.main, i = t.lineAt(r);
    if (r > i.from + K7)
      return n;
    let s = t.sliceString(i.from, r);
    if (!e.some((u) => u.test(s)))
      return n;
    let { state: l } = n, o = -1, a = [];
    for (let { head: u } of l.selection.ranges) {
      let h = l.doc.lineAt(u);
      if (h.from == o)
        continue;
      o = h.from;
      let c = wh(l, h.from);
      if (c == null)
        continue;
      let f = /^\s*/.exec(h.text)[0], m = el(l, c);
      f != m && a.push({ from: h.from, to: h.from + f.length, insert: m });
    }
    return a.length ? [n, { changes: a, sequential: !0 }] : n;
  });
}
const Z7 = /* @__PURE__ */ X.define(), J7 = /* @__PURE__ */ new we();
function ID(n) {
  let e = n.firstChild, t = n.lastChild;
  return e && e.to < t.from ? { from: e.to, to: t.type.isError ? n.to : t.from } : null;
}
function Q7(n, e, t) {
  let r = nt(n);
  if (r.length < t)
    return null;
  let i = r.resolveStack(t, 1), s = null;
  for (let l = i; l; l = l.next) {
    let o = l.node;
    if (o.to <= t || o.from > t)
      continue;
    if (s && o.from < e)
      break;
    let a = o.type.prop(J7);
    if (a && (o.to < r.length - 50 || r.length == n.doc.length || !e8(o))) {
      let u = a(o, n);
      u && u.from <= t && u.from >= e && u.to > t && (s = u);
    }
  }
  return s;
}
function e8(n) {
  let e = n.lastChild;
  return e && e.to == n.to && e.type.isError;
}
function zo(n, e, t) {
  for (let r of n.facet(Z7)) {
    let i = r(n, e, t);
    if (i)
      return i;
  }
  return Q7(n, e, t);
}
function Ag(n, e) {
  let t = e.mapPos(n.from, 1), r = e.mapPos(n.to, -1);
  return t >= r ? void 0 : { from: t, to: r };
}
const ca = /* @__PURE__ */ ye.define({ map: Ag }), dl = /* @__PURE__ */ ye.define({ map: Ag });
function Dg(n) {
  let e = [];
  for (let { head: t } of n.state.selection.ranges)
    e.some((r) => r.from <= t && r.to >= t) || e.push(n.lineBlockAt(t));
  return e;
}
const ai = /* @__PURE__ */ Lt.define({
  create() {
    return be.none;
  },
  update(n, e) {
    n = n.map(e.changes);
    for (let t of e.effects)
      if (t.is(ca) && !t8(n, t.value.from, t.value.to)) {
        let { preparePlaceholder: r } = e.state.facet(Mg), i = r ? be.replace({ widget: new a8(r(e.state, t.value)) }) : ed;
        n = n.update({ add: [i.range(t.value.from, t.value.to)] });
      } else t.is(dl) && (n = n.update({
        filter: (r, i) => t.value.from != r || t.value.to != i,
        filterFrom: t.value.from,
        filterTo: t.value.to
      }));
    if (e.selection) {
      let t = !1, { head: r } = e.selection.main;
      n.between(r, r, (i, s) => {
        i < r && s > r && (t = !0);
      }), t && (n = n.update({
        filterFrom: r,
        filterTo: r,
        filter: (i, s) => s <= r || i >= r
      }));
    }
    return n;
  },
  provide: (n) => Q.decorations.from(n),
  toJSON(n, e) {
    let t = [];
    return n.between(0, e.doc.length, (r, i) => {
      t.push(r, i);
    }), t;
  },
  fromJSON(n) {
    if (!Array.isArray(n) || n.length % 2)
      throw new RangeError("Invalid JSON for fold state");
    let e = [];
    for (let t = 0; t < n.length; ) {
      let r = n[t++], i = n[t++];
      if (typeof r != "number" || typeof i != "number")
        throw new RangeError("Invalid JSON for fold state");
      e.push(ed.range(r, i));
    }
    return be.set(e, !0);
  }
});
function Po(n, e, t) {
  var r;
  let i = null;
  return (r = n.field(ai, !1)) === null || r === void 0 || r.between(e, t, (s, l) => {
    (!i || i.from > s) && (i = { from: s, to: l });
  }), i;
}
function t8(n, e, t) {
  let r = !1;
  return n.between(e, e, (i, s) => {
    i == e && s == t && (r = !0);
  }), r;
}
function Cg(n, e) {
  return n.field(ai, !1) ? e : e.concat(ye.appendConfig.of(Tg()));
}
const r8 = (n) => {
  for (let e of Dg(n)) {
    let t = zo(n.state, e.from, e.to);
    if (t)
      return n.dispatch({ effects: Cg(n.state, [ca.of(t), _g(n, t)]) }), !0;
  }
  return !1;
}, n8 = (n) => {
  if (!n.state.field(ai, !1))
    return !1;
  let e = [];
  for (let t of Dg(n)) {
    let r = Po(n.state, t.from, t.to);
    r && e.push(dl.of(r), _g(n, r, !1));
  }
  return e.length && n.dispatch({ effects: e }), e.length > 0;
};
function _g(n, e, t = !0) {
  let r = n.state.doc.lineAt(e.from).number, i = n.state.doc.lineAt(e.to).number;
  return Q.announce.of(`${n.state.phrase(t ? "Folded lines" : "Unfolded lines")} ${r} ${n.state.phrase("to")} ${i}.`);
}
const i8 = (n) => {
  let { state: e } = n, t = [];
  for (let r = 0; r < e.doc.length; ) {
    let i = n.lineBlockAt(r), s = zo(e, i.from, i.to);
    s && t.push(ca.of(s)), r = (s ? n.lineBlockAt(s.to) : i).to + 1;
  }
  return t.length && n.dispatch({ effects: Cg(n.state, t) }), !!t.length;
}, s8 = (n) => {
  let e = n.state.field(ai, !1);
  if (!e || !e.size)
    return !1;
  let t = [];
  return e.between(0, n.state.doc.length, (r, i) => {
    t.push(dl.of({ from: r, to: i }));
  }), n.dispatch({ effects: t }), !0;
}, l8 = [
  { key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: r8 },
  { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: n8 },
  { key: "Ctrl-Alt-[", run: i8 },
  { key: "Ctrl-Alt-]", run: s8 }
], o8 = {
  placeholderDOM: null,
  preparePlaceholder: null,
  placeholderText: "…"
}, Mg = /* @__PURE__ */ X.define({
  combine(n) {
    return bi(n, o8);
  }
});
function Tg(n) {
  return [ai, c8];
}
function Eg(n, e) {
  let { state: t } = n, r = t.facet(Mg), i = (l) => {
    let o = n.lineBlockAt(n.posAtDOM(l.target)), a = Po(n.state, o.from, o.to);
    a && n.dispatch({ effects: dl.of(a) }), l.preventDefault();
  };
  if (r.placeholderDOM)
    return r.placeholderDOM(n, i, e);
  let s = document.createElement("span");
  return s.textContent = r.placeholderText, s.setAttribute("aria-label", t.phrase("folded code")), s.title = t.phrase("unfold"), s.className = "cm-foldPlaceholder", s.onclick = i, s;
}
const ed = /* @__PURE__ */ be.replace({ widget: /* @__PURE__ */ new class extends Xr {
  toDOM(n) {
    return Eg(n, null);
  }
}() });
class a8 extends Xr {
  constructor(e) {
    super(), this.value = e;
  }
  eq(e) {
    return this.value == e.value;
  }
  toDOM(e) {
    return Eg(e, this.value);
  }
}
const u8 = {
  openText: "⌄",
  closedText: "›",
  markerDOM: null,
  domEventHandlers: {},
  foldingChanged: () => !1
};
class $a extends Nn {
  constructor(e, t) {
    super(), this.config = e, this.open = t;
  }
  eq(e) {
    return this.config == e.config && this.open == e.open;
  }
  toDOM(e) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    let t = document.createElement("span");
    return t.textContent = this.open ? this.config.openText : this.config.closedText, t.title = e.state.phrase(this.open ? "Fold line" : "Unfold line"), t;
  }
}
function h8(n = {}) {
  let e = Object.assign(Object.assign({}, u8), n), t = new $a(e, !0), r = new $a(e, !1), i = pt.fromClass(class {
    constructor(l) {
      this.from = l.viewport.from, this.markers = this.buildMarkers(l);
    }
    update(l) {
      (l.docChanged || l.viewportChanged || l.startState.facet(zn) != l.state.facet(zn) || l.startState.field(ai, !1) != l.state.field(ai, !1) || nt(l.startState) != nt(l.state) || e.foldingChanged(l)) && (this.markers = this.buildMarkers(l.view));
    }
    buildMarkers(l) {
      let o = new ni();
      for (let a of l.viewportLineBlocks) {
        let u = Po(l.state, a.from, a.to) ? r : zo(l.state, a.from, a.to) ? t : null;
        u && o.add(a.from, a.from, u);
      }
      return o.finish();
    }
  }), { domEventHandlers: s } = e;
  return [
    i,
    a7({
      class: "cm-foldGutter",
      markers(l) {
        var o;
        return ((o = l.plugin(i)) === null || o === void 0 ? void 0 : o.markers) || Ce.empty;
      },
      initialSpacer() {
        return new $a(e, !1);
      },
      domEventHandlers: Object.assign(Object.assign({}, s), { click: (l, o, a) => {
        if (s.click && s.click(l, o, a))
          return !0;
        let u = Po(l.state, o.from, o.to);
        if (u)
          return l.dispatch({ effects: dl.of(u) }), !0;
        let h = zo(l.state, o.from, o.to);
        return h ? (l.dispatch({ effects: ca.of(h) }), !0) : !1;
      } })
    }),
    Tg()
  ];
}
const c8 = /* @__PURE__ */ Q.baseTheme({
  ".cm-foldPlaceholder": {
    backgroundColor: "#eee",
    border: "1px solid #ddd",
    color: "#888",
    borderRadius: ".2em",
    margin: "0 1px",
    padding: "0 1px",
    cursor: "pointer"
  },
  ".cm-foldGutter span": {
    padding: "0 1px",
    cursor: "pointer"
  }
});
class ns {
  constructor(e, t) {
    this.specs = e;
    let r;
    function i(o) {
      let a = On.newName();
      return (r || (r = /* @__PURE__ */ Object.create(null)))["." + a] = o, a;
    }
    const s = typeof t.all == "string" ? t.all : t.all ? i(t.all) : void 0, l = t.scope;
    this.scope = l instanceof Jt ? (o) => o.prop(Jn) == l.data : l ? (o) => o == l : void 0, this.style = bg(e.map((o) => ({
      tag: o.tag,
      class: o.class || i(Object.assign({}, o, { tag: null }))
    })), {
      all: s
    }).style, this.module = r ? new On(r) : null, this.themeType = t.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(e, t) {
    return new ns(e, t || {});
  }
}
const Eu = /* @__PURE__ */ X.define(), Fg = /* @__PURE__ */ X.define({
  combine(n) {
    return n.length ? [n[0]] : null;
  }
});
function Ya(n) {
  let e = n.facet(Eu);
  return e.length ? e : n.facet(Fg);
}
function xh(n, e) {
  let t = [d8], r;
  return n instanceof ns && (n.module && t.push(Q.styleModule.of(n.module)), r = n.themeType), e?.fallback ? t.push(Fg.of(n)) : r ? t.push(Eu.computeN([Q.darkTheme], (i) => i.facet(Q.darkTheme) == (r == "dark") ? [n] : [])) : t.push(Eu.of(n)), t;
}
class f8 {
  constructor(e) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = nt(e.state), this.decorations = this.buildDeco(e, Ya(e.state)), this.decoratedTo = e.viewport.to;
  }
  update(e) {
    let t = nt(e.state), r = Ya(e.state), i = r != Ya(e.startState), { viewport: s } = e.view, l = e.changes.mapPos(this.decoratedTo, 1);
    t.length < s.to && !i && t.type == this.tree.type && l >= s.to ? (this.decorations = this.decorations.map(e.changes), this.decoratedTo = l) : (t != this.tree || e.viewportChanged || i) && (this.tree = t, this.decorations = this.buildDeco(e.view, r), this.decoratedTo = s.to);
  }
  buildDeco(e, t) {
    if (!t || !this.tree.length)
      return be.none;
    let r = new ni();
    for (let { from: i, to: s } of e.visibleRanges)
      N7(this.tree, t, (l, o, a) => {
        r.add(l, o, this.markCache[a] || (this.markCache[a] = be.mark({ class: a })));
      }, i, s);
    return r.finish();
  }
}
const d8 = /* @__PURE__ */ al.high(/* @__PURE__ */ pt.fromClass(f8, {
  decorations: (n) => n.decorations
})), m8 = /* @__PURE__ */ ns.define([
  {
    tag: E.meta,
    color: "#404740"
  },
  {
    tag: E.link,
    textDecoration: "underline"
  },
  {
    tag: E.heading,
    textDecoration: "underline",
    fontWeight: "bold"
  },
  {
    tag: E.emphasis,
    fontStyle: "italic"
  },
  {
    tag: E.strong,
    fontWeight: "bold"
  },
  {
    tag: E.strikethrough,
    textDecoration: "line-through"
  },
  {
    tag: E.keyword,
    color: "#708"
  },
  {
    tag: [E.atom, E.bool, E.url, E.contentSeparator, E.labelName],
    color: "#219"
  },
  {
    tag: [E.literal, E.inserted],
    color: "#164"
  },
  {
    tag: [E.string, E.deleted],
    color: "#a11"
  },
  {
    tag: [E.regexp, E.escape, /* @__PURE__ */ E.special(E.string)],
    color: "#e40"
  },
  {
    tag: /* @__PURE__ */ E.definition(E.variableName),
    color: "#00f"
  },
  {
    tag: /* @__PURE__ */ E.local(E.variableName),
    color: "#30a"
  },
  {
    tag: [E.typeName, E.namespace],
    color: "#085"
  },
  {
    tag: E.className,
    color: "#167"
  },
  {
    tag: [/* @__PURE__ */ E.special(E.variableName), E.macroName],
    color: "#256"
  },
  {
    tag: /* @__PURE__ */ E.definition(E.propertyName),
    color: "#00c"
  },
  {
    tag: E.comment,
    color: "#940"
  },
  {
    tag: E.invalid,
    color: "#f00"
  }
]), p8 = 1e4, g8 = "()[]{}", b8 = /* @__PURE__ */ new we();
function Fu(n, e, t) {
  let r = n.prop(e < 0 ? we.openedBy : we.closedBy);
  if (r)
    return r;
  if (n.name.length == 1) {
    let i = t.indexOf(n.name);
    if (i > -1 && i % 2 == (e < 0 ? 1 : 0))
      return [t[i + e]];
  }
  return null;
}
function Bu(n) {
  let e = n.type.prop(b8);
  return e ? e(n.node) : n;
}
function Bi(n, e, t, r = {}) {
  let i = r.maxScanDistance || p8, s = r.brackets || g8, l = nt(n), o = l.resolveInner(e, t);
  for (let a = o; a; a = a.parent) {
    let u = Fu(a.type, t, s);
    if (u && a.from < a.to) {
      let h = Bu(a);
      if (h && (t > 0 ? e >= h.from && e < h.to : e > h.from && e <= h.to))
        return v8(n, e, t, a, h, u, s);
    }
  }
  return y8(n, e, t, l, o.type, i, s);
}
function v8(n, e, t, r, i, s, l) {
  let o = r.parent, a = { from: i.from, to: i.to }, u = 0, h = o?.cursor();
  if (h && (t < 0 ? h.childBefore(r.from) : h.childAfter(r.to)))
    do
      if (t < 0 ? h.to <= r.from : h.from >= r.to) {
        if (u == 0 && s.indexOf(h.type.name) > -1 && h.from < h.to) {
          let c = Bu(h);
          return { start: a, end: c ? { from: c.from, to: c.to } : void 0, matched: !0 };
        } else if (Fu(h.type, t, l))
          u++;
        else if (Fu(h.type, -t, l)) {
          if (u == 0) {
            let c = Bu(h);
            return {
              start: a,
              end: c && c.from < c.to ? { from: c.from, to: c.to } : void 0,
              matched: !1
            };
          }
          u--;
        }
      }
    while (t < 0 ? h.prevSibling() : h.nextSibling());
  return { start: a, matched: !1 };
}
function y8(n, e, t, r, i, s, l) {
  let o = t < 0 ? n.sliceDoc(e - 1, e) : n.sliceDoc(e, e + 1), a = l.indexOf(o);
  if (a < 0 || a % 2 == 0 != t > 0)
    return null;
  let u = { from: t < 0 ? e - 1 : e, to: t > 0 ? e + 1 : e }, h = n.doc.iterRange(e, t > 0 ? n.doc.length : 0), c = 0;
  for (let f = 0; !h.next().done && f <= s; ) {
    let m = h.value;
    t < 0 && (f += m.length);
    let g = e + f * t;
    for (let v = t > 0 ? 0 : m.length - 1, k = t > 0 ? m.length : -1; v != k; v += t) {
      let S = l.indexOf(m[v]);
      if (!(S < 0 || r.resolveInner(g + v, 1).type != i))
        if (S % 2 == 0 == t > 0)
          c++;
        else {
          if (c == 1)
            return { start: u, end: { from: g + v, to: g + v + 1 }, matched: S >> 1 == a >> 1 };
          c--;
        }
    }
    t > 0 && (f += m.length);
  }
  return h.done ? { start: u, matched: !1 } : null;
}
function td(n, e, t, r = 0, i = 0) {
  e == null && (e = n.search(/[^\s\u00a0]/), e == -1 && (e = n.length));
  let s = i;
  for (let l = r; l < e; l++)
    n.charCodeAt(l) == 9 ? s += t - s % t : s++;
  return s;
}
class Bg {
  /**
  Create a stream.
  */
  constructor(e, t, r, i) {
    this.string = e, this.tabSize = t, this.indentUnit = r, this.overrideIndent = i, this.pos = 0, this.start = 0, this.lastColumnPos = 0, this.lastColumnValue = 0;
  }
  /**
  True if we are at the end of the line.
  */
  eol() {
    return this.pos >= this.string.length;
  }
  /**
  True if we are at the start of the line.
  */
  sol() {
    return this.pos == 0;
  }
  /**
  Get the next code unit after the current position, or undefined
  if we're at the end of the line.
  */
  peek() {
    return this.string.charAt(this.pos) || void 0;
  }
  /**
  Read the next code unit and advance `this.pos`.
  */
  next() {
    if (this.pos < this.string.length)
      return this.string.charAt(this.pos++);
  }
  /**
  Match the next character against the given string, regular
  expression, or predicate. Consume and return it if it matches.
  */
  eat(e) {
    let t = this.string.charAt(this.pos), r;
    if (typeof e == "string" ? r = t == e : r = t && (e instanceof RegExp ? e.test(t) : e(t)), r)
      return ++this.pos, t;
  }
  /**
  Continue matching characters that match the given string,
  regular expression, or predicate function. Return true if any
  characters were consumed.
  */
  eatWhile(e) {
    let t = this.pos;
    for (; this.eat(e); )
      ;
    return this.pos > t;
  }
  /**
  Consume whitespace ahead of `this.pos`. Return true if any was
  found.
  */
  eatSpace() {
    let e = this.pos;
    for (; /[\s\u00a0]/.test(this.string.charAt(this.pos)); )
      ++this.pos;
    return this.pos > e;
  }
  /**
  Move to the end of the line.
  */
  skipToEnd() {
    this.pos = this.string.length;
  }
  /**
  Move to directly before the given character, if found on the
  current line.
  */
  skipTo(e) {
    let t = this.string.indexOf(e, this.pos);
    if (t > -1)
      return this.pos = t, !0;
  }
  /**
  Move back `n` characters.
  */
  backUp(e) {
    this.pos -= e;
  }
  /**
  Get the column position at `this.pos`.
  */
  column() {
    return this.lastColumnPos < this.start && (this.lastColumnValue = td(this.string, this.start, this.tabSize, this.lastColumnPos, this.lastColumnValue), this.lastColumnPos = this.start), this.lastColumnValue;
  }
  /**
  Get the indentation column of the current line.
  */
  indentation() {
    var e;
    return (e = this.overrideIndent) !== null && e !== void 0 ? e : td(this.string, null, this.tabSize);
  }
  /**
  Match the input against the given string or regular expression
  (which should start with a `^`). Return true or the regexp match
  if it matches.
  
  Unless `consume` is set to `false`, this will move `this.pos`
  past the matched text.
  
  When matching a string `caseInsensitive` can be set to true to
  make the match case-insensitive.
  */
  match(e, t, r) {
    if (typeof e == "string") {
      let i = (l) => r ? l.toLowerCase() : l, s = this.string.substr(this.pos, e.length);
      return i(s) == i(e) ? (t !== !1 && (this.pos += e.length), !0) : null;
    } else {
      let i = this.string.slice(this.pos).match(e);
      return i && i.index > 0 ? null : (i && t !== !1 && (this.pos += i[0].length), i);
    }
  }
  /**
  Get the current token.
  */
  current() {
    return this.string.slice(this.start, this.pos);
  }
}
function w8(n) {
  return {
    name: n.name || "",
    token: n.token,
    blankLine: n.blankLine || (() => {
    }),
    startState: n.startState || (() => !0),
    copyState: n.copyState || k8,
    indent: n.indent || (() => null),
    languageData: n.languageData || {},
    tokenTable: n.tokenTable || Ah
  };
}
function k8(n) {
  if (typeof n != "object")
    return n;
  let e = {};
  for (let t in n) {
    let r = n[t];
    e[t] = r instanceof Array ? r.slice() : r;
  }
  return e;
}
const rd = /* @__PURE__ */ new WeakMap();
class Oi extends Jt {
  constructor(e) {
    let t = vg(e.languageData), r = w8(e), i, s = new class extends pg {
      createParse(l, o, a) {
        return new S8(i, l, o, a);
      }
    }();
    super(t, s, [kg.of((l, o) => this.getIndent(l, o))], e.name), this.topNode = C8(t), i = this, this.streamParser = r, this.stateAfter = new we({ perNode: !0 }), this.tokenTable = e.tokenTable ? new Ng(r.tokenTable) : D8;
  }
  /**
  Define a stream language.
  */
  static define(e) {
    return new Oi(e);
  }
  getIndent(e, t) {
    let r = nt(e.state), i = r.resolve(t);
    for (; i && i.type != this.topNode; )
      i = i.parent;
    if (!i)
      return null;
    let s, { overrideIndentation: l } = e.options;
    l && (s = rd.get(e.state), s != null && s < t - 1e4 && (s = void 0));
    let o = Sh(this, r, 0, i.from, s ?? t), a, u;
    if (o ? (u = o.state, a = o.pos + 1) : (u = this.streamParser.startState(e.unit), a = 0), t - a > 1e4)
      return null;
    for (; a < t; ) {
      let c = e.state.doc.lineAt(a), f = Math.min(t, c.to);
      if (c.length) {
        let m = l ? l(c.from) : -1, g = new Bg(c.text, e.state.tabSize, e.unit, m < 0 ? void 0 : m);
        for (; g.pos < f - c.from; )
          Rg(this.streamParser.token, g, u);
      } else
        this.streamParser.blankLine(u, e.unit);
      if (f == t)
        break;
      a = c.to + 1;
    }
    let h = e.lineAt(t);
    return l && s == null && rd.set(e.state, h.from), this.streamParser.indent(u, /^\s*(.*)/.exec(h.text)[1], e);
  }
  get allowsNesting() {
    return !1;
  }
}
function Sh(n, e, t, r, i) {
  let s = t >= r && t + e.length <= i && e.prop(n.stateAfter);
  if (s)
    return { state: n.streamParser.copyState(s), pos: t + e.length };
  for (let l = e.children.length - 1; l >= 0; l--) {
    let o = e.children[l], a = t + e.positions[l], u = o instanceof Le && a < i && Sh(n, o, a, r, i);
    if (u)
      return u;
  }
  return null;
}
function Og(n, e, t, r, i) {
  if (i && t <= 0 && r >= e.length)
    return e;
  !i && e.type == n.topNode && (i = !0);
  for (let s = e.children.length - 1; s >= 0; s--) {
    let l = e.positions[s], o = e.children[s], a;
    if (l < r && o instanceof Le) {
      if (!(a = Og(n, o, t - l, r - l, i)))
        break;
      return i ? new Le(e.type, e.children.slice(0, s).concat(a), e.positions.slice(0, s + 1), l + a.length) : a;
    }
  }
  return null;
}
function x8(n, e, t, r) {
  for (let i of e) {
    let s = i.from + (i.openStart ? 25 : 0), l = i.to - (i.openEnd ? 25 : 0), o = s <= t && l > t && Sh(n, i.tree, 0 - i.offset, t, l), a;
    if (o && (a = Og(n, i.tree, t + i.offset, o.pos + i.offset, !1)))
      return { state: o.state, tree: a };
  }
  return { state: n.streamParser.startState(r ? oi(r) : 4), tree: Le.empty };
}
class S8 {
  constructor(e, t, r, i) {
    this.lang = e, this.input = t, this.fragments = r, this.ranges = i, this.stoppedAt = null, this.chunks = [], this.chunkPos = [], this.chunk = [], this.chunkReused = void 0, this.rangeIndex = 0, this.to = i[i.length - 1].to;
    let s = Ki.get(), l = i[0].from, { state: o, tree: a } = x8(e, r, l, s?.state);
    this.state = o, this.parsedPos = this.chunkStart = l + a.length;
    for (let u = 0; u < a.children.length; u++)
      this.chunks.push(a.children[u]), this.chunkPos.push(a.positions[u]);
    s && this.parsedPos < s.viewport.from - 1e5 && (this.state = this.lang.streamParser.startState(oi(s.state)), s.skipUntilInView(this.parsedPos, s.viewport.from), this.parsedPos = s.viewport.from), this.moveRangeIndex();
  }
  advance() {
    let e = Ki.get(), t = this.stoppedAt == null ? this.to : Math.min(this.to, this.stoppedAt), r = Math.min(
      t,
      this.chunkStart + 2048
      /* C.ChunkSize */
    );
    for (e && (r = Math.min(r, e.viewport.to)); this.parsedPos < r; )
      this.parseLine(e);
    return this.chunkStart < this.parsedPos && this.finishChunk(), this.parsedPos >= t ? this.finish() : e && this.parsedPos >= e.viewport.to ? (e.skipUntilInView(this.parsedPos, t), this.finish()) : null;
  }
  stopAt(e) {
    this.stoppedAt = e;
  }
  lineAfter(e) {
    let t = this.input.chunk(e);
    if (this.input.lineChunks)
      t == `
` && (t = "");
    else {
      let r = t.indexOf(`
`);
      r > -1 && (t = t.slice(0, r));
    }
    return e + t.length <= this.to ? t : t.slice(0, this.to - e);
  }
  nextLine() {
    let e = this.parsedPos, t = this.lineAfter(e), r = e + t.length;
    for (let i = this.rangeIndex; ; ) {
      let s = this.ranges[i].to;
      if (s >= r || (t = t.slice(0, s - (r - t.length)), i++, i == this.ranges.length))
        break;
      let l = this.ranges[i].from, o = this.lineAfter(l);
      t += o, r = l + o.length;
    }
    return { line: t, end: r };
  }
  skipGapsTo(e, t, r) {
    for (; ; ) {
      let i = this.ranges[this.rangeIndex].to, s = e + t;
      if (r > 0 ? i > s : i >= s)
        break;
      let l = this.ranges[++this.rangeIndex].from;
      t += l - i;
    }
    return t;
  }
  moveRangeIndex() {
    for (; this.ranges[this.rangeIndex].to < this.parsedPos; )
      this.rangeIndex++;
  }
  emitToken(e, t, r, i, s) {
    if (this.ranges.length > 1) {
      s = this.skipGapsTo(t, s, 1), t += s;
      let l = this.chunk.length;
      s = this.skipGapsTo(r, s, -1), r += s, i += this.chunk.length - l;
    }
    return this.chunk.push(e, t, r, i), s;
  }
  parseLine(e) {
    let { line: t, end: r } = this.nextLine(), i = 0, { streamParser: s } = this.lang, l = new Bg(t, e ? e.state.tabSize : 4, e ? oi(e.state) : 2);
    if (l.eol())
      s.blankLine(this.state, l.indentUnit);
    else
      for (; !l.eol(); ) {
        let o = Rg(s.token, l, this.state);
        if (o && (i = this.emitToken(this.lang.tokenTable.resolve(o), this.parsedPos + l.start, this.parsedPos + l.pos, 4, i)), l.start > 1e4)
          break;
      }
    this.parsedPos = r, this.moveRangeIndex(), this.parsedPos < this.to && this.parsedPos++;
  }
  finishChunk() {
    let e = Le.build({
      buffer: this.chunk,
      start: this.chunkStart,
      length: this.parsedPos - this.chunkStart,
      nodeSet: A8,
      topID: 0,
      maxBufferLength: 2048,
      reused: this.chunkReused
    });
    e = new Le(e.type, e.children, e.positions, e.length, [[this.lang.stateAfter, this.lang.streamParser.copyState(this.state)]]), this.chunks.push(e), this.chunkPos.push(this.chunkStart - this.ranges[0].from), this.chunk = [], this.chunkReused = void 0, this.chunkStart = this.parsedPos;
  }
  finish() {
    return new Le(this.lang.topNode, this.chunks, this.chunkPos, this.parsedPos - this.ranges[0].from).balance();
  }
}
function Rg(n, e, t) {
  e.start = e.pos;
  for (let r = 0; r < 10; r++) {
    let i = n(e, t);
    if (e.pos > e.start)
      return i;
  }
  throw new Error("Stream parser failed to advance stream.");
}
const Ah = /* @__PURE__ */ Object.create(null), tl = [Dt.none], A8 = /* @__PURE__ */ new gh(tl), nd = [], id = /* @__PURE__ */ Object.create(null), Lg = /* @__PURE__ */ Object.create(null);
for (let [n, e] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Lg[n] = /* @__PURE__ */ Ig(Ah, e);
class Ng {
  constructor(e) {
    this.extra = e, this.table = Object.assign(/* @__PURE__ */ Object.create(null), Lg);
  }
  resolve(e) {
    return e ? this.table[e] || (this.table[e] = Ig(this.extra, e)) : 0;
  }
}
const D8 = /* @__PURE__ */ new Ng(Ah);
function Ka(n, e) {
  nd.indexOf(n) > -1 || (nd.push(n), console.warn(e));
}
function Ig(n, e) {
  let t = [];
  for (let o of e.split(" ")) {
    let a = [];
    for (let u of o.split(".")) {
      let h = n[u] || E[u];
      h ? typeof h == "function" ? a.length ? a = a.map(h) : Ka(u, `Modifier ${u} used at start of tag`) : a.length ? Ka(u, `Tag ${u} used as modifier`) : a = Array.isArray(h) ? h : [h] : Ka(u, `Unknown highlighting tag ${u}`);
    }
    for (let u of a)
      t.push(u);
  }
  if (!t.length)
    return 0;
  let r = e.replace(/ /g, "_"), i = r + " " + t.map((o) => o.id), s = id[i];
  if (s)
    return s.id;
  let l = id[i] = Dt.define({
    id: tl.length,
    name: r,
    props: [R7({ [r]: t })]
  });
  return tl.push(l), l.id;
}
function C8(n) {
  let e = Dt.define({ id: tl.length, name: "Document", props: [Jn.add(() => n)], top: !0 });
  return tl.push(e), e;
}
Ie.RTL, Ie.LTR;
const _8 = (n) => {
  let { state: e } = n, t = e.doc.lineAt(e.selection.main.from), r = Ch(n.state, t.from);
  return r.line ? M8(n) : r.block ? E8(n) : !1;
};
function Dh(n, e) {
  return ({ state: t, dispatch: r }) => {
    if (t.readOnly)
      return !1;
    let i = n(e, t);
    return i ? (r(t.update(i)), !0) : !1;
  };
}
const M8 = /* @__PURE__ */ Dh(
  O8,
  0
  /* CommentOption.Toggle */
), T8 = /* @__PURE__ */ Dh(
  zg,
  0
  /* CommentOption.Toggle */
), E8 = /* @__PURE__ */ Dh(
  (n, e) => zg(n, e, B8(e)),
  0
  /* CommentOption.Toggle */
);
function Ch(n, e) {
  let t = n.languageDataAt("commentTokens", e);
  return t.length ? t[0] : {};
}
const bs = 50;
function F8(n, { open: e, close: t }, r, i) {
  let s = n.sliceDoc(r - bs, r), l = n.sliceDoc(i, i + bs), o = /\s*$/.exec(s)[0].length, a = /^\s*/.exec(l)[0].length, u = s.length - o;
  if (s.slice(u - e.length, u) == e && l.slice(a, a + t.length) == t)
    return {
      open: { pos: r - o, margin: o && 1 },
      close: { pos: i + a, margin: a && 1 }
    };
  let h, c;
  i - r <= 2 * bs ? h = c = n.sliceDoc(r, i) : (h = n.sliceDoc(r, r + bs), c = n.sliceDoc(i - bs, i));
  let f = /^\s*/.exec(h)[0].length, m = /\s*$/.exec(c)[0].length, g = c.length - m - t.length;
  return h.slice(f, f + e.length) == e && c.slice(g, g + t.length) == t ? {
    open: {
      pos: r + f + e.length,
      margin: /\s/.test(h.charAt(f + e.length)) ? 1 : 0
    },
    close: {
      pos: i - m - t.length,
      margin: /\s/.test(c.charAt(g - 1)) ? 1 : 0
    }
  } : null;
}
function B8(n) {
  let e = [];
  for (let t of n.selection.ranges) {
    let r = n.doc.lineAt(t.from), i = t.to <= r.to ? r : n.doc.lineAt(t.to);
    i.from > r.from && i.from == t.to && (i = t.to == r.to + 1 ? r : n.doc.lineAt(t.to - 1));
    let s = e.length - 1;
    s >= 0 && e[s].to > r.from ? e[s].to = i.to : e.push({ from: r.from + /^\s*/.exec(r.text)[0].length, to: i.to });
  }
  return e;
}
function zg(n, e, t = e.selection.ranges) {
  let r = t.map((s) => Ch(e, s.from).block);
  if (!r.every((s) => s))
    return null;
  let i = t.map((s, l) => F8(e, r[l], s.from, s.to));
  if (n != 2 && !i.every((s) => s))
    return { changes: e.changes(t.map((s, l) => i[l] ? [] : [{ from: s.from, insert: r[l].open + " " }, { from: s.to, insert: " " + r[l].close }])) };
  if (n != 1 && i.some((s) => s)) {
    let s = [];
    for (let l = 0, o; l < i.length; l++)
      if (o = i[l]) {
        let a = r[l], { open: u, close: h } = o;
        s.push({ from: u.pos - a.open.length, to: u.pos + u.margin }, { from: h.pos - h.margin, to: h.pos + a.close.length });
      }
    return { changes: s };
  }
  return null;
}
function O8(n, e, t = e.selection.ranges) {
  let r = [], i = -1;
  for (let { from: s, to: l } of t) {
    let o = r.length, a = 1e9, u = Ch(e, s).line;
    if (u) {
      for (let h = s; h <= l; ) {
        let c = e.doc.lineAt(h);
        if (c.from > i && (s == l || l > c.from)) {
          i = c.from;
          let f = /^\s*/.exec(c.text)[0].length, m = f == c.length, g = c.text.slice(f, f + u.length) == u ? f : -1;
          f < c.text.length && f < a && (a = f), r.push({ line: c, comment: g, token: u, indent: f, empty: m, single: !1 });
        }
        h = c.to + 1;
      }
      if (a < 1e9)
        for (let h = o; h < r.length; h++)
          r[h].indent < r[h].line.text.length && (r[h].indent = a);
      r.length == o + 1 && (r[o].single = !0);
    }
  }
  if (n != 2 && r.some((s) => s.comment < 0 && (!s.empty || s.single))) {
    let s = [];
    for (let { line: o, token: a, indent: u, empty: h, single: c } of r)
      (c || !h) && s.push({ from: o.from + u, insert: a + " " });
    let l = e.changes(s);
    return { changes: l, selection: e.selection.map(l, 1) };
  } else if (n != 1 && r.some((s) => s.comment >= 0)) {
    let s = [];
    for (let { line: l, comment: o, token: a } of r)
      if (o >= 0) {
        let u = l.from + o, h = u + a.length;
        l.text[h - l.from] == " " && h++, s.push({ from: u, to: h });
      }
    return { changes: s };
  }
  return null;
}
const Ou = /* @__PURE__ */ vn.define(), R8 = /* @__PURE__ */ vn.define(), L8 = /* @__PURE__ */ X.define(), Pg = /* @__PURE__ */ X.define({
  combine(n) {
    return bi(n, {
      minDepth: 100,
      newGroupDelay: 500,
      joinToEvent: (e, t) => t
    }, {
      minDepth: Math.max,
      newGroupDelay: Math.min,
      joinToEvent: (e, t) => (r, i) => e(r, i) || t(r, i)
    });
  }
}), Hg = /* @__PURE__ */ Lt.define({
  create() {
    return Hr.empty;
  },
  update(n, e) {
    let t = e.state.facet(Pg), r = e.annotation(Ou);
    if (r) {
      let a = Rt.fromTransaction(e, r.selection), u = r.side, h = u == 0 ? n.undone : n.done;
      return a ? h = Ho(h, h.length, t.minDepth, a) : h = Wg(h, e.startState.selection), new Hr(u == 0 ? r.rest : h, u == 0 ? h : r.rest);
    }
    let i = e.annotation(R8);
    if ((i == "full" || i == "before") && (n = n.isolate()), e.annotation(Qe.addToHistory) === !1)
      return e.changes.empty ? n : n.addMapping(e.changes.desc);
    let s = Rt.fromTransaction(e), l = e.annotation(Qe.time), o = e.annotation(Qe.userEvent);
    return s ? n = n.addChanges(s, l, o, t, e) : e.selection && (n = n.addSelection(e.startState.selection, l, o, t.newGroupDelay)), (i == "full" || i == "after") && (n = n.isolate()), n;
  },
  toJSON(n) {
    return { done: n.done.map((e) => e.toJSON()), undone: n.undone.map((e) => e.toJSON()) };
  },
  fromJSON(n) {
    return new Hr(n.done.map(Rt.fromJSON), n.undone.map(Rt.fromJSON));
  }
});
function N8(n = {}) {
  return [
    Hg,
    Pg.of(n),
    Q.domEventHandlers({
      beforeinput(e, t) {
        let r = e.inputType == "historyUndo" ? qg : e.inputType == "historyRedo" ? Ru : null;
        return r ? (e.preventDefault(), r(t)) : !1;
      }
    })
  ];
}
function fa(n, e) {
  return function({ state: t, dispatch: r }) {
    if (!e && t.readOnly)
      return !1;
    let i = t.field(Hg, !1);
    if (!i)
      return !1;
    let s = i.pop(n, t, e);
    return s ? (r(s), !0) : !1;
  };
}
const qg = /* @__PURE__ */ fa(0, !1), Ru = /* @__PURE__ */ fa(1, !1), I8 = /* @__PURE__ */ fa(0, !0), z8 = /* @__PURE__ */ fa(1, !0);
class Rt {
  constructor(e, t, r, i, s) {
    this.changes = e, this.effects = t, this.mapped = r, this.startSelection = i, this.selectionsAfter = s;
  }
  setSelAfter(e) {
    return new Rt(this.changes, this.effects, this.mapped, this.startSelection, e);
  }
  toJSON() {
    var e, t, r;
    return {
      changes: (e = this.changes) === null || e === void 0 ? void 0 : e.toJSON(),
      mapped: (t = this.mapped) === null || t === void 0 ? void 0 : t.toJSON(),
      startSelection: (r = this.startSelection) === null || r === void 0 ? void 0 : r.toJSON(),
      selectionsAfter: this.selectionsAfter.map((i) => i.toJSON())
    };
  }
  static fromJSON(e) {
    return new Rt(e.changes && tt.fromJSON(e.changes), [], e.mapped && $r.fromJSON(e.mapped), e.startSelection && I.fromJSON(e.startSelection), e.selectionsAfter.map(I.fromJSON));
  }
  // This does not check `addToHistory` and such, it assumes the
  // transaction needs to be converted to an item. Returns null when
  // there are no changes or effects in the transaction.
  static fromTransaction(e, t) {
    let r = Qt;
    for (let i of e.startState.facet(L8)) {
      let s = i(e);
      s.length && (r = r.concat(s));
    }
    return !r.length && e.changes.empty ? null : new Rt(e.changes.invert(e.startState.doc), r, void 0, t || e.startState.selection, Qt);
  }
  static selection(e) {
    return new Rt(void 0, Qt, void 0, void 0, e);
  }
}
function Ho(n, e, t, r) {
  let i = e + 1 > t + 20 ? e - t - 1 : 0, s = n.slice(i, e);
  return s.push(r), s;
}
function P8(n, e) {
  let t = [], r = !1;
  return n.iterChangedRanges((i, s) => t.push(i, s)), e.iterChangedRanges((i, s, l, o) => {
    for (let a = 0; a < t.length; ) {
      let u = t[a++], h = t[a++];
      o >= u && l <= h && (r = !0);
    }
  }), r;
}
function H8(n, e) {
  return n.ranges.length == e.ranges.length && n.ranges.filter((t, r) => t.empty != e.ranges[r].empty).length === 0;
}
function Vg(n, e) {
  return n.length ? e.length ? n.concat(e) : n : e;
}
const Qt = [], q8 = 200;
function Wg(n, e) {
  if (n.length) {
    let t = n[n.length - 1], r = t.selectionsAfter.slice(Math.max(0, t.selectionsAfter.length - q8));
    return r.length && r[r.length - 1].eq(e) ? n : (r.push(e), Ho(n, n.length - 1, 1e9, t.setSelAfter(r)));
  } else
    return [Rt.selection([e])];
}
function V8(n) {
  let e = n[n.length - 1], t = n.slice();
  return t[n.length - 1] = e.setSelAfter(e.selectionsAfter.slice(0, e.selectionsAfter.length - 1)), t;
}
function Xa(n, e) {
  if (!n.length)
    return n;
  let t = n.length, r = Qt;
  for (; t; ) {
    let i = W8(n[t - 1], e, r);
    if (i.changes && !i.changes.empty || i.effects.length) {
      let s = n.slice(0, t);
      return s[t - 1] = i, s;
    } else
      e = i.mapped, t--, r = i.selectionsAfter;
  }
  return r.length ? [Rt.selection(r)] : Qt;
}
function W8(n, e, t) {
  let r = Vg(n.selectionsAfter.length ? n.selectionsAfter.map((o) => o.map(e)) : Qt, t);
  if (!n.changes)
    return Rt.selection(r);
  let i = n.changes.map(e), s = e.mapDesc(n.changes, !0), l = n.mapped ? n.mapped.composeDesc(s) : s;
  return new Rt(i, ye.mapEffects(n.effects, e), l, n.startSelection.map(s), r);
}
const U8 = /^(input\.type|delete)($|\.)/;
class Hr {
  constructor(e, t, r = 0, i = void 0) {
    this.done = e, this.undone = t, this.prevTime = r, this.prevUserEvent = i;
  }
  isolate() {
    return this.prevTime ? new Hr(this.done, this.undone) : this;
  }
  addChanges(e, t, r, i, s) {
    let l = this.done, o = l[l.length - 1];
    return o && o.changes && !o.changes.empty && e.changes && (!r || U8.test(r)) && (!o.selectionsAfter.length && t - this.prevTime < i.newGroupDelay && i.joinToEvent(s, P8(o.changes, e.changes)) || // For compose (but not compose.start) events, always join with previous event
    r == "input.type.compose") ? l = Ho(l, l.length - 1, i.minDepth, new Rt(e.changes.compose(o.changes), Vg(ye.mapEffects(e.effects, o.changes), o.effects), o.mapped, o.startSelection, Qt)) : l = Ho(l, l.length, i.minDepth, e), new Hr(l, Qt, t, r);
  }
  addSelection(e, t, r, i) {
    let s = this.done.length ? this.done[this.done.length - 1].selectionsAfter : Qt;
    return s.length > 0 && t - this.prevTime < i && r == this.prevUserEvent && r && /^select($|\.)/.test(r) && H8(s[s.length - 1], e) ? this : new Hr(Wg(this.done, e), this.undone, t, r);
  }
  addMapping(e) {
    return new Hr(Xa(this.done, e), Xa(this.undone, e), this.prevTime, this.prevUserEvent);
  }
  pop(e, t, r) {
    let i = e == 0 ? this.done : this.undone;
    if (i.length == 0)
      return null;
    let s = i[i.length - 1], l = s.selectionsAfter[0] || t.selection;
    if (r && s.selectionsAfter.length)
      return t.update({
        selection: s.selectionsAfter[s.selectionsAfter.length - 1],
        annotations: Ou.of({ side: e, rest: V8(i), selection: l }),
        userEvent: e == 0 ? "select.undo" : "select.redo",
        scrollIntoView: !0
      });
    if (s.changes) {
      let o = i.length == 1 ? Qt : i.slice(0, i.length - 1);
      return s.mapped && (o = Xa(o, s.mapped)), t.update({
        changes: s.changes,
        selection: s.startSelection,
        effects: s.effects,
        annotations: Ou.of({ side: e, rest: o, selection: l }),
        filter: !1,
        userEvent: e == 0 ? "undo" : "redo",
        scrollIntoView: !0
      });
    } else
      return null;
  }
}
Hr.empty = /* @__PURE__ */ new Hr(Qt, Qt);
const G8 = [
  { key: "Mod-z", run: qg, preventDefault: !0 },
  { key: "Mod-y", mac: "Mod-Shift-z", run: Ru, preventDefault: !0 },
  { linux: "Ctrl-Shift-z", run: Ru, preventDefault: !0 },
  { key: "Mod-u", run: I8, preventDefault: !0 },
  { key: "Alt-u", mac: "Mod-Shift-u", run: z8, preventDefault: !0 }
];
function is(n, e) {
  return I.create(n.ranges.map(e), n.mainIndex);
}
function Zr(n, e) {
  return n.update({ selection: e, scrollIntoView: !0, userEvent: "select" });
}
function Ar({ state: n, dispatch: e }, t) {
  let r = is(n.selection, t);
  return r.eq(n.selection, !0) ? !1 : (e(Zr(n, r)), !0);
}
function da(n, e) {
  return I.cursor(e ? n.to : n.from);
}
function Ug(n, e) {
  return Ar(n, (t) => t.empty ? n.moveByChar(t, e) : da(t, e));
}
function gt(n) {
  return n.textDirectionAt(n.state.selection.main.head) == Ie.LTR;
}
const Gg = (n) => Ug(n, !gt(n)), jg = (n) => Ug(n, gt(n));
function $g(n, e) {
  return Ar(n, (t) => t.empty ? n.moveByGroup(t, e) : da(t, e));
}
const j8 = (n) => $g(n, !gt(n)), $8 = (n) => $g(n, gt(n));
function Y8(n, e, t) {
  if (e.type.prop(t))
    return !0;
  let r = e.to - e.from;
  return r && (r > 2 || /[^\s,.;:]/.test(n.sliceDoc(e.from, e.to))) || e.firstChild;
}
function ma(n, e, t) {
  let r = nt(n).resolveInner(e.head), i = t ? we.closedBy : we.openedBy;
  for (let a = e.head; ; ) {
    let u = t ? r.childAfter(a) : r.childBefore(a);
    if (!u)
      break;
    Y8(n, u, i) ? r = u : a = t ? u.to : u.from;
  }
  let s = r.type.prop(i), l, o;
  return s && (l = t ? Bi(n, r.from, 1) : Bi(n, r.to, -1)) && l.matched ? o = t ? l.end.to : l.end.from : o = t ? r.to : r.from, I.cursor(o, t ? -1 : 1);
}
const K8 = (n) => Ar(n, (e) => ma(n.state, e, !gt(n))), X8 = (n) => Ar(n, (e) => ma(n.state, e, gt(n)));
function Yg(n, e) {
  return Ar(n, (t) => {
    if (!t.empty)
      return da(t, e);
    let r = n.moveVertically(t, e);
    return r.head != t.head ? r : n.moveToLineBoundary(t, e);
  });
}
const Kg = (n) => Yg(n, !1), Xg = (n) => Yg(n, !0);
function Zg(n) {
  let e = n.scrollDOM.clientHeight < n.scrollDOM.scrollHeight - 2, t = 0, r = 0, i;
  if (e) {
    for (let s of n.state.facet(Q.scrollMargins)) {
      let l = s(n);
      l?.top && (t = Math.max(l?.top, t)), l?.bottom && (r = Math.max(l?.bottom, r));
    }
    i = n.scrollDOM.clientHeight - t - r;
  } else
    i = (n.dom.ownerDocument.defaultView || window).innerHeight;
  return {
    marginTop: t,
    marginBottom: r,
    selfScroll: e,
    height: Math.max(n.defaultLineHeight, i - 5)
  };
}
function Jg(n, e) {
  let t = Zg(n), { state: r } = n, i = is(r.selection, (l) => l.empty ? n.moveVertically(l, e, t.height) : da(l, e));
  if (i.eq(r.selection))
    return !1;
  let s;
  if (t.selfScroll) {
    let l = n.coordsAtPos(r.selection.main.head), o = n.scrollDOM.getBoundingClientRect(), a = o.top + t.marginTop, u = o.bottom - t.marginBottom;
    l && l.top > a && l.bottom < u && (s = Q.scrollIntoView(i.main.head, { y: "start", yMargin: l.top - a }));
  }
  return n.dispatch(Zr(r, i), { effects: s }), !0;
}
const sd = (n) => Jg(n, !1), Lu = (n) => Jg(n, !0);
function Vn(n, e, t) {
  let r = n.lineBlockAt(e.head), i = n.moveToLineBoundary(e, t);
  if (i.head == e.head && i.head != (t ? r.to : r.from) && (i = n.moveToLineBoundary(e, t, !1)), !t && i.head == r.from && r.length) {
    let s = /^\s*/.exec(n.state.sliceDoc(r.from, Math.min(r.from + 100, r.to)))[0].length;
    s && e.head != r.from + s && (i = I.cursor(r.from + s));
  }
  return i;
}
const Z8 = (n) => Ar(n, (e) => Vn(n, e, !0)), J8 = (n) => Ar(n, (e) => Vn(n, e, !1)), Q8 = (n) => Ar(n, (e) => Vn(n, e, !gt(n))), eb = (n) => Ar(n, (e) => Vn(n, e, gt(n))), tb = (n) => Ar(n, (e) => I.cursor(n.lineBlockAt(e.head).from, 1)), rb = (n) => Ar(n, (e) => I.cursor(n.lineBlockAt(e.head).to, -1));
function nb(n, e, t) {
  let r = !1, i = is(n.selection, (s) => {
    let l = Bi(n, s.head, -1) || Bi(n, s.head, 1) || s.head > 0 && Bi(n, s.head - 1, 1) || s.head < n.doc.length && Bi(n, s.head + 1, -1);
    if (!l || !l.end)
      return s;
    r = !0;
    let o = l.start.from == s.head ? l.end.to : l.end.from;
    return I.cursor(o);
  });
  return r ? (e(Zr(n, i)), !0) : !1;
}
const ib = ({ state: n, dispatch: e }) => nb(n, e);
function ur(n, e) {
  let t = is(n.state.selection, (r) => {
    let i = e(r);
    return I.range(r.anchor, i.head, i.goalColumn, i.bidiLevel || void 0);
  });
  return t.eq(n.state.selection) ? !1 : (n.dispatch(Zr(n.state, t)), !0);
}
function Qg(n, e) {
  return ur(n, (t) => n.moveByChar(t, e));
}
const e4 = (n) => Qg(n, !gt(n)), t4 = (n) => Qg(n, gt(n));
function r4(n, e) {
  return ur(n, (t) => n.moveByGroup(t, e));
}
const sb = (n) => r4(n, !gt(n)), lb = (n) => r4(n, gt(n)), ob = (n) => ur(n, (e) => ma(n.state, e, !gt(n))), ab = (n) => ur(n, (e) => ma(n.state, e, gt(n)));
function n4(n, e) {
  return ur(n, (t) => n.moveVertically(t, e));
}
const i4 = (n) => n4(n, !1), s4 = (n) => n4(n, !0);
function l4(n, e) {
  return ur(n, (t) => n.moveVertically(t, e, Zg(n).height));
}
const ld = (n) => l4(n, !1), od = (n) => l4(n, !0), ub = (n) => ur(n, (e) => Vn(n, e, !0)), hb = (n) => ur(n, (e) => Vn(n, e, !1)), cb = (n) => ur(n, (e) => Vn(n, e, !gt(n))), fb = (n) => ur(n, (e) => Vn(n, e, gt(n))), db = (n) => ur(n, (e) => I.cursor(n.lineBlockAt(e.head).from)), mb = (n) => ur(n, (e) => I.cursor(n.lineBlockAt(e.head).to)), ad = ({ state: n, dispatch: e }) => (e(Zr(n, { anchor: 0 })), !0), ud = ({ state: n, dispatch: e }) => (e(Zr(n, { anchor: n.doc.length })), !0), hd = ({ state: n, dispatch: e }) => (e(Zr(n, { anchor: n.selection.main.anchor, head: 0 })), !0), cd = ({ state: n, dispatch: e }) => (e(Zr(n, { anchor: n.selection.main.anchor, head: n.doc.length })), !0), pb = ({ state: n, dispatch: e }) => (e(n.update({ selection: { anchor: 0, head: n.doc.length }, userEvent: "select" })), !0), gb = ({ state: n, dispatch: e }) => {
  let t = pa(n).map(({ from: r, to: i }) => I.range(r, Math.min(i + 1, n.doc.length)));
  return e(n.update({ selection: I.create(t), userEvent: "select" })), !0;
}, bb = ({ state: n, dispatch: e }) => {
  let t = is(n.selection, (r) => {
    let i = nt(n), s = i.resolveStack(r.from, 1);
    if (r.empty) {
      let l = i.resolveStack(r.from, -1);
      l.node.from >= s.node.from && l.node.to <= s.node.to && (s = l);
    }
    for (let l = s; l; l = l.next) {
      let { node: o } = l;
      if ((o.from < r.from && o.to >= r.to || o.to > r.to && o.from <= r.from) && l.next)
        return I.range(o.to, o.from);
    }
    return r;
  });
  return t.eq(n.selection) ? !1 : (e(Zr(n, t)), !0);
}, vb = ({ state: n, dispatch: e }) => {
  let t = n.selection, r = null;
  return t.ranges.length > 1 ? r = I.create([t.main]) : t.main.empty || (r = I.create([I.cursor(t.main.head)])), r ? (e(Zr(n, r)), !0) : !1;
};
function ml(n, e) {
  if (n.state.readOnly)
    return !1;
  let t = "delete.selection", { state: r } = n, i = r.changeByRange((s) => {
    let { from: l, to: o } = s;
    if (l == o) {
      let a = e(s);
      a < l ? (t = "delete.backward", a = Hl(n, a, !1)) : a > l && (t = "delete.forward", a = Hl(n, a, !0)), l = Math.min(l, a), o = Math.max(o, a);
    } else
      l = Hl(n, l, !1), o = Hl(n, o, !0);
    return l == o ? { range: s } : { changes: { from: l, to: o }, range: I.cursor(l, l < s.head ? -1 : 1) };
  });
  return i.changes.empty ? !1 : (n.dispatch(r.update(i, {
    scrollIntoView: !0,
    userEvent: t,
    effects: t == "delete.selection" ? Q.announce.of(r.phrase("Selection deleted")) : void 0
  })), !0);
}
function Hl(n, e, t) {
  if (n instanceof Q)
    for (let r of n.state.facet(Q.atomicRanges).map((i) => i(n)))
      r.between(e, e, (i, s) => {
        i < e && s > e && (e = t ? s : i);
      });
  return e;
}
const o4 = (n, e, t) => ml(n, (r) => {
  let i = r.from, { state: s } = n, l = s.doc.lineAt(i), o, a;
  if (t && !e && i > l.from && i < l.from + 200 && !/[^ \t]/.test(o = l.text.slice(0, i - l.from))) {
    if (o[o.length - 1] == "	")
      return i - 1;
    let u = rs(o, s.tabSize), h = u % oi(s) || oi(s);
    for (let c = 0; c < h && o[o.length - 1 - c] == " "; c++)
      i--;
    a = i;
  } else
    a = kt(l.text, i - l.from, e, e) + l.from, a == i && l.number != (e ? s.doc.lines : 1) ? a += e ? 1 : -1 : !e && /[\ufe00-\ufe0f]/.test(l.text.slice(a - l.from, i - l.from)) && (a = kt(l.text, a - l.from, !1, !1) + l.from);
  return a;
}), Nu = (n) => o4(n, !1, !0), a4 = (n) => o4(n, !0, !1), u4 = (n, e) => ml(n, (t) => {
  let r = t.head, { state: i } = n, s = i.doc.lineAt(r), l = i.charCategorizer(r);
  for (let o = null; ; ) {
    if (r == (e ? s.to : s.from)) {
      r == t.head && s.number != (e ? i.doc.lines : 1) && (r += e ? 1 : -1);
      break;
    }
    let a = kt(s.text, r - s.from, e) + s.from, u = s.text.slice(Math.min(r, a) - s.from, Math.max(r, a) - s.from), h = l(u);
    if (o != null && h != o)
      break;
    (u != " " || r != t.head) && (o = h), r = a;
  }
  return r;
}), h4 = (n) => u4(n, !1), yb = (n) => u4(n, !0), wb = (n) => ml(n, (e) => {
  let t = n.lineBlockAt(e.head).to;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), kb = (n) => ml(n, (e) => {
  let t = n.moveToLineBoundary(e, !1).head;
  return e.head > t ? t : Math.max(0, e.head - 1);
}), xb = (n) => ml(n, (e) => {
  let t = n.moveToLineBoundary(e, !0).head;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), Sb = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((r) => ({
    changes: { from: r.from, to: r.to, insert: Ae.of(["", ""]) },
    range: I.cursor(r.from)
  }));
  return e(n.update(t, { scrollIntoView: !0, userEvent: "input" })), !0;
}, Ab = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((r) => {
    if (!r.empty || r.from == 0 || r.from == n.doc.length)
      return { range: r };
    let i = r.from, s = n.doc.lineAt(i), l = i == s.from ? i - 1 : kt(s.text, i - s.from, !1) + s.from, o = i == s.to ? i + 1 : kt(s.text, i - s.from, !0) + s.from;
    return {
      changes: { from: l, to: o, insert: n.doc.slice(i, o).append(n.doc.slice(l, i)) },
      range: I.cursor(o)
    };
  });
  return t.changes.empty ? !1 : (e(n.update(t, { scrollIntoView: !0, userEvent: "move.character" })), !0);
};
function pa(n) {
  let e = [], t = -1;
  for (let r of n.selection.ranges) {
    let i = n.doc.lineAt(r.from), s = n.doc.lineAt(r.to);
    if (!r.empty && r.to == s.from && (s = n.doc.lineAt(r.to - 1)), t >= i.number) {
      let l = e[e.length - 1];
      l.to = s.to, l.ranges.push(r);
    } else
      e.push({ from: i.from, to: s.to, ranges: [r] });
    t = s.number + 1;
  }
  return e;
}
function c4(n, e, t) {
  if (n.readOnly)
    return !1;
  let r = [], i = [];
  for (let s of pa(n)) {
    if (t ? s.to == n.doc.length : s.from == 0)
      continue;
    let l = n.doc.lineAt(t ? s.to + 1 : s.from - 1), o = l.length + 1;
    if (t) {
      r.push({ from: s.to, to: l.to }, { from: s.from, insert: l.text + n.lineBreak });
      for (let a of s.ranges)
        i.push(I.range(Math.min(n.doc.length, a.anchor + o), Math.min(n.doc.length, a.head + o)));
    } else {
      r.push({ from: l.from, to: s.from }, { from: s.to, insert: n.lineBreak + l.text });
      for (let a of s.ranges)
        i.push(I.range(a.anchor - o, a.head - o));
    }
  }
  return r.length ? (e(n.update({
    changes: r,
    scrollIntoView: !0,
    selection: I.create(i, n.selection.mainIndex),
    userEvent: "move.line"
  })), !0) : !1;
}
const Db = ({ state: n, dispatch: e }) => c4(n, e, !1), Cb = ({ state: n, dispatch: e }) => c4(n, e, !0);
function f4(n, e, t) {
  if (n.readOnly)
    return !1;
  let r = [];
  for (let i of pa(n))
    t ? r.push({ from: i.from, insert: n.doc.slice(i.from, i.to) + n.lineBreak }) : r.push({ from: i.to, insert: n.lineBreak + n.doc.slice(i.from, i.to) });
  return e(n.update({ changes: r, scrollIntoView: !0, userEvent: "input.copyline" })), !0;
}
const _b = ({ state: n, dispatch: e }) => f4(n, e, !1), Mb = ({ state: n, dispatch: e }) => f4(n, e, !0), Tb = (n) => {
  if (n.state.readOnly)
    return !1;
  let { state: e } = n, t = e.changes(pa(e).map(({ from: i, to: s }) => (i > 0 ? i-- : s < e.doc.length && s++, { from: i, to: s }))), r = is(e.selection, (i) => {
    let s;
    if (n.lineWrapping) {
      let l = n.lineBlockAt(i.head), o = n.coordsAtPos(i.head, i.assoc || 1);
      o && (s = l.bottom + n.documentTop - o.bottom + n.defaultLineHeight / 2);
    }
    return n.moveVertically(i, !0, s);
  }).map(t);
  return n.dispatch({ changes: t, selection: r, scrollIntoView: !0, userEvent: "delete.line" }), !0;
};
function Eb(n, e) {
  if (/\(\)|\[\]|\{\}/.test(n.sliceDoc(e - 1, e + 1)))
    return { from: e, to: e };
  let t = nt(n).resolveInner(e), r = t.childBefore(e), i = t.childAfter(e), s;
  return r && i && r.to <= e && i.from >= e && (s = r.type.prop(we.closedBy)) && s.indexOf(i.name) > -1 && n.doc.lineAt(r.to).from == n.doc.lineAt(i.from).from && !/\S/.test(n.sliceDoc(r.to, i.from)) ? { from: r.to, to: i.from } : null;
}
const fd = /* @__PURE__ */ d4(!1), Fb = /* @__PURE__ */ d4(!0);
function d4(n) {
  return ({ state: e, dispatch: t }) => {
    if (e.readOnly)
      return !1;
    let r = e.changeByRange((i) => {
      let { from: s, to: l } = i, o = e.doc.lineAt(s), a = !n && s == l && Eb(e, s);
      n && (s = l = (l <= o.to ? o : e.doc.lineAt(l)).to);
      let u = new ha(e, { simulateBreak: s, simulateDoubleBreak: !!a }), h = wh(u, s);
      for (h == null && (h = rs(/^\s*/.exec(e.doc.lineAt(s).text)[0], e.tabSize)); l < o.to && /\s/.test(o.text[l - o.from]); )
        l++;
      a ? { from: s, to: l } = a : s > o.from && s < o.from + 100 && !/\S/.test(o.text.slice(0, s)) && (s = o.from);
      let c = ["", el(e, h)];
      return a && c.push(el(e, u.lineIndent(o.from, -1))), {
        changes: { from: s, to: l, insert: Ae.of(c) },
        range: I.cursor(s + 1 + c[1].length)
      };
    });
    return t(e.update(r, { scrollIntoView: !0, userEvent: "input" })), !0;
  };
}
function _h(n, e) {
  let t = -1;
  return n.changeByRange((r) => {
    let i = [];
    for (let l = r.from; l <= r.to; ) {
      let o = n.doc.lineAt(l);
      o.number > t && (r.empty || r.to > o.from) && (e(o, i, r), t = o.number), l = o.to + 1;
    }
    let s = n.changes(i);
    return {
      changes: i,
      range: I.range(s.mapPos(r.anchor, 1), s.mapPos(r.head, 1))
    };
  });
}
const Bb = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = /* @__PURE__ */ Object.create(null), r = new ha(n, { overrideIndentation: (s) => {
    let l = t[s];
    return l ?? -1;
  } }), i = _h(n, (s, l, o) => {
    let a = wh(r, s.from);
    if (a == null)
      return;
    /\S/.test(s.text) || (a = 0);
    let u = /^\s*/.exec(s.text)[0], h = el(n, a);
    (u != h || o.from < s.from + u.length) && (t[s.from] = a, l.push({ from: s.from, to: s.from + u.length, insert: h }));
  });
  return i.changes.empty || e(n.update(i, { userEvent: "indent" })), !0;
}, m4 = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(_h(n, (t, r) => {
  r.push({ from: t.from, insert: n.facet(ua) });
}), { userEvent: "input.indent" })), !0), p4 = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(_h(n, (t, r) => {
  let i = /^\s*/.exec(t.text)[0];
  if (!i)
    return;
  let s = rs(i, n.tabSize), l = 0, o = el(n, Math.max(0, s - oi(n)));
  for (; l < i.length && l < o.length && i.charCodeAt(l) == o.charCodeAt(l); )
    l++;
  r.push({ from: t.from + l, to: t.from + i.length, insert: o.slice(l) });
}), { userEvent: "delete.dedent" })), !0), Ob = (n) => (n.setTabFocusMode(), !0), Rb = [
  { key: "Ctrl-b", run: Gg, shift: e4, preventDefault: !0 },
  { key: "Ctrl-f", run: jg, shift: t4 },
  { key: "Ctrl-p", run: Kg, shift: i4 },
  { key: "Ctrl-n", run: Xg, shift: s4 },
  { key: "Ctrl-a", run: tb, shift: db },
  { key: "Ctrl-e", run: rb, shift: mb },
  { key: "Ctrl-d", run: a4 },
  { key: "Ctrl-h", run: Nu },
  { key: "Ctrl-k", run: wb },
  { key: "Ctrl-Alt-h", run: h4 },
  { key: "Ctrl-o", run: Sb },
  { key: "Ctrl-t", run: Ab },
  { key: "Ctrl-v", run: Lu }
], Lb = /* @__PURE__ */ [
  { key: "ArrowLeft", run: Gg, shift: e4, preventDefault: !0 },
  { key: "Mod-ArrowLeft", mac: "Alt-ArrowLeft", run: j8, shift: sb, preventDefault: !0 },
  { mac: "Cmd-ArrowLeft", run: Q8, shift: cb, preventDefault: !0 },
  { key: "ArrowRight", run: jg, shift: t4, preventDefault: !0 },
  { key: "Mod-ArrowRight", mac: "Alt-ArrowRight", run: $8, shift: lb, preventDefault: !0 },
  { mac: "Cmd-ArrowRight", run: eb, shift: fb, preventDefault: !0 },
  { key: "ArrowUp", run: Kg, shift: i4, preventDefault: !0 },
  { mac: "Cmd-ArrowUp", run: ad, shift: hd },
  { mac: "Ctrl-ArrowUp", run: sd, shift: ld },
  { key: "ArrowDown", run: Xg, shift: s4, preventDefault: !0 },
  { mac: "Cmd-ArrowDown", run: ud, shift: cd },
  { mac: "Ctrl-ArrowDown", run: Lu, shift: od },
  { key: "PageUp", run: sd, shift: ld },
  { key: "PageDown", run: Lu, shift: od },
  { key: "Home", run: J8, shift: hb, preventDefault: !0 },
  { key: "Mod-Home", run: ad, shift: hd },
  { key: "End", run: Z8, shift: ub, preventDefault: !0 },
  { key: "Mod-End", run: ud, shift: cd },
  { key: "Enter", run: fd, shift: fd },
  { key: "Mod-a", run: pb },
  { key: "Backspace", run: Nu, shift: Nu },
  { key: "Delete", run: a4 },
  { key: "Mod-Backspace", mac: "Alt-Backspace", run: h4 },
  { key: "Mod-Delete", mac: "Alt-Delete", run: yb },
  { mac: "Mod-Backspace", run: kb },
  { mac: "Mod-Delete", run: xb }
].concat(/* @__PURE__ */ Rb.map((n) => ({ mac: n.key, run: n.run, shift: n.shift }))), Nb = /* @__PURE__ */ [
  { key: "Alt-ArrowLeft", mac: "Ctrl-ArrowLeft", run: K8, shift: ob },
  { key: "Alt-ArrowRight", mac: "Ctrl-ArrowRight", run: X8, shift: ab },
  { key: "Alt-ArrowUp", run: Db },
  { key: "Shift-Alt-ArrowUp", run: _b },
  { key: "Alt-ArrowDown", run: Cb },
  { key: "Shift-Alt-ArrowDown", run: Mb },
  { key: "Escape", run: vb },
  { key: "Mod-Enter", run: Fb },
  { key: "Alt-l", mac: "Ctrl-l", run: gb },
  { key: "Mod-i", run: bb, preventDefault: !0 },
  { key: "Mod-[", run: p4 },
  { key: "Mod-]", run: m4 },
  { key: "Mod-Alt-\\", run: Bb },
  { key: "Shift-Mod-k", run: Tb },
  { key: "Shift-Mod-\\", run: ib },
  { key: "Mod-/", run: _8 },
  { key: "Alt-A", run: T8 },
  { key: "Ctrl-m", mac: "Shift-Alt-m", run: Ob }
].concat(Lb), Ib = { key: "Tab", run: m4, shift: p4 }, zb = "#2E3235", Rr = "#DDDDDD", Ps = "#B9D2FF", ql = "#b0b0b0", Pb = "#e0e0e0", g4 = "#808080", Za = "#000000", Hb = "#A54543", b4 = "#fc6d24", Gn = "#fda331", Ja = "#8abeb7", dd = "#b5bd68", vs = "#6fb3d2", ys = "#cc99cc", qb = "#6987AF", md = b4, pd = "#292d30", Vl = Ps + "30", Vb = zb, Qa = Rr, Wb = "#202325", gd = Rr, Ub = /* @__PURE__ */ Q.theme({
  "&": {
    color: Rr,
    backgroundColor: Vb
  },
  ".cm-content": {
    caretColor: gd
  },
  ".cm-cursor, .cm-dropCursor": { borderLeftColor: gd },
  "&.cm-focused .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: Wb },
  ".cm-panels": { backgroundColor: pd, color: ql },
  ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
  ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
  ".cm-searchMatch": {
    backgroundColor: Ps,
    outline: `1px solid ${ql}`,
    color: Za
  },
  ".cm-searchMatch.cm-searchMatch-selected": {
    backgroundColor: Pb,
    color: Za
  },
  ".cm-activeLine": { backgroundColor: Vl },
  ".cm-selectionMatch": { backgroundColor: Vl },
  "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
    outline: `1px solid ${ql}`
  },
  "&.cm-focused .cm-matchingBracket": {
    backgroundColor: Ps,
    color: Za
  },
  ".cm-gutters": {
    borderRight: "1px solid #ffffff10",
    color: g4,
    backgroundColor: pd
  },
  ".cm-activeLineGutter": {
    backgroundColor: Vl
  },
  ".cm-foldPlaceholder": {
    backgroundColor: "transparent",
    border: "none",
    color: Ps
  },
  ".cm-tooltip": {
    border: "none",
    backgroundColor: Qa
  },
  ".cm-tooltip .cm-tooltip-arrow:before": {
    borderTopColor: "transparent",
    borderBottomColor: "transparent"
  },
  ".cm-tooltip .cm-tooltip-arrow:after": {
    borderTopColor: Qa,
    borderBottomColor: Qa
  },
  ".cm-tooltip-autocomplete": {
    "& > ul > li[aria-selected]": {
      backgroundColor: Vl,
      color: ql
    }
  }
}, { dark: !0 }), Gb = /* @__PURE__ */ ns.define([
  { tag: E.keyword, color: Gn },
  {
    tag: [E.name, E.deleted, E.character, E.propertyName, E.macroName],
    color: dd
  },
  { tag: [E.variableName], color: vs },
  { tag: [/* @__PURE__ */ E.function(E.variableName)], color: Gn },
  { tag: [E.labelName], color: b4 },
  {
    tag: [E.color, /* @__PURE__ */ E.constant(E.name), /* @__PURE__ */ E.standard(E.name)],
    color: Gn
  },
  { tag: [/* @__PURE__ */ E.definition(E.name), E.separator], color: ys },
  { tag: [E.brace], color: ys },
  {
    tag: [E.annotation],
    color: md
  },
  {
    tag: [E.number, E.changed, E.annotation, E.modifier, E.self, E.namespace],
    color: Gn
  },
  {
    tag: [E.typeName, E.className],
    color: vs
  },
  {
    tag: [E.operator, E.operatorKeyword],
    color: ys
  },
  {
    tag: [E.tagName],
    color: Gn
  },
  {
    tag: [E.squareBracket],
    color: ys
  },
  {
    tag: [E.angleBracket],
    color: ys
  },
  {
    tag: [E.attributeName],
    color: vs
  },
  {
    tag: [E.regexp],
    color: Gn
  },
  {
    tag: [E.quote],
    color: Rr
  },
  { tag: [E.string], color: dd },
  {
    tag: E.link,
    color: qb,
    textDecoration: "underline",
    textUnderlinePosition: "under"
  },
  {
    tag: [E.url, E.escape, /* @__PURE__ */ E.special(E.string)],
    color: Ja
  },
  { tag: [E.meta], color: Hb },
  { tag: [E.comment], color: g4, fontStyle: "italic" },
  { tag: E.monospace, color: Rr },
  { tag: E.strong, fontWeight: "bold", color: Gn },
  { tag: E.emphasis, fontStyle: "italic", color: vs },
  { tag: E.strikethrough, textDecoration: "line-through" },
  { tag: E.heading, fontWeight: "bold", color: Rr },
  { tag: /* @__PURE__ */ E.special(E.heading1), fontWeight: "bold", color: Rr },
  { tag: E.heading1, fontWeight: "bold", color: Rr },
  {
    tag: [E.heading2, E.heading3, E.heading4],
    fontWeight: "bold",
    color: Rr
  },
  {
    tag: [E.heading5, E.heading6],
    color: Rr
  },
  { tag: [E.atom, E.bool, /* @__PURE__ */ E.special(E.variableName)], color: Ja },
  {
    tag: [E.processingInstruction, E.inserted],
    color: Ja
  },
  {
    tag: [E.contentSeparator],
    color: vs
  },
  { tag: E.invalid, color: Ps, borderBottom: `1px dotted ${md}` }
]), jb = [
  Ub,
  /* @__PURE__ */ xh(Gb)
], bd = "#2e3440", Mh = "#3b4252", vd = "#434c5e", Wl = "#4c566a", yd = "#e5e9f0", Iu = "#eceff4", e0 = "#8fbcbb", wd = "#88c0d0", $b = "#81a1c1", cr = "#5e81ac", Yb = "#bf616a", Di = "#d08770", t0 = "#ebcb8b", kd = "#a3be8c", Kb = "#b48ead", xd = "#d30102", Th = Iu, r0 = Th, Xb = "#ffffff", n0 = Mh, Zb = Th, Sd = Mh, Jb = /* @__PURE__ */ Q.theme({
  "&": {
    color: bd,
    backgroundColor: Xb
  },
  ".cm-content": {
    caretColor: Sd
  },
  ".cm-cursor, .cm-dropCursor": { borderLeftColor: Sd },
  "&.cm-focused .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: Zb },
  ".cm-panels": { backgroundColor: Th, color: Wl },
  ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
  ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
  ".cm-searchMatch": {
    backgroundColor: "#72a1ff59",
    outline: `1px solid ${Wl}`
  },
  ".cm-searchMatch.cm-searchMatch-selected": {
    backgroundColor: yd
  },
  ".cm-activeLine": { backgroundColor: r0 },
  ".cm-selectionMatch": { backgroundColor: yd },
  "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
    outline: `1px solid ${Wl}`
  },
  "&.cm-focused .cm-matchingBracket": {
    backgroundColor: Iu
  },
  ".cm-gutters": {
    backgroundColor: Iu,
    color: bd,
    border: "none"
  },
  ".cm-activeLineGutter": {
    backgroundColor: r0
  },
  ".cm-foldPlaceholder": {
    backgroundColor: "transparent",
    border: "none",
    color: "#ddd"
  },
  ".cm-tooltip": {
    border: "none",
    backgroundColor: n0
  },
  ".cm-tooltip .cm-tooltip-arrow:before": {
    borderTopColor: "transparent",
    borderBottomColor: "transparent"
  },
  ".cm-tooltip .cm-tooltip-arrow:after": {
    borderTopColor: n0,
    borderBottomColor: n0
  },
  ".cm-tooltip-autocomplete": {
    "& > ul > li[aria-selected]": {
      backgroundColor: r0,
      color: Wl
    }
  }
}, { dark: !1 }), Qb = /* @__PURE__ */ ns.define([
  { tag: E.keyword, color: cr },
  {
    tag: [E.name, E.deleted, E.character, E.propertyName, E.macroName],
    color: Di
  },
  { tag: [E.variableName], color: Di },
  { tag: [/* @__PURE__ */ E.function(E.variableName)], color: cr },
  { tag: [E.labelName], color: $b },
  {
    tag: [E.color, /* @__PURE__ */ E.constant(E.name), /* @__PURE__ */ E.standard(E.name)],
    color: cr
  },
  { tag: [/* @__PURE__ */ E.definition(E.name), E.separator], color: kd },
  { tag: [E.brace], color: e0 },
  {
    tag: [E.annotation],
    color: xd
  },
  {
    tag: [E.number, E.changed, E.annotation, E.modifier, E.self, E.namespace],
    color: wd
  },
  {
    tag: [E.typeName, E.className],
    color: t0
  },
  {
    tag: [E.operator, E.operatorKeyword],
    color: kd
  },
  {
    tag: [E.tagName],
    color: Kb
  },
  {
    tag: [E.squareBracket],
    color: Yb
  },
  {
    tag: [E.angleBracket],
    color: Di
  },
  {
    tag: [E.attributeName],
    color: t0
  },
  {
    tag: [E.regexp],
    color: cr
  },
  {
    tag: [E.quote],
    color: Mh
  },
  { tag: [E.string], color: Di },
  {
    tag: E.link,
    color: e0,
    textDecoration: "underline",
    textUnderlinePosition: "under"
  },
  {
    tag: [E.url, E.escape, /* @__PURE__ */ E.special(E.string)],
    color: Di
  },
  { tag: [E.meta], color: wd },
  { tag: [E.comment], color: vd, fontStyle: "italic" },
  { tag: E.strong, fontWeight: "bold", color: cr },
  { tag: E.emphasis, fontStyle: "italic", color: cr },
  { tag: E.strikethrough, textDecoration: "line-through" },
  { tag: E.heading, fontWeight: "bold", color: cr },
  { tag: /* @__PURE__ */ E.special(E.heading1), fontWeight: "bold", color: cr },
  { tag: E.heading1, fontWeight: "bold", color: cr },
  {
    tag: [E.heading2, E.heading3, E.heading4],
    fontWeight: "bold",
    color: cr
  },
  {
    tag: [E.heading5, E.heading6],
    color: cr
  },
  { tag: [E.atom, E.bool, /* @__PURE__ */ E.special(E.variableName)], color: Di },
  {
    tag: [E.processingInstruction, E.inserted],
    color: e0
  },
  {
    tag: [E.contentSeparator],
    color: t0
  },
  { tag: E.invalid, color: vd, borderBottom: `1px dotted ${xd}` }
]), e9 = [
  Jb,
  /* @__PURE__ */ xh(Qb)
];
class t9 {
  /**
  Create a new completion context. (Mostly useful for testing
  completion sources—in the editor, the extension will create
  these for you.)
  */
  constructor(e, t, r, i) {
    this.state = e, this.pos = t, this.explicit = r, this.view = i, this.abortListeners = [], this.abortOnDocChange = !1;
  }
  /**
  Get the extent, content, and (if there is a token) type of the
  token before `this.pos`.
  */
  tokenBefore(e) {
    let t = nt(this.state).resolveInner(this.pos, -1);
    for (; t && e.indexOf(t.name) < 0; )
      t = t.parent;
    return t ? {
      from: t.from,
      to: this.pos,
      text: this.state.sliceDoc(t.from, this.pos),
      type: t.type
    } : null;
  }
  /**
  Get the match of the given expression directly before the
  cursor.
  */
  matchBefore(e) {
    let t = this.state.doc.lineAt(this.pos), r = Math.max(t.from, this.pos - 250), i = t.text.slice(r - t.from, this.pos - t.from), s = i.search(v4(e, !1));
    return s < 0 ? null : { from: r + s, to: this.pos, text: i.slice(s) };
  }
  /**
  Yields true when the query has been aborted. Can be useful in
  asynchronous queries to avoid doing work that will be ignored.
  */
  get aborted() {
    return this.abortListeners == null;
  }
  /**
  Allows you to register abort handlers, which will be called when
  the query is
  [aborted](https://codemirror.net/6/docs/ref/#autocomplete.CompletionContext.aborted).
  
  By default, running queries will not be aborted for regular
  typing or backspacing, on the assumption that they are likely to
  return a result with a
  [`validFor`](https://codemirror.net/6/docs/ref/#autocomplete.CompletionResult.validFor) field that
  allows the result to be used after all. Passing `onDocChange:
  true` will cause this query to be aborted for any document
  change.
  */
  addEventListener(e, t, r) {
    e == "abort" && this.abortListeners && (this.abortListeners.push(t), r && r.onDocChange && (this.abortOnDocChange = !0));
  }
}
function Ad(n) {
  let e = Object.keys(n).join(""), t = /\w/.test(e);
  return t && (e = e.replace(/\w/g, "")), `[${t ? "\\w" : ""}${e.replace(/[^\w\s]/g, "\\$&")}]`;
}
function r9(n) {
  let e = /* @__PURE__ */ Object.create(null), t = /* @__PURE__ */ Object.create(null);
  for (let { label: i } of n) {
    e[i[0]] = !0;
    for (let s = 1; s < i.length; s++)
      t[i[s]] = !0;
  }
  let r = Ad(e) + Ad(t) + "*$";
  return [new RegExp("^" + r), new RegExp(r)];
}
function n9(n) {
  let e = n.map((i) => typeof i == "string" ? { label: i } : i), [t, r] = e.every((i) => /^\w+$/.test(i.label)) ? [/\w*$/, /\w+$/] : r9(e);
  return (i) => {
    let s = i.matchBefore(r);
    return s || i.explicit ? { from: s ? s.from : i.pos, options: e, validFor: t } : null;
  };
}
function zD(n, e) {
  return (t) => {
    for (let r = nt(t.state).resolveInner(t.pos, -1); r; r = r.parent) {
      if (n.indexOf(r.name) > -1)
        return null;
      if (r.type.isTop)
        break;
    }
    return e(t);
  };
}
class Dd {
  constructor(e, t, r, i) {
    this.completion = e, this.source = t, this.match = r, this.score = i;
  }
}
function qi(n) {
  return n.selection.main.from;
}
function v4(n, e) {
  var t;
  let { source: r } = n, i = e && r[0] != "^", s = r[r.length - 1] != "$";
  return !i && !s ? n : new RegExp(`${i ? "^" : ""}(?:${r})${s ? "$" : ""}`, (t = n.flags) !== null && t !== void 0 ? t : n.ignoreCase ? "i" : "");
}
const Eh = /* @__PURE__ */ vn.define();
function i9(n, e, t, r) {
  let { main: i } = n.selection, s = t - i.from, l = r - i.from;
  return Object.assign(Object.assign({}, n.changeByRange((o) => {
    if (o != i && t != r && n.sliceDoc(o.from + s, o.from + l) != n.sliceDoc(t, r))
      return { range: o };
    let a = n.toText(e);
    return {
      changes: { from: o.from + s, to: r == i.from ? o.to : o.from + l, insert: a },
      range: I.cursor(o.from + s + a.length)
    };
  })), { scrollIntoView: !0, userEvent: "input.complete" });
}
const Cd = /* @__PURE__ */ new WeakMap();
function s9(n) {
  if (!Array.isArray(n))
    return n;
  let e = Cd.get(n);
  return e || Cd.set(n, e = n9(n)), e;
}
const y4 = /* @__PURE__ */ ye.define(), Fh = /* @__PURE__ */ ye.define();
class l9 {
  constructor(e) {
    this.pattern = e, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [], this.score = 0, this.matched = [];
    for (let t = 0; t < e.length; ) {
      let r = ft(e, t), i = vr(r);
      this.chars.push(r);
      let s = e.slice(t, t + i), l = s.toUpperCase();
      this.folded.push(ft(l == s ? s.toLowerCase() : l, 0)), t += i;
    }
    this.astral = e.length != this.chars.length;
  }
  ret(e, t) {
    return this.score = e, this.matched = t, this;
  }
  // Matches a given word (completion) against the pattern (input).
  // Will return a boolean indicating whether there was a match and,
  // on success, set `this.score` to the score, `this.matched` to an
  // array of `from, to` pairs indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  match(e) {
    if (this.pattern.length == 0)
      return this.ret(-100, []);
    if (e.length < this.pattern.length)
      return null;
    let { chars: t, folded: r, any: i, precise: s, byWord: l } = this;
    if (t.length == 1) {
      let x = ft(e, 0), y = vr(x), A = y == e.length ? 0 : -100;
      if (x != t[0]) if (x == r[0])
        A += -200;
      else
        return null;
      return this.ret(A, [0, y]);
    }
    let o = e.indexOf(this.pattern);
    if (o == 0)
      return this.ret(e.length == this.pattern.length ? 0 : -100, [0, this.pattern.length]);
    let a = t.length, u = 0;
    if (o < 0) {
      for (let x = 0, y = Math.min(e.length, 200); x < y && u < a; ) {
        let A = ft(e, x);
        (A == t[u] || A == r[u]) && (i[u++] = x), x += vr(A);
      }
      if (u < a)
        return null;
    }
    let h = 0, c = 0, f = !1, m = 0, g = -1, v = -1, k = /[a-z]/.test(e), S = !0;
    for (let x = 0, y = Math.min(e.length, 200), A = 0; x < y && c < a; ) {
      let C = ft(e, x);
      o < 0 && (h < a && C == t[h] && (s[h++] = x), m < a && (C == t[m] || C == r[m] ? (m == 0 && (g = x), v = x + 1, m++) : m = 0));
      let T, M = C < 255 ? C >= 48 && C <= 57 || C >= 97 && C <= 122 ? 2 : C >= 65 && C <= 90 ? 1 : 0 : (T = Ym(C)) != T.toLowerCase() ? 1 : T != T.toUpperCase() ? 2 : 0;
      (!x || M == 1 && k || A == 0 && M != 0) && (t[c] == C || r[c] == C && (f = !0) ? l[c++] = x : l.length && (S = !1)), A = M, x += vr(C);
    }
    return c == a && l[0] == 0 && S ? this.result(-100 + (f ? -200 : 0), l, e) : m == a && g == 0 ? this.ret(-200 - e.length + (v == e.length ? 0 : -100), [0, v]) : o > -1 ? this.ret(-700 - e.length, [o, o + this.pattern.length]) : m == a ? this.ret(-900 - e.length, [g, v]) : c == a ? this.result(-100 + (f ? -200 : 0) + -700 + (S ? 0 : -1100), l, e) : t.length == 2 ? null : this.result((i[0] ? -700 : 0) + -200 + -1100, i, e);
  }
  result(e, t, r) {
    let i = [], s = 0;
    for (let l of t) {
      let o = l + (this.astral ? vr(ft(r, l)) : 1);
      s && i[s - 1] == l ? i[s - 1] = o : (i[s++] = l, i[s++] = o);
    }
    return this.ret(e - r.length, i);
  }
}
class o9 {
  constructor(e) {
    this.pattern = e, this.matched = [], this.score = 0, this.folded = e.toLowerCase();
  }
  match(e) {
    if (e.length < this.pattern.length)
      return null;
    let t = e.slice(0, this.pattern.length), r = t == this.pattern ? 0 : t.toLowerCase() == this.folded ? -200 : null;
    return r == null ? null : (this.matched = [0, t.length], this.score = r + (e.length == this.pattern.length ? 0 : -100), this);
  }
}
const Ir = /* @__PURE__ */ X.define({
  combine(n) {
    return bi(n, {
      activateOnTyping: !0,
      activateOnCompletion: () => !1,
      activateOnTypingDelay: 100,
      selectOnOpen: !0,
      override: null,
      closeOnBlur: !0,
      maxRenderedOptions: 100,
      defaultKeymap: !0,
      tooltipClass: () => "",
      optionClass: () => "",
      aboveCursor: !1,
      icons: !0,
      addToOptions: [],
      positionInfo: a9,
      filterStrict: !1,
      compareCompletions: (e, t) => e.label.localeCompare(t.label),
      interactionDelay: 75,
      updateSyncTime: 100
    }, {
      defaultKeymap: (e, t) => e && t,
      closeOnBlur: (e, t) => e && t,
      icons: (e, t) => e && t,
      tooltipClass: (e, t) => (r) => _d(e(r), t(r)),
      optionClass: (e, t) => (r) => _d(e(r), t(r)),
      addToOptions: (e, t) => e.concat(t),
      filterStrict: (e, t) => e || t
    });
  }
});
function _d(n, e) {
  return n ? e ? n + " " + e : n : e;
}
function a9(n, e, t, r, i, s) {
  let l = n.textDirection == Ie.RTL, o = l, a = !1, u = "top", h, c, f = e.left - i.left, m = i.right - e.right, g = r.right - r.left, v = r.bottom - r.top;
  if (o && f < Math.min(g, m) ? o = !1 : !o && m < Math.min(g, f) && (o = !0), g <= (o ? f : m))
    h = Math.max(i.top, Math.min(t.top, i.bottom - v)) - e.top, c = Math.min(400, o ? f : m);
  else {
    a = !0, c = Math.min(
      400,
      (l ? e.right : i.right - e.left) - 30
      /* Info.Margin */
    );
    let x = i.bottom - e.bottom;
    x >= v || x > e.top ? h = t.bottom - e.top : (u = "bottom", h = e.bottom - t.top);
  }
  let k = (e.bottom - e.top) / s.offsetHeight, S = (e.right - e.left) / s.offsetWidth;
  return {
    style: `${u}: ${h / k}px; max-width: ${c / S}px`,
    class: "cm-completionInfo-" + (a ? l ? "left-narrow" : "right-narrow" : o ? "left" : "right")
  };
}
function u9(n) {
  let e = n.addToOptions.slice();
  return n.icons && e.push({
    render(t) {
      let r = document.createElement("div");
      return r.classList.add("cm-completionIcon"), t.type && r.classList.add(...t.type.split(/\s+/g).map((i) => "cm-completionIcon-" + i)), r.setAttribute("aria-hidden", "true"), r;
    },
    position: 20
  }), e.push({
    render(t, r, i, s) {
      let l = document.createElement("span");
      l.className = "cm-completionLabel";
      let o = t.displayLabel || t.label, a = 0;
      for (let u = 0; u < s.length; ) {
        let h = s[u++], c = s[u++];
        h > a && l.appendChild(document.createTextNode(o.slice(a, h)));
        let f = l.appendChild(document.createElement("span"));
        f.appendChild(document.createTextNode(o.slice(h, c))), f.className = "cm-completionMatchedText", a = c;
      }
      return a < o.length && l.appendChild(document.createTextNode(o.slice(a))), l;
    },
    position: 50
  }, {
    render(t) {
      if (!t.detail)
        return null;
      let r = document.createElement("span");
      return r.className = "cm-completionDetail", r.textContent = t.detail, r;
    },
    position: 80
  }), e.sort((t, r) => t.position - r.position).map((t) => t.render);
}
function i0(n, e, t) {
  if (n <= t)
    return { from: 0, to: n };
  if (e < 0 && (e = 0), e <= n >> 1) {
    let i = Math.floor(e / t);
    return { from: i * t, to: (i + 1) * t };
  }
  let r = Math.floor((n - e) / t);
  return { from: n - (r + 1) * t, to: n - r * t };
}
class h9 {
  constructor(e, t, r) {
    this.view = e, this.stateField = t, this.applyCompletion = r, this.info = null, this.infoDestroy = null, this.placeInfoReq = {
      read: () => this.measureInfo(),
      write: (a) => this.placeInfo(a),
      key: this
    }, this.space = null, this.currentClass = "";
    let i = e.state.field(t), { options: s, selected: l } = i.open, o = e.state.facet(Ir);
    this.optionContent = u9(o), this.optionClass = o.optionClass, this.tooltipClass = o.tooltipClass, this.range = i0(s.length, l, o.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.updateTooltipClass(e.state), this.dom.addEventListener("mousedown", (a) => {
      let { options: u } = e.state.field(t).open;
      for (let h = a.target, c; h && h != this.dom; h = h.parentNode)
        if (h.nodeName == "LI" && (c = /-(\d+)$/.exec(h.id)) && +c[1] < u.length) {
          this.applyCompletion(e, u[+c[1]]), a.preventDefault();
          return;
        }
    }), this.dom.addEventListener("focusout", (a) => {
      let u = e.state.field(this.stateField, !1);
      u && u.tooltip && e.state.facet(Ir).closeOnBlur && a.relatedTarget != e.contentDOM && e.dispatch({ effects: Fh.of(null) });
    }), this.showOptions(s, i.id);
  }
  mount() {
    this.updateSel();
  }
  showOptions(e, t) {
    this.list && this.list.remove(), this.list = this.dom.appendChild(this.createListBox(e, t, this.range)), this.list.addEventListener("scroll", () => {
      this.info && this.view.requestMeasure(this.placeInfoReq);
    });
  }
  update(e) {
    var t;
    let r = e.state.field(this.stateField), i = e.startState.field(this.stateField);
    if (this.updateTooltipClass(e.state), r != i) {
      let { options: s, selected: l, disabled: o } = r.open;
      (!i.open || i.open.options != s) && (this.range = i0(s.length, l, e.state.facet(Ir).maxRenderedOptions), this.showOptions(s, r.id)), this.updateSel(), o != ((t = i.open) === null || t === void 0 ? void 0 : t.disabled) && this.dom.classList.toggle("cm-tooltip-autocomplete-disabled", !!o);
    }
  }
  updateTooltipClass(e) {
    let t = this.tooltipClass(e);
    if (t != this.currentClass) {
      for (let r of this.currentClass.split(" "))
        r && this.dom.classList.remove(r);
      for (let r of t.split(" "))
        r && this.dom.classList.add(r);
      this.currentClass = t;
    }
  }
  positioned(e) {
    this.space = e, this.info && this.view.requestMeasure(this.placeInfoReq);
  }
  updateSel() {
    let e = this.view.state.field(this.stateField), t = e.open;
    if ((t.selected > -1 && t.selected < this.range.from || t.selected >= this.range.to) && (this.range = i0(t.options.length, t.selected, this.view.state.facet(Ir).maxRenderedOptions), this.showOptions(t.options, e.id)), this.updateSelectedOption(t.selected)) {
      this.destroyInfo();
      let { completion: r } = t.options[t.selected], { info: i } = r;
      if (!i)
        return;
      let s = typeof i == "string" ? document.createTextNode(i) : i(r);
      if (!s)
        return;
      "then" in s ? s.then((l) => {
        l && this.view.state.field(this.stateField, !1) == e && this.addInfoPane(l, r);
      }).catch((l) => Xt(this.view.state, l, "completion info")) : this.addInfoPane(s, r);
    }
  }
  addInfoPane(e, t) {
    this.destroyInfo();
    let r = this.info = document.createElement("div");
    if (r.className = "cm-tooltip cm-completionInfo", e.nodeType != null)
      r.appendChild(e), this.infoDestroy = null;
    else {
      let { dom: i, destroy: s } = e;
      r.appendChild(i), this.infoDestroy = s || null;
    }
    this.dom.appendChild(r), this.view.requestMeasure(this.placeInfoReq);
  }
  updateSelectedOption(e) {
    let t = null;
    for (let r = this.list.firstChild, i = this.range.from; r; r = r.nextSibling, i++)
      r.nodeName != "LI" || !r.id ? i-- : i == e ? r.hasAttribute("aria-selected") || (r.setAttribute("aria-selected", "true"), t = r) : r.hasAttribute("aria-selected") && r.removeAttribute("aria-selected");
    return t && f9(this.list, t), t;
  }
  measureInfo() {
    let e = this.dom.querySelector("[aria-selected]");
    if (!e || !this.info)
      return null;
    let t = this.dom.getBoundingClientRect(), r = this.info.getBoundingClientRect(), i = e.getBoundingClientRect(), s = this.space;
    if (!s) {
      let l = this.dom.ownerDocument.defaultView || window;
      s = { left: 0, top: 0, right: l.innerWidth, bottom: l.innerHeight };
    }
    return i.top > Math.min(s.bottom, t.bottom) - 10 || i.bottom < Math.max(s.top, t.top) + 10 ? null : this.view.state.facet(Ir).positionInfo(this.view, t, i, r, s, this.dom);
  }
  placeInfo(e) {
    this.info && (e ? (e.style && (this.info.style.cssText = e.style), this.info.className = "cm-tooltip cm-completionInfo " + (e.class || "")) : this.info.style.cssText = "top: -1e6px");
  }
  createListBox(e, t, r) {
    const i = document.createElement("ul");
    i.id = t, i.setAttribute("role", "listbox"), i.setAttribute("aria-expanded", "true"), i.setAttribute("aria-label", this.view.state.phrase("Completions"));
    let s = null;
    for (let l = r.from; l < r.to; l++) {
      let { completion: o, match: a } = e[l], { section: u } = o;
      if (u) {
        let f = typeof u == "string" ? u : u.name;
        if (f != s && (l > r.from || r.from == 0))
          if (s = f, typeof u != "string" && u.header)
            i.appendChild(u.header(u));
          else {
            let m = i.appendChild(document.createElement("completion-section"));
            m.textContent = f;
          }
      }
      const h = i.appendChild(document.createElement("li"));
      h.id = t + "-" + l, h.setAttribute("role", "option");
      let c = this.optionClass(o);
      c && (h.className = c);
      for (let f of this.optionContent) {
        let m = f(o, this.view.state, this.view, a);
        m && h.appendChild(m);
      }
    }
    return r.from && i.classList.add("cm-completionListIncompleteTop"), r.to < e.length && i.classList.add("cm-completionListIncompleteBottom"), i;
  }
  destroyInfo() {
    this.info && (this.infoDestroy && this.infoDestroy(), this.info.remove(), this.info = null);
  }
  destroy() {
    this.destroyInfo();
  }
}
function c9(n, e) {
  return (t) => new h9(t, n, e);
}
function f9(n, e) {
  let t = n.getBoundingClientRect(), r = e.getBoundingClientRect(), i = t.height / n.offsetHeight;
  r.top < t.top ? n.scrollTop -= (t.top - r.top) / i : r.bottom > t.bottom && (n.scrollTop += (r.bottom - t.bottom) / i);
}
function Md(n) {
  return (n.boost || 0) * 100 + (n.apply ? 10 : 0) + (n.info ? 5 : 0) + (n.type ? 1 : 0);
}
function d9(n, e) {
  let t = [], r = null, i = (u) => {
    t.push(u);
    let { section: h } = u.completion;
    if (h) {
      r || (r = []);
      let c = typeof h == "string" ? h : h.name;
      r.some((f) => f.name == c) || r.push(typeof h == "string" ? { name: c } : h);
    }
  }, s = e.facet(Ir);
  for (let u of n)
    if (u.hasResult()) {
      let h = u.result.getMatch;
      if (u.result.filter === !1)
        for (let c of u.result.options)
          i(new Dd(c, u.source, h ? h(c) : [], 1e9 - t.length));
      else {
        let c = e.sliceDoc(u.from, u.to), f, m = s.filterStrict ? new o9(c) : new l9(c);
        for (let g of u.result.options)
          if (f = m.match(g.label)) {
            let v = g.displayLabel ? h ? h(g, f.matched) : [] : f.matched;
            i(new Dd(g, u.source, v, f.score + (g.boost || 0)));
          }
      }
    }
  if (r) {
    let u = /* @__PURE__ */ Object.create(null), h = 0, c = (f, m) => {
      var g, v;
      return ((g = f.rank) !== null && g !== void 0 ? g : 1e9) - ((v = m.rank) !== null && v !== void 0 ? v : 1e9) || (f.name < m.name ? -1 : 1);
    };
    for (let f of r.sort(c))
      h -= 1e5, u[f.name] = h;
    for (let f of t) {
      let { section: m } = f.completion;
      m && (f.score += u[typeof m == "string" ? m : m.name]);
    }
  }
  let l = [], o = null, a = s.compareCompletions;
  for (let u of t.sort((h, c) => c.score - h.score || a(h.completion, c.completion))) {
    let h = u.completion;
    !o || o.label != h.label || o.detail != h.detail || o.type != null && h.type != null && o.type != h.type || o.apply != h.apply || o.boost != h.boost ? l.push(u) : Md(u.completion) > Md(o) && (l[l.length - 1] = u), o = u.completion;
  }
  return l;
}
class Ri {
  constructor(e, t, r, i, s, l) {
    this.options = e, this.attrs = t, this.tooltip = r, this.timestamp = i, this.selected = s, this.disabled = l;
  }
  setSelected(e, t) {
    return e == this.selected || e >= this.options.length ? this : new Ri(this.options, Td(t, e), this.tooltip, this.timestamp, e, this.disabled);
  }
  static build(e, t, r, i, s) {
    let l = d9(e, t);
    if (!l.length)
      return i && e.some(
        (a) => a.state == 1
        /* State.Pending */
      ) ? new Ri(i.options, i.attrs, i.tooltip, i.timestamp, i.selected, !0) : null;
    let o = t.facet(Ir).selectOnOpen ? 0 : -1;
    if (i && i.selected != o && i.selected != -1) {
      let a = i.options[i.selected].completion;
      for (let u = 0; u < l.length; u++)
        if (l[u].completion == a) {
          o = u;
          break;
        }
    }
    return new Ri(l, Td(r, o), {
      pos: e.reduce((a, u) => u.hasResult() ? Math.min(a, u.from) : a, 1e8),
      create: k9,
      above: s.aboveCursor
    }, i ? i.timestamp : Date.now(), o, !1);
  }
  map(e) {
    return new Ri(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: e.mapPos(this.tooltip.pos) }), this.timestamp, this.selected, this.disabled);
  }
}
class qo {
  constructor(e, t, r) {
    this.active = e, this.id = t, this.open = r;
  }
  static start() {
    return new qo(b9, "cm-ac-" + Math.floor(Math.random() * 2e6).toString(36), null);
  }
  update(e) {
    let { state: t } = e, r = t.facet(Ir), s = (r.override || t.languageDataAt("autocomplete", qi(t)).map(s9)).map((o) => (this.active.find((u) => u.source == o) || new Yt(
      o,
      this.active.some(
        (u) => u.state != 0
        /* State.Inactive */
      ) ? 1 : 0
      /* State.Inactive */
    )).update(e, r));
    s.length == this.active.length && s.every((o, a) => o == this.active[a]) && (s = this.active);
    let l = this.open;
    l && e.docChanged && (l = l.map(e.changes)), e.selection || s.some((o) => o.hasResult() && e.changes.touchesRange(o.from, o.to)) || !m9(s, this.active) ? l = Ri.build(s, t, this.id, l, r) : l && l.disabled && !s.some(
      (o) => o.state == 1
      /* State.Pending */
    ) && (l = null), !l && s.every(
      (o) => o.state != 1
      /* State.Pending */
    ) && s.some((o) => o.hasResult()) && (s = s.map((o) => o.hasResult() ? new Yt(
      o.source,
      0
      /* State.Inactive */
    ) : o));
    for (let o of e.effects)
      o.is(w4) && (l = l && l.setSelected(o.value, this.id));
    return s == this.active && l == this.open ? this : new qo(s, this.id, l);
  }
  get tooltip() {
    return this.open ? this.open.tooltip : null;
  }
  get attrs() {
    return this.open ? this.open.attrs : this.active.length ? p9 : g9;
  }
}
function m9(n, e) {
  if (n == e)
    return !0;
  for (let t = 0, r = 0; ; ) {
    for (; t < n.length && !n[t].hasResult; )
      t++;
    for (; r < e.length && !e[r].hasResult; )
      r++;
    let i = t == n.length, s = r == e.length;
    if (i || s)
      return i == s;
    if (n[t++].result != e[r++].result)
      return !1;
  }
}
const p9 = {
  "aria-autocomplete": "list"
}, g9 = {};
function Td(n, e) {
  let t = {
    "aria-autocomplete": "list",
    "aria-haspopup": "listbox",
    "aria-controls": n
  };
  return e > -1 && (t["aria-activedescendant"] = n + "-" + e), t;
}
const b9 = [];
function v9(n, e) {
  if (n.isUserEvent("input.complete")) {
    let r = n.annotation(Eh);
    if (r && e.activateOnCompletion(r))
      return 12;
  }
  let t = n.isUserEvent("input.type");
  return t && e.activateOnTyping ? 5 : t ? 1 : n.isUserEvent("delete.backward") ? 2 : n.selection ? 8 : n.docChanged ? 16 : 0;
}
class Yt {
  constructor(e, t, r = -1) {
    this.source = e, this.state = t, this.explicitPos = r;
  }
  hasResult() {
    return !1;
  }
  update(e, t) {
    let r = v9(e, t), i = this;
    (r & 8 || r & 16 && this.touches(e)) && (i = new Yt(
      i.source,
      0
      /* State.Inactive */
    )), r & 4 && i.state == 0 && (i = new Yt(
      this.source,
      1
      /* State.Pending */
    )), i = i.updateFor(e, r);
    for (let s of e.effects)
      if (s.is(y4))
        i = new Yt(i.source, 1, s.value ? qi(e.state) : -1);
      else if (s.is(Fh))
        i = new Yt(
          i.source,
          0
          /* State.Inactive */
        );
      else if (s.is(w9))
        for (let l of s.value)
          l.source == i.source && (i = l);
    return i;
  }
  updateFor(e, t) {
    return this.map(e.changes);
  }
  map(e) {
    return e.empty || this.explicitPos < 0 ? this : new Yt(this.source, this.state, e.mapPos(this.explicitPos));
  }
  touches(e) {
    return e.changes.touchesRange(qi(e.state));
  }
}
class Hs extends Yt {
  constructor(e, t, r, i, s) {
    super(e, 2, t), this.result = r, this.from = i, this.to = s;
  }
  hasResult() {
    return !0;
  }
  updateFor(e, t) {
    var r;
    if (!(t & 3))
      return this.map(e.changes);
    let i = this.result;
    i.map && !e.changes.empty && (i = i.map(i, e.changes));
    let s = e.changes.mapPos(this.from), l = e.changes.mapPos(this.to, 1), o = qi(e.state);
    if ((this.explicitPos < 0 ? o <= s : o < this.from) || o > l || !i || t & 2 && qi(e.startState) == this.from)
      return new Yt(
        this.source,
        t & 4 ? 1 : 0
        /* State.Inactive */
      );
    let a = this.explicitPos < 0 ? -1 : e.changes.mapPos(this.explicitPos);
    return y9(i.validFor, e.state, s, l) ? new Hs(this.source, a, i, s, l) : i.update && (i = i.update(i, s, l, new t9(e.state, o, a >= 0))) ? new Hs(this.source, a, i, i.from, (r = i.to) !== null && r !== void 0 ? r : qi(e.state)) : new Yt(this.source, 1, a);
  }
  map(e) {
    return e.empty ? this : (this.result.map ? this.result.map(this.result, e) : this.result) ? new Hs(this.source, this.explicitPos < 0 ? -1 : e.mapPos(this.explicitPos), this.result, e.mapPos(this.from), e.mapPos(this.to, 1)) : new Yt(
      this.source,
      0
      /* State.Inactive */
    );
  }
  touches(e) {
    return e.changes.touchesRange(this.from, this.to);
  }
}
function y9(n, e, t, r) {
  if (!n)
    return !1;
  let i = e.sliceDoc(t, r);
  return typeof n == "function" ? n(i, t, r, e) : v4(n, !0).test(i);
}
const w9 = /* @__PURE__ */ ye.define({
  map(n, e) {
    return n.map((t) => t.map(e));
  }
}), w4 = /* @__PURE__ */ ye.define(), ss = /* @__PURE__ */ Lt.define({
  create() {
    return qo.start();
  },
  update(n, e) {
    return n.update(e);
  },
  provide: (n) => [
    ph.from(n, (e) => e.tooltip),
    Q.contentAttributes.from(n, (e) => e.attrs)
  ]
});
function k4(n, e) {
  const t = e.completion.apply || e.completion.label;
  let r = n.state.field(ss).active.find((i) => i.source == e.source);
  return r instanceof Hs ? (typeof t == "string" ? n.dispatch(Object.assign(Object.assign({}, i9(n.state, t, r.from, r.to)), { annotations: Eh.of(e.completion) })) : t(n, e.completion, r.from, r.to), !0) : !1;
}
const k9 = /* @__PURE__ */ c9(ss, k4);
function Ul(n, e = "option") {
  return (t) => {
    let r = t.state.field(ss, !1);
    if (!r || !r.open || r.open.disabled || Date.now() - r.open.timestamp < t.state.facet(Ir).interactionDelay)
      return !1;
    let i = 1, s;
    e == "page" && (s = n7(t, r.open.tooltip)) && (i = Math.max(2, Math.floor(s.dom.offsetHeight / s.dom.querySelector("li").offsetHeight) - 1));
    let { length: l } = r.open.options, o = r.open.selected > -1 ? r.open.selected + i * (n ? 1 : -1) : n ? 0 : l - 1;
    return o < 0 ? o = e == "page" ? 0 : l - 1 : o >= l && (o = e == "page" ? l - 1 : 0), t.dispatch({ effects: w4.of(o) }), !0;
  };
}
const x9 = (n) => {
  let e = n.state.field(ss, !1);
  return n.state.readOnly || !e || !e.open || e.open.selected < 0 || e.open.disabled || Date.now() - e.open.timestamp < n.state.facet(Ir).interactionDelay ? !1 : k4(n, e.open.options[e.open.selected]);
}, Ed = (n) => n.state.field(ss, !1) ? (n.dispatch({ effects: y4.of(!0) }), !0) : !1, S9 = (n) => {
  let e = n.state.field(ss, !1);
  return !e || !e.active.some(
    (t) => t.state != 0
    /* State.Inactive */
  ) ? !1 : (n.dispatch({ effects: Fh.of(null) }), !0);
}, A9 = /* @__PURE__ */ Q.baseTheme({
  ".cm-tooltip.cm-tooltip-autocomplete": {
    "& > ul": {
      fontFamily: "monospace",
      whiteSpace: "nowrap",
      overflow: "hidden auto",
      maxWidth_fallback: "700px",
      maxWidth: "min(700px, 95vw)",
      minWidth: "250px",
      maxHeight: "10em",
      height: "100%",
      listStyle: "none",
      margin: 0,
      padding: 0,
      "& > li, & > completion-section": {
        padding: "1px 3px",
        lineHeight: 1.2
      },
      "& > li": {
        overflowX: "hidden",
        textOverflow: "ellipsis",
        cursor: "pointer"
      },
      "& > completion-section": {
        display: "list-item",
        borderBottom: "1px solid silver",
        paddingLeft: "0.5em",
        opacity: 0.7
      }
    }
  },
  "&light .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#17c",
    color: "white"
  },
  "&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#777"
  },
  "&dark .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#347",
    color: "white"
  },
  "&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#444"
  },
  ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": {
    content: '"···"',
    opacity: 0.5,
    display: "block",
    textAlign: "center"
  },
  ".cm-tooltip.cm-completionInfo": {
    position: "absolute",
    padding: "3px 9px",
    width: "max-content",
    maxWidth: "400px",
    boxSizing: "border-box",
    whiteSpace: "pre-line"
  },
  ".cm-completionInfo.cm-completionInfo-left": { right: "100%" },
  ".cm-completionInfo.cm-completionInfo-right": { left: "100%" },
  ".cm-completionInfo.cm-completionInfo-left-narrow": { right: "30px" },
  ".cm-completionInfo.cm-completionInfo-right-narrow": { left: "30px" },
  "&light .cm-snippetField": { backgroundColor: "#00000022" },
  "&dark .cm-snippetField": { backgroundColor: "#ffffff22" },
  ".cm-snippetFieldPosition": {
    verticalAlign: "text-top",
    width: 0,
    height: "1.15em",
    display: "inline-block",
    margin: "0 -0.7px -.7em",
    borderLeft: "1.4px dotted #888"
  },
  ".cm-completionMatchedText": {
    textDecoration: "underline"
  },
  ".cm-completionDetail": {
    marginLeft: "0.5em",
    fontStyle: "italic"
  },
  ".cm-completionIcon": {
    fontSize: "90%",
    width: ".8em",
    display: "inline-block",
    textAlign: "center",
    paddingRight: ".6em",
    opacity: "0.6",
    boxSizing: "content-box"
  },
  ".cm-completionIcon-function, .cm-completionIcon-method": {
    "&:after": { content: "'ƒ'" }
  },
  ".cm-completionIcon-class": {
    "&:after": { content: "'○'" }
  },
  ".cm-completionIcon-interface": {
    "&:after": { content: "'◌'" }
  },
  ".cm-completionIcon-variable": {
    "&:after": { content: "'𝑥'" }
  },
  ".cm-completionIcon-constant": {
    "&:after": { content: "'𝐶'" }
  },
  ".cm-completionIcon-type": {
    "&:after": { content: "'𝑡'" }
  },
  ".cm-completionIcon-enum": {
    "&:after": { content: "'∪'" }
  },
  ".cm-completionIcon-property": {
    "&:after": { content: "'□'" }
  },
  ".cm-completionIcon-keyword": {
    "&:after": { content: "'🔑︎'" }
    // Disable emoji rendering
  },
  ".cm-completionIcon-namespace": {
    "&:after": { content: "'▢'" }
  },
  ".cm-completionIcon-text": {
    "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" }
  }
});
class D9 {
  constructor(e, t, r, i) {
    this.field = e, this.line = t, this.from = r, this.to = i;
  }
}
class Bh {
  constructor(e, t, r) {
    this.field = e, this.from = t, this.to = r;
  }
  map(e) {
    let t = e.mapPos(this.from, -1, at.TrackDel), r = e.mapPos(this.to, 1, at.TrackDel);
    return t == null || r == null ? null : new Bh(this.field, t, r);
  }
}
class Oh {
  constructor(e, t) {
    this.lines = e, this.fieldPositions = t;
  }
  instantiate(e, t) {
    let r = [], i = [t], s = e.doc.lineAt(t), l = /^\s*/.exec(s.text)[0];
    for (let a of this.lines) {
      if (r.length) {
        let u = l, h = /^\t*/.exec(a)[0].length;
        for (let c = 0; c < h; c++)
          u += e.facet(ua);
        i.push(t + u.length - h), a = u + a.slice(h);
      }
      r.push(a), t += a.length + 1;
    }
    let o = this.fieldPositions.map((a) => new Bh(a.field, i[a.line] + a.from, i[a.line] + a.to));
    return { text: r, ranges: o };
  }
  static parse(e) {
    let t = [], r = [], i = [], s;
    for (let l of e.split(/\r\n?|\n/)) {
      for (; s = /[#$]\{(?:(\d+)(?::([^}]*))?|((?:\\[{}]|[^}])*))\}/.exec(l); ) {
        let o = s[1] ? +s[1] : null, a = s[2] || s[3] || "", u = -1, h = a.replace(/\\[{}]/g, (c) => c[1]);
        for (let c = 0; c < t.length; c++)
          (o != null ? t[c].seq == o : h && t[c].name == h) && (u = c);
        if (u < 0) {
          let c = 0;
          for (; c < t.length && (o == null || t[c].seq != null && t[c].seq < o); )
            c++;
          t.splice(c, 0, { seq: o, name: h }), u = c;
          for (let f of i)
            f.field >= u && f.field++;
        }
        i.push(new D9(u, r.length, s.index, s.index + h.length)), l = l.slice(0, s.index) + a + l.slice(s.index + s[0].length);
      }
      l = l.replace(/\\([{}])/g, (o, a, u) => {
        for (let h of i)
          h.line == r.length && h.from > u && (h.from--, h.to--);
        return a;
      }), r.push(l);
    }
    return new Oh(r, i);
  }
}
let C9 = /* @__PURE__ */ be.widget({ widget: /* @__PURE__ */ new class extends Xr {
  toDOM() {
    let n = document.createElement("span");
    return n.className = "cm-snippetFieldPosition", n;
  }
  ignoreEvent() {
    return !1;
  }
}() }), _9 = /* @__PURE__ */ be.mark({ class: "cm-snippetField" });
class ls {
  constructor(e, t) {
    this.ranges = e, this.active = t, this.deco = be.set(e.map((r) => (r.from == r.to ? C9 : _9).range(r.from, r.to)));
  }
  map(e) {
    let t = [];
    for (let r of this.ranges) {
      let i = r.map(e);
      if (!i)
        return null;
      t.push(i);
    }
    return new ls(t, this.active);
  }
  selectionInsideField(e) {
    return e.ranges.every((t) => this.ranges.some((r) => r.field == this.active && r.from <= t.from && r.to >= t.to));
  }
}
const pl = /* @__PURE__ */ ye.define({
  map(n, e) {
    return n && n.map(e);
  }
}), M9 = /* @__PURE__ */ ye.define(), rl = /* @__PURE__ */ Lt.define({
  create() {
    return null;
  },
  update(n, e) {
    for (let t of e.effects) {
      if (t.is(pl))
        return t.value;
      if (t.is(M9) && n)
        return new ls(n.ranges, t.value);
    }
    return n && e.docChanged && (n = n.map(e.changes)), n && e.selection && !n.selectionInsideField(e.selection) && (n = null), n;
  },
  provide: (n) => Q.decorations.from(n, (e) => e ? e.deco : be.none)
});
function Rh(n, e) {
  return I.create(n.filter((t) => t.field == e).map((t) => I.range(t.from, t.to)));
}
function T9(n) {
  let e = Oh.parse(n);
  return (t, r, i, s) => {
    let { text: l, ranges: o } = e.instantiate(t.state, i), a = {
      changes: { from: i, to: s, insert: Ae.of(l) },
      scrollIntoView: !0,
      annotations: r ? [Eh.of(r), Qe.userEvent.of("input.complete")] : void 0
    };
    if (o.length && (a.selection = Rh(o, 0)), o.some((u) => u.field > 0)) {
      let u = new ls(o, 0), h = a.effects = [pl.of(u)];
      t.state.field(rl, !1) === void 0 && h.push(ye.appendConfig.of([rl, R9, L9, A9]));
    }
    t.dispatch(t.state.update(a));
  };
}
function x4(n) {
  return ({ state: e, dispatch: t }) => {
    let r = e.field(rl, !1);
    if (!r || n < 0 && r.active == 0)
      return !1;
    let i = r.active + n, s = n > 0 && !r.ranges.some((l) => l.field == i + n);
    return t(e.update({
      selection: Rh(r.ranges, i),
      effects: pl.of(s ? null : new ls(r.ranges, i)),
      scrollIntoView: !0
    })), !0;
  };
}
const E9 = ({ state: n, dispatch: e }) => n.field(rl, !1) ? (e(n.update({ effects: pl.of(null) })), !0) : !1, F9 = /* @__PURE__ */ x4(1), B9 = /* @__PURE__ */ x4(-1), O9 = [
  { key: "Tab", run: F9, shift: B9 },
  { key: "Escape", run: E9 }
], Fd = /* @__PURE__ */ X.define({
  combine(n) {
    return n.length ? n[0] : O9;
  }
}), R9 = /* @__PURE__ */ al.highest(/* @__PURE__ */ oa.compute([Fd], (n) => n.facet(Fd)));
function PD(n, e) {
  return Object.assign(Object.assign({}, e), { apply: T9(n) });
}
const L9 = /* @__PURE__ */ Q.domEventHandlers({
  mousedown(n, e) {
    let t = e.state.field(rl, !1), r;
    if (!t || (r = e.posAtCoords({ x: n.clientX, y: n.clientY })) == null)
      return !1;
    let i = t.ranges.find((s) => s.from <= r && s.to >= r);
    return !i || i.field == t.active ? !1 : (e.dispatch({
      selection: Rh(t.ranges, i.field),
      effects: pl.of(t.ranges.some((s) => s.field > i.field) ? new ls(t.ranges, i.field) : null),
      scrollIntoView: !0
    }), !0);
  }
}), nl = {
  brackets: ["(", "[", "{", "'", '"'],
  before: ")]}:;>",
  stringPrefixes: []
}, Qn = /* @__PURE__ */ ye.define({
  map(n, e) {
    let t = e.mapPos(n, -1, at.TrackAfter);
    return t ?? void 0;
  }
}), Lh = /* @__PURE__ */ new class extends ri {
}();
Lh.startSide = 1;
Lh.endSide = -1;
const S4 = /* @__PURE__ */ Lt.define({
  create() {
    return Ce.empty;
  },
  update(n, e) {
    if (n = n.map(e.changes), e.selection) {
      let t = e.state.doc.lineAt(e.selection.main.head);
      n = n.update({ filter: (r) => r >= t.from && r <= t.to });
    }
    for (let t of e.effects)
      t.is(Qn) && (n = n.update({ add: [Lh.range(t.value, t.value + 1)] }));
    return n;
  }
});
function N9() {
  return [z9, S4];
}
const s0 = "()[]{}<>";
function A4(n) {
  for (let e = 0; e < s0.length; e += 2)
    if (s0.charCodeAt(e) == n)
      return s0.charAt(e + 1);
  return Ym(n < 128 ? n : n + 1);
}
function D4(n, e) {
  return n.languageDataAt("closeBrackets", e)[0] || nl;
}
const I9 = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), z9 = /* @__PURE__ */ Q.inputHandler.of((n, e, t, r) => {
  if ((I9 ? n.composing : n.compositionStarted) || n.state.readOnly)
    return !1;
  let i = n.state.selection.main;
  if (r.length > 2 || r.length == 2 && vr(ft(r, 0)) == 1 || e != i.from || t != i.to)
    return !1;
  let s = q9(n.state, r);
  return s ? (n.dispatch(s), !0) : !1;
}), P9 = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let r = D4(n, n.selection.main.head).brackets || nl.brackets, i = null, s = n.changeByRange((l) => {
    if (l.empty) {
      let o = V9(n.doc, l.head);
      for (let a of r)
        if (a == o && ga(n.doc, l.head) == A4(ft(a, 0)))
          return {
            changes: { from: l.head - a.length, to: l.head + a.length },
            range: I.cursor(l.head - a.length)
          };
    }
    return { range: i = l };
  });
  return i || e(n.update(s, { scrollIntoView: !0, userEvent: "delete.backward" })), !i;
}, H9 = [
  { key: "Backspace", run: P9 }
];
function q9(n, e) {
  let t = D4(n, n.selection.main.head), r = t.brackets || nl.brackets;
  for (let i of r) {
    let s = A4(ft(i, 0));
    if (e == i)
      return s == i ? G9(n, i, r.indexOf(i + i + i) > -1, t) : W9(n, i, s, t.before || nl.before);
    if (e == s && C4(n, n.selection.main.from))
      return U9(n, i, s);
  }
  return null;
}
function C4(n, e) {
  let t = !1;
  return n.field(S4).between(0, n.doc.length, (r) => {
    r == e && (t = !0);
  }), t;
}
function ga(n, e) {
  let t = n.sliceString(e, e + 2);
  return t.slice(0, vr(ft(t, 0)));
}
function V9(n, e) {
  let t = n.sliceString(e - 2, e);
  return vr(ft(t, 0)) == t.length ? t : t.slice(1);
}
function W9(n, e, t, r) {
  let i = null, s = n.changeByRange((l) => {
    if (!l.empty)
      return {
        changes: [{ insert: e, from: l.from }, { insert: t, from: l.to }],
        effects: Qn.of(l.to + e.length),
        range: I.range(l.anchor + e.length, l.head + e.length)
      };
    let o = ga(n.doc, l.head);
    return !o || /\s/.test(o) || r.indexOf(o) > -1 ? {
      changes: { insert: e + t, from: l.head },
      effects: Qn.of(l.head + e.length),
      range: I.cursor(l.head + e.length)
    } : { range: i = l };
  });
  return i ? null : n.update(s, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function U9(n, e, t) {
  let r = null, i = n.changeByRange((s) => s.empty && ga(n.doc, s.head) == t ? {
    changes: { from: s.head, to: s.head + t.length, insert: t },
    range: I.cursor(s.head + t.length)
  } : r = { range: s });
  return r ? null : n.update(i, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function G9(n, e, t, r) {
  let i = r.stringPrefixes || nl.stringPrefixes, s = null, l = n.changeByRange((o) => {
    if (!o.empty)
      return {
        changes: [{ insert: e, from: o.from }, { insert: e, from: o.to }],
        effects: Qn.of(o.to + e.length),
        range: I.range(o.anchor + e.length, o.head + e.length)
      };
    let a = o.head, u = ga(n.doc, a), h;
    if (u == e) {
      if (Bd(n, a))
        return {
          changes: { insert: e + e, from: a },
          effects: Qn.of(a + e.length),
          range: I.cursor(a + e.length)
        };
      if (C4(n, a)) {
        let f = t && n.sliceDoc(a, a + e.length * 3) == e + e + e ? e + e + e : e;
        return {
          changes: { from: a, to: a + f.length, insert: f },
          range: I.cursor(a + f.length)
        };
      }
    } else {
      if (t && n.sliceDoc(a - 2 * e.length, a) == e + e && (h = Od(n, a - 2 * e.length, i)) > -1 && Bd(n, h))
        return {
          changes: { insert: e + e + e + e, from: a },
          effects: Qn.of(a + e.length),
          range: I.cursor(a + e.length)
        };
      if (n.charCategorizer(a)(u) != Kt.Word && Od(n, a, i) > -1 && !j9(n, a, e, i))
        return {
          changes: { insert: e + e, from: a },
          effects: Qn.of(a + e.length),
          range: I.cursor(a + e.length)
        };
    }
    return { range: s = o };
  });
  return s ? null : n.update(l, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function Bd(n, e) {
  let t = nt(n).resolveInner(e + 1);
  return t.parent && t.from == e;
}
function j9(n, e, t, r) {
  let i = nt(n).resolveInner(e, -1), s = r.reduce((l, o) => Math.max(l, o.length), 0);
  for (let l = 0; l < 5; l++) {
    let o = n.sliceDoc(i.from, Math.min(i.to, i.from + t.length + s)), a = o.indexOf(t);
    if (!a || a > -1 && r.indexOf(o.slice(0, a)) > -1) {
      let h = i.firstChild;
      for (; h && h.from == i.from && h.to - h.from > t.length + a; ) {
        if (n.sliceDoc(h.to - t.length, h.to) == t)
          return !1;
        h = h.firstChild;
      }
      return !0;
    }
    let u = i.to == e && i.parent;
    if (!u)
      break;
    i = u;
  }
  return !1;
}
function Od(n, e, t) {
  let r = n.charCategorizer(e);
  if (r(n.sliceDoc(e - 1, e)) != Kt.Word)
    return e;
  for (let i of t) {
    let s = e - i.length;
    if (n.sliceDoc(s, e) == i && r(n.sliceDoc(s - 1, s)) != Kt.Word)
      return s;
  }
  return -1;
}
const $9 = [
  { key: "Ctrl-Space", run: Ed },
  { mac: "Alt-`", run: Ed },
  { key: "Escape", run: S9 },
  { key: "ArrowDown", run: /* @__PURE__ */ Ul(!0) },
  { key: "ArrowUp", run: /* @__PURE__ */ Ul(!1) },
  { key: "PageDown", run: /* @__PURE__ */ Ul(!0, "page") },
  { key: "PageUp", run: /* @__PURE__ */ Ul(!1, "page") },
  { key: "Enter", run: x9 }
];
function zr() {
  var n = arguments[0];
  typeof n == "string" && (n = document.createElement(n));
  var e = 1, t = arguments[1];
  if (t && typeof t == "object" && t.nodeType == null && !Array.isArray(t)) {
    for (var r in t) if (Object.prototype.hasOwnProperty.call(t, r)) {
      var i = t[r];
      typeof i == "string" ? n.setAttribute(r, i) : i != null && (n[r] = i);
    }
    e++;
  }
  for (; e < arguments.length; e++) _4(n, arguments[e]);
  return n;
}
function _4(n, e) {
  if (typeof e == "string")
    n.appendChild(document.createTextNode(e));
  else if (e != null) if (e.nodeType != null)
    n.appendChild(e);
  else if (Array.isArray(e))
    for (var t = 0; t < e.length; t++) _4(n, e[t]);
  else
    throw new RangeError("Unsupported child node: " + e);
}
class Y9 {
  constructor(e, t, r) {
    this.from = e, this.to = t, this.diagnostic = r;
  }
}
class Xn {
  constructor(e, t, r) {
    this.diagnostics = e, this.panel = t, this.selected = r;
  }
  static init(e, t, r) {
    let i = e, s = r.facet(il).markerFilter;
    s && (i = s(i, r));
    let l = be.set(i.map((o) => o.from == o.to || o.from == o.to - 1 && r.doc.lineAt(o.from).to == o.from ? be.widget({
      widget: new nv(o),
      diagnostic: o
    }).range(o.from) : be.mark({
      attributes: { class: "cm-lintRange cm-lintRange-" + o.severity + (o.markClass ? " " + o.markClass : "") },
      diagnostic: o
    }).range(o.from, o.to)), !0);
    return new Xn(l, t, Zi(l));
  }
}
function Zi(n, e = null, t = 0) {
  let r = null;
  return n.between(t, 1e9, (i, s, { spec: l }) => {
    if (!(e && l.diagnostic != e))
      return r = new Y9(i, s, l.diagnostic), !1;
  }), r;
}
function K9(n, e) {
  let t = e.pos, r = e.end || t, i = n.state.facet(il).hideOn(n, t, r);
  if (i != null)
    return i;
  let s = n.startState.doc.lineAt(e.pos);
  return !!(n.effects.some((l) => l.is(M4)) || n.changes.touchesRange(s.from, Math.max(s.to, r)));
}
function X9(n, e) {
  return n.field(Pt, !1) ? e : e.concat(ye.appendConfig.of(lv));
}
const M4 = /* @__PURE__ */ ye.define(), Nh = /* @__PURE__ */ ye.define(), T4 = /* @__PURE__ */ ye.define(), Pt = /* @__PURE__ */ Lt.define({
  create() {
    return new Xn(be.none, null, null);
  },
  update(n, e) {
    if (e.docChanged && n.diagnostics.size) {
      let t = n.diagnostics.map(e.changes), r = null, i = n.panel;
      if (n.selected) {
        let s = e.changes.mapPos(n.selected.from, 1);
        r = Zi(t, n.selected.diagnostic, s) || Zi(t, null, s);
      }
      !t.size && i && e.state.facet(il).autoPanel && (i = null), n = new Xn(t, i, r);
    }
    for (let t of e.effects)
      if (t.is(M4)) {
        let r = e.state.facet(il).autoPanel ? t.value.length ? sl.open : null : n.panel;
        n = Xn.init(t.value, r, e.state);
      } else t.is(Nh) ? n = new Xn(n.diagnostics, t.value ? sl.open : null, n.selected) : t.is(T4) && (n = new Xn(n.diagnostics, n.panel, t.value));
    return n;
  },
  provide: (n) => [
    Au.from(n, (e) => e.panel),
    Q.decorations.from(n, (e) => e.diagnostics)
  ]
}), Z9 = /* @__PURE__ */ be.mark({ class: "cm-lintRange cm-lintRange-active" });
function J9(n, e, t) {
  let { diagnostics: r } = n.state.field(Pt), i = [], s = 2e8, l = 0;
  r.between(e - (t < 0 ? 1 : 0), e + (t > 0 ? 1 : 0), (a, u, { spec: h }) => {
    e >= a && e <= u && (a == u || (e > a || t > 0) && (e < u || t < 0)) && (i.push(h.diagnostic), s = Math.min(a, s), l = Math.max(u, l));
  });
  let o = n.state.facet(il).tooltipFilter;
  return o && (i = o(i, n.state)), i.length ? {
    pos: s,
    end: l,
    above: n.state.doc.lineAt(s).to < l,
    create() {
      return { dom: Q9(n, i) };
    }
  } : null;
}
function Q9(n, e) {
  return zr("ul", { class: "cm-tooltip-lint" }, e.map((t) => F4(n, t, !1)));
}
const ev = (n) => {
  let e = n.state.field(Pt, !1);
  (!e || !e.panel) && n.dispatch({ effects: X9(n.state, [Nh.of(!0)]) });
  let t = s7(n, sl.open);
  return t && t.dom.querySelector(".cm-panel-lint ul").focus(), !0;
}, Rd = (n) => {
  let e = n.state.field(Pt, !1);
  return !e || !e.panel ? !1 : (n.dispatch({ effects: Nh.of(!1) }), !0);
}, tv = (n) => {
  let e = n.state.field(Pt, !1);
  if (!e)
    return !1;
  let t = n.state.selection.main, r = e.diagnostics.iter(t.to + 1);
  return !r.value && (r = e.diagnostics.iter(0), !r.value || r.from == t.from && r.to == t.to) ? !1 : (n.dispatch({ selection: { anchor: r.from, head: r.to }, scrollIntoView: !0 }), !0);
}, rv = [
  { key: "Mod-Shift-m", run: ev, preventDefault: !0 },
  { key: "F8", run: tv }
], il = /* @__PURE__ */ X.define({
  combine(n) {
    return Object.assign({ sources: n.map((e) => e.source).filter((e) => e != null) }, bi(n.map((e) => e.config), {
      delay: 750,
      markerFilter: null,
      tooltipFilter: null,
      needsRefresh: null,
      hideOn: () => null
    }, {
      needsRefresh: (e, t) => e ? t ? (r) => e(r) || t(r) : e : t
    }));
  }
});
function E4(n) {
  let e = [];
  if (n)
    e: for (let { name: t } of n) {
      for (let r = 0; r < t.length; r++) {
        let i = t[r];
        if (/[a-zA-Z]/.test(i) && !e.some((s) => s.toLowerCase() == i.toLowerCase())) {
          e.push(i);
          continue e;
        }
      }
      e.push("");
    }
  return e;
}
function F4(n, e, t) {
  var r;
  let i = t ? E4(e.actions) : [];
  return zr("li", { class: "cm-diagnostic cm-diagnostic-" + e.severity }, zr("span", { class: "cm-diagnosticText" }, e.renderMessage ? e.renderMessage(n) : e.message), (r = e.actions) === null || r === void 0 ? void 0 : r.map((s, l) => {
    let o = !1, a = (f) => {
      if (f.preventDefault(), o)
        return;
      o = !0;
      let m = Zi(n.state.field(Pt).diagnostics, e);
      m && s.apply(n, m.from, m.to);
    }, { name: u } = s, h = i[l] ? u.indexOf(i[l]) : -1, c = h < 0 ? u : [
      u.slice(0, h),
      zr("u", u.slice(h, h + 1)),
      u.slice(h + 1)
    ];
    return zr("button", {
      type: "button",
      class: "cm-diagnosticAction",
      onclick: a,
      onmousedown: a,
      "aria-label": ` Action: ${u}${h < 0 ? "" : ` (access key "${i[l]})"`}.`
    }, c);
  }), e.source && zr("div", { class: "cm-diagnosticSource" }, e.source));
}
class nv extends Xr {
  constructor(e) {
    super(), this.diagnostic = e;
  }
  eq(e) {
    return e.diagnostic == this.diagnostic;
  }
  toDOM() {
    return zr("span", { class: "cm-lintPoint cm-lintPoint-" + this.diagnostic.severity });
  }
}
class Ld {
  constructor(e, t) {
    this.diagnostic = t, this.id = "item_" + Math.floor(Math.random() * 4294967295).toString(16), this.dom = F4(e, t, !0), this.dom.id = this.id, this.dom.setAttribute("role", "option");
  }
}
class sl {
  constructor(e) {
    this.view = e, this.items = [];
    let t = (i) => {
      if (i.keyCode == 27)
        Rd(this.view), this.view.focus();
      else if (i.keyCode == 38 || i.keyCode == 33)
        this.moveSelection((this.selectedIndex - 1 + this.items.length) % this.items.length);
      else if (i.keyCode == 40 || i.keyCode == 34)
        this.moveSelection((this.selectedIndex + 1) % this.items.length);
      else if (i.keyCode == 36)
        this.moveSelection(0);
      else if (i.keyCode == 35)
        this.moveSelection(this.items.length - 1);
      else if (i.keyCode == 13)
        this.view.focus();
      else if (i.keyCode >= 65 && i.keyCode <= 90 && this.selectedIndex >= 0) {
        let { diagnostic: s } = this.items[this.selectedIndex], l = E4(s.actions);
        for (let o = 0; o < l.length; o++)
          if (l[o].toUpperCase().charCodeAt(0) == i.keyCode) {
            let a = Zi(this.view.state.field(Pt).diagnostics, s);
            a && s.actions[o].apply(e, a.from, a.to);
          }
      } else
        return;
      i.preventDefault();
    }, r = (i) => {
      for (let s = 0; s < this.items.length; s++)
        this.items[s].dom.contains(i.target) && this.moveSelection(s);
    };
    this.list = zr("ul", {
      tabIndex: 0,
      role: "listbox",
      "aria-label": this.view.state.phrase("Diagnostics"),
      onkeydown: t,
      onclick: r
    }), this.dom = zr("div", { class: "cm-panel-lint" }, this.list, zr("button", {
      type: "button",
      name: "close",
      "aria-label": this.view.state.phrase("close"),
      onclick: () => Rd(this.view)
    }, "×")), this.update();
  }
  get selectedIndex() {
    let e = this.view.state.field(Pt).selected;
    if (!e)
      return -1;
    for (let t = 0; t < this.items.length; t++)
      if (this.items[t].diagnostic == e.diagnostic)
        return t;
    return -1;
  }
  update() {
    let { diagnostics: e, selected: t } = this.view.state.field(Pt), r = 0, i = !1, s = null;
    for (e.between(0, this.view.state.doc.length, (l, o, { spec: a }) => {
      let u = -1, h;
      for (let c = r; c < this.items.length; c++)
        if (this.items[c].diagnostic == a.diagnostic) {
          u = c;
          break;
        }
      u < 0 ? (h = new Ld(this.view, a.diagnostic), this.items.splice(r, 0, h), i = !0) : (h = this.items[u], u > r && (this.items.splice(r, u - r), i = !0)), t && h.diagnostic == t.diagnostic ? h.dom.hasAttribute("aria-selected") || (h.dom.setAttribute("aria-selected", "true"), s = h) : h.dom.hasAttribute("aria-selected") && h.dom.removeAttribute("aria-selected"), r++;
    }); r < this.items.length && !(this.items.length == 1 && this.items[0].diagnostic.from < 0); )
      i = !0, this.items.pop();
    this.items.length == 0 && (this.items.push(new Ld(this.view, {
      from: -1,
      to: -1,
      severity: "info",
      message: this.view.state.phrase("No diagnostics")
    })), i = !0), s ? (this.list.setAttribute("aria-activedescendant", s.id), this.view.requestMeasure({
      key: this,
      read: () => ({ sel: s.dom.getBoundingClientRect(), panel: this.list.getBoundingClientRect() }),
      write: ({ sel: l, panel: o }) => {
        let a = o.height / this.list.offsetHeight;
        l.top < o.top ? this.list.scrollTop -= (o.top - l.top) / a : l.bottom > o.bottom && (this.list.scrollTop += (l.bottom - o.bottom) / a);
      }
    })) : this.selectedIndex < 0 && this.list.removeAttribute("aria-activedescendant"), i && this.sync();
  }
  sync() {
    let e = this.list.firstChild;
    function t() {
      let r = e;
      e = r.nextSibling, r.remove();
    }
    for (let r of this.items)
      if (r.dom.parentNode == this.list) {
        for (; e != r.dom; )
          t();
        e = r.dom.nextSibling;
      } else
        this.list.insertBefore(r.dom, e);
    for (; e; )
      t();
  }
  moveSelection(e) {
    if (this.selectedIndex < 0)
      return;
    let t = this.view.state.field(Pt), r = Zi(t.diagnostics, this.items[e].diagnostic);
    r && this.view.dispatch({
      selection: { anchor: r.from, head: r.to },
      scrollIntoView: !0,
      effects: T4.of(r)
    });
  }
  static open(e) {
    return new sl(e);
  }
}
function iv(n, e = 'viewBox="0 0 40 40"') {
  return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" ${e}>${encodeURIComponent(n)}</svg>')`;
}
function Gl(n) {
  return iv(`<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="${n}" fill="none" stroke-width=".7"/>`, 'width="6" height="3"');
}
const sv = /* @__PURE__ */ Q.baseTheme({
  ".cm-diagnostic": {
    padding: "3px 6px 3px 8px",
    marginLeft: "-1px",
    display: "block",
    whiteSpace: "pre-wrap"
  },
  ".cm-diagnostic-error": { borderLeft: "5px solid #d11" },
  ".cm-diagnostic-warning": { borderLeft: "5px solid orange" },
  ".cm-diagnostic-info": { borderLeft: "5px solid #999" },
  ".cm-diagnostic-hint": { borderLeft: "5px solid #66d" },
  ".cm-diagnosticAction": {
    font: "inherit",
    border: "none",
    padding: "2px 4px",
    backgroundColor: "#444",
    color: "white",
    borderRadius: "3px",
    marginLeft: "8px",
    cursor: "pointer"
  },
  ".cm-diagnosticSource": {
    fontSize: "70%",
    opacity: 0.7
  },
  ".cm-lintRange": {
    backgroundPosition: "left bottom",
    backgroundRepeat: "repeat-x",
    paddingBottom: "0.7px"
  },
  ".cm-lintRange-error": { backgroundImage: /* @__PURE__ */ Gl("#d11") },
  ".cm-lintRange-warning": { backgroundImage: /* @__PURE__ */ Gl("orange") },
  ".cm-lintRange-info": { backgroundImage: /* @__PURE__ */ Gl("#999") },
  ".cm-lintRange-hint": { backgroundImage: /* @__PURE__ */ Gl("#66d") },
  ".cm-lintRange-active": { backgroundColor: "#ffdd9980" },
  ".cm-tooltip-lint": {
    padding: 0,
    margin: 0
  },
  ".cm-lintPoint": {
    position: "relative",
    "&:after": {
      content: '""',
      position: "absolute",
      bottom: 0,
      left: "-2px",
      borderLeft: "3px solid transparent",
      borderRight: "3px solid transparent",
      borderBottom: "4px solid #d11"
    }
  },
  ".cm-lintPoint-warning": {
    "&:after": { borderBottomColor: "orange" }
  },
  ".cm-lintPoint-info": {
    "&:after": { borderBottomColor: "#999" }
  },
  ".cm-lintPoint-hint": {
    "&:after": { borderBottomColor: "#66d" }
  },
  ".cm-panel.cm-panel-lint": {
    position: "relative",
    "& ul": {
      maxHeight: "100px",
      overflowY: "auto",
      "& [aria-selected]": {
        backgroundColor: "#ddd",
        "& u": { textDecoration: "underline" }
      },
      "&:focus [aria-selected]": {
        background_fallback: "#bdf",
        backgroundColor: "Highlight",
        color_fallback: "white",
        color: "HighlightText"
      },
      "& u": { textDecoration: "none" },
      padding: 0,
      margin: 0
    },
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "2px",
      background: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    }
  }
}), lv = [
  Pt,
  /* @__PURE__ */ Q.decorations.compute([Pt], (n) => {
    let { selected: e, panel: t } = n.field(Pt);
    return !e || !t || e.from == e.to ? be.none : be.set([
      Z9.range(e.from, e.to)
    ]);
  }),
  /* @__PURE__ */ r7(J9, { hideOn: K9 }),
  sv
], ov = [
  p7(),
  R6(),
  N8(),
  h8(),
  D6(),
  Se.allowMultipleSelections.of(!0),
  X7(),
  xh(m8, { fallback: !0 }),
  N9(),
  G6(),
  Y6(),
  oa.of([
    ...H9,
    ...Nb,
    ...G8,
    ...l8,
    ...$9,
    ...rv
  ])
], Nd = {
  python: () => import("./index-eoOYcYY6.js").then((n) => n.python()),
  markdown: async () => {
    const [n, e] = await Promise.all([
      import("./index-DRYwRkrj.js"),
      import("./frontmatter-DeWKdYCf.js")
    ]);
    return n.markdown({ extensions: [e.frontmatter] });
  },
  json: () => import("./index-CrYb5Scy.js").then((n) => n.json()),
  html: () => import("./index-B_0nvriU.js").then((n) => n.html()),
  css: () => import("./index-Bh8J2SOT.js").then((n) => n.css()),
  javascript: () => import("./index-C83s03OK.js").then((n) => n.javascript()),
  typescript: () => import("./index-C83s03OK.js").then(
    (n) => n.javascript({ typescript: !0 })
  ),
  yaml: () => import("./yaml-Dt6Tp2eU.js").then(
    (n) => Oi.define(n.yaml)
  ),
  dockerfile: () => import("./dockerfile-CEE6bo6a.js").then(
    (n) => Oi.define(n.dockerFile)
  ),
  shell: () => import("./shell-C0C2sNA_.js").then(
    (n) => Oi.define(n.shell)
  ),
  r: () => import("./r-Bz1d3XP0.js").then(
    (n) => Oi.define(n.r)
  )
}, av = {
  py: "python",
  md: "markdown",
  js: "javascript",
  ts: "typescript",
  sh: "shell"
};
async function uv(n) {
  const e = Nd[n] || Nd[av[n]] || void 0;
  if (e)
    return e();
}
const {
  SvelteComponent: hv,
  append_hydration: cv,
  attr: l0,
  binding_callbacks: fv,
  children: Id,
  claim_element: zd,
  detach: o0,
  element: Pd,
  init: dv,
  insert_hydration: mv,
  noop: Hd,
  safe_not_equal: pv
} = window.__gradio__svelte__internal, { createEventDispatcher: gv, onMount: bv } = window.__gradio__svelte__internal;
function vv(n) {
  let e, t, r;
  return {
    c() {
      e = Pd("div"), t = Pd("div"), this.h();
    },
    l(i) {
      e = zd(i, "DIV", { class: !0 });
      var s = Id(e);
      t = zd(s, "DIV", { class: !0 }), Id(t).forEach(o0), s.forEach(o0), this.h();
    },
    h() {
      l0(t, "class", r = "codemirror-wrapper " + /*classNames*/
      n[0] + " svelte-1f1hlu0"), l0(e, "class", "wrap svelte-1f1hlu0");
    },
    m(i, s) {
      mv(i, e, s), cv(e, t), n[13](t);
    },
    p(i, s) {
      s[0] & /*classNames*/
      1 && r !== (r = "codemirror-wrapper " + /*classNames*/
      i[0] + " svelte-1f1hlu0") && l0(t, "class", r);
    },
    i: Hd,
    o: Hd,
    d(i) {
      i && o0(e), n[13](null);
    }
  };
}
function yv(n) {
  var e, t;
  let r = n.dom.querySelectorAll(".cm-gutterElement");
  if (r.length === 0)
    return null;
  for (var i = 0; i < r.length; i++) {
    let s = r[i], l = (t = (e = getComputedStyle(s)) === null || e === void 0 ? void 0 : e.height) !== null && t !== void 0 ? t : "0px";
    if (l != "0px")
      return l;
  }
  return null;
}
function wv(n, e, t) {
  var r = this && this.__awaiter || function(H, fe, J, re) {
    function ae(de) {
      return de instanceof J ? de : new J(function(P) {
        P(de);
      });
    }
    return new (J || (J = Promise))(function(de, P) {
      function ze(je) {
        try {
          Pe(re.next(je));
        } catch (Ye) {
          P(Ye);
        }
      }
      function Me(je) {
        try {
          Pe(re.throw(je));
        } catch (Ye) {
          P(Ye);
        }
      }
      function Pe(je) {
        je.done ? de(je.value) : ae(je.value).then(ze, Me);
      }
      Pe((re = re.apply(H, fe || [])).next());
    });
  };
  let { classNames: i = "" } = e, { value: s = "" } = e, { dark_mode: l } = e, { basic: o = !0 } = e, { language: a } = e, { lines: u = 5 } = e, { extensions: h = [] } = e, { highlights: c = [] } = e, { useTab: f = !0 } = e, { readonly: m = !1 } = e, { placeholder: g = void 0 } = e;
  const v = gv();
  let k, S, x;
  function y(H) {
    return r(this, void 0, void 0, function* () {
      const fe = yield uv(H);
      t(12, k = fe);
    });
  }
  function A(H) {
    const fe = H.querySelectorAll(".cm-line");
    let J = "transparent";
    fe.forEach((re, ae) => {
      var de, P;
      const ze = ae + 1;
      let Me = (P = (de = c.find(([Pe, je]) => Pe === ze)) === null || de === void 0 ? void 0 : de[1]) !== null && P !== void 0 ? P : J;
      re.style.backgroundColor = Me, J = Me;
    });
  }
  function C(H) {
    x && H !== x.state.doc.toString() && x.dispatch({
      changes: {
        from: 0,
        to: x.state.doc.length,
        insert: H
      }
    });
  }
  function T() {
    x && x.requestMeasure({ read: N });
  }
  function M() {
    const H = new Q({
      parent: S,
      state: Z(s)
    });
    return H.dom.addEventListener("focus", L, !0), H.dom.addEventListener("blur", R, !0), H;
  }
  function L() {
    v("focus");
  }
  function R() {
    v("blur");
  }
  function N(H) {
    let fe = H.dom.querySelectorAll(".cm-gutter"), J = u + 1, re = yv(H);
    if (!re)
      return null;
    for (var ae = 0; ae < fe.length; ae++) {
      let de = fe[ae];
      de.style.minHeight = `calc(${re} * ${J})`;
    }
    return A(S), null;
  }
  function W(H) {
    if (H.docChanged) {
      const J = H.state.doc.toString();
      t(2, s = J), v("change", J);
    }
    x.requestMeasure({ read: N });
  }
  function q() {
    return [
      ...oe(o, f, g, m, k),
      he,
      ...ve(),
      ...h
    ];
  }
  const he = Q.theme({
    "&": {
      fontSize: "var(--text-sm)",
      backgroundColor: "var(--border-color-secondary)"
    },
    ".cm-content": {
      paddingTop: "5px",
      paddingBottom: "5px",
      color: "var(--body-text-color)",
      fontFamily: "var(--font-mono)",
      minHeight: "100%"
    },
    ".cm-gutters": {
      marginRight: "1px",
      borderRight: "1px solid var(--border-color-primary)",
      backgroundColor: "transparent",
      color: "var(--body-text-color-subdued)"
    },
    ".cm-focused": { outline: "none" },
    ".cm-scroller": { height: "auto" },
    ".cm-cursor": {
      borderLeftColor: "var(--body-text-color)"
    }
  });
  function Z(H) {
    return Se.create({
      doc: H ?? void 0,
      extensions: q()
    });
  }
  function oe(H, fe, J, re, ae) {
    const de = [
      Q.editable.of(!re),
      Se.readOnly.of(re),
      Q.contentAttributes.of({ "aria-label": "Code input container" })
    ];
    return H && de.push(ov), fe && de.push(oa.of([Ib])), J && de.push(q6(J)), ae && de.push(ae), de.push(Q.updateListener.of(W)), de;
  }
  function ve() {
    const H = [];
    return l ? H.push(jb) : H.push(e9), H;
  }
  function _e() {
    x?.dispatch({
      effects: ye.reconfigure.of(q())
    });
  }
  bv(() => (x = M(), () => x?.destroy()));
  function pe(H) {
    fv[H ? "unshift" : "push"](() => {
      S = H, t(1, S);
    });
  }
  return n.$$set = (H) => {
    "classNames" in H && t(0, i = H.classNames), "value" in H && t(2, s = H.value), "dark_mode" in H && t(3, l = H.dark_mode), "basic" in H && t(4, o = H.basic), "language" in H && t(5, a = H.language), "lines" in H && t(6, u = H.lines), "extensions" in H && t(7, h = H.extensions), "highlights" in H && t(8, c = H.highlights), "useTab" in H && t(9, f = H.useTab), "readonly" in H && t(10, m = H.readonly), "placeholder" in H && t(11, g = H.placeholder);
  }, n.$$.update = () => {
    n.$$.dirty[0] & /*language*/
    32 && y(a), n.$$.dirty[0] & /*lang_extension*/
    4096 && _e(), n.$$.dirty[0] & /*value*/
    4 && C(s);
  }, T(), [
    i,
    S,
    s,
    l,
    o,
    a,
    u,
    h,
    c,
    f,
    m,
    g,
    k,
    pe
  ];
}
let kv = class extends hv {
  constructor(e) {
    super(), dv(
      this,
      e,
      wv,
      vv,
      pv,
      {
        classNames: 0,
        value: 2,
        dark_mode: 3,
        basic: 4,
        language: 5,
        lines: 6,
        extensions: 7,
        highlights: 8,
        useTab: 9,
        readonly: 10,
        placeholder: 11
      },
      null,
      [-1, -1]
    );
  }
};
function wo() {
}
const xv = (n) => n;
function Sv(n, e) {
  return n != n ? e == e : n !== e || n && typeof n == "object" || typeof n == "function";
}
const B4 = typeof window < "u";
let qd = B4 ? () => window.performance.now() : () => Date.now(), O4 = B4 ? (n) => requestAnimationFrame(n) : wo;
const Vi = /* @__PURE__ */ new Set();
function R4(n) {
  Vi.forEach((e) => {
    e.c(n) || (Vi.delete(e), e.f());
  }), Vi.size !== 0 && O4(R4);
}
function Av(n) {
  let e;
  return Vi.size === 0 && O4(R4), {
    promise: new Promise((t) => {
      Vi.add(e = { c: n, f: t });
    }),
    abort() {
      Vi.delete(e);
    }
  };
}
function Vo(n, { delay: e = 0, duration: t = 400, easing: r = xv } = {}) {
  const i = +getComputedStyle(n).opacity;
  return {
    delay: e,
    duration: t,
    easing: r,
    css: (s) => `opacity: ${s * i}`
  };
}
const Ci = [];
function Dv(n, e = wo) {
  let t;
  const r = /* @__PURE__ */ new Set();
  function i(o) {
    if (Sv(n, o) && (n = o, t)) {
      const a = !Ci.length;
      for (const u of r)
        u[1](), Ci.push(u, n);
      if (a) {
        for (let u = 0; u < Ci.length; u += 2)
          Ci[u][0](Ci[u + 1]);
        Ci.length = 0;
      }
    }
  }
  function s(o) {
    i(o(n));
  }
  function l(o, a = wo) {
    const u = [o, a];
    return r.add(u), r.size === 1 && (t = e(i, s) || wo), o(n), () => {
      r.delete(u), r.size === 0 && t && (t(), t = null);
    };
  }
  return { set: i, update: s, subscribe: l };
}
function Vd(n) {
  return Object.prototype.toString.call(n) === "[object Date]";
}
function zu(n, e, t, r) {
  if (typeof t == "number" || Vd(t)) {
    const i = r - t, s = (t - e) / (n.dt || 1 / 60), l = n.opts.stiffness * i, o = n.opts.damping * s, a = (l - o) * n.inv_mass, u = (s + a) * n.dt;
    return Math.abs(u) < n.opts.precision && Math.abs(i) < n.opts.precision ? r : (n.settled = !1, Vd(t) ? new Date(t.getTime() + u) : t + u);
  } else {
    if (Array.isArray(t))
      return t.map(
        (i, s) => zu(n, e[s], t[s], r[s])
      );
    if (typeof t == "object") {
      const i = {};
      for (const s in t)
        i[s] = zu(n, e[s], t[s], r[s]);
      return i;
    } else
      throw new Error(`Cannot spring ${typeof t} values`);
  }
}
function Wd(n, e = {}) {
  const t = Dv(n), { stiffness: r = 0.15, damping: i = 0.8, precision: s = 0.01 } = e;
  let l, o, a, u = n, h = n, c = 1, f = 0, m = !1;
  function g(k, S = {}) {
    h = k;
    const x = a = {};
    return n == null || S.hard || v.stiffness >= 1 && v.damping >= 1 ? (m = !0, l = qd(), u = k, t.set(n = h), Promise.resolve()) : (S.soft && (f = 1 / ((S.soft === !0 ? 0.5 : +S.soft) * 60), c = 0), o || (l = qd(), m = !1, o = Av((y) => {
      if (m)
        return m = !1, o = null, !1;
      c = Math.min(c + f, 1);
      const A = {
        inv_mass: c,
        opts: v,
        settled: !0,
        dt: (y - l) * 60 / 1e3
      }, C = zu(A, u, n, h);
      return l = y, u = n, t.set(n = C), A.settled && (o = null), !A.settled;
    })), new Promise((y) => {
      o.promise.then(() => {
        x === a && y();
      });
    }));
  }
  const v = {
    set: g,
    update: (k, S) => g(k(h, n), S),
    subscribe: t.subscribe,
    stiffness: r,
    damping: i,
    precision: s
  };
  return v;
}
const {
  SvelteComponent: Cv,
  append_hydration: _v,
  attr: ln,
  children: Ud,
  claim_svg_element: Gd,
  detach: a0,
  init: Mv,
  insert_hydration: Tv,
  noop: u0,
  safe_not_equal: Ev,
  svg_element: jd
} = window.__gradio__svelte__internal;
function Fv(n) {
  let e, t;
  return {
    c() {
      e = jd("svg"), t = jd("polyline"), this.h();
    },
    l(r) {
      e = Gd(r, "svg", {
        xmlns: !0,
        viewBox: !0,
        fill: !0,
        stroke: !0,
        "aria-hidden": !0,
        "stroke-width": !0,
        "stroke-linecap": !0,
        "stroke-linejoin": !0
      });
      var i = Ud(e);
      t = Gd(i, "polyline", { points: !0 }), Ud(t).forEach(a0), i.forEach(a0), this.h();
    },
    h() {
      ln(t, "points", "20 6 9 17 4 12"), ln(e, "xmlns", "http://www.w3.org/2000/svg"), ln(e, "viewBox", "2 0 20 20"), ln(e, "fill", "none"), ln(e, "stroke", "currentColor"), ln(e, "aria-hidden", "true"), ln(e, "stroke-width", "1.5"), ln(e, "stroke-linecap", "round"), ln(e, "stroke-linejoin", "round");
    },
    m(r, i) {
      Tv(r, e, i), _v(e, t);
    },
    p: u0,
    i: u0,
    o: u0,
    d(r) {
      r && a0(e);
    }
  };
}
class L4 extends Cv {
  constructor(e) {
    super(), Mv(this, e, null, Fv, Ev, {});
  }
}
const {
  SvelteComponent: Bv,
  append_hydration: h0,
  attr: fr,
  children: jl,
  claim_svg_element: $l,
  detach: ws,
  init: Ov,
  insert_hydration: Rv,
  noop: c0,
  safe_not_equal: Lv,
  set_style: Br,
  svg_element: Yl
} = window.__gradio__svelte__internal;
function Nv(n) {
  let e, t, r, i;
  return {
    c() {
      e = Yl("svg"), t = Yl("g"), r = Yl("path"), i = Yl("path"), this.h();
    },
    l(s) {
      e = $l(s, "svg", {
        width: !0,
        height: !0,
        viewBox: !0,
        version: !0,
        xmlns: !0,
        "xmlns:xlink": !0,
        "xml:space": !0,
        stroke: !0,
        style: !0
      });
      var l = jl(e);
      t = $l(l, "g", { transform: !0 });
      var o = jl(t);
      r = $l(o, "path", { d: !0, style: !0 }), jl(r).forEach(ws), o.forEach(ws), i = $l(l, "path", { d: !0, style: !0 }), jl(i).forEach(ws), l.forEach(ws), this.h();
    },
    h() {
      fr(r, "d", "M18,6L6.087,17.913"), Br(r, "fill", "none"), Br(r, "fill-rule", "nonzero"), Br(r, "stroke-width", "2px"), fr(t, "transform", "matrix(1.14096,-0.140958,-0.140958,1.14096,-0.0559523,0.0559523)"), fr(i, "d", "M4.364,4.364L19.636,19.636"), Br(i, "fill", "none"), Br(i, "fill-rule", "nonzero"), Br(i, "stroke-width", "2px"), fr(e, "width", "100%"), fr(e, "height", "100%"), fr(e, "viewBox", "0 0 24 24"), fr(e, "version", "1.1"), fr(e, "xmlns", "http://www.w3.org/2000/svg"), fr(e, "xmlns:xlink", "http://www.w3.org/1999/xlink"), fr(e, "xml:space", "preserve"), fr(e, "stroke", "currentColor"), Br(e, "fill-rule", "evenodd"), Br(e, "clip-rule", "evenodd"), Br(e, "stroke-linecap", "round"), Br(e, "stroke-linejoin", "round");
    },
    m(s, l) {
      Rv(s, e, l), h0(e, t), h0(t, r), h0(e, i);
    },
    p: c0,
    i: c0,
    o: c0,
    d(s) {
      s && ws(e);
    }
  };
}
class Iv extends Bv {
  constructor(e) {
    super(), Ov(this, e, null, Nv, Lv, {});
  }
}
const {
  SvelteComponent: zv,
  append_hydration: Pv,
  attr: ks,
  children: $d,
  claim_svg_element: Yd,
  detach: f0,
  init: Hv,
  insert_hydration: qv,
  noop: d0,
  safe_not_equal: Vv,
  svg_element: Kd
} = window.__gradio__svelte__internal;
function Wv(n) {
  let e, t;
  return {
    c() {
      e = Kd("svg"), t = Kd("path"), this.h();
    },
    l(r) {
      e = Yd(r, "svg", { width: !0, height: !0, viewBox: !0 });
      var i = $d(e);
      t = Yd(i, "path", { fill: !0, d: !0 }), $d(t).forEach(f0), i.forEach(f0), this.h();
    },
    h() {
      ks(t, "fill", "currentColor"), ks(t, "d", "m31 16l-7 7l-1.41-1.41L28.17 16l-5.58-5.59L24 9l7 7zM1 16l7-7l1.41 1.41L3.83 16l5.58 5.59L8 23l-7-7zm11.42 9.484L17.64 6l1.932.517L14.352 26z"), ks(e, "width", "100%"), ks(e, "height", "100%"), ks(e, "viewBox", "0 0 32 32");
    },
    m(r, i) {
      qv(r, e, i), Pv(e, t);
    },
    p: d0,
    i: d0,
    o: d0,
    d(r) {
      r && f0(e);
    }
  };
}
class N4 extends zv {
  constructor(e) {
    super(), Hv(this, e, null, Wv, Vv, {});
  }
}
const {
  SvelteComponent: Uv,
  append_hydration: Xd,
  attr: wn,
  children: m0,
  claim_svg_element: p0,
  detach: Kl,
  init: Gv,
  insert_hydration: jv,
  noop: g0,
  safe_not_equal: $v,
  svg_element: b0
} = window.__gradio__svelte__internal;
function Yv(n) {
  let e, t, r;
  return {
    c() {
      e = b0("svg"), t = b0("path"), r = b0("path"), this.h();
    },
    l(i) {
      e = p0(i, "svg", {
        xmlns: !0,
        viewBox: !0,
        color: !0,
        "aria-hidden": !0
      });
      var s = m0(e);
      t = p0(s, "path", { fill: !0, d: !0 }), m0(t).forEach(Kl), r = p0(s, "path", { fill: !0, d: !0 }), m0(r).forEach(Kl), s.forEach(Kl), this.h();
    },
    h() {
      wn(t, "fill", "currentColor"), wn(t, "d", "M28 10v18H10V10h18m0-2H10a2 2 0 0 0-2 2v18a2 2 0 0 0 2 2h18a2 2 0 0 0 2-2V10a2 2 0 0 0-2-2Z"), wn(r, "fill", "currentColor"), wn(r, "d", "M4 18H2V4a2 2 0 0 1 2-2h14v2H4Z"), wn(e, "xmlns", "http://www.w3.org/2000/svg"), wn(e, "viewBox", "0 0 33 33"), wn(e, "color", "currentColor"), wn(e, "aria-hidden", "true");
    },
    m(i, s) {
      jv(i, e, s), Xd(e, t), Xd(e, r);
    },
    p: g0,
    i: g0,
    o: g0,
    d(i) {
      i && Kl(e);
    }
  };
}
class Kv extends Uv {
  constructor(e) {
    super(), Gv(this, e, null, Yv, $v, {});
  }
}
const {
  SvelteComponent: Xv,
  append_hydration: Zv,
  attr: _i,
  children: Zd,
  claim_svg_element: Jd,
  detach: v0,
  init: Jv,
  insert_hydration: Qv,
  noop: y0,
  safe_not_equal: ey,
  svg_element: Qd
} = window.__gradio__svelte__internal;
function ty(n) {
  let e, t;
  return {
    c() {
      e = Qd("svg"), t = Qd("path"), this.h();
    },
    l(r) {
      e = Jd(r, "svg", {
        xmlns: !0,
        width: !0,
        height: !0,
        viewBox: !0
      });
      var i = Zd(e);
      t = Jd(i, "path", { fill: !0, d: !0 }), Zd(t).forEach(v0), i.forEach(v0), this.h();
    },
    h() {
      _i(t, "fill", "currentColor"), _i(t, "d", "M26 24v4H6v-4H4v4a2 2 0 0 0 2 2h20a2 2 0 0 0 2-2v-4zm0-10l-1.41-1.41L17 20.17V2h-2v18.17l-7.59-7.58L6 14l10 10l10-10z"), _i(e, "xmlns", "http://www.w3.org/2000/svg"), _i(e, "width", "100%"), _i(e, "height", "100%"), _i(e, "viewBox", "0 0 32 32");
    },
    m(r, i) {
      Qv(r, e, i), Zv(e, t);
    },
    p: y0,
    i: y0,
    o: y0,
    d(r) {
      r && v0(e);
    }
  };
}
class ry extends Xv {
  constructor(e) {
    super(), Jv(this, e, null, ty, ey, {});
  }
}
const {
  SvelteComponent: ny,
  add_render_callback: iy,
  append_hydration: sy,
  attr: ei,
  check_outros: ly,
  children: I4,
  claim_component: z4,
  claim_element: P4,
  claim_space: oy,
  create_bidirectional_transition: e1,
  create_component: H4,
  destroy_component: q4,
  detach: Wo,
  element: V4,
  group_outros: ay,
  init: uy,
  insert_hydration: W4,
  listen: hy,
  mount_component: U4,
  safe_not_equal: cy,
  space: fy,
  toggle_class: t1,
  transition_in: Bs,
  transition_out: ko
} = window.__gradio__svelte__internal, { onDestroy: dy } = window.__gradio__svelte__internal;
function r1(n) {
  let e, t, r, i;
  return t = new L4({}), {
    c() {
      e = V4("span"), H4(t.$$.fragment), this.h();
    },
    l(s) {
      e = P4(s, "SPAN", {
        class: !0,
        "aria-roledescription": !0,
        "aria-label": !0
      });
      var l = I4(e);
      z4(t.$$.fragment, l), l.forEach(Wo), this.h();
    },
    h() {
      ei(e, "class", "check svelte-qjb524"), ei(e, "aria-roledescription", "Value copied"), ei(e, "aria-label", "Copied");
    },
    m(s, l) {
      W4(s, e, l), U4(t, e, null), i = !0;
    },
    i(s) {
      i || (Bs(t.$$.fragment, s), s && iy(() => {
        i && (r || (r = e1(e, Vo, {}, !0)), r.run(1));
      }), i = !0);
    },
    o(s) {
      ko(t.$$.fragment, s), s && (r || (r = e1(e, Vo, {}, !1)), r.run(0)), i = !1;
    },
    d(s) {
      s && Wo(e), q4(t), s && r && r.end();
    }
  };
}
function my(n) {
  let e, t, r, i, s, l;
  t = new Kv({});
  let o = (
    /*copied*/
    n[0] && r1()
  );
  return {
    c() {
      e = V4("button"), H4(t.$$.fragment), r = fy(), o && o.c(), this.h();
    },
    l(a) {
      e = P4(a, "BUTTON", {
        title: !0,
        "aria-roledescription": !0,
        "aria-label": !0,
        class: !0
      });
      var u = I4(e);
      z4(t.$$.fragment, u), r = oy(u), o && o.l(u), u.forEach(Wo), this.h();
    },
    h() {
      ei(e, "title", "copy"), ei(e, "aria-roledescription", "Copy value"), ei(e, "aria-label", "Copy"), ei(e, "class", "svelte-qjb524"), t1(
        e,
        "copied",
        /*copied*/
        n[0]
      );
    },
    m(a, u) {
      W4(a, e, u), U4(t, e, null), sy(e, r), o && o.m(e, null), i = !0, s || (l = hy(
        e,
        "click",
        /*handle_copy*/
        n[1]
      ), s = !0);
    },
    p(a, [u]) {
      /*copied*/
      a[0] ? o ? u & /*copied*/
      1 && Bs(o, 1) : (o = r1(), o.c(), Bs(o, 1), o.m(e, null)) : o && (ay(), ko(o, 1, 1, () => {
        o = null;
      }), ly()), (!i || u & /*copied*/
      1) && t1(
        e,
        "copied",
        /*copied*/
        a[0]
      );
    },
    i(a) {
      i || (Bs(t.$$.fragment, a), Bs(o), i = !0);
    },
    o(a) {
      ko(t.$$.fragment, a), ko(o), i = !1;
    },
    d(a) {
      a && Wo(e), q4(t), o && o.d(), s = !1, l();
    }
  };
}
function py(n, e, t) {
  var r = this && this.__awaiter || function(u, h, c, f) {
    function m(g) {
      return g instanceof c ? g : new c(function(v) {
        v(g);
      });
    }
    return new (c || (c = Promise))(function(g, v) {
      function k(y) {
        try {
          x(f.next(y));
        } catch (A) {
          v(A);
        }
      }
      function S(y) {
        try {
          x(f.throw(y));
        } catch (A) {
          v(A);
        }
      }
      function x(y) {
        y.done ? g(y.value) : m(y.value).then(k, S);
      }
      x((f = f.apply(u, h || [])).next());
    });
  };
  let i = !1, { value: s } = e, l;
  function o() {
    t(0, i = !0), l && clearTimeout(l), l = setTimeout(
      () => {
        t(0, i = !1);
      },
      2e3
    );
  }
  function a() {
    return r(this, void 0, void 0, function* () {
      "clipboard" in navigator && (yield navigator.clipboard.writeText(s), o());
    });
  }
  return dy(() => {
    l && clearTimeout(l);
  }), n.$$set = (u) => {
    "value" in u && t(2, s = u.value);
  }, [i, a, s];
}
class gy extends ny {
  constructor(e) {
    super(), uy(this, e, py, my, cy, { value: 2 });
  }
}
const { setContext: qD, getContext: by } = window.__gradio__svelte__internal, vy = "WORKER_PROXY_CONTEXT_KEY";
function yy() {
  return by(vy);
}
const wy = "lite.local";
function ky(n) {
  return n.host === window.location.host || n.host === "localhost:7860" || n.host === "127.0.0.1:7860" || // Ref: https://github.com/gradio-app/gradio/blob/v3.32.0/js/app/src/Index.svelte#L194
  n.host === wy;
}
function xy(n, e) {
  const t = e.toLowerCase();
  for (const [r, i] of Object.entries(n))
    if (r.toLowerCase() === t)
      return i;
}
function Sy(n) {
  const e = typeof window < "u";
  if (n == null || !e)
    return !1;
  const t = new URL(n, window.location.href);
  return !(!ky(t) || t.protocol !== "http:" && t.protocol !== "https:");
}
const {
  SvelteComponent: Ay,
  assign: Uo,
  check_outros: G4,
  children: j4,
  claim_element: $4,
  compute_rest_props: n1,
  create_slot: Ih,
  detach: Ji,
  element: Y4,
  empty: Go,
  exclude_internal_props: Dy,
  get_all_dirty_from_scope: zh,
  get_slot_changes: Ph,
  get_spread_update: K4,
  group_outros: X4,
  init: Cy,
  insert_hydration: ba,
  listen: Z4,
  prevent_default: _y,
  safe_not_equal: My,
  set_attributes: jo,
  set_style: i1,
  toggle_class: $o,
  transition_in: ui,
  transition_out: hi,
  update_slot_base: Hh
} = window.__gradio__svelte__internal, { createEventDispatcher: Ty } = window.__gradio__svelte__internal;
function Ey(n) {
  let e, t, r, i, s;
  const l = (
    /*#slots*/
    n[8].default
  ), o = Ih(
    l,
    n,
    /*$$scope*/
    n[7],
    null
  );
  let a = [
    { class: "download-link" },
    { href: (
      /*href*/
      n[0]
    ) },
    {
      target: t = typeof window < "u" && window.__is_colab__ ? "_blank" : null
    },
    { rel: "noopener noreferrer" },
    { download: (
      /*download*/
      n[1]
    ) },
    /*$$restProps*/
    n[6]
  ], u = {};
  for (let h = 0; h < a.length; h += 1)
    u = Uo(u, a[h]);
  return {
    c() {
      e = Y4("a"), o && o.c(), this.h();
    },
    l(h) {
      e = $4(h, "A", {
        class: !0,
        href: !0,
        target: !0,
        rel: !0,
        download: !0
      });
      var c = j4(e);
      o && o.l(c), c.forEach(Ji), this.h();
    },
    h() {
      jo(e, u), i1(e, "position", "relative"), $o(e, "svelte-151nsdd", !0);
    },
    m(h, c) {
      ba(h, e, c), o && o.m(e, null), r = !0, i || (s = Z4(
        e,
        "click",
        /*dispatch*/
        n[3].bind(null, "click")
      ), i = !0);
    },
    p(h, c) {
      o && o.p && (!r || c & /*$$scope*/
      128) && Hh(
        o,
        l,
        h,
        /*$$scope*/
        h[7],
        r ? Ph(
          l,
          /*$$scope*/
          h[7],
          c,
          null
        ) : zh(
          /*$$scope*/
          h[7]
        ),
        null
      ), jo(e, u = K4(a, [
        { class: "download-link" },
        (!r || c & /*href*/
        1) && { href: (
          /*href*/
          h[0]
        ) },
        { target: t },
        { rel: "noopener noreferrer" },
        (!r || c & /*download*/
        2) && { download: (
          /*download*/
          h[1]
        ) },
        c & /*$$restProps*/
        64 && /*$$restProps*/
        h[6]
      ])), i1(e, "position", "relative"), $o(e, "svelte-151nsdd", !0);
    },
    i(h) {
      r || (ui(o, h), r = !0);
    },
    o(h) {
      hi(o, h), r = !1;
    },
    d(h) {
      h && Ji(e), o && o.d(h), i = !1, s();
    }
  };
}
function Fy(n) {
  let e, t, r, i;
  const s = [Oy, By], l = [];
  function o(a, u) {
    return (
      /*is_downloading*/
      a[2] ? 0 : 1
    );
  }
  return e = o(n), t = l[e] = s[e](n), {
    c() {
      t.c(), r = Go();
    },
    l(a) {
      t.l(a), r = Go();
    },
    m(a, u) {
      l[e].m(a, u), ba(a, r, u), i = !0;
    },
    p(a, u) {
      let h = e;
      e = o(a), e === h ? l[e].p(a, u) : (X4(), hi(l[h], 1, 1, () => {
        l[h] = null;
      }), G4(), t = l[e], t ? t.p(a, u) : (t = l[e] = s[e](a), t.c()), ui(t, 1), t.m(r.parentNode, r));
    },
    i(a) {
      i || (ui(t), i = !0);
    },
    o(a) {
      hi(t), i = !1;
    },
    d(a) {
      a && Ji(r), l[e].d(a);
    }
  };
}
function By(n) {
  let e, t, r, i;
  const s = (
    /*#slots*/
    n[8].default
  ), l = Ih(
    s,
    n,
    /*$$scope*/
    n[7],
    null
  );
  let o = [
    /*$$restProps*/
    n[6],
    { href: (
      /*href*/
      n[0]
    ) }
  ], a = {};
  for (let u = 0; u < o.length; u += 1)
    a = Uo(a, o[u]);
  return {
    c() {
      e = Y4("a"), l && l.c(), this.h();
    },
    l(u) {
      e = $4(u, "A", { href: !0 });
      var h = j4(e);
      l && l.l(h), h.forEach(Ji), this.h();
    },
    h() {
      jo(e, a), $o(e, "svelte-151nsdd", !0);
    },
    m(u, h) {
      ba(u, e, h), l && l.m(e, null), t = !0, r || (i = Z4(e, "click", _y(
        /*wasm_click_handler*/
        n[5]
      )), r = !0);
    },
    p(u, h) {
      l && l.p && (!t || h & /*$$scope*/
      128) && Hh(
        l,
        s,
        u,
        /*$$scope*/
        u[7],
        t ? Ph(
          s,
          /*$$scope*/
          u[7],
          h,
          null
        ) : zh(
          /*$$scope*/
          u[7]
        ),
        null
      ), jo(e, a = K4(o, [
        h & /*$$restProps*/
        64 && /*$$restProps*/
        u[6],
        (!t || h & /*href*/
        1) && { href: (
          /*href*/
          u[0]
        ) }
      ])), $o(e, "svelte-151nsdd", !0);
    },
    i(u) {
      t || (ui(l, u), t = !0);
    },
    o(u) {
      hi(l, u), t = !1;
    },
    d(u) {
      u && Ji(e), l && l.d(u), r = !1, i();
    }
  };
}
function Oy(n) {
  let e;
  const t = (
    /*#slots*/
    n[8].default
  ), r = Ih(
    t,
    n,
    /*$$scope*/
    n[7],
    null
  );
  return {
    c() {
      r && r.c();
    },
    l(i) {
      r && r.l(i);
    },
    m(i, s) {
      r && r.m(i, s), e = !0;
    },
    p(i, s) {
      r && r.p && (!e || s & /*$$scope*/
      128) && Hh(
        r,
        t,
        i,
        /*$$scope*/
        i[7],
        e ? Ph(
          t,
          /*$$scope*/
          i[7],
          s,
          null
        ) : zh(
          /*$$scope*/
          i[7]
        ),
        null
      );
    },
    i(i) {
      e || (ui(r, i), e = !0);
    },
    o(i) {
      hi(r, i), e = !1;
    },
    d(i) {
      r && r.d(i);
    }
  };
}
function Ry(n) {
  let e, t, r, i, s;
  const l = [Fy, Ey], o = [];
  function a(u, h) {
    return h & /*href*/
    1 && (e = null), e == null && (e = !!/*worker_proxy*/
    (u[4] && Sy(
      /*href*/
      u[0]
    ))), e ? 0 : 1;
  }
  return t = a(n, -1), r = o[t] = l[t](n), {
    c() {
      r.c(), i = Go();
    },
    l(u) {
      r.l(u), i = Go();
    },
    m(u, h) {
      o[t].m(u, h), ba(u, i, h), s = !0;
    },
    p(u, [h]) {
      let c = t;
      t = a(u, h), t === c ? o[t].p(u, h) : (X4(), hi(o[c], 1, 1, () => {
        o[c] = null;
      }), G4(), r = o[t], r ? r.p(u, h) : (r = o[t] = l[t](u), r.c()), ui(r, 1), r.m(i.parentNode, i));
    },
    i(u) {
      s || (ui(r), s = !0);
    },
    o(u) {
      hi(r), s = !1;
    },
    d(u) {
      u && Ji(i), o[t].d(u);
    }
  };
}
function Ly(n, e, t) {
  const r = ["href", "download"];
  let i = n1(e, r), { $$slots: s = {}, $$scope: l } = e;
  var o = this && this.__awaiter || function(g, v, k, S) {
    function x(y) {
      return y instanceof k ? y : new k(function(A) {
        A(y);
      });
    }
    return new (k || (k = Promise))(function(y, A) {
      function C(L) {
        try {
          M(S.next(L));
        } catch (R) {
          A(R);
        }
      }
      function T(L) {
        try {
          M(S.throw(L));
        } catch (R) {
          A(R);
        }
      }
      function M(L) {
        L.done ? y(L.value) : x(L.value).then(C, T);
      }
      M((S = S.apply(g, v || [])).next());
    });
  };
  let { href: a = void 0 } = e, { download: u } = e;
  const h = Ty();
  let c = !1;
  const f = yy();
  function m() {
    return o(this, void 0, void 0, function* () {
      if (c)
        return;
      if (h("click"), a == null)
        throw new Error("href is not defined.");
      if (f == null)
        throw new Error("Wasm worker proxy is not available.");
      const v = new URL(a, window.location.href).pathname;
      t(2, c = !0), f.httpRequest({
        method: "GET",
        path: v,
        headers: {},
        query_string: ""
      }).then((k) => {
        if (k.status !== 200)
          throw new Error(`Failed to get file ${v} from the Wasm worker.`);
        const S = new Blob(
          [k.body],
          {
            type: xy(k.headers, "content-type")
          }
        ), x = URL.createObjectURL(S), y = document.createElement("a");
        y.href = x, y.download = u, y.click(), URL.revokeObjectURL(x);
      }).finally(() => {
        t(2, c = !1);
      });
    });
  }
  return n.$$set = (g) => {
    e = Uo(Uo({}, e), Dy(g)), t(6, i = n1(e, r)), "href" in g && t(0, a = g.href), "download" in g && t(1, u = g.download), "$$scope" in g && t(7, l = g.$$scope);
  }, [
    a,
    u,
    c,
    h,
    f,
    m,
    i,
    l,
    s
  ];
}
class Ny extends Ay {
  constructor(e) {
    super(), Cy(this, e, Ly, Ry, My, { href: 0, download: 1 });
  }
}
const {
  SvelteComponent: Iy,
  add_render_callback: zy,
  attr: J4,
  check_outros: Py,
  children: Q4,
  claim_component: qh,
  claim_element: e2,
  claim_space: Hy,
  create_bidirectional_transition: s1,
  create_component: Vh,
  destroy_component: Wh,
  detach: Qi,
  element: t2,
  empty: l1,
  group_outros: qy,
  init: Vy,
  insert_hydration: Yo,
  mount_component: Uh,
  safe_not_equal: Wy,
  space: Uy,
  transition_in: Li,
  transition_out: qs
} = window.__gradio__svelte__internal, { onDestroy: Gy } = window.__gradio__svelte__internal;
function o1(n) {
  let e, t, r, i;
  return t = new L4({}), {
    c() {
      e = t2("span"), Vh(t.$$.fragment), this.h();
    },
    l(s) {
      e = e2(s, "SPAN", { class: !0 });
      var l = Q4(e);
      qh(t.$$.fragment, l), l.forEach(Qi), this.h();
    },
    h() {
      J4(e, "class", "check svelte-peh06t");
    },
    m(s, l) {
      Yo(s, e, l), Uh(t, e, null), i = !0;
    },
    i(s) {
      i || (Li(t.$$.fragment, s), s && zy(() => {
        i && (r || (r = s1(e, Vo, {}, !0)), r.run(1));
      }), i = !0);
    },
    o(s) {
      qs(t.$$.fragment, s), s && (r || (r = s1(e, Vo, {}, !1)), r.run(0)), i = !1;
    },
    d(s) {
      s && Qi(e), Wh(t), s && r && r.end();
    }
  };
}
function jy(n) {
  let e, t, r, i;
  e = new ry({});
  let s = (
    /*copied*/
    n[0] && o1()
  );
  return {
    c() {
      Vh(e.$$.fragment), t = Uy(), s && s.c(), r = l1();
    },
    l(l) {
      qh(e.$$.fragment, l), t = Hy(l), s && s.l(l), r = l1();
    },
    m(l, o) {
      Uh(e, l, o), Yo(l, t, o), s && s.m(l, o), Yo(l, r, o), i = !0;
    },
    p(l, o) {
      /*copied*/
      l[0] ? s ? o & /*copied*/
      1 && Li(s, 1) : (s = o1(), s.c(), Li(s, 1), s.m(r.parentNode, r)) : s && (qy(), qs(s, 1, 1, () => {
        s = null;
      }), Py());
    },
    i(l) {
      i || (Li(e.$$.fragment, l), Li(s), i = !0);
    },
    o(l) {
      qs(e.$$.fragment, l), qs(s), i = !1;
    },
    d(l) {
      l && (Qi(t), Qi(r)), Wh(e, l), s && s.d(l);
    }
  };
}
function $y(n) {
  let e, t, r;
  return t = new Ny({
    props: {
      download: "file." + /*ext*/
      n[2],
      href: (
        /*download_value*/
        n[1]
      ),
      $$slots: { default: [jy] },
      $$scope: { ctx: n }
    }
  }), t.$on(
    "click",
    /*copy_feedback*/
    n[3]
  ), {
    c() {
      e = t2("div"), Vh(t.$$.fragment), this.h();
    },
    l(i) {
      e = e2(i, "DIV", { class: !0 });
      var s = Q4(e);
      qh(t.$$.fragment, s), s.forEach(Qi), this.h();
    },
    h() {
      J4(e, "class", "container svelte-peh06t");
    },
    m(i, s) {
      Yo(i, e, s), Uh(t, e, null), r = !0;
    },
    p(i, [s]) {
      const l = {};
      s & /*ext*/
      4 && (l.download = "file." + /*ext*/
      i[2]), s & /*download_value*/
      2 && (l.href = /*download_value*/
      i[1]), s & /*$$scope, copied*/
      129 && (l.$$scope = { dirty: s, ctx: i }), t.$set(l);
    },
    i(i) {
      r || (Li(t.$$.fragment, i), r = !0);
    },
    o(i) {
      qs(t.$$.fragment, i), r = !1;
    },
    d(i) {
      i && Qi(e), Wh(t);
    }
  };
}
function Yy(n) {
  return {
    py: "py",
    python: "py",
    md: "md",
    markdown: "md",
    json: "json",
    html: "html",
    css: "css",
    js: "js",
    javascript: "js",
    ts: "ts",
    typescript: "ts",
    yaml: "yaml",
    yml: "yml",
    dockerfile: "dockerfile",
    sh: "sh",
    shell: "sh",
    r: "r"
  }[n] || "txt";
}
function Ky(n, e, t) {
  let r, i, { value: s } = e, { language: l } = e, o = !1, a;
  function u() {
    t(0, o = !0), a && clearTimeout(a), a = setTimeout(
      () => {
        t(0, o = !1);
      },
      2e3
    );
  }
  return Gy(() => {
    a && clearTimeout(a);
  }), n.$$set = (h) => {
    "value" in h && t(4, s = h.value), "language" in h && t(5, l = h.language);
  }, n.$$.update = () => {
    n.$$.dirty & /*language*/
    32 && t(2, r = Yy(l)), n.$$.dirty & /*value*/
    16 && t(1, i = URL.createObjectURL(new Blob([s])));
  }, [o, i, r, u, s, l];
}
class Xy extends Iy {
  constructor(e) {
    super(), Vy(this, e, Ky, $y, Wy, { value: 4, language: 5 });
  }
}
const {
  SvelteComponent: Zy,
  append_hydration: Jy,
  attr: Qy,
  children: ew,
  claim_component: a1,
  claim_element: tw,
  claim_space: rw,
  create_component: u1,
  destroy_component: h1,
  detach: c1,
  element: nw,
  init: iw,
  insert_hydration: sw,
  mount_component: f1,
  safe_not_equal: lw,
  space: ow,
  transition_in: d1,
  transition_out: m1
} = window.__gradio__svelte__internal;
function aw(n) {
  let e, t, r, i, s;
  return t = new Xy({
    props: {
      value: (
        /*value*/
        n[0]
      ),
      language: (
        /*language*/
        n[1]
      )
    }
  }), i = new gy({ props: { value: (
    /*value*/
    n[0]
  ) } }), {
    c() {
      e = nw("div"), u1(t.$$.fragment), r = ow(), u1(i.$$.fragment), this.h();
    },
    l(l) {
      e = tw(l, "DIV", { class: !0 });
      var o = ew(e);
      a1(t.$$.fragment, o), r = rw(o), a1(i.$$.fragment, o), o.forEach(c1), this.h();
    },
    h() {
      Qy(e, "class", "svelte-1bqqv16");
    },
    m(l, o) {
      sw(l, e, o), f1(t, e, null), Jy(e, r), f1(i, e, null), s = !0;
    },
    p(l, [o]) {
      const a = {};
      o & /*value*/
      1 && (a.value = /*value*/
      l[0]), o & /*language*/
      2 && (a.language = /*language*/
      l[1]), t.$set(a);
      const u = {};
      o & /*value*/
      1 && (u.value = /*value*/
      l[0]), i.$set(u);
    },
    i(l) {
      s || (d1(t.$$.fragment, l), d1(i.$$.fragment, l), s = !0);
    },
    o(l) {
      m1(t.$$.fragment, l), m1(i.$$.fragment, l), s = !1;
    },
    d(l) {
      l && c1(e), h1(t), h1(i);
    }
  };
}
function uw(n, e, t) {
  let { value: r } = e, { language: i } = e;
  return n.$$set = (s) => {
    "value" in s && t(0, r = s.value), "language" in s && t(1, i = s.language);
  }, [r, i];
}
class hw extends Zy {
  constructor(e) {
    super(), iw(this, e, uw, aw, lw, { value: 0, language: 1 });
  }
}
function Ni(n) {
  let e = ["", "k", "M", "G", "T", "P", "E", "Z"], t = 0;
  for (; n > 1e3 && t < e.length - 1; )
    n /= 1e3, t++;
  let r = e[t];
  return (Number.isInteger(n) ? n : n.toFixed(1)) + r;
}
const {
  SvelteComponent: cw,
  append_hydration: dr,
  attr: xe,
  children: Ut,
  claim_element: fw,
  claim_svg_element: mr,
  component_subscribe: p1,
  detach: Nt,
  element: dw,
  init: mw,
  insert_hydration: pw,
  noop: g1,
  safe_not_equal: gw,
  set_style: Xl,
  svg_element: pr,
  toggle_class: b1
} = window.__gradio__svelte__internal, { onMount: bw } = window.__gradio__svelte__internal;
function vw(n) {
  let e, t, r, i, s, l, o, a, u, h, c, f;
  return {
    c() {
      e = dw("div"), t = pr("svg"), r = pr("g"), i = pr("path"), s = pr("path"), l = pr("path"), o = pr("path"), a = pr("g"), u = pr("path"), h = pr("path"), c = pr("path"), f = pr("path"), this.h();
    },
    l(m) {
      e = fw(m, "DIV", { class: !0 });
      var g = Ut(e);
      t = mr(g, "svg", {
        viewBox: !0,
        fill: !0,
        xmlns: !0,
        class: !0
      });
      var v = Ut(t);
      r = mr(v, "g", { style: !0 });
      var k = Ut(r);
      i = mr(k, "path", {
        d: !0,
        fill: !0,
        "fill-opacity": !0,
        class: !0
      }), Ut(i).forEach(Nt), s = mr(k, "path", { d: !0, fill: !0, class: !0 }), Ut(s).forEach(Nt), l = mr(k, "path", {
        d: !0,
        fill: !0,
        "fill-opacity": !0,
        class: !0
      }), Ut(l).forEach(Nt), o = mr(k, "path", { d: !0, fill: !0, class: !0 }), Ut(o).forEach(Nt), k.forEach(Nt), a = mr(v, "g", { style: !0 });
      var S = Ut(a);
      u = mr(S, "path", {
        d: !0,
        fill: !0,
        "fill-opacity": !0,
        class: !0
      }), Ut(u).forEach(Nt), h = mr(S, "path", { d: !0, fill: !0, class: !0 }), Ut(h).forEach(Nt), c = mr(S, "path", {
        d: !0,
        fill: !0,
        "fill-opacity": !0,
        class: !0
      }), Ut(c).forEach(Nt), f = mr(S, "path", { d: !0, fill: !0, class: !0 }), Ut(f).forEach(Nt), S.forEach(Nt), v.forEach(Nt), g.forEach(Nt), this.h();
    },
    h() {
      xe(i, "d", "M255.926 0.754768L509.702 139.936V221.027L255.926 81.8465V0.754768Z"), xe(i, "fill", "#FF7C00"), xe(i, "fill-opacity", "0.4"), xe(i, "class", "svelte-43sxxs"), xe(s, "d", "M509.69 139.936L254.981 279.641V361.255L509.69 221.55V139.936Z"), xe(s, "fill", "#FF7C00"), xe(s, "class", "svelte-43sxxs"), xe(l, "d", "M0.250138 139.937L254.981 279.641V361.255L0.250138 221.55V139.937Z"), xe(l, "fill", "#FF7C00"), xe(l, "fill-opacity", "0.4"), xe(l, "class", "svelte-43sxxs"), xe(o, "d", "M255.923 0.232622L0.236328 139.936V221.55L255.923 81.8469V0.232622Z"), xe(o, "fill", "#FF7C00"), xe(o, "class", "svelte-43sxxs"), Xl(r, "transform", "translate(" + /*$top*/
      n[1][0] + "px, " + /*$top*/
      n[1][1] + "px)"), xe(u, "d", "M255.926 141.5L509.702 280.681V361.773L255.926 222.592V141.5Z"), xe(u, "fill", "#FF7C00"), xe(u, "fill-opacity", "0.4"), xe(u, "class", "svelte-43sxxs"), xe(h, "d", "M509.69 280.679L254.981 420.384V501.998L509.69 362.293V280.679Z"), xe(h, "fill", "#FF7C00"), xe(h, "class", "svelte-43sxxs"), xe(c, "d", "M0.250138 280.681L254.981 420.386V502L0.250138 362.295V280.681Z"), xe(c, "fill", "#FF7C00"), xe(c, "fill-opacity", "0.4"), xe(c, "class", "svelte-43sxxs"), xe(f, "d", "M255.923 140.977L0.236328 280.68V362.294L255.923 222.591V140.977Z"), xe(f, "fill", "#FF7C00"), xe(f, "class", "svelte-43sxxs"), Xl(a, "transform", "translate(" + /*$bottom*/
      n[2][0] + "px, " + /*$bottom*/
      n[2][1] + "px)"), xe(t, "viewBox", "-1200 -1200 3000 3000"), xe(t, "fill", "none"), xe(t, "xmlns", "http://www.w3.org/2000/svg"), xe(t, "class", "svelte-43sxxs"), xe(e, "class", "svelte-43sxxs"), b1(
        e,
        "margin",
        /*margin*/
        n[0]
      );
    },
    m(m, g) {
      pw(m, e, g), dr(e, t), dr(t, r), dr(r, i), dr(r, s), dr(r, l), dr(r, o), dr(t, a), dr(a, u), dr(a, h), dr(a, c), dr(a, f);
    },
    p(m, [g]) {
      g & /*$top*/
      2 && Xl(r, "transform", "translate(" + /*$top*/
      m[1][0] + "px, " + /*$top*/
      m[1][1] + "px)"), g & /*$bottom*/
      4 && Xl(a, "transform", "translate(" + /*$bottom*/
      m[2][0] + "px, " + /*$bottom*/
      m[2][1] + "px)"), g & /*margin*/
      1 && b1(
        e,
        "margin",
        /*margin*/
        m[0]
      );
    },
    i: g1,
    o: g1,
    d(m) {
      m && Nt(e);
    }
  };
}
function yw(n, e, t) {
  let r, i;
  var s = this && this.__awaiter || function(m, g, v, k) {
    function S(x) {
      return x instanceof v ? x : new v(function(y) {
        y(x);
      });
    }
    return new (v || (v = Promise))(function(x, y) {
      function A(M) {
        try {
          T(k.next(M));
        } catch (L) {
          y(L);
        }
      }
      function C(M) {
        try {
          T(k.throw(M));
        } catch (L) {
          y(L);
        }
      }
      function T(M) {
        M.done ? x(M.value) : S(M.value).then(A, C);
      }
      T((k = k.apply(m, g || [])).next());
    });
  };
  let { margin: l = !0 } = e;
  const o = Wd([0, 0]);
  p1(n, o, (m) => t(1, r = m));
  const a = Wd([0, 0]);
  p1(n, a, (m) => t(2, i = m));
  let u;
  function h() {
    return s(this, void 0, void 0, function* () {
      yield Promise.all([o.set([125, 140]), a.set([-125, -140])]), yield Promise.all([o.set([-125, 140]), a.set([125, -140])]), yield Promise.all([o.set([-125, 0]), a.set([125, -0])]), yield Promise.all([o.set([125, 0]), a.set([-125, 0])]);
    });
  }
  function c() {
    return s(this, void 0, void 0, function* () {
      yield h(), u || c();
    });
  }
  function f() {
    return s(this, void 0, void 0, function* () {
      yield Promise.all([o.set([125, 0]), a.set([-125, 0])]), c();
    });
  }
  return bw(() => (f(), () => u = !0)), n.$$set = (m) => {
    "margin" in m && t(0, l = m.margin);
  }, [l, r, i, o, a];
}
class ww extends cw {
  constructor(e) {
    super(), mw(this, e, yw, vw, gw, { margin: 0 });
  }
}
const {
  SvelteComponent: kw,
  assign: xw,
  children: Sw,
  claim_element: Aw,
  create_slot: Dw,
  detach: v1,
  element: Cw,
  get_all_dirty_from_scope: _w,
  get_slot_changes: Mw,
  get_spread_update: Tw,
  init: Ew,
  insert_hydration: Fw,
  safe_not_equal: Bw,
  set_dynamic_element_data: y1,
  set_style: st,
  toggle_class: Gt,
  transition_in: r2,
  transition_out: n2,
  update_slot_base: Ow
} = window.__gradio__svelte__internal;
function Rw(n) {
  let e, t, r;
  const i = (
    /*#slots*/
    n[22].default
  ), s = Dw(
    i,
    n,
    /*$$scope*/
    n[21],
    null
  );
  let l = [
    { "data-testid": (
      /*test_id*/
      n[10]
    ) },
    { id: (
      /*elem_id*/
      n[5]
    ) },
    {
      class: t = "block " + /*elem_classes*/
      n[6].join(" ") + " svelte-1ezsyiy"
    }
  ], o = {};
  for (let a = 0; a < l.length; a += 1)
    o = xw(o, l[a]);
  return {
    c() {
      e = Cw(
        /*tag*/
        n[18]
      ), s && s.c(), this.h();
    },
    l(a) {
      e = Aw(
        a,
        /*tag*/
        (n[18] || "null").toUpperCase(),
        {
          "data-testid": !0,
          id: !0,
          class: !0
        }
      );
      var u = Sw(e);
      s && s.l(u), u.forEach(v1), this.h();
    },
    h() {
      y1(
        /*tag*/
        n[18]
      )(e, o), Gt(
        e,
        "hidden",
        /*visible*/
        n[13] === !1
      ), Gt(
        e,
        "padded",
        /*padding*/
        n[9]
      ), Gt(
        e,
        "flex",
        /*flex*/
        n[0]
      ), Gt(
        e,
        "border_focus",
        /*border_mode*/
        n[8] === "focus"
      ), Gt(
        e,
        "border_contrast",
        /*border_mode*/
        n[8] === "contrast"
      ), Gt(e, "hide-container", !/*explicit_call*/
      n[11] && !/*container*/
      n[12]), st(
        e,
        "height",
        /*get_dimension*/
        n[19](
          /*height*/
          n[1]
        )
      ), st(
        e,
        "min-height",
        /*get_dimension*/
        n[19](
          /*min_height*/
          n[2]
        )
      ), st(
        e,
        "max-height",
        /*get_dimension*/
        n[19](
          /*max_height*/
          n[3]
        )
      ), st(e, "width", typeof /*width*/
      n[4] == "number" ? `calc(min(${/*width*/
      n[4]}px, 100%))` : (
        /*get_dimension*/
        n[19](
          /*width*/
          n[4]
        )
      )), st(
        e,
        "border-style",
        /*variant*/
        n[7]
      ), st(
        e,
        "overflow",
        /*allow_overflow*/
        n[14] ? (
          /*overflow_behavior*/
          n[15]
        ) : "hidden"
      ), st(
        e,
        "flex-grow",
        /*scale*/
        n[16]
      ), st(e, "min-width", `calc(min(${/*min_width*/
      n[17]}px, 100%))`), st(e, "border-width", "var(--block-border-width)");
    },
    m(a, u) {
      Fw(a, e, u), s && s.m(e, null), r = !0;
    },
    p(a, u) {
      s && s.p && (!r || u & /*$$scope*/
      2097152) && Ow(
        s,
        i,
        a,
        /*$$scope*/
        a[21],
        r ? Mw(
          i,
          /*$$scope*/
          a[21],
          u,
          null
        ) : _w(
          /*$$scope*/
          a[21]
        ),
        null
      ), y1(
        /*tag*/
        a[18]
      )(e, o = Tw(l, [
        (!r || u & /*test_id*/
        1024) && { "data-testid": (
          /*test_id*/
          a[10]
        ) },
        (!r || u & /*elem_id*/
        32) && { id: (
          /*elem_id*/
          a[5]
        ) },
        (!r || u & /*elem_classes*/
        64 && t !== (t = "block " + /*elem_classes*/
        a[6].join(" ") + " svelte-1ezsyiy")) && { class: t }
      ])), Gt(
        e,
        "hidden",
        /*visible*/
        a[13] === !1
      ), Gt(
        e,
        "padded",
        /*padding*/
        a[9]
      ), Gt(
        e,
        "flex",
        /*flex*/
        a[0]
      ), Gt(
        e,
        "border_focus",
        /*border_mode*/
        a[8] === "focus"
      ), Gt(
        e,
        "border_contrast",
        /*border_mode*/
        a[8] === "contrast"
      ), Gt(e, "hide-container", !/*explicit_call*/
      a[11] && !/*container*/
      a[12]), u & /*height*/
      2 && st(
        e,
        "height",
        /*get_dimension*/
        a[19](
          /*height*/
          a[1]
        )
      ), u & /*min_height*/
      4 && st(
        e,
        "min-height",
        /*get_dimension*/
        a[19](
          /*min_height*/
          a[2]
        )
      ), u & /*max_height*/
      8 && st(
        e,
        "max-height",
        /*get_dimension*/
        a[19](
          /*max_height*/
          a[3]
        )
      ), u & /*width*/
      16 && st(e, "width", typeof /*width*/
      a[4] == "number" ? `calc(min(${/*width*/
      a[4]}px, 100%))` : (
        /*get_dimension*/
        a[19](
          /*width*/
          a[4]
        )
      )), u & /*variant*/
      128 && st(
        e,
        "border-style",
        /*variant*/
        a[7]
      ), u & /*allow_overflow, overflow_behavior*/
      49152 && st(
        e,
        "overflow",
        /*allow_overflow*/
        a[14] ? (
          /*overflow_behavior*/
          a[15]
        ) : "hidden"
      ), u & /*scale*/
      65536 && st(
        e,
        "flex-grow",
        /*scale*/
        a[16]
      ), u & /*min_width*/
      131072 && st(e, "min-width", `calc(min(${/*min_width*/
      a[17]}px, 100%))`);
    },
    i(a) {
      r || (r2(s, a), r = !0);
    },
    o(a) {
      n2(s, a), r = !1;
    },
    d(a) {
      a && v1(e), s && s.d(a);
    }
  };
}
function Lw(n) {
  let e, t = (
    /*tag*/
    n[18] && Rw(n)
  );
  return {
    c() {
      t && t.c();
    },
    l(r) {
      t && t.l(r);
    },
    m(r, i) {
      t && t.m(r, i), e = !0;
    },
    p(r, [i]) {
      /*tag*/
      r[18] && t.p(r, i);
    },
    i(r) {
      e || (r2(t, r), e = !0);
    },
    o(r) {
      n2(t, r), e = !1;
    },
    d(r) {
      t && t.d(r);
    }
  };
}
function Nw(n, e, t) {
  let { $$slots: r = {}, $$scope: i } = e, { height: s = void 0 } = e, { min_height: l = void 0 } = e, { max_height: o = void 0 } = e, { width: a = void 0 } = e, { elem_id: u = "" } = e, { elem_classes: h = [] } = e, { variant: c = "solid" } = e, { border_mode: f = "base" } = e, { padding: m = !0 } = e, { type: g = "normal" } = e, { test_id: v = void 0 } = e, { explicit_call: k = !1 } = e, { container: S = !0 } = e, { visible: x = !0 } = e, { allow_overflow: y = !0 } = e, { overflow_behavior: A = "auto" } = e, { scale: C = null } = e, { min_width: T = 0 } = e, { flex: M = !1 } = e;
  x || (M = !1);
  let L = g === "fieldset" ? "fieldset" : "div";
  const R = (N) => {
    if (N !== void 0) {
      if (typeof N == "number")
        return N + "px";
      if (typeof N == "string")
        return N;
    }
  };
  return n.$$set = (N) => {
    "height" in N && t(1, s = N.height), "min_height" in N && t(2, l = N.min_height), "max_height" in N && t(3, o = N.max_height), "width" in N && t(4, a = N.width), "elem_id" in N && t(5, u = N.elem_id), "elem_classes" in N && t(6, h = N.elem_classes), "variant" in N && t(7, c = N.variant), "border_mode" in N && t(8, f = N.border_mode), "padding" in N && t(9, m = N.padding), "type" in N && t(20, g = N.type), "test_id" in N && t(10, v = N.test_id), "explicit_call" in N && t(11, k = N.explicit_call), "container" in N && t(12, S = N.container), "visible" in N && t(13, x = N.visible), "allow_overflow" in N && t(14, y = N.allow_overflow), "overflow_behavior" in N && t(15, A = N.overflow_behavior), "scale" in N && t(16, C = N.scale), "min_width" in N && t(17, T = N.min_width), "flex" in N && t(0, M = N.flex), "$$scope" in N && t(21, i = N.$$scope);
  }, [
    M,
    s,
    l,
    o,
    a,
    u,
    h,
    c,
    f,
    m,
    v,
    k,
    S,
    x,
    y,
    A,
    C,
    T,
    L,
    R,
    g,
    i,
    r
  ];
}
class Iw extends kw {
  constructor(e) {
    super(), Ew(this, e, Nw, Lw, Bw, {
      height: 1,
      min_height: 2,
      max_height: 3,
      width: 4,
      elem_id: 5,
      elem_classes: 6,
      variant: 7,
      border_mode: 8,
      padding: 9,
      type: 20,
      test_id: 10,
      explicit_call: 11,
      container: 12,
      visible: 13,
      allow_overflow: 14,
      overflow_behavior: 15,
      scale: 16,
      min_width: 17,
      flex: 0
    });
  }
}
const zw = [
  { color: "red", primary: 600, secondary: 100 },
  { color: "green", primary: 600, secondary: 100 },
  { color: "blue", primary: 600, secondary: 100 },
  { color: "yellow", primary: 500, secondary: 100 },
  { color: "purple", primary: 600, secondary: 100 },
  { color: "teal", primary: 600, secondary: 100 },
  { color: "orange", primary: 600, secondary: 100 },
  { color: "cyan", primary: 600, secondary: 100 },
  { color: "lime", primary: 500, secondary: 100 },
  { color: "pink", primary: 600, secondary: 100 }
], w1 = {
  inherit: "inherit",
  current: "currentColor",
  transparent: "transparent",
  black: "#000",
  white: "#fff",
  slate: {
    50: "#f8fafc",
    100: "#f1f5f9",
    200: "#e2e8f0",
    300: "#cbd5e1",
    400: "#94a3b8",
    500: "#64748b",
    600: "#475569",
    700: "#334155",
    800: "#1e293b",
    900: "#0f172a",
    950: "#020617"
  },
  gray: {
    50: "#f9fafb",
    100: "#f3f4f6",
    200: "#e5e7eb",
    300: "#d1d5db",
    400: "#9ca3af",
    500: "#6b7280",
    600: "#4b5563",
    700: "#374151",
    800: "#1f2937",
    900: "#111827",
    950: "#030712"
  },
  zinc: {
    50: "#fafafa",
    100: "#f4f4f5",
    200: "#e4e4e7",
    300: "#d4d4d8",
    400: "#a1a1aa",
    500: "#71717a",
    600: "#52525b",
    700: "#3f3f46",
    800: "#27272a",
    900: "#18181b",
    950: "#09090b"
  },
  neutral: {
    50: "#fafafa",
    100: "#f5f5f5",
    200: "#e5e5e5",
    300: "#d4d4d4",
    400: "#a3a3a3",
    500: "#737373",
    600: "#525252",
    700: "#404040",
    800: "#262626",
    900: "#171717",
    950: "#0a0a0a"
  },
  stone: {
    50: "#fafaf9",
    100: "#f5f5f4",
    200: "#e7e5e4",
    300: "#d6d3d1",
    400: "#a8a29e",
    500: "#78716c",
    600: "#57534e",
    700: "#44403c",
    800: "#292524",
    900: "#1c1917",
    950: "#0c0a09"
  },
  red: {
    50: "#fef2f2",
    100: "#fee2e2",
    200: "#fecaca",
    300: "#fca5a5",
    400: "#f87171",
    500: "#ef4444",
    600: "#dc2626",
    700: "#b91c1c",
    800: "#991b1b",
    900: "#7f1d1d",
    950: "#450a0a"
  },
  orange: {
    50: "#fff7ed",
    100: "#ffedd5",
    200: "#fed7aa",
    300: "#fdba74",
    400: "#fb923c",
    500: "#f97316",
    600: "#ea580c",
    700: "#c2410c",
    800: "#9a3412",
    900: "#7c2d12",
    950: "#431407"
  },
  amber: {
    50: "#fffbeb",
    100: "#fef3c7",
    200: "#fde68a",
    300: "#fcd34d",
    400: "#fbbf24",
    500: "#f59e0b",
    600: "#d97706",
    700: "#b45309",
    800: "#92400e",
    900: "#78350f",
    950: "#451a03"
  },
  yellow: {
    50: "#fefce8",
    100: "#fef9c3",
    200: "#fef08a",
    300: "#fde047",
    400: "#facc15",
    500: "#eab308",
    600: "#ca8a04",
    700: "#a16207",
    800: "#854d0e",
    900: "#713f12",
    950: "#422006"
  },
  lime: {
    50: "#f7fee7",
    100: "#ecfccb",
    200: "#d9f99d",
    300: "#bef264",
    400: "#a3e635",
    500: "#84cc16",
    600: "#65a30d",
    700: "#4d7c0f",
    800: "#3f6212",
    900: "#365314",
    950: "#1a2e05"
  },
  green: {
    50: "#f0fdf4",
    100: "#dcfce7",
    200: "#bbf7d0",
    300: "#86efac",
    400: "#4ade80",
    500: "#22c55e",
    600: "#16a34a",
    700: "#15803d",
    800: "#166534",
    900: "#14532d",
    950: "#052e16"
  },
  emerald: {
    50: "#ecfdf5",
    100: "#d1fae5",
    200: "#a7f3d0",
    300: "#6ee7b7",
    400: "#34d399",
    500: "#10b981",
    600: "#059669",
    700: "#047857",
    800: "#065f46",
    900: "#064e3b",
    950: "#022c22"
  },
  teal: {
    50: "#f0fdfa",
    100: "#ccfbf1",
    200: "#99f6e4",
    300: "#5eead4",
    400: "#2dd4bf",
    500: "#14b8a6",
    600: "#0d9488",
    700: "#0f766e",
    800: "#115e59",
    900: "#134e4a",
    950: "#042f2e"
  },
  cyan: {
    50: "#ecfeff",
    100: "#cffafe",
    200: "#a5f3fc",
    300: "#67e8f9",
    400: "#22d3ee",
    500: "#06b6d4",
    600: "#0891b2",
    700: "#0e7490",
    800: "#155e75",
    900: "#164e63",
    950: "#083344"
  },
  sky: {
    50: "#f0f9ff",
    100: "#e0f2fe",
    200: "#bae6fd",
    300: "#7dd3fc",
    400: "#38bdf8",
    500: "#0ea5e9",
    600: "#0284c7",
    700: "#0369a1",
    800: "#075985",
    900: "#0c4a6e",
    950: "#082f49"
  },
  blue: {
    50: "#eff6ff",
    100: "#dbeafe",
    200: "#bfdbfe",
    300: "#93c5fd",
    400: "#60a5fa",
    500: "#3b82f6",
    600: "#2563eb",
    700: "#1d4ed8",
    800: "#1e40af",
    900: "#1e3a8a",
    950: "#172554"
  },
  indigo: {
    50: "#eef2ff",
    100: "#e0e7ff",
    200: "#c7d2fe",
    300: "#a5b4fc",
    400: "#818cf8",
    500: "#6366f1",
    600: "#4f46e5",
    700: "#4338ca",
    800: "#3730a3",
    900: "#312e81",
    950: "#1e1b4b"
  },
  violet: {
    50: "#f5f3ff",
    100: "#ede9fe",
    200: "#ddd6fe",
    300: "#c4b5fd",
    400: "#a78bfa",
    500: "#8b5cf6",
    600: "#7c3aed",
    700: "#6d28d9",
    800: "#5b21b6",
    900: "#4c1d95",
    950: "#2e1065"
  },
  purple: {
    50: "#faf5ff",
    100: "#f3e8ff",
    200: "#e9d5ff",
    300: "#d8b4fe",
    400: "#c084fc",
    500: "#a855f7",
    600: "#9333ea",
    700: "#7e22ce",
    800: "#6b21a8",
    900: "#581c87",
    950: "#3b0764"
  },
  fuchsia: {
    50: "#fdf4ff",
    100: "#fae8ff",
    200: "#f5d0fe",
    300: "#f0abfc",
    400: "#e879f9",
    500: "#d946ef",
    600: "#c026d3",
    700: "#a21caf",
    800: "#86198f",
    900: "#701a75",
    950: "#4a044e"
  },
  pink: {
    50: "#fdf2f8",
    100: "#fce7f3",
    200: "#fbcfe8",
    300: "#f9a8d4",
    400: "#f472b6",
    500: "#ec4899",
    600: "#db2777",
    700: "#be185d",
    800: "#9d174d",
    900: "#831843",
    950: "#500724"
  },
  rose: {
    50: "#fff1f2",
    100: "#ffe4e6",
    200: "#fecdd3",
    300: "#fda4af",
    400: "#fb7185",
    500: "#f43f5e",
    600: "#e11d48",
    700: "#be123c",
    800: "#9f1239",
    900: "#881337",
    950: "#4c0519"
  }
};
zw.reduce(
  (n, { color: e, primary: t, secondary: r }) => ({
    ...n,
    [e]: {
      primary: w1[e][t],
      secondary: w1[e][r]
    }
  }),
  {}
);
class Gh {
  // The + prefix indicates that these fields aren't writeable
  // Lexer holding the input string.
  // Start offset, zero-based inclusive.
  // End offset, zero-based exclusive.
  constructor(e, t, r) {
    this.lexer = void 0, this.start = void 0, this.end = void 0, this.lexer = e, this.start = t, this.end = r;
  }
  /**
   * Merges two `SourceLocation`s from location providers, given they are
   * provided in order of appearance.
   * - Returns the first one's location if only the first is provided.
   * - Returns a merged range of the first and the last if both are provided
   *   and their lexers match.
   * - Otherwise, returns null.
   */
  static range(e, t) {
    return t ? !e || !e.loc || !t.loc || e.loc.lexer !== t.loc.lexer ? null : new Gh(e.loc.lexer, e.loc.start, t.loc.end) : e && e.loc;
  }
}
class jh {
  // don't expand the token
  // used in \noexpand
  constructor(e, t) {
    this.text = void 0, this.loc = void 0, this.noexpand = void 0, this.treatAsRelax = void 0, this.text = e, this.loc = t;
  }
  /**
   * Given a pair of tokens (this and endToken), compute a `Token` encompassing
   * the whole input range enclosed by these two.
   */
  range(e, t) {
    return new jh(t, Gh.range(this, e));
  }
}
class ie {
  // Error start position based on passed-in Token or ParseNode.
  // Length of affected text based on passed-in Token or ParseNode.
  // The underlying error message without any context added.
  constructor(e, t) {
    this.name = void 0, this.position = void 0, this.length = void 0, this.rawMessage = void 0;
    var r = "KaTeX parse error: " + e, i, s, l = t && t.loc;
    if (l && l.start <= l.end) {
      var o = l.lexer.input;
      i = l.start, s = l.end, i === o.length ? r += " at end of input: " : r += " at position " + (i + 1) + ": ";
      var a = o.slice(i, s).replace(/[^]/g, "$&̲"), u;
      i > 15 ? u = "…" + o.slice(i - 15, i) : u = o.slice(0, i);
      var h;
      s + 15 < o.length ? h = o.slice(s, s + 15) + "…" : h = o.slice(s), r += u + a + h;
    }
    var c = new Error(r);
    return c.name = "ParseError", c.__proto__ = ie.prototype, c.position = i, i != null && s != null && (c.length = s - i), c.rawMessage = e, c;
  }
}
ie.prototype.__proto__ = Error.prototype;
var Pw = function(e, t) {
  return e.indexOf(t) !== -1;
}, Hw = function(e, t) {
  return e === void 0 ? t : e;
}, qw = /([A-Z])/g, Vw = function(e) {
  return e.replace(qw, "-$1").toLowerCase();
}, Ww = {
  "&": "&amp;",
  ">": "&gt;",
  "<": "&lt;",
  '"': "&quot;",
  "'": "&#x27;"
}, Uw = /[&><"']/g;
function Gw(n) {
  return String(n).replace(Uw, (e) => Ww[e]);
}
var i2 = function n(e) {
  return e.type === "ordgroup" || e.type === "color" ? e.body.length === 1 ? n(e.body[0]) : e : e.type === "font" ? n(e.body) : e;
}, jw = function(e) {
  var t = i2(e);
  return t.type === "mathord" || t.type === "textord" || t.type === "atom";
}, $w = function(e) {
  if (!e)
    throw new Error("Expected non-null, but got " + String(e));
  return e;
}, Yw = function(e) {
  var t = /^[\x00-\x20]*([^\\/#?]*?)(:|&#0*58|&#x0*3a|&colon)/i.exec(e);
  return t ? t[2] !== ":" || !/^[a-zA-Z][a-zA-Z0-9+\-.]*$/.test(t[1]) ? null : t[1].toLowerCase() : "_relative";
}, le = {
  contains: Pw,
  deflt: Hw,
  escape: Gw,
  hyphenate: Vw,
  getBaseElem: i2,
  isCharacterBox: jw,
  protocolFromUrl: Yw
};
class kn {
  constructor(e, t, r) {
    this.id = void 0, this.size = void 0, this.cramped = void 0, this.id = e, this.size = t, this.cramped = r;
  }
  /**
   * Get the style of a superscript given a base in the current style.
   */
  sup() {
    return Lr[Kw[this.id]];
  }
  /**
   * Get the style of a subscript given a base in the current style.
   */
  sub() {
    return Lr[Xw[this.id]];
  }
  /**
   * Get the style of a fraction numerator given the fraction in the current
   * style.
   */
  fracNum() {
    return Lr[Zw[this.id]];
  }
  /**
   * Get the style of a fraction denominator given the fraction in the current
   * style.
   */
  fracDen() {
    return Lr[Jw[this.id]];
  }
  /**
   * Get the cramped version of a style (in particular, cramping a cramped style
   * doesn't change the style).
   */
  cramp() {
    return Lr[Qw[this.id]];
  }
  /**
   * Get a text or display version of this style.
   */
  text() {
    return Lr[ek[this.id]];
  }
  /**
   * Return true if this style is tightly spaced (scriptstyle/scriptscriptstyle)
   */
  isTight() {
    return this.size >= 2;
  }
}
var $h = 0, Ko = 1, Wi = 2, mn = 3, ll = 4, er = 5, es = 6, xt = 7, Lr = [new kn($h, 0, !1), new kn(Ko, 0, !0), new kn(Wi, 1, !1), new kn(mn, 1, !0), new kn(ll, 2, !1), new kn(er, 2, !0), new kn(es, 3, !1), new kn(xt, 3, !0)], Kw = [ll, er, ll, er, es, xt, es, xt], Xw = [er, er, er, er, xt, xt, xt, xt], Zw = [Wi, mn, ll, er, es, xt, es, xt], Jw = [mn, mn, er, er, xt, xt, xt, xt], Qw = [Ko, Ko, mn, mn, er, er, xt, xt], ek = [$h, Ko, Wi, mn, Wi, mn, Wi, mn], ue = {
  DISPLAY: Lr[$h],
  TEXT: Lr[Wi],
  SCRIPT: Lr[ll],
  SCRIPTSCRIPT: Lr[es]
}, Pu = [{
  // Latin characters beyond the Latin-1 characters we have metrics for.
  // Needed for Czech, Hungarian and Turkish text, for example.
  name: "latin",
  blocks: [
    [256, 591],
    // Latin Extended-A and Latin Extended-B
    [768, 879]
    // Combining Diacritical marks
  ]
}, {
  // The Cyrillic script used by Russian and related languages.
  // A Cyrillic subset used to be supported as explicitly defined
  // symbols in symbols.js
  name: "cyrillic",
  blocks: [[1024, 1279]]
}, {
  // Armenian
  name: "armenian",
  blocks: [[1328, 1423]]
}, {
  // The Brahmic scripts of South and Southeast Asia
  // Devanagari (0900–097F)
  // Bengali (0980–09FF)
  // Gurmukhi (0A00–0A7F)
  // Gujarati (0A80–0AFF)
  // Oriya (0B00–0B7F)
  // Tamil (0B80–0BFF)
  // Telugu (0C00–0C7F)
  // Kannada (0C80–0CFF)
  // Malayalam (0D00–0D7F)
  // Sinhala (0D80–0DFF)
  // Thai (0E00–0E7F)
  // Lao (0E80–0EFF)
  // Tibetan (0F00–0FFF)
  // Myanmar (1000–109F)
  name: "brahmic",
  blocks: [[2304, 4255]]
}, {
  name: "georgian",
  blocks: [[4256, 4351]]
}, {
  // Chinese and Japanese.
  // The "k" in cjk is for Korean, but we've separated Korean out
  name: "cjk",
  blocks: [
    [12288, 12543],
    // CJK symbols and punctuation, Hiragana, Katakana
    [19968, 40879],
    // CJK ideograms
    [65280, 65376]
    // Fullwidth punctuation
    // TODO: add halfwidth Katakana and Romanji glyphs
  ]
}, {
  // Korean
  name: "hangul",
  blocks: [[44032, 55215]]
}];
function tk(n) {
  for (var e = 0; e < Pu.length; e++)
    for (var t = Pu[e], r = 0; r < t.blocks.length; r++) {
      var i = t.blocks[r];
      if (n >= i[0] && n <= i[1])
        return t.name;
    }
  return null;
}
var xo = [];
Pu.forEach((n) => n.blocks.forEach((e) => xo.push(...e)));
function rk(n) {
  for (var e = 0; e < xo.length; e += 2)
    if (n >= xo[e] && n <= xo[e + 1])
      return !0;
  return !1;
}
var Mi = 80, nk = function(e, t) {
  return "M95," + (622 + e + t) + `
c-2.7,0,-7.17,-2.7,-13.5,-8c-5.8,-5.3,-9.5,-10,-9.5,-14
c0,-2,0.3,-3.3,1,-4c1.3,-2.7,23.83,-20.7,67.5,-54
c44.2,-33.3,65.8,-50.3,66.5,-51c1.3,-1.3,3,-2,5,-2c4.7,0,8.7,3.3,12,10
s173,378,173,378c0.7,0,35.3,-71,104,-213c68.7,-142,137.5,-285,206.5,-429
c69,-144,104.5,-217.7,106.5,-221
l` + e / 2.075 + " -" + e + `
c5.3,-9.3,12,-14,20,-14
H400000v` + (40 + e) + `H845.2724
s-225.272,467,-225.272,467s-235,486,-235,486c-2.7,4.7,-9,7,-19,7
c-6,0,-10,-1,-12,-3s-194,-422,-194,-422s-65,47,-65,47z
M` + (834 + e) + " " + t + "h400000v" + (40 + e) + "h-400000z";
}, ik = function(e, t) {
  return "M263," + (601 + e + t) + `c0.7,0,18,39.7,52,119
c34,79.3,68.167,158.7,102.5,238c34.3,79.3,51.8,119.3,52.5,120
c340,-704.7,510.7,-1060.3,512,-1067
l` + e / 2.084 + " -" + e + `
c4.7,-7.3,11,-11,19,-11
H40000v` + (40 + e) + `H1012.3
s-271.3,567,-271.3,567c-38.7,80.7,-84,175,-136,283c-52,108,-89.167,185.3,-111.5,232
c-22.3,46.7,-33.8,70.3,-34.5,71c-4.7,4.7,-12.3,7,-23,7s-12,-1,-12,-1
s-109,-253,-109,-253c-72.7,-168,-109.3,-252,-110,-252c-10.7,8,-22,16.7,-34,26
c-22,17.3,-33.3,26,-34,26s-26,-26,-26,-26s76,-59,76,-59s76,-60,76,-60z
M` + (1001 + e) + " " + t + "h400000v" + (40 + e) + "h-400000z";
}, sk = function(e, t) {
  return "M983 " + (10 + e + t) + `
l` + e / 3.13 + " -" + e + `
c4,-6.7,10,-10,18,-10 H400000v` + (40 + e) + `
H1013.1s-83.4,268,-264.1,840c-180.7,572,-277,876.3,-289,913c-4.7,4.7,-12.7,7,-24,7
s-12,0,-12,0c-1.3,-3.3,-3.7,-11.7,-7,-25c-35.3,-125.3,-106.7,-373.3,-214,-744
c-10,12,-21,25,-33,39s-32,39,-32,39c-6,-5.3,-15,-14,-27,-26s25,-30,25,-30
c26.7,-32.7,52,-63,76,-91s52,-60,52,-60s208,722,208,722
c56,-175.3,126.3,-397.3,211,-666c84.7,-268.7,153.8,-488.2,207.5,-658.5
c53.7,-170.3,84.5,-266.8,92.5,-289.5z
M` + (1001 + e) + " " + t + "h400000v" + (40 + e) + "h-400000z";
}, lk = function(e, t) {
  return "M424," + (2398 + e + t) + `
c-1.3,-0.7,-38.5,-172,-111.5,-514c-73,-342,-109.8,-513.3,-110.5,-514
c0,-2,-10.7,14.3,-32,49c-4.7,7.3,-9.8,15.7,-15.5,25c-5.7,9.3,-9.8,16,-12.5,20
s-5,7,-5,7c-4,-3.3,-8.3,-7.7,-13,-13s-13,-13,-13,-13s76,-122,76,-122s77,-121,77,-121
s209,968,209,968c0,-2,84.7,-361.7,254,-1079c169.3,-717.3,254.7,-1077.7,256,-1081
l` + e / 4.223 + " -" + e + `c4,-6.7,10,-10,18,-10 H400000
v` + (40 + e) + `H1014.6
s-87.3,378.7,-272.6,1166c-185.3,787.3,-279.3,1182.3,-282,1185
c-2,6,-10,9,-24,9
c-8,0,-12,-0.7,-12,-2z M` + (1001 + e) + " " + t + `
h400000v` + (40 + e) + "h-400000z";
}, ok = function(e, t) {
  return "M473," + (2713 + e + t) + `
c339.3,-1799.3,509.3,-2700,510,-2702 l` + e / 5.298 + " -" + e + `
c3.3,-7.3,9.3,-11,18,-11 H400000v` + (40 + e) + `H1017.7
s-90.5,478,-276.2,1466c-185.7,988,-279.5,1483,-281.5,1485c-2,6,-10,9,-24,9
c-8,0,-12,-0.7,-12,-2c0,-1.3,-5.3,-32,-16,-92c-50.7,-293.3,-119.7,-693.3,-207,-1200
c0,-1.3,-5.3,8.7,-16,30c-10.7,21.3,-21.3,42.7,-32,64s-16,33,-16,33s-26,-26,-26,-26
s76,-153,76,-153s77,-151,77,-151c0.7,0.7,35.7,202,105,604c67.3,400.7,102,602.7,104,
606zM` + (1001 + e) + " " + t + "h400000v" + (40 + e) + "H1017.7z";
}, ak = function(e) {
  var t = e / 2;
  return "M400000 " + e + " H0 L" + t + " 0 l65 45 L145 " + (e - 80) + " H400000z";
}, uk = function(e, t, r) {
  var i = r - 54 - t - e;
  return "M702 " + (e + t) + "H400000" + (40 + e) + `
H742v` + i + `l-4 4-4 4c-.667.7 -2 1.5-4 2.5s-4.167 1.833-6.5 2.5-5.5 1-9.5 1
h-12l-28-84c-16.667-52-96.667 -294.333-240-727l-212 -643 -85 170
c-4-3.333-8.333-7.667-13 -13l-13-13l77-155 77-156c66 199.333 139 419.667
219 661 l218 661zM702 ` + t + "H400000v" + (40 + e) + "H742z";
}, hk = function(e, t, r) {
  t = 1e3 * t;
  var i = "";
  switch (e) {
    case "sqrtMain":
      i = nk(t, Mi);
      break;
    case "sqrtSize1":
      i = ik(t, Mi);
      break;
    case "sqrtSize2":
      i = sk(t, Mi);
      break;
    case "sqrtSize3":
      i = lk(t, Mi);
      break;
    case "sqrtSize4":
      i = ok(t, Mi);
      break;
    case "sqrtTall":
      i = uk(t, Mi, r);
  }
  return i;
}, ck = function(e, t) {
  switch (e) {
    case "⎜":
      return "M291 0 H417 V" + t + " H291z M291 0 H417 V" + t + " H291z";
    case "∣":
      return "M145 0 H188 V" + t + " H145z M145 0 H188 V" + t + " H145z";
    case "∥":
      return "M145 0 H188 V" + t + " H145z M145 0 H188 V" + t + " H145z" + ("M367 0 H410 V" + t + " H367z M367 0 H410 V" + t + " H367z");
    case "⎟":
      return "M457 0 H583 V" + t + " H457z M457 0 H583 V" + t + " H457z";
    case "⎢":
      return "M319 0 H403 V" + t + " H319z M319 0 H403 V" + t + " H319z";
    case "⎥":
      return "M263 0 H347 V" + t + " H263z M263 0 H347 V" + t + " H263z";
    case "⎪":
      return "M384 0 H504 V" + t + " H384z M384 0 H504 V" + t + " H384z";
    case "⏐":
      return "M312 0 H355 V" + t + " H312z M312 0 H355 V" + t + " H312z";
    case "‖":
      return "M257 0 H300 V" + t + " H257z M257 0 H300 V" + t + " H257z" + ("M478 0 H521 V" + t + " H478z M478 0 H521 V" + t + " H478z");
    default:
      return "";
  }
}, k1 = {
  // The doubleleftarrow geometry is from glyph U+21D0 in the font KaTeX Main
  doubleleftarrow: `M262 157
l10-10c34-36 62.7-77 86-123 3.3-8 5-13.3 5-16 0-5.3-6.7-8-20-8-7.3
 0-12.2.5-14.5 1.5-2.3 1-4.8 4.5-7.5 10.5-49.3 97.3-121.7 169.3-217 216-28
 14-57.3 25-88 33-6.7 2-11 3.8-13 5.5-2 1.7-3 4.2-3 7.5s1 5.8 3 7.5
c2 1.7 6.3 3.5 13 5.5 68 17.3 128.2 47.8 180.5 91.5 52.3 43.7 93.8 96.2 124.5
 157.5 9.3 8 15.3 12.3 18 13h6c12-.7 18-4 18-10 0-2-1.7-7-5-15-23.3-46-52-87
-86-123l-10-10h399738v-40H218c328 0 0 0 0 0l-10-8c-26.7-20-65.7-43-117-69 2.7
-2 6-3.7 10-5 36.7-16 72.3-37.3 107-64l10-8h399782v-40z
m8 0v40h399730v-40zm0 194v40h399730v-40z`,
  // doublerightarrow is from glyph U+21D2 in font KaTeX Main
  doublerightarrow: `M399738 392l
-10 10c-34 36-62.7 77-86 123-3.3 8-5 13.3-5 16 0 5.3 6.7 8 20 8 7.3 0 12.2-.5
 14.5-1.5 2.3-1 4.8-4.5 7.5-10.5 49.3-97.3 121.7-169.3 217-216 28-14 57.3-25 88
-33 6.7-2 11-3.8 13-5.5 2-1.7 3-4.2 3-7.5s-1-5.8-3-7.5c-2-1.7-6.3-3.5-13-5.5-68
-17.3-128.2-47.8-180.5-91.5-52.3-43.7-93.8-96.2-124.5-157.5-9.3-8-15.3-12.3-18
-13h-6c-12 .7-18 4-18 10 0 2 1.7 7 5 15 23.3 46 52 87 86 123l10 10H0v40h399782
c-328 0 0 0 0 0l10 8c26.7 20 65.7 43 117 69-2.7 2-6 3.7-10 5-36.7 16-72.3 37.3
-107 64l-10 8H0v40zM0 157v40h399730v-40zm0 194v40h399730v-40z`,
  // leftarrow is from glyph U+2190 in font KaTeX Main
  leftarrow: `M400000 241H110l3-3c68.7-52.7 113.7-120
 135-202 4-14.7 6-23 6-25 0-7.3-7-11-21-11-8 0-13.2.8-15.5 2.5-2.3 1.7-4.2 5.8
-5.5 12.5-1.3 4.7-2.7 10.3-4 17-12 48.7-34.8 92-68.5 130S65.3 228.3 18 247
c-10 4-16 7.7-18 11 0 8.7 6 14.3 18 17 47.3 18.7 87.8 47 121.5 85S196 441.3 208
 490c.7 2 1.3 5 2 9s1.2 6.7 1.5 8c.3 1.3 1 3.3 2 6s2.2 4.5 3.5 5.5c1.3 1 3.3
 1.8 6 2.5s6 1 10 1c14 0 21-3.7 21-11 0-2-2-10.3-6-25-20-79.3-65-146.7-135-202
 l-3-3h399890zM100 241v40h399900v-40z`,
  // overbrace is from glyphs U+23A9/23A8/23A7 in font KaTeX_Size4-Regular
  leftbrace: `M6 548l-6-6v-35l6-11c56-104 135.3-181.3 238-232 57.3-28.7 117
-45 179-50h399577v120H403c-43.3 7-81 15-113 26-100.7 33-179.7 91-237 174-2.7
 5-6 9-10 13-.7 1-7.3 1-20 1H6z`,
  leftbraceunder: `M0 6l6-6h17c12.688 0 19.313.3 20 1 4 4 7.313 8.3 10 13
 35.313 51.3 80.813 93.8 136.5 127.5 55.688 33.7 117.188 55.8 184.5 66.5.688
 0 2 .3 4 1 18.688 2.7 76 4.3 172 5h399450v120H429l-6-1c-124.688-8-235-61.7
-331-161C60.687 138.7 32.312 99.3 7 54L0 41V6z`,
  // overgroup is from the MnSymbol package (public domain)
  leftgroup: `M400000 80
H435C64 80 168.3 229.4 21 260c-5.9 1.2-18 0-18 0-2 0-3-1-3-3v-38C76 61 257 0
 435 0h399565z`,
  leftgroupunder: `M400000 262
H435C64 262 168.3 112.6 21 82c-5.9-1.2-18 0-18 0-2 0-3 1-3 3v38c76 158 257 219
 435 219h399565z`,
  // Harpoons are from glyph U+21BD in font KaTeX Main
  leftharpoon: `M0 267c.7 5.3 3 10 7 14h399993v-40H93c3.3
-3.3 10.2-9.5 20.5-18.5s17.8-15.8 22.5-20.5c50.7-52 88-110.3 112-175 4-11.3 5
-18.3 3-21-1.3-4-7.3-6-18-6-8 0-13 .7-15 2s-4.7 6.7-8 16c-42 98.7-107.3 174.7
-196 228-6.7 4.7-10.7 8-12 10-1.3 2-2 5.7-2 11zm100-26v40h399900v-40z`,
  leftharpoonplus: `M0 267c.7 5.3 3 10 7 14h399993v-40H93c3.3-3.3 10.2-9.5
 20.5-18.5s17.8-15.8 22.5-20.5c50.7-52 88-110.3 112-175 4-11.3 5-18.3 3-21-1.3
-4-7.3-6-18-6-8 0-13 .7-15 2s-4.7 6.7-8 16c-42 98.7-107.3 174.7-196 228-6.7 4.7
-10.7 8-12 10-1.3 2-2 5.7-2 11zm100-26v40h399900v-40zM0 435v40h400000v-40z
m0 0v40h400000v-40z`,
  leftharpoondown: `M7 241c-4 4-6.333 8.667-7 14 0 5.333.667 9 2 11s5.333
 5.333 12 10c90.667 54 156 130 196 228 3.333 10.667 6.333 16.333 9 17 2 .667 5
 1 9 1h5c10.667 0 16.667-2 18-6 2-2.667 1-9.667-3-21-32-87.333-82.667-157.667
-152-211l-3-3h399907v-40zM93 281 H400000 v-40L7 241z`,
  leftharpoondownplus: `M7 435c-4 4-6.3 8.7-7 14 0 5.3.7 9 2 11s5.3 5.3 12
 10c90.7 54 156 130 196 228 3.3 10.7 6.3 16.3 9 17 2 .7 5 1 9 1h5c10.7 0 16.7
-2 18-6 2-2.7 1-9.7-3-21-32-87.3-82.7-157.7-152-211l-3-3h399907v-40H7zm93 0
v40h399900v-40zM0 241v40h399900v-40zm0 0v40h399900v-40z`,
  // hook is from glyph U+21A9 in font KaTeX Main
  lefthook: `M400000 281 H103s-33-11.2-61-33.5S0 197.3 0 164s14.2-61.2 42.5
-83.5C70.8 58.2 104 47 142 47 c16.7 0 25 6.7 25 20 0 12-8.7 18.7-26 20-40 3.3
-68.7 15.7-86 37-10 12-15 25.3-15 40 0 22.7 9.8 40.7 29.5 54 19.7 13.3 43.5 21
 71.5 23h399859zM103 281v-40h399897v40z`,
  leftlinesegment: `M40 281 V428 H0 V94 H40 V241 H400000 v40z
M40 281 V428 H0 V94 H40 V241 H400000 v40z`,
  leftmapsto: `M40 281 V448H0V74H40V241H400000v40z
M40 281 V448H0V74H40V241H400000v40z`,
  // tofrom is from glyph U+21C4 in font KaTeX AMS Regular
  leftToFrom: `M0 147h400000v40H0zm0 214c68 40 115.7 95.7 143 167h22c15.3 0 23
-.3 23-1 0-1.3-5.3-13.7-16-37-18-35.3-41.3-69-70-101l-7-8h399905v-40H95l7-8
c28.7-32 52-65.7 70-101 10.7-23.3 16-35.7 16-37 0-.7-7.7-1-23-1h-22C115.7 265.3
 68 321 0 361zm0-174v-40h399900v40zm100 154v40h399900v-40z`,
  longequal: `M0 50 h400000 v40H0z m0 194h40000v40H0z
M0 50 h400000 v40H0z m0 194h40000v40H0z`,
  midbrace: `M200428 334
c-100.7-8.3-195.3-44-280-108-55.3-42-101.7-93-139-153l-9-14c-2.7 4-5.7 8.7-9 14
-53.3 86.7-123.7 153-211 199-66.7 36-137.3 56.3-212 62H0V214h199568c178.3-11.7
 311.7-78.3 403-201 6-8 9.7-12 11-12 .7-.7 6.7-1 18-1s17.3.3 18 1c1.3 0 5 4 11
 12 44.7 59.3 101.3 106.3 170 141s145.3 54.3 229 60h199572v120z`,
  midbraceunder: `M199572 214
c100.7 8.3 195.3 44 280 108 55.3 42 101.7 93 139 153l9 14c2.7-4 5.7-8.7 9-14
 53.3-86.7 123.7-153 211-199 66.7-36 137.3-56.3 212-62h199568v120H200432c-178.3
 11.7-311.7 78.3-403 201-6 8-9.7 12-11 12-.7.7-6.7 1-18 1s-17.3-.3-18-1c-1.3 0
-5-4-11-12-44.7-59.3-101.3-106.3-170-141s-145.3-54.3-229-60H0V214z`,
  oiintSize1: `M512.6 71.6c272.6 0 320.3 106.8 320.3 178.2 0 70.8-47.7 177.6
-320.3 177.6S193.1 320.6 193.1 249.8c0-71.4 46.9-178.2 319.5-178.2z
m368.1 178.2c0-86.4-60.9-215.4-368.1-215.4-306.4 0-367.3 129-367.3 215.4 0 85.8
60.9 214.8 367.3 214.8 307.2 0 368.1-129 368.1-214.8z`,
  oiintSize2: `M757.8 100.1c384.7 0 451.1 137.6 451.1 230 0 91.3-66.4 228.8
-451.1 228.8-386.3 0-452.7-137.5-452.7-228.8 0-92.4 66.4-230 452.7-230z
m502.4 230c0-111.2-82.4-277.2-502.4-277.2s-504 166-504 277.2
c0 110 84 276 504 276s502.4-166 502.4-276z`,
  oiiintSize1: `M681.4 71.6c408.9 0 480.5 106.8 480.5 178.2 0 70.8-71.6 177.6
-480.5 177.6S202.1 320.6 202.1 249.8c0-71.4 70.5-178.2 479.3-178.2z
m525.8 178.2c0-86.4-86.8-215.4-525.7-215.4-437.9 0-524.7 129-524.7 215.4 0
85.8 86.8 214.8 524.7 214.8 438.9 0 525.7-129 525.7-214.8z`,
  oiiintSize2: `M1021.2 53c603.6 0 707.8 165.8 707.8 277.2 0 110-104.2 275.8
-707.8 275.8-606 0-710.2-165.8-710.2-275.8C311 218.8 415.2 53 1021.2 53z
m770.4 277.1c0-131.2-126.4-327.6-770.5-327.6S248.4 198.9 248.4 330.1
c0 130 128.8 326.4 772.7 326.4s770.5-196.4 770.5-326.4z`,
  rightarrow: `M0 241v40h399891c-47.3 35.3-84 78-110 128
-16.7 32-27.7 63.7-33 95 0 1.3-.2 2.7-.5 4-.3 1.3-.5 2.3-.5 3 0 7.3 6.7 11 20
 11 8 0 13.2-.8 15.5-2.5 2.3-1.7 4.2-5.5 5.5-11.5 2-13.3 5.7-27 11-41 14.7-44.7
 39-84.5 73-119.5s73.7-60.2 119-75.5c6-2 9-5.7 9-11s-3-9-9-11c-45.3-15.3-85
-40.5-119-75.5s-58.3-74.8-73-119.5c-4.7-14-8.3-27.3-11-40-1.3-6.7-3.2-10.8-5.5
-12.5-2.3-1.7-7.5-2.5-15.5-2.5-14 0-21 3.7-21 11 0 2 2 10.3 6 25 20.7 83.3 67
 151.7 139 205zm0 0v40h399900v-40z`,
  rightbrace: `M400000 542l
-6 6h-17c-12.7 0-19.3-.3-20-1-4-4-7.3-8.3-10-13-35.3-51.3-80.8-93.8-136.5-127.5
s-117.2-55.8-184.5-66.5c-.7 0-2-.3-4-1-18.7-2.7-76-4.3-172-5H0V214h399571l6 1
c124.7 8 235 61.7 331 161 31.3 33.3 59.7 72.7 85 118l7 13v35z`,
  rightbraceunder: `M399994 0l6 6v35l-6 11c-56 104-135.3 181.3-238 232-57.3
 28.7-117 45-179 50H-300V214h399897c43.3-7 81-15 113-26 100.7-33 179.7-91 237
-174 2.7-5 6-9 10-13 .7-1 7.3-1 20-1h17z`,
  rightgroup: `M0 80h399565c371 0 266.7 149.4 414 180 5.9 1.2 18 0 18 0 2 0
 3-1 3-3v-38c-76-158-257-219-435-219H0z`,
  rightgroupunder: `M0 262h399565c371 0 266.7-149.4 414-180 5.9-1.2 18 0 18
 0 2 0 3 1 3 3v38c-76 158-257 219-435 219H0z`,
  rightharpoon: `M0 241v40h399993c4.7-4.7 7-9.3 7-14 0-9.3
-3.7-15.3-11-18-92.7-56.7-159-133.7-199-231-3.3-9.3-6-14.7-8-16-2-1.3-7-2-15-2
-10.7 0-16.7 2-18 6-2 2.7-1 9.7 3 21 15.3 42 36.7 81.8 64 119.5 27.3 37.7 58
 69.2 92 94.5zm0 0v40h399900v-40z`,
  rightharpoonplus: `M0 241v40h399993c4.7-4.7 7-9.3 7-14 0-9.3-3.7-15.3-11
-18-92.7-56.7-159-133.7-199-231-3.3-9.3-6-14.7-8-16-2-1.3-7-2-15-2-10.7 0-16.7
 2-18 6-2 2.7-1 9.7 3 21 15.3 42 36.7 81.8 64 119.5 27.3 37.7 58 69.2 92 94.5z
m0 0v40h399900v-40z m100 194v40h399900v-40zm0 0v40h399900v-40z`,
  rightharpoondown: `M399747 511c0 7.3 6.7 11 20 11 8 0 13-.8 15-2.5s4.7-6.8
 8-15.5c40-94 99.3-166.3 178-217 13.3-8 20.3-12.3 21-13 5.3-3.3 8.5-5.8 9.5
-7.5 1-1.7 1.5-5.2 1.5-10.5s-2.3-10.3-7-15H0v40h399908c-34 25.3-64.7 57-92 95
-27.3 38-48.7 77.7-64 119-3.3 8.7-5 14-5 16zM0 241v40h399900v-40z`,
  rightharpoondownplus: `M399747 705c0 7.3 6.7 11 20 11 8 0 13-.8
 15-2.5s4.7-6.8 8-15.5c40-94 99.3-166.3 178-217 13.3-8 20.3-12.3 21-13 5.3-3.3
 8.5-5.8 9.5-7.5 1-1.7 1.5-5.2 1.5-10.5s-2.3-10.3-7-15H0v40h399908c-34 25.3
-64.7 57-92 95-27.3 38-48.7 77.7-64 119-3.3 8.7-5 14-5 16zM0 435v40h399900v-40z
m0-194v40h400000v-40zm0 0v40h400000v-40z`,
  righthook: `M399859 241c-764 0 0 0 0 0 40-3.3 68.7-15.7 86-37 10-12 15-25.3
 15-40 0-22.7-9.8-40.7-29.5-54-19.7-13.3-43.5-21-71.5-23-17.3-1.3-26-8-26-20 0
-13.3 8.7-20 26-20 38 0 71 11.2 99 33.5 0 0 7 5.6 21 16.7 14 11.2 21 33.5 21
 66.8s-14 61.2-42 83.5c-28 22.3-61 33.5-99 33.5L0 241z M0 281v-40h399859v40z`,
  rightlinesegment: `M399960 241 V94 h40 V428 h-40 V281 H0 v-40z
M399960 241 V94 h40 V428 h-40 V281 H0 v-40z`,
  rightToFrom: `M400000 167c-70.7-42-118-97.7-142-167h-23c-15.3 0-23 .3-23
 1 0 1.3 5.3 13.7 16 37 18 35.3 41.3 69 70 101l7 8H0v40h399905l-7 8c-28.7 32
-52 65.7-70 101-10.7 23.3-16 35.7-16 37 0 .7 7.7 1 23 1h23c24-69.3 71.3-125 142
-167z M100 147v40h399900v-40zM0 341v40h399900v-40z`,
  // twoheadleftarrow is from glyph U+219E in font KaTeX AMS Regular
  twoheadleftarrow: `M0 167c68 40
 115.7 95.7 143 167h22c15.3 0 23-.3 23-1 0-1.3-5.3-13.7-16-37-18-35.3-41.3-69
-70-101l-7-8h125l9 7c50.7 39.3 85 86 103 140h46c0-4.7-6.3-18.7-19-42-18-35.3
-40-67.3-66-96l-9-9h399716v-40H284l9-9c26-28.7 48-60.7 66-96 12.7-23.333 19
-37.333 19-42h-46c-18 54-52.3 100.7-103 140l-9 7H95l7-8c28.7-32 52-65.7 70-101
 10.7-23.333 16-35.7 16-37 0-.7-7.7-1-23-1h-22C115.7 71.3 68 127 0 167z`,
  twoheadrightarrow: `M400000 167
c-68-40-115.7-95.7-143-167h-22c-15.3 0-23 .3-23 1 0 1.3 5.3 13.7 16 37 18 35.3
 41.3 69 70 101l7 8h-125l-9-7c-50.7-39.3-85-86-103-140h-46c0 4.7 6.3 18.7 19 42
 18 35.3 40 67.3 66 96l9 9H0v40h399716l-9 9c-26 28.7-48 60.7-66 96-12.7 23.333
-19 37.333-19 42h46c18-54 52.3-100.7 103-140l9-7h125l-7 8c-28.7 32-52 65.7-70
 101-10.7 23.333-16 35.7-16 37 0 .7 7.7 1 23 1h22c27.3-71.3 75-127 143-167z`,
  // tilde1 is a modified version of a glyph from the MnSymbol package
  tilde1: `M200 55.538c-77 0-168 73.953-177 73.953-3 0-7
-2.175-9-5.437L2 97c-1-2-2-4-2-6 0-4 2-7 5-9l20-12C116 12 171 0 207 0c86 0
 114 68 191 68 78 0 168-68 177-68 4 0 7 2 9 5l12 19c1 2.175 2 4.35 2 6.525 0
 4.35-2 7.613-5 9.788l-19 13.05c-92 63.077-116.937 75.308-183 76.128
-68.267.847-113-73.952-191-73.952z`,
  // ditto tilde2, tilde3, & tilde4
  tilde2: `M344 55.266c-142 0-300.638 81.316-311.5 86.418
-8.01 3.762-22.5 10.91-23.5 5.562L1 120c-1-2-1-3-1-4 0-5 3-9 8-10l18.4-9C160.9
 31.9 283 0 358 0c148 0 188 122 331 122s314-97 326-97c4 0 8 2 10 7l7 21.114
c1 2.14 1 3.21 1 4.28 0 5.347-3 9.626-7 10.696l-22.3 12.622C852.6 158.372 751
 181.476 676 181.476c-149 0-189-126.21-332-126.21z`,
  tilde3: `M786 59C457 59 32 175.242 13 175.242c-6 0-10-3.457
-11-10.37L.15 138c-1-7 3-12 10-13l19.2-6.4C378.4 40.7 634.3 0 804.3 0c337 0
 411.8 157 746.8 157 328 0 754-112 773-112 5 0 10 3 11 9l1 14.075c1 8.066-.697
 16.595-6.697 17.492l-21.052 7.31c-367.9 98.146-609.15 122.696-778.15 122.696
 -338 0-409-156.573-744-156.573z`,
  tilde4: `M786 58C457 58 32 177.487 13 177.487c-6 0-10-3.345
-11-10.035L.15 143c-1-7 3-12 10-13l22-6.7C381.2 35 637.15 0 807.15 0c337 0 409
 177 744 177 328 0 754-127 773-127 5 0 10 3 11 9l1 14.794c1 7.805-3 13.38-9
 14.495l-20.7 5.574c-366.85 99.79-607.3 139.372-776.3 139.372-338 0-409
 -175.236-744-175.236z`,
  // vec is from glyph U+20D7 in font KaTeX Main
  vec: `M377 20c0-5.333 1.833-10 5.5-14S391 0 397 0c4.667 0 8.667 1.667 12 5
3.333 2.667 6.667 9 10 19 6.667 24.667 20.333 43.667 41 57 7.333 4.667 11
10.667 11 18 0 6-1 10-3 12s-6.667 5-14 9c-28.667 14.667-53.667 35.667-75 63
-1.333 1.333-3.167 3.5-5.5 6.5s-4 4.833-5 5.5c-1 .667-2.5 1.333-4.5 2s-4.333 1
-7 1c-4.667 0-9.167-1.833-13.5-5.5S337 184 337 178c0-12.667 15.667-32.333 47-59
H213l-171-1c-8.667-6-13-12.333-13-19 0-4.667 4.333-11.333 13-20h359
c-16-25.333-24-45-24-59z`,
  // widehat1 is a modified version of a glyph from the MnSymbol package
  widehat1: `M529 0h5l519 115c5 1 9 5 9 10 0 1-1 2-1 3l-4 22
c-1 5-5 9-11 9h-2L532 67 19 159h-2c-5 0-9-4-11-9l-5-22c-1-6 2-12 8-13z`,
  // ditto widehat2, widehat3, & widehat4
  widehat2: `M1181 0h2l1171 176c6 0 10 5 10 11l-2 23c-1 6-5 10
-11 10h-1L1182 67 15 220h-1c-6 0-10-4-11-10l-2-23c-1-6 4-11 10-11z`,
  widehat3: `M1181 0h2l1171 236c6 0 10 5 10 11l-2 23c-1 6-5 10
-11 10h-1L1182 67 15 280h-1c-6 0-10-4-11-10l-2-23c-1-6 4-11 10-11z`,
  widehat4: `M1181 0h2l1171 296c6 0 10 5 10 11l-2 23c-1 6-5 10
-11 10h-1L1182 67 15 340h-1c-6 0-10-4-11-10l-2-23c-1-6 4-11 10-11z`,
  // widecheck paths are all inverted versions of widehat
  widecheck1: `M529,159h5l519,-115c5,-1,9,-5,9,-10c0,-1,-1,-2,-1,-3l-4,-22c-1,
-5,-5,-9,-11,-9h-2l-512,92l-513,-92h-2c-5,0,-9,4,-11,9l-5,22c-1,6,2,12,8,13z`,
  widecheck2: `M1181,220h2l1171,-176c6,0,10,-5,10,-11l-2,-23c-1,-6,-5,-10,
-11,-10h-1l-1168,153l-1167,-153h-1c-6,0,-10,4,-11,10l-2,23c-1,6,4,11,10,11z`,
  widecheck3: `M1181,280h2l1171,-236c6,0,10,-5,10,-11l-2,-23c-1,-6,-5,-10,
-11,-10h-1l-1168,213l-1167,-213h-1c-6,0,-10,4,-11,10l-2,23c-1,6,4,11,10,11z`,
  widecheck4: `M1181,340h2l1171,-296c6,0,10,-5,10,-11l-2,-23c-1,-6,-5,-10,
-11,-10h-1l-1168,273l-1167,-273h-1c-6,0,-10,4,-11,10l-2,23c-1,6,4,11,10,11z`,
  // The next ten paths support reaction arrows from the mhchem package.
  // Arrows for \ce{<-->} are offset from xAxis by 0.22ex, per mhchem in LaTeX
  // baraboveleftarrow is mostly from glyph U+2190 in font KaTeX Main
  baraboveleftarrow: `M400000 620h-399890l3 -3c68.7 -52.7 113.7 -120 135 -202
c4 -14.7 6 -23 6 -25c0 -7.3 -7 -11 -21 -11c-8 0 -13.2 0.8 -15.5 2.5
c-2.3 1.7 -4.2 5.8 -5.5 12.5c-1.3 4.7 -2.7 10.3 -4 17c-12 48.7 -34.8 92 -68.5 130
s-74.2 66.3 -121.5 85c-10 4 -16 7.7 -18 11c0 8.7 6 14.3 18 17c47.3 18.7 87.8 47
121.5 85s56.5 81.3 68.5 130c0.7 2 1.3 5 2 9s1.2 6.7 1.5 8c0.3 1.3 1 3.3 2 6
s2.2 4.5 3.5 5.5c1.3 1 3.3 1.8 6 2.5s6 1 10 1c14 0 21 -3.7 21 -11
c0 -2 -2 -10.3 -6 -25c-20 -79.3 -65 -146.7 -135 -202l-3 -3h399890z
M100 620v40h399900v-40z M0 241v40h399900v-40zM0 241v40h399900v-40z`,
  // rightarrowabovebar is mostly from glyph U+2192, KaTeX Main
  rightarrowabovebar: `M0 241v40h399891c-47.3 35.3-84 78-110 128-16.7 32
-27.7 63.7-33 95 0 1.3-.2 2.7-.5 4-.3 1.3-.5 2.3-.5 3 0 7.3 6.7 11 20 11 8 0
13.2-.8 15.5-2.5 2.3-1.7 4.2-5.5 5.5-11.5 2-13.3 5.7-27 11-41 14.7-44.7 39
-84.5 73-119.5s73.7-60.2 119-75.5c6-2 9-5.7 9-11s-3-9-9-11c-45.3-15.3-85-40.5
-119-75.5s-58.3-74.8-73-119.5c-4.7-14-8.3-27.3-11-40-1.3-6.7-3.2-10.8-5.5
-12.5-2.3-1.7-7.5-2.5-15.5-2.5-14 0-21 3.7-21 11 0 2 2 10.3 6 25 20.7 83.3 67
151.7 139 205zm96 379h399894v40H0zm0 0h399904v40H0z`,
  // The short left harpoon has 0.5em (i.e. 500 units) kern on the left end.
  // Ref from mhchem.sty: \rlap{\raisebox{-.22ex}{$\kern0.5em
  baraboveshortleftharpoon: `M507,435c-4,4,-6.3,8.7,-7,14c0,5.3,0.7,9,2,11
c1.3,2,5.3,5.3,12,10c90.7,54,156,130,196,228c3.3,10.7,6.3,16.3,9,17
c2,0.7,5,1,9,1c0,0,5,0,5,0c10.7,0,16.7,-2,18,-6c2,-2.7,1,-9.7,-3,-21
c-32,-87.3,-82.7,-157.7,-152,-211c0,0,-3,-3,-3,-3l399351,0l0,-40
c-398570,0,-399437,0,-399437,0z M593 435 v40 H399500 v-40z
M0 281 v-40 H399908 v40z M0 281 v-40 H399908 v40z`,
  rightharpoonaboveshortbar: `M0,241 l0,40c399126,0,399993,0,399993,0
c4.7,-4.7,7,-9.3,7,-14c0,-9.3,-3.7,-15.3,-11,-18c-92.7,-56.7,-159,-133.7,-199,
-231c-3.3,-9.3,-6,-14.7,-8,-16c-2,-1.3,-7,-2,-15,-2c-10.7,0,-16.7,2,-18,6
c-2,2.7,-1,9.7,3,21c15.3,42,36.7,81.8,64,119.5c27.3,37.7,58,69.2,92,94.5z
M0 241 v40 H399908 v-40z M0 475 v-40 H399500 v40z M0 475 v-40 H399500 v40z`,
  shortbaraboveleftharpoon: `M7,435c-4,4,-6.3,8.7,-7,14c0,5.3,0.7,9,2,11
c1.3,2,5.3,5.3,12,10c90.7,54,156,130,196,228c3.3,10.7,6.3,16.3,9,17c2,0.7,5,1,9,
1c0,0,5,0,5,0c10.7,0,16.7,-2,18,-6c2,-2.7,1,-9.7,-3,-21c-32,-87.3,-82.7,-157.7,
-152,-211c0,0,-3,-3,-3,-3l399907,0l0,-40c-399126,0,-399993,0,-399993,0z
M93 435 v40 H400000 v-40z M500 241 v40 H400000 v-40z M500 241 v40 H400000 v-40z`,
  shortrightharpoonabovebar: `M53,241l0,40c398570,0,399437,0,399437,0
c4.7,-4.7,7,-9.3,7,-14c0,-9.3,-3.7,-15.3,-11,-18c-92.7,-56.7,-159,-133.7,-199,
-231c-3.3,-9.3,-6,-14.7,-8,-16c-2,-1.3,-7,-2,-15,-2c-10.7,0,-16.7,2,-18,6
c-2,2.7,-1,9.7,3,21c15.3,42,36.7,81.8,64,119.5c27.3,37.7,58,69.2,92,94.5z
M500 241 v40 H399408 v-40z M500 435 v40 H400000 v-40z`
}, fk = function(e, t) {
  switch (e) {
    case "lbrack":
      return "M403 1759 V84 H666 V0 H319 V1759 v" + t + ` v1759 h347 v-84
H403z M403 1759 V0 H319 V1759 v` + t + " v1759 h84z";
    case "rbrack":
      return "M347 1759 V0 H0 V84 H263 V1759 v" + t + ` v1759 H0 v84 H347z
M347 1759 V0 H263 V1759 v` + t + " v1759 h84z";
    case "vert":
      return "M145 15 v585 v" + t + ` v585 c2.667,10,9.667,15,21,15
c10,0,16.667,-5,20,-15 v-585 v` + -t + ` v-585 c-2.667,-10,-9.667,-15,-21,-15
c-10,0,-16.667,5,-20,15z M188 15 H145 v585 v` + t + " v585 h43z";
    case "doublevert":
      return "M145 15 v585 v" + t + ` v585 c2.667,10,9.667,15,21,15
c10,0,16.667,-5,20,-15 v-585 v` + -t + ` v-585 c-2.667,-10,-9.667,-15,-21,-15
c-10,0,-16.667,5,-20,15z M188 15 H145 v585 v` + t + ` v585 h43z
M367 15 v585 v` + t + ` v585 c2.667,10,9.667,15,21,15
c10,0,16.667,-5,20,-15 v-585 v` + -t + ` v-585 c-2.667,-10,-9.667,-15,-21,-15
c-10,0,-16.667,5,-20,15z M410 15 H367 v585 v` + t + " v585 h43z";
    case "lfloor":
      return "M319 602 V0 H403 V602 v" + t + ` v1715 h263 v84 H319z
MM319 602 V0 H403 V602 v` + t + " v1715 H319z";
    case "rfloor":
      return "M319 602 V0 H403 V602 v" + t + ` v1799 H0 v-84 H319z
MM319 602 V0 H403 V602 v` + t + " v1715 H319z";
    case "lceil":
      return "M403 1759 V84 H666 V0 H319 V1759 v" + t + ` v602 h84z
M403 1759 V0 H319 V1759 v` + t + " v602 h84z";
    case "rceil":
      return "M347 1759 V0 H0 V84 H263 V1759 v" + t + ` v602 h84z
M347 1759 V0 h-84 V1759 v` + t + " v602 h84z";
    case "lparen":
      return `M863,9c0,-2,-2,-5,-6,-9c0,0,-17,0,-17,0c-12.7,0,-19.3,0.3,-20,1
c-5.3,5.3,-10.3,11,-15,17c-242.7,294.7,-395.3,682,-458,1162c-21.3,163.3,-33.3,349,
-36,557 l0,` + (t + 84) + `c0.2,6,0,26,0,60c2,159.3,10,310.7,24,454c53.3,528,210,
949.7,470,1265c4.7,6,9.7,11.7,15,17c0.7,0.7,7,1,19,1c0,0,18,0,18,0c4,-4,6,-7,6,-9
c0,-2.7,-3.3,-8.7,-10,-18c-135.3,-192.7,-235.5,-414.3,-300.5,-665c-65,-250.7,-102.5,
-544.7,-112.5,-882c-2,-104,-3,-167,-3,-189
l0,-` + (t + 92) + `c0,-162.7,5.7,-314,17,-454c20.7,-272,63.7,-513,129,-723c65.3,
-210,155.3,-396.3,270,-559c6.7,-9.3,10,-15.3,10,-18z`;
    case "rparen":
      return `M76,0c-16.7,0,-25,3,-25,9c0,2,2,6.3,6,13c21.3,28.7,42.3,60.3,
63,95c96.7,156.7,172.8,332.5,228.5,527.5c55.7,195,92.8,416.5,111.5,664.5
c11.3,139.3,17,290.7,17,454c0,28,1.7,43,3.3,45l0,` + (t + 9) + `
c-3,4,-3.3,16.7,-3.3,38c0,162,-5.7,313.7,-17,455c-18.7,248,-55.8,469.3,-111.5,664
c-55.7,194.7,-131.8,370.3,-228.5,527c-20.7,34.7,-41.7,66.3,-63,95c-2,3.3,-4,7,-6,11
c0,7.3,5.7,11,17,11c0,0,11,0,11,0c9.3,0,14.3,-0.3,15,-1c5.3,-5.3,10.3,-11,15,-17
c242.7,-294.7,395.3,-681.7,458,-1161c21.3,-164.7,33.3,-350.7,36,-558
l0,-` + (t + 144) + `c-2,-159.3,-10,-310.7,-24,-454c-53.3,-528,-210,-949.7,
-470,-1265c-4.7,-6,-9.7,-11.7,-15,-17c-0.7,-0.7,-6.7,-1,-18,-1z`;
    default:
      throw new Error("Unknown stretchy delimiter.");
  }
};
class gl {
  // HtmlDomNode
  // Never used; needed for satisfying interface.
  constructor(e) {
    this.children = void 0, this.classes = void 0, this.height = void 0, this.depth = void 0, this.maxFontSize = void 0, this.style = void 0, this.children = e, this.classes = [], this.height = 0, this.depth = 0, this.maxFontSize = 0, this.style = {};
  }
  hasClass(e) {
    return le.contains(this.classes, e);
  }
  /** Convert the fragment into a node. */
  toNode() {
    for (var e = document.createDocumentFragment(), t = 0; t < this.children.length; t++)
      e.appendChild(this.children[t].toNode());
    return e;
  }
  /** Convert the fragment into HTML markup. */
  toMarkup() {
    for (var e = "", t = 0; t < this.children.length; t++)
      e += this.children[t].toMarkup();
    return e;
  }
  /**
   * Converts the math node into a string, similar to innerText. Applies to
   * MathDomNode's only.
   */
  toText() {
    var e = (t) => t.toText();
    return this.children.map(e).join("");
  }
}
var un = {
  "AMS-Regular": {
    32: [0, 0, 0, 0, 0.25],
    65: [0, 0.68889, 0, 0, 0.72222],
    66: [0, 0.68889, 0, 0, 0.66667],
    67: [0, 0.68889, 0, 0, 0.72222],
    68: [0, 0.68889, 0, 0, 0.72222],
    69: [0, 0.68889, 0, 0, 0.66667],
    70: [0, 0.68889, 0, 0, 0.61111],
    71: [0, 0.68889, 0, 0, 0.77778],
    72: [0, 0.68889, 0, 0, 0.77778],
    73: [0, 0.68889, 0, 0, 0.38889],
    74: [0.16667, 0.68889, 0, 0, 0.5],
    75: [0, 0.68889, 0, 0, 0.77778],
    76: [0, 0.68889, 0, 0, 0.66667],
    77: [0, 0.68889, 0, 0, 0.94445],
    78: [0, 0.68889, 0, 0, 0.72222],
    79: [0.16667, 0.68889, 0, 0, 0.77778],
    80: [0, 0.68889, 0, 0, 0.61111],
    81: [0.16667, 0.68889, 0, 0, 0.77778],
    82: [0, 0.68889, 0, 0, 0.72222],
    83: [0, 0.68889, 0, 0, 0.55556],
    84: [0, 0.68889, 0, 0, 0.66667],
    85: [0, 0.68889, 0, 0, 0.72222],
    86: [0, 0.68889, 0, 0, 0.72222],
    87: [0, 0.68889, 0, 0, 1],
    88: [0, 0.68889, 0, 0, 0.72222],
    89: [0, 0.68889, 0, 0, 0.72222],
    90: [0, 0.68889, 0, 0, 0.66667],
    107: [0, 0.68889, 0, 0, 0.55556],
    160: [0, 0, 0, 0, 0.25],
    165: [0, 0.675, 0.025, 0, 0.75],
    174: [0.15559, 0.69224, 0, 0, 0.94666],
    240: [0, 0.68889, 0, 0, 0.55556],
    295: [0, 0.68889, 0, 0, 0.54028],
    710: [0, 0.825, 0, 0, 2.33334],
    732: [0, 0.9, 0, 0, 2.33334],
    770: [0, 0.825, 0, 0, 2.33334],
    771: [0, 0.9, 0, 0, 2.33334],
    989: [0.08167, 0.58167, 0, 0, 0.77778],
    1008: [0, 0.43056, 0.04028, 0, 0.66667],
    8245: [0, 0.54986, 0, 0, 0.275],
    8463: [0, 0.68889, 0, 0, 0.54028],
    8487: [0, 0.68889, 0, 0, 0.72222],
    8498: [0, 0.68889, 0, 0, 0.55556],
    8502: [0, 0.68889, 0, 0, 0.66667],
    8503: [0, 0.68889, 0, 0, 0.44445],
    8504: [0, 0.68889, 0, 0, 0.66667],
    8513: [0, 0.68889, 0, 0, 0.63889],
    8592: [-0.03598, 0.46402, 0, 0, 0.5],
    8594: [-0.03598, 0.46402, 0, 0, 0.5],
    8602: [-0.13313, 0.36687, 0, 0, 1],
    8603: [-0.13313, 0.36687, 0, 0, 1],
    8606: [0.01354, 0.52239, 0, 0, 1],
    8608: [0.01354, 0.52239, 0, 0, 1],
    8610: [0.01354, 0.52239, 0, 0, 1.11111],
    8611: [0.01354, 0.52239, 0, 0, 1.11111],
    8619: [0, 0.54986, 0, 0, 1],
    8620: [0, 0.54986, 0, 0, 1],
    8621: [-0.13313, 0.37788, 0, 0, 1.38889],
    8622: [-0.13313, 0.36687, 0, 0, 1],
    8624: [0, 0.69224, 0, 0, 0.5],
    8625: [0, 0.69224, 0, 0, 0.5],
    8630: [0, 0.43056, 0, 0, 1],
    8631: [0, 0.43056, 0, 0, 1],
    8634: [0.08198, 0.58198, 0, 0, 0.77778],
    8635: [0.08198, 0.58198, 0, 0, 0.77778],
    8638: [0.19444, 0.69224, 0, 0, 0.41667],
    8639: [0.19444, 0.69224, 0, 0, 0.41667],
    8642: [0.19444, 0.69224, 0, 0, 0.41667],
    8643: [0.19444, 0.69224, 0, 0, 0.41667],
    8644: [0.1808, 0.675, 0, 0, 1],
    8646: [0.1808, 0.675, 0, 0, 1],
    8647: [0.1808, 0.675, 0, 0, 1],
    8648: [0.19444, 0.69224, 0, 0, 0.83334],
    8649: [0.1808, 0.675, 0, 0, 1],
    8650: [0.19444, 0.69224, 0, 0, 0.83334],
    8651: [0.01354, 0.52239, 0, 0, 1],
    8652: [0.01354, 0.52239, 0, 0, 1],
    8653: [-0.13313, 0.36687, 0, 0, 1],
    8654: [-0.13313, 0.36687, 0, 0, 1],
    8655: [-0.13313, 0.36687, 0, 0, 1],
    8666: [0.13667, 0.63667, 0, 0, 1],
    8667: [0.13667, 0.63667, 0, 0, 1],
    8669: [-0.13313, 0.37788, 0, 0, 1],
    8672: [-0.064, 0.437, 0, 0, 1.334],
    8674: [-0.064, 0.437, 0, 0, 1.334],
    8705: [0, 0.825, 0, 0, 0.5],
    8708: [0, 0.68889, 0, 0, 0.55556],
    8709: [0.08167, 0.58167, 0, 0, 0.77778],
    8717: [0, 0.43056, 0, 0, 0.42917],
    8722: [-0.03598, 0.46402, 0, 0, 0.5],
    8724: [0.08198, 0.69224, 0, 0, 0.77778],
    8726: [0.08167, 0.58167, 0, 0, 0.77778],
    8733: [0, 0.69224, 0, 0, 0.77778],
    8736: [0, 0.69224, 0, 0, 0.72222],
    8737: [0, 0.69224, 0, 0, 0.72222],
    8738: [0.03517, 0.52239, 0, 0, 0.72222],
    8739: [0.08167, 0.58167, 0, 0, 0.22222],
    8740: [0.25142, 0.74111, 0, 0, 0.27778],
    8741: [0.08167, 0.58167, 0, 0, 0.38889],
    8742: [0.25142, 0.74111, 0, 0, 0.5],
    8756: [0, 0.69224, 0, 0, 0.66667],
    8757: [0, 0.69224, 0, 0, 0.66667],
    8764: [-0.13313, 0.36687, 0, 0, 0.77778],
    8765: [-0.13313, 0.37788, 0, 0, 0.77778],
    8769: [-0.13313, 0.36687, 0, 0, 0.77778],
    8770: [-0.03625, 0.46375, 0, 0, 0.77778],
    8774: [0.30274, 0.79383, 0, 0, 0.77778],
    8776: [-0.01688, 0.48312, 0, 0, 0.77778],
    8778: [0.08167, 0.58167, 0, 0, 0.77778],
    8782: [0.06062, 0.54986, 0, 0, 0.77778],
    8783: [0.06062, 0.54986, 0, 0, 0.77778],
    8785: [0.08198, 0.58198, 0, 0, 0.77778],
    8786: [0.08198, 0.58198, 0, 0, 0.77778],
    8787: [0.08198, 0.58198, 0, 0, 0.77778],
    8790: [0, 0.69224, 0, 0, 0.77778],
    8791: [0.22958, 0.72958, 0, 0, 0.77778],
    8796: [0.08198, 0.91667, 0, 0, 0.77778],
    8806: [0.25583, 0.75583, 0, 0, 0.77778],
    8807: [0.25583, 0.75583, 0, 0, 0.77778],
    8808: [0.25142, 0.75726, 0, 0, 0.77778],
    8809: [0.25142, 0.75726, 0, 0, 0.77778],
    8812: [0.25583, 0.75583, 0, 0, 0.5],
    8814: [0.20576, 0.70576, 0, 0, 0.77778],
    8815: [0.20576, 0.70576, 0, 0, 0.77778],
    8816: [0.30274, 0.79383, 0, 0, 0.77778],
    8817: [0.30274, 0.79383, 0, 0, 0.77778],
    8818: [0.22958, 0.72958, 0, 0, 0.77778],
    8819: [0.22958, 0.72958, 0, 0, 0.77778],
    8822: [0.1808, 0.675, 0, 0, 0.77778],
    8823: [0.1808, 0.675, 0, 0, 0.77778],
    8828: [0.13667, 0.63667, 0, 0, 0.77778],
    8829: [0.13667, 0.63667, 0, 0, 0.77778],
    8830: [0.22958, 0.72958, 0, 0, 0.77778],
    8831: [0.22958, 0.72958, 0, 0, 0.77778],
    8832: [0.20576, 0.70576, 0, 0, 0.77778],
    8833: [0.20576, 0.70576, 0, 0, 0.77778],
    8840: [0.30274, 0.79383, 0, 0, 0.77778],
    8841: [0.30274, 0.79383, 0, 0, 0.77778],
    8842: [0.13597, 0.63597, 0, 0, 0.77778],
    8843: [0.13597, 0.63597, 0, 0, 0.77778],
    8847: [0.03517, 0.54986, 0, 0, 0.77778],
    8848: [0.03517, 0.54986, 0, 0, 0.77778],
    8858: [0.08198, 0.58198, 0, 0, 0.77778],
    8859: [0.08198, 0.58198, 0, 0, 0.77778],
    8861: [0.08198, 0.58198, 0, 0, 0.77778],
    8862: [0, 0.675, 0, 0, 0.77778],
    8863: [0, 0.675, 0, 0, 0.77778],
    8864: [0, 0.675, 0, 0, 0.77778],
    8865: [0, 0.675, 0, 0, 0.77778],
    8872: [0, 0.69224, 0, 0, 0.61111],
    8873: [0, 0.69224, 0, 0, 0.72222],
    8874: [0, 0.69224, 0, 0, 0.88889],
    8876: [0, 0.68889, 0, 0, 0.61111],
    8877: [0, 0.68889, 0, 0, 0.61111],
    8878: [0, 0.68889, 0, 0, 0.72222],
    8879: [0, 0.68889, 0, 0, 0.72222],
    8882: [0.03517, 0.54986, 0, 0, 0.77778],
    8883: [0.03517, 0.54986, 0, 0, 0.77778],
    8884: [0.13667, 0.63667, 0, 0, 0.77778],
    8885: [0.13667, 0.63667, 0, 0, 0.77778],
    8888: [0, 0.54986, 0, 0, 1.11111],
    8890: [0.19444, 0.43056, 0, 0, 0.55556],
    8891: [0.19444, 0.69224, 0, 0, 0.61111],
    8892: [0.19444, 0.69224, 0, 0, 0.61111],
    8901: [0, 0.54986, 0, 0, 0.27778],
    8903: [0.08167, 0.58167, 0, 0, 0.77778],
    8905: [0.08167, 0.58167, 0, 0, 0.77778],
    8906: [0.08167, 0.58167, 0, 0, 0.77778],
    8907: [0, 0.69224, 0, 0, 0.77778],
    8908: [0, 0.69224, 0, 0, 0.77778],
    8909: [-0.03598, 0.46402, 0, 0, 0.77778],
    8910: [0, 0.54986, 0, 0, 0.76042],
    8911: [0, 0.54986, 0, 0, 0.76042],
    8912: [0.03517, 0.54986, 0, 0, 0.77778],
    8913: [0.03517, 0.54986, 0, 0, 0.77778],
    8914: [0, 0.54986, 0, 0, 0.66667],
    8915: [0, 0.54986, 0, 0, 0.66667],
    8916: [0, 0.69224, 0, 0, 0.66667],
    8918: [0.0391, 0.5391, 0, 0, 0.77778],
    8919: [0.0391, 0.5391, 0, 0, 0.77778],
    8920: [0.03517, 0.54986, 0, 0, 1.33334],
    8921: [0.03517, 0.54986, 0, 0, 1.33334],
    8922: [0.38569, 0.88569, 0, 0, 0.77778],
    8923: [0.38569, 0.88569, 0, 0, 0.77778],
    8926: [0.13667, 0.63667, 0, 0, 0.77778],
    8927: [0.13667, 0.63667, 0, 0, 0.77778],
    8928: [0.30274, 0.79383, 0, 0, 0.77778],
    8929: [0.30274, 0.79383, 0, 0, 0.77778],
    8934: [0.23222, 0.74111, 0, 0, 0.77778],
    8935: [0.23222, 0.74111, 0, 0, 0.77778],
    8936: [0.23222, 0.74111, 0, 0, 0.77778],
    8937: [0.23222, 0.74111, 0, 0, 0.77778],
    8938: [0.20576, 0.70576, 0, 0, 0.77778],
    8939: [0.20576, 0.70576, 0, 0, 0.77778],
    8940: [0.30274, 0.79383, 0, 0, 0.77778],
    8941: [0.30274, 0.79383, 0, 0, 0.77778],
    8994: [0.19444, 0.69224, 0, 0, 0.77778],
    8995: [0.19444, 0.69224, 0, 0, 0.77778],
    9416: [0.15559, 0.69224, 0, 0, 0.90222],
    9484: [0, 0.69224, 0, 0, 0.5],
    9488: [0, 0.69224, 0, 0, 0.5],
    9492: [0, 0.37788, 0, 0, 0.5],
    9496: [0, 0.37788, 0, 0, 0.5],
    9585: [0.19444, 0.68889, 0, 0, 0.88889],
    9586: [0.19444, 0.74111, 0, 0, 0.88889],
    9632: [0, 0.675, 0, 0, 0.77778],
    9633: [0, 0.675, 0, 0, 0.77778],
    9650: [0, 0.54986, 0, 0, 0.72222],
    9651: [0, 0.54986, 0, 0, 0.72222],
    9654: [0.03517, 0.54986, 0, 0, 0.77778],
    9660: [0, 0.54986, 0, 0, 0.72222],
    9661: [0, 0.54986, 0, 0, 0.72222],
    9664: [0.03517, 0.54986, 0, 0, 0.77778],
    9674: [0.11111, 0.69224, 0, 0, 0.66667],
    9733: [0.19444, 0.69224, 0, 0, 0.94445],
    10003: [0, 0.69224, 0, 0, 0.83334],
    10016: [0, 0.69224, 0, 0, 0.83334],
    10731: [0.11111, 0.69224, 0, 0, 0.66667],
    10846: [0.19444, 0.75583, 0, 0, 0.61111],
    10877: [0.13667, 0.63667, 0, 0, 0.77778],
    10878: [0.13667, 0.63667, 0, 0, 0.77778],
    10885: [0.25583, 0.75583, 0, 0, 0.77778],
    10886: [0.25583, 0.75583, 0, 0, 0.77778],
    10887: [0.13597, 0.63597, 0, 0, 0.77778],
    10888: [0.13597, 0.63597, 0, 0, 0.77778],
    10889: [0.26167, 0.75726, 0, 0, 0.77778],
    10890: [0.26167, 0.75726, 0, 0, 0.77778],
    10891: [0.48256, 0.98256, 0, 0, 0.77778],
    10892: [0.48256, 0.98256, 0, 0, 0.77778],
    10901: [0.13667, 0.63667, 0, 0, 0.77778],
    10902: [0.13667, 0.63667, 0, 0, 0.77778],
    10933: [0.25142, 0.75726, 0, 0, 0.77778],
    10934: [0.25142, 0.75726, 0, 0, 0.77778],
    10935: [0.26167, 0.75726, 0, 0, 0.77778],
    10936: [0.26167, 0.75726, 0, 0, 0.77778],
    10937: [0.26167, 0.75726, 0, 0, 0.77778],
    10938: [0.26167, 0.75726, 0, 0, 0.77778],
    10949: [0.25583, 0.75583, 0, 0, 0.77778],
    10950: [0.25583, 0.75583, 0, 0, 0.77778],
    10955: [0.28481, 0.79383, 0, 0, 0.77778],
    10956: [0.28481, 0.79383, 0, 0, 0.77778],
    57350: [0.08167, 0.58167, 0, 0, 0.22222],
    57351: [0.08167, 0.58167, 0, 0, 0.38889],
    57352: [0.08167, 0.58167, 0, 0, 0.77778],
    57353: [0, 0.43056, 0.04028, 0, 0.66667],
    57356: [0.25142, 0.75726, 0, 0, 0.77778],
    57357: [0.25142, 0.75726, 0, 0, 0.77778],
    57358: [0.41951, 0.91951, 0, 0, 0.77778],
    57359: [0.30274, 0.79383, 0, 0, 0.77778],
    57360: [0.30274, 0.79383, 0, 0, 0.77778],
    57361: [0.41951, 0.91951, 0, 0, 0.77778],
    57366: [0.25142, 0.75726, 0, 0, 0.77778],
    57367: [0.25142, 0.75726, 0, 0, 0.77778],
    57368: [0.25142, 0.75726, 0, 0, 0.77778],
    57369: [0.25142, 0.75726, 0, 0, 0.77778],
    57370: [0.13597, 0.63597, 0, 0, 0.77778],
    57371: [0.13597, 0.63597, 0, 0, 0.77778]
  },
  "Caligraphic-Regular": {
    32: [0, 0, 0, 0, 0.25],
    65: [0, 0.68333, 0, 0.19445, 0.79847],
    66: [0, 0.68333, 0.03041, 0.13889, 0.65681],
    67: [0, 0.68333, 0.05834, 0.13889, 0.52653],
    68: [0, 0.68333, 0.02778, 0.08334, 0.77139],
    69: [0, 0.68333, 0.08944, 0.11111, 0.52778],
    70: [0, 0.68333, 0.09931, 0.11111, 0.71875],
    71: [0.09722, 0.68333, 0.0593, 0.11111, 0.59487],
    72: [0, 0.68333, 965e-5, 0.11111, 0.84452],
    73: [0, 0.68333, 0.07382, 0, 0.54452],
    74: [0.09722, 0.68333, 0.18472, 0.16667, 0.67778],
    75: [0, 0.68333, 0.01445, 0.05556, 0.76195],
    76: [0, 0.68333, 0, 0.13889, 0.68972],
    77: [0, 0.68333, 0, 0.13889, 1.2009],
    78: [0, 0.68333, 0.14736, 0.08334, 0.82049],
    79: [0, 0.68333, 0.02778, 0.11111, 0.79611],
    80: [0, 0.68333, 0.08222, 0.08334, 0.69556],
    81: [0.09722, 0.68333, 0, 0.11111, 0.81667],
    82: [0, 0.68333, 0, 0.08334, 0.8475],
    83: [0, 0.68333, 0.075, 0.13889, 0.60556],
    84: [0, 0.68333, 0.25417, 0, 0.54464],
    85: [0, 0.68333, 0.09931, 0.08334, 0.62583],
    86: [0, 0.68333, 0.08222, 0, 0.61278],
    87: [0, 0.68333, 0.08222, 0.08334, 0.98778],
    88: [0, 0.68333, 0.14643, 0.13889, 0.7133],
    89: [0.09722, 0.68333, 0.08222, 0.08334, 0.66834],
    90: [0, 0.68333, 0.07944, 0.13889, 0.72473],
    160: [0, 0, 0, 0, 0.25]
  },
  "Fraktur-Regular": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69141, 0, 0, 0.29574],
    34: [0, 0.69141, 0, 0, 0.21471],
    38: [0, 0.69141, 0, 0, 0.73786],
    39: [0, 0.69141, 0, 0, 0.21201],
    40: [0.24982, 0.74947, 0, 0, 0.38865],
    41: [0.24982, 0.74947, 0, 0, 0.38865],
    42: [0, 0.62119, 0, 0, 0.27764],
    43: [0.08319, 0.58283, 0, 0, 0.75623],
    44: [0, 0.10803, 0, 0, 0.27764],
    45: [0.08319, 0.58283, 0, 0, 0.75623],
    46: [0, 0.10803, 0, 0, 0.27764],
    47: [0.24982, 0.74947, 0, 0, 0.50181],
    48: [0, 0.47534, 0, 0, 0.50181],
    49: [0, 0.47534, 0, 0, 0.50181],
    50: [0, 0.47534, 0, 0, 0.50181],
    51: [0.18906, 0.47534, 0, 0, 0.50181],
    52: [0.18906, 0.47534, 0, 0, 0.50181],
    53: [0.18906, 0.47534, 0, 0, 0.50181],
    54: [0, 0.69141, 0, 0, 0.50181],
    55: [0.18906, 0.47534, 0, 0, 0.50181],
    56: [0, 0.69141, 0, 0, 0.50181],
    57: [0.18906, 0.47534, 0, 0, 0.50181],
    58: [0, 0.47534, 0, 0, 0.21606],
    59: [0.12604, 0.47534, 0, 0, 0.21606],
    61: [-0.13099, 0.36866, 0, 0, 0.75623],
    63: [0, 0.69141, 0, 0, 0.36245],
    65: [0, 0.69141, 0, 0, 0.7176],
    66: [0, 0.69141, 0, 0, 0.88397],
    67: [0, 0.69141, 0, 0, 0.61254],
    68: [0, 0.69141, 0, 0, 0.83158],
    69: [0, 0.69141, 0, 0, 0.66278],
    70: [0.12604, 0.69141, 0, 0, 0.61119],
    71: [0, 0.69141, 0, 0, 0.78539],
    72: [0.06302, 0.69141, 0, 0, 0.7203],
    73: [0, 0.69141, 0, 0, 0.55448],
    74: [0.12604, 0.69141, 0, 0, 0.55231],
    75: [0, 0.69141, 0, 0, 0.66845],
    76: [0, 0.69141, 0, 0, 0.66602],
    77: [0, 0.69141, 0, 0, 1.04953],
    78: [0, 0.69141, 0, 0, 0.83212],
    79: [0, 0.69141, 0, 0, 0.82699],
    80: [0.18906, 0.69141, 0, 0, 0.82753],
    81: [0.03781, 0.69141, 0, 0, 0.82699],
    82: [0, 0.69141, 0, 0, 0.82807],
    83: [0, 0.69141, 0, 0, 0.82861],
    84: [0, 0.69141, 0, 0, 0.66899],
    85: [0, 0.69141, 0, 0, 0.64576],
    86: [0, 0.69141, 0, 0, 0.83131],
    87: [0, 0.69141, 0, 0, 1.04602],
    88: [0, 0.69141, 0, 0, 0.71922],
    89: [0.18906, 0.69141, 0, 0, 0.83293],
    90: [0.12604, 0.69141, 0, 0, 0.60201],
    91: [0.24982, 0.74947, 0, 0, 0.27764],
    93: [0.24982, 0.74947, 0, 0, 0.27764],
    94: [0, 0.69141, 0, 0, 0.49965],
    97: [0, 0.47534, 0, 0, 0.50046],
    98: [0, 0.69141, 0, 0, 0.51315],
    99: [0, 0.47534, 0, 0, 0.38946],
    100: [0, 0.62119, 0, 0, 0.49857],
    101: [0, 0.47534, 0, 0, 0.40053],
    102: [0.18906, 0.69141, 0, 0, 0.32626],
    103: [0.18906, 0.47534, 0, 0, 0.5037],
    104: [0.18906, 0.69141, 0, 0, 0.52126],
    105: [0, 0.69141, 0, 0, 0.27899],
    106: [0, 0.69141, 0, 0, 0.28088],
    107: [0, 0.69141, 0, 0, 0.38946],
    108: [0, 0.69141, 0, 0, 0.27953],
    109: [0, 0.47534, 0, 0, 0.76676],
    110: [0, 0.47534, 0, 0, 0.52666],
    111: [0, 0.47534, 0, 0, 0.48885],
    112: [0.18906, 0.52396, 0, 0, 0.50046],
    113: [0.18906, 0.47534, 0, 0, 0.48912],
    114: [0, 0.47534, 0, 0, 0.38919],
    115: [0, 0.47534, 0, 0, 0.44266],
    116: [0, 0.62119, 0, 0, 0.33301],
    117: [0, 0.47534, 0, 0, 0.5172],
    118: [0, 0.52396, 0, 0, 0.5118],
    119: [0, 0.52396, 0, 0, 0.77351],
    120: [0.18906, 0.47534, 0, 0, 0.38865],
    121: [0.18906, 0.47534, 0, 0, 0.49884],
    122: [0.18906, 0.47534, 0, 0, 0.39054],
    160: [0, 0, 0, 0, 0.25],
    8216: [0, 0.69141, 0, 0, 0.21471],
    8217: [0, 0.69141, 0, 0, 0.21471],
    58112: [0, 0.62119, 0, 0, 0.49749],
    58113: [0, 0.62119, 0, 0, 0.4983],
    58114: [0.18906, 0.69141, 0, 0, 0.33328],
    58115: [0.18906, 0.69141, 0, 0, 0.32923],
    58116: [0.18906, 0.47534, 0, 0, 0.50343],
    58117: [0, 0.69141, 0, 0, 0.33301],
    58118: [0, 0.62119, 0, 0, 0.33409],
    58119: [0, 0.47534, 0, 0, 0.50073]
  },
  "Main-Bold": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0, 0, 0.35],
    34: [0, 0.69444, 0, 0, 0.60278],
    35: [0.19444, 0.69444, 0, 0, 0.95833],
    36: [0.05556, 0.75, 0, 0, 0.575],
    37: [0.05556, 0.75, 0, 0, 0.95833],
    38: [0, 0.69444, 0, 0, 0.89444],
    39: [0, 0.69444, 0, 0, 0.31944],
    40: [0.25, 0.75, 0, 0, 0.44722],
    41: [0.25, 0.75, 0, 0, 0.44722],
    42: [0, 0.75, 0, 0, 0.575],
    43: [0.13333, 0.63333, 0, 0, 0.89444],
    44: [0.19444, 0.15556, 0, 0, 0.31944],
    45: [0, 0.44444, 0, 0, 0.38333],
    46: [0, 0.15556, 0, 0, 0.31944],
    47: [0.25, 0.75, 0, 0, 0.575],
    48: [0, 0.64444, 0, 0, 0.575],
    49: [0, 0.64444, 0, 0, 0.575],
    50: [0, 0.64444, 0, 0, 0.575],
    51: [0, 0.64444, 0, 0, 0.575],
    52: [0, 0.64444, 0, 0, 0.575],
    53: [0, 0.64444, 0, 0, 0.575],
    54: [0, 0.64444, 0, 0, 0.575],
    55: [0, 0.64444, 0, 0, 0.575],
    56: [0, 0.64444, 0, 0, 0.575],
    57: [0, 0.64444, 0, 0, 0.575],
    58: [0, 0.44444, 0, 0, 0.31944],
    59: [0.19444, 0.44444, 0, 0, 0.31944],
    60: [0.08556, 0.58556, 0, 0, 0.89444],
    61: [-0.10889, 0.39111, 0, 0, 0.89444],
    62: [0.08556, 0.58556, 0, 0, 0.89444],
    63: [0, 0.69444, 0, 0, 0.54305],
    64: [0, 0.69444, 0, 0, 0.89444],
    65: [0, 0.68611, 0, 0, 0.86944],
    66: [0, 0.68611, 0, 0, 0.81805],
    67: [0, 0.68611, 0, 0, 0.83055],
    68: [0, 0.68611, 0, 0, 0.88194],
    69: [0, 0.68611, 0, 0, 0.75555],
    70: [0, 0.68611, 0, 0, 0.72361],
    71: [0, 0.68611, 0, 0, 0.90416],
    72: [0, 0.68611, 0, 0, 0.9],
    73: [0, 0.68611, 0, 0, 0.43611],
    74: [0, 0.68611, 0, 0, 0.59444],
    75: [0, 0.68611, 0, 0, 0.90138],
    76: [0, 0.68611, 0, 0, 0.69166],
    77: [0, 0.68611, 0, 0, 1.09166],
    78: [0, 0.68611, 0, 0, 0.9],
    79: [0, 0.68611, 0, 0, 0.86388],
    80: [0, 0.68611, 0, 0, 0.78611],
    81: [0.19444, 0.68611, 0, 0, 0.86388],
    82: [0, 0.68611, 0, 0, 0.8625],
    83: [0, 0.68611, 0, 0, 0.63889],
    84: [0, 0.68611, 0, 0, 0.8],
    85: [0, 0.68611, 0, 0, 0.88472],
    86: [0, 0.68611, 0.01597, 0, 0.86944],
    87: [0, 0.68611, 0.01597, 0, 1.18888],
    88: [0, 0.68611, 0, 0, 0.86944],
    89: [0, 0.68611, 0.02875, 0, 0.86944],
    90: [0, 0.68611, 0, 0, 0.70277],
    91: [0.25, 0.75, 0, 0, 0.31944],
    92: [0.25, 0.75, 0, 0, 0.575],
    93: [0.25, 0.75, 0, 0, 0.31944],
    94: [0, 0.69444, 0, 0, 0.575],
    95: [0.31, 0.13444, 0.03194, 0, 0.575],
    97: [0, 0.44444, 0, 0, 0.55902],
    98: [0, 0.69444, 0, 0, 0.63889],
    99: [0, 0.44444, 0, 0, 0.51111],
    100: [0, 0.69444, 0, 0, 0.63889],
    101: [0, 0.44444, 0, 0, 0.52708],
    102: [0, 0.69444, 0.10903, 0, 0.35139],
    103: [0.19444, 0.44444, 0.01597, 0, 0.575],
    104: [0, 0.69444, 0, 0, 0.63889],
    105: [0, 0.69444, 0, 0, 0.31944],
    106: [0.19444, 0.69444, 0, 0, 0.35139],
    107: [0, 0.69444, 0, 0, 0.60694],
    108: [0, 0.69444, 0, 0, 0.31944],
    109: [0, 0.44444, 0, 0, 0.95833],
    110: [0, 0.44444, 0, 0, 0.63889],
    111: [0, 0.44444, 0, 0, 0.575],
    112: [0.19444, 0.44444, 0, 0, 0.63889],
    113: [0.19444, 0.44444, 0, 0, 0.60694],
    114: [0, 0.44444, 0, 0, 0.47361],
    115: [0, 0.44444, 0, 0, 0.45361],
    116: [0, 0.63492, 0, 0, 0.44722],
    117: [0, 0.44444, 0, 0, 0.63889],
    118: [0, 0.44444, 0.01597, 0, 0.60694],
    119: [0, 0.44444, 0.01597, 0, 0.83055],
    120: [0, 0.44444, 0, 0, 0.60694],
    121: [0.19444, 0.44444, 0.01597, 0, 0.60694],
    122: [0, 0.44444, 0, 0, 0.51111],
    123: [0.25, 0.75, 0, 0, 0.575],
    124: [0.25, 0.75, 0, 0, 0.31944],
    125: [0.25, 0.75, 0, 0, 0.575],
    126: [0.35, 0.34444, 0, 0, 0.575],
    160: [0, 0, 0, 0, 0.25],
    163: [0, 0.69444, 0, 0, 0.86853],
    168: [0, 0.69444, 0, 0, 0.575],
    172: [0, 0.44444, 0, 0, 0.76666],
    176: [0, 0.69444, 0, 0, 0.86944],
    177: [0.13333, 0.63333, 0, 0, 0.89444],
    184: [0.17014, 0, 0, 0, 0.51111],
    198: [0, 0.68611, 0, 0, 1.04166],
    215: [0.13333, 0.63333, 0, 0, 0.89444],
    216: [0.04861, 0.73472, 0, 0, 0.89444],
    223: [0, 0.69444, 0, 0, 0.59722],
    230: [0, 0.44444, 0, 0, 0.83055],
    247: [0.13333, 0.63333, 0, 0, 0.89444],
    248: [0.09722, 0.54167, 0, 0, 0.575],
    305: [0, 0.44444, 0, 0, 0.31944],
    338: [0, 0.68611, 0, 0, 1.16944],
    339: [0, 0.44444, 0, 0, 0.89444],
    567: [0.19444, 0.44444, 0, 0, 0.35139],
    710: [0, 0.69444, 0, 0, 0.575],
    711: [0, 0.63194, 0, 0, 0.575],
    713: [0, 0.59611, 0, 0, 0.575],
    714: [0, 0.69444, 0, 0, 0.575],
    715: [0, 0.69444, 0, 0, 0.575],
    728: [0, 0.69444, 0, 0, 0.575],
    729: [0, 0.69444, 0, 0, 0.31944],
    730: [0, 0.69444, 0, 0, 0.86944],
    732: [0, 0.69444, 0, 0, 0.575],
    733: [0, 0.69444, 0, 0, 0.575],
    915: [0, 0.68611, 0, 0, 0.69166],
    916: [0, 0.68611, 0, 0, 0.95833],
    920: [0, 0.68611, 0, 0, 0.89444],
    923: [0, 0.68611, 0, 0, 0.80555],
    926: [0, 0.68611, 0, 0, 0.76666],
    928: [0, 0.68611, 0, 0, 0.9],
    931: [0, 0.68611, 0, 0, 0.83055],
    933: [0, 0.68611, 0, 0, 0.89444],
    934: [0, 0.68611, 0, 0, 0.83055],
    936: [0, 0.68611, 0, 0, 0.89444],
    937: [0, 0.68611, 0, 0, 0.83055],
    8211: [0, 0.44444, 0.03194, 0, 0.575],
    8212: [0, 0.44444, 0.03194, 0, 1.14999],
    8216: [0, 0.69444, 0, 0, 0.31944],
    8217: [0, 0.69444, 0, 0, 0.31944],
    8220: [0, 0.69444, 0, 0, 0.60278],
    8221: [0, 0.69444, 0, 0, 0.60278],
    8224: [0.19444, 0.69444, 0, 0, 0.51111],
    8225: [0.19444, 0.69444, 0, 0, 0.51111],
    8242: [0, 0.55556, 0, 0, 0.34444],
    8407: [0, 0.72444, 0.15486, 0, 0.575],
    8463: [0, 0.69444, 0, 0, 0.66759],
    8465: [0, 0.69444, 0, 0, 0.83055],
    8467: [0, 0.69444, 0, 0, 0.47361],
    8472: [0.19444, 0.44444, 0, 0, 0.74027],
    8476: [0, 0.69444, 0, 0, 0.83055],
    8501: [0, 0.69444, 0, 0, 0.70277],
    8592: [-0.10889, 0.39111, 0, 0, 1.14999],
    8593: [0.19444, 0.69444, 0, 0, 0.575],
    8594: [-0.10889, 0.39111, 0, 0, 1.14999],
    8595: [0.19444, 0.69444, 0, 0, 0.575],
    8596: [-0.10889, 0.39111, 0, 0, 1.14999],
    8597: [0.25, 0.75, 0, 0, 0.575],
    8598: [0.19444, 0.69444, 0, 0, 1.14999],
    8599: [0.19444, 0.69444, 0, 0, 1.14999],
    8600: [0.19444, 0.69444, 0, 0, 1.14999],
    8601: [0.19444, 0.69444, 0, 0, 1.14999],
    8636: [-0.10889, 0.39111, 0, 0, 1.14999],
    8637: [-0.10889, 0.39111, 0, 0, 1.14999],
    8640: [-0.10889, 0.39111, 0, 0, 1.14999],
    8641: [-0.10889, 0.39111, 0, 0, 1.14999],
    8656: [-0.10889, 0.39111, 0, 0, 1.14999],
    8657: [0.19444, 0.69444, 0, 0, 0.70277],
    8658: [-0.10889, 0.39111, 0, 0, 1.14999],
    8659: [0.19444, 0.69444, 0, 0, 0.70277],
    8660: [-0.10889, 0.39111, 0, 0, 1.14999],
    8661: [0.25, 0.75, 0, 0, 0.70277],
    8704: [0, 0.69444, 0, 0, 0.63889],
    8706: [0, 0.69444, 0.06389, 0, 0.62847],
    8707: [0, 0.69444, 0, 0, 0.63889],
    8709: [0.05556, 0.75, 0, 0, 0.575],
    8711: [0, 0.68611, 0, 0, 0.95833],
    8712: [0.08556, 0.58556, 0, 0, 0.76666],
    8715: [0.08556, 0.58556, 0, 0, 0.76666],
    8722: [0.13333, 0.63333, 0, 0, 0.89444],
    8723: [0.13333, 0.63333, 0, 0, 0.89444],
    8725: [0.25, 0.75, 0, 0, 0.575],
    8726: [0.25, 0.75, 0, 0, 0.575],
    8727: [-0.02778, 0.47222, 0, 0, 0.575],
    8728: [-0.02639, 0.47361, 0, 0, 0.575],
    8729: [-0.02639, 0.47361, 0, 0, 0.575],
    8730: [0.18, 0.82, 0, 0, 0.95833],
    8733: [0, 0.44444, 0, 0, 0.89444],
    8734: [0, 0.44444, 0, 0, 1.14999],
    8736: [0, 0.69224, 0, 0, 0.72222],
    8739: [0.25, 0.75, 0, 0, 0.31944],
    8741: [0.25, 0.75, 0, 0, 0.575],
    8743: [0, 0.55556, 0, 0, 0.76666],
    8744: [0, 0.55556, 0, 0, 0.76666],
    8745: [0, 0.55556, 0, 0, 0.76666],
    8746: [0, 0.55556, 0, 0, 0.76666],
    8747: [0.19444, 0.69444, 0.12778, 0, 0.56875],
    8764: [-0.10889, 0.39111, 0, 0, 0.89444],
    8768: [0.19444, 0.69444, 0, 0, 0.31944],
    8771: [222e-5, 0.50222, 0, 0, 0.89444],
    8773: [0.027, 0.638, 0, 0, 0.894],
    8776: [0.02444, 0.52444, 0, 0, 0.89444],
    8781: [222e-5, 0.50222, 0, 0, 0.89444],
    8801: [222e-5, 0.50222, 0, 0, 0.89444],
    8804: [0.19667, 0.69667, 0, 0, 0.89444],
    8805: [0.19667, 0.69667, 0, 0, 0.89444],
    8810: [0.08556, 0.58556, 0, 0, 1.14999],
    8811: [0.08556, 0.58556, 0, 0, 1.14999],
    8826: [0.08556, 0.58556, 0, 0, 0.89444],
    8827: [0.08556, 0.58556, 0, 0, 0.89444],
    8834: [0.08556, 0.58556, 0, 0, 0.89444],
    8835: [0.08556, 0.58556, 0, 0, 0.89444],
    8838: [0.19667, 0.69667, 0, 0, 0.89444],
    8839: [0.19667, 0.69667, 0, 0, 0.89444],
    8846: [0, 0.55556, 0, 0, 0.76666],
    8849: [0.19667, 0.69667, 0, 0, 0.89444],
    8850: [0.19667, 0.69667, 0, 0, 0.89444],
    8851: [0, 0.55556, 0, 0, 0.76666],
    8852: [0, 0.55556, 0, 0, 0.76666],
    8853: [0.13333, 0.63333, 0, 0, 0.89444],
    8854: [0.13333, 0.63333, 0, 0, 0.89444],
    8855: [0.13333, 0.63333, 0, 0, 0.89444],
    8856: [0.13333, 0.63333, 0, 0, 0.89444],
    8857: [0.13333, 0.63333, 0, 0, 0.89444],
    8866: [0, 0.69444, 0, 0, 0.70277],
    8867: [0, 0.69444, 0, 0, 0.70277],
    8868: [0, 0.69444, 0, 0, 0.89444],
    8869: [0, 0.69444, 0, 0, 0.89444],
    8900: [-0.02639, 0.47361, 0, 0, 0.575],
    8901: [-0.02639, 0.47361, 0, 0, 0.31944],
    8902: [-0.02778, 0.47222, 0, 0, 0.575],
    8968: [0.25, 0.75, 0, 0, 0.51111],
    8969: [0.25, 0.75, 0, 0, 0.51111],
    8970: [0.25, 0.75, 0, 0, 0.51111],
    8971: [0.25, 0.75, 0, 0, 0.51111],
    8994: [-0.13889, 0.36111, 0, 0, 1.14999],
    8995: [-0.13889, 0.36111, 0, 0, 1.14999],
    9651: [0.19444, 0.69444, 0, 0, 1.02222],
    9657: [-0.02778, 0.47222, 0, 0, 0.575],
    9661: [0.19444, 0.69444, 0, 0, 1.02222],
    9667: [-0.02778, 0.47222, 0, 0, 0.575],
    9711: [0.19444, 0.69444, 0, 0, 1.14999],
    9824: [0.12963, 0.69444, 0, 0, 0.89444],
    9825: [0.12963, 0.69444, 0, 0, 0.89444],
    9826: [0.12963, 0.69444, 0, 0, 0.89444],
    9827: [0.12963, 0.69444, 0, 0, 0.89444],
    9837: [0, 0.75, 0, 0, 0.44722],
    9838: [0.19444, 0.69444, 0, 0, 0.44722],
    9839: [0.19444, 0.69444, 0, 0, 0.44722],
    10216: [0.25, 0.75, 0, 0, 0.44722],
    10217: [0.25, 0.75, 0, 0, 0.44722],
    10815: [0, 0.68611, 0, 0, 0.9],
    10927: [0.19667, 0.69667, 0, 0, 0.89444],
    10928: [0.19667, 0.69667, 0, 0, 0.89444],
    57376: [0.19444, 0.69444, 0, 0, 0]
  },
  "Main-BoldItalic": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0.11417, 0, 0.38611],
    34: [0, 0.69444, 0.07939, 0, 0.62055],
    35: [0.19444, 0.69444, 0.06833, 0, 0.94444],
    37: [0.05556, 0.75, 0.12861, 0, 0.94444],
    38: [0, 0.69444, 0.08528, 0, 0.88555],
    39: [0, 0.69444, 0.12945, 0, 0.35555],
    40: [0.25, 0.75, 0.15806, 0, 0.47333],
    41: [0.25, 0.75, 0.03306, 0, 0.47333],
    42: [0, 0.75, 0.14333, 0, 0.59111],
    43: [0.10333, 0.60333, 0.03306, 0, 0.88555],
    44: [0.19444, 0.14722, 0, 0, 0.35555],
    45: [0, 0.44444, 0.02611, 0, 0.41444],
    46: [0, 0.14722, 0, 0, 0.35555],
    47: [0.25, 0.75, 0.15806, 0, 0.59111],
    48: [0, 0.64444, 0.13167, 0, 0.59111],
    49: [0, 0.64444, 0.13167, 0, 0.59111],
    50: [0, 0.64444, 0.13167, 0, 0.59111],
    51: [0, 0.64444, 0.13167, 0, 0.59111],
    52: [0.19444, 0.64444, 0.13167, 0, 0.59111],
    53: [0, 0.64444, 0.13167, 0, 0.59111],
    54: [0, 0.64444, 0.13167, 0, 0.59111],
    55: [0.19444, 0.64444, 0.13167, 0, 0.59111],
    56: [0, 0.64444, 0.13167, 0, 0.59111],
    57: [0, 0.64444, 0.13167, 0, 0.59111],
    58: [0, 0.44444, 0.06695, 0, 0.35555],
    59: [0.19444, 0.44444, 0.06695, 0, 0.35555],
    61: [-0.10889, 0.39111, 0.06833, 0, 0.88555],
    63: [0, 0.69444, 0.11472, 0, 0.59111],
    64: [0, 0.69444, 0.09208, 0, 0.88555],
    65: [0, 0.68611, 0, 0, 0.86555],
    66: [0, 0.68611, 0.0992, 0, 0.81666],
    67: [0, 0.68611, 0.14208, 0, 0.82666],
    68: [0, 0.68611, 0.09062, 0, 0.87555],
    69: [0, 0.68611, 0.11431, 0, 0.75666],
    70: [0, 0.68611, 0.12903, 0, 0.72722],
    71: [0, 0.68611, 0.07347, 0, 0.89527],
    72: [0, 0.68611, 0.17208, 0, 0.8961],
    73: [0, 0.68611, 0.15681, 0, 0.47166],
    74: [0, 0.68611, 0.145, 0, 0.61055],
    75: [0, 0.68611, 0.14208, 0, 0.89499],
    76: [0, 0.68611, 0, 0, 0.69777],
    77: [0, 0.68611, 0.17208, 0, 1.07277],
    78: [0, 0.68611, 0.17208, 0, 0.8961],
    79: [0, 0.68611, 0.09062, 0, 0.85499],
    80: [0, 0.68611, 0.0992, 0, 0.78721],
    81: [0.19444, 0.68611, 0.09062, 0, 0.85499],
    82: [0, 0.68611, 0.02559, 0, 0.85944],
    83: [0, 0.68611, 0.11264, 0, 0.64999],
    84: [0, 0.68611, 0.12903, 0, 0.7961],
    85: [0, 0.68611, 0.17208, 0, 0.88083],
    86: [0, 0.68611, 0.18625, 0, 0.86555],
    87: [0, 0.68611, 0.18625, 0, 1.15999],
    88: [0, 0.68611, 0.15681, 0, 0.86555],
    89: [0, 0.68611, 0.19803, 0, 0.86555],
    90: [0, 0.68611, 0.14208, 0, 0.70888],
    91: [0.25, 0.75, 0.1875, 0, 0.35611],
    93: [0.25, 0.75, 0.09972, 0, 0.35611],
    94: [0, 0.69444, 0.06709, 0, 0.59111],
    95: [0.31, 0.13444, 0.09811, 0, 0.59111],
    97: [0, 0.44444, 0.09426, 0, 0.59111],
    98: [0, 0.69444, 0.07861, 0, 0.53222],
    99: [0, 0.44444, 0.05222, 0, 0.53222],
    100: [0, 0.69444, 0.10861, 0, 0.59111],
    101: [0, 0.44444, 0.085, 0, 0.53222],
    102: [0.19444, 0.69444, 0.21778, 0, 0.4],
    103: [0.19444, 0.44444, 0.105, 0, 0.53222],
    104: [0, 0.69444, 0.09426, 0, 0.59111],
    105: [0, 0.69326, 0.11387, 0, 0.35555],
    106: [0.19444, 0.69326, 0.1672, 0, 0.35555],
    107: [0, 0.69444, 0.11111, 0, 0.53222],
    108: [0, 0.69444, 0.10861, 0, 0.29666],
    109: [0, 0.44444, 0.09426, 0, 0.94444],
    110: [0, 0.44444, 0.09426, 0, 0.64999],
    111: [0, 0.44444, 0.07861, 0, 0.59111],
    112: [0.19444, 0.44444, 0.07861, 0, 0.59111],
    113: [0.19444, 0.44444, 0.105, 0, 0.53222],
    114: [0, 0.44444, 0.11111, 0, 0.50167],
    115: [0, 0.44444, 0.08167, 0, 0.48694],
    116: [0, 0.63492, 0.09639, 0, 0.385],
    117: [0, 0.44444, 0.09426, 0, 0.62055],
    118: [0, 0.44444, 0.11111, 0, 0.53222],
    119: [0, 0.44444, 0.11111, 0, 0.76777],
    120: [0, 0.44444, 0.12583, 0, 0.56055],
    121: [0.19444, 0.44444, 0.105, 0, 0.56166],
    122: [0, 0.44444, 0.13889, 0, 0.49055],
    126: [0.35, 0.34444, 0.11472, 0, 0.59111],
    160: [0, 0, 0, 0, 0.25],
    168: [0, 0.69444, 0.11473, 0, 0.59111],
    176: [0, 0.69444, 0, 0, 0.94888],
    184: [0.17014, 0, 0, 0, 0.53222],
    198: [0, 0.68611, 0.11431, 0, 1.02277],
    216: [0.04861, 0.73472, 0.09062, 0, 0.88555],
    223: [0.19444, 0.69444, 0.09736, 0, 0.665],
    230: [0, 0.44444, 0.085, 0, 0.82666],
    248: [0.09722, 0.54167, 0.09458, 0, 0.59111],
    305: [0, 0.44444, 0.09426, 0, 0.35555],
    338: [0, 0.68611, 0.11431, 0, 1.14054],
    339: [0, 0.44444, 0.085, 0, 0.82666],
    567: [0.19444, 0.44444, 0.04611, 0, 0.385],
    710: [0, 0.69444, 0.06709, 0, 0.59111],
    711: [0, 0.63194, 0.08271, 0, 0.59111],
    713: [0, 0.59444, 0.10444, 0, 0.59111],
    714: [0, 0.69444, 0.08528, 0, 0.59111],
    715: [0, 0.69444, 0, 0, 0.59111],
    728: [0, 0.69444, 0.10333, 0, 0.59111],
    729: [0, 0.69444, 0.12945, 0, 0.35555],
    730: [0, 0.69444, 0, 0, 0.94888],
    732: [0, 0.69444, 0.11472, 0, 0.59111],
    733: [0, 0.69444, 0.11472, 0, 0.59111],
    915: [0, 0.68611, 0.12903, 0, 0.69777],
    916: [0, 0.68611, 0, 0, 0.94444],
    920: [0, 0.68611, 0.09062, 0, 0.88555],
    923: [0, 0.68611, 0, 0, 0.80666],
    926: [0, 0.68611, 0.15092, 0, 0.76777],
    928: [0, 0.68611, 0.17208, 0, 0.8961],
    931: [0, 0.68611, 0.11431, 0, 0.82666],
    933: [0, 0.68611, 0.10778, 0, 0.88555],
    934: [0, 0.68611, 0.05632, 0, 0.82666],
    936: [0, 0.68611, 0.10778, 0, 0.88555],
    937: [0, 0.68611, 0.0992, 0, 0.82666],
    8211: [0, 0.44444, 0.09811, 0, 0.59111],
    8212: [0, 0.44444, 0.09811, 0, 1.18221],
    8216: [0, 0.69444, 0.12945, 0, 0.35555],
    8217: [0, 0.69444, 0.12945, 0, 0.35555],
    8220: [0, 0.69444, 0.16772, 0, 0.62055],
    8221: [0, 0.69444, 0.07939, 0, 0.62055]
  },
  "Main-Italic": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0.12417, 0, 0.30667],
    34: [0, 0.69444, 0.06961, 0, 0.51444],
    35: [0.19444, 0.69444, 0.06616, 0, 0.81777],
    37: [0.05556, 0.75, 0.13639, 0, 0.81777],
    38: [0, 0.69444, 0.09694, 0, 0.76666],
    39: [0, 0.69444, 0.12417, 0, 0.30667],
    40: [0.25, 0.75, 0.16194, 0, 0.40889],
    41: [0.25, 0.75, 0.03694, 0, 0.40889],
    42: [0, 0.75, 0.14917, 0, 0.51111],
    43: [0.05667, 0.56167, 0.03694, 0, 0.76666],
    44: [0.19444, 0.10556, 0, 0, 0.30667],
    45: [0, 0.43056, 0.02826, 0, 0.35778],
    46: [0, 0.10556, 0, 0, 0.30667],
    47: [0.25, 0.75, 0.16194, 0, 0.51111],
    48: [0, 0.64444, 0.13556, 0, 0.51111],
    49: [0, 0.64444, 0.13556, 0, 0.51111],
    50: [0, 0.64444, 0.13556, 0, 0.51111],
    51: [0, 0.64444, 0.13556, 0, 0.51111],
    52: [0.19444, 0.64444, 0.13556, 0, 0.51111],
    53: [0, 0.64444, 0.13556, 0, 0.51111],
    54: [0, 0.64444, 0.13556, 0, 0.51111],
    55: [0.19444, 0.64444, 0.13556, 0, 0.51111],
    56: [0, 0.64444, 0.13556, 0, 0.51111],
    57: [0, 0.64444, 0.13556, 0, 0.51111],
    58: [0, 0.43056, 0.0582, 0, 0.30667],
    59: [0.19444, 0.43056, 0.0582, 0, 0.30667],
    61: [-0.13313, 0.36687, 0.06616, 0, 0.76666],
    63: [0, 0.69444, 0.1225, 0, 0.51111],
    64: [0, 0.69444, 0.09597, 0, 0.76666],
    65: [0, 0.68333, 0, 0, 0.74333],
    66: [0, 0.68333, 0.10257, 0, 0.70389],
    67: [0, 0.68333, 0.14528, 0, 0.71555],
    68: [0, 0.68333, 0.09403, 0, 0.755],
    69: [0, 0.68333, 0.12028, 0, 0.67833],
    70: [0, 0.68333, 0.13305, 0, 0.65277],
    71: [0, 0.68333, 0.08722, 0, 0.77361],
    72: [0, 0.68333, 0.16389, 0, 0.74333],
    73: [0, 0.68333, 0.15806, 0, 0.38555],
    74: [0, 0.68333, 0.14028, 0, 0.525],
    75: [0, 0.68333, 0.14528, 0, 0.76888],
    76: [0, 0.68333, 0, 0, 0.62722],
    77: [0, 0.68333, 0.16389, 0, 0.89666],
    78: [0, 0.68333, 0.16389, 0, 0.74333],
    79: [0, 0.68333, 0.09403, 0, 0.76666],
    80: [0, 0.68333, 0.10257, 0, 0.67833],
    81: [0.19444, 0.68333, 0.09403, 0, 0.76666],
    82: [0, 0.68333, 0.03868, 0, 0.72944],
    83: [0, 0.68333, 0.11972, 0, 0.56222],
    84: [0, 0.68333, 0.13305, 0, 0.71555],
    85: [0, 0.68333, 0.16389, 0, 0.74333],
    86: [0, 0.68333, 0.18361, 0, 0.74333],
    87: [0, 0.68333, 0.18361, 0, 0.99888],
    88: [0, 0.68333, 0.15806, 0, 0.74333],
    89: [0, 0.68333, 0.19383, 0, 0.74333],
    90: [0, 0.68333, 0.14528, 0, 0.61333],
    91: [0.25, 0.75, 0.1875, 0, 0.30667],
    93: [0.25, 0.75, 0.10528, 0, 0.30667],
    94: [0, 0.69444, 0.06646, 0, 0.51111],
    95: [0.31, 0.12056, 0.09208, 0, 0.51111],
    97: [0, 0.43056, 0.07671, 0, 0.51111],
    98: [0, 0.69444, 0.06312, 0, 0.46],
    99: [0, 0.43056, 0.05653, 0, 0.46],
    100: [0, 0.69444, 0.10333, 0, 0.51111],
    101: [0, 0.43056, 0.07514, 0, 0.46],
    102: [0.19444, 0.69444, 0.21194, 0, 0.30667],
    103: [0.19444, 0.43056, 0.08847, 0, 0.46],
    104: [0, 0.69444, 0.07671, 0, 0.51111],
    105: [0, 0.65536, 0.1019, 0, 0.30667],
    106: [0.19444, 0.65536, 0.14467, 0, 0.30667],
    107: [0, 0.69444, 0.10764, 0, 0.46],
    108: [0, 0.69444, 0.10333, 0, 0.25555],
    109: [0, 0.43056, 0.07671, 0, 0.81777],
    110: [0, 0.43056, 0.07671, 0, 0.56222],
    111: [0, 0.43056, 0.06312, 0, 0.51111],
    112: [0.19444, 0.43056, 0.06312, 0, 0.51111],
    113: [0.19444, 0.43056, 0.08847, 0, 0.46],
    114: [0, 0.43056, 0.10764, 0, 0.42166],
    115: [0, 0.43056, 0.08208, 0, 0.40889],
    116: [0, 0.61508, 0.09486, 0, 0.33222],
    117: [0, 0.43056, 0.07671, 0, 0.53666],
    118: [0, 0.43056, 0.10764, 0, 0.46],
    119: [0, 0.43056, 0.10764, 0, 0.66444],
    120: [0, 0.43056, 0.12042, 0, 0.46389],
    121: [0.19444, 0.43056, 0.08847, 0, 0.48555],
    122: [0, 0.43056, 0.12292, 0, 0.40889],
    126: [0.35, 0.31786, 0.11585, 0, 0.51111],
    160: [0, 0, 0, 0, 0.25],
    168: [0, 0.66786, 0.10474, 0, 0.51111],
    176: [0, 0.69444, 0, 0, 0.83129],
    184: [0.17014, 0, 0, 0, 0.46],
    198: [0, 0.68333, 0.12028, 0, 0.88277],
    216: [0.04861, 0.73194, 0.09403, 0, 0.76666],
    223: [0.19444, 0.69444, 0.10514, 0, 0.53666],
    230: [0, 0.43056, 0.07514, 0, 0.71555],
    248: [0.09722, 0.52778, 0.09194, 0, 0.51111],
    338: [0, 0.68333, 0.12028, 0, 0.98499],
    339: [0, 0.43056, 0.07514, 0, 0.71555],
    710: [0, 0.69444, 0.06646, 0, 0.51111],
    711: [0, 0.62847, 0.08295, 0, 0.51111],
    713: [0, 0.56167, 0.10333, 0, 0.51111],
    714: [0, 0.69444, 0.09694, 0, 0.51111],
    715: [0, 0.69444, 0, 0, 0.51111],
    728: [0, 0.69444, 0.10806, 0, 0.51111],
    729: [0, 0.66786, 0.11752, 0, 0.30667],
    730: [0, 0.69444, 0, 0, 0.83129],
    732: [0, 0.66786, 0.11585, 0, 0.51111],
    733: [0, 0.69444, 0.1225, 0, 0.51111],
    915: [0, 0.68333, 0.13305, 0, 0.62722],
    916: [0, 0.68333, 0, 0, 0.81777],
    920: [0, 0.68333, 0.09403, 0, 0.76666],
    923: [0, 0.68333, 0, 0, 0.69222],
    926: [0, 0.68333, 0.15294, 0, 0.66444],
    928: [0, 0.68333, 0.16389, 0, 0.74333],
    931: [0, 0.68333, 0.12028, 0, 0.71555],
    933: [0, 0.68333, 0.11111, 0, 0.76666],
    934: [0, 0.68333, 0.05986, 0, 0.71555],
    936: [0, 0.68333, 0.11111, 0, 0.76666],
    937: [0, 0.68333, 0.10257, 0, 0.71555],
    8211: [0, 0.43056, 0.09208, 0, 0.51111],
    8212: [0, 0.43056, 0.09208, 0, 1.02222],
    8216: [0, 0.69444, 0.12417, 0, 0.30667],
    8217: [0, 0.69444, 0.12417, 0, 0.30667],
    8220: [0, 0.69444, 0.1685, 0, 0.51444],
    8221: [0, 0.69444, 0.06961, 0, 0.51444],
    8463: [0, 0.68889, 0, 0, 0.54028]
  },
  "Main-Regular": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0, 0, 0.27778],
    34: [0, 0.69444, 0, 0, 0.5],
    35: [0.19444, 0.69444, 0, 0, 0.83334],
    36: [0.05556, 0.75, 0, 0, 0.5],
    37: [0.05556, 0.75, 0, 0, 0.83334],
    38: [0, 0.69444, 0, 0, 0.77778],
    39: [0, 0.69444, 0, 0, 0.27778],
    40: [0.25, 0.75, 0, 0, 0.38889],
    41: [0.25, 0.75, 0, 0, 0.38889],
    42: [0, 0.75, 0, 0, 0.5],
    43: [0.08333, 0.58333, 0, 0, 0.77778],
    44: [0.19444, 0.10556, 0, 0, 0.27778],
    45: [0, 0.43056, 0, 0, 0.33333],
    46: [0, 0.10556, 0, 0, 0.27778],
    47: [0.25, 0.75, 0, 0, 0.5],
    48: [0, 0.64444, 0, 0, 0.5],
    49: [0, 0.64444, 0, 0, 0.5],
    50: [0, 0.64444, 0, 0, 0.5],
    51: [0, 0.64444, 0, 0, 0.5],
    52: [0, 0.64444, 0, 0, 0.5],
    53: [0, 0.64444, 0, 0, 0.5],
    54: [0, 0.64444, 0, 0, 0.5],
    55: [0, 0.64444, 0, 0, 0.5],
    56: [0, 0.64444, 0, 0, 0.5],
    57: [0, 0.64444, 0, 0, 0.5],
    58: [0, 0.43056, 0, 0, 0.27778],
    59: [0.19444, 0.43056, 0, 0, 0.27778],
    60: [0.0391, 0.5391, 0, 0, 0.77778],
    61: [-0.13313, 0.36687, 0, 0, 0.77778],
    62: [0.0391, 0.5391, 0, 0, 0.77778],
    63: [0, 0.69444, 0, 0, 0.47222],
    64: [0, 0.69444, 0, 0, 0.77778],
    65: [0, 0.68333, 0, 0, 0.75],
    66: [0, 0.68333, 0, 0, 0.70834],
    67: [0, 0.68333, 0, 0, 0.72222],
    68: [0, 0.68333, 0, 0, 0.76389],
    69: [0, 0.68333, 0, 0, 0.68056],
    70: [0, 0.68333, 0, 0, 0.65278],
    71: [0, 0.68333, 0, 0, 0.78472],
    72: [0, 0.68333, 0, 0, 0.75],
    73: [0, 0.68333, 0, 0, 0.36111],
    74: [0, 0.68333, 0, 0, 0.51389],
    75: [0, 0.68333, 0, 0, 0.77778],
    76: [0, 0.68333, 0, 0, 0.625],
    77: [0, 0.68333, 0, 0, 0.91667],
    78: [0, 0.68333, 0, 0, 0.75],
    79: [0, 0.68333, 0, 0, 0.77778],
    80: [0, 0.68333, 0, 0, 0.68056],
    81: [0.19444, 0.68333, 0, 0, 0.77778],
    82: [0, 0.68333, 0, 0, 0.73611],
    83: [0, 0.68333, 0, 0, 0.55556],
    84: [0, 0.68333, 0, 0, 0.72222],
    85: [0, 0.68333, 0, 0, 0.75],
    86: [0, 0.68333, 0.01389, 0, 0.75],
    87: [0, 0.68333, 0.01389, 0, 1.02778],
    88: [0, 0.68333, 0, 0, 0.75],
    89: [0, 0.68333, 0.025, 0, 0.75],
    90: [0, 0.68333, 0, 0, 0.61111],
    91: [0.25, 0.75, 0, 0, 0.27778],
    92: [0.25, 0.75, 0, 0, 0.5],
    93: [0.25, 0.75, 0, 0, 0.27778],
    94: [0, 0.69444, 0, 0, 0.5],
    95: [0.31, 0.12056, 0.02778, 0, 0.5],
    97: [0, 0.43056, 0, 0, 0.5],
    98: [0, 0.69444, 0, 0, 0.55556],
    99: [0, 0.43056, 0, 0, 0.44445],
    100: [0, 0.69444, 0, 0, 0.55556],
    101: [0, 0.43056, 0, 0, 0.44445],
    102: [0, 0.69444, 0.07778, 0, 0.30556],
    103: [0.19444, 0.43056, 0.01389, 0, 0.5],
    104: [0, 0.69444, 0, 0, 0.55556],
    105: [0, 0.66786, 0, 0, 0.27778],
    106: [0.19444, 0.66786, 0, 0, 0.30556],
    107: [0, 0.69444, 0, 0, 0.52778],
    108: [0, 0.69444, 0, 0, 0.27778],
    109: [0, 0.43056, 0, 0, 0.83334],
    110: [0, 0.43056, 0, 0, 0.55556],
    111: [0, 0.43056, 0, 0, 0.5],
    112: [0.19444, 0.43056, 0, 0, 0.55556],
    113: [0.19444, 0.43056, 0, 0, 0.52778],
    114: [0, 0.43056, 0, 0, 0.39167],
    115: [0, 0.43056, 0, 0, 0.39445],
    116: [0, 0.61508, 0, 0, 0.38889],
    117: [0, 0.43056, 0, 0, 0.55556],
    118: [0, 0.43056, 0.01389, 0, 0.52778],
    119: [0, 0.43056, 0.01389, 0, 0.72222],
    120: [0, 0.43056, 0, 0, 0.52778],
    121: [0.19444, 0.43056, 0.01389, 0, 0.52778],
    122: [0, 0.43056, 0, 0, 0.44445],
    123: [0.25, 0.75, 0, 0, 0.5],
    124: [0.25, 0.75, 0, 0, 0.27778],
    125: [0.25, 0.75, 0, 0, 0.5],
    126: [0.35, 0.31786, 0, 0, 0.5],
    160: [0, 0, 0, 0, 0.25],
    163: [0, 0.69444, 0, 0, 0.76909],
    167: [0.19444, 0.69444, 0, 0, 0.44445],
    168: [0, 0.66786, 0, 0, 0.5],
    172: [0, 0.43056, 0, 0, 0.66667],
    176: [0, 0.69444, 0, 0, 0.75],
    177: [0.08333, 0.58333, 0, 0, 0.77778],
    182: [0.19444, 0.69444, 0, 0, 0.61111],
    184: [0.17014, 0, 0, 0, 0.44445],
    198: [0, 0.68333, 0, 0, 0.90278],
    215: [0.08333, 0.58333, 0, 0, 0.77778],
    216: [0.04861, 0.73194, 0, 0, 0.77778],
    223: [0, 0.69444, 0, 0, 0.5],
    230: [0, 0.43056, 0, 0, 0.72222],
    247: [0.08333, 0.58333, 0, 0, 0.77778],
    248: [0.09722, 0.52778, 0, 0, 0.5],
    305: [0, 0.43056, 0, 0, 0.27778],
    338: [0, 0.68333, 0, 0, 1.01389],
    339: [0, 0.43056, 0, 0, 0.77778],
    567: [0.19444, 0.43056, 0, 0, 0.30556],
    710: [0, 0.69444, 0, 0, 0.5],
    711: [0, 0.62847, 0, 0, 0.5],
    713: [0, 0.56778, 0, 0, 0.5],
    714: [0, 0.69444, 0, 0, 0.5],
    715: [0, 0.69444, 0, 0, 0.5],
    728: [0, 0.69444, 0, 0, 0.5],
    729: [0, 0.66786, 0, 0, 0.27778],
    730: [0, 0.69444, 0, 0, 0.75],
    732: [0, 0.66786, 0, 0, 0.5],
    733: [0, 0.69444, 0, 0, 0.5],
    915: [0, 0.68333, 0, 0, 0.625],
    916: [0, 0.68333, 0, 0, 0.83334],
    920: [0, 0.68333, 0, 0, 0.77778],
    923: [0, 0.68333, 0, 0, 0.69445],
    926: [0, 0.68333, 0, 0, 0.66667],
    928: [0, 0.68333, 0, 0, 0.75],
    931: [0, 0.68333, 0, 0, 0.72222],
    933: [0, 0.68333, 0, 0, 0.77778],
    934: [0, 0.68333, 0, 0, 0.72222],
    936: [0, 0.68333, 0, 0, 0.77778],
    937: [0, 0.68333, 0, 0, 0.72222],
    8211: [0, 0.43056, 0.02778, 0, 0.5],
    8212: [0, 0.43056, 0.02778, 0, 1],
    8216: [0, 0.69444, 0, 0, 0.27778],
    8217: [0, 0.69444, 0, 0, 0.27778],
    8220: [0, 0.69444, 0, 0, 0.5],
    8221: [0, 0.69444, 0, 0, 0.5],
    8224: [0.19444, 0.69444, 0, 0, 0.44445],
    8225: [0.19444, 0.69444, 0, 0, 0.44445],
    8230: [0, 0.123, 0, 0, 1.172],
    8242: [0, 0.55556, 0, 0, 0.275],
    8407: [0, 0.71444, 0.15382, 0, 0.5],
    8463: [0, 0.68889, 0, 0, 0.54028],
    8465: [0, 0.69444, 0, 0, 0.72222],
    8467: [0, 0.69444, 0, 0.11111, 0.41667],
    8472: [0.19444, 0.43056, 0, 0.11111, 0.63646],
    8476: [0, 0.69444, 0, 0, 0.72222],
    8501: [0, 0.69444, 0, 0, 0.61111],
    8592: [-0.13313, 0.36687, 0, 0, 1],
    8593: [0.19444, 0.69444, 0, 0, 0.5],
    8594: [-0.13313, 0.36687, 0, 0, 1],
    8595: [0.19444, 0.69444, 0, 0, 0.5],
    8596: [-0.13313, 0.36687, 0, 0, 1],
    8597: [0.25, 0.75, 0, 0, 0.5],
    8598: [0.19444, 0.69444, 0, 0, 1],
    8599: [0.19444, 0.69444, 0, 0, 1],
    8600: [0.19444, 0.69444, 0, 0, 1],
    8601: [0.19444, 0.69444, 0, 0, 1],
    8614: [0.011, 0.511, 0, 0, 1],
    8617: [0.011, 0.511, 0, 0, 1.126],
    8618: [0.011, 0.511, 0, 0, 1.126],
    8636: [-0.13313, 0.36687, 0, 0, 1],
    8637: [-0.13313, 0.36687, 0, 0, 1],
    8640: [-0.13313, 0.36687, 0, 0, 1],
    8641: [-0.13313, 0.36687, 0, 0, 1],
    8652: [0.011, 0.671, 0, 0, 1],
    8656: [-0.13313, 0.36687, 0, 0, 1],
    8657: [0.19444, 0.69444, 0, 0, 0.61111],
    8658: [-0.13313, 0.36687, 0, 0, 1],
    8659: [0.19444, 0.69444, 0, 0, 0.61111],
    8660: [-0.13313, 0.36687, 0, 0, 1],
    8661: [0.25, 0.75, 0, 0, 0.61111],
    8704: [0, 0.69444, 0, 0, 0.55556],
    8706: [0, 0.69444, 0.05556, 0.08334, 0.5309],
    8707: [0, 0.69444, 0, 0, 0.55556],
    8709: [0.05556, 0.75, 0, 0, 0.5],
    8711: [0, 0.68333, 0, 0, 0.83334],
    8712: [0.0391, 0.5391, 0, 0, 0.66667],
    8715: [0.0391, 0.5391, 0, 0, 0.66667],
    8722: [0.08333, 0.58333, 0, 0, 0.77778],
    8723: [0.08333, 0.58333, 0, 0, 0.77778],
    8725: [0.25, 0.75, 0, 0, 0.5],
    8726: [0.25, 0.75, 0, 0, 0.5],
    8727: [-0.03472, 0.46528, 0, 0, 0.5],
    8728: [-0.05555, 0.44445, 0, 0, 0.5],
    8729: [-0.05555, 0.44445, 0, 0, 0.5],
    8730: [0.2, 0.8, 0, 0, 0.83334],
    8733: [0, 0.43056, 0, 0, 0.77778],
    8734: [0, 0.43056, 0, 0, 1],
    8736: [0, 0.69224, 0, 0, 0.72222],
    8739: [0.25, 0.75, 0, 0, 0.27778],
    8741: [0.25, 0.75, 0, 0, 0.5],
    8743: [0, 0.55556, 0, 0, 0.66667],
    8744: [0, 0.55556, 0, 0, 0.66667],
    8745: [0, 0.55556, 0, 0, 0.66667],
    8746: [0, 0.55556, 0, 0, 0.66667],
    8747: [0.19444, 0.69444, 0.11111, 0, 0.41667],
    8764: [-0.13313, 0.36687, 0, 0, 0.77778],
    8768: [0.19444, 0.69444, 0, 0, 0.27778],
    8771: [-0.03625, 0.46375, 0, 0, 0.77778],
    8773: [-0.022, 0.589, 0, 0, 0.778],
    8776: [-0.01688, 0.48312, 0, 0, 0.77778],
    8781: [-0.03625, 0.46375, 0, 0, 0.77778],
    8784: [-0.133, 0.673, 0, 0, 0.778],
    8801: [-0.03625, 0.46375, 0, 0, 0.77778],
    8804: [0.13597, 0.63597, 0, 0, 0.77778],
    8805: [0.13597, 0.63597, 0, 0, 0.77778],
    8810: [0.0391, 0.5391, 0, 0, 1],
    8811: [0.0391, 0.5391, 0, 0, 1],
    8826: [0.0391, 0.5391, 0, 0, 0.77778],
    8827: [0.0391, 0.5391, 0, 0, 0.77778],
    8834: [0.0391, 0.5391, 0, 0, 0.77778],
    8835: [0.0391, 0.5391, 0, 0, 0.77778],
    8838: [0.13597, 0.63597, 0, 0, 0.77778],
    8839: [0.13597, 0.63597, 0, 0, 0.77778],
    8846: [0, 0.55556, 0, 0, 0.66667],
    8849: [0.13597, 0.63597, 0, 0, 0.77778],
    8850: [0.13597, 0.63597, 0, 0, 0.77778],
    8851: [0, 0.55556, 0, 0, 0.66667],
    8852: [0, 0.55556, 0, 0, 0.66667],
    8853: [0.08333, 0.58333, 0, 0, 0.77778],
    8854: [0.08333, 0.58333, 0, 0, 0.77778],
    8855: [0.08333, 0.58333, 0, 0, 0.77778],
    8856: [0.08333, 0.58333, 0, 0, 0.77778],
    8857: [0.08333, 0.58333, 0, 0, 0.77778],
    8866: [0, 0.69444, 0, 0, 0.61111],
    8867: [0, 0.69444, 0, 0, 0.61111],
    8868: [0, 0.69444, 0, 0, 0.77778],
    8869: [0, 0.69444, 0, 0, 0.77778],
    8872: [0.249, 0.75, 0, 0, 0.867],
    8900: [-0.05555, 0.44445, 0, 0, 0.5],
    8901: [-0.05555, 0.44445, 0, 0, 0.27778],
    8902: [-0.03472, 0.46528, 0, 0, 0.5],
    8904: [5e-3, 0.505, 0, 0, 0.9],
    8942: [0.03, 0.903, 0, 0, 0.278],
    8943: [-0.19, 0.313, 0, 0, 1.172],
    8945: [-0.1, 0.823, 0, 0, 1.282],
    8968: [0.25, 0.75, 0, 0, 0.44445],
    8969: [0.25, 0.75, 0, 0, 0.44445],
    8970: [0.25, 0.75, 0, 0, 0.44445],
    8971: [0.25, 0.75, 0, 0, 0.44445],
    8994: [-0.14236, 0.35764, 0, 0, 1],
    8995: [-0.14236, 0.35764, 0, 0, 1],
    9136: [0.244, 0.744, 0, 0, 0.412],
    9137: [0.244, 0.745, 0, 0, 0.412],
    9651: [0.19444, 0.69444, 0, 0, 0.88889],
    9657: [-0.03472, 0.46528, 0, 0, 0.5],
    9661: [0.19444, 0.69444, 0, 0, 0.88889],
    9667: [-0.03472, 0.46528, 0, 0, 0.5],
    9711: [0.19444, 0.69444, 0, 0, 1],
    9824: [0.12963, 0.69444, 0, 0, 0.77778],
    9825: [0.12963, 0.69444, 0, 0, 0.77778],
    9826: [0.12963, 0.69444, 0, 0, 0.77778],
    9827: [0.12963, 0.69444, 0, 0, 0.77778],
    9837: [0, 0.75, 0, 0, 0.38889],
    9838: [0.19444, 0.69444, 0, 0, 0.38889],
    9839: [0.19444, 0.69444, 0, 0, 0.38889],
    10216: [0.25, 0.75, 0, 0, 0.38889],
    10217: [0.25, 0.75, 0, 0, 0.38889],
    10222: [0.244, 0.744, 0, 0, 0.412],
    10223: [0.244, 0.745, 0, 0, 0.412],
    10229: [0.011, 0.511, 0, 0, 1.609],
    10230: [0.011, 0.511, 0, 0, 1.638],
    10231: [0.011, 0.511, 0, 0, 1.859],
    10232: [0.024, 0.525, 0, 0, 1.609],
    10233: [0.024, 0.525, 0, 0, 1.638],
    10234: [0.024, 0.525, 0, 0, 1.858],
    10236: [0.011, 0.511, 0, 0, 1.638],
    10815: [0, 0.68333, 0, 0, 0.75],
    10927: [0.13597, 0.63597, 0, 0, 0.77778],
    10928: [0.13597, 0.63597, 0, 0, 0.77778],
    57376: [0.19444, 0.69444, 0, 0, 0]
  },
  "Math-BoldItalic": {
    32: [0, 0, 0, 0, 0.25],
    48: [0, 0.44444, 0, 0, 0.575],
    49: [0, 0.44444, 0, 0, 0.575],
    50: [0, 0.44444, 0, 0, 0.575],
    51: [0.19444, 0.44444, 0, 0, 0.575],
    52: [0.19444, 0.44444, 0, 0, 0.575],
    53: [0.19444, 0.44444, 0, 0, 0.575],
    54: [0, 0.64444, 0, 0, 0.575],
    55: [0.19444, 0.44444, 0, 0, 0.575],
    56: [0, 0.64444, 0, 0, 0.575],
    57: [0.19444, 0.44444, 0, 0, 0.575],
    65: [0, 0.68611, 0, 0, 0.86944],
    66: [0, 0.68611, 0.04835, 0, 0.8664],
    67: [0, 0.68611, 0.06979, 0, 0.81694],
    68: [0, 0.68611, 0.03194, 0, 0.93812],
    69: [0, 0.68611, 0.05451, 0, 0.81007],
    70: [0, 0.68611, 0.15972, 0, 0.68889],
    71: [0, 0.68611, 0, 0, 0.88673],
    72: [0, 0.68611, 0.08229, 0, 0.98229],
    73: [0, 0.68611, 0.07778, 0, 0.51111],
    74: [0, 0.68611, 0.10069, 0, 0.63125],
    75: [0, 0.68611, 0.06979, 0, 0.97118],
    76: [0, 0.68611, 0, 0, 0.75555],
    77: [0, 0.68611, 0.11424, 0, 1.14201],
    78: [0, 0.68611, 0.11424, 0, 0.95034],
    79: [0, 0.68611, 0.03194, 0, 0.83666],
    80: [0, 0.68611, 0.15972, 0, 0.72309],
    81: [0.19444, 0.68611, 0, 0, 0.86861],
    82: [0, 0.68611, 421e-5, 0, 0.87235],
    83: [0, 0.68611, 0.05382, 0, 0.69271],
    84: [0, 0.68611, 0.15972, 0, 0.63663],
    85: [0, 0.68611, 0.11424, 0, 0.80027],
    86: [0, 0.68611, 0.25555, 0, 0.67778],
    87: [0, 0.68611, 0.15972, 0, 1.09305],
    88: [0, 0.68611, 0.07778, 0, 0.94722],
    89: [0, 0.68611, 0.25555, 0, 0.67458],
    90: [0, 0.68611, 0.06979, 0, 0.77257],
    97: [0, 0.44444, 0, 0, 0.63287],
    98: [0, 0.69444, 0, 0, 0.52083],
    99: [0, 0.44444, 0, 0, 0.51342],
    100: [0, 0.69444, 0, 0, 0.60972],
    101: [0, 0.44444, 0, 0, 0.55361],
    102: [0.19444, 0.69444, 0.11042, 0, 0.56806],
    103: [0.19444, 0.44444, 0.03704, 0, 0.5449],
    104: [0, 0.69444, 0, 0, 0.66759],
    105: [0, 0.69326, 0, 0, 0.4048],
    106: [0.19444, 0.69326, 0.0622, 0, 0.47083],
    107: [0, 0.69444, 0.01852, 0, 0.6037],
    108: [0, 0.69444, 88e-4, 0, 0.34815],
    109: [0, 0.44444, 0, 0, 1.0324],
    110: [0, 0.44444, 0, 0, 0.71296],
    111: [0, 0.44444, 0, 0, 0.58472],
    112: [0.19444, 0.44444, 0, 0, 0.60092],
    113: [0.19444, 0.44444, 0.03704, 0, 0.54213],
    114: [0, 0.44444, 0.03194, 0, 0.5287],
    115: [0, 0.44444, 0, 0, 0.53125],
    116: [0, 0.63492, 0, 0, 0.41528],
    117: [0, 0.44444, 0, 0, 0.68102],
    118: [0, 0.44444, 0.03704, 0, 0.56666],
    119: [0, 0.44444, 0.02778, 0, 0.83148],
    120: [0, 0.44444, 0, 0, 0.65903],
    121: [0.19444, 0.44444, 0.03704, 0, 0.59028],
    122: [0, 0.44444, 0.04213, 0, 0.55509],
    160: [0, 0, 0, 0, 0.25],
    915: [0, 0.68611, 0.15972, 0, 0.65694],
    916: [0, 0.68611, 0, 0, 0.95833],
    920: [0, 0.68611, 0.03194, 0, 0.86722],
    923: [0, 0.68611, 0, 0, 0.80555],
    926: [0, 0.68611, 0.07458, 0, 0.84125],
    928: [0, 0.68611, 0.08229, 0, 0.98229],
    931: [0, 0.68611, 0.05451, 0, 0.88507],
    933: [0, 0.68611, 0.15972, 0, 0.67083],
    934: [0, 0.68611, 0, 0, 0.76666],
    936: [0, 0.68611, 0.11653, 0, 0.71402],
    937: [0, 0.68611, 0.04835, 0, 0.8789],
    945: [0, 0.44444, 0, 0, 0.76064],
    946: [0.19444, 0.69444, 0.03403, 0, 0.65972],
    947: [0.19444, 0.44444, 0.06389, 0, 0.59003],
    948: [0, 0.69444, 0.03819, 0, 0.52222],
    949: [0, 0.44444, 0, 0, 0.52882],
    950: [0.19444, 0.69444, 0.06215, 0, 0.50833],
    951: [0.19444, 0.44444, 0.03704, 0, 0.6],
    952: [0, 0.69444, 0.03194, 0, 0.5618],
    953: [0, 0.44444, 0, 0, 0.41204],
    954: [0, 0.44444, 0, 0, 0.66759],
    955: [0, 0.69444, 0, 0, 0.67083],
    956: [0.19444, 0.44444, 0, 0, 0.70787],
    957: [0, 0.44444, 0.06898, 0, 0.57685],
    958: [0.19444, 0.69444, 0.03021, 0, 0.50833],
    959: [0, 0.44444, 0, 0, 0.58472],
    960: [0, 0.44444, 0.03704, 0, 0.68241],
    961: [0.19444, 0.44444, 0, 0, 0.6118],
    962: [0.09722, 0.44444, 0.07917, 0, 0.42361],
    963: [0, 0.44444, 0.03704, 0, 0.68588],
    964: [0, 0.44444, 0.13472, 0, 0.52083],
    965: [0, 0.44444, 0.03704, 0, 0.63055],
    966: [0.19444, 0.44444, 0, 0, 0.74722],
    967: [0.19444, 0.44444, 0, 0, 0.71805],
    968: [0.19444, 0.69444, 0.03704, 0, 0.75833],
    969: [0, 0.44444, 0.03704, 0, 0.71782],
    977: [0, 0.69444, 0, 0, 0.69155],
    981: [0.19444, 0.69444, 0, 0, 0.7125],
    982: [0, 0.44444, 0.03194, 0, 0.975],
    1009: [0.19444, 0.44444, 0, 0, 0.6118],
    1013: [0, 0.44444, 0, 0, 0.48333],
    57649: [0, 0.44444, 0, 0, 0.39352],
    57911: [0.19444, 0.44444, 0, 0, 0.43889]
  },
  "Math-Italic": {
    32: [0, 0, 0, 0, 0.25],
    48: [0, 0.43056, 0, 0, 0.5],
    49: [0, 0.43056, 0, 0, 0.5],
    50: [0, 0.43056, 0, 0, 0.5],
    51: [0.19444, 0.43056, 0, 0, 0.5],
    52: [0.19444, 0.43056, 0, 0, 0.5],
    53: [0.19444, 0.43056, 0, 0, 0.5],
    54: [0, 0.64444, 0, 0, 0.5],
    55: [0.19444, 0.43056, 0, 0, 0.5],
    56: [0, 0.64444, 0, 0, 0.5],
    57: [0.19444, 0.43056, 0, 0, 0.5],
    65: [0, 0.68333, 0, 0.13889, 0.75],
    66: [0, 0.68333, 0.05017, 0.08334, 0.75851],
    67: [0, 0.68333, 0.07153, 0.08334, 0.71472],
    68: [0, 0.68333, 0.02778, 0.05556, 0.82792],
    69: [0, 0.68333, 0.05764, 0.08334, 0.7382],
    70: [0, 0.68333, 0.13889, 0.08334, 0.64306],
    71: [0, 0.68333, 0, 0.08334, 0.78625],
    72: [0, 0.68333, 0.08125, 0.05556, 0.83125],
    73: [0, 0.68333, 0.07847, 0.11111, 0.43958],
    74: [0, 0.68333, 0.09618, 0.16667, 0.55451],
    75: [0, 0.68333, 0.07153, 0.05556, 0.84931],
    76: [0, 0.68333, 0, 0.02778, 0.68056],
    77: [0, 0.68333, 0.10903, 0.08334, 0.97014],
    78: [0, 0.68333, 0.10903, 0.08334, 0.80347],
    79: [0, 0.68333, 0.02778, 0.08334, 0.76278],
    80: [0, 0.68333, 0.13889, 0.08334, 0.64201],
    81: [0.19444, 0.68333, 0, 0.08334, 0.79056],
    82: [0, 0.68333, 773e-5, 0.08334, 0.75929],
    83: [0, 0.68333, 0.05764, 0.08334, 0.6132],
    84: [0, 0.68333, 0.13889, 0.08334, 0.58438],
    85: [0, 0.68333, 0.10903, 0.02778, 0.68278],
    86: [0, 0.68333, 0.22222, 0, 0.58333],
    87: [0, 0.68333, 0.13889, 0, 0.94445],
    88: [0, 0.68333, 0.07847, 0.08334, 0.82847],
    89: [0, 0.68333, 0.22222, 0, 0.58056],
    90: [0, 0.68333, 0.07153, 0.08334, 0.68264],
    97: [0, 0.43056, 0, 0, 0.52859],
    98: [0, 0.69444, 0, 0, 0.42917],
    99: [0, 0.43056, 0, 0.05556, 0.43276],
    100: [0, 0.69444, 0, 0.16667, 0.52049],
    101: [0, 0.43056, 0, 0.05556, 0.46563],
    102: [0.19444, 0.69444, 0.10764, 0.16667, 0.48959],
    103: [0.19444, 0.43056, 0.03588, 0.02778, 0.47697],
    104: [0, 0.69444, 0, 0, 0.57616],
    105: [0, 0.65952, 0, 0, 0.34451],
    106: [0.19444, 0.65952, 0.05724, 0, 0.41181],
    107: [0, 0.69444, 0.03148, 0, 0.5206],
    108: [0, 0.69444, 0.01968, 0.08334, 0.29838],
    109: [0, 0.43056, 0, 0, 0.87801],
    110: [0, 0.43056, 0, 0, 0.60023],
    111: [0, 0.43056, 0, 0.05556, 0.48472],
    112: [0.19444, 0.43056, 0, 0.08334, 0.50313],
    113: [0.19444, 0.43056, 0.03588, 0.08334, 0.44641],
    114: [0, 0.43056, 0.02778, 0.05556, 0.45116],
    115: [0, 0.43056, 0, 0.05556, 0.46875],
    116: [0, 0.61508, 0, 0.08334, 0.36111],
    117: [0, 0.43056, 0, 0.02778, 0.57246],
    118: [0, 0.43056, 0.03588, 0.02778, 0.48472],
    119: [0, 0.43056, 0.02691, 0.08334, 0.71592],
    120: [0, 0.43056, 0, 0.02778, 0.57153],
    121: [0.19444, 0.43056, 0.03588, 0.05556, 0.49028],
    122: [0, 0.43056, 0.04398, 0.05556, 0.46505],
    160: [0, 0, 0, 0, 0.25],
    915: [0, 0.68333, 0.13889, 0.08334, 0.61528],
    916: [0, 0.68333, 0, 0.16667, 0.83334],
    920: [0, 0.68333, 0.02778, 0.08334, 0.76278],
    923: [0, 0.68333, 0, 0.16667, 0.69445],
    926: [0, 0.68333, 0.07569, 0.08334, 0.74236],
    928: [0, 0.68333, 0.08125, 0.05556, 0.83125],
    931: [0, 0.68333, 0.05764, 0.08334, 0.77986],
    933: [0, 0.68333, 0.13889, 0.05556, 0.58333],
    934: [0, 0.68333, 0, 0.08334, 0.66667],
    936: [0, 0.68333, 0.11, 0.05556, 0.61222],
    937: [0, 0.68333, 0.05017, 0.08334, 0.7724],
    945: [0, 0.43056, 37e-4, 0.02778, 0.6397],
    946: [0.19444, 0.69444, 0.05278, 0.08334, 0.56563],
    947: [0.19444, 0.43056, 0.05556, 0, 0.51773],
    948: [0, 0.69444, 0.03785, 0.05556, 0.44444],
    949: [0, 0.43056, 0, 0.08334, 0.46632],
    950: [0.19444, 0.69444, 0.07378, 0.08334, 0.4375],
    951: [0.19444, 0.43056, 0.03588, 0.05556, 0.49653],
    952: [0, 0.69444, 0.02778, 0.08334, 0.46944],
    953: [0, 0.43056, 0, 0.05556, 0.35394],
    954: [0, 0.43056, 0, 0, 0.57616],
    955: [0, 0.69444, 0, 0, 0.58334],
    956: [0.19444, 0.43056, 0, 0.02778, 0.60255],
    957: [0, 0.43056, 0.06366, 0.02778, 0.49398],
    958: [0.19444, 0.69444, 0.04601, 0.11111, 0.4375],
    959: [0, 0.43056, 0, 0.05556, 0.48472],
    960: [0, 0.43056, 0.03588, 0, 0.57003],
    961: [0.19444, 0.43056, 0, 0.08334, 0.51702],
    962: [0.09722, 0.43056, 0.07986, 0.08334, 0.36285],
    963: [0, 0.43056, 0.03588, 0, 0.57141],
    964: [0, 0.43056, 0.1132, 0.02778, 0.43715],
    965: [0, 0.43056, 0.03588, 0.02778, 0.54028],
    966: [0.19444, 0.43056, 0, 0.08334, 0.65417],
    967: [0.19444, 0.43056, 0, 0.05556, 0.62569],
    968: [0.19444, 0.69444, 0.03588, 0.11111, 0.65139],
    969: [0, 0.43056, 0.03588, 0, 0.62245],
    977: [0, 0.69444, 0, 0.08334, 0.59144],
    981: [0.19444, 0.69444, 0, 0.08334, 0.59583],
    982: [0, 0.43056, 0.02778, 0, 0.82813],
    1009: [0.19444, 0.43056, 0, 0.08334, 0.51702],
    1013: [0, 0.43056, 0, 0.05556, 0.4059],
    57649: [0, 0.43056, 0, 0.02778, 0.32246],
    57911: [0.19444, 0.43056, 0, 0.08334, 0.38403]
  },
  "SansSerif-Bold": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0, 0, 0.36667],
    34: [0, 0.69444, 0, 0, 0.55834],
    35: [0.19444, 0.69444, 0, 0, 0.91667],
    36: [0.05556, 0.75, 0, 0, 0.55],
    37: [0.05556, 0.75, 0, 0, 1.02912],
    38: [0, 0.69444, 0, 0, 0.83056],
    39: [0, 0.69444, 0, 0, 0.30556],
    40: [0.25, 0.75, 0, 0, 0.42778],
    41: [0.25, 0.75, 0, 0, 0.42778],
    42: [0, 0.75, 0, 0, 0.55],
    43: [0.11667, 0.61667, 0, 0, 0.85556],
    44: [0.10556, 0.13056, 0, 0, 0.30556],
    45: [0, 0.45833, 0, 0, 0.36667],
    46: [0, 0.13056, 0, 0, 0.30556],
    47: [0.25, 0.75, 0, 0, 0.55],
    48: [0, 0.69444, 0, 0, 0.55],
    49: [0, 0.69444, 0, 0, 0.55],
    50: [0, 0.69444, 0, 0, 0.55],
    51: [0, 0.69444, 0, 0, 0.55],
    52: [0, 0.69444, 0, 0, 0.55],
    53: [0, 0.69444, 0, 0, 0.55],
    54: [0, 0.69444, 0, 0, 0.55],
    55: [0, 0.69444, 0, 0, 0.55],
    56: [0, 0.69444, 0, 0, 0.55],
    57: [0, 0.69444, 0, 0, 0.55],
    58: [0, 0.45833, 0, 0, 0.30556],
    59: [0.10556, 0.45833, 0, 0, 0.30556],
    61: [-0.09375, 0.40625, 0, 0, 0.85556],
    63: [0, 0.69444, 0, 0, 0.51945],
    64: [0, 0.69444, 0, 0, 0.73334],
    65: [0, 0.69444, 0, 0, 0.73334],
    66: [0, 0.69444, 0, 0, 0.73334],
    67: [0, 0.69444, 0, 0, 0.70278],
    68: [0, 0.69444, 0, 0, 0.79445],
    69: [0, 0.69444, 0, 0, 0.64167],
    70: [0, 0.69444, 0, 0, 0.61111],
    71: [0, 0.69444, 0, 0, 0.73334],
    72: [0, 0.69444, 0, 0, 0.79445],
    73: [0, 0.69444, 0, 0, 0.33056],
    74: [0, 0.69444, 0, 0, 0.51945],
    75: [0, 0.69444, 0, 0, 0.76389],
    76: [0, 0.69444, 0, 0, 0.58056],
    77: [0, 0.69444, 0, 0, 0.97778],
    78: [0, 0.69444, 0, 0, 0.79445],
    79: [0, 0.69444, 0, 0, 0.79445],
    80: [0, 0.69444, 0, 0, 0.70278],
    81: [0.10556, 0.69444, 0, 0, 0.79445],
    82: [0, 0.69444, 0, 0, 0.70278],
    83: [0, 0.69444, 0, 0, 0.61111],
    84: [0, 0.69444, 0, 0, 0.73334],
    85: [0, 0.69444, 0, 0, 0.76389],
    86: [0, 0.69444, 0.01528, 0, 0.73334],
    87: [0, 0.69444, 0.01528, 0, 1.03889],
    88: [0, 0.69444, 0, 0, 0.73334],
    89: [0, 0.69444, 0.0275, 0, 0.73334],
    90: [0, 0.69444, 0, 0, 0.67223],
    91: [0.25, 0.75, 0, 0, 0.34306],
    93: [0.25, 0.75, 0, 0, 0.34306],
    94: [0, 0.69444, 0, 0, 0.55],
    95: [0.35, 0.10833, 0.03056, 0, 0.55],
    97: [0, 0.45833, 0, 0, 0.525],
    98: [0, 0.69444, 0, 0, 0.56111],
    99: [0, 0.45833, 0, 0, 0.48889],
    100: [0, 0.69444, 0, 0, 0.56111],
    101: [0, 0.45833, 0, 0, 0.51111],
    102: [0, 0.69444, 0.07639, 0, 0.33611],
    103: [0.19444, 0.45833, 0.01528, 0, 0.55],
    104: [0, 0.69444, 0, 0, 0.56111],
    105: [0, 0.69444, 0, 0, 0.25556],
    106: [0.19444, 0.69444, 0, 0, 0.28611],
    107: [0, 0.69444, 0, 0, 0.53056],
    108: [0, 0.69444, 0, 0, 0.25556],
    109: [0, 0.45833, 0, 0, 0.86667],
    110: [0, 0.45833, 0, 0, 0.56111],
    111: [0, 0.45833, 0, 0, 0.55],
    112: [0.19444, 0.45833, 0, 0, 0.56111],
    113: [0.19444, 0.45833, 0, 0, 0.56111],
    114: [0, 0.45833, 0.01528, 0, 0.37222],
    115: [0, 0.45833, 0, 0, 0.42167],
    116: [0, 0.58929, 0, 0, 0.40417],
    117: [0, 0.45833, 0, 0, 0.56111],
    118: [0, 0.45833, 0.01528, 0, 0.5],
    119: [0, 0.45833, 0.01528, 0, 0.74445],
    120: [0, 0.45833, 0, 0, 0.5],
    121: [0.19444, 0.45833, 0.01528, 0, 0.5],
    122: [0, 0.45833, 0, 0, 0.47639],
    126: [0.35, 0.34444, 0, 0, 0.55],
    160: [0, 0, 0, 0, 0.25],
    168: [0, 0.69444, 0, 0, 0.55],
    176: [0, 0.69444, 0, 0, 0.73334],
    180: [0, 0.69444, 0, 0, 0.55],
    184: [0.17014, 0, 0, 0, 0.48889],
    305: [0, 0.45833, 0, 0, 0.25556],
    567: [0.19444, 0.45833, 0, 0, 0.28611],
    710: [0, 0.69444, 0, 0, 0.55],
    711: [0, 0.63542, 0, 0, 0.55],
    713: [0, 0.63778, 0, 0, 0.55],
    728: [0, 0.69444, 0, 0, 0.55],
    729: [0, 0.69444, 0, 0, 0.30556],
    730: [0, 0.69444, 0, 0, 0.73334],
    732: [0, 0.69444, 0, 0, 0.55],
    733: [0, 0.69444, 0, 0, 0.55],
    915: [0, 0.69444, 0, 0, 0.58056],
    916: [0, 0.69444, 0, 0, 0.91667],
    920: [0, 0.69444, 0, 0, 0.85556],
    923: [0, 0.69444, 0, 0, 0.67223],
    926: [0, 0.69444, 0, 0, 0.73334],
    928: [0, 0.69444, 0, 0, 0.79445],
    931: [0, 0.69444, 0, 0, 0.79445],
    933: [0, 0.69444, 0, 0, 0.85556],
    934: [0, 0.69444, 0, 0, 0.79445],
    936: [0, 0.69444, 0, 0, 0.85556],
    937: [0, 0.69444, 0, 0, 0.79445],
    8211: [0, 0.45833, 0.03056, 0, 0.55],
    8212: [0, 0.45833, 0.03056, 0, 1.10001],
    8216: [0, 0.69444, 0, 0, 0.30556],
    8217: [0, 0.69444, 0, 0, 0.30556],
    8220: [0, 0.69444, 0, 0, 0.55834],
    8221: [0, 0.69444, 0, 0, 0.55834]
  },
  "SansSerif-Italic": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0.05733, 0, 0.31945],
    34: [0, 0.69444, 316e-5, 0, 0.5],
    35: [0.19444, 0.69444, 0.05087, 0, 0.83334],
    36: [0.05556, 0.75, 0.11156, 0, 0.5],
    37: [0.05556, 0.75, 0.03126, 0, 0.83334],
    38: [0, 0.69444, 0.03058, 0, 0.75834],
    39: [0, 0.69444, 0.07816, 0, 0.27778],
    40: [0.25, 0.75, 0.13164, 0, 0.38889],
    41: [0.25, 0.75, 0.02536, 0, 0.38889],
    42: [0, 0.75, 0.11775, 0, 0.5],
    43: [0.08333, 0.58333, 0.02536, 0, 0.77778],
    44: [0.125, 0.08333, 0, 0, 0.27778],
    45: [0, 0.44444, 0.01946, 0, 0.33333],
    46: [0, 0.08333, 0, 0, 0.27778],
    47: [0.25, 0.75, 0.13164, 0, 0.5],
    48: [0, 0.65556, 0.11156, 0, 0.5],
    49: [0, 0.65556, 0.11156, 0, 0.5],
    50: [0, 0.65556, 0.11156, 0, 0.5],
    51: [0, 0.65556, 0.11156, 0, 0.5],
    52: [0, 0.65556, 0.11156, 0, 0.5],
    53: [0, 0.65556, 0.11156, 0, 0.5],
    54: [0, 0.65556, 0.11156, 0, 0.5],
    55: [0, 0.65556, 0.11156, 0, 0.5],
    56: [0, 0.65556, 0.11156, 0, 0.5],
    57: [0, 0.65556, 0.11156, 0, 0.5],
    58: [0, 0.44444, 0.02502, 0, 0.27778],
    59: [0.125, 0.44444, 0.02502, 0, 0.27778],
    61: [-0.13, 0.37, 0.05087, 0, 0.77778],
    63: [0, 0.69444, 0.11809, 0, 0.47222],
    64: [0, 0.69444, 0.07555, 0, 0.66667],
    65: [0, 0.69444, 0, 0, 0.66667],
    66: [0, 0.69444, 0.08293, 0, 0.66667],
    67: [0, 0.69444, 0.11983, 0, 0.63889],
    68: [0, 0.69444, 0.07555, 0, 0.72223],
    69: [0, 0.69444, 0.11983, 0, 0.59722],
    70: [0, 0.69444, 0.13372, 0, 0.56945],
    71: [0, 0.69444, 0.11983, 0, 0.66667],
    72: [0, 0.69444, 0.08094, 0, 0.70834],
    73: [0, 0.69444, 0.13372, 0, 0.27778],
    74: [0, 0.69444, 0.08094, 0, 0.47222],
    75: [0, 0.69444, 0.11983, 0, 0.69445],
    76: [0, 0.69444, 0, 0, 0.54167],
    77: [0, 0.69444, 0.08094, 0, 0.875],
    78: [0, 0.69444, 0.08094, 0, 0.70834],
    79: [0, 0.69444, 0.07555, 0, 0.73611],
    80: [0, 0.69444, 0.08293, 0, 0.63889],
    81: [0.125, 0.69444, 0.07555, 0, 0.73611],
    82: [0, 0.69444, 0.08293, 0, 0.64584],
    83: [0, 0.69444, 0.09205, 0, 0.55556],
    84: [0, 0.69444, 0.13372, 0, 0.68056],
    85: [0, 0.69444, 0.08094, 0, 0.6875],
    86: [0, 0.69444, 0.1615, 0, 0.66667],
    87: [0, 0.69444, 0.1615, 0, 0.94445],
    88: [0, 0.69444, 0.13372, 0, 0.66667],
    89: [0, 0.69444, 0.17261, 0, 0.66667],
    90: [0, 0.69444, 0.11983, 0, 0.61111],
    91: [0.25, 0.75, 0.15942, 0, 0.28889],
    93: [0.25, 0.75, 0.08719, 0, 0.28889],
    94: [0, 0.69444, 0.0799, 0, 0.5],
    95: [0.35, 0.09444, 0.08616, 0, 0.5],
    97: [0, 0.44444, 981e-5, 0, 0.48056],
    98: [0, 0.69444, 0.03057, 0, 0.51667],
    99: [0, 0.44444, 0.08336, 0, 0.44445],
    100: [0, 0.69444, 0.09483, 0, 0.51667],
    101: [0, 0.44444, 0.06778, 0, 0.44445],
    102: [0, 0.69444, 0.21705, 0, 0.30556],
    103: [0.19444, 0.44444, 0.10836, 0, 0.5],
    104: [0, 0.69444, 0.01778, 0, 0.51667],
    105: [0, 0.67937, 0.09718, 0, 0.23889],
    106: [0.19444, 0.67937, 0.09162, 0, 0.26667],
    107: [0, 0.69444, 0.08336, 0, 0.48889],
    108: [0, 0.69444, 0.09483, 0, 0.23889],
    109: [0, 0.44444, 0.01778, 0, 0.79445],
    110: [0, 0.44444, 0.01778, 0, 0.51667],
    111: [0, 0.44444, 0.06613, 0, 0.5],
    112: [0.19444, 0.44444, 0.0389, 0, 0.51667],
    113: [0.19444, 0.44444, 0.04169, 0, 0.51667],
    114: [0, 0.44444, 0.10836, 0, 0.34167],
    115: [0, 0.44444, 0.0778, 0, 0.38333],
    116: [0, 0.57143, 0.07225, 0, 0.36111],
    117: [0, 0.44444, 0.04169, 0, 0.51667],
    118: [0, 0.44444, 0.10836, 0, 0.46111],
    119: [0, 0.44444, 0.10836, 0, 0.68334],
    120: [0, 0.44444, 0.09169, 0, 0.46111],
    121: [0.19444, 0.44444, 0.10836, 0, 0.46111],
    122: [0, 0.44444, 0.08752, 0, 0.43472],
    126: [0.35, 0.32659, 0.08826, 0, 0.5],
    160: [0, 0, 0, 0, 0.25],
    168: [0, 0.67937, 0.06385, 0, 0.5],
    176: [0, 0.69444, 0, 0, 0.73752],
    184: [0.17014, 0, 0, 0, 0.44445],
    305: [0, 0.44444, 0.04169, 0, 0.23889],
    567: [0.19444, 0.44444, 0.04169, 0, 0.26667],
    710: [0, 0.69444, 0.0799, 0, 0.5],
    711: [0, 0.63194, 0.08432, 0, 0.5],
    713: [0, 0.60889, 0.08776, 0, 0.5],
    714: [0, 0.69444, 0.09205, 0, 0.5],
    715: [0, 0.69444, 0, 0, 0.5],
    728: [0, 0.69444, 0.09483, 0, 0.5],
    729: [0, 0.67937, 0.07774, 0, 0.27778],
    730: [0, 0.69444, 0, 0, 0.73752],
    732: [0, 0.67659, 0.08826, 0, 0.5],
    733: [0, 0.69444, 0.09205, 0, 0.5],
    915: [0, 0.69444, 0.13372, 0, 0.54167],
    916: [0, 0.69444, 0, 0, 0.83334],
    920: [0, 0.69444, 0.07555, 0, 0.77778],
    923: [0, 0.69444, 0, 0, 0.61111],
    926: [0, 0.69444, 0.12816, 0, 0.66667],
    928: [0, 0.69444, 0.08094, 0, 0.70834],
    931: [0, 0.69444, 0.11983, 0, 0.72222],
    933: [0, 0.69444, 0.09031, 0, 0.77778],
    934: [0, 0.69444, 0.04603, 0, 0.72222],
    936: [0, 0.69444, 0.09031, 0, 0.77778],
    937: [0, 0.69444, 0.08293, 0, 0.72222],
    8211: [0, 0.44444, 0.08616, 0, 0.5],
    8212: [0, 0.44444, 0.08616, 0, 1],
    8216: [0, 0.69444, 0.07816, 0, 0.27778],
    8217: [0, 0.69444, 0.07816, 0, 0.27778],
    8220: [0, 0.69444, 0.14205, 0, 0.5],
    8221: [0, 0.69444, 316e-5, 0, 0.5]
  },
  "SansSerif-Regular": {
    32: [0, 0, 0, 0, 0.25],
    33: [0, 0.69444, 0, 0, 0.31945],
    34: [0, 0.69444, 0, 0, 0.5],
    35: [0.19444, 0.69444, 0, 0, 0.83334],
    36: [0.05556, 0.75, 0, 0, 0.5],
    37: [0.05556, 0.75, 0, 0, 0.83334],
    38: [0, 0.69444, 0, 0, 0.75834],
    39: [0, 0.69444, 0, 0, 0.27778],
    40: [0.25, 0.75, 0, 0, 0.38889],
    41: [0.25, 0.75, 0, 0, 0.38889],
    42: [0, 0.75, 0, 0, 0.5],
    43: [0.08333, 0.58333, 0, 0, 0.77778],
    44: [0.125, 0.08333, 0, 0, 0.27778],
    45: [0, 0.44444, 0, 0, 0.33333],
    46: [0, 0.08333, 0, 0, 0.27778],
    47: [0.25, 0.75, 0, 0, 0.5],
    48: [0, 0.65556, 0, 0, 0.5],
    49: [0, 0.65556, 0, 0, 0.5],
    50: [0, 0.65556, 0, 0, 0.5],
    51: [0, 0.65556, 0, 0, 0.5],
    52: [0, 0.65556, 0, 0, 0.5],
    53: [0, 0.65556, 0, 0, 0.5],
    54: [0, 0.65556, 0, 0, 0.5],
    55: [0, 0.65556, 0, 0, 0.5],
    56: [0, 0.65556, 0, 0, 0.5],
    57: [0, 0.65556, 0, 0, 0.5],
    58: [0, 0.44444, 0, 0, 0.27778],
    59: [0.125, 0.44444, 0, 0, 0.27778],
    61: [-0.13, 0.37, 0, 0, 0.77778],
    63: [0, 0.69444, 0, 0, 0.47222],
    64: [0, 0.69444, 0, 0, 0.66667],
    65: [0, 0.69444, 0, 0, 0.66667],
    66: [0, 0.69444, 0, 0, 0.66667],
    67: [0, 0.69444, 0, 0, 0.63889],
    68: [0, 0.69444, 0, 0, 0.72223],
    69: [0, 0.69444, 0, 0, 0.59722],
    70: [0, 0.69444, 0, 0, 0.56945],
    71: [0, 0.69444, 0, 0, 0.66667],
    72: [0, 0.69444, 0, 0, 0.70834],
    73: [0, 0.69444, 0, 0, 0.27778],
    74: [0, 0.69444, 0, 0, 0.47222],
    75: [0, 0.69444, 0, 0, 0.69445],
    76: [0, 0.69444, 0, 0, 0.54167],
    77: [0, 0.69444, 0, 0, 0.875],
    78: [0, 0.69444, 0, 0, 0.70834],
    79: [0, 0.69444, 0, 0, 0.73611],
    80: [0, 0.69444, 0, 0, 0.63889],
    81: [0.125, 0.69444, 0, 0, 0.73611],
    82: [0, 0.69444, 0, 0, 0.64584],
    83: [0, 0.69444, 0, 0, 0.55556],
    84: [0, 0.69444, 0, 0, 0.68056],
    85: [0, 0.69444, 0, 0, 0.6875],
    86: [0, 0.69444, 0.01389, 0, 0.66667],
    87: [0, 0.69444, 0.01389, 0, 0.94445],
    88: [0, 0.69444, 0, 0, 0.66667],
    89: [0, 0.69444, 0.025, 0, 0.66667],
    90: [0, 0.69444, 0, 0, 0.61111],
    91: [0.25, 0.75, 0, 0, 0.28889],
    93: [0.25, 0.75, 0, 0, 0.28889],
    94: [0, 0.69444, 0, 0, 0.5],
    95: [0.35, 0.09444, 0.02778, 0, 0.5],
    97: [0, 0.44444, 0, 0, 0.48056],
    98: [0, 0.69444, 0, 0, 0.51667],
    99: [0, 0.44444, 0, 0, 0.44445],
    100: [0, 0.69444, 0, 0, 0.51667],
    101: [0, 0.44444, 0, 0, 0.44445],
    102: [0, 0.69444, 0.06944, 0, 0.30556],
    103: [0.19444, 0.44444, 0.01389, 0, 0.5],
    104: [0, 0.69444, 0, 0, 0.51667],
    105: [0, 0.67937, 0, 0, 0.23889],
    106: [0.19444, 0.67937, 0, 0, 0.26667],
    107: [0, 0.69444, 0, 0, 0.48889],
    108: [0, 0.69444, 0, 0, 0.23889],
    109: [0, 0.44444, 0, 0, 0.79445],
    110: [0, 0.44444, 0, 0, 0.51667],
    111: [0, 0.44444, 0, 0, 0.5],
    112: [0.19444, 0.44444, 0, 0, 0.51667],
    113: [0.19444, 0.44444, 0, 0, 0.51667],
    114: [0, 0.44444, 0.01389, 0, 0.34167],
    115: [0, 0.44444, 0, 0, 0.38333],
    116: [0, 0.57143, 0, 0, 0.36111],
    117: [0, 0.44444, 0, 0, 0.51667],
    118: [0, 0.44444, 0.01389, 0, 0.46111],
    119: [0, 0.44444, 0.01389, 0, 0.68334],
    120: [0, 0.44444, 0, 0, 0.46111],
    121: [0.19444, 0.44444, 0.01389, 0, 0.46111],
    122: [0, 0.44444, 0, 0, 0.43472],
    126: [0.35, 0.32659, 0, 0, 0.5],
    160: [0, 0, 0, 0, 0.25],
    168: [0, 0.67937, 0, 0, 0.5],
    176: [0, 0.69444, 0, 0, 0.66667],
    184: [0.17014, 0, 0, 0, 0.44445],
    305: [0, 0.44444, 0, 0, 0.23889],
    567: [0.19444, 0.44444, 0, 0, 0.26667],
    710: [0, 0.69444, 0, 0, 0.5],
    711: [0, 0.63194, 0, 0, 0.5],
    713: [0, 0.60889, 0, 0, 0.5],
    714: [0, 0.69444, 0, 0, 0.5],
    715: [0, 0.69444, 0, 0, 0.5],
    728: [0, 0.69444, 0, 0, 0.5],
    729: [0, 0.67937, 0, 0, 0.27778],
    730: [0, 0.69444, 0, 0, 0.66667],
    732: [0, 0.67659, 0, 0, 0.5],
    733: [0, 0.69444, 0, 0, 0.5],
    915: [0, 0.69444, 0, 0, 0.54167],
    916: [0, 0.69444, 0, 0, 0.83334],
    920: [0, 0.69444, 0, 0, 0.77778],
    923: [0, 0.69444, 0, 0, 0.61111],
    926: [0, 0.69444, 0, 0, 0.66667],
    928: [0, 0.69444, 0, 0, 0.70834],
    931: [0, 0.69444, 0, 0, 0.72222],
    933: [0, 0.69444, 0, 0, 0.77778],
    934: [0, 0.69444, 0, 0, 0.72222],
    936: [0, 0.69444, 0, 0, 0.77778],
    937: [0, 0.69444, 0, 0, 0.72222],
    8211: [0, 0.44444, 0.02778, 0, 0.5],
    8212: [0, 0.44444, 0.02778, 0, 1],
    8216: [0, 0.69444, 0, 0, 0.27778],
    8217: [0, 0.69444, 0, 0, 0.27778],
    8220: [0, 0.69444, 0, 0, 0.5],
    8221: [0, 0.69444, 0, 0, 0.5]
  },
  "Script-Regular": {
    32: [0, 0, 0, 0, 0.25],
    65: [0, 0.7, 0.22925, 0, 0.80253],
    66: [0, 0.7, 0.04087, 0, 0.90757],
    67: [0, 0.7, 0.1689, 0, 0.66619],
    68: [0, 0.7, 0.09371, 0, 0.77443],
    69: [0, 0.7, 0.18583, 0, 0.56162],
    70: [0, 0.7, 0.13634, 0, 0.89544],
    71: [0, 0.7, 0.17322, 0, 0.60961],
    72: [0, 0.7, 0.29694, 0, 0.96919],
    73: [0, 0.7, 0.19189, 0, 0.80907],
    74: [0.27778, 0.7, 0.19189, 0, 1.05159],
    75: [0, 0.7, 0.31259, 0, 0.91364],
    76: [0, 0.7, 0.19189, 0, 0.87373],
    77: [0, 0.7, 0.15981, 0, 1.08031],
    78: [0, 0.7, 0.3525, 0, 0.9015],
    79: [0, 0.7, 0.08078, 0, 0.73787],
    80: [0, 0.7, 0.08078, 0, 1.01262],
    81: [0, 0.7, 0.03305, 0, 0.88282],
    82: [0, 0.7, 0.06259, 0, 0.85],
    83: [0, 0.7, 0.19189, 0, 0.86767],
    84: [0, 0.7, 0.29087, 0, 0.74697],
    85: [0, 0.7, 0.25815, 0, 0.79996],
    86: [0, 0.7, 0.27523, 0, 0.62204],
    87: [0, 0.7, 0.27523, 0, 0.80532],
    88: [0, 0.7, 0.26006, 0, 0.94445],
    89: [0, 0.7, 0.2939, 0, 0.70961],
    90: [0, 0.7, 0.24037, 0, 0.8212],
    160: [0, 0, 0, 0, 0.25]
  },
  "Size1-Regular": {
    32: [0, 0, 0, 0, 0.25],
    40: [0.35001, 0.85, 0, 0, 0.45834],
    41: [0.35001, 0.85, 0, 0, 0.45834],
    47: [0.35001, 0.85, 0, 0, 0.57778],
    91: [0.35001, 0.85, 0, 0, 0.41667],
    92: [0.35001, 0.85, 0, 0, 0.57778],
    93: [0.35001, 0.85, 0, 0, 0.41667],
    123: [0.35001, 0.85, 0, 0, 0.58334],
    125: [0.35001, 0.85, 0, 0, 0.58334],
    160: [0, 0, 0, 0, 0.25],
    710: [0, 0.72222, 0, 0, 0.55556],
    732: [0, 0.72222, 0, 0, 0.55556],
    770: [0, 0.72222, 0, 0, 0.55556],
    771: [0, 0.72222, 0, 0, 0.55556],
    8214: [-99e-5, 0.601, 0, 0, 0.77778],
    8593: [1e-5, 0.6, 0, 0, 0.66667],
    8595: [1e-5, 0.6, 0, 0, 0.66667],
    8657: [1e-5, 0.6, 0, 0, 0.77778],
    8659: [1e-5, 0.6, 0, 0, 0.77778],
    8719: [0.25001, 0.75, 0, 0, 0.94445],
    8720: [0.25001, 0.75, 0, 0, 0.94445],
    8721: [0.25001, 0.75, 0, 0, 1.05556],
    8730: [0.35001, 0.85, 0, 0, 1],
    8739: [-599e-5, 0.606, 0, 0, 0.33333],
    8741: [-599e-5, 0.606, 0, 0, 0.55556],
    8747: [0.30612, 0.805, 0.19445, 0, 0.47222],
    8748: [0.306, 0.805, 0.19445, 0, 0.47222],
    8749: [0.306, 0.805, 0.19445, 0, 0.47222],
    8750: [0.30612, 0.805, 0.19445, 0, 0.47222],
    8896: [0.25001, 0.75, 0, 0, 0.83334],
    8897: [0.25001, 0.75, 0, 0, 0.83334],
    8898: [0.25001, 0.75, 0, 0, 0.83334],
    8899: [0.25001, 0.75, 0, 0, 0.83334],
    8968: [0.35001, 0.85, 0, 0, 0.47222],
    8969: [0.35001, 0.85, 0, 0, 0.47222],
    8970: [0.35001, 0.85, 0, 0, 0.47222],
    8971: [0.35001, 0.85, 0, 0, 0.47222],
    9168: [-99e-5, 0.601, 0, 0, 0.66667],
    10216: [0.35001, 0.85, 0, 0, 0.47222],
    10217: [0.35001, 0.85, 0, 0, 0.47222],
    10752: [0.25001, 0.75, 0, 0, 1.11111],
    10753: [0.25001, 0.75, 0, 0, 1.11111],
    10754: [0.25001, 0.75, 0, 0, 1.11111],
    10756: [0.25001, 0.75, 0, 0, 0.83334],
    10758: [0.25001, 0.75, 0, 0, 0.83334]
  },
  "Size2-Regular": {
    32: [0, 0, 0, 0, 0.25],
    40: [0.65002, 1.15, 0, 0, 0.59722],
    41: [0.65002, 1.15, 0, 0, 0.59722],
    47: [0.65002, 1.15, 0, 0, 0.81111],
    91: [0.65002, 1.15, 0, 0, 0.47222],
    92: [0.65002, 1.15, 0, 0, 0.81111],
    93: [0.65002, 1.15, 0, 0, 0.47222],
    123: [0.65002, 1.15, 0, 0, 0.66667],
    125: [0.65002, 1.15, 0, 0, 0.66667],
    160: [0, 0, 0, 0, 0.25],
    710: [0, 0.75, 0, 0, 1],
    732: [0, 0.75, 0, 0, 1],
    770: [0, 0.75, 0, 0, 1],
    771: [0, 0.75, 0, 0, 1],
    8719: [0.55001, 1.05, 0, 0, 1.27778],
    8720: [0.55001, 1.05, 0, 0, 1.27778],
    8721: [0.55001, 1.05, 0, 0, 1.44445],
    8730: [0.65002, 1.15, 0, 0, 1],
    8747: [0.86225, 1.36, 0.44445, 0, 0.55556],
    8748: [0.862, 1.36, 0.44445, 0, 0.55556],
    8749: [0.862, 1.36, 0.44445, 0, 0.55556],
    8750: [0.86225, 1.36, 0.44445, 0, 0.55556],
    8896: [0.55001, 1.05, 0, 0, 1.11111],
    8897: [0.55001, 1.05, 0, 0, 1.11111],
    8898: [0.55001, 1.05, 0, 0, 1.11111],
    8899: [0.55001, 1.05, 0, 0, 1.11111],
    8968: [0.65002, 1.15, 0, 0, 0.52778],
    8969: [0.65002, 1.15, 0, 0, 0.52778],
    8970: [0.65002, 1.15, 0, 0, 0.52778],
    8971: [0.65002, 1.15, 0, 0, 0.52778],
    10216: [0.65002, 1.15, 0, 0, 0.61111],
    10217: [0.65002, 1.15, 0, 0, 0.61111],
    10752: [0.55001, 1.05, 0, 0, 1.51112],
    10753: [0.55001, 1.05, 0, 0, 1.51112],
    10754: [0.55001, 1.05, 0, 0, 1.51112],
    10756: [0.55001, 1.05, 0, 0, 1.11111],
    10758: [0.55001, 1.05, 0, 0, 1.11111]
  },
  "Size3-Regular": {
    32: [0, 0, 0, 0, 0.25],
    40: [0.95003, 1.45, 0, 0, 0.73611],
    41: [0.95003, 1.45, 0, 0, 0.73611],
    47: [0.95003, 1.45, 0, 0, 1.04445],
    91: [0.95003, 1.45, 0, 0, 0.52778],
    92: [0.95003, 1.45, 0, 0, 1.04445],
    93: [0.95003, 1.45, 0, 0, 0.52778],
    123: [0.95003, 1.45, 0, 0, 0.75],
    125: [0.95003, 1.45, 0, 0, 0.75],
    160: [0, 0, 0, 0, 0.25],
    710: [0, 0.75, 0, 0, 1.44445],
    732: [0, 0.75, 0, 0, 1.44445],
    770: [0, 0.75, 0, 0, 1.44445],
    771: [0, 0.75, 0, 0, 1.44445],
    8730: [0.95003, 1.45, 0, 0, 1],
    8968: [0.95003, 1.45, 0, 0, 0.58334],
    8969: [0.95003, 1.45, 0, 0, 0.58334],
    8970: [0.95003, 1.45, 0, 0, 0.58334],
    8971: [0.95003, 1.45, 0, 0, 0.58334],
    10216: [0.95003, 1.45, 0, 0, 0.75],
    10217: [0.95003, 1.45, 0, 0, 0.75]
  },
  "Size4-Regular": {
    32: [0, 0, 0, 0, 0.25],
    40: [1.25003, 1.75, 0, 0, 0.79167],
    41: [1.25003, 1.75, 0, 0, 0.79167],
    47: [1.25003, 1.75, 0, 0, 1.27778],
    91: [1.25003, 1.75, 0, 0, 0.58334],
    92: [1.25003, 1.75, 0, 0, 1.27778],
    93: [1.25003, 1.75, 0, 0, 0.58334],
    123: [1.25003, 1.75, 0, 0, 0.80556],
    125: [1.25003, 1.75, 0, 0, 0.80556],
    160: [0, 0, 0, 0, 0.25],
    710: [0, 0.825, 0, 0, 1.8889],
    732: [0, 0.825, 0, 0, 1.8889],
    770: [0, 0.825, 0, 0, 1.8889],
    771: [0, 0.825, 0, 0, 1.8889],
    8730: [1.25003, 1.75, 0, 0, 1],
    8968: [1.25003, 1.75, 0, 0, 0.63889],
    8969: [1.25003, 1.75, 0, 0, 0.63889],
    8970: [1.25003, 1.75, 0, 0, 0.63889],
    8971: [1.25003, 1.75, 0, 0, 0.63889],
    9115: [0.64502, 1.155, 0, 0, 0.875],
    9116: [1e-5, 0.6, 0, 0, 0.875],
    9117: [0.64502, 1.155, 0, 0, 0.875],
    9118: [0.64502, 1.155, 0, 0, 0.875],
    9119: [1e-5, 0.6, 0, 0, 0.875],
    9120: [0.64502, 1.155, 0, 0, 0.875],
    9121: [0.64502, 1.155, 0, 0, 0.66667],
    9122: [-99e-5, 0.601, 0, 0, 0.66667],
    9123: [0.64502, 1.155, 0, 0, 0.66667],
    9124: [0.64502, 1.155, 0, 0, 0.66667],
    9125: [-99e-5, 0.601, 0, 0, 0.66667],
    9126: [0.64502, 1.155, 0, 0, 0.66667],
    9127: [1e-5, 0.9, 0, 0, 0.88889],
    9128: [0.65002, 1.15, 0, 0, 0.88889],
    9129: [0.90001, 0, 0, 0, 0.88889],
    9130: [0, 0.3, 0, 0, 0.88889],
    9131: [1e-5, 0.9, 0, 0, 0.88889],
    9132: [0.65002, 1.15, 0, 0, 0.88889],
    9133: [0.90001, 0, 0, 0, 0.88889],
    9143: [0.88502, 0.915, 0, 0, 1.05556],
    10216: [1.25003, 1.75, 0, 0, 0.80556],
    10217: [1.25003, 1.75, 0, 0, 0.80556],
    57344: [-499e-5, 0.605, 0, 0, 1.05556],
    57345: [-499e-5, 0.605, 0, 0, 1.05556],
    57680: [0, 0.12, 0, 0, 0.45],
    57681: [0, 0.12, 0, 0, 0.45],
    57682: [0, 0.12, 0, 0, 0.45],
    57683: [0, 0.12, 0, 0, 0.45]
  },
  "Typewriter-Regular": {
    32: [0, 0, 0, 0, 0.525],
    33: [0, 0.61111, 0, 0, 0.525],
    34: [0, 0.61111, 0, 0, 0.525],
    35: [0, 0.61111, 0, 0, 0.525],
    36: [0.08333, 0.69444, 0, 0, 0.525],
    37: [0.08333, 0.69444, 0, 0, 0.525],
    38: [0, 0.61111, 0, 0, 0.525],
    39: [0, 0.61111, 0, 0, 0.525],
    40: [0.08333, 0.69444, 0, 0, 0.525],
    41: [0.08333, 0.69444, 0, 0, 0.525],
    42: [0, 0.52083, 0, 0, 0.525],
    43: [-0.08056, 0.53055, 0, 0, 0.525],
    44: [0.13889, 0.125, 0, 0, 0.525],
    45: [-0.08056, 0.53055, 0, 0, 0.525],
    46: [0, 0.125, 0, 0, 0.525],
    47: [0.08333, 0.69444, 0, 0, 0.525],
    48: [0, 0.61111, 0, 0, 0.525],
    49: [0, 0.61111, 0, 0, 0.525],
    50: [0, 0.61111, 0, 0, 0.525],
    51: [0, 0.61111, 0, 0, 0.525],
    52: [0, 0.61111, 0, 0, 0.525],
    53: [0, 0.61111, 0, 0, 0.525],
    54: [0, 0.61111, 0, 0, 0.525],
    55: [0, 0.61111, 0, 0, 0.525],
    56: [0, 0.61111, 0, 0, 0.525],
    57: [0, 0.61111, 0, 0, 0.525],
    58: [0, 0.43056, 0, 0, 0.525],
    59: [0.13889, 0.43056, 0, 0, 0.525],
    60: [-0.05556, 0.55556, 0, 0, 0.525],
    61: [-0.19549, 0.41562, 0, 0, 0.525],
    62: [-0.05556, 0.55556, 0, 0, 0.525],
    63: [0, 0.61111, 0, 0, 0.525],
    64: [0, 0.61111, 0, 0, 0.525],
    65: [0, 0.61111, 0, 0, 0.525],
    66: [0, 0.61111, 0, 0, 0.525],
    67: [0, 0.61111, 0, 0, 0.525],
    68: [0, 0.61111, 0, 0, 0.525],
    69: [0, 0.61111, 0, 0, 0.525],
    70: [0, 0.61111, 0, 0, 0.525],
    71: [0, 0.61111, 0, 0, 0.525],
    72: [0, 0.61111, 0, 0, 0.525],
    73: [0, 0.61111, 0, 0, 0.525],
    74: [0, 0.61111, 0, 0, 0.525],
    75: [0, 0.61111, 0, 0, 0.525],
    76: [0, 0.61111, 0, 0, 0.525],
    77: [0, 0.61111, 0, 0, 0.525],
    78: [0, 0.61111, 0, 0, 0.525],
    79: [0, 0.61111, 0, 0, 0.525],
    80: [0, 0.61111, 0, 0, 0.525],
    81: [0.13889, 0.61111, 0, 0, 0.525],
    82: [0, 0.61111, 0, 0, 0.525],
    83: [0, 0.61111, 0, 0, 0.525],
    84: [0, 0.61111, 0, 0, 0.525],
    85: [0, 0.61111, 0, 0, 0.525],
    86: [0, 0.61111, 0, 0, 0.525],
    87: [0, 0.61111, 0, 0, 0.525],
    88: [0, 0.61111, 0, 0, 0.525],
    89: [0, 0.61111, 0, 0, 0.525],
    90: [0, 0.61111, 0, 0, 0.525],
    91: [0.08333, 0.69444, 0, 0, 0.525],
    92: [0.08333, 0.69444, 0, 0, 0.525],
    93: [0.08333, 0.69444, 0, 0, 0.525],
    94: [0, 0.61111, 0, 0, 0.525],
    95: [0.09514, 0, 0, 0, 0.525],
    96: [0, 0.61111, 0, 0, 0.525],
    97: [0, 0.43056, 0, 0, 0.525],
    98: [0, 0.61111, 0, 0, 0.525],
    99: [0, 0.43056, 0, 0, 0.525],
    100: [0, 0.61111, 0, 0, 0.525],
    101: [0, 0.43056, 0, 0, 0.525],
    102: [0, 0.61111, 0, 0, 0.525],
    103: [0.22222, 0.43056, 0, 0, 0.525],
    104: [0, 0.61111, 0, 0, 0.525],
    105: [0, 0.61111, 0, 0, 0.525],
    106: [0.22222, 0.61111, 0, 0, 0.525],
    107: [0, 0.61111, 0, 0, 0.525],
    108: [0, 0.61111, 0, 0, 0.525],
    109: [0, 0.43056, 0, 0, 0.525],
    110: [0, 0.43056, 0, 0, 0.525],
    111: [0, 0.43056, 0, 0, 0.525],
    112: [0.22222, 0.43056, 0, 0, 0.525],
    113: [0.22222, 0.43056, 0, 0, 0.525],
    114: [0, 0.43056, 0, 0, 0.525],
    115: [0, 0.43056, 0, 0, 0.525],
    116: [0, 0.55358, 0, 0, 0.525],
    117: [0, 0.43056, 0, 0, 0.525],
    118: [0, 0.43056, 0, 0, 0.525],
    119: [0, 0.43056, 0, 0, 0.525],
    120: [0, 0.43056, 0, 0, 0.525],
    121: [0.22222, 0.43056, 0, 0, 0.525],
    122: [0, 0.43056, 0, 0, 0.525],
    123: [0.08333, 0.69444, 0, 0, 0.525],
    124: [0.08333, 0.69444, 0, 0, 0.525],
    125: [0.08333, 0.69444, 0, 0, 0.525],
    126: [0, 0.61111, 0, 0, 0.525],
    127: [0, 0.61111, 0, 0, 0.525],
    160: [0, 0, 0, 0, 0.525],
    176: [0, 0.61111, 0, 0, 0.525],
    184: [0.19445, 0, 0, 0, 0.525],
    305: [0, 0.43056, 0, 0, 0.525],
    567: [0.22222, 0.43056, 0, 0, 0.525],
    711: [0, 0.56597, 0, 0, 0.525],
    713: [0, 0.56555, 0, 0, 0.525],
    714: [0, 0.61111, 0, 0, 0.525],
    715: [0, 0.61111, 0, 0, 0.525],
    728: [0, 0.61111, 0, 0, 0.525],
    730: [0, 0.61111, 0, 0, 0.525],
    770: [0, 0.61111, 0, 0, 0.525],
    771: [0, 0.61111, 0, 0, 0.525],
    776: [0, 0.61111, 0, 0, 0.525],
    915: [0, 0.61111, 0, 0, 0.525],
    916: [0, 0.61111, 0, 0, 0.525],
    920: [0, 0.61111, 0, 0, 0.525],
    923: [0, 0.61111, 0, 0, 0.525],
    926: [0, 0.61111, 0, 0, 0.525],
    928: [0, 0.61111, 0, 0, 0.525],
    931: [0, 0.61111, 0, 0, 0.525],
    933: [0, 0.61111, 0, 0, 0.525],
    934: [0, 0.61111, 0, 0, 0.525],
    936: [0, 0.61111, 0, 0, 0.525],
    937: [0, 0.61111, 0, 0, 0.525],
    8216: [0, 0.61111, 0, 0, 0.525],
    8217: [0, 0.61111, 0, 0, 0.525],
    8242: [0, 0.61111, 0, 0, 0.525],
    9251: [0.11111, 0.21944, 0, 0, 0.525]
  }
}, x1 = {
  // Latin-1
  Å: "A",
  Ð: "D",
  Þ: "o",
  å: "a",
  ð: "d",
  þ: "o",
  // Cyrillic
  А: "A",
  Б: "B",
  В: "B",
  Г: "F",
  Д: "A",
  Е: "E",
  Ж: "K",
  З: "3",
  И: "N",
  Й: "N",
  К: "K",
  Л: "N",
  М: "M",
  Н: "H",
  О: "O",
  П: "N",
  Р: "P",
  С: "C",
  Т: "T",
  У: "y",
  Ф: "O",
  Х: "X",
  Ц: "U",
  Ч: "h",
  Ш: "W",
  Щ: "W",
  Ъ: "B",
  Ы: "X",
  Ь: "B",
  Э: "3",
  Ю: "X",
  Я: "R",
  а: "a",
  б: "b",
  в: "a",
  г: "r",
  д: "y",
  е: "e",
  ж: "m",
  з: "e",
  и: "n",
  й: "n",
  к: "n",
  л: "n",
  м: "m",
  н: "n",
  о: "o",
  п: "n",
  р: "p",
  с: "c",
  т: "o",
  у: "y",
  ф: "b",
  х: "x",
  ц: "n",
  ч: "n",
  ш: "w",
  щ: "w",
  ъ: "a",
  ы: "m",
  ь: "a",
  э: "e",
  ю: "m",
  я: "r"
};
function Yh(n, e, t) {
  if (!un[e])
    throw new Error("Font metrics not found for font: " + e + ".");
  var r = n.charCodeAt(0), i = un[e][r];
  if (!i && n[0] in x1 && (r = x1[n[0]].charCodeAt(0), i = un[e][r]), !i && t === "text" && rk(r) && (i = un[e][77]), i)
    return {
      depth: i[0],
      height: i[1],
      italic: i[2],
      skew: i[3],
      width: i[4]
    };
}
var Hu = {
  // https://en.wikibooks.org/wiki/LaTeX/Lengths and
  // https://tex.stackexchange.com/a/8263
  pt: 1,
  // TeX point
  mm: 7227 / 2540,
  // millimeter
  cm: 7227 / 254,
  // centimeter
  in: 72.27,
  // inch
  bp: 803 / 800,
  // big (PostScript) points
  pc: 12,
  // pica
  dd: 1238 / 1157,
  // didot
  cc: 14856 / 1157,
  // cicero (12 didot)
  nd: 685 / 642,
  // new didot
  nc: 1370 / 107,
  // new cicero (12 new didot)
  sp: 1 / 65536,
  // scaled point (TeX's internal smallest unit)
  // https://tex.stackexchange.com/a/41371
  px: 803 / 800
  // \pdfpxdimen defaults to 1 bp in pdfTeX and LuaTeX
}, dk = {
  ex: !0,
  em: !0,
  mu: !0
}, mk = function(e) {
  return typeof e != "string" && (e = e.unit), e in Hu || e in dk || e === "ex";
}, We = function(e, t) {
  var r;
  if (e.unit in Hu)
    r = Hu[e.unit] / t.fontMetrics().ptPerEm / t.sizeMultiplier;
  else if (e.unit === "mu")
    r = t.fontMetrics().cssEmPerMu;
  else {
    var i;
    if (t.style.isTight() ? i = t.havingStyle(t.style.text()) : i = t, e.unit === "ex")
      r = i.fontMetrics().xHeight;
    else if (e.unit === "em")
      r = i.fontMetrics().quad;
    else
      throw new ie("Invalid unit: '" + e.unit + "'");
    i !== t && (r *= i.sizeMultiplier / t.sizeMultiplier);
  }
  return Math.min(e.number * r, t.maxSize);
}, G = function(e) {
  return +e.toFixed(4) + "em";
}, Pn = function(e) {
  return e.filter((t) => t).join(" ");
}, s2 = function(e, t, r) {
  if (this.classes = e || [], this.attributes = {}, this.height = 0, this.depth = 0, this.maxFontSize = 0, this.style = r || {}, t) {
    t.style.isTight() && this.classes.push("mtight");
    var i = t.getColor();
    i && (this.style.color = i);
  }
}, l2 = function(e) {
  var t = document.createElement(e);
  t.className = Pn(this.classes);
  for (var r in this.style)
    this.style.hasOwnProperty(r) && (t.style[r] = this.style[r]);
  for (var i in this.attributes)
    this.attributes.hasOwnProperty(i) && t.setAttribute(i, this.attributes[i]);
  for (var s = 0; s < this.children.length; s++)
    t.appendChild(this.children[s].toNode());
  return t;
}, o2 = function(e) {
  var t = "<" + e;
  this.classes.length && (t += ' class="' + le.escape(Pn(this.classes)) + '"');
  var r = "";
  for (var i in this.style)
    this.style.hasOwnProperty(i) && (r += le.hyphenate(i) + ":" + this.style[i] + ";");
  r && (t += ' style="' + le.escape(r) + '"');
  for (var s in this.attributes)
    this.attributes.hasOwnProperty(s) && (t += " " + s + '="' + le.escape(this.attributes[s]) + '"');
  t += ">";
  for (var l = 0; l < this.children.length; l++)
    t += this.children[l].toMarkup();
  return t += "</" + e + ">", t;
};
class va {
  constructor(e, t, r, i) {
    this.children = void 0, this.attributes = void 0, this.classes = void 0, this.height = void 0, this.depth = void 0, this.width = void 0, this.maxFontSize = void 0, this.style = void 0, s2.call(this, e, r, i), this.children = t || [];
  }
  /**
   * Sets an arbitrary attribute on the span. Warning: use this wisely. Not
   * all browsers support attributes the same, and having too many custom
   * attributes is probably bad.
   */
  setAttribute(e, t) {
    this.attributes[e] = t;
  }
  hasClass(e) {
    return le.contains(this.classes, e);
  }
  toNode() {
    return l2.call(this, "span");
  }
  toMarkup() {
    return o2.call(this, "span");
  }
}
class a2 {
  constructor(e, t, r, i) {
    this.children = void 0, this.attributes = void 0, this.classes = void 0, this.height = void 0, this.depth = void 0, this.maxFontSize = void 0, this.style = void 0, s2.call(this, t, i), this.children = r || [], this.setAttribute("href", e);
  }
  setAttribute(e, t) {
    this.attributes[e] = t;
  }
  hasClass(e) {
    return le.contains(this.classes, e);
  }
  toNode() {
    return l2.call(this, "a");
  }
  toMarkup() {
    return o2.call(this, "a");
  }
}
class pk {
  constructor(e, t, r) {
    this.src = void 0, this.alt = void 0, this.classes = void 0, this.height = void 0, this.depth = void 0, this.maxFontSize = void 0, this.style = void 0, this.alt = t, this.src = e, this.classes = ["mord"], this.style = r;
  }
  hasClass(e) {
    return le.contains(this.classes, e);
  }
  toNode() {
    var e = document.createElement("img");
    e.src = this.src, e.alt = this.alt, e.className = "mord";
    for (var t in this.style)
      this.style.hasOwnProperty(t) && (e.style[t] = this.style[t]);
    return e;
  }
  toMarkup() {
    var e = '<img src="' + le.escape(this.src) + '"' + (' alt="' + le.escape(this.alt) + '"'), t = "";
    for (var r in this.style)
      this.style.hasOwnProperty(r) && (t += le.hyphenate(r) + ":" + this.style[r] + ";");
    return t && (e += ' style="' + le.escape(t) + '"'), e += "'/>", e;
  }
}
var gk = {
  î: "ı̂",
  ï: "ı̈",
  í: "ı́",
  // 'ī': '\u0131\u0304', // enable when we add Extended Latin
  ì: "ı̀"
};
class Kr {
  constructor(e, t, r, i, s, l, o, a) {
    this.text = void 0, this.height = void 0, this.depth = void 0, this.italic = void 0, this.skew = void 0, this.width = void 0, this.maxFontSize = void 0, this.classes = void 0, this.style = void 0, this.text = e, this.height = t || 0, this.depth = r || 0, this.italic = i || 0, this.skew = s || 0, this.width = l || 0, this.classes = o || [], this.style = a || {}, this.maxFontSize = 0;
    var u = tk(this.text.charCodeAt(0));
    u && this.classes.push(u + "_fallback"), /[îïíì]/.test(this.text) && (this.text = gk[this.text]);
  }
  hasClass(e) {
    return le.contains(this.classes, e);
  }
  /**
   * Creates a text node or span from a symbol node. Note that a span is only
   * created if it is needed.
   */
  toNode() {
    var e = document.createTextNode(this.text), t = null;
    this.italic > 0 && (t = document.createElement("span"), t.style.marginRight = G(this.italic)), this.classes.length > 0 && (t = t || document.createElement("span"), t.className = Pn(this.classes));
    for (var r in this.style)
      this.style.hasOwnProperty(r) && (t = t || document.createElement("span"), t.style[r] = this.style[r]);
    return t ? (t.appendChild(e), t) : e;
  }
  /**
   * Creates markup for a symbol node.
   */
  toMarkup() {
    var e = !1, t = "<span";
    this.classes.length && (e = !0, t += ' class="', t += le.escape(Pn(this.classes)), t += '"');
    var r = "";
    this.italic > 0 && (r += "margin-right:" + this.italic + "em;");
    for (var i in this.style)
      this.style.hasOwnProperty(i) && (r += le.hyphenate(i) + ":" + this.style[i] + ";");
    r && (e = !0, t += ' style="' + le.escape(r) + '"');
    var s = le.escape(this.text);
    return e ? (t += ">", t += s, t += "</span>", t) : s;
  }
}
class Hn {
  constructor(e, t) {
    this.children = void 0, this.attributes = void 0, this.children = e || [], this.attributes = t || {};
  }
  toNode() {
    var e = "http://www.w3.org/2000/svg", t = document.createElementNS(e, "svg");
    for (var r in this.attributes)
      Object.prototype.hasOwnProperty.call(this.attributes, r) && t.setAttribute(r, this.attributes[r]);
    for (var i = 0; i < this.children.length; i++)
      t.appendChild(this.children[i].toNode());
    return t;
  }
  toMarkup() {
    var e = '<svg xmlns="http://www.w3.org/2000/svg"';
    for (var t in this.attributes)
      Object.prototype.hasOwnProperty.call(this.attributes, t) && (e += " " + t + '="' + le.escape(this.attributes[t]) + '"');
    e += ">";
    for (var r = 0; r < this.children.length; r++)
      e += this.children[r].toMarkup();
    return e += "</svg>", e;
  }
}
class ci {
  constructor(e, t) {
    this.pathName = void 0, this.alternate = void 0, this.pathName = e, this.alternate = t;
  }
  toNode() {
    var e = "http://www.w3.org/2000/svg", t = document.createElementNS(e, "path");
    return this.alternate ? t.setAttribute("d", this.alternate) : t.setAttribute("d", k1[this.pathName]), t;
  }
  toMarkup() {
    return this.alternate ? '<path d="' + le.escape(this.alternate) + '"/>' : '<path d="' + le.escape(k1[this.pathName]) + '"/>';
  }
}
class S1 {
  constructor(e) {
    this.attributes = void 0, this.attributes = e || {};
  }
  toNode() {
    var e = "http://www.w3.org/2000/svg", t = document.createElementNS(e, "line");
    for (var r in this.attributes)
      Object.prototype.hasOwnProperty.call(this.attributes, r) && t.setAttribute(r, this.attributes[r]);
    return t;
  }
  toMarkup() {
    var e = "<line";
    for (var t in this.attributes)
      Object.prototype.hasOwnProperty.call(this.attributes, t) && (e += " " + t + '="' + le.escape(this.attributes[t]) + '"');
    return e += "/>", e;
  }
}
function A1(n) {
  if (n instanceof Kr)
    return n;
  throw new Error("Expected symbolNode but got " + String(n) + ".");
}
function bk(n) {
  if (n instanceof va)
    return n;
  throw new Error("Expected span<HtmlDomNode> but got " + String(n) + ".");
}
var vk = {
  "accent-token": 1,
  mathord: 1,
  "op-token": 1,
  spacing: 1,
  textord: 1
}, Ze = {
  math: {},
  text: {}
};
function d(n, e, t, r, i, s) {
  Ze[n][i] = {
    font: e,
    group: t,
    replace: r
  }, s && r && (Ze[n][r] = Ze[n][i]);
}
var p = "math", z = "text", b = "main", D = "ams", He = "accent-token", Y = "bin", _t = "close", os = "inner", se = "mathord", et = "op-token", qt = "open", ya = "punct", _ = "rel", yn = "spacing", F = "textord";
d(p, b, _, "≡", "\\equiv", !0);
d(p, b, _, "≺", "\\prec", !0);
d(p, b, _, "≻", "\\succ", !0);
d(p, b, _, "∼", "\\sim", !0);
d(p, b, _, "⊥", "\\perp");
d(p, b, _, "⪯", "\\preceq", !0);
d(p, b, _, "⪰", "\\succeq", !0);
d(p, b, _, "≃", "\\simeq", !0);
d(p, b, _, "∣", "\\mid", !0);
d(p, b, _, "≪", "\\ll", !0);
d(p, b, _, "≫", "\\gg", !0);
d(p, b, _, "≍", "\\asymp", !0);
d(p, b, _, "∥", "\\parallel");
d(p, b, _, "⋈", "\\bowtie", !0);
d(p, b, _, "⌣", "\\smile", !0);
d(p, b, _, "⊑", "\\sqsubseteq", !0);
d(p, b, _, "⊒", "\\sqsupseteq", !0);
d(p, b, _, "≐", "\\doteq", !0);
d(p, b, _, "⌢", "\\frown", !0);
d(p, b, _, "∋", "\\ni", !0);
d(p, b, _, "∝", "\\propto", !0);
d(p, b, _, "⊢", "\\vdash", !0);
d(p, b, _, "⊣", "\\dashv", !0);
d(p, b, _, "∋", "\\owns");
d(p, b, ya, ".", "\\ldotp");
d(p, b, ya, "⋅", "\\cdotp");
d(p, b, F, "#", "\\#");
d(z, b, F, "#", "\\#");
d(p, b, F, "&", "\\&");
d(z, b, F, "&", "\\&");
d(p, b, F, "ℵ", "\\aleph", !0);
d(p, b, F, "∀", "\\forall", !0);
d(p, b, F, "ℏ", "\\hbar", !0);
d(p, b, F, "∃", "\\exists", !0);
d(p, b, F, "∇", "\\nabla", !0);
d(p, b, F, "♭", "\\flat", !0);
d(p, b, F, "ℓ", "\\ell", !0);
d(p, b, F, "♮", "\\natural", !0);
d(p, b, F, "♣", "\\clubsuit", !0);
d(p, b, F, "℘", "\\wp", !0);
d(p, b, F, "♯", "\\sharp", !0);
d(p, b, F, "♢", "\\diamondsuit", !0);
d(p, b, F, "ℜ", "\\Re", !0);
d(p, b, F, "♡", "\\heartsuit", !0);
d(p, b, F, "ℑ", "\\Im", !0);
d(p, b, F, "♠", "\\spadesuit", !0);
d(p, b, F, "§", "\\S", !0);
d(z, b, F, "§", "\\S");
d(p, b, F, "¶", "\\P", !0);
d(z, b, F, "¶", "\\P");
d(p, b, F, "†", "\\dag");
d(z, b, F, "†", "\\dag");
d(z, b, F, "†", "\\textdagger");
d(p, b, F, "‡", "\\ddag");
d(z, b, F, "‡", "\\ddag");
d(z, b, F, "‡", "\\textdaggerdbl");
d(p, b, _t, "⎱", "\\rmoustache", !0);
d(p, b, qt, "⎰", "\\lmoustache", !0);
d(p, b, _t, "⟯", "\\rgroup", !0);
d(p, b, qt, "⟮", "\\lgroup", !0);
d(p, b, Y, "∓", "\\mp", !0);
d(p, b, Y, "⊖", "\\ominus", !0);
d(p, b, Y, "⊎", "\\uplus", !0);
d(p, b, Y, "⊓", "\\sqcap", !0);
d(p, b, Y, "∗", "\\ast");
d(p, b, Y, "⊔", "\\sqcup", !0);
d(p, b, Y, "◯", "\\bigcirc", !0);
d(p, b, Y, "∙", "\\bullet", !0);
d(p, b, Y, "‡", "\\ddagger");
d(p, b, Y, "≀", "\\wr", !0);
d(p, b, Y, "⨿", "\\amalg");
d(p, b, Y, "&", "\\And");
d(p, b, _, "⟵", "\\longleftarrow", !0);
d(p, b, _, "⇐", "\\Leftarrow", !0);
d(p, b, _, "⟸", "\\Longleftarrow", !0);
d(p, b, _, "⟶", "\\longrightarrow", !0);
d(p, b, _, "⇒", "\\Rightarrow", !0);
d(p, b, _, "⟹", "\\Longrightarrow", !0);
d(p, b, _, "↔", "\\leftrightarrow", !0);
d(p, b, _, "⟷", "\\longleftrightarrow", !0);
d(p, b, _, "⇔", "\\Leftrightarrow", !0);
d(p, b, _, "⟺", "\\Longleftrightarrow", !0);
d(p, b, _, "↦", "\\mapsto", !0);
d(p, b, _, "⟼", "\\longmapsto", !0);
d(p, b, _, "↗", "\\nearrow", !0);
d(p, b, _, "↩", "\\hookleftarrow", !0);
d(p, b, _, "↪", "\\hookrightarrow", !0);
d(p, b, _, "↘", "\\searrow", !0);
d(p, b, _, "↼", "\\leftharpoonup", !0);
d(p, b, _, "⇀", "\\rightharpoonup", !0);
d(p, b, _, "↙", "\\swarrow", !0);
d(p, b, _, "↽", "\\leftharpoondown", !0);
d(p, b, _, "⇁", "\\rightharpoondown", !0);
d(p, b, _, "↖", "\\nwarrow", !0);
d(p, b, _, "⇌", "\\rightleftharpoons", !0);
d(p, D, _, "≮", "\\nless", !0);
d(p, D, _, "", "\\@nleqslant");
d(p, D, _, "", "\\@nleqq");
d(p, D, _, "⪇", "\\lneq", !0);
d(p, D, _, "≨", "\\lneqq", !0);
d(p, D, _, "", "\\@lvertneqq");
d(p, D, _, "⋦", "\\lnsim", !0);
d(p, D, _, "⪉", "\\lnapprox", !0);
d(p, D, _, "⊀", "\\nprec", !0);
d(p, D, _, "⋠", "\\npreceq", !0);
d(p, D, _, "⋨", "\\precnsim", !0);
d(p, D, _, "⪹", "\\precnapprox", !0);
d(p, D, _, "≁", "\\nsim", !0);
d(p, D, _, "", "\\@nshortmid");
d(p, D, _, "∤", "\\nmid", !0);
d(p, D, _, "⊬", "\\nvdash", !0);
d(p, D, _, "⊭", "\\nvDash", !0);
d(p, D, _, "⋪", "\\ntriangleleft");
d(p, D, _, "⋬", "\\ntrianglelefteq", !0);
d(p, D, _, "⊊", "\\subsetneq", !0);
d(p, D, _, "", "\\@varsubsetneq");
d(p, D, _, "⫋", "\\subsetneqq", !0);
d(p, D, _, "", "\\@varsubsetneqq");
d(p, D, _, "≯", "\\ngtr", !0);
d(p, D, _, "", "\\@ngeqslant");
d(p, D, _, "", "\\@ngeqq");
d(p, D, _, "⪈", "\\gneq", !0);
d(p, D, _, "≩", "\\gneqq", !0);
d(p, D, _, "", "\\@gvertneqq");
d(p, D, _, "⋧", "\\gnsim", !0);
d(p, D, _, "⪊", "\\gnapprox", !0);
d(p, D, _, "⊁", "\\nsucc", !0);
d(p, D, _, "⋡", "\\nsucceq", !0);
d(p, D, _, "⋩", "\\succnsim", !0);
d(p, D, _, "⪺", "\\succnapprox", !0);
d(p, D, _, "≆", "\\ncong", !0);
d(p, D, _, "", "\\@nshortparallel");
d(p, D, _, "∦", "\\nparallel", !0);
d(p, D, _, "⊯", "\\nVDash", !0);
d(p, D, _, "⋫", "\\ntriangleright");
d(p, D, _, "⋭", "\\ntrianglerighteq", !0);
d(p, D, _, "", "\\@nsupseteqq");
d(p, D, _, "⊋", "\\supsetneq", !0);
d(p, D, _, "", "\\@varsupsetneq");
d(p, D, _, "⫌", "\\supsetneqq", !0);
d(p, D, _, "", "\\@varsupsetneqq");
d(p, D, _, "⊮", "\\nVdash", !0);
d(p, D, _, "⪵", "\\precneqq", !0);
d(p, D, _, "⪶", "\\succneqq", !0);
d(p, D, _, "", "\\@nsubseteqq");
d(p, D, Y, "⊴", "\\unlhd");
d(p, D, Y, "⊵", "\\unrhd");
d(p, D, _, "↚", "\\nleftarrow", !0);
d(p, D, _, "↛", "\\nrightarrow", !0);
d(p, D, _, "⇍", "\\nLeftarrow", !0);
d(p, D, _, "⇏", "\\nRightarrow", !0);
d(p, D, _, "↮", "\\nleftrightarrow", !0);
d(p, D, _, "⇎", "\\nLeftrightarrow", !0);
d(p, D, _, "△", "\\vartriangle");
d(p, D, F, "ℏ", "\\hslash");
d(p, D, F, "▽", "\\triangledown");
d(p, D, F, "◊", "\\lozenge");
d(p, D, F, "Ⓢ", "\\circledS");
d(p, D, F, "®", "\\circledR");
d(z, D, F, "®", "\\circledR");
d(p, D, F, "∡", "\\measuredangle", !0);
d(p, D, F, "∄", "\\nexists");
d(p, D, F, "℧", "\\mho");
d(p, D, F, "Ⅎ", "\\Finv", !0);
d(p, D, F, "⅁", "\\Game", !0);
d(p, D, F, "‵", "\\backprime");
d(p, D, F, "▲", "\\blacktriangle");
d(p, D, F, "▼", "\\blacktriangledown");
d(p, D, F, "■", "\\blacksquare");
d(p, D, F, "⧫", "\\blacklozenge");
d(p, D, F, "★", "\\bigstar");
d(p, D, F, "∢", "\\sphericalangle", !0);
d(p, D, F, "∁", "\\complement", !0);
d(p, D, F, "ð", "\\eth", !0);
d(z, b, F, "ð", "ð");
d(p, D, F, "╱", "\\diagup");
d(p, D, F, "╲", "\\diagdown");
d(p, D, F, "□", "\\square");
d(p, D, F, "□", "\\Box");
d(p, D, F, "◊", "\\Diamond");
d(p, D, F, "¥", "\\yen", !0);
d(z, D, F, "¥", "\\yen", !0);
d(p, D, F, "✓", "\\checkmark", !0);
d(z, D, F, "✓", "\\checkmark");
d(p, D, F, "ℶ", "\\beth", !0);
d(p, D, F, "ℸ", "\\daleth", !0);
d(p, D, F, "ℷ", "\\gimel", !0);
d(p, D, F, "ϝ", "\\digamma", !0);
d(p, D, F, "ϰ", "\\varkappa");
d(p, D, qt, "┌", "\\@ulcorner", !0);
d(p, D, _t, "┐", "\\@urcorner", !0);
d(p, D, qt, "└", "\\@llcorner", !0);
d(p, D, _t, "┘", "\\@lrcorner", !0);
d(p, D, _, "≦", "\\leqq", !0);
d(p, D, _, "⩽", "\\leqslant", !0);
d(p, D, _, "⪕", "\\eqslantless", !0);
d(p, D, _, "≲", "\\lesssim", !0);
d(p, D, _, "⪅", "\\lessapprox", !0);
d(p, D, _, "≊", "\\approxeq", !0);
d(p, D, Y, "⋖", "\\lessdot");
d(p, D, _, "⋘", "\\lll", !0);
d(p, D, _, "≶", "\\lessgtr", !0);
d(p, D, _, "⋚", "\\lesseqgtr", !0);
d(p, D, _, "⪋", "\\lesseqqgtr", !0);
d(p, D, _, "≑", "\\doteqdot");
d(p, D, _, "≓", "\\risingdotseq", !0);
d(p, D, _, "≒", "\\fallingdotseq", !0);
d(p, D, _, "∽", "\\backsim", !0);
d(p, D, _, "⋍", "\\backsimeq", !0);
d(p, D, _, "⫅", "\\subseteqq", !0);
d(p, D, _, "⋐", "\\Subset", !0);
d(p, D, _, "⊏", "\\sqsubset", !0);
d(p, D, _, "≼", "\\preccurlyeq", !0);
d(p, D, _, "⋞", "\\curlyeqprec", !0);
d(p, D, _, "≾", "\\precsim", !0);
d(p, D, _, "⪷", "\\precapprox", !0);
d(p, D, _, "⊲", "\\vartriangleleft");
d(p, D, _, "⊴", "\\trianglelefteq");
d(p, D, _, "⊨", "\\vDash", !0);
d(p, D, _, "⊪", "\\Vvdash", !0);
d(p, D, _, "⌣", "\\smallsmile");
d(p, D, _, "⌢", "\\smallfrown");
d(p, D, _, "≏", "\\bumpeq", !0);
d(p, D, _, "≎", "\\Bumpeq", !0);
d(p, D, _, "≧", "\\geqq", !0);
d(p, D, _, "⩾", "\\geqslant", !0);
d(p, D, _, "⪖", "\\eqslantgtr", !0);
d(p, D, _, "≳", "\\gtrsim", !0);
d(p, D, _, "⪆", "\\gtrapprox", !0);
d(p, D, Y, "⋗", "\\gtrdot");
d(p, D, _, "⋙", "\\ggg", !0);
d(p, D, _, "≷", "\\gtrless", !0);
d(p, D, _, "⋛", "\\gtreqless", !0);
d(p, D, _, "⪌", "\\gtreqqless", !0);
d(p, D, _, "≖", "\\eqcirc", !0);
d(p, D, _, "≗", "\\circeq", !0);
d(p, D, _, "≜", "\\triangleq", !0);
d(p, D, _, "∼", "\\thicksim");
d(p, D, _, "≈", "\\thickapprox");
d(p, D, _, "⫆", "\\supseteqq", !0);
d(p, D, _, "⋑", "\\Supset", !0);
d(p, D, _, "⊐", "\\sqsupset", !0);
d(p, D, _, "≽", "\\succcurlyeq", !0);
d(p, D, _, "⋟", "\\curlyeqsucc", !0);
d(p, D, _, "≿", "\\succsim", !0);
d(p, D, _, "⪸", "\\succapprox", !0);
d(p, D, _, "⊳", "\\vartriangleright");
d(p, D, _, "⊵", "\\trianglerighteq");
d(p, D, _, "⊩", "\\Vdash", !0);
d(p, D, _, "∣", "\\shortmid");
d(p, D, _, "∥", "\\shortparallel");
d(p, D, _, "≬", "\\between", !0);
d(p, D, _, "⋔", "\\pitchfork", !0);
d(p, D, _, "∝", "\\varpropto");
d(p, D, _, "◀", "\\blacktriangleleft");
d(p, D, _, "∴", "\\therefore", !0);
d(p, D, _, "∍", "\\backepsilon");
d(p, D, _, "▶", "\\blacktriangleright");
d(p, D, _, "∵", "\\because", !0);
d(p, D, _, "⋘", "\\llless");
d(p, D, _, "⋙", "\\gggtr");
d(p, D, Y, "⊲", "\\lhd");
d(p, D, Y, "⊳", "\\rhd");
d(p, D, _, "≂", "\\eqsim", !0);
d(p, b, _, "⋈", "\\Join");
d(p, D, _, "≑", "\\Doteq", !0);
d(p, D, Y, "∔", "\\dotplus", !0);
d(p, D, Y, "∖", "\\smallsetminus");
d(p, D, Y, "⋒", "\\Cap", !0);
d(p, D, Y, "⋓", "\\Cup", !0);
d(p, D, Y, "⩞", "\\doublebarwedge", !0);
d(p, D, Y, "⊟", "\\boxminus", !0);
d(p, D, Y, "⊞", "\\boxplus", !0);
d(p, D, Y, "⋇", "\\divideontimes", !0);
d(p, D, Y, "⋉", "\\ltimes", !0);
d(p, D, Y, "⋊", "\\rtimes", !0);
d(p, D, Y, "⋋", "\\leftthreetimes", !0);
d(p, D, Y, "⋌", "\\rightthreetimes", !0);
d(p, D, Y, "⋏", "\\curlywedge", !0);
d(p, D, Y, "⋎", "\\curlyvee", !0);
d(p, D, Y, "⊝", "\\circleddash", !0);
d(p, D, Y, "⊛", "\\circledast", !0);
d(p, D, Y, "⋅", "\\centerdot");
d(p, D, Y, "⊺", "\\intercal", !0);
d(p, D, Y, "⋒", "\\doublecap");
d(p, D, Y, "⋓", "\\doublecup");
d(p, D, Y, "⊠", "\\boxtimes", !0);
d(p, D, _, "⇢", "\\dashrightarrow", !0);
d(p, D, _, "⇠", "\\dashleftarrow", !0);
d(p, D, _, "⇇", "\\leftleftarrows", !0);
d(p, D, _, "⇆", "\\leftrightarrows", !0);
d(p, D, _, "⇚", "\\Lleftarrow", !0);
d(p, D, _, "↞", "\\twoheadleftarrow", !0);
d(p, D, _, "↢", "\\leftarrowtail", !0);
d(p, D, _, "↫", "\\looparrowleft", !0);
d(p, D, _, "⇋", "\\leftrightharpoons", !0);
d(p, D, _, "↶", "\\curvearrowleft", !0);
d(p, D, _, "↺", "\\circlearrowleft", !0);
d(p, D, _, "↰", "\\Lsh", !0);
d(p, D, _, "⇈", "\\upuparrows", !0);
d(p, D, _, "↿", "\\upharpoonleft", !0);
d(p, D, _, "⇃", "\\downharpoonleft", !0);
d(p, b, _, "⊶", "\\origof", !0);
d(p, b, _, "⊷", "\\imageof", !0);
d(p, D, _, "⊸", "\\multimap", !0);
d(p, D, _, "↭", "\\leftrightsquigarrow", !0);
d(p, D, _, "⇉", "\\rightrightarrows", !0);
d(p, D, _, "⇄", "\\rightleftarrows", !0);
d(p, D, _, "↠", "\\twoheadrightarrow", !0);
d(p, D, _, "↣", "\\rightarrowtail", !0);
d(p, D, _, "↬", "\\looparrowright", !0);
d(p, D, _, "↷", "\\curvearrowright", !0);
d(p, D, _, "↻", "\\circlearrowright", !0);
d(p, D, _, "↱", "\\Rsh", !0);
d(p, D, _, "⇊", "\\downdownarrows", !0);
d(p, D, _, "↾", "\\upharpoonright", !0);
d(p, D, _, "⇂", "\\downharpoonright", !0);
d(p, D, _, "⇝", "\\rightsquigarrow", !0);
d(p, D, _, "⇝", "\\leadsto");
d(p, D, _, "⇛", "\\Rrightarrow", !0);
d(p, D, _, "↾", "\\restriction");
d(p, b, F, "‘", "`");
d(p, b, F, "$", "\\$");
d(z, b, F, "$", "\\$");
d(z, b, F, "$", "\\textdollar");
d(p, b, F, "%", "\\%");
d(z, b, F, "%", "\\%");
d(p, b, F, "_", "\\_");
d(z, b, F, "_", "\\_");
d(z, b, F, "_", "\\textunderscore");
d(p, b, F, "∠", "\\angle", !0);
d(p, b, F, "∞", "\\infty", !0);
d(p, b, F, "′", "\\prime");
d(p, b, F, "△", "\\triangle");
d(p, b, F, "Γ", "\\Gamma", !0);
d(p, b, F, "Δ", "\\Delta", !0);
d(p, b, F, "Θ", "\\Theta", !0);
d(p, b, F, "Λ", "\\Lambda", !0);
d(p, b, F, "Ξ", "\\Xi", !0);
d(p, b, F, "Π", "\\Pi", !0);
d(p, b, F, "Σ", "\\Sigma", !0);
d(p, b, F, "Υ", "\\Upsilon", !0);
d(p, b, F, "Φ", "\\Phi", !0);
d(p, b, F, "Ψ", "\\Psi", !0);
d(p, b, F, "Ω", "\\Omega", !0);
d(p, b, F, "A", "Α");
d(p, b, F, "B", "Β");
d(p, b, F, "E", "Ε");
d(p, b, F, "Z", "Ζ");
d(p, b, F, "H", "Η");
d(p, b, F, "I", "Ι");
d(p, b, F, "K", "Κ");
d(p, b, F, "M", "Μ");
d(p, b, F, "N", "Ν");
d(p, b, F, "O", "Ο");
d(p, b, F, "P", "Ρ");
d(p, b, F, "T", "Τ");
d(p, b, F, "X", "Χ");
d(p, b, F, "¬", "\\neg", !0);
d(p, b, F, "¬", "\\lnot");
d(p, b, F, "⊤", "\\top");
d(p, b, F, "⊥", "\\bot");
d(p, b, F, "∅", "\\emptyset");
d(p, D, F, "∅", "\\varnothing");
d(p, b, se, "α", "\\alpha", !0);
d(p, b, se, "β", "\\beta", !0);
d(p, b, se, "γ", "\\gamma", !0);
d(p, b, se, "δ", "\\delta", !0);
d(p, b, se, "ϵ", "\\epsilon", !0);
d(p, b, se, "ζ", "\\zeta", !0);
d(p, b, se, "η", "\\eta", !0);
d(p, b, se, "θ", "\\theta", !0);
d(p, b, se, "ι", "\\iota", !0);
d(p, b, se, "κ", "\\kappa", !0);
d(p, b, se, "λ", "\\lambda", !0);
d(p, b, se, "μ", "\\mu", !0);
d(p, b, se, "ν", "\\nu", !0);
d(p, b, se, "ξ", "\\xi", !0);
d(p, b, se, "ο", "\\omicron", !0);
d(p, b, se, "π", "\\pi", !0);
d(p, b, se, "ρ", "\\rho", !0);
d(p, b, se, "σ", "\\sigma", !0);
d(p, b, se, "τ", "\\tau", !0);
d(p, b, se, "υ", "\\upsilon", !0);
d(p, b, se, "ϕ", "\\phi", !0);
d(p, b, se, "χ", "\\chi", !0);
d(p, b, se, "ψ", "\\psi", !0);
d(p, b, se, "ω", "\\omega", !0);
d(p, b, se, "ε", "\\varepsilon", !0);
d(p, b, se, "ϑ", "\\vartheta", !0);
d(p, b, se, "ϖ", "\\varpi", !0);
d(p, b, se, "ϱ", "\\varrho", !0);
d(p, b, se, "ς", "\\varsigma", !0);
d(p, b, se, "φ", "\\varphi", !0);
d(p, b, Y, "∗", "*", !0);
d(p, b, Y, "+", "+");
d(p, b, Y, "−", "-", !0);
d(p, b, Y, "⋅", "\\cdot", !0);
d(p, b, Y, "∘", "\\circ", !0);
d(p, b, Y, "÷", "\\div", !0);
d(p, b, Y, "±", "\\pm", !0);
d(p, b, Y, "×", "\\times", !0);
d(p, b, Y, "∩", "\\cap", !0);
d(p, b, Y, "∪", "\\cup", !0);
d(p, b, Y, "∖", "\\setminus", !0);
d(p, b, Y, "∧", "\\land");
d(p, b, Y, "∨", "\\lor");
d(p, b, Y, "∧", "\\wedge", !0);
d(p, b, Y, "∨", "\\vee", !0);
d(p, b, F, "√", "\\surd");
d(p, b, qt, "⟨", "\\langle", !0);
d(p, b, qt, "∣", "\\lvert");
d(p, b, qt, "∥", "\\lVert");
d(p, b, _t, "?", "?");
d(p, b, _t, "!", "!");
d(p, b, _t, "⟩", "\\rangle", !0);
d(p, b, _t, "∣", "\\rvert");
d(p, b, _t, "∥", "\\rVert");
d(p, b, _, "=", "=");
d(p, b, _, ":", ":");
d(p, b, _, "≈", "\\approx", !0);
d(p, b, _, "≅", "\\cong", !0);
d(p, b, _, "≥", "\\ge");
d(p, b, _, "≥", "\\geq", !0);
d(p, b, _, "←", "\\gets");
d(p, b, _, ">", "\\gt", !0);
d(p, b, _, "∈", "\\in", !0);
d(p, b, _, "", "\\@not");
d(p, b, _, "⊂", "\\subset", !0);
d(p, b, _, "⊃", "\\supset", !0);
d(p, b, _, "⊆", "\\subseteq", !0);
d(p, b, _, "⊇", "\\supseteq", !0);
d(p, D, _, "⊈", "\\nsubseteq", !0);
d(p, D, _, "⊉", "\\nsupseteq", !0);
d(p, b, _, "⊨", "\\models");
d(p, b, _, "←", "\\leftarrow", !0);
d(p, b, _, "≤", "\\le");
d(p, b, _, "≤", "\\leq", !0);
d(p, b, _, "<", "\\lt", !0);
d(p, b, _, "→", "\\rightarrow", !0);
d(p, b, _, "→", "\\to");
d(p, D, _, "≱", "\\ngeq", !0);
d(p, D, _, "≰", "\\nleq", !0);
d(p, b, yn, " ", "\\ ");
d(p, b, yn, " ", "\\space");
d(p, b, yn, " ", "\\nobreakspace");
d(z, b, yn, " ", "\\ ");
d(z, b, yn, " ", " ");
d(z, b, yn, " ", "\\space");
d(z, b, yn, " ", "\\nobreakspace");
d(p, b, yn, null, "\\nobreak");
d(p, b, yn, null, "\\allowbreak");
d(p, b, ya, ",", ",");
d(p, b, ya, ";", ";");
d(p, D, Y, "⊼", "\\barwedge", !0);
d(p, D, Y, "⊻", "\\veebar", !0);
d(p, b, Y, "⊙", "\\odot", !0);
d(p, b, Y, "⊕", "\\oplus", !0);
d(p, b, Y, "⊗", "\\otimes", !0);
d(p, b, F, "∂", "\\partial", !0);
d(p, b, Y, "⊘", "\\oslash", !0);
d(p, D, Y, "⊚", "\\circledcirc", !0);
d(p, D, Y, "⊡", "\\boxdot", !0);
d(p, b, Y, "△", "\\bigtriangleup");
d(p, b, Y, "▽", "\\bigtriangledown");
d(p, b, Y, "†", "\\dagger");
d(p, b, Y, "⋄", "\\diamond");
d(p, b, Y, "⋆", "\\star");
d(p, b, Y, "◃", "\\triangleleft");
d(p, b, Y, "▹", "\\triangleright");
d(p, b, qt, "{", "\\{");
d(z, b, F, "{", "\\{");
d(z, b, F, "{", "\\textbraceleft");
d(p, b, _t, "}", "\\}");
d(z, b, F, "}", "\\}");
d(z, b, F, "}", "\\textbraceright");
d(p, b, qt, "{", "\\lbrace");
d(p, b, _t, "}", "\\rbrace");
d(p, b, qt, "[", "\\lbrack", !0);
d(z, b, F, "[", "\\lbrack", !0);
d(p, b, _t, "]", "\\rbrack", !0);
d(z, b, F, "]", "\\rbrack", !0);
d(p, b, qt, "(", "\\lparen", !0);
d(p, b, _t, ")", "\\rparen", !0);
d(z, b, F, "<", "\\textless", !0);
d(z, b, F, ">", "\\textgreater", !0);
d(p, b, qt, "⌊", "\\lfloor", !0);
d(p, b, _t, "⌋", "\\rfloor", !0);
d(p, b, qt, "⌈", "\\lceil", !0);
d(p, b, _t, "⌉", "\\rceil", !0);
d(p, b, F, "\\", "\\backslash");
d(p, b, F, "∣", "|");
d(p, b, F, "∣", "\\vert");
d(z, b, F, "|", "\\textbar", !0);
d(p, b, F, "∥", "\\|");
d(p, b, F, "∥", "\\Vert");
d(z, b, F, "∥", "\\textbardbl");
d(z, b, F, "~", "\\textasciitilde");
d(z, b, F, "\\", "\\textbackslash");
d(z, b, F, "^", "\\textasciicircum");
d(p, b, _, "↑", "\\uparrow", !0);
d(p, b, _, "⇑", "\\Uparrow", !0);
d(p, b, _, "↓", "\\downarrow", !0);
d(p, b, _, "⇓", "\\Downarrow", !0);
d(p, b, _, "↕", "\\updownarrow", !0);
d(p, b, _, "⇕", "\\Updownarrow", !0);
d(p, b, et, "∐", "\\coprod");
d(p, b, et, "⋁", "\\bigvee");
d(p, b, et, "⋀", "\\bigwedge");
d(p, b, et, "⨄", "\\biguplus");
d(p, b, et, "⋂", "\\bigcap");
d(p, b, et, "⋃", "\\bigcup");
d(p, b, et, "∫", "\\int");
d(p, b, et, "∫", "\\intop");
d(p, b, et, "∬", "\\iint");
d(p, b, et, "∭", "\\iiint");
d(p, b, et, "∏", "\\prod");
d(p, b, et, "∑", "\\sum");
d(p, b, et, "⨂", "\\bigotimes");
d(p, b, et, "⨁", "\\bigoplus");
d(p, b, et, "⨀", "\\bigodot");
d(p, b, et, "∮", "\\oint");
d(p, b, et, "∯", "\\oiint");
d(p, b, et, "∰", "\\oiiint");
d(p, b, et, "⨆", "\\bigsqcup");
d(p, b, et, "∫", "\\smallint");
d(z, b, os, "…", "\\textellipsis");
d(p, b, os, "…", "\\mathellipsis");
d(z, b, os, "…", "\\ldots", !0);
d(p, b, os, "…", "\\ldots", !0);
d(p, b, os, "⋯", "\\@cdots", !0);
d(p, b, os, "⋱", "\\ddots", !0);
d(p, b, F, "⋮", "\\varvdots");
d(p, b, He, "ˊ", "\\acute");
d(p, b, He, "ˋ", "\\grave");
d(p, b, He, "¨", "\\ddot");
d(p, b, He, "~", "\\tilde");
d(p, b, He, "ˉ", "\\bar");
d(p, b, He, "˘", "\\breve");
d(p, b, He, "ˇ", "\\check");
d(p, b, He, "^", "\\hat");
d(p, b, He, "⃗", "\\vec");
d(p, b, He, "˙", "\\dot");
d(p, b, He, "˚", "\\mathring");
d(p, b, se, "", "\\@imath");
d(p, b, se, "", "\\@jmath");
d(p, b, F, "ı", "ı");
d(p, b, F, "ȷ", "ȷ");
d(z, b, F, "ı", "\\i", !0);
d(z, b, F, "ȷ", "\\j", !0);
d(z, b, F, "ß", "\\ss", !0);
d(z, b, F, "æ", "\\ae", !0);
d(z, b, F, "œ", "\\oe", !0);
d(z, b, F, "ø", "\\o", !0);
d(z, b, F, "Æ", "\\AE", !0);
d(z, b, F, "Œ", "\\OE", !0);
d(z, b, F, "Ø", "\\O", !0);
d(z, b, He, "ˊ", "\\'");
d(z, b, He, "ˋ", "\\`");
d(z, b, He, "ˆ", "\\^");
d(z, b, He, "˜", "\\~");
d(z, b, He, "ˉ", "\\=");
d(z, b, He, "˘", "\\u");
d(z, b, He, "˙", "\\.");
d(z, b, He, "¸", "\\c");
d(z, b, He, "˚", "\\r");
d(z, b, He, "ˇ", "\\v");
d(z, b, He, "¨", '\\"');
d(z, b, He, "˝", "\\H");
d(z, b, He, "◯", "\\textcircled");
var u2 = {
  "--": !0,
  "---": !0,
  "``": !0,
  "''": !0
};
d(z, b, F, "–", "--", !0);
d(z, b, F, "–", "\\textendash");
d(z, b, F, "—", "---", !0);
d(z, b, F, "—", "\\textemdash");
d(z, b, F, "‘", "`", !0);
d(z, b, F, "‘", "\\textquoteleft");
d(z, b, F, "’", "'", !0);
d(z, b, F, "’", "\\textquoteright");
d(z, b, F, "“", "``", !0);
d(z, b, F, "“", "\\textquotedblleft");
d(z, b, F, "”", "''", !0);
d(z, b, F, "”", "\\textquotedblright");
d(p, b, F, "°", "\\degree", !0);
d(z, b, F, "°", "\\degree");
d(z, b, F, "°", "\\textdegree", !0);
d(p, b, F, "£", "\\pounds");
d(p, b, F, "£", "\\mathsterling", !0);
d(z, b, F, "£", "\\pounds");
d(z, b, F, "£", "\\textsterling", !0);
d(p, D, F, "✠", "\\maltese");
d(z, D, F, "✠", "\\maltese");
var D1 = '0123456789/@."';
for (var w0 = 0; w0 < D1.length; w0++) {
  var C1 = D1.charAt(w0);
  d(p, b, F, C1, C1);
}
var _1 = '0123456789!@*()-=+";:?/.,';
for (var k0 = 0; k0 < _1.length; k0++) {
  var M1 = _1.charAt(k0);
  d(z, b, F, M1, M1);
}
var Xo = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
for (var x0 = 0; x0 < Xo.length; x0++) {
  var Zl = Xo.charAt(x0);
  d(p, b, se, Zl, Zl), d(z, b, F, Zl, Zl);
}
d(p, D, F, "C", "ℂ");
d(z, D, F, "C", "ℂ");
d(p, D, F, "H", "ℍ");
d(z, D, F, "H", "ℍ");
d(p, D, F, "N", "ℕ");
d(z, D, F, "N", "ℕ");
d(p, D, F, "P", "ℙ");
d(z, D, F, "P", "ℙ");
d(p, D, F, "Q", "ℚ");
d(z, D, F, "Q", "ℚ");
d(p, D, F, "R", "ℝ");
d(z, D, F, "R", "ℝ");
d(p, D, F, "Z", "ℤ");
d(z, D, F, "Z", "ℤ");
d(p, b, se, "h", "ℎ");
d(z, b, se, "h", "ℎ");
var ce = "";
for (var yt = 0; yt < Xo.length; yt++) {
  var $e = Xo.charAt(yt);
  ce = String.fromCharCode(55349, 56320 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56372 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56424 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56580 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56684 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56736 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56788 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56840 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56944 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), yt < 26 && (ce = String.fromCharCode(55349, 56632 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce), ce = String.fromCharCode(55349, 56476 + yt), d(p, b, se, $e, ce), d(z, b, F, $e, ce));
}
ce = "𝕜";
d(p, b, se, "k", ce);
d(z, b, F, "k", ce);
for (var jn = 0; jn < 10; jn++) {
  var xn = jn.toString();
  ce = String.fromCharCode(55349, 57294 + jn), d(p, b, se, xn, ce), d(z, b, F, xn, ce), ce = String.fromCharCode(55349, 57314 + jn), d(p, b, se, xn, ce), d(z, b, F, xn, ce), ce = String.fromCharCode(55349, 57324 + jn), d(p, b, se, xn, ce), d(z, b, F, xn, ce), ce = String.fromCharCode(55349, 57334 + jn), d(p, b, se, xn, ce), d(z, b, F, xn, ce);
}
var T1 = "ÐÞþ";
for (var S0 = 0; S0 < T1.length; S0++) {
  var Jl = T1.charAt(S0);
  d(p, b, se, Jl, Jl), d(z, b, F, Jl, Jl);
}
var Ql = [
  ["mathbf", "textbf", "Main-Bold"],
  // A-Z bold upright
  ["mathbf", "textbf", "Main-Bold"],
  // a-z bold upright
  ["mathnormal", "textit", "Math-Italic"],
  // A-Z italic
  ["mathnormal", "textit", "Math-Italic"],
  // a-z italic
  ["boldsymbol", "boldsymbol", "Main-BoldItalic"],
  // A-Z bold italic
  ["boldsymbol", "boldsymbol", "Main-BoldItalic"],
  // a-z bold italic
  // Map fancy A-Z letters to script, not calligraphic.
  // This aligns with unicode-math and math fonts (except Cambria Math).
  ["mathscr", "textscr", "Script-Regular"],
  // A-Z script
  ["", "", ""],
  // a-z script.  No font
  ["", "", ""],
  // A-Z bold script. No font
  ["", "", ""],
  // a-z bold script. No font
  ["mathfrak", "textfrak", "Fraktur-Regular"],
  // A-Z Fraktur
  ["mathfrak", "textfrak", "Fraktur-Regular"],
  // a-z Fraktur
  ["mathbb", "textbb", "AMS-Regular"],
  // A-Z double-struck
  ["mathbb", "textbb", "AMS-Regular"],
  // k double-struck
  // Note that we are using a bold font, but font metrics for regular Fraktur.
  ["mathboldfrak", "textboldfrak", "Fraktur-Regular"],
  // A-Z bold Fraktur
  ["mathboldfrak", "textboldfrak", "Fraktur-Regular"],
  // a-z bold Fraktur
  ["mathsf", "textsf", "SansSerif-Regular"],
  // A-Z sans-serif
  ["mathsf", "textsf", "SansSerif-Regular"],
  // a-z sans-serif
  ["mathboldsf", "textboldsf", "SansSerif-Bold"],
  // A-Z bold sans-serif
  ["mathboldsf", "textboldsf", "SansSerif-Bold"],
  // a-z bold sans-serif
  ["mathitsf", "textitsf", "SansSerif-Italic"],
  // A-Z italic sans-serif
  ["mathitsf", "textitsf", "SansSerif-Italic"],
  // a-z italic sans-serif
  ["", "", ""],
  // A-Z bold italic sans. No font
  ["", "", ""],
  // a-z bold italic sans. No font
  ["mathtt", "texttt", "Typewriter-Regular"],
  // A-Z monospace
  ["mathtt", "texttt", "Typewriter-Regular"]
  // a-z monospace
], E1 = [
  ["mathbf", "textbf", "Main-Bold"],
  // 0-9 bold
  ["", "", ""],
  // 0-9 double-struck. No KaTeX font.
  ["mathsf", "textsf", "SansSerif-Regular"],
  // 0-9 sans-serif
  ["mathboldsf", "textboldsf", "SansSerif-Bold"],
  // 0-9 bold sans-serif
  ["mathtt", "texttt", "Typewriter-Regular"]
  // 0-9 monospace
], yk = function(e, t) {
  var r = e.charCodeAt(0), i = e.charCodeAt(1), s = (r - 55296) * 1024 + (i - 56320) + 65536, l = t === "math" ? 0 : 1;
  if (119808 <= s && s < 120484) {
    var o = Math.floor((s - 119808) / 26);
    return [Ql[o][2], Ql[o][l]];
  } else if (120782 <= s && s <= 120831) {
    var a = Math.floor((s - 120782) / 10);
    return [E1[a][2], E1[a][l]];
  } else {
    if (s === 120485 || s === 120486)
      return [Ql[0][2], Ql[0][l]];
    if (120486 < s && s < 120782)
      return ["", ""];
    throw new ie("Unsupported character: " + e);
  }
}, wa = function(e, t, r) {
  return Ze[r][e] && Ze[r][e].replace && (e = Ze[r][e].replace), {
    value: e,
    metrics: Yh(e, t, r)
  };
}, br = function(e, t, r, i, s) {
  var l = wa(e, t, r), o = l.metrics;
  e = l.value;
  var a;
  if (o) {
    var u = o.italic;
    (r === "text" || i && i.font === "mathit") && (u = 0), a = new Kr(e, o.height, o.depth, u, o.skew, o.width, s);
  } else
    typeof console < "u" && console.warn("No character metrics " + ("for '" + e + "' in style '" + t + "' and mode '" + r + "'")), a = new Kr(e, 0, 0, 0, 0, 0, s);
  if (i) {
    a.maxFontSize = i.sizeMultiplier, i.style.isTight() && a.classes.push("mtight");
    var h = i.getColor();
    h && (a.style.color = h);
  }
  return a;
}, wk = function(e, t, r, i) {
  return i === void 0 && (i = []), r.font === "boldsymbol" && wa(e, "Main-Bold", t).metrics ? br(e, "Main-Bold", t, r, i.concat(["mathbf"])) : e === "\\" || Ze[t][e].font === "main" ? br(e, "Main-Regular", t, r, i) : br(e, "AMS-Regular", t, r, i.concat(["amsrm"]));
}, kk = function(e, t, r, i, s) {
  return s !== "textord" && wa(e, "Math-BoldItalic", t).metrics ? {
    fontName: "Math-BoldItalic",
    fontClass: "boldsymbol"
  } : {
    fontName: "Main-Bold",
    fontClass: "mathbf"
  };
}, xk = function(e, t, r) {
  var i = e.mode, s = e.text, l = ["mord"], o = i === "math" || i === "text" && t.font, a = o ? t.font : t.fontFamily, u = "", h = "";
  if (s.charCodeAt(0) === 55349 && ([u, h] = yk(s, i)), u.length > 0)
    return br(s, u, i, t, l.concat(h));
  if (a) {
    var c, f;
    if (a === "boldsymbol") {
      var m = kk(s, i, t, l, r);
      c = m.fontName, f = [m.fontClass];
    } else o ? (c = f2[a].fontName, f = [a]) : (c = eo(a, t.fontWeight, t.fontShape), f = [a, t.fontWeight, t.fontShape]);
    if (wa(s, c, i).metrics)
      return br(s, c, i, t, l.concat(f));
    if (u2.hasOwnProperty(s) && c.slice(0, 10) === "Typewriter") {
      for (var g = [], v = 0; v < s.length; v++)
        g.push(br(s[v], c, i, t, l.concat(f)));
      return c2(g);
    }
  }
  if (r === "mathord")
    return br(s, "Math-Italic", i, t, l.concat(["mathnormal"]));
  if (r === "textord") {
    var k = Ze[i][s] && Ze[i][s].font;
    if (k === "ams") {
      var S = eo("amsrm", t.fontWeight, t.fontShape);
      return br(s, S, i, t, l.concat("amsrm", t.fontWeight, t.fontShape));
    } else if (k === "main" || !k) {
      var x = eo("textrm", t.fontWeight, t.fontShape);
      return br(s, x, i, t, l.concat(t.fontWeight, t.fontShape));
    } else {
      var y = eo(k, t.fontWeight, t.fontShape);
      return br(s, y, i, t, l.concat(y, t.fontWeight, t.fontShape));
    }
  } else
    throw new Error("unexpected type: " + r + " in makeOrd");
}, Sk = (n, e) => {
  if (Pn(n.classes) !== Pn(e.classes) || n.skew !== e.skew || n.maxFontSize !== e.maxFontSize)
    return !1;
  if (n.classes.length === 1) {
    var t = n.classes[0];
    if (t === "mbin" || t === "mord")
      return !1;
  }
  for (var r in n.style)
    if (n.style.hasOwnProperty(r) && n.style[r] !== e.style[r])
      return !1;
  for (var i in e.style)
    if (e.style.hasOwnProperty(i) && n.style[i] !== e.style[i])
      return !1;
  return !0;
}, Ak = (n) => {
  for (var e = 0; e < n.length - 1; e++) {
    var t = n[e], r = n[e + 1];
    t instanceof Kr && r instanceof Kr && Sk(t, r) && (t.text += r.text, t.height = Math.max(t.height, r.height), t.depth = Math.max(t.depth, r.depth), t.italic = r.italic, n.splice(e + 1, 1), e--);
  }
  return n;
}, Kh = function(e) {
  for (var t = 0, r = 0, i = 0, s = 0; s < e.children.length; s++) {
    var l = e.children[s];
    l.height > t && (t = l.height), l.depth > r && (r = l.depth), l.maxFontSize > i && (i = l.maxFontSize);
  }
  e.height = t, e.depth = r, e.maxFontSize = i;
}, Bt = function(e, t, r, i) {
  var s = new va(e, t, r, i);
  return Kh(s), s;
}, h2 = (n, e, t, r) => new va(n, e, t, r), Dk = function(e, t, r) {
  var i = Bt([e], [], t);
  return i.height = Math.max(r || t.fontMetrics().defaultRuleThickness, t.minRuleThickness), i.style.borderBottomWidth = G(i.height), i.maxFontSize = 1, i;
}, Ck = function(e, t, r, i) {
  var s = new a2(e, t, r, i);
  return Kh(s), s;
}, c2 = function(e) {
  var t = new gl(e);
  return Kh(t), t;
}, _k = function(e, t) {
  return e instanceof gl ? Bt([], [e], t) : e;
}, Mk = function(e) {
  if (e.positionType === "individualShift") {
    for (var t = e.children, r = [t[0]], i = -t[0].shift - t[0].elem.depth, s = i, l = 1; l < t.length; l++) {
      var o = -t[l].shift - s - t[l].elem.depth, a = o - (t[l - 1].elem.height + t[l - 1].elem.depth);
      s = s + o, r.push({
        type: "kern",
        size: a
      }), r.push(t[l]);
    }
    return {
      children: r,
      depth: i
    };
  }
  var u;
  if (e.positionType === "top") {
    for (var h = e.positionData, c = 0; c < e.children.length; c++) {
      var f = e.children[c];
      h -= f.type === "kern" ? f.size : f.elem.height + f.elem.depth;
    }
    u = h;
  } else if (e.positionType === "bottom")
    u = -e.positionData;
  else {
    var m = e.children[0];
    if (m.type !== "elem")
      throw new Error('First child must have type "elem".');
    if (e.positionType === "shift")
      u = -m.elem.depth - e.positionData;
    else if (e.positionType === "firstBaseline")
      u = -m.elem.depth;
    else
      throw new Error("Invalid positionType " + e.positionType + ".");
  }
  return {
    children: e.children,
    depth: u
  };
}, Tk = function(e, t) {
  for (var {
    children: r,
    depth: i
  } = Mk(e), s = 0, l = 0; l < r.length; l++) {
    var o = r[l];
    if (o.type === "elem") {
      var a = o.elem;
      s = Math.max(s, a.maxFontSize, a.height);
    }
  }
  s += 2;
  var u = Bt(["pstrut"], []);
  u.style.height = G(s);
  for (var h = [], c = i, f = i, m = i, g = 0; g < r.length; g++) {
    var v = r[g];
    if (v.type === "kern")
      m += v.size;
    else {
      var k = v.elem, S = v.wrapperClasses || [], x = v.wrapperStyle || {}, y = Bt(S, [u, k], void 0, x);
      y.style.top = G(-s - m - k.depth), v.marginLeft && (y.style.marginLeft = v.marginLeft), v.marginRight && (y.style.marginRight = v.marginRight), h.push(y), m += k.height + k.depth;
    }
    c = Math.min(c, m), f = Math.max(f, m);
  }
  var A = Bt(["vlist"], h);
  A.style.height = G(f);
  var C;
  if (c < 0) {
    var T = Bt([], []), M = Bt(["vlist"], [T]);
    M.style.height = G(-c);
    var L = Bt(["vlist-s"], [new Kr("​")]);
    C = [Bt(["vlist-r"], [A, L]), Bt(["vlist-r"], [M])];
  } else
    C = [Bt(["vlist-r"], [A])];
  var R = Bt(["vlist-t"], C);
  return C.length === 2 && R.classes.push("vlist-t2"), R.height = f, R.depth = -c, R;
}, Ek = (n, e) => {
  var t = Bt(["mspace"], [], e), r = We(n, e);
  return t.style.marginRight = G(r), t;
}, eo = function(e, t, r) {
  var i = "";
  switch (e) {
    case "amsrm":
      i = "AMS";
      break;
    case "textrm":
      i = "Main";
      break;
    case "textsf":
      i = "SansSerif";
      break;
    case "texttt":
      i = "Typewriter";
      break;
    default:
      i = e;
  }
  var s;
  return t === "textbf" && r === "textit" ? s = "BoldItalic" : t === "textbf" ? s = "Bold" : t === "textit" ? s = "Italic" : s = "Regular", i + "-" + s;
}, f2 = {
  // styles
  mathbf: {
    variant: "bold",
    fontName: "Main-Bold"
  },
  mathrm: {
    variant: "normal",
    fontName: "Main-Regular"
  },
  textit: {
    variant: "italic",
    fontName: "Main-Italic"
  },
  mathit: {
    variant: "italic",
    fontName: "Main-Italic"
  },
  mathnormal: {
    variant: "italic",
    fontName: "Math-Italic"
  },
  // "boldsymbol" is missing because they require the use of multiple fonts:
  // Math-BoldItalic and Main-Bold.  This is handled by a special case in
  // makeOrd which ends up calling boldsymbol.
  // families
  mathbb: {
    variant: "double-struck",
    fontName: "AMS-Regular"
  },
  mathcal: {
    variant: "script",
    fontName: "Caligraphic-Regular"
  },
  mathfrak: {
    variant: "fraktur",
    fontName: "Fraktur-Regular"
  },
  mathscr: {
    variant: "script",
    fontName: "Script-Regular"
  },
  mathsf: {
    variant: "sans-serif",
    fontName: "SansSerif-Regular"
  },
  mathtt: {
    variant: "monospace",
    fontName: "Typewriter-Regular"
  }
}, d2 = {
  //   path, width, height
  vec: ["vec", 0.471, 0.714],
  // values from the font glyph
  oiintSize1: ["oiintSize1", 0.957, 0.499],
  // oval to overlay the integrand
  oiintSize2: ["oiintSize2", 1.472, 0.659],
  oiiintSize1: ["oiiintSize1", 1.304, 0.499],
  oiiintSize2: ["oiiintSize2", 1.98, 0.659]
}, Fk = function(e, t) {
  var [r, i, s] = d2[e], l = new ci(r), o = new Hn([l], {
    width: G(i),
    height: G(s),
    // Override CSS rule `.katex svg { width: 100% }`
    style: "width:" + G(i),
    viewBox: "0 0 " + 1e3 * i + " " + 1e3 * s,
    preserveAspectRatio: "xMinYMin"
  }), a = h2(["overlay"], [o], t);
  return a.height = s, a.style.height = G(s), a.style.width = G(i), a;
}, O = {
  fontMap: f2,
  makeSymbol: br,
  mathsym: wk,
  makeSpan: Bt,
  makeSvgSpan: h2,
  makeLineSpan: Dk,
  makeAnchor: Ck,
  makeFragment: c2,
  wrapFragment: _k,
  makeVList: Tk,
  makeOrd: xk,
  makeGlue: Ek,
  staticSvg: Fk,
  svgData: d2,
  tryCombineChars: Ak
}, qe = {
  number: 3,
  unit: "mu"
}, $n = {
  number: 4,
  unit: "mu"
}, on = {
  number: 5,
  unit: "mu"
}, Bk = {
  mord: {
    mop: qe,
    mbin: $n,
    mrel: on,
    minner: qe
  },
  mop: {
    mord: qe,
    mop: qe,
    mrel: on,
    minner: qe
  },
  mbin: {
    mord: $n,
    mop: $n,
    mopen: $n,
    minner: $n
  },
  mrel: {
    mord: on,
    mop: on,
    mopen: on,
    minner: on
  },
  mopen: {},
  mclose: {
    mop: qe,
    mbin: $n,
    mrel: on,
    minner: qe
  },
  mpunct: {
    mord: qe,
    mop: qe,
    mrel: on,
    mopen: qe,
    mclose: qe,
    mpunct: qe,
    minner: qe
  },
  minner: {
    mord: qe,
    mop: qe,
    mbin: $n,
    mrel: on,
    mopen: qe,
    mpunct: qe,
    minner: qe
  }
}, Ok = {
  mord: {
    mop: qe
  },
  mop: {
    mord: qe,
    mop: qe
  },
  mbin: {},
  mrel: {},
  mopen: {},
  mclose: {
    mop: qe
  },
  mpunct: {},
  minner: {
    mop: qe
  }
}, m2 = {}, Zo = {}, Jo = {};
function $(n) {
  for (var {
    type: e,
    names: t,
    props: r,
    handler: i,
    htmlBuilder: s,
    mathmlBuilder: l
  } = n, o = {
    type: e,
    numArgs: r.numArgs,
    argTypes: r.argTypes,
    allowedInArgument: !!r.allowedInArgument,
    allowedInText: !!r.allowedInText,
    allowedInMath: r.allowedInMath === void 0 ? !0 : r.allowedInMath,
    numOptionalArgs: r.numOptionalArgs || 0,
    infix: !!r.infix,
    primitive: !!r.primitive,
    handler: i
  }, a = 0; a < t.length; ++a)
    m2[t[a]] = o;
  e && (s && (Zo[e] = s), l && (Jo[e] = l));
}
function vi(n) {
  var {
    type: e,
    htmlBuilder: t,
    mathmlBuilder: r
  } = n;
  $({
    type: e,
    names: [],
    props: {
      numArgs: 0
    },
    handler() {
      throw new Error("Should never be called.");
    },
    htmlBuilder: t,
    mathmlBuilder: r
  });
}
var Qo = function(e) {
  return e.type === "ordgroup" && e.body.length === 1 ? e.body[0] : e;
}, Xe = function(e) {
  return e.type === "ordgroup" ? e.body : [e];
}, ts = O.makeSpan, Rk = ["leftmost", "mbin", "mopen", "mrel", "mop", "mpunct"], Lk = ["rightmost", "mrel", "mclose", "mpunct"], Nk = {
  display: ue.DISPLAY,
  text: ue.TEXT,
  script: ue.SCRIPT,
  scriptscript: ue.SCRIPTSCRIPT
}, Ik = {
  mord: "mord",
  mop: "mop",
  mbin: "mbin",
  mrel: "mrel",
  mopen: "mopen",
  mclose: "mclose",
  mpunct: "mpunct",
  minner: "minner"
}, ut = function(e, t, r, i) {
  i === void 0 && (i = [null, null]);
  for (var s = [], l = 0; l < e.length; l++) {
    var o = De(e[l], t);
    if (o instanceof gl) {
      var a = o.children;
      s.push(...a);
    } else
      s.push(o);
  }
  if (O.tryCombineChars(s), !r)
    return s;
  var u = t;
  if (e.length === 1) {
    var h = e[0];
    h.type === "sizing" ? u = t.havingSize(h.size) : h.type === "styling" && (u = t.havingStyle(Nk[h.style]));
  }
  var c = ts([i[0] || "leftmost"], [], t), f = ts([i[1] || "rightmost"], [], t), m = r === "root";
  return F1(s, (g, v) => {
    var k = v.classes[0], S = g.classes[0];
    k === "mbin" && le.contains(Lk, S) ? v.classes[0] = "mord" : S === "mbin" && le.contains(Rk, k) && (g.classes[0] = "mord");
  }, {
    node: c
  }, f, m), F1(s, (g, v) => {
    var k = qu(v), S = qu(g), x = k && S ? g.hasClass("mtight") ? Ok[k][S] : Bk[k][S] : null;
    if (x)
      return O.makeGlue(x, u);
  }, {
    node: c
  }, f, m), s;
}, F1 = function n(e, t, r, i, s) {
  i && e.push(i);
  for (var l = 0; l < e.length; l++) {
    var o = e[l], a = p2(o);
    if (a) {
      n(a.children, t, r, null, s);
      continue;
    }
    var u = !o.hasClass("mspace");
    if (u) {
      var h = t(o, r.node);
      h && (r.insertAfter ? r.insertAfter(h) : (e.unshift(h), l++));
    }
    u ? r.node = o : s && o.hasClass("newline") && (r.node = ts(["leftmost"])), r.insertAfter = /* @__PURE__ */ ((c) => (f) => {
      e.splice(c + 1, 0, f), l++;
    })(l);
  }
  i && e.pop();
}, p2 = function(e) {
  return e instanceof gl || e instanceof a2 || e instanceof va && e.hasClass("enclosing") ? e : null;
}, zk = function n(e, t) {
  var r = p2(e);
  if (r) {
    var i = r.children;
    if (i.length) {
      if (t === "right")
        return n(i[i.length - 1], "right");
      if (t === "left")
        return n(i[0], "left");
    }
  }
  return e;
}, qu = function(e, t) {
  return e ? (t && (e = zk(e, t)), Ik[e.classes[0]] || null) : null;
}, ol = function(e, t) {
  var r = ["nulldelimiter"].concat(e.baseSizingClasses());
  return ts(t.concat(r));
}, De = function(e, t, r) {
  if (!e)
    return ts();
  if (Zo[e.type]) {
    var i = Zo[e.type](e, t);
    if (r && t.size !== r.size) {
      i = ts(t.sizingClasses(r), [i], t);
      var s = t.sizeMultiplier / r.sizeMultiplier;
      i.height *= s, i.depth *= s;
    }
    return i;
  } else
    throw new ie("Got group of unknown type: '" + e.type + "'");
};
function g2(n) {
  return new gl(n);
}
class yr {
  constructor(e, t, r) {
    this.type = void 0, this.attributes = void 0, this.children = void 0, this.classes = void 0, this.type = e, this.attributes = {}, this.children = t || [], this.classes = r || [];
  }
  /**
   * Sets an attribute on a MathML node. MathML depends on attributes to convey a
   * semantic content, so this is used heavily.
   */
  setAttribute(e, t) {
    this.attributes[e] = t;
  }
  /**
   * Gets an attribute on a MathML node.
   */
  getAttribute(e) {
    return this.attributes[e];
  }
  /**
   * Converts the math node into a MathML-namespaced DOM element.
   */
  toNode() {
    var e = document.createElementNS("http://www.w3.org/1998/Math/MathML", this.type);
    for (var t in this.attributes)
      Object.prototype.hasOwnProperty.call(this.attributes, t) && e.setAttribute(t, this.attributes[t]);
    this.classes.length > 0 && (e.className = Pn(this.classes));
    for (var r = 0; r < this.children.length; r++)
      e.appendChild(this.children[r].toNode());
    return e;
  }
  /**
   * Converts the math node into an HTML markup string.
   */
  toMarkup() {
    var e = "<" + this.type;
    for (var t in this.attributes)
      Object.prototype.hasOwnProperty.call(this.attributes, t) && (e += " " + t + '="', e += le.escape(this.attributes[t]), e += '"');
    this.classes.length > 0 && (e += ' class ="' + le.escape(Pn(this.classes)) + '"'), e += ">";
    for (var r = 0; r < this.children.length; r++)
      e += this.children[r].toMarkup();
    return e += "</" + this.type + ">", e;
  }
  /**
   * Converts the math node into a string, similar to innerText, but escaped.
   */
  toText() {
    return this.children.map((e) => e.toText()).join("");
  }
}
class Vs {
  constructor(e) {
    this.text = void 0, this.text = e;
  }
  /**
   * Converts the text node into a DOM text node.
   */
  toNode() {
    return document.createTextNode(this.text);
  }
  /**
   * Converts the text node into escaped HTML markup
   * (representing the text itself).
   */
  toMarkup() {
    return le.escape(this.toText());
  }
  /**
   * Converts the text node into a string
   * (representing the text itself).
   */
  toText() {
    return this.text;
  }
}
class Pk {
  /**
   * Create a Space node with width given in CSS ems.
   */
  constructor(e) {
    this.width = void 0, this.character = void 0, this.width = e, e >= 0.05555 && e <= 0.05556 ? this.character = " " : e >= 0.1666 && e <= 0.1667 ? this.character = " " : e >= 0.2222 && e <= 0.2223 ? this.character = " " : e >= 0.2777 && e <= 0.2778 ? this.character = "  " : e >= -0.05556 && e <= -0.05555 ? this.character = " ⁣" : e >= -0.1667 && e <= -0.1666 ? this.character = " ⁣" : e >= -0.2223 && e <= -0.2222 ? this.character = " ⁣" : e >= -0.2778 && e <= -0.2777 ? this.character = " ⁣" : this.character = null;
  }
  /**
   * Converts the math node into a MathML-namespaced DOM element.
   */
  toNode() {
    if (this.character)
      return document.createTextNode(this.character);
    var e = document.createElementNS("http://www.w3.org/1998/Math/MathML", "mspace");
    return e.setAttribute("width", G(this.width)), e;
  }
  /**
   * Converts the math node into an HTML markup string.
   */
  toMarkup() {
    return this.character ? "<mtext>" + this.character + "</mtext>" : '<mspace width="' + G(this.width) + '"/>';
  }
  /**
   * Converts the math node into a string, similar to innerText.
   */
  toText() {
    return this.character ? this.character : " ";
  }
}
var V = {
  MathNode: yr,
  TextNode: Vs,
  SpaceNode: Pk,
  newDocumentFragment: g2
}, sr = function(e, t, r) {
  return Ze[t][e] && Ze[t][e].replace && e.charCodeAt(0) !== 55349 && !(u2.hasOwnProperty(e) && r && (r.fontFamily && r.fontFamily.slice(4, 6) === "tt" || r.font && r.font.slice(4, 6) === "tt")) && (e = Ze[t][e].replace), new V.TextNode(e);
}, Xh = function(e) {
  return e.length === 1 ? e[0] : new V.MathNode("mrow", e);
}, Zh = function(e, t) {
  if (t.fontFamily === "texttt")
    return "monospace";
  if (t.fontFamily === "textsf")
    return t.fontShape === "textit" && t.fontWeight === "textbf" ? "sans-serif-bold-italic" : t.fontShape === "textit" ? "sans-serif-italic" : t.fontWeight === "textbf" ? "bold-sans-serif" : "sans-serif";
  if (t.fontShape === "textit" && t.fontWeight === "textbf")
    return "bold-italic";
  if (t.fontShape === "textit")
    return "italic";
  if (t.fontWeight === "textbf")
    return "bold";
  var r = t.font;
  if (!r || r === "mathnormal")
    return null;
  var i = e.mode;
  if (r === "mathit")
    return "italic";
  if (r === "boldsymbol")
    return e.type === "textord" ? "bold" : "bold-italic";
  if (r === "mathbf")
    return "bold";
  if (r === "mathbb")
    return "double-struck";
  if (r === "mathfrak")
    return "fraktur";
  if (r === "mathscr" || r === "mathcal")
    return "script";
  if (r === "mathsf")
    return "sans-serif";
  if (r === "mathtt")
    return "monospace";
  var s = e.text;
  if (le.contains(["\\imath", "\\jmath"], s))
    return null;
  Ze[i][s] && Ze[i][s].replace && (s = Ze[i][s].replace);
  var l = O.fontMap[r].fontName;
  return Yh(s, l, i) ? O.fontMap[r].variant : null;
}, Vt = function(e, t, r) {
  if (e.length === 1) {
    var i = Oe(e[0], t);
    return r && i instanceof yr && i.type === "mo" && (i.setAttribute("lspace", "0em"), i.setAttribute("rspace", "0em")), [i];
  }
  for (var s = [], l, o = 0; o < e.length; o++) {
    var a = Oe(e[o], t);
    if (a instanceof yr && l instanceof yr) {
      if (a.type === "mtext" && l.type === "mtext" && a.getAttribute("mathvariant") === l.getAttribute("mathvariant")) {
        l.children.push(...a.children);
        continue;
      } else if (a.type === "mn" && l.type === "mn") {
        l.children.push(...a.children);
        continue;
      } else if (a.type === "mi" && a.children.length === 1 && l.type === "mn") {
        var u = a.children[0];
        if (u instanceof Vs && u.text === ".") {
          l.children.push(...a.children);
          continue;
        }
      } else if (l.type === "mi" && l.children.length === 1) {
        var h = l.children[0];
        if (h instanceof Vs && h.text === "̸" && (a.type === "mo" || a.type === "mi" || a.type === "mn")) {
          var c = a.children[0];
          c instanceof Vs && c.text.length > 0 && (c.text = c.text.slice(0, 1) + "̸" + c.text.slice(1), s.pop());
        }
      }
    }
    s.push(a), l = a;
  }
  return s;
}, qn = function(e, t, r) {
  return Xh(Vt(e, t, r));
}, Oe = function(e, t) {
  if (!e)
    return new V.MathNode("mrow");
  if (Jo[e.type]) {
    var r = Jo[e.type](e, t);
    return r;
  } else
    throw new ie("Got group of unknown type: '" + e.type + "'");
}, Hk = {
  widehat: "^",
  widecheck: "ˇ",
  widetilde: "~",
  utilde: "~",
  overleftarrow: "←",
  underleftarrow: "←",
  xleftarrow: "←",
  overrightarrow: "→",
  underrightarrow: "→",
  xrightarrow: "→",
  underbrace: "⏟",
  overbrace: "⏞",
  overgroup: "⏠",
  undergroup: "⏡",
  overleftrightarrow: "↔",
  underleftrightarrow: "↔",
  xleftrightarrow: "↔",
  Overrightarrow: "⇒",
  xRightarrow: "⇒",
  overleftharpoon: "↼",
  xleftharpoonup: "↼",
  overrightharpoon: "⇀",
  xrightharpoonup: "⇀",
  xLeftarrow: "⇐",
  xLeftrightarrow: "⇔",
  xhookleftarrow: "↩",
  xhookrightarrow: "↪",
  xmapsto: "↦",
  xrightharpoondown: "⇁",
  xleftharpoondown: "↽",
  xrightleftharpoons: "⇌",
  xleftrightharpoons: "⇋",
  xtwoheadleftarrow: "↞",
  xtwoheadrightarrow: "↠",
  xlongequal: "=",
  xtofrom: "⇄",
  xrightleftarrows: "⇄",
  xrightequilibrium: "⇌",
  // Not a perfect match.
  xleftequilibrium: "⇋",
  // None better available.
  "\\cdrightarrow": "→",
  "\\cdleftarrow": "←",
  "\\cdlongequal": "="
}, qk = function(e) {
  var t = new V.MathNode("mo", [new V.TextNode(Hk[e.replace(/^\\/, "")])]);
  return t.setAttribute("stretchy", "true"), t;
}, Vk = {
  //   path(s), minWidth, height, align
  overrightarrow: [["rightarrow"], 0.888, 522, "xMaxYMin"],
  overleftarrow: [["leftarrow"], 0.888, 522, "xMinYMin"],
  underrightarrow: [["rightarrow"], 0.888, 522, "xMaxYMin"],
  underleftarrow: [["leftarrow"], 0.888, 522, "xMinYMin"],
  xrightarrow: [["rightarrow"], 1.469, 522, "xMaxYMin"],
  "\\cdrightarrow": [["rightarrow"], 3, 522, "xMaxYMin"],
  // CD minwwidth2.5pc
  xleftarrow: [["leftarrow"], 1.469, 522, "xMinYMin"],
  "\\cdleftarrow": [["leftarrow"], 3, 522, "xMinYMin"],
  Overrightarrow: [["doublerightarrow"], 0.888, 560, "xMaxYMin"],
  xRightarrow: [["doublerightarrow"], 1.526, 560, "xMaxYMin"],
  xLeftarrow: [["doubleleftarrow"], 1.526, 560, "xMinYMin"],
  overleftharpoon: [["leftharpoon"], 0.888, 522, "xMinYMin"],
  xleftharpoonup: [["leftharpoon"], 0.888, 522, "xMinYMin"],
  xleftharpoondown: [["leftharpoondown"], 0.888, 522, "xMinYMin"],
  overrightharpoon: [["rightharpoon"], 0.888, 522, "xMaxYMin"],
  xrightharpoonup: [["rightharpoon"], 0.888, 522, "xMaxYMin"],
  xrightharpoondown: [["rightharpoondown"], 0.888, 522, "xMaxYMin"],
  xlongequal: [["longequal"], 0.888, 334, "xMinYMin"],
  "\\cdlongequal": [["longequal"], 3, 334, "xMinYMin"],
  xtwoheadleftarrow: [["twoheadleftarrow"], 0.888, 334, "xMinYMin"],
  xtwoheadrightarrow: [["twoheadrightarrow"], 0.888, 334, "xMaxYMin"],
  overleftrightarrow: [["leftarrow", "rightarrow"], 0.888, 522],
  overbrace: [["leftbrace", "midbrace", "rightbrace"], 1.6, 548],
  underbrace: [["leftbraceunder", "midbraceunder", "rightbraceunder"], 1.6, 548],
  underleftrightarrow: [["leftarrow", "rightarrow"], 0.888, 522],
  xleftrightarrow: [["leftarrow", "rightarrow"], 1.75, 522],
  xLeftrightarrow: [["doubleleftarrow", "doublerightarrow"], 1.75, 560],
  xrightleftharpoons: [["leftharpoondownplus", "rightharpoonplus"], 1.75, 716],
  xleftrightharpoons: [["leftharpoonplus", "rightharpoondownplus"], 1.75, 716],
  xhookleftarrow: [["leftarrow", "righthook"], 1.08, 522],
  xhookrightarrow: [["lefthook", "rightarrow"], 1.08, 522],
  overlinesegment: [["leftlinesegment", "rightlinesegment"], 0.888, 522],
  underlinesegment: [["leftlinesegment", "rightlinesegment"], 0.888, 522],
  overgroup: [["leftgroup", "rightgroup"], 0.888, 342],
  undergroup: [["leftgroupunder", "rightgroupunder"], 0.888, 342],
  xmapsto: [["leftmapsto", "rightarrow"], 1.5, 522],
  xtofrom: [["leftToFrom", "rightToFrom"], 1.75, 528],
  // The next three arrows are from the mhchem package.
  // In mhchem.sty, min-length is 2.0em. But these arrows might appear in the
  // document as \xrightarrow or \xrightleftharpoons. Those have
  // min-length = 1.75em, so we set min-length on these next three to match.
  xrightleftarrows: [["baraboveleftarrow", "rightarrowabovebar"], 1.75, 901],
  xrightequilibrium: [["baraboveshortleftharpoon", "rightharpoonaboveshortbar"], 1.75, 716],
  xleftequilibrium: [["shortbaraboveleftharpoon", "shortrightharpoonabovebar"], 1.75, 716]
}, Wk = function(e) {
  return e.type === "ordgroup" ? e.body.length : 1;
}, Uk = function(e, t) {
  function r() {
    var o = 4e5, a = e.label.slice(1);
    if (le.contains(["widehat", "widecheck", "widetilde", "utilde"], a)) {
      var u = e, h = Wk(u.base), c, f, m;
      if (h > 5)
        a === "widehat" || a === "widecheck" ? (c = 420, o = 2364, m = 0.42, f = a + "4") : (c = 312, o = 2340, m = 0.34, f = "tilde4");
      else {
        var g = [1, 1, 2, 2, 3, 3][h];
        a === "widehat" || a === "widecheck" ? (o = [0, 1062, 2364, 2364, 2364][g], c = [0, 239, 300, 360, 420][g], m = [0, 0.24, 0.3, 0.3, 0.36, 0.42][g], f = a + g) : (o = [0, 600, 1033, 2339, 2340][g], c = [0, 260, 286, 306, 312][g], m = [0, 0.26, 0.286, 0.3, 0.306, 0.34][g], f = "tilde" + g);
      }
      var v = new ci(f), k = new Hn([v], {
        width: "100%",
        height: G(m),
        viewBox: "0 0 " + o + " " + c,
        preserveAspectRatio: "none"
      });
      return {
        span: O.makeSvgSpan([], [k], t),
        minWidth: 0,
        height: m
      };
    } else {
      var S = [], x = Vk[a], [y, A, C] = x, T = C / 1e3, M = y.length, L, R;
      if (M === 1) {
        var N = x[3];
        L = ["hide-tail"], R = [N];
      } else if (M === 2)
        L = ["halfarrow-left", "halfarrow-right"], R = ["xMinYMin", "xMaxYMin"];
      else if (M === 3)
        L = ["brace-left", "brace-center", "brace-right"], R = ["xMinYMin", "xMidYMin", "xMaxYMin"];
      else
        throw new Error(`Correct katexImagesData or update code here to support
                    ` + M + " children.");
      for (var W = 0; W < M; W++) {
        var q = new ci(y[W]), he = new Hn([q], {
          width: "400em",
          height: G(T),
          viewBox: "0 0 " + o + " " + C,
          preserveAspectRatio: R[W] + " slice"
        }), Z = O.makeSvgSpan([L[W]], [he], t);
        if (M === 1)
          return {
            span: Z,
            minWidth: A,
            height: T
          };
        Z.style.height = G(T), S.push(Z);
      }
      return {
        span: O.makeSpan(["stretchy"], S, t),
        minWidth: A,
        height: T
      };
    }
  }
  var {
    span: i,
    minWidth: s,
    height: l
  } = r();
  return i.height = l, i.style.height = G(l), s > 0 && (i.style.minWidth = G(s)), i;
}, Gk = function(e, t, r, i, s) {
  var l, o = e.height + e.depth + r + i;
  if (/fbox|color|angl/.test(t)) {
    if (l = O.makeSpan(["stretchy", t], [], s), t === "fbox") {
      var a = s.color && s.getColor();
      a && (l.style.borderColor = a);
    }
  } else {
    var u = [];
    /^[bx]cancel$/.test(t) && u.push(new S1({
      x1: "0",
      y1: "0",
      x2: "100%",
      y2: "100%",
      "stroke-width": "0.046em"
    })), /^x?cancel$/.test(t) && u.push(new S1({
      x1: "0",
      y1: "100%",
      x2: "100%",
      y2: "0",
      "stroke-width": "0.046em"
    }));
    var h = new Hn(u, {
      width: "100%",
      height: G(o)
    });
    l = O.makeSvgSpan([], [h], s);
  }
  return l.height = o, l.style.height = G(o), l;
}, bn = {
  encloseSpan: Gk,
  mathMLnode: qk,
  svgSpan: Uk
};
function ge(n, e) {
  if (!n || n.type !== e)
    throw new Error("Expected node of type " + e + ", but got " + (n ? "node of type " + n.type : String(n)));
  return n;
}
function Jh(n) {
  var e = ka(n);
  if (!e)
    throw new Error("Expected node of symbol group type, but got " + (n ? "node of type " + n.type : String(n)));
  return e;
}
function ka(n) {
  return n && (n.type === "atom" || vk.hasOwnProperty(n.type)) ? n : null;
}
var Qh = (n, e) => {
  var t, r, i;
  n && n.type === "supsub" ? (r = ge(n.base, "accent"), t = r.base, n.base = t, i = bk(De(n, e)), n.base = r) : (r = ge(n, "accent"), t = r.base);
  var s = De(t, e.havingCrampedStyle()), l = r.isShifty && le.isCharacterBox(t), o = 0;
  if (l) {
    var a = le.getBaseElem(t), u = De(a, e.havingCrampedStyle());
    o = A1(u).skew;
  }
  var h = r.label === "\\c", c = h ? s.height + s.depth : Math.min(s.height, e.fontMetrics().xHeight), f;
  if (r.isStretchy)
    f = bn.svgSpan(r, e), f = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: s
      }, {
        type: "elem",
        elem: f,
        wrapperClasses: ["svg-align"],
        wrapperStyle: o > 0 ? {
          width: "calc(100% - " + G(2 * o) + ")",
          marginLeft: G(2 * o)
        } : void 0
      }]
    }, e);
  else {
    var m, g;
    r.label === "\\vec" ? (m = O.staticSvg("vec", e), g = O.svgData.vec[1]) : (m = O.makeOrd({
      mode: r.mode,
      text: r.label
    }, e, "textord"), m = A1(m), m.italic = 0, g = m.width, h && (c += m.depth)), f = O.makeSpan(["accent-body"], [m]);
    var v = r.label === "\\textcircled";
    v && (f.classes.push("accent-full"), c = s.height);
    var k = o;
    v || (k -= g / 2), f.style.left = G(k), r.label === "\\textcircled" && (f.style.top = ".2em"), f = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: s
      }, {
        type: "kern",
        size: -c
      }, {
        type: "elem",
        elem: f
      }]
    }, e);
  }
  var S = O.makeSpan(["mord", "accent"], [f], e);
  return i ? (i.children[0] = S, i.height = Math.max(S.height, i.height), i.classes[0] = "mord", i) : S;
}, b2 = (n, e) => {
  var t = n.isStretchy ? bn.mathMLnode(n.label) : new V.MathNode("mo", [sr(n.label, n.mode)]), r = new V.MathNode("mover", [Oe(n.base, e), t]);
  return r.setAttribute("accent", "true"), r;
}, jk = new RegExp(["\\acute", "\\grave", "\\ddot", "\\tilde", "\\bar", "\\breve", "\\check", "\\hat", "\\vec", "\\dot", "\\mathring"].map((n) => "\\" + n).join("|"));
$({
  type: "accent",
  names: ["\\acute", "\\grave", "\\ddot", "\\tilde", "\\bar", "\\breve", "\\check", "\\hat", "\\vec", "\\dot", "\\mathring", "\\widecheck", "\\widehat", "\\widetilde", "\\overrightarrow", "\\overleftarrow", "\\Overrightarrow", "\\overleftrightarrow", "\\overgroup", "\\overlinesegment", "\\overleftharpoon", "\\overrightharpoon"],
  props: {
    numArgs: 1
  },
  handler: (n, e) => {
    var t = Qo(e[0]), r = !jk.test(n.funcName), i = !r || n.funcName === "\\widehat" || n.funcName === "\\widetilde" || n.funcName === "\\widecheck";
    return {
      type: "accent",
      mode: n.parser.mode,
      label: n.funcName,
      isStretchy: r,
      isShifty: i,
      base: t
    };
  },
  htmlBuilder: Qh,
  mathmlBuilder: b2
});
$({
  type: "accent",
  names: ["\\'", "\\`", "\\^", "\\~", "\\=", "\\u", "\\.", '\\"', "\\c", "\\r", "\\H", "\\v", "\\textcircled"],
  props: {
    numArgs: 1,
    allowedInText: !0,
    allowedInMath: !0,
    // unless in strict mode
    argTypes: ["primitive"]
  },
  handler: (n, e) => {
    var t = e[0], r = n.parser.mode;
    return r === "math" && (n.parser.settings.reportNonstrict("mathVsTextAccents", "LaTeX's accent " + n.funcName + " works only in text mode"), r = "text"), {
      type: "accent",
      mode: r,
      label: n.funcName,
      isStretchy: !1,
      isShifty: !0,
      base: t
    };
  },
  htmlBuilder: Qh,
  mathmlBuilder: b2
});
$({
  type: "accentUnder",
  names: ["\\underleftarrow", "\\underrightarrow", "\\underleftrightarrow", "\\undergroup", "\\underlinesegment", "\\utilde"],
  props: {
    numArgs: 1
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    return {
      type: "accentUnder",
      mode: t.mode,
      label: r,
      base: i
    };
  },
  htmlBuilder: (n, e) => {
    var t = De(n.base, e), r = bn.svgSpan(n, e), i = n.label === "\\utilde" ? 0.12 : 0, s = O.makeVList({
      positionType: "top",
      positionData: t.height,
      children: [{
        type: "elem",
        elem: r,
        wrapperClasses: ["svg-align"]
      }, {
        type: "kern",
        size: i
      }, {
        type: "elem",
        elem: t
      }]
    }, e);
    return O.makeSpan(["mord", "accentunder"], [s], e);
  },
  mathmlBuilder: (n, e) => {
    var t = bn.mathMLnode(n.label), r = new V.MathNode("munder", [Oe(n.base, e), t]);
    return r.setAttribute("accentunder", "true"), r;
  }
});
var to = (n) => {
  var e = new V.MathNode("mpadded", n ? [n] : []);
  return e.setAttribute("width", "+0.6em"), e.setAttribute("lspace", "0.3em"), e;
};
$({
  type: "xArrow",
  names: [
    "\\xleftarrow",
    "\\xrightarrow",
    "\\xLeftarrow",
    "\\xRightarrow",
    "\\xleftrightarrow",
    "\\xLeftrightarrow",
    "\\xhookleftarrow",
    "\\xhookrightarrow",
    "\\xmapsto",
    "\\xrightharpoondown",
    "\\xrightharpoonup",
    "\\xleftharpoondown",
    "\\xleftharpoonup",
    "\\xrightleftharpoons",
    "\\xleftrightharpoons",
    "\\xlongequal",
    "\\xtwoheadrightarrow",
    "\\xtwoheadleftarrow",
    "\\xtofrom",
    // The next 3 functions are here to support the mhchem extension.
    // Direct use of these functions is discouraged and may break someday.
    "\\xrightleftarrows",
    "\\xrightequilibrium",
    "\\xleftequilibrium",
    // The next 3 functions are here only to support the {CD} environment.
    "\\\\cdrightarrow",
    "\\\\cdleftarrow",
    "\\\\cdlongequal"
  ],
  props: {
    numArgs: 1,
    numOptionalArgs: 1
  },
  handler(n, e, t) {
    var {
      parser: r,
      funcName: i
    } = n;
    return {
      type: "xArrow",
      mode: r.mode,
      label: i,
      body: e[0],
      below: t[0]
    };
  },
  // Flow is unable to correctly infer the type of `group`, even though it's
  // unambiguously determined from the passed-in `type` above.
  htmlBuilder(n, e) {
    var t = e.style, r = e.havingStyle(t.sup()), i = O.wrapFragment(De(n.body, r, e), e), s = n.label.slice(0, 2) === "\\x" ? "x" : "cd";
    i.classes.push(s + "-arrow-pad");
    var l;
    n.below && (r = e.havingStyle(t.sub()), l = O.wrapFragment(De(n.below, r, e), e), l.classes.push(s + "-arrow-pad"));
    var o = bn.svgSpan(n, e), a = -e.fontMetrics().axisHeight + 0.5 * o.height, u = -e.fontMetrics().axisHeight - 0.5 * o.height - 0.111;
    (i.depth > 0.25 || n.label === "\\xleftequilibrium") && (u -= i.depth);
    var h;
    if (l) {
      var c = -e.fontMetrics().axisHeight + l.height + 0.5 * o.height + 0.111;
      h = O.makeVList({
        positionType: "individualShift",
        children: [{
          type: "elem",
          elem: i,
          shift: u
        }, {
          type: "elem",
          elem: o,
          shift: a
        }, {
          type: "elem",
          elem: l,
          shift: c
        }]
      }, e);
    } else
      h = O.makeVList({
        positionType: "individualShift",
        children: [{
          type: "elem",
          elem: i,
          shift: u
        }, {
          type: "elem",
          elem: o,
          shift: a
        }]
      }, e);
    return h.children[0].children[0].children[1].classes.push("svg-align"), O.makeSpan(["mrel", "x-arrow"], [h], e);
  },
  mathmlBuilder(n, e) {
    var t = bn.mathMLnode(n.label);
    t.setAttribute("minsize", n.label.charAt(0) === "x" ? "1.75em" : "3.0em");
    var r;
    if (n.body) {
      var i = to(Oe(n.body, e));
      if (n.below) {
        var s = to(Oe(n.below, e));
        r = new V.MathNode("munderover", [t, s, i]);
      } else
        r = new V.MathNode("mover", [t, i]);
    } else if (n.below) {
      var l = to(Oe(n.below, e));
      r = new V.MathNode("munder", [t, l]);
    } else
      r = to(), r = new V.MathNode("mover", [t, r]);
    return r;
  }
});
var $k = O.makeSpan;
function v2(n, e) {
  var t = ut(n.body, e, !0);
  return $k([n.mclass], t, e);
}
function y2(n, e) {
  var t, r = Vt(n.body, e);
  return n.mclass === "minner" ? t = new V.MathNode("mpadded", r) : n.mclass === "mord" ? n.isCharacterBox ? (t = r[0], t.type = "mi") : t = new V.MathNode("mi", r) : (n.isCharacterBox ? (t = r[0], t.type = "mo") : t = new V.MathNode("mo", r), n.mclass === "mbin" ? (t.attributes.lspace = "0.22em", t.attributes.rspace = "0.22em") : n.mclass === "mpunct" ? (t.attributes.lspace = "0em", t.attributes.rspace = "0.17em") : n.mclass === "mopen" || n.mclass === "mclose" ? (t.attributes.lspace = "0em", t.attributes.rspace = "0em") : n.mclass === "minner" && (t.attributes.lspace = "0.0556em", t.attributes.width = "+0.1111em")), t;
}
$({
  type: "mclass",
  names: ["\\mathord", "\\mathbin", "\\mathrel", "\\mathopen", "\\mathclose", "\\mathpunct", "\\mathinner"],
  props: {
    numArgs: 1,
    primitive: !0
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    return {
      type: "mclass",
      mode: t.mode,
      mclass: "m" + r.slice(5),
      // TODO(kevinb): don't prefix with 'm'
      body: Xe(i),
      isCharacterBox: le.isCharacterBox(i)
    };
  },
  htmlBuilder: v2,
  mathmlBuilder: y2
});
var xa = (n) => {
  var e = n.type === "ordgroup" && n.body.length ? n.body[0] : n;
  return e.type === "atom" && (e.family === "bin" || e.family === "rel") ? "m" + e.family : "mord";
};
$({
  type: "mclass",
  names: ["\\@binrel"],
  props: {
    numArgs: 2
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "mclass",
      mode: t.mode,
      mclass: xa(e[0]),
      body: Xe(e[1]),
      isCharacterBox: le.isCharacterBox(e[1])
    };
  }
});
$({
  type: "mclass",
  names: ["\\stackrel", "\\overset", "\\underset"],
  props: {
    numArgs: 2
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n, i = e[1], s = e[0], l;
    r !== "\\stackrel" ? l = xa(i) : l = "mrel";
    var o = {
      type: "op",
      mode: i.mode,
      limits: !0,
      alwaysHandleSupSub: !0,
      parentIsSupSub: !1,
      symbol: !1,
      suppressBaseShift: r !== "\\stackrel",
      body: Xe(i)
    }, a = {
      type: "supsub",
      mode: s.mode,
      base: o,
      sup: r === "\\underset" ? null : s,
      sub: r === "\\underset" ? s : null
    };
    return {
      type: "mclass",
      mode: t.mode,
      mclass: l,
      body: [a],
      isCharacterBox: le.isCharacterBox(a)
    };
  },
  htmlBuilder: v2,
  mathmlBuilder: y2
});
$({
  type: "pmb",
  names: ["\\pmb"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "pmb",
      mode: t.mode,
      mclass: xa(e[0]),
      body: Xe(e[0])
    };
  },
  htmlBuilder(n, e) {
    var t = ut(n.body, e, !0), r = O.makeSpan([n.mclass], t, e);
    return r.style.textShadow = "0.02em 0.01em 0.04px", r;
  },
  mathmlBuilder(n, e) {
    var t = Vt(n.body, e), r = new V.MathNode("mstyle", t);
    return r.setAttribute("style", "text-shadow: 0.02em 0.01em 0.04px"), r;
  }
});
var Yk = {
  ">": "\\\\cdrightarrow",
  "<": "\\\\cdleftarrow",
  "=": "\\\\cdlongequal",
  A: "\\uparrow",
  V: "\\downarrow",
  "|": "\\Vert",
  ".": "no arrow"
}, B1 = () => ({
  type: "styling",
  body: [],
  mode: "math",
  style: "display"
}), O1 = (n) => n.type === "textord" && n.text === "@", Kk = (n, e) => (n.type === "mathord" || n.type === "atom") && n.text === e;
function Xk(n, e, t) {
  var r = Yk[n];
  switch (r) {
    case "\\\\cdrightarrow":
    case "\\\\cdleftarrow":
      return t.callFunction(r, [e[0]], [e[1]]);
    case "\\uparrow":
    case "\\downarrow": {
      var i = t.callFunction("\\\\cdleft", [e[0]], []), s = {
        type: "atom",
        text: r,
        mode: "math",
        family: "rel"
      }, l = t.callFunction("\\Big", [s], []), o = t.callFunction("\\\\cdright", [e[1]], []), a = {
        type: "ordgroup",
        mode: "math",
        body: [i, l, o]
      };
      return t.callFunction("\\\\cdparent", [a], []);
    }
    case "\\\\cdlongequal":
      return t.callFunction("\\\\cdlongequal", [], []);
    case "\\Vert": {
      var u = {
        type: "textord",
        text: "\\Vert",
        mode: "math"
      };
      return t.callFunction("\\Big", [u], []);
    }
    default:
      return {
        type: "textord",
        text: " ",
        mode: "math"
      };
  }
}
function Zk(n) {
  var e = [];
  for (n.gullet.beginGroup(), n.gullet.macros.set("\\cr", "\\\\\\relax"), n.gullet.beginGroup(); ; ) {
    e.push(n.parseExpression(!1, "\\\\")), n.gullet.endGroup(), n.gullet.beginGroup();
    var t = n.fetch().text;
    if (t === "&" || t === "\\\\")
      n.consume();
    else if (t === "\\end") {
      e[e.length - 1].length === 0 && e.pop();
      break;
    } else
      throw new ie("Expected \\\\ or \\cr or \\end", n.nextToken);
  }
  for (var r = [], i = [r], s = 0; s < e.length; s++) {
    for (var l = e[s], o = B1(), a = 0; a < l.length; a++)
      if (!O1(l[a]))
        o.body.push(l[a]);
      else {
        r.push(o), a += 1;
        var u = Jh(l[a]).text, h = new Array(2);
        if (h[0] = {
          type: "ordgroup",
          mode: "math",
          body: []
        }, h[1] = {
          type: "ordgroup",
          mode: "math",
          body: []
        }, !("=|.".indexOf(u) > -1)) if ("<>AV".indexOf(u) > -1)
          for (var c = 0; c < 2; c++) {
            for (var f = !0, m = a + 1; m < l.length; m++) {
              if (Kk(l[m], u)) {
                f = !1, a = m;
                break;
              }
              if (O1(l[m]))
                throw new ie("Missing a " + u + " character to complete a CD arrow.", l[m]);
              h[c].body.push(l[m]);
            }
            if (f)
              throw new ie("Missing a " + u + " character to complete a CD arrow.", l[a]);
          }
        else
          throw new ie('Expected one of "<>AV=|." after @', l[a]);
        var g = Xk(u, h, n), v = {
          type: "styling",
          body: [g],
          mode: "math",
          style: "display"
          // CD is always displaystyle.
        };
        r.push(v), o = B1();
      }
    s % 2 === 0 ? r.push(o) : r.shift(), r = [], i.push(r);
  }
  n.gullet.endGroup(), n.gullet.endGroup();
  var k = new Array(i[0].length).fill({
    type: "align",
    align: "c",
    pregap: 0.25,
    // CD package sets \enskip between columns.
    postgap: 0.25
    // So pre and post each get half an \enskip, i.e. 0.25em.
  });
  return {
    type: "array",
    mode: "math",
    body: i,
    arraystretch: 1,
    addJot: !0,
    rowGaps: [null],
    cols: k,
    colSeparationType: "CD",
    hLinesBeforeRow: new Array(i.length + 1).fill([])
  };
}
$({
  type: "cdlabel",
  names: ["\\\\cdleft", "\\\\cdright"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n;
    return {
      type: "cdlabel",
      mode: t.mode,
      side: r.slice(4),
      label: e[0]
    };
  },
  htmlBuilder(n, e) {
    var t = e.havingStyle(e.style.sup()), r = O.wrapFragment(De(n.label, t, e), e);
    return r.classes.push("cd-label-" + n.side), r.style.bottom = G(0.8 - r.depth), r.height = 0, r.depth = 0, r;
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mrow", [Oe(n.label, e)]);
    return t = new V.MathNode("mpadded", [t]), t.setAttribute("width", "0"), n.side === "left" && t.setAttribute("lspace", "-1width"), t.setAttribute("voffset", "0.7em"), t = new V.MathNode("mstyle", [t]), t.setAttribute("displaystyle", "false"), t.setAttribute("scriptlevel", "1"), t;
  }
});
$({
  type: "cdlabelparent",
  names: ["\\\\cdparent"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "cdlabelparent",
      mode: t.mode,
      fragment: e[0]
    };
  },
  htmlBuilder(n, e) {
    var t = O.wrapFragment(De(n.fragment, e), e);
    return t.classes.push("cd-vert-arrow"), t;
  },
  mathmlBuilder(n, e) {
    return new V.MathNode("mrow", [Oe(n.fragment, e)]);
  }
});
$({
  type: "textord",
  names: ["\\@char"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler(n, e) {
    for (var {
      parser: t
    } = n, r = ge(e[0], "ordgroup"), i = r.body, s = "", l = 0; l < i.length; l++) {
      var o = ge(i[l], "textord");
      s += o.text;
    }
    var a = parseInt(s), u;
    if (isNaN(a))
      throw new ie("\\@char has non-numeric argument " + s);
    if (a < 0 || a >= 1114111)
      throw new ie("\\@char with invalid code point " + s);
    return a <= 65535 ? u = String.fromCharCode(a) : (a -= 65536, u = String.fromCharCode((a >> 10) + 55296, (a & 1023) + 56320)), {
      type: "textord",
      mode: t.mode,
      text: u
    };
  }
});
var w2 = (n, e) => {
  var t = ut(n.body, e.withColor(n.color), !1);
  return O.makeFragment(t);
}, k2 = (n, e) => {
  var t = Vt(n.body, e.withColor(n.color)), r = new V.MathNode("mstyle", t);
  return r.setAttribute("mathcolor", n.color), r;
};
$({
  type: "color",
  names: ["\\textcolor"],
  props: {
    numArgs: 2,
    allowedInText: !0,
    argTypes: ["color", "original"]
  },
  handler(n, e) {
    var {
      parser: t
    } = n, r = ge(e[0], "color-token").color, i = e[1];
    return {
      type: "color",
      mode: t.mode,
      color: r,
      body: Xe(i)
    };
  },
  htmlBuilder: w2,
  mathmlBuilder: k2
});
$({
  type: "color",
  names: ["\\color"],
  props: {
    numArgs: 1,
    allowedInText: !0,
    argTypes: ["color"]
  },
  handler(n, e) {
    var {
      parser: t,
      breakOnTokenText: r
    } = n, i = ge(e[0], "color-token").color;
    t.gullet.macros.set("\\current@color", i);
    var s = t.parseExpression(!0, r);
    return {
      type: "color",
      mode: t.mode,
      color: i,
      body: s
    };
  },
  htmlBuilder: w2,
  mathmlBuilder: k2
});
$({
  type: "cr",
  names: ["\\\\"],
  props: {
    numArgs: 0,
    numOptionalArgs: 0,
    allowedInText: !0
  },
  handler(n, e, t) {
    var {
      parser: r
    } = n, i = r.gullet.future().text === "[" ? r.parseSizeGroup(!0) : null, s = !r.settings.displayMode || !r.settings.useStrictBehavior("newLineInDisplayMode", "In LaTeX, \\\\ or \\newline does nothing in display mode");
    return {
      type: "cr",
      mode: r.mode,
      newLine: s,
      size: i && ge(i, "size").value
    };
  },
  // The following builders are called only at the top level,
  // not within tabular/array environments.
  htmlBuilder(n, e) {
    var t = O.makeSpan(["mspace"], [], e);
    return n.newLine && (t.classes.push("newline"), n.size && (t.style.marginTop = G(We(n.size, e)))), t;
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mspace");
    return n.newLine && (t.setAttribute("linebreak", "newline"), n.size && t.setAttribute("height", G(We(n.size, e)))), t;
  }
});
var Vu = {
  "\\global": "\\global",
  "\\long": "\\\\globallong",
  "\\\\globallong": "\\\\globallong",
  "\\def": "\\gdef",
  "\\gdef": "\\gdef",
  "\\edef": "\\xdef",
  "\\xdef": "\\xdef",
  "\\let": "\\\\globallet",
  "\\futurelet": "\\\\globalfuture"
}, x2 = (n) => {
  var e = n.text;
  if (/^(?:[\\{}$&#^_]|EOF)$/.test(e))
    throw new ie("Expected a control sequence", n);
  return e;
}, Jk = (n) => {
  var e = n.gullet.popToken();
  return e.text === "=" && (e = n.gullet.popToken(), e.text === " " && (e = n.gullet.popToken())), e;
}, S2 = (n, e, t, r) => {
  var i = n.gullet.macros.get(t.text);
  i == null && (t.noexpand = !0, i = {
    tokens: [t],
    numArgs: 0,
    // reproduce the same behavior in expansion
    unexpandable: !n.gullet.isExpandable(t.text)
  }), n.gullet.macros.set(e, i, r);
};
$({
  type: "internal",
  names: [
    "\\global",
    "\\long",
    "\\\\globallong"
    // can’t be entered directly
  ],
  props: {
    numArgs: 0,
    allowedInText: !0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n;
    e.consumeSpaces();
    var r = e.fetch();
    if (Vu[r.text])
      return (t === "\\global" || t === "\\\\globallong") && (r.text = Vu[r.text]), ge(e.parseFunction(), "internal");
    throw new ie("Invalid token after macro prefix", r);
  }
});
$({
  type: "internal",
  names: ["\\def", "\\gdef", "\\edef", "\\xdef"],
  props: {
    numArgs: 0,
    allowedInText: !0,
    primitive: !0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n, r = e.gullet.popToken(), i = r.text;
    if (/^(?:[\\{}$&#^_]|EOF)$/.test(i))
      throw new ie("Expected a control sequence", r);
    for (var s = 0, l, o = [[]]; e.gullet.future().text !== "{"; )
      if (r = e.gullet.popToken(), r.text === "#") {
        if (e.gullet.future().text === "{") {
          l = e.gullet.future(), o[s].push("{");
          break;
        }
        if (r = e.gullet.popToken(), !/^[1-9]$/.test(r.text))
          throw new ie('Invalid argument number "' + r.text + '"');
        if (parseInt(r.text) !== s + 1)
          throw new ie('Argument number "' + r.text + '" out of order');
        s++, o.push([]);
      } else {
        if (r.text === "EOF")
          throw new ie("Expected a macro definition");
        o[s].push(r.text);
      }
    var {
      tokens: a
    } = e.gullet.consumeArg();
    return l && a.unshift(l), (t === "\\edef" || t === "\\xdef") && (a = e.gullet.expandTokens(a), a.reverse()), e.gullet.macros.set(i, {
      tokens: a,
      numArgs: s,
      delimiters: o
    }, t === Vu[t]), {
      type: "internal",
      mode: e.mode
    };
  }
});
$({
  type: "internal",
  names: [
    "\\let",
    "\\\\globallet"
    // can’t be entered directly
  ],
  props: {
    numArgs: 0,
    allowedInText: !0,
    primitive: !0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n, r = x2(e.gullet.popToken());
    e.gullet.consumeSpaces();
    var i = Jk(e);
    return S2(e, r, i, t === "\\\\globallet"), {
      type: "internal",
      mode: e.mode
    };
  }
});
$({
  type: "internal",
  names: [
    "\\futurelet",
    "\\\\globalfuture"
    // can’t be entered directly
  ],
  props: {
    numArgs: 0,
    allowedInText: !0,
    primitive: !0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n, r = x2(e.gullet.popToken()), i = e.gullet.popToken(), s = e.gullet.popToken();
    return S2(e, r, s, t === "\\\\globalfuture"), e.gullet.pushToken(s), e.gullet.pushToken(i), {
      type: "internal",
      mode: e.mode
    };
  }
});
var Os = function(e, t, r) {
  var i = Ze.math[e] && Ze.math[e].replace, s = Yh(i || e, t, r);
  if (!s)
    throw new Error("Unsupported symbol " + e + " and font size " + t + ".");
  return s;
}, ec = function(e, t, r, i) {
  var s = r.havingBaseStyle(t), l = O.makeSpan(i.concat(s.sizingClasses(r)), [e], r), o = s.sizeMultiplier / r.sizeMultiplier;
  return l.height *= o, l.depth *= o, l.maxFontSize = s.sizeMultiplier, l;
}, A2 = function(e, t, r) {
  var i = t.havingBaseStyle(r), s = (1 - t.sizeMultiplier / i.sizeMultiplier) * t.fontMetrics().axisHeight;
  e.classes.push("delimcenter"), e.style.top = G(s), e.height -= s, e.depth += s;
}, Qk = function(e, t, r, i, s, l) {
  var o = O.makeSymbol(e, "Main-Regular", s, i), a = ec(o, t, i, l);
  return r && A2(a, i, t), a;
}, ex = function(e, t, r, i) {
  return O.makeSymbol(e, "Size" + t + "-Regular", r, i);
}, D2 = function(e, t, r, i, s, l) {
  var o = ex(e, t, s, i), a = ec(O.makeSpan(["delimsizing", "size" + t], [o], i), ue.TEXT, i, l);
  return r && A2(a, i, ue.TEXT), a;
}, A0 = function(e, t, r) {
  var i;
  t === "Size1-Regular" ? i = "delim-size1" : i = "delim-size4";
  var s = O.makeSpan(["delimsizinginner", i], [O.makeSpan([], [O.makeSymbol(e, t, r)])]);
  return {
    type: "elem",
    elem: s
  };
}, D0 = function(e, t, r) {
  var i = un["Size4-Regular"][e.charCodeAt(0)] ? un["Size4-Regular"][e.charCodeAt(0)][4] : un["Size1-Regular"][e.charCodeAt(0)][4], s = new ci("inner", ck(e, Math.round(1e3 * t))), l = new Hn([s], {
    width: G(i),
    height: G(t),
    // Override CSS rule `.katex svg { width: 100% }`
    style: "width:" + G(i),
    viewBox: "0 0 " + 1e3 * i + " " + Math.round(1e3 * t),
    preserveAspectRatio: "xMinYMin"
  }), o = O.makeSvgSpan([], [l], r);
  return o.height = t, o.style.height = G(t), o.style.width = G(i), {
    type: "elem",
    elem: o
  };
}, Wu = 8e-3, ro = {
  type: "kern",
  size: -1 * Wu
}, tx = ["|", "\\lvert", "\\rvert", "\\vert"], rx = ["\\|", "\\lVert", "\\rVert", "\\Vert"], C2 = function(e, t, r, i, s, l) {
  var o, a, u, h, c = "", f = 0;
  o = u = h = e, a = null;
  var m = "Size1-Regular";
  e === "\\uparrow" ? u = h = "⏐" : e === "\\Uparrow" ? u = h = "‖" : e === "\\downarrow" ? o = u = "⏐" : e === "\\Downarrow" ? o = u = "‖" : e === "\\updownarrow" ? (o = "\\uparrow", u = "⏐", h = "\\downarrow") : e === "\\Updownarrow" ? (o = "\\Uparrow", u = "‖", h = "\\Downarrow") : le.contains(tx, e) ? (u = "∣", c = "vert", f = 333) : le.contains(rx, e) ? (u = "∥", c = "doublevert", f = 556) : e === "[" || e === "\\lbrack" ? (o = "⎡", u = "⎢", h = "⎣", m = "Size4-Regular", c = "lbrack", f = 667) : e === "]" || e === "\\rbrack" ? (o = "⎤", u = "⎥", h = "⎦", m = "Size4-Regular", c = "rbrack", f = 667) : e === "\\lfloor" || e === "⌊" ? (u = o = "⎢", h = "⎣", m = "Size4-Regular", c = "lfloor", f = 667) : e === "\\lceil" || e === "⌈" ? (o = "⎡", u = h = "⎢", m = "Size4-Regular", c = "lceil", f = 667) : e === "\\rfloor" || e === "⌋" ? (u = o = "⎥", h = "⎦", m = "Size4-Regular", c = "rfloor", f = 667) : e === "\\rceil" || e === "⌉" ? (o = "⎤", u = h = "⎥", m = "Size4-Regular", c = "rceil", f = 667) : e === "(" || e === "\\lparen" ? (o = "⎛", u = "⎜", h = "⎝", m = "Size4-Regular", c = "lparen", f = 875) : e === ")" || e === "\\rparen" ? (o = "⎞", u = "⎟", h = "⎠", m = "Size4-Regular", c = "rparen", f = 875) : e === "\\{" || e === "\\lbrace" ? (o = "⎧", a = "⎨", h = "⎩", u = "⎪", m = "Size4-Regular") : e === "\\}" || e === "\\rbrace" ? (o = "⎫", a = "⎬", h = "⎭", u = "⎪", m = "Size4-Regular") : e === "\\lgroup" || e === "⟮" ? (o = "⎧", h = "⎩", u = "⎪", m = "Size4-Regular") : e === "\\rgroup" || e === "⟯" ? (o = "⎫", h = "⎭", u = "⎪", m = "Size4-Regular") : e === "\\lmoustache" || e === "⎰" ? (o = "⎧", h = "⎭", u = "⎪", m = "Size4-Regular") : (e === "\\rmoustache" || e === "⎱") && (o = "⎫", h = "⎩", u = "⎪", m = "Size4-Regular");
  var g = Os(o, m, s), v = g.height + g.depth, k = Os(u, m, s), S = k.height + k.depth, x = Os(h, m, s), y = x.height + x.depth, A = 0, C = 1;
  if (a !== null) {
    var T = Os(a, m, s);
    A = T.height + T.depth, C = 2;
  }
  var M = v + y + A, L = Math.max(0, Math.ceil((t - M) / (C * S))), R = M + L * C * S, N = i.fontMetrics().axisHeight;
  r && (N *= i.sizeMultiplier);
  var W = R / 2 - N, q = [];
  if (c.length > 0) {
    var he = R - v - y, Z = Math.round(R * 1e3), oe = fk(c, Math.round(he * 1e3)), ve = new ci(c, oe), _e = (f / 1e3).toFixed(3) + "em", pe = (Z / 1e3).toFixed(3) + "em", H = new Hn([ve], {
      width: _e,
      height: pe,
      viewBox: "0 0 " + f + " " + Z
    }), fe = O.makeSvgSpan([], [H], i);
    fe.height = Z / 1e3, fe.style.width = _e, fe.style.height = pe, q.push({
      type: "elem",
      elem: fe
    });
  } else {
    if (q.push(A0(h, m, s)), q.push(ro), a === null) {
      var J = R - v - y + 2 * Wu;
      q.push(D0(u, J, i));
    } else {
      var re = (R - v - y - A) / 2 + 2 * Wu;
      q.push(D0(u, re, i)), q.push(ro), q.push(A0(a, m, s)), q.push(ro), q.push(D0(u, re, i));
    }
    q.push(ro), q.push(A0(o, m, s));
  }
  var ae = i.havingBaseStyle(ue.TEXT), de = O.makeVList({
    positionType: "bottom",
    positionData: W,
    children: q
  }, ae);
  return ec(O.makeSpan(["delimsizing", "mult"], [de], ae), ue.TEXT, i, l);
}, C0 = 80, _0 = 0.08, M0 = function(e, t, r, i, s) {
  var l = hk(e, i, r), o = new ci(e, l), a = new Hn([o], {
    // Note: 1000:1 ratio of viewBox to document em width.
    width: "400em",
    height: G(t),
    viewBox: "0 0 400000 " + r,
    preserveAspectRatio: "xMinYMin slice"
  });
  return O.makeSvgSpan(["hide-tail"], [a], s);
}, nx = function(e, t) {
  var r = t.havingBaseSizing(), i = E2("\\surd", e * r.sizeMultiplier, T2, r), s = r.sizeMultiplier, l = Math.max(0, t.minRuleThickness - t.fontMetrics().sqrtRuleThickness), o, a = 0, u = 0, h = 0, c;
  return i.type === "small" ? (h = 1e3 + 1e3 * l + C0, e < 1 ? s = 1 : e < 1.4 && (s = 0.7), a = (1 + l + _0) / s, u = (1 + l) / s, o = M0("sqrtMain", a, h, l, t), o.style.minWidth = "0.853em", c = 0.833 / s) : i.type === "large" ? (h = (1e3 + C0) * Ws[i.size], u = (Ws[i.size] + l) / s, a = (Ws[i.size] + l + _0) / s, o = M0("sqrtSize" + i.size, a, h, l, t), o.style.minWidth = "1.02em", c = 1 / s) : (a = e + l + _0, u = e + l, h = Math.floor(1e3 * e + l) + C0, o = M0("sqrtTall", a, h, l, t), o.style.minWidth = "0.742em", c = 1.056), o.height = u, o.style.height = G(a), {
    span: o,
    advanceWidth: c,
    // Calculate the actual line width.
    // This actually should depend on the chosen font -- e.g. \boldmath
    // should use the thicker surd symbols from e.g. KaTeX_Main-Bold, and
    // have thicker rules.
    ruleWidth: (t.fontMetrics().sqrtRuleThickness + l) * s
  };
}, _2 = ["(", "\\lparen", ")", "\\rparen", "[", "\\lbrack", "]", "\\rbrack", "\\{", "\\lbrace", "\\}", "\\rbrace", "\\lfloor", "\\rfloor", "⌊", "⌋", "\\lceil", "\\rceil", "⌈", "⌉", "\\surd"], ix = ["\\uparrow", "\\downarrow", "\\updownarrow", "\\Uparrow", "\\Downarrow", "\\Updownarrow", "|", "\\|", "\\vert", "\\Vert", "\\lvert", "\\rvert", "\\lVert", "\\rVert", "\\lgroup", "\\rgroup", "⟮", "⟯", "\\lmoustache", "\\rmoustache", "⎰", "⎱"], M2 = ["<", ">", "\\langle", "\\rangle", "/", "\\backslash", "\\lt", "\\gt"], Ws = [0, 1.2, 1.8, 2.4, 3], sx = function(e, t, r, i, s) {
  if (e === "<" || e === "\\lt" || e === "⟨" ? e = "\\langle" : (e === ">" || e === "\\gt" || e === "⟩") && (e = "\\rangle"), le.contains(_2, e) || le.contains(M2, e))
    return D2(e, t, !1, r, i, s);
  if (le.contains(ix, e))
    return C2(e, Ws[t], !1, r, i, s);
  throw new ie("Illegal delimiter: '" + e + "'");
}, lx = [{
  type: "small",
  style: ue.SCRIPTSCRIPT
}, {
  type: "small",
  style: ue.SCRIPT
}, {
  type: "small",
  style: ue.TEXT
}, {
  type: "large",
  size: 1
}, {
  type: "large",
  size: 2
}, {
  type: "large",
  size: 3
}, {
  type: "large",
  size: 4
}], ox = [{
  type: "small",
  style: ue.SCRIPTSCRIPT
}, {
  type: "small",
  style: ue.SCRIPT
}, {
  type: "small",
  style: ue.TEXT
}, {
  type: "stack"
}], T2 = [{
  type: "small",
  style: ue.SCRIPTSCRIPT
}, {
  type: "small",
  style: ue.SCRIPT
}, {
  type: "small",
  style: ue.TEXT
}, {
  type: "large",
  size: 1
}, {
  type: "large",
  size: 2
}, {
  type: "large",
  size: 3
}, {
  type: "large",
  size: 4
}, {
  type: "stack"
}], ax = function(e) {
  if (e.type === "small")
    return "Main-Regular";
  if (e.type === "large")
    return "Size" + e.size + "-Regular";
  if (e.type === "stack")
    return "Size4-Regular";
  throw new Error("Add support for delim type '" + e.type + "' here.");
}, E2 = function(e, t, r, i) {
  for (var s = Math.min(2, 3 - i.style.size), l = s; l < r.length && r[l].type !== "stack"; l++) {
    var o = Os(e, ax(r[l]), "math"), a = o.height + o.depth;
    if (r[l].type === "small") {
      var u = i.havingBaseStyle(r[l].style);
      a *= u.sizeMultiplier;
    }
    if (a > t)
      return r[l];
  }
  return r[r.length - 1];
}, F2 = function(e, t, r, i, s, l) {
  e === "<" || e === "\\lt" || e === "⟨" ? e = "\\langle" : (e === ">" || e === "\\gt" || e === "⟩") && (e = "\\rangle");
  var o;
  le.contains(M2, e) ? o = lx : le.contains(_2, e) ? o = T2 : o = ox;
  var a = E2(e, t, o, i);
  return a.type === "small" ? Qk(e, a.style, r, i, s, l) : a.type === "large" ? D2(e, a.size, r, i, s, l) : C2(e, t, r, i, s, l);
}, ux = function(e, t, r, i, s, l) {
  var o = i.fontMetrics().axisHeight * i.sizeMultiplier, a = 901, u = 5 / i.fontMetrics().ptPerEm, h = Math.max(t - o, r + o), c = Math.max(
    // In real TeX, calculations are done using integral values which are
    // 65536 per pt, or 655360 per em. So, the division here truncates in
    // TeX but doesn't here, producing different results. If we wanted to
    // exactly match TeX's calculation, we could do
    //   Math.floor(655360 * maxDistFromAxis / 500) *
    //    delimiterFactor / 655360
    // (To see the difference, compare
    //    x^{x^{\left(\rule{0.1em}{0.68em}\right)}}
    // in TeX and KaTeX)
    h / 500 * a,
    2 * h - u
  );
  return F2(e, c, !0, i, s, l);
}, pn = {
  sqrtImage: nx,
  sizedDelim: sx,
  sizeToMaxHeight: Ws,
  customSizedDelim: F2,
  leftRightDelim: ux
}, R1 = {
  "\\bigl": {
    mclass: "mopen",
    size: 1
  },
  "\\Bigl": {
    mclass: "mopen",
    size: 2
  },
  "\\biggl": {
    mclass: "mopen",
    size: 3
  },
  "\\Biggl": {
    mclass: "mopen",
    size: 4
  },
  "\\bigr": {
    mclass: "mclose",
    size: 1
  },
  "\\Bigr": {
    mclass: "mclose",
    size: 2
  },
  "\\biggr": {
    mclass: "mclose",
    size: 3
  },
  "\\Biggr": {
    mclass: "mclose",
    size: 4
  },
  "\\bigm": {
    mclass: "mrel",
    size: 1
  },
  "\\Bigm": {
    mclass: "mrel",
    size: 2
  },
  "\\biggm": {
    mclass: "mrel",
    size: 3
  },
  "\\Biggm": {
    mclass: "mrel",
    size: 4
  },
  "\\big": {
    mclass: "mord",
    size: 1
  },
  "\\Big": {
    mclass: "mord",
    size: 2
  },
  "\\bigg": {
    mclass: "mord",
    size: 3
  },
  "\\Bigg": {
    mclass: "mord",
    size: 4
  }
}, hx = ["(", "\\lparen", ")", "\\rparen", "[", "\\lbrack", "]", "\\rbrack", "\\{", "\\lbrace", "\\}", "\\rbrace", "\\lfloor", "\\rfloor", "⌊", "⌋", "\\lceil", "\\rceil", "⌈", "⌉", "<", ">", "\\langle", "⟨", "\\rangle", "⟩", "\\lt", "\\gt", "\\lvert", "\\rvert", "\\lVert", "\\rVert", "\\lgroup", "\\rgroup", "⟮", "⟯", "\\lmoustache", "\\rmoustache", "⎰", "⎱", "/", "\\backslash", "|", "\\vert", "\\|", "\\Vert", "\\uparrow", "\\Uparrow", "\\downarrow", "\\Downarrow", "\\updownarrow", "\\Updownarrow", "."];
function Sa(n, e) {
  var t = ka(n);
  if (t && le.contains(hx, t.text))
    return t;
  throw t ? new ie("Invalid delimiter '" + t.text + "' after '" + e.funcName + "'", n) : new ie("Invalid delimiter type '" + n.type + "'", n);
}
$({
  type: "delimsizing",
  names: ["\\bigl", "\\Bigl", "\\biggl", "\\Biggl", "\\bigr", "\\Bigr", "\\biggr", "\\Biggr", "\\bigm", "\\Bigm", "\\biggm", "\\Biggm", "\\big", "\\Big", "\\bigg", "\\Bigg"],
  props: {
    numArgs: 1,
    argTypes: ["primitive"]
  },
  handler: (n, e) => {
    var t = Sa(e[0], n);
    return {
      type: "delimsizing",
      mode: n.parser.mode,
      size: R1[n.funcName].size,
      mclass: R1[n.funcName].mclass,
      delim: t.text
    };
  },
  htmlBuilder: (n, e) => n.delim === "." ? O.makeSpan([n.mclass]) : pn.sizedDelim(n.delim, n.size, e, n.mode, [n.mclass]),
  mathmlBuilder: (n) => {
    var e = [];
    n.delim !== "." && e.push(sr(n.delim, n.mode));
    var t = new V.MathNode("mo", e);
    n.mclass === "mopen" || n.mclass === "mclose" ? t.setAttribute("fence", "true") : t.setAttribute("fence", "false"), t.setAttribute("stretchy", "true");
    var r = G(pn.sizeToMaxHeight[n.size]);
    return t.setAttribute("minsize", r), t.setAttribute("maxsize", r), t;
  }
});
function L1(n) {
  if (!n.body)
    throw new Error("Bug: The leftright ParseNode wasn't fully parsed.");
}
$({
  type: "leftright-right",
  names: ["\\right"],
  props: {
    numArgs: 1,
    primitive: !0
  },
  handler: (n, e) => {
    var t = n.parser.gullet.macros.get("\\current@color");
    if (t && typeof t != "string")
      throw new ie("\\current@color set to non-string in \\right");
    return {
      type: "leftright-right",
      mode: n.parser.mode,
      delim: Sa(e[0], n).text,
      color: t
      // undefined if not set via \color
    };
  }
});
$({
  type: "leftright",
  names: ["\\left"],
  props: {
    numArgs: 1,
    primitive: !0
  },
  handler: (n, e) => {
    var t = Sa(e[0], n), r = n.parser;
    ++r.leftrightDepth;
    var i = r.parseExpression(!1);
    --r.leftrightDepth, r.expect("\\right", !1);
    var s = ge(r.parseFunction(), "leftright-right");
    return {
      type: "leftright",
      mode: r.mode,
      body: i,
      left: t.text,
      right: s.delim,
      rightColor: s.color
    };
  },
  htmlBuilder: (n, e) => {
    L1(n);
    for (var t = ut(n.body, e, !0, ["mopen", "mclose"]), r = 0, i = 0, s = !1, l = 0; l < t.length; l++)
      t[l].isMiddle ? s = !0 : (r = Math.max(t[l].height, r), i = Math.max(t[l].depth, i));
    r *= e.sizeMultiplier, i *= e.sizeMultiplier;
    var o;
    if (n.left === "." ? o = ol(e, ["mopen"]) : o = pn.leftRightDelim(n.left, r, i, e, n.mode, ["mopen"]), t.unshift(o), s)
      for (var a = 1; a < t.length; a++) {
        var u = t[a], h = u.isMiddle;
        h && (t[a] = pn.leftRightDelim(h.delim, r, i, h.options, n.mode, []));
      }
    var c;
    if (n.right === ".")
      c = ol(e, ["mclose"]);
    else {
      var f = n.rightColor ? e.withColor(n.rightColor) : e;
      c = pn.leftRightDelim(n.right, r, i, f, n.mode, ["mclose"]);
    }
    return t.push(c), O.makeSpan(["minner"], t, e);
  },
  mathmlBuilder: (n, e) => {
    L1(n);
    var t = Vt(n.body, e);
    if (n.left !== ".") {
      var r = new V.MathNode("mo", [sr(n.left, n.mode)]);
      r.setAttribute("fence", "true"), t.unshift(r);
    }
    if (n.right !== ".") {
      var i = new V.MathNode("mo", [sr(n.right, n.mode)]);
      i.setAttribute("fence", "true"), n.rightColor && i.setAttribute("mathcolor", n.rightColor), t.push(i);
    }
    return Xh(t);
  }
});
$({
  type: "middle",
  names: ["\\middle"],
  props: {
    numArgs: 1,
    primitive: !0
  },
  handler: (n, e) => {
    var t = Sa(e[0], n);
    if (!n.parser.leftrightDepth)
      throw new ie("\\middle without preceding \\left", t);
    return {
      type: "middle",
      mode: n.parser.mode,
      delim: t.text
    };
  },
  htmlBuilder: (n, e) => {
    var t;
    if (n.delim === ".")
      t = ol(e, []);
    else {
      t = pn.sizedDelim(n.delim, 1, e, n.mode, []);
      var r = {
        delim: n.delim,
        options: e
      };
      t.isMiddle = r;
    }
    return t;
  },
  mathmlBuilder: (n, e) => {
    var t = n.delim === "\\vert" || n.delim === "|" ? sr("|", "text") : sr(n.delim, n.mode), r = new V.MathNode("mo", [t]);
    return r.setAttribute("fence", "true"), r.setAttribute("lspace", "0.05em"), r.setAttribute("rspace", "0.05em"), r;
  }
});
var tc = (n, e) => {
  var t = O.wrapFragment(De(n.body, e), e), r = n.label.slice(1), i = e.sizeMultiplier, s, l = 0, o = le.isCharacterBox(n.body);
  if (r === "sout")
    s = O.makeSpan(["stretchy", "sout"]), s.height = e.fontMetrics().defaultRuleThickness / i, l = -0.5 * e.fontMetrics().xHeight;
  else if (r === "phase") {
    var a = We({
      number: 0.6,
      unit: "pt"
    }, e), u = We({
      number: 0.35,
      unit: "ex"
    }, e), h = e.havingBaseSizing();
    i = i / h.sizeMultiplier;
    var c = t.height + t.depth + a + u;
    t.style.paddingLeft = G(c / 2 + a);
    var f = Math.floor(1e3 * c * i), m = ak(f), g = new Hn([new ci("phase", m)], {
      width: "400em",
      height: G(f / 1e3),
      viewBox: "0 0 400000 " + f,
      preserveAspectRatio: "xMinYMin slice"
    });
    s = O.makeSvgSpan(["hide-tail"], [g], e), s.style.height = G(c), l = t.depth + a + u;
  } else {
    /cancel/.test(r) ? o || t.classes.push("cancel-pad") : r === "angl" ? t.classes.push("anglpad") : t.classes.push("boxpad");
    var v = 0, k = 0, S = 0;
    /box/.test(r) ? (S = Math.max(
      e.fontMetrics().fboxrule,
      // default
      e.minRuleThickness
      // User override.
    ), v = e.fontMetrics().fboxsep + (r === "colorbox" ? 0 : S), k = v) : r === "angl" ? (S = Math.max(e.fontMetrics().defaultRuleThickness, e.minRuleThickness), v = 4 * S, k = Math.max(0, 0.25 - t.depth)) : (v = o ? 0.2 : 0, k = v), s = bn.encloseSpan(t, r, v, k, e), /fbox|boxed|fcolorbox/.test(r) ? (s.style.borderStyle = "solid", s.style.borderWidth = G(S)) : r === "angl" && S !== 0.049 && (s.style.borderTopWidth = G(S), s.style.borderRightWidth = G(S)), l = t.depth + k, n.backgroundColor && (s.style.backgroundColor = n.backgroundColor, n.borderColor && (s.style.borderColor = n.borderColor));
  }
  var x;
  if (n.backgroundColor)
    x = O.makeVList({
      positionType: "individualShift",
      children: [
        // Put the color background behind inner;
        {
          type: "elem",
          elem: s,
          shift: l
        },
        {
          type: "elem",
          elem: t,
          shift: 0
        }
      ]
    }, e);
  else {
    var y = /cancel|phase/.test(r) ? ["svg-align"] : [];
    x = O.makeVList({
      positionType: "individualShift",
      children: [
        // Write the \cancel stroke on top of inner.
        {
          type: "elem",
          elem: t,
          shift: 0
        },
        {
          type: "elem",
          elem: s,
          shift: l,
          wrapperClasses: y
        }
      ]
    }, e);
  }
  return /cancel/.test(r) && (x.height = t.height, x.depth = t.depth), /cancel/.test(r) && !o ? O.makeSpan(["mord", "cancel-lap"], [x], e) : O.makeSpan(["mord"], [x], e);
}, rc = (n, e) => {
  var t = 0, r = new V.MathNode(n.label.indexOf("colorbox") > -1 ? "mpadded" : "menclose", [Oe(n.body, e)]);
  switch (n.label) {
    case "\\cancel":
      r.setAttribute("notation", "updiagonalstrike");
      break;
    case "\\bcancel":
      r.setAttribute("notation", "downdiagonalstrike");
      break;
    case "\\phase":
      r.setAttribute("notation", "phasorangle");
      break;
    case "\\sout":
      r.setAttribute("notation", "horizontalstrike");
      break;
    case "\\fbox":
      r.setAttribute("notation", "box");
      break;
    case "\\angl":
      r.setAttribute("notation", "actuarial");
      break;
    case "\\fcolorbox":
    case "\\colorbox":
      if (t = e.fontMetrics().fboxsep * e.fontMetrics().ptPerEm, r.setAttribute("width", "+" + 2 * t + "pt"), r.setAttribute("height", "+" + 2 * t + "pt"), r.setAttribute("lspace", t + "pt"), r.setAttribute("voffset", t + "pt"), n.label === "\\fcolorbox") {
        var i = Math.max(
          e.fontMetrics().fboxrule,
          // default
          e.minRuleThickness
          // user override
        );
        r.setAttribute("style", "border: " + i + "em solid " + String(n.borderColor));
      }
      break;
    case "\\xcancel":
      r.setAttribute("notation", "updiagonalstrike downdiagonalstrike");
      break;
  }
  return n.backgroundColor && r.setAttribute("mathbackground", n.backgroundColor), r;
};
$({
  type: "enclose",
  names: ["\\colorbox"],
  props: {
    numArgs: 2,
    allowedInText: !0,
    argTypes: ["color", "text"]
  },
  handler(n, e, t) {
    var {
      parser: r,
      funcName: i
    } = n, s = ge(e[0], "color-token").color, l = e[1];
    return {
      type: "enclose",
      mode: r.mode,
      label: i,
      backgroundColor: s,
      body: l
    };
  },
  htmlBuilder: tc,
  mathmlBuilder: rc
});
$({
  type: "enclose",
  names: ["\\fcolorbox"],
  props: {
    numArgs: 3,
    allowedInText: !0,
    argTypes: ["color", "color", "text"]
  },
  handler(n, e, t) {
    var {
      parser: r,
      funcName: i
    } = n, s = ge(e[0], "color-token").color, l = ge(e[1], "color-token").color, o = e[2];
    return {
      type: "enclose",
      mode: r.mode,
      label: i,
      backgroundColor: l,
      borderColor: s,
      body: o
    };
  },
  htmlBuilder: tc,
  mathmlBuilder: rc
});
$({
  type: "enclose",
  names: ["\\fbox"],
  props: {
    numArgs: 1,
    argTypes: ["hbox"],
    allowedInText: !0
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "enclose",
      mode: t.mode,
      label: "\\fbox",
      body: e[0]
    };
  }
});
$({
  type: "enclose",
  names: ["\\cancel", "\\bcancel", "\\xcancel", "\\sout", "\\phase"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    return {
      type: "enclose",
      mode: t.mode,
      label: r,
      body: i
    };
  },
  htmlBuilder: tc,
  mathmlBuilder: rc
});
$({
  type: "enclose",
  names: ["\\angl"],
  props: {
    numArgs: 1,
    argTypes: ["hbox"],
    allowedInText: !1
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "enclose",
      mode: t.mode,
      label: "\\angl",
      body: e[0]
    };
  }
});
var B2 = {};
function Jr(n) {
  for (var {
    type: e,
    names: t,
    props: r,
    handler: i,
    htmlBuilder: s,
    mathmlBuilder: l
  } = n, o = {
    type: e,
    numArgs: r.numArgs || 0,
    allowedInText: !1,
    numOptionalArgs: 0,
    handler: i
  }, a = 0; a < t.length; ++a)
    B2[t[a]] = o;
  s && (Zo[e] = s), l && (Jo[e] = l);
}
var cx = {};
function w(n, e) {
  cx[n] = e;
}
function N1(n) {
  var e = [];
  n.consumeSpaces();
  var t = n.fetch().text;
  for (t === "\\relax" && (n.consume(), n.consumeSpaces(), t = n.fetch().text); t === "\\hline" || t === "\\hdashline"; )
    n.consume(), e.push(t === "\\hdashline"), n.consumeSpaces(), t = n.fetch().text;
  return e;
}
var Aa = (n) => {
  var e = n.parser.settings;
  if (!e.displayMode)
    throw new ie("{" + n.envName + "} can be used only in display mode.");
};
function nc(n) {
  if (n.indexOf("ed") === -1)
    return n.indexOf("*") === -1;
}
function Wn(n, e, t) {
  var {
    hskipBeforeAndAfter: r,
    addJot: i,
    cols: s,
    arraystretch: l,
    colSeparationType: o,
    autoTag: a,
    singleRow: u,
    emptySingleRow: h,
    maxNumCols: c,
    leqno: f
  } = e;
  if (n.gullet.beginGroup(), u || n.gullet.macros.set("\\cr", "\\\\\\relax"), !l) {
    var m = n.gullet.expandMacroAsText("\\arraystretch");
    if (m == null)
      l = 1;
    else if (l = parseFloat(m), !l || l < 0)
      throw new ie("Invalid \\arraystretch: " + m);
  }
  n.gullet.beginGroup();
  var g = [], v = [g], k = [], S = [], x = a != null ? [] : void 0;
  function y() {
    a && n.gullet.macros.set("\\@eqnsw", "1", !0);
  }
  function A() {
    x && (n.gullet.macros.get("\\df@tag") ? (x.push(n.subparse([new jh("\\df@tag")])), n.gullet.macros.set("\\df@tag", void 0, !0)) : x.push(!!a && n.gullet.macros.get("\\@eqnsw") === "1"));
  }
  for (y(), S.push(N1(n)); ; ) {
    var C = n.parseExpression(!1, u ? "\\end" : "\\\\");
    n.gullet.endGroup(), n.gullet.beginGroup(), C = {
      type: "ordgroup",
      mode: n.mode,
      body: C
    }, t && (C = {
      type: "styling",
      mode: n.mode,
      style: t,
      body: [C]
    }), g.push(C);
    var T = n.fetch().text;
    if (T === "&") {
      if (c && g.length === c) {
        if (u || o)
          throw new ie("Too many tab characters: &", n.nextToken);
        n.settings.reportNonstrict("textEnv", "Too few columns specified in the {array} column argument.");
      }
      n.consume();
    } else if (T === "\\end") {
      A(), g.length === 1 && C.type === "styling" && C.body[0].body.length === 0 && (v.length > 1 || !h) && v.pop(), S.length < v.length + 1 && S.push([]);
      break;
    } else if (T === "\\\\") {
      n.consume();
      var M = void 0;
      n.gullet.future().text !== " " && (M = n.parseSizeGroup(!0)), k.push(M ? M.value : null), A(), S.push(N1(n)), g = [], v.push(g), y();
    } else
      throw new ie("Expected & or \\\\ or \\cr or \\end", n.nextToken);
  }
  return n.gullet.endGroup(), n.gullet.endGroup(), {
    type: "array",
    mode: n.mode,
    addJot: i,
    arraystretch: l,
    body: v,
    cols: s,
    rowGaps: k,
    hskipBeforeAndAfter: r,
    hLinesBeforeRow: S,
    colSeparationType: o,
    tags: x,
    leqno: f
  };
}
function ic(n) {
  return n.slice(0, 1) === "d" ? "display" : "text";
}
var Qr = function(e, t) {
  var r, i, s = e.body.length, l = e.hLinesBeforeRow, o = 0, a = new Array(s), u = [], h = Math.max(
    // From LaTeX \showthe\arrayrulewidth. Equals 0.04 em.
    t.fontMetrics().arrayRuleWidth,
    t.minRuleThickness
    // User override.
  ), c = 1 / t.fontMetrics().ptPerEm, f = 5 * c;
  if (e.colSeparationType && e.colSeparationType === "small") {
    var m = t.havingStyle(ue.SCRIPT).sizeMultiplier;
    f = 0.2778 * (m / t.sizeMultiplier);
  }
  var g = e.colSeparationType === "CD" ? We({
    number: 3,
    unit: "ex"
  }, t) : 12 * c, v = 3 * c, k = e.arraystretch * g, S = 0.7 * k, x = 0.3 * k, y = 0;
  function A(tn) {
    for (var rn = 0; rn < tn.length; ++rn)
      rn > 0 && (y += 0.25), u.push({
        pos: y,
        isDashed: tn[rn]
      });
  }
  for (A(l[0]), r = 0; r < e.body.length; ++r) {
    var C = e.body[r], T = S, M = x;
    o < C.length && (o = C.length);
    var L = new Array(C.length);
    for (i = 0; i < C.length; ++i) {
      var R = De(C[i], t);
      M < R.depth && (M = R.depth), T < R.height && (T = R.height), L[i] = R;
    }
    var N = e.rowGaps[r], W = 0;
    N && (W = We(N, t), W > 0 && (W += x, M < W && (M = W), W = 0)), e.addJot && (M += v), L.height = T, L.depth = M, y += T, L.pos = y, y += M + W, a[r] = L, A(l[r + 1]);
  }
  var q = y / 2 + t.fontMetrics().axisHeight, he = e.cols || [], Z = [], oe, ve, _e = [];
  if (e.tags && e.tags.some((tn) => tn))
    for (r = 0; r < s; ++r) {
      var pe = a[r], H = pe.pos - q, fe = e.tags[r], J = void 0;
      fe === !0 ? J = O.makeSpan(["eqn-num"], [], t) : fe === !1 ? J = O.makeSpan([], [], t) : J = O.makeSpan([], ut(fe, t, !0), t), J.depth = pe.depth, J.height = pe.height, _e.push({
        type: "elem",
        elem: J,
        shift: H
      });
    }
  for (
    i = 0, ve = 0;
    // Continue while either there are more columns or more column
    // descriptions, so trailing separators don't get lost.
    i < o || ve < he.length;
    ++i, ++ve
  ) {
    for (var re = he[ve] || {}, ae = !0; re.type === "separator"; ) {
      if (ae || (oe = O.makeSpan(["arraycolsep"], []), oe.style.width = G(t.fontMetrics().doubleRuleSep), Z.push(oe)), re.separator === "|" || re.separator === ":") {
        var de = re.separator === "|" ? "solid" : "dashed", P = O.makeSpan(["vertical-separator"], [], t);
        P.style.height = G(y), P.style.borderRightWidth = G(h), P.style.borderRightStyle = de, P.style.margin = "0 " + G(-h / 2);
        var ze = y - q;
        ze && (P.style.verticalAlign = G(-ze)), Z.push(P);
      } else
        throw new ie("Invalid separator type: " + re.separator);
      ve++, re = he[ve] || {}, ae = !1;
    }
    if (!(i >= o)) {
      var Me = void 0;
      (i > 0 || e.hskipBeforeAndAfter) && (Me = le.deflt(re.pregap, f), Me !== 0 && (oe = O.makeSpan(["arraycolsep"], []), oe.style.width = G(Me), Z.push(oe)));
      var Pe = [];
      for (r = 0; r < s; ++r) {
        var je = a[r], Ye = je[i];
        if (Ye) {
          var Mt = je.pos - q;
          Ye.depth = je.depth, Ye.height = je.height, Pe.push({
            type: "elem",
            elem: Ye,
            shift: Mt
          });
        }
      }
      Pe = O.makeVList({
        positionType: "individualShift",
        children: Pe
      }, t), Pe = O.makeSpan(["col-align-" + (re.align || "c")], [Pe]), Z.push(Pe), (i < o - 1 || e.hskipBeforeAndAfter) && (Me = le.deflt(re.postgap, f), Me !== 0 && (oe = O.makeSpan(["arraycolsep"], []), oe.style.width = G(Me), Z.push(oe)));
    }
  }
  if (a = O.makeSpan(["mtable"], Z), u.length > 0) {
    for (var Wt = O.makeLineSpan("hline", t, h), hr = O.makeLineSpan("hdashline", t, h), bt = [{
      type: "elem",
      elem: a,
      shift: 0
    }]; u.length > 0; ) {
      var Tt = u.pop(), Dr = Tt.pos - q;
      Tt.isDashed ? bt.push({
        type: "elem",
        elem: hr,
        shift: Dr
      }) : bt.push({
        type: "elem",
        elem: Wt,
        shift: Dr
      });
    }
    a = O.makeVList({
      positionType: "individualShift",
      children: bt
    }, t);
  }
  if (_e.length === 0)
    return O.makeSpan(["mord"], [a], t);
  var Cr = O.makeVList({
    positionType: "individualShift",
    children: _e
  }, t);
  return Cr = O.makeSpan(["tag"], [Cr], t), O.makeFragment([a, Cr]);
}, fx = {
  c: "center ",
  l: "left ",
  r: "right "
}, en = function(e, t) {
  for (var r = [], i = new V.MathNode("mtd", [], ["mtr-glue"]), s = new V.MathNode("mtd", [], ["mml-eqn-num"]), l = 0; l < e.body.length; l++) {
    for (var o = e.body[l], a = [], u = 0; u < o.length; u++)
      a.push(new V.MathNode("mtd", [Oe(o[u], t)]));
    e.tags && e.tags[l] && (a.unshift(i), a.push(i), e.leqno ? a.unshift(s) : a.push(s)), r.push(new V.MathNode("mtr", a));
  }
  var h = new V.MathNode("mtable", r), c = e.arraystretch === 0.5 ? 0.1 : 0.16 + e.arraystretch - 1 + (e.addJot ? 0.09 : 0);
  h.setAttribute("rowspacing", G(c));
  var f = "", m = "";
  if (e.cols && e.cols.length > 0) {
    var g = e.cols, v = "", k = !1, S = 0, x = g.length;
    g[0].type === "separator" && (f += "top ", S = 1), g[g.length - 1].type === "separator" && (f += "bottom ", x -= 1);
    for (var y = S; y < x; y++)
      g[y].type === "align" ? (m += fx[g[y].align], k && (v += "none "), k = !0) : g[y].type === "separator" && k && (v += g[y].separator === "|" ? "solid " : "dashed ", k = !1);
    h.setAttribute("columnalign", m.trim()), /[sd]/.test(v) && h.setAttribute("columnlines", v.trim());
  }
  if (e.colSeparationType === "align") {
    for (var A = e.cols || [], C = "", T = 1; T < A.length; T++)
      C += T % 2 ? "0em " : "1em ";
    h.setAttribute("columnspacing", C.trim());
  } else e.colSeparationType === "alignat" || e.colSeparationType === "gather" ? h.setAttribute("columnspacing", "0em") : e.colSeparationType === "small" ? h.setAttribute("columnspacing", "0.2778em") : e.colSeparationType === "CD" ? h.setAttribute("columnspacing", "0.5em") : h.setAttribute("columnspacing", "1em");
  var M = "", L = e.hLinesBeforeRow;
  f += L[0].length > 0 ? "left " : "", f += L[L.length - 1].length > 0 ? "right " : "";
  for (var R = 1; R < L.length - 1; R++)
    M += L[R].length === 0 ? "none " : L[R][0] ? "dashed " : "solid ";
  return /[sd]/.test(M) && h.setAttribute("rowlines", M.trim()), f !== "" && (h = new V.MathNode("menclose", [h]), h.setAttribute("notation", f.trim())), e.arraystretch && e.arraystretch < 1 && (h = new V.MathNode("mstyle", [h]), h.setAttribute("scriptlevel", "1")), h;
}, O2 = function(e, t) {
  e.envName.indexOf("ed") === -1 && Aa(e);
  var r = [], i = e.envName.indexOf("at") > -1 ? "alignat" : "align", s = e.envName === "split", l = Wn(e.parser, {
    cols: r,
    addJot: !0,
    autoTag: s ? void 0 : nc(e.envName),
    emptySingleRow: !0,
    colSeparationType: i,
    maxNumCols: s ? 2 : void 0,
    leqno: e.parser.settings.leqno
  }, "display"), o, a = 0, u = {
    type: "ordgroup",
    mode: e.mode,
    body: []
  };
  if (t[0] && t[0].type === "ordgroup") {
    for (var h = "", c = 0; c < t[0].body.length; c++) {
      var f = ge(t[0].body[c], "textord");
      h += f.text;
    }
    o = Number(h), a = o * 2;
  }
  var m = !a;
  l.body.forEach(function(S) {
    for (var x = 1; x < S.length; x += 2) {
      var y = ge(S[x], "styling"), A = ge(y.body[0], "ordgroup");
      A.body.unshift(u);
    }
    if (m)
      a < S.length && (a = S.length);
    else {
      var C = S.length / 2;
      if (o < C)
        throw new ie("Too many math in a row: " + ("expected " + o + ", but got " + C), S[0]);
    }
  });
  for (var g = 0; g < a; ++g) {
    var v = "r", k = 0;
    g % 2 === 1 ? v = "l" : g > 0 && m && (k = 1), r[g] = {
      type: "align",
      align: v,
      pregap: k,
      postgap: 0
    };
  }
  return l.colSeparationType = m ? "align" : "alignat", l;
};
Jr({
  type: "array",
  names: ["array", "darray"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var t = ka(e[0]), r = t ? [e[0]] : ge(e[0], "ordgroup").body, i = r.map(function(l) {
      var o = Jh(l), a = o.text;
      if ("lcr".indexOf(a) !== -1)
        return {
          type: "align",
          align: a
        };
      if (a === "|")
        return {
          type: "separator",
          separator: "|"
        };
      if (a === ":")
        return {
          type: "separator",
          separator: ":"
        };
      throw new ie("Unknown column alignment: " + a, l);
    }), s = {
      cols: i,
      hskipBeforeAndAfter: !0,
      // \@preamble in lttab.dtx
      maxNumCols: i.length
    };
    return Wn(n.parser, s, ic(n.envName));
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["matrix", "pmatrix", "bmatrix", "Bmatrix", "vmatrix", "Vmatrix", "matrix*", "pmatrix*", "bmatrix*", "Bmatrix*", "vmatrix*", "Vmatrix*"],
  props: {
    numArgs: 0
  },
  handler(n) {
    var e = {
      matrix: null,
      pmatrix: ["(", ")"],
      bmatrix: ["[", "]"],
      Bmatrix: ["\\{", "\\}"],
      vmatrix: ["|", "|"],
      Vmatrix: ["\\Vert", "\\Vert"]
    }[n.envName.replace("*", "")], t = "c", r = {
      hskipBeforeAndAfter: !1,
      cols: [{
        type: "align",
        align: t
      }]
    };
    if (n.envName.charAt(n.envName.length - 1) === "*") {
      var i = n.parser;
      if (i.consumeSpaces(), i.fetch().text === "[") {
        if (i.consume(), i.consumeSpaces(), t = i.fetch().text, "lcr".indexOf(t) === -1)
          throw new ie("Expected l or c or r", i.nextToken);
        i.consume(), i.consumeSpaces(), i.expect("]"), i.consume(), r.cols = [{
          type: "align",
          align: t
        }];
      }
    }
    var s = Wn(n.parser, r, ic(n.envName)), l = Math.max(0, ...s.body.map((o) => o.length));
    return s.cols = new Array(l).fill({
      type: "align",
      align: t
    }), e ? {
      type: "leftright",
      mode: n.mode,
      body: [s],
      left: e[0],
      right: e[1],
      rightColor: void 0
      // \right uninfluenced by \color in array
    } : s;
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["smallmatrix"],
  props: {
    numArgs: 0
  },
  handler(n) {
    var e = {
      arraystretch: 0.5
    }, t = Wn(n.parser, e, "script");
    return t.colSeparationType = "small", t;
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["subarray"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var t = ka(e[0]), r = t ? [e[0]] : ge(e[0], "ordgroup").body, i = r.map(function(l) {
      var o = Jh(l), a = o.text;
      if ("lc".indexOf(a) !== -1)
        return {
          type: "align",
          align: a
        };
      throw new ie("Unknown column alignment: " + a, l);
    });
    if (i.length > 1)
      throw new ie("{subarray} can contain only one column");
    var s = {
      cols: i,
      hskipBeforeAndAfter: !1,
      arraystretch: 0.5
    };
    if (s = Wn(n.parser, s, "script"), s.body.length > 0 && s.body[0].length > 1)
      throw new ie("{subarray} can contain only one column");
    return s;
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["cases", "dcases", "rcases", "drcases"],
  props: {
    numArgs: 0
  },
  handler(n) {
    var e = {
      arraystretch: 1.2,
      cols: [{
        type: "align",
        align: "l",
        pregap: 0,
        // TODO(kevinb) get the current style.
        // For now we use the metrics for TEXT style which is what we were
        // doing before.  Before attempting to get the current style we
        // should look at TeX's behavior especially for \over and matrices.
        postgap: 1
        /* 1em quad */
      }, {
        type: "align",
        align: "l",
        pregap: 0,
        postgap: 0
      }]
    }, t = Wn(n.parser, e, ic(n.envName));
    return {
      type: "leftright",
      mode: n.mode,
      body: [t],
      left: n.envName.indexOf("r") > -1 ? "." : "\\{",
      right: n.envName.indexOf("r") > -1 ? "\\}" : ".",
      rightColor: void 0
    };
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["align", "align*", "aligned", "split"],
  props: {
    numArgs: 0
  },
  handler: O2,
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["gathered", "gather", "gather*"],
  props: {
    numArgs: 0
  },
  handler(n) {
    le.contains(["gather", "gather*"], n.envName) && Aa(n);
    var e = {
      cols: [{
        type: "align",
        align: "c"
      }],
      addJot: !0,
      colSeparationType: "gather",
      autoTag: nc(n.envName),
      emptySingleRow: !0,
      leqno: n.parser.settings.leqno
    };
    return Wn(n.parser, e, "display");
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["alignat", "alignat*", "alignedat"],
  props: {
    numArgs: 1
  },
  handler: O2,
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["equation", "equation*"],
  props: {
    numArgs: 0
  },
  handler(n) {
    Aa(n);
    var e = {
      autoTag: nc(n.envName),
      emptySingleRow: !0,
      singleRow: !0,
      maxNumCols: 1,
      leqno: n.parser.settings.leqno
    };
    return Wn(n.parser, e, "display");
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
Jr({
  type: "array",
  names: ["CD"],
  props: {
    numArgs: 0
  },
  handler(n) {
    return Aa(n), Zk(n.parser);
  },
  htmlBuilder: Qr,
  mathmlBuilder: en
});
w("\\nonumber", "\\gdef\\@eqnsw{0}");
w("\\notag", "\\nonumber");
$({
  type: "text",
  // Doesn't matter what this is.
  names: ["\\hline", "\\hdashline"],
  props: {
    numArgs: 0,
    allowedInText: !0,
    allowedInMath: !0
  },
  handler(n, e) {
    throw new ie(n.funcName + " valid only within array environment");
  }
});
var I1 = B2;
$({
  type: "environment",
  names: ["\\begin", "\\end"],
  props: {
    numArgs: 1,
    argTypes: ["text"]
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    if (i.type !== "ordgroup")
      throw new ie("Invalid environment name", i);
    for (var s = "", l = 0; l < i.body.length; ++l)
      s += ge(i.body[l], "textord").text;
    if (r === "\\begin") {
      if (!I1.hasOwnProperty(s))
        throw new ie("No such environment: " + s, i);
      var o = I1[s], {
        args: a,
        optArgs: u
      } = t.parseArguments("\\begin{" + s + "}", o), h = {
        mode: t.mode,
        envName: s,
        parser: t
      }, c = o.handler(h, a, u);
      t.expect("\\end", !1);
      var f = t.nextToken, m = ge(t.parseFunction(), "environment");
      if (m.name !== s)
        throw new ie("Mismatch: \\begin{" + s + "} matched by \\end{" + m.name + "}", f);
      return c;
    }
    return {
      type: "environment",
      mode: t.mode,
      name: s,
      nameGroup: i
    };
  }
});
var R2 = (n, e) => {
  var t = n.font, r = e.withFont(t);
  return De(n.body, r);
}, L2 = (n, e) => {
  var t = n.font, r = e.withFont(t);
  return Oe(n.body, r);
}, z1 = {
  "\\Bbb": "\\mathbb",
  "\\bold": "\\mathbf",
  "\\frak": "\\mathfrak",
  "\\bm": "\\boldsymbol"
};
$({
  type: "font",
  names: [
    // styles, except \boldsymbol defined below
    "\\mathrm",
    "\\mathit",
    "\\mathbf",
    "\\mathnormal",
    // families
    "\\mathbb",
    "\\mathcal",
    "\\mathfrak",
    "\\mathscr",
    "\\mathsf",
    "\\mathtt",
    // aliases, except \bm defined below
    "\\Bbb",
    "\\bold",
    "\\frak"
  ],
  props: {
    numArgs: 1,
    allowedInArgument: !0
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = Qo(e[0]), s = r;
    return s in z1 && (s = z1[s]), {
      type: "font",
      mode: t.mode,
      font: s.slice(1),
      body: i
    };
  },
  htmlBuilder: R2,
  mathmlBuilder: L2
});
$({
  type: "mclass",
  names: ["\\boldsymbol", "\\bm"],
  props: {
    numArgs: 1
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = e[0], i = le.isCharacterBox(r);
    return {
      type: "mclass",
      mode: t.mode,
      mclass: xa(r),
      body: [{
        type: "font",
        mode: t.mode,
        font: "boldsymbol",
        body: r
      }],
      isCharacterBox: i
    };
  }
});
$({
  type: "font",
  names: ["\\rm", "\\sf", "\\tt", "\\bf", "\\it", "\\cal"],
  props: {
    numArgs: 0,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r,
      breakOnTokenText: i
    } = n, {
      mode: s
    } = t, l = t.parseExpression(!0, i), o = "math" + r.slice(1);
    return {
      type: "font",
      mode: s,
      font: o,
      body: {
        type: "ordgroup",
        mode: t.mode,
        body: l
      }
    };
  },
  htmlBuilder: R2,
  mathmlBuilder: L2
});
var N2 = (n, e) => {
  var t = e;
  return n === "display" ? t = t.id >= ue.SCRIPT.id ? t.text() : ue.DISPLAY : n === "text" && t.size === ue.DISPLAY.size ? t = ue.TEXT : n === "script" ? t = ue.SCRIPT : n === "scriptscript" && (t = ue.SCRIPTSCRIPT), t;
}, sc = (n, e) => {
  var t = N2(n.size, e.style), r = t.fracNum(), i = t.fracDen(), s;
  s = e.havingStyle(r);
  var l = De(n.numer, s, e);
  if (n.continued) {
    var o = 8.5 / e.fontMetrics().ptPerEm, a = 3.5 / e.fontMetrics().ptPerEm;
    l.height = l.height < o ? o : l.height, l.depth = l.depth < a ? a : l.depth;
  }
  s = e.havingStyle(i);
  var u = De(n.denom, s, e), h, c, f;
  n.hasBarLine ? (n.barSize ? (c = We(n.barSize, e), h = O.makeLineSpan("frac-line", e, c)) : h = O.makeLineSpan("frac-line", e), c = h.height, f = h.height) : (h = null, c = 0, f = e.fontMetrics().defaultRuleThickness);
  var m, g, v;
  t.size === ue.DISPLAY.size || n.size === "display" ? (m = e.fontMetrics().num1, c > 0 ? g = 3 * f : g = 7 * f, v = e.fontMetrics().denom1) : (c > 0 ? (m = e.fontMetrics().num2, g = f) : (m = e.fontMetrics().num3, g = 3 * f), v = e.fontMetrics().denom2);
  var k;
  if (h) {
    var x = e.fontMetrics().axisHeight;
    m - l.depth - (x + 0.5 * c) < g && (m += g - (m - l.depth - (x + 0.5 * c))), x - 0.5 * c - (u.height - v) < g && (v += g - (x - 0.5 * c - (u.height - v)));
    var y = -(x - 0.5 * c);
    k = O.makeVList({
      positionType: "individualShift",
      children: [{
        type: "elem",
        elem: u,
        shift: v
      }, {
        type: "elem",
        elem: h,
        shift: y
      }, {
        type: "elem",
        elem: l,
        shift: -m
      }]
    }, e);
  } else {
    var S = m - l.depth - (u.height - v);
    S < g && (m += 0.5 * (g - S), v += 0.5 * (g - S)), k = O.makeVList({
      positionType: "individualShift",
      children: [{
        type: "elem",
        elem: u,
        shift: v
      }, {
        type: "elem",
        elem: l,
        shift: -m
      }]
    }, e);
  }
  s = e.havingStyle(t), k.height *= s.sizeMultiplier / e.sizeMultiplier, k.depth *= s.sizeMultiplier / e.sizeMultiplier;
  var A;
  t.size === ue.DISPLAY.size ? A = e.fontMetrics().delim1 : t.size === ue.SCRIPTSCRIPT.size ? A = e.havingStyle(ue.SCRIPT).fontMetrics().delim2 : A = e.fontMetrics().delim2;
  var C, T;
  return n.leftDelim == null ? C = ol(e, ["mopen"]) : C = pn.customSizedDelim(n.leftDelim, A, !0, e.havingStyle(t), n.mode, ["mopen"]), n.continued ? T = O.makeSpan([]) : n.rightDelim == null ? T = ol(e, ["mclose"]) : T = pn.customSizedDelim(n.rightDelim, A, !0, e.havingStyle(t), n.mode, ["mclose"]), O.makeSpan(["mord"].concat(s.sizingClasses(e)), [C, O.makeSpan(["mfrac"], [k]), T], e);
}, lc = (n, e) => {
  var t = new V.MathNode("mfrac", [Oe(n.numer, e), Oe(n.denom, e)]);
  if (!n.hasBarLine)
    t.setAttribute("linethickness", "0px");
  else if (n.barSize) {
    var r = We(n.barSize, e);
    t.setAttribute("linethickness", G(r));
  }
  var i = N2(n.size, e.style);
  if (i.size !== e.style.size) {
    t = new V.MathNode("mstyle", [t]);
    var s = i.size === ue.DISPLAY.size ? "true" : "false";
    t.setAttribute("displaystyle", s), t.setAttribute("scriptlevel", "0");
  }
  if (n.leftDelim != null || n.rightDelim != null) {
    var l = [];
    if (n.leftDelim != null) {
      var o = new V.MathNode("mo", [new V.TextNode(n.leftDelim.replace("\\", ""))]);
      o.setAttribute("fence", "true"), l.push(o);
    }
    if (l.push(t), n.rightDelim != null) {
      var a = new V.MathNode("mo", [new V.TextNode(n.rightDelim.replace("\\", ""))]);
      a.setAttribute("fence", "true"), l.push(a);
    }
    return Xh(l);
  }
  return t;
};
$({
  type: "genfrac",
  names: [
    "\\dfrac",
    "\\frac",
    "\\tfrac",
    "\\dbinom",
    "\\binom",
    "\\tbinom",
    "\\\\atopfrac",
    // can’t be entered directly
    "\\\\bracefrac",
    "\\\\brackfrac"
    // ditto
  ],
  props: {
    numArgs: 2,
    allowedInArgument: !0
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0], s = e[1], l, o = null, a = null, u = "auto";
    switch (r) {
      case "\\dfrac":
      case "\\frac":
      case "\\tfrac":
        l = !0;
        break;
      case "\\\\atopfrac":
        l = !1;
        break;
      case "\\dbinom":
      case "\\binom":
      case "\\tbinom":
        l = !1, o = "(", a = ")";
        break;
      case "\\\\bracefrac":
        l = !1, o = "\\{", a = "\\}";
        break;
      case "\\\\brackfrac":
        l = !1, o = "[", a = "]";
        break;
      default:
        throw new Error("Unrecognized genfrac command");
    }
    switch (r) {
      case "\\dfrac":
      case "\\dbinom":
        u = "display";
        break;
      case "\\tfrac":
      case "\\tbinom":
        u = "text";
        break;
    }
    return {
      type: "genfrac",
      mode: t.mode,
      continued: !1,
      numer: i,
      denom: s,
      hasBarLine: l,
      leftDelim: o,
      rightDelim: a,
      size: u,
      barSize: null
    };
  },
  htmlBuilder: sc,
  mathmlBuilder: lc
});
$({
  type: "genfrac",
  names: ["\\cfrac"],
  props: {
    numArgs: 2
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0], s = e[1];
    return {
      type: "genfrac",
      mode: t.mode,
      continued: !0,
      numer: i,
      denom: s,
      hasBarLine: !0,
      leftDelim: null,
      rightDelim: null,
      size: "display",
      barSize: null
    };
  }
});
$({
  type: "infix",
  names: ["\\over", "\\choose", "\\atop", "\\brace", "\\brack"],
  props: {
    numArgs: 0,
    infix: !0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t,
      token: r
    } = n, i;
    switch (t) {
      case "\\over":
        i = "\\frac";
        break;
      case "\\choose":
        i = "\\binom";
        break;
      case "\\atop":
        i = "\\\\atopfrac";
        break;
      case "\\brace":
        i = "\\\\bracefrac";
        break;
      case "\\brack":
        i = "\\\\brackfrac";
        break;
      default:
        throw new Error("Unrecognized infix genfrac command");
    }
    return {
      type: "infix",
      mode: e.mode,
      replaceWith: i,
      token: r
    };
  }
});
var P1 = ["display", "text", "script", "scriptscript"], H1 = function(e) {
  var t = null;
  return e.length > 0 && (t = e, t = t === "." ? null : t), t;
};
$({
  type: "genfrac",
  names: ["\\genfrac"],
  props: {
    numArgs: 6,
    allowedInArgument: !0,
    argTypes: ["math", "math", "size", "text", "math", "math"]
  },
  handler(n, e) {
    var {
      parser: t
    } = n, r = e[4], i = e[5], s = Qo(e[0]), l = s.type === "atom" && s.family === "open" ? H1(s.text) : null, o = Qo(e[1]), a = o.type === "atom" && o.family === "close" ? H1(o.text) : null, u = ge(e[2], "size"), h, c = null;
    u.isBlank ? h = !0 : (c = u.value, h = c.number > 0);
    var f = "auto", m = e[3];
    if (m.type === "ordgroup") {
      if (m.body.length > 0) {
        var g = ge(m.body[0], "textord");
        f = P1[Number(g.text)];
      }
    } else
      m = ge(m, "textord"), f = P1[Number(m.text)];
    return {
      type: "genfrac",
      mode: t.mode,
      numer: r,
      denom: i,
      continued: !1,
      hasBarLine: h,
      barSize: c,
      leftDelim: l,
      rightDelim: a,
      size: f
    };
  },
  htmlBuilder: sc,
  mathmlBuilder: lc
});
$({
  type: "infix",
  names: ["\\above"],
  props: {
    numArgs: 1,
    argTypes: ["size"],
    infix: !0
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r,
      token: i
    } = n;
    return {
      type: "infix",
      mode: t.mode,
      replaceWith: "\\\\abovefrac",
      size: ge(e[0], "size").value,
      token: i
    };
  }
});
$({
  type: "genfrac",
  names: ["\\\\abovefrac"],
  props: {
    numArgs: 3,
    argTypes: ["math", "size", "math"]
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0], s = $w(ge(e[1], "infix").size), l = e[2], o = s.number > 0;
    return {
      type: "genfrac",
      mode: t.mode,
      numer: i,
      denom: l,
      continued: !1,
      hasBarLine: o,
      barSize: s,
      leftDelim: null,
      rightDelim: null,
      size: "auto"
    };
  },
  htmlBuilder: sc,
  mathmlBuilder: lc
});
var I2 = (n, e) => {
  var t = e.style, r, i;
  n.type === "supsub" ? (r = n.sup ? De(n.sup, e.havingStyle(t.sup()), e) : De(n.sub, e.havingStyle(t.sub()), e), i = ge(n.base, "horizBrace")) : i = ge(n, "horizBrace");
  var s = De(i.base, e.havingBaseStyle(ue.DISPLAY)), l = bn.svgSpan(i, e), o;
  if (i.isOver ? (o = O.makeVList({
    positionType: "firstBaseline",
    children: [{
      type: "elem",
      elem: s
    }, {
      type: "kern",
      size: 0.1
    }, {
      type: "elem",
      elem: l
    }]
  }, e), o.children[0].children[0].children[1].classes.push("svg-align")) : (o = O.makeVList({
    positionType: "bottom",
    positionData: s.depth + 0.1 + l.height,
    children: [{
      type: "elem",
      elem: l
    }, {
      type: "kern",
      size: 0.1
    }, {
      type: "elem",
      elem: s
    }]
  }, e), o.children[0].children[0].children[0].classes.push("svg-align")), r) {
    var a = O.makeSpan(["mord", i.isOver ? "mover" : "munder"], [o], e);
    i.isOver ? o = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: a
      }, {
        type: "kern",
        size: 0.2
      }, {
        type: "elem",
        elem: r
      }]
    }, e) : o = O.makeVList({
      positionType: "bottom",
      positionData: a.depth + 0.2 + r.height + r.depth,
      children: [{
        type: "elem",
        elem: r
      }, {
        type: "kern",
        size: 0.2
      }, {
        type: "elem",
        elem: a
      }]
    }, e);
  }
  return O.makeSpan(["mord", i.isOver ? "mover" : "munder"], [o], e);
}, dx = (n, e) => {
  var t = bn.mathMLnode(n.label);
  return new V.MathNode(n.isOver ? "mover" : "munder", [Oe(n.base, e), t]);
};
$({
  type: "horizBrace",
  names: ["\\overbrace", "\\underbrace"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n;
    return {
      type: "horizBrace",
      mode: t.mode,
      label: r,
      isOver: /^\\over/.test(r),
      base: e[0]
    };
  },
  htmlBuilder: I2,
  mathmlBuilder: dx
});
$({
  type: "href",
  names: ["\\href"],
  props: {
    numArgs: 2,
    argTypes: ["url", "original"],
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = e[1], i = ge(e[0], "url").url;
    return t.settings.isTrusted({
      command: "\\href",
      url: i
    }) ? {
      type: "href",
      mode: t.mode,
      href: i,
      body: Xe(r)
    } : t.formatUnsupportedCmd("\\href");
  },
  htmlBuilder: (n, e) => {
    var t = ut(n.body, e, !1);
    return O.makeAnchor(n.href, [], t, e);
  },
  mathmlBuilder: (n, e) => {
    var t = qn(n.body, e);
    return t instanceof yr || (t = new yr("mrow", [t])), t.setAttribute("href", n.href), t;
  }
});
$({
  type: "href",
  names: ["\\url"],
  props: {
    numArgs: 1,
    argTypes: ["url"],
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = ge(e[0], "url").url;
    if (!t.settings.isTrusted({
      command: "\\url",
      url: r
    }))
      return t.formatUnsupportedCmd("\\url");
    for (var i = [], s = 0; s < r.length; s++) {
      var l = r[s];
      l === "~" && (l = "\\textasciitilde"), i.push({
        type: "textord",
        mode: "text",
        text: l
      });
    }
    var o = {
      type: "text",
      mode: t.mode,
      font: "\\texttt",
      body: i
    };
    return {
      type: "href",
      mode: t.mode,
      href: r,
      body: Xe(o)
    };
  }
});
$({
  type: "hbox",
  names: ["\\hbox"],
  props: {
    numArgs: 1,
    argTypes: ["text"],
    allowedInText: !0,
    primitive: !0
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "hbox",
      mode: t.mode,
      body: Xe(e[0])
    };
  },
  htmlBuilder(n, e) {
    var t = ut(n.body, e, !1);
    return O.makeFragment(t);
  },
  mathmlBuilder(n, e) {
    return new V.MathNode("mrow", Vt(n.body, e));
  }
});
$({
  type: "html",
  names: ["\\htmlClass", "\\htmlId", "\\htmlStyle", "\\htmlData"],
  props: {
    numArgs: 2,
    argTypes: ["raw", "original"],
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r,
      token: i
    } = n, s = ge(e[0], "raw").string, l = e[1];
    t.settings.strict && t.settings.reportNonstrict("htmlExtension", "HTML extension is disabled on strict mode");
    var o, a = {};
    switch (r) {
      case "\\htmlClass":
        a.class = s, o = {
          command: "\\htmlClass",
          class: s
        };
        break;
      case "\\htmlId":
        a.id = s, o = {
          command: "\\htmlId",
          id: s
        };
        break;
      case "\\htmlStyle":
        a.style = s, o = {
          command: "\\htmlStyle",
          style: s
        };
        break;
      case "\\htmlData": {
        for (var u = s.split(","), h = 0; h < u.length; h++) {
          var c = u[h].split("=");
          if (c.length !== 2)
            throw new ie("Error parsing key-value for \\htmlData");
          a["data-" + c[0].trim()] = c[1].trim();
        }
        o = {
          command: "\\htmlData",
          attributes: a
        };
        break;
      }
      default:
        throw new Error("Unrecognized html command");
    }
    return t.settings.isTrusted(o) ? {
      type: "html",
      mode: t.mode,
      attributes: a,
      body: Xe(l)
    } : t.formatUnsupportedCmd(r);
  },
  htmlBuilder: (n, e) => {
    var t = ut(n.body, e, !1), r = ["enclosing"];
    n.attributes.class && r.push(...n.attributes.class.trim().split(/\s+/));
    var i = O.makeSpan(r, t, e);
    for (var s in n.attributes)
      s !== "class" && n.attributes.hasOwnProperty(s) && i.setAttribute(s, n.attributes[s]);
    return i;
  },
  mathmlBuilder: (n, e) => qn(n.body, e)
});
$({
  type: "htmlmathml",
  names: ["\\html@mathml"],
  props: {
    numArgs: 2,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n;
    return {
      type: "htmlmathml",
      mode: t.mode,
      html: Xe(e[0]),
      mathml: Xe(e[1])
    };
  },
  htmlBuilder: (n, e) => {
    var t = ut(n.html, e, !1);
    return O.makeFragment(t);
  },
  mathmlBuilder: (n, e) => qn(n.mathml, e)
});
var T0 = function(e) {
  if (/^[-+]? *(\d+(\.\d*)?|\.\d+)$/.test(e))
    return {
      number: +e,
      unit: "bp"
    };
  var t = /([-+]?) *(\d+(?:\.\d*)?|\.\d+) *([a-z]{2})/.exec(e);
  if (!t)
    throw new ie("Invalid size: '" + e + "' in \\includegraphics");
  var r = {
    number: +(t[1] + t[2]),
    // sign + magnitude, cast to number
    unit: t[3]
  };
  if (!mk(r))
    throw new ie("Invalid unit: '" + r.unit + "' in \\includegraphics.");
  return r;
};
$({
  type: "includegraphics",
  names: ["\\includegraphics"],
  props: {
    numArgs: 1,
    numOptionalArgs: 1,
    argTypes: ["raw", "url"],
    allowedInText: !1
  },
  handler: (n, e, t) => {
    var {
      parser: r
    } = n, i = {
      number: 0,
      unit: "em"
    }, s = {
      number: 0.9,
      unit: "em"
    }, l = {
      number: 0,
      unit: "em"
    }, o = "";
    if (t[0])
      for (var a = ge(t[0], "raw").string, u = a.split(","), h = 0; h < u.length; h++) {
        var c = u[h].split("=");
        if (c.length === 2) {
          var f = c[1].trim();
          switch (c[0].trim()) {
            case "alt":
              o = f;
              break;
            case "width":
              i = T0(f);
              break;
            case "height":
              s = T0(f);
              break;
            case "totalheight":
              l = T0(f);
              break;
            default:
              throw new ie("Invalid key: '" + c[0] + "' in \\includegraphics.");
          }
        }
      }
    var m = ge(e[0], "url").url;
    return o === "" && (o = m, o = o.replace(/^.*[\\/]/, ""), o = o.substring(0, o.lastIndexOf("."))), r.settings.isTrusted({
      command: "\\includegraphics",
      url: m
    }) ? {
      type: "includegraphics",
      mode: r.mode,
      alt: o,
      width: i,
      height: s,
      totalheight: l,
      src: m
    } : r.formatUnsupportedCmd("\\includegraphics");
  },
  htmlBuilder: (n, e) => {
    var t = We(n.height, e), r = 0;
    n.totalheight.number > 0 && (r = We(n.totalheight, e) - t);
    var i = 0;
    n.width.number > 0 && (i = We(n.width, e));
    var s = {
      height: G(t + r)
    };
    i > 0 && (s.width = G(i)), r > 0 && (s.verticalAlign = G(-r));
    var l = new pk(n.src, n.alt, s);
    return l.height = t, l.depth = r, l;
  },
  mathmlBuilder: (n, e) => {
    var t = new V.MathNode("mglyph", []);
    t.setAttribute("alt", n.alt);
    var r = We(n.height, e), i = 0;
    if (n.totalheight.number > 0 && (i = We(n.totalheight, e) - r, t.setAttribute("valign", G(-i))), t.setAttribute("height", G(r + i)), n.width.number > 0) {
      var s = We(n.width, e);
      t.setAttribute("width", G(s));
    }
    return t.setAttribute("src", n.src), t;
  }
});
$({
  type: "kern",
  names: ["\\kern", "\\mkern", "\\hskip", "\\mskip"],
  props: {
    numArgs: 1,
    argTypes: ["size"],
    primitive: !0,
    allowedInText: !0
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n, i = ge(e[0], "size");
    if (t.settings.strict) {
      var s = r[1] === "m", l = i.value.unit === "mu";
      s ? (l || t.settings.reportNonstrict("mathVsTextUnits", "LaTeX's " + r + " supports only mu units, " + ("not " + i.value.unit + " units")), t.mode !== "math" && t.settings.reportNonstrict("mathVsTextUnits", "LaTeX's " + r + " works only in math mode")) : l && t.settings.reportNonstrict("mathVsTextUnits", "LaTeX's " + r + " doesn't support mu units");
    }
    return {
      type: "kern",
      mode: t.mode,
      dimension: i.value
    };
  },
  htmlBuilder(n, e) {
    return O.makeGlue(n.dimension, e);
  },
  mathmlBuilder(n, e) {
    var t = We(n.dimension, e);
    return new V.SpaceNode(t);
  }
});
$({
  type: "lap",
  names: ["\\mathllap", "\\mathrlap", "\\mathclap"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    return {
      type: "lap",
      mode: t.mode,
      alignment: r.slice(5),
      body: i
    };
  },
  htmlBuilder: (n, e) => {
    var t;
    n.alignment === "clap" ? (t = O.makeSpan([], [De(n.body, e)]), t = O.makeSpan(["inner"], [t], e)) : t = O.makeSpan(["inner"], [De(n.body, e)]);
    var r = O.makeSpan(["fix"], []), i = O.makeSpan([n.alignment], [t, r], e), s = O.makeSpan(["strut"]);
    return s.style.height = G(i.height + i.depth), i.depth && (s.style.verticalAlign = G(-i.depth)), i.children.unshift(s), i = O.makeSpan(["thinbox"], [i], e), O.makeSpan(["mord", "vbox"], [i], e);
  },
  mathmlBuilder: (n, e) => {
    var t = new V.MathNode("mpadded", [Oe(n.body, e)]);
    if (n.alignment !== "rlap") {
      var r = n.alignment === "llap" ? "-1" : "-0.5";
      t.setAttribute("lspace", r + "width");
    }
    return t.setAttribute("width", "0px"), t;
  }
});
$({
  type: "styling",
  names: ["\\(", "$"],
  props: {
    numArgs: 0,
    allowedInText: !0,
    allowedInMath: !1
  },
  handler(n, e) {
    var {
      funcName: t,
      parser: r
    } = n, i = r.mode;
    r.switchMode("math");
    var s = t === "\\(" ? "\\)" : "$", l = r.parseExpression(!1, s);
    return r.expect(s), r.switchMode(i), {
      type: "styling",
      mode: r.mode,
      style: "text",
      body: l
    };
  }
});
$({
  type: "text",
  // Doesn't matter what this is.
  names: ["\\)", "\\]"],
  props: {
    numArgs: 0,
    allowedInText: !0,
    allowedInMath: !1
  },
  handler(n, e) {
    throw new ie("Mismatched " + n.funcName);
  }
});
var q1 = (n, e) => {
  switch (e.style.size) {
    case ue.DISPLAY.size:
      return n.display;
    case ue.TEXT.size:
      return n.text;
    case ue.SCRIPT.size:
      return n.script;
    case ue.SCRIPTSCRIPT.size:
      return n.scriptscript;
    default:
      return n.text;
  }
};
$({
  type: "mathchoice",
  names: ["\\mathchoice"],
  props: {
    numArgs: 4,
    primitive: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n;
    return {
      type: "mathchoice",
      mode: t.mode,
      display: Xe(e[0]),
      text: Xe(e[1]),
      script: Xe(e[2]),
      scriptscript: Xe(e[3])
    };
  },
  htmlBuilder: (n, e) => {
    var t = q1(n, e), r = ut(t, e, !1);
    return O.makeFragment(r);
  },
  mathmlBuilder: (n, e) => {
    var t = q1(n, e);
    return qn(t, e);
  }
});
var z2 = (n, e, t, r, i, s, l) => {
  n = O.makeSpan([], [n]);
  var o = t && le.isCharacterBox(t), a, u;
  if (e) {
    var h = De(e, r.havingStyle(i.sup()), r);
    u = {
      elem: h,
      kern: Math.max(r.fontMetrics().bigOpSpacing1, r.fontMetrics().bigOpSpacing3 - h.depth)
    };
  }
  if (t) {
    var c = De(t, r.havingStyle(i.sub()), r);
    a = {
      elem: c,
      kern: Math.max(r.fontMetrics().bigOpSpacing2, r.fontMetrics().bigOpSpacing4 - c.height)
    };
  }
  var f;
  if (u && a) {
    var m = r.fontMetrics().bigOpSpacing5 + a.elem.height + a.elem.depth + a.kern + n.depth + l;
    f = O.makeVList({
      positionType: "bottom",
      positionData: m,
      children: [{
        type: "kern",
        size: r.fontMetrics().bigOpSpacing5
      }, {
        type: "elem",
        elem: a.elem,
        marginLeft: G(-s)
      }, {
        type: "kern",
        size: a.kern
      }, {
        type: "elem",
        elem: n
      }, {
        type: "kern",
        size: u.kern
      }, {
        type: "elem",
        elem: u.elem,
        marginLeft: G(s)
      }, {
        type: "kern",
        size: r.fontMetrics().bigOpSpacing5
      }]
    }, r);
  } else if (a) {
    var g = n.height - l;
    f = O.makeVList({
      positionType: "top",
      positionData: g,
      children: [{
        type: "kern",
        size: r.fontMetrics().bigOpSpacing5
      }, {
        type: "elem",
        elem: a.elem,
        marginLeft: G(-s)
      }, {
        type: "kern",
        size: a.kern
      }, {
        type: "elem",
        elem: n
      }]
    }, r);
  } else if (u) {
    var v = n.depth + l;
    f = O.makeVList({
      positionType: "bottom",
      positionData: v,
      children: [{
        type: "elem",
        elem: n
      }, {
        type: "kern",
        size: u.kern
      }, {
        type: "elem",
        elem: u.elem,
        marginLeft: G(s)
      }, {
        type: "kern",
        size: r.fontMetrics().bigOpSpacing5
      }]
    }, r);
  } else
    return n;
  var k = [f];
  if (a && s !== 0 && !o) {
    var S = O.makeSpan(["mspace"], [], r);
    S.style.marginRight = G(s), k.unshift(S);
  }
  return O.makeSpan(["mop", "op-limits"], k, r);
}, P2 = ["\\smallint"], as = (n, e) => {
  var t, r, i = !1, s;
  n.type === "supsub" ? (t = n.sup, r = n.sub, s = ge(n.base, "op"), i = !0) : s = ge(n, "op");
  var l = e.style, o = !1;
  l.size === ue.DISPLAY.size && s.symbol && !le.contains(P2, s.name) && (o = !0);
  var a;
  if (s.symbol) {
    var u = o ? "Size2-Regular" : "Size1-Regular", h = "";
    if ((s.name === "\\oiint" || s.name === "\\oiiint") && (h = s.name.slice(1), s.name = h === "oiint" ? "\\iint" : "\\iiint"), a = O.makeSymbol(s.name, u, "math", e, ["mop", "op-symbol", o ? "large-op" : "small-op"]), h.length > 0) {
      var c = a.italic, f = O.staticSvg(h + "Size" + (o ? "2" : "1"), e);
      a = O.makeVList({
        positionType: "individualShift",
        children: [{
          type: "elem",
          elem: a,
          shift: 0
        }, {
          type: "elem",
          elem: f,
          shift: o ? 0.08 : 0
        }]
      }, e), s.name = "\\" + h, a.classes.unshift("mop"), a.italic = c;
    }
  } else if (s.body) {
    var m = ut(s.body, e, !0);
    m.length === 1 && m[0] instanceof Kr ? (a = m[0], a.classes[0] = "mop") : a = O.makeSpan(["mop"], m, e);
  } else {
    for (var g = [], v = 1; v < s.name.length; v++)
      g.push(O.mathsym(s.name[v], s.mode, e));
    a = O.makeSpan(["mop"], g, e);
  }
  var k = 0, S = 0;
  return (a instanceof Kr || s.name === "\\oiint" || s.name === "\\oiiint") && !s.suppressBaseShift && (k = (a.height - a.depth) / 2 - e.fontMetrics().axisHeight, S = a.italic), i ? z2(a, t, r, e, l, S, k) : (k && (a.style.position = "relative", a.style.top = G(k)), a);
}, bl = (n, e) => {
  var t;
  if (n.symbol)
    t = new yr("mo", [sr(n.name, n.mode)]), le.contains(P2, n.name) && t.setAttribute("largeop", "false");
  else if (n.body)
    t = new yr("mo", Vt(n.body, e));
  else {
    t = new yr("mi", [new Vs(n.name.slice(1))]);
    var r = new yr("mo", [sr("⁡", "text")]);
    n.parentIsSupSub ? t = new yr("mrow", [t, r]) : t = g2([t, r]);
  }
  return t;
}, mx = {
  "∏": "\\prod",
  "∐": "\\coprod",
  "∑": "\\sum",
  "⋀": "\\bigwedge",
  "⋁": "\\bigvee",
  "⋂": "\\bigcap",
  "⋃": "\\bigcup",
  "⨀": "\\bigodot",
  "⨁": "\\bigoplus",
  "⨂": "\\bigotimes",
  "⨄": "\\biguplus",
  "⨆": "\\bigsqcup"
};
$({
  type: "op",
  names: ["\\coprod", "\\bigvee", "\\bigwedge", "\\biguplus", "\\bigcap", "\\bigcup", "\\intop", "\\prod", "\\sum", "\\bigotimes", "\\bigoplus", "\\bigodot", "\\bigsqcup", "\\smallint", "∏", "∐", "∑", "⋀", "⋁", "⋂", "⋃", "⨀", "⨁", "⨂", "⨄", "⨆"],
  props: {
    numArgs: 0
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = r;
    return i.length === 1 && (i = mx[i]), {
      type: "op",
      mode: t.mode,
      limits: !0,
      parentIsSupSub: !1,
      symbol: !0,
      name: i
    };
  },
  htmlBuilder: as,
  mathmlBuilder: bl
});
$({
  type: "op",
  names: ["\\mathop"],
  props: {
    numArgs: 1,
    primitive: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = e[0];
    return {
      type: "op",
      mode: t.mode,
      limits: !1,
      parentIsSupSub: !1,
      symbol: !1,
      body: Xe(r)
    };
  },
  htmlBuilder: as,
  mathmlBuilder: bl
});
var px = {
  "∫": "\\int",
  "∬": "\\iint",
  "∭": "\\iiint",
  "∮": "\\oint",
  "∯": "\\oiint",
  "∰": "\\oiiint"
};
$({
  type: "op",
  names: ["\\arcsin", "\\arccos", "\\arctan", "\\arctg", "\\arcctg", "\\arg", "\\ch", "\\cos", "\\cosec", "\\cosh", "\\cot", "\\cotg", "\\coth", "\\csc", "\\ctg", "\\cth", "\\deg", "\\dim", "\\exp", "\\hom", "\\ker", "\\lg", "\\ln", "\\log", "\\sec", "\\sin", "\\sinh", "\\sh", "\\tan", "\\tanh", "\\tg", "\\th"],
  props: {
    numArgs: 0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n;
    return {
      type: "op",
      mode: e.mode,
      limits: !1,
      parentIsSupSub: !1,
      symbol: !1,
      name: t
    };
  },
  htmlBuilder: as,
  mathmlBuilder: bl
});
$({
  type: "op",
  names: ["\\det", "\\gcd", "\\inf", "\\lim", "\\max", "\\min", "\\Pr", "\\sup"],
  props: {
    numArgs: 0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n;
    return {
      type: "op",
      mode: e.mode,
      limits: !0,
      parentIsSupSub: !1,
      symbol: !1,
      name: t
    };
  },
  htmlBuilder: as,
  mathmlBuilder: bl
});
$({
  type: "op",
  names: ["\\int", "\\iint", "\\iiint", "\\oint", "\\oiint", "\\oiiint", "∫", "∬", "∭", "∮", "∯", "∰"],
  props: {
    numArgs: 0
  },
  handler(n) {
    var {
      parser: e,
      funcName: t
    } = n, r = t;
    return r.length === 1 && (r = px[r]), {
      type: "op",
      mode: e.mode,
      limits: !1,
      parentIsSupSub: !1,
      symbol: !0,
      name: r
    };
  },
  htmlBuilder: as,
  mathmlBuilder: bl
});
var H2 = (n, e) => {
  var t, r, i = !1, s;
  n.type === "supsub" ? (t = n.sup, r = n.sub, s = ge(n.base, "operatorname"), i = !0) : s = ge(n, "operatorname");
  var l;
  if (s.body.length > 0) {
    for (var o = s.body.map((c) => {
      var f = c.text;
      return typeof f == "string" ? {
        type: "textord",
        mode: c.mode,
        text: f
      } : c;
    }), a = ut(o, e.withFont("mathrm"), !0), u = 0; u < a.length; u++) {
      var h = a[u];
      h instanceof Kr && (h.text = h.text.replace(/\u2212/, "-").replace(/\u2217/, "*"));
    }
    l = O.makeSpan(["mop"], a, e);
  } else
    l = O.makeSpan(["mop"], [], e);
  return i ? z2(l, t, r, e, e.style, 0, 0) : l;
}, gx = (n, e) => {
  for (var t = Vt(n.body, e.withFont("mathrm")), r = !0, i = 0; i < t.length; i++) {
    var s = t[i];
    if (!(s instanceof V.SpaceNode)) if (s instanceof V.MathNode)
      switch (s.type) {
        case "mi":
        case "mn":
        case "ms":
        case "mspace":
        case "mtext":
          break;
        case "mo": {
          var l = s.children[0];
          s.children.length === 1 && l instanceof V.TextNode ? l.text = l.text.replace(/\u2212/, "-").replace(/\u2217/, "*") : r = !1;
          break;
        }
        default:
          r = !1;
      }
    else
      r = !1;
  }
  if (r) {
    var o = t.map((h) => h.toText()).join("");
    t = [new V.TextNode(o)];
  }
  var a = new V.MathNode("mi", t);
  a.setAttribute("mathvariant", "normal");
  var u = new V.MathNode("mo", [sr("⁡", "text")]);
  return n.parentIsSupSub ? new V.MathNode("mrow", [a, u]) : V.newDocumentFragment([a, u]);
};
$({
  type: "operatorname",
  names: ["\\operatorname@", "\\operatornamewithlimits"],
  props: {
    numArgs: 1
  },
  handler: (n, e) => {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    return {
      type: "operatorname",
      mode: t.mode,
      body: Xe(i),
      alwaysHandleSupSub: r === "\\operatornamewithlimits",
      limits: !1,
      parentIsSupSub: !1
    };
  },
  htmlBuilder: H2,
  mathmlBuilder: gx
});
w("\\operatorname", "\\@ifstar\\operatornamewithlimits\\operatorname@");
vi({
  type: "ordgroup",
  htmlBuilder(n, e) {
    return n.semisimple ? O.makeFragment(ut(n.body, e, !1)) : O.makeSpan(["mord"], ut(n.body, e, !0), e);
  },
  mathmlBuilder(n, e) {
    return qn(n.body, e, !0);
  }
});
$({
  type: "overline",
  names: ["\\overline"],
  props: {
    numArgs: 1
  },
  handler(n, e) {
    var {
      parser: t
    } = n, r = e[0];
    return {
      type: "overline",
      mode: t.mode,
      body: r
    };
  },
  htmlBuilder(n, e) {
    var t = De(n.body, e.havingCrampedStyle()), r = O.makeLineSpan("overline-line", e), i = e.fontMetrics().defaultRuleThickness, s = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: t
      }, {
        type: "kern",
        size: 3 * i
      }, {
        type: "elem",
        elem: r
      }, {
        type: "kern",
        size: i
      }]
    }, e);
    return O.makeSpan(["mord", "overline"], [s], e);
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mo", [new V.TextNode("‾")]);
    t.setAttribute("stretchy", "true");
    var r = new V.MathNode("mover", [Oe(n.body, e), t]);
    return r.setAttribute("accent", "true"), r;
  }
});
$({
  type: "phantom",
  names: ["\\phantom"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = e[0];
    return {
      type: "phantom",
      mode: t.mode,
      body: Xe(r)
    };
  },
  htmlBuilder: (n, e) => {
    var t = ut(n.body, e.withPhantom(), !1);
    return O.makeFragment(t);
  },
  mathmlBuilder: (n, e) => {
    var t = Vt(n.body, e);
    return new V.MathNode("mphantom", t);
  }
});
$({
  type: "hphantom",
  names: ["\\hphantom"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = e[0];
    return {
      type: "hphantom",
      mode: t.mode,
      body: r
    };
  },
  htmlBuilder: (n, e) => {
    var t = O.makeSpan([], [De(n.body, e.withPhantom())]);
    if (t.height = 0, t.depth = 0, t.children)
      for (var r = 0; r < t.children.length; r++)
        t.children[r].height = 0, t.children[r].depth = 0;
    return t = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: t
      }]
    }, e), O.makeSpan(["mord"], [t], e);
  },
  mathmlBuilder: (n, e) => {
    var t = Vt(Xe(n.body), e), r = new V.MathNode("mphantom", t), i = new V.MathNode("mpadded", [r]);
    return i.setAttribute("height", "0px"), i.setAttribute("depth", "0px"), i;
  }
});
$({
  type: "vphantom",
  names: ["\\vphantom"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      parser: t
    } = n, r = e[0];
    return {
      type: "vphantom",
      mode: t.mode,
      body: r
    };
  },
  htmlBuilder: (n, e) => {
    var t = O.makeSpan(["inner"], [De(n.body, e.withPhantom())]), r = O.makeSpan(["fix"], []);
    return O.makeSpan(["mord", "rlap"], [t, r], e);
  },
  mathmlBuilder: (n, e) => {
    var t = Vt(Xe(n.body), e), r = new V.MathNode("mphantom", t), i = new V.MathNode("mpadded", [r]);
    return i.setAttribute("width", "0px"), i;
  }
});
$({
  type: "raisebox",
  names: ["\\raisebox"],
  props: {
    numArgs: 2,
    argTypes: ["size", "hbox"],
    allowedInText: !0
  },
  handler(n, e) {
    var {
      parser: t
    } = n, r = ge(e[0], "size").value, i = e[1];
    return {
      type: "raisebox",
      mode: t.mode,
      dy: r,
      body: i
    };
  },
  htmlBuilder(n, e) {
    var t = De(n.body, e), r = We(n.dy, e);
    return O.makeVList({
      positionType: "shift",
      positionData: -r,
      children: [{
        type: "elem",
        elem: t
      }]
    }, e);
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mpadded", [Oe(n.body, e)]), r = n.dy.number + n.dy.unit;
    return t.setAttribute("voffset", r), t;
  }
});
$({
  type: "internal",
  names: ["\\relax"],
  props: {
    numArgs: 0,
    allowedInText: !0
  },
  handler(n) {
    var {
      parser: e
    } = n;
    return {
      type: "internal",
      mode: e.mode
    };
  }
});
$({
  type: "rule",
  names: ["\\rule"],
  props: {
    numArgs: 2,
    numOptionalArgs: 1,
    argTypes: ["size", "size", "size"]
  },
  handler(n, e, t) {
    var {
      parser: r
    } = n, i = t[0], s = ge(e[0], "size"), l = ge(e[1], "size");
    return {
      type: "rule",
      mode: r.mode,
      shift: i && ge(i, "size").value,
      width: s.value,
      height: l.value
    };
  },
  htmlBuilder(n, e) {
    var t = O.makeSpan(["mord", "rule"], [], e), r = We(n.width, e), i = We(n.height, e), s = n.shift ? We(n.shift, e) : 0;
    return t.style.borderRightWidth = G(r), t.style.borderTopWidth = G(i), t.style.bottom = G(s), t.width = r, t.height = i + s, t.depth = -s, t.maxFontSize = i * 1.125 * e.sizeMultiplier, t;
  },
  mathmlBuilder(n, e) {
    var t = We(n.width, e), r = We(n.height, e), i = n.shift ? We(n.shift, e) : 0, s = e.color && e.getColor() || "black", l = new V.MathNode("mspace");
    l.setAttribute("mathbackground", s), l.setAttribute("width", G(t)), l.setAttribute("height", G(r));
    var o = new V.MathNode("mpadded", [l]);
    return i >= 0 ? o.setAttribute("height", G(i)) : (o.setAttribute("height", G(i)), o.setAttribute("depth", G(-i))), o.setAttribute("voffset", G(i)), o;
  }
});
function q2(n, e, t) {
  for (var r = ut(n, e, !1), i = e.sizeMultiplier / t.sizeMultiplier, s = 0; s < r.length; s++) {
    var l = r[s].classes.indexOf("sizing");
    l < 0 ? Array.prototype.push.apply(r[s].classes, e.sizingClasses(t)) : r[s].classes[l + 1] === "reset-size" + e.size && (r[s].classes[l + 1] = "reset-size" + t.size), r[s].height *= i, r[s].depth *= i;
  }
  return O.makeFragment(r);
}
var V1 = ["\\tiny", "\\sixptsize", "\\scriptsize", "\\footnotesize", "\\small", "\\normalsize", "\\large", "\\Large", "\\LARGE", "\\huge", "\\Huge"], bx = (n, e) => {
  var t = e.havingSize(n.size);
  return q2(n.body, t, e);
};
$({
  type: "sizing",
  names: V1,
  props: {
    numArgs: 0,
    allowedInText: !0
  },
  handler: (n, e) => {
    var {
      breakOnTokenText: t,
      funcName: r,
      parser: i
    } = n, s = i.parseExpression(!1, t);
    return {
      type: "sizing",
      mode: i.mode,
      // Figure out what size to use based on the list of functions above
      size: V1.indexOf(r) + 1,
      body: s
    };
  },
  htmlBuilder: bx,
  mathmlBuilder: (n, e) => {
    var t = e.havingSize(n.size), r = Vt(n.body, t), i = new V.MathNode("mstyle", r);
    return i.setAttribute("mathsize", G(t.sizeMultiplier)), i;
  }
});
$({
  type: "smash",
  names: ["\\smash"],
  props: {
    numArgs: 1,
    numOptionalArgs: 1,
    allowedInText: !0
  },
  handler: (n, e, t) => {
    var {
      parser: r
    } = n, i = !1, s = !1, l = t[0] && ge(t[0], "ordgroup");
    if (l)
      for (var o = "", a = 0; a < l.body.length; ++a) {
        var u = l.body[a];
        if (o = u.text, o === "t")
          i = !0;
        else if (o === "b")
          s = !0;
        else {
          i = !1, s = !1;
          break;
        }
      }
    else
      i = !0, s = !0;
    var h = e[0];
    return {
      type: "smash",
      mode: r.mode,
      body: h,
      smashHeight: i,
      smashDepth: s
    };
  },
  htmlBuilder: (n, e) => {
    var t = O.makeSpan([], [De(n.body, e)]);
    if (!n.smashHeight && !n.smashDepth)
      return t;
    if (n.smashHeight && (t.height = 0, t.children))
      for (var r = 0; r < t.children.length; r++)
        t.children[r].height = 0;
    if (n.smashDepth && (t.depth = 0, t.children))
      for (var i = 0; i < t.children.length; i++)
        t.children[i].depth = 0;
    var s = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: t
      }]
    }, e);
    return O.makeSpan(["mord"], [s], e);
  },
  mathmlBuilder: (n, e) => {
    var t = new V.MathNode("mpadded", [Oe(n.body, e)]);
    return n.smashHeight && t.setAttribute("height", "0px"), n.smashDepth && t.setAttribute("depth", "0px"), t;
  }
});
$({
  type: "sqrt",
  names: ["\\sqrt"],
  props: {
    numArgs: 1,
    numOptionalArgs: 1
  },
  handler(n, e, t) {
    var {
      parser: r
    } = n, i = t[0], s = e[0];
    return {
      type: "sqrt",
      mode: r.mode,
      body: s,
      index: i
    };
  },
  htmlBuilder(n, e) {
    var t = De(n.body, e.havingCrampedStyle());
    t.height === 0 && (t.height = e.fontMetrics().xHeight), t = O.wrapFragment(t, e);
    var r = e.fontMetrics(), i = r.defaultRuleThickness, s = i;
    e.style.id < ue.TEXT.id && (s = e.fontMetrics().xHeight);
    var l = i + s / 4, o = t.height + t.depth + l + i, {
      span: a,
      ruleWidth: u,
      advanceWidth: h
    } = pn.sqrtImage(o, e), c = a.height - u;
    c > t.height + t.depth + l && (l = (l + c - t.height - t.depth) / 2);
    var f = a.height - t.height - l - u;
    t.style.paddingLeft = G(h);
    var m = O.makeVList({
      positionType: "firstBaseline",
      children: [{
        type: "elem",
        elem: t,
        wrapperClasses: ["svg-align"]
      }, {
        type: "kern",
        size: -(t.height + f)
      }, {
        type: "elem",
        elem: a
      }, {
        type: "kern",
        size: u
      }]
    }, e);
    if (n.index) {
      var g = e.havingStyle(ue.SCRIPTSCRIPT), v = De(n.index, g, e), k = 0.6 * (m.height - m.depth), S = O.makeVList({
        positionType: "shift",
        positionData: -k,
        children: [{
          type: "elem",
          elem: v
        }]
      }, e), x = O.makeSpan(["root"], [S]);
      return O.makeSpan(["mord", "sqrt"], [x, m], e);
    } else
      return O.makeSpan(["mord", "sqrt"], [m], e);
  },
  mathmlBuilder(n, e) {
    var {
      body: t,
      index: r
    } = n;
    return r ? new V.MathNode("mroot", [Oe(t, e), Oe(r, e)]) : new V.MathNode("msqrt", [Oe(t, e)]);
  }
});
var W1 = {
  display: ue.DISPLAY,
  text: ue.TEXT,
  script: ue.SCRIPT,
  scriptscript: ue.SCRIPTSCRIPT
};
$({
  type: "styling",
  names: ["\\displaystyle", "\\textstyle", "\\scriptstyle", "\\scriptscriptstyle"],
  props: {
    numArgs: 0,
    allowedInText: !0,
    primitive: !0
  },
  handler(n, e) {
    var {
      breakOnTokenText: t,
      funcName: r,
      parser: i
    } = n, s = i.parseExpression(!0, t), l = r.slice(1, r.length - 5);
    return {
      type: "styling",
      mode: i.mode,
      // Figure out what style to use by pulling out the style from
      // the function name
      style: l,
      body: s
    };
  },
  htmlBuilder(n, e) {
    var t = W1[n.style], r = e.havingStyle(t).withFont("");
    return q2(n.body, r, e);
  },
  mathmlBuilder(n, e) {
    var t = W1[n.style], r = e.havingStyle(t), i = Vt(n.body, r), s = new V.MathNode("mstyle", i), l = {
      display: ["0", "true"],
      text: ["0", "false"],
      script: ["1", "false"],
      scriptscript: ["2", "false"]
    }, o = l[n.style];
    return s.setAttribute("scriptlevel", o[0]), s.setAttribute("displaystyle", o[1]), s;
  }
});
var vx = function(e, t) {
  var r = e.base;
  if (r)
    if (r.type === "op") {
      var i = r.limits && (t.style.size === ue.DISPLAY.size || r.alwaysHandleSupSub);
      return i ? as : null;
    } else if (r.type === "operatorname") {
      var s = r.alwaysHandleSupSub && (t.style.size === ue.DISPLAY.size || r.limits);
      return s ? H2 : null;
    } else {
      if (r.type === "accent")
        return le.isCharacterBox(r.base) ? Qh : null;
      if (r.type === "horizBrace") {
        var l = !e.sub;
        return l === r.isOver ? I2 : null;
      } else
        return null;
    }
  else return null;
};
vi({
  type: "supsub",
  htmlBuilder(n, e) {
    var t = vx(n, e);
    if (t)
      return t(n, e);
    var {
      base: r,
      sup: i,
      sub: s
    } = n, l = De(r, e), o, a, u = e.fontMetrics(), h = 0, c = 0, f = r && le.isCharacterBox(r);
    if (i) {
      var m = e.havingStyle(e.style.sup());
      o = De(i, m, e), f || (h = l.height - m.fontMetrics().supDrop * m.sizeMultiplier / e.sizeMultiplier);
    }
    if (s) {
      var g = e.havingStyle(e.style.sub());
      a = De(s, g, e), f || (c = l.depth + g.fontMetrics().subDrop * g.sizeMultiplier / e.sizeMultiplier);
    }
    var v;
    e.style === ue.DISPLAY ? v = u.sup1 : e.style.cramped ? v = u.sup3 : v = u.sup2;
    var k = e.sizeMultiplier, S = G(0.5 / u.ptPerEm / k), x = null;
    if (a) {
      var y = n.base && n.base.type === "op" && n.base.name && (n.base.name === "\\oiint" || n.base.name === "\\oiiint");
      (l instanceof Kr || y) && (x = G(-l.italic));
    }
    var A;
    if (o && a) {
      h = Math.max(h, v, o.depth + 0.25 * u.xHeight), c = Math.max(c, u.sub2);
      var C = u.defaultRuleThickness, T = 4 * C;
      if (h - o.depth - (a.height - c) < T) {
        c = T - (h - o.depth) + a.height;
        var M = 0.8 * u.xHeight - (h - o.depth);
        M > 0 && (h += M, c -= M);
      }
      var L = [{
        type: "elem",
        elem: a,
        shift: c,
        marginRight: S,
        marginLeft: x
      }, {
        type: "elem",
        elem: o,
        shift: -h,
        marginRight: S
      }];
      A = O.makeVList({
        positionType: "individualShift",
        children: L
      }, e);
    } else if (a) {
      c = Math.max(c, u.sub1, a.height - 0.8 * u.xHeight);
      var R = [{
        type: "elem",
        elem: a,
        marginLeft: x,
        marginRight: S
      }];
      A = O.makeVList({
        positionType: "shift",
        positionData: c,
        children: R
      }, e);
    } else if (o)
      h = Math.max(h, v, o.depth + 0.25 * u.xHeight), A = O.makeVList({
        positionType: "shift",
        positionData: -h,
        children: [{
          type: "elem",
          elem: o,
          marginRight: S
        }]
      }, e);
    else
      throw new Error("supsub must have either sup or sub.");
    var N = qu(l, "right") || "mord";
    return O.makeSpan([N], [l, O.makeSpan(["msupsub"], [A])], e);
  },
  mathmlBuilder(n, e) {
    var t = !1, r, i;
    n.base && n.base.type === "horizBrace" && (i = !!n.sup, i === n.base.isOver && (t = !0, r = n.base.isOver)), n.base && (n.base.type === "op" || n.base.type === "operatorname") && (n.base.parentIsSupSub = !0);
    var s = [Oe(n.base, e)];
    n.sub && s.push(Oe(n.sub, e)), n.sup && s.push(Oe(n.sup, e));
    var l;
    if (t)
      l = r ? "mover" : "munder";
    else if (n.sub)
      if (n.sup) {
        var u = n.base;
        u && u.type === "op" && u.limits && e.style === ue.DISPLAY || u && u.type === "operatorname" && u.alwaysHandleSupSub && (e.style === ue.DISPLAY || u.limits) ? l = "munderover" : l = "msubsup";
      } else {
        var a = n.base;
        a && a.type === "op" && a.limits && (e.style === ue.DISPLAY || a.alwaysHandleSupSub) || a && a.type === "operatorname" && a.alwaysHandleSupSub && (a.limits || e.style === ue.DISPLAY) ? l = "munder" : l = "msub";
      }
    else {
      var o = n.base;
      o && o.type === "op" && o.limits && (e.style === ue.DISPLAY || o.alwaysHandleSupSub) || o && o.type === "operatorname" && o.alwaysHandleSupSub && (o.limits || e.style === ue.DISPLAY) ? l = "mover" : l = "msup";
    }
    return new V.MathNode(l, s);
  }
});
vi({
  type: "atom",
  htmlBuilder(n, e) {
    return O.mathsym(n.text, n.mode, e, ["m" + n.family]);
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mo", [sr(n.text, n.mode)]);
    if (n.family === "bin") {
      var r = Zh(n, e);
      r === "bold-italic" && t.setAttribute("mathvariant", r);
    } else n.family === "punct" ? t.setAttribute("separator", "true") : (n.family === "open" || n.family === "close") && t.setAttribute("stretchy", "false");
    return t;
  }
});
var V2 = {
  mi: "italic",
  mn: "normal",
  mtext: "normal"
};
vi({
  type: "mathord",
  htmlBuilder(n, e) {
    return O.makeOrd(n, e, "mathord");
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mi", [sr(n.text, n.mode, e)]), r = Zh(n, e) || "italic";
    return r !== V2[t.type] && t.setAttribute("mathvariant", r), t;
  }
});
vi({
  type: "textord",
  htmlBuilder(n, e) {
    return O.makeOrd(n, e, "textord");
  },
  mathmlBuilder(n, e) {
    var t = sr(n.text, n.mode, e), r = Zh(n, e) || "normal", i;
    return n.mode === "text" ? i = new V.MathNode("mtext", [t]) : /[0-9]/.test(n.text) ? i = new V.MathNode("mn", [t]) : n.text === "\\prime" ? i = new V.MathNode("mo", [t]) : i = new V.MathNode("mi", [t]), r !== V2[i.type] && i.setAttribute("mathvariant", r), i;
  }
});
var E0 = {
  "\\nobreak": "nobreak",
  "\\allowbreak": "allowbreak"
}, F0 = {
  " ": {},
  "\\ ": {},
  "~": {
    className: "nobreak"
  },
  "\\space": {},
  "\\nobreakspace": {
    className: "nobreak"
  }
};
vi({
  type: "spacing",
  htmlBuilder(n, e) {
    if (F0.hasOwnProperty(n.text)) {
      var t = F0[n.text].className || "";
      if (n.mode === "text") {
        var r = O.makeOrd(n, e, "textord");
        return r.classes.push(t), r;
      } else
        return O.makeSpan(["mspace", t], [O.mathsym(n.text, n.mode, e)], e);
    } else {
      if (E0.hasOwnProperty(n.text))
        return O.makeSpan(["mspace", E0[n.text]], [], e);
      throw new ie('Unknown type of space "' + n.text + '"');
    }
  },
  mathmlBuilder(n, e) {
    var t;
    if (F0.hasOwnProperty(n.text))
      t = new V.MathNode("mtext", [new V.TextNode(" ")]);
    else {
      if (E0.hasOwnProperty(n.text))
        return new V.MathNode("mspace");
      throw new ie('Unknown type of space "' + n.text + '"');
    }
    return t;
  }
});
var U1 = () => {
  var n = new V.MathNode("mtd", []);
  return n.setAttribute("width", "50%"), n;
};
vi({
  type: "tag",
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mtable", [new V.MathNode("mtr", [U1(), new V.MathNode("mtd", [qn(n.body, e)]), U1(), new V.MathNode("mtd", [qn(n.tag, e)])])]);
    return t.setAttribute("width", "100%"), t;
  }
});
var G1 = {
  "\\text": void 0,
  "\\textrm": "textrm",
  "\\textsf": "textsf",
  "\\texttt": "texttt",
  "\\textnormal": "textrm"
}, j1 = {
  "\\textbf": "textbf",
  "\\textmd": "textmd"
}, yx = {
  "\\textit": "textit",
  "\\textup": "textup"
}, $1 = (n, e) => {
  var t = n.font;
  if (t) {
    if (G1[t])
      return e.withTextFontFamily(G1[t]);
    if (j1[t])
      return e.withTextFontWeight(j1[t]);
    if (t === "\\emph")
      return e.fontShape === "textit" ? e.withTextFontShape("textup") : e.withTextFontShape("textit");
  } else return e;
  return e.withTextFontShape(yx[t]);
};
$({
  type: "text",
  names: [
    // Font families
    "\\text",
    "\\textrm",
    "\\textsf",
    "\\texttt",
    "\\textnormal",
    // Font weights
    "\\textbf",
    "\\textmd",
    // Font Shapes
    "\\textit",
    "\\textup",
    "\\emph"
  ],
  props: {
    numArgs: 1,
    argTypes: ["text"],
    allowedInArgument: !0,
    allowedInText: !0
  },
  handler(n, e) {
    var {
      parser: t,
      funcName: r
    } = n, i = e[0];
    return {
      type: "text",
      mode: t.mode,
      body: Xe(i),
      font: r
    };
  },
  htmlBuilder(n, e) {
    var t = $1(n, e), r = ut(n.body, t, !0);
    return O.makeSpan(["mord", "text"], r, t);
  },
  mathmlBuilder(n, e) {
    var t = $1(n, e);
    return qn(n.body, t);
  }
});
$({
  type: "underline",
  names: ["\\underline"],
  props: {
    numArgs: 1,
    allowedInText: !0
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "underline",
      mode: t.mode,
      body: e[0]
    };
  },
  htmlBuilder(n, e) {
    var t = De(n.body, e), r = O.makeLineSpan("underline-line", e), i = e.fontMetrics().defaultRuleThickness, s = O.makeVList({
      positionType: "top",
      positionData: t.height,
      children: [{
        type: "kern",
        size: i
      }, {
        type: "elem",
        elem: r
      }, {
        type: "kern",
        size: 3 * i
      }, {
        type: "elem",
        elem: t
      }]
    }, e);
    return O.makeSpan(["mord", "underline"], [s], e);
  },
  mathmlBuilder(n, e) {
    var t = new V.MathNode("mo", [new V.TextNode("‾")]);
    t.setAttribute("stretchy", "true");
    var r = new V.MathNode("munder", [Oe(n.body, e), t]);
    return r.setAttribute("accentunder", "true"), r;
  }
});
$({
  type: "vcenter",
  names: ["\\vcenter"],
  props: {
    numArgs: 1,
    argTypes: ["original"],
    // In LaTeX, \vcenter can act only on a box.
    allowedInText: !1
  },
  handler(n, e) {
    var {
      parser: t
    } = n;
    return {
      type: "vcenter",
      mode: t.mode,
      body: e[0]
    };
  },
  htmlBuilder(n, e) {
    var t = De(n.body, e), r = e.fontMetrics().axisHeight, i = 0.5 * (t.height - r - (t.depth + r));
    return O.makeVList({
      positionType: "shift",
      positionData: i,
      children: [{
        type: "elem",
        elem: t
      }]
    }, e);
  },
  mathmlBuilder(n, e) {
    return new V.MathNode("mpadded", [Oe(n.body, e)], ["vcenter"]);
  }
});
$({
  type: "verb",
  names: ["\\verb"],
  props: {
    numArgs: 0,
    allowedInText: !0
  },
  handler(n, e, t) {
    throw new ie("\\verb ended by end of line instead of matching delimiter");
  },
  htmlBuilder(n, e) {
    for (var t = Y1(n), r = [], i = e.havingStyle(e.style.text()), s = 0; s < t.length; s++) {
      var l = t[s];
      l === "~" && (l = "\\textasciitilde"), r.push(O.makeSymbol(l, "Typewriter-Regular", n.mode, i, ["mord", "texttt"]));
    }
    return O.makeSpan(["mord", "text"].concat(i.sizingClasses(e)), O.tryCombineChars(r), i);
  },
  mathmlBuilder(n, e) {
    var t = new V.TextNode(Y1(n)), r = new V.MathNode("mtext", [t]);
    return r.setAttribute("mathvariant", "monospace"), r;
  }
});
var Y1 = (n) => n.body.replace(/ /g, n.star ? "␣" : " "), wx = m2;
w("\\noexpand", function(n) {
  var e = n.popToken();
  return n.isExpandable(e.text) && (e.noexpand = !0, e.treatAsRelax = !0), {
    tokens: [e],
    numArgs: 0
  };
});
w("\\expandafter", function(n) {
  var e = n.popToken();
  return n.expandOnce(!0), {
    tokens: [e],
    numArgs: 0
  };
});
w("\\@firstoftwo", function(n) {
  var e = n.consumeArgs(2);
  return {
    tokens: e[0],
    numArgs: 0
  };
});
w("\\@secondoftwo", function(n) {
  var e = n.consumeArgs(2);
  return {
    tokens: e[1],
    numArgs: 0
  };
});
w("\\@ifnextchar", function(n) {
  var e = n.consumeArgs(3);
  n.consumeSpaces();
  var t = n.future();
  return e[0].length === 1 && e[0][0].text === t.text ? {
    tokens: e[1],
    numArgs: 0
  } : {
    tokens: e[2],
    numArgs: 0
  };
});
w("\\@ifstar", "\\@ifnextchar *{\\@firstoftwo{#1}}");
w("\\TextOrMath", function(n) {
  var e = n.consumeArgs(2);
  return n.mode === "text" ? {
    tokens: e[0],
    numArgs: 0
  } : {
    tokens: e[1],
    numArgs: 0
  };
});
var K1 = {
  0: 0,
  1: 1,
  2: 2,
  3: 3,
  4: 4,
  5: 5,
  6: 6,
  7: 7,
  8: 8,
  9: 9,
  a: 10,
  A: 10,
  b: 11,
  B: 11,
  c: 12,
  C: 12,
  d: 13,
  D: 13,
  e: 14,
  E: 14,
  f: 15,
  F: 15
};
w("\\char", function(n) {
  var e = n.popToken(), t, r = "";
  if (e.text === "'")
    t = 8, e = n.popToken();
  else if (e.text === '"')
    t = 16, e = n.popToken();
  else if (e.text === "`")
    if (e = n.popToken(), e.text[0] === "\\")
      r = e.text.charCodeAt(1);
    else {
      if (e.text === "EOF")
        throw new ie("\\char` missing argument");
      r = e.text.charCodeAt(0);
    }
  else
    t = 10;
  if (t) {
    if (r = K1[e.text], r == null || r >= t)
      throw new ie("Invalid base-" + t + " digit " + e.text);
    for (var i; (i = K1[n.future().text]) != null && i < t; )
      r *= t, r += i, n.popToken();
  }
  return "\\@char{" + r + "}";
});
var oc = (n, e, t) => {
  var r = n.consumeArg().tokens;
  if (r.length !== 1)
    throw new ie("\\newcommand's first argument must be a macro name");
  var i = r[0].text, s = n.isDefined(i);
  if (s && !e)
    throw new ie("\\newcommand{" + i + "} attempting to redefine " + (i + "; use \\renewcommand"));
  if (!s && !t)
    throw new ie("\\renewcommand{" + i + "} when command " + i + " does not yet exist; use \\newcommand");
  var l = 0;
  if (r = n.consumeArg().tokens, r.length === 1 && r[0].text === "[") {
    for (var o = "", a = n.expandNextToken(); a.text !== "]" && a.text !== "EOF"; )
      o += a.text, a = n.expandNextToken();
    if (!o.match(/^\s*[0-9]+\s*$/))
      throw new ie("Invalid number of arguments: " + o);
    l = parseInt(o), r = n.consumeArg().tokens;
  }
  return n.macros.set(i, {
    tokens: r,
    numArgs: l
  }), "";
};
w("\\newcommand", (n) => oc(n, !1, !0));
w("\\renewcommand", (n) => oc(n, !0, !1));
w("\\providecommand", (n) => oc(n, !0, !0));
w("\\message", (n) => {
  var e = n.consumeArgs(1)[0];
  return console.log(e.reverse().map((t) => t.text).join("")), "";
});
w("\\errmessage", (n) => {
  var e = n.consumeArgs(1)[0];
  return console.error(e.reverse().map((t) => t.text).join("")), "";
});
w("\\show", (n) => {
  var e = n.popToken(), t = e.text;
  return console.log(e, n.macros.get(t), wx[t], Ze.math[t], Ze.text[t]), "";
});
w("\\bgroup", "{");
w("\\egroup", "}");
w("~", "\\nobreakspace");
w("\\lq", "`");
w("\\rq", "'");
w("\\aa", "\\r a");
w("\\AA", "\\r A");
w("\\textcopyright", "\\html@mathml{\\textcircled{c}}{\\char`©}");
w("\\copyright", "\\TextOrMath{\\textcopyright}{\\text{\\textcopyright}}");
w("\\textregistered", "\\html@mathml{\\textcircled{\\scriptsize R}}{\\char`®}");
w("ℬ", "\\mathscr{B}");
w("ℰ", "\\mathscr{E}");
w("ℱ", "\\mathscr{F}");
w("ℋ", "\\mathscr{H}");
w("ℐ", "\\mathscr{I}");
w("ℒ", "\\mathscr{L}");
w("ℳ", "\\mathscr{M}");
w("ℛ", "\\mathscr{R}");
w("ℭ", "\\mathfrak{C}");
w("ℌ", "\\mathfrak{H}");
w("ℨ", "\\mathfrak{Z}");
w("\\Bbbk", "\\Bbb{k}");
w("·", "\\cdotp");
w("\\llap", "\\mathllap{\\textrm{#1}}");
w("\\rlap", "\\mathrlap{\\textrm{#1}}");
w("\\clap", "\\mathclap{\\textrm{#1}}");
w("\\mathstrut", "\\vphantom{(}");
w("\\underbar", "\\underline{\\text{#1}}");
w("\\not", '\\html@mathml{\\mathrel{\\mathrlap\\@not}}{\\char"338}');
w("\\neq", "\\html@mathml{\\mathrel{\\not=}}{\\mathrel{\\char`≠}}");
w("\\ne", "\\neq");
w("≠", "\\neq");
w("\\notin", "\\html@mathml{\\mathrel{{\\in}\\mathllap{/\\mskip1mu}}}{\\mathrel{\\char`∉}}");
w("∉", "\\notin");
w("≘", "\\html@mathml{\\mathrel{=\\kern{-1em}\\raisebox{0.4em}{$\\scriptsize\\frown$}}}{\\mathrel{\\char`≘}}");
w("≙", "\\html@mathml{\\stackrel{\\tiny\\wedge}{=}}{\\mathrel{\\char`≘}}");
w("≚", "\\html@mathml{\\stackrel{\\tiny\\vee}{=}}{\\mathrel{\\char`≚}}");
w("≛", "\\html@mathml{\\stackrel{\\scriptsize\\star}{=}}{\\mathrel{\\char`≛}}");
w("≝", "\\html@mathml{\\stackrel{\\tiny\\mathrm{def}}{=}}{\\mathrel{\\char`≝}}");
w("≞", "\\html@mathml{\\stackrel{\\tiny\\mathrm{m}}{=}}{\\mathrel{\\char`≞}}");
w("≟", "\\html@mathml{\\stackrel{\\tiny?}{=}}{\\mathrel{\\char`≟}}");
w("⟂", "\\perp");
w("‼", "\\mathclose{!\\mkern-0.8mu!}");
w("∌", "\\notni");
w("⌜", "\\ulcorner");
w("⌝", "\\urcorner");
w("⌞", "\\llcorner");
w("⌟", "\\lrcorner");
w("©", "\\copyright");
w("®", "\\textregistered");
w("️", "\\textregistered");
w("\\ulcorner", '\\html@mathml{\\@ulcorner}{\\mathop{\\char"231c}}');
w("\\urcorner", '\\html@mathml{\\@urcorner}{\\mathop{\\char"231d}}');
w("\\llcorner", '\\html@mathml{\\@llcorner}{\\mathop{\\char"231e}}');
w("\\lrcorner", '\\html@mathml{\\@lrcorner}{\\mathop{\\char"231f}}');
w("\\vdots", "\\mathord{\\varvdots\\rule{0pt}{15pt}}");
w("⋮", "\\vdots");
w("\\varGamma", "\\mathit{\\Gamma}");
w("\\varDelta", "\\mathit{\\Delta}");
w("\\varTheta", "\\mathit{\\Theta}");
w("\\varLambda", "\\mathit{\\Lambda}");
w("\\varXi", "\\mathit{\\Xi}");
w("\\varPi", "\\mathit{\\Pi}");
w("\\varSigma", "\\mathit{\\Sigma}");
w("\\varUpsilon", "\\mathit{\\Upsilon}");
w("\\varPhi", "\\mathit{\\Phi}");
w("\\varPsi", "\\mathit{\\Psi}");
w("\\varOmega", "\\mathit{\\Omega}");
w("\\substack", "\\begin{subarray}{c}#1\\end{subarray}");
w("\\colon", "\\nobreak\\mskip2mu\\mathpunct{}\\mathchoice{\\mkern-3mu}{\\mkern-3mu}{}{}{:}\\mskip6mu\\relax");
w("\\boxed", "\\fbox{$\\displaystyle{#1}$}");
w("\\iff", "\\DOTSB\\;\\Longleftrightarrow\\;");
w("\\implies", "\\DOTSB\\;\\Longrightarrow\\;");
w("\\impliedby", "\\DOTSB\\;\\Longleftarrow\\;");
var X1 = {
  ",": "\\dotsc",
  "\\not": "\\dotsb",
  // \keybin@ checks for the following:
  "+": "\\dotsb",
  "=": "\\dotsb",
  "<": "\\dotsb",
  ">": "\\dotsb",
  "-": "\\dotsb",
  "*": "\\dotsb",
  ":": "\\dotsb",
  // Symbols whose definition starts with \DOTSB:
  "\\DOTSB": "\\dotsb",
  "\\coprod": "\\dotsb",
  "\\bigvee": "\\dotsb",
  "\\bigwedge": "\\dotsb",
  "\\biguplus": "\\dotsb",
  "\\bigcap": "\\dotsb",
  "\\bigcup": "\\dotsb",
  "\\prod": "\\dotsb",
  "\\sum": "\\dotsb",
  "\\bigotimes": "\\dotsb",
  "\\bigoplus": "\\dotsb",
  "\\bigodot": "\\dotsb",
  "\\bigsqcup": "\\dotsb",
  "\\And": "\\dotsb",
  "\\longrightarrow": "\\dotsb",
  "\\Longrightarrow": "\\dotsb",
  "\\longleftarrow": "\\dotsb",
  "\\Longleftarrow": "\\dotsb",
  "\\longleftrightarrow": "\\dotsb",
  "\\Longleftrightarrow": "\\dotsb",
  "\\mapsto": "\\dotsb",
  "\\longmapsto": "\\dotsb",
  "\\hookrightarrow": "\\dotsb",
  "\\doteq": "\\dotsb",
  // Symbols whose definition starts with \mathbin:
  "\\mathbin": "\\dotsb",
  // Symbols whose definition starts with \mathrel:
  "\\mathrel": "\\dotsb",
  "\\relbar": "\\dotsb",
  "\\Relbar": "\\dotsb",
  "\\xrightarrow": "\\dotsb",
  "\\xleftarrow": "\\dotsb",
  // Symbols whose definition starts with \DOTSI:
  "\\DOTSI": "\\dotsi",
  "\\int": "\\dotsi",
  "\\oint": "\\dotsi",
  "\\iint": "\\dotsi",
  "\\iiint": "\\dotsi",
  "\\iiiint": "\\dotsi",
  "\\idotsint": "\\dotsi",
  // Symbols whose definition starts with \DOTSX:
  "\\DOTSX": "\\dotsx"
};
w("\\dots", function(n) {
  var e = "\\dotso", t = n.expandAfterFuture().text;
  return t in X1 ? e = X1[t] : (t.slice(0, 4) === "\\not" || t in Ze.math && le.contains(["bin", "rel"], Ze.math[t].group)) && (e = "\\dotsb"), e;
});
var ac = {
  // \rightdelim@ checks for the following:
  ")": !0,
  "]": !0,
  "\\rbrack": !0,
  "\\}": !0,
  "\\rbrace": !0,
  "\\rangle": !0,
  "\\rceil": !0,
  "\\rfloor": !0,
  "\\rgroup": !0,
  "\\rmoustache": !0,
  "\\right": !0,
  "\\bigr": !0,
  "\\biggr": !0,
  "\\Bigr": !0,
  "\\Biggr": !0,
  // \extra@ also tests for the following:
  $: !0,
  // \extrap@ checks for the following:
  ";": !0,
  ".": !0,
  ",": !0
};
w("\\dotso", function(n) {
  var e = n.future().text;
  return e in ac ? "\\ldots\\," : "\\ldots";
});
w("\\dotsc", function(n) {
  var e = n.future().text;
  return e in ac && e !== "," ? "\\ldots\\," : "\\ldots";
});
w("\\cdots", function(n) {
  var e = n.future().text;
  return e in ac ? "\\@cdots\\," : "\\@cdots";
});
w("\\dotsb", "\\cdots");
w("\\dotsm", "\\cdots");
w("\\dotsi", "\\!\\cdots");
w("\\dotsx", "\\ldots\\,");
w("\\DOTSI", "\\relax");
w("\\DOTSB", "\\relax");
w("\\DOTSX", "\\relax");
w("\\tmspace", "\\TextOrMath{\\kern#1#3}{\\mskip#1#2}\\relax");
w("\\,", "\\tmspace+{3mu}{.1667em}");
w("\\thinspace", "\\,");
w("\\>", "\\mskip{4mu}");
w("\\:", "\\tmspace+{4mu}{.2222em}");
w("\\medspace", "\\:");
w("\\;", "\\tmspace+{5mu}{.2777em}");
w("\\thickspace", "\\;");
w("\\!", "\\tmspace-{3mu}{.1667em}");
w("\\negthinspace", "\\!");
w("\\negmedspace", "\\tmspace-{4mu}{.2222em}");
w("\\negthickspace", "\\tmspace-{5mu}{.277em}");
w("\\enspace", "\\kern.5em ");
w("\\enskip", "\\hskip.5em\\relax");
w("\\quad", "\\hskip1em\\relax");
w("\\qquad", "\\hskip2em\\relax");
w("\\tag", "\\@ifstar\\tag@literal\\tag@paren");
w("\\tag@paren", "\\tag@literal{({#1})}");
w("\\tag@literal", (n) => {
  if (n.macros.get("\\df@tag"))
    throw new ie("Multiple \\tag");
  return "\\gdef\\df@tag{\\text{#1}}";
});
w("\\bmod", "\\mathchoice{\\mskip1mu}{\\mskip1mu}{\\mskip5mu}{\\mskip5mu}\\mathbin{\\rm mod}\\mathchoice{\\mskip1mu}{\\mskip1mu}{\\mskip5mu}{\\mskip5mu}");
w("\\pod", "\\allowbreak\\mathchoice{\\mkern18mu}{\\mkern8mu}{\\mkern8mu}{\\mkern8mu}(#1)");
w("\\pmod", "\\pod{{\\rm mod}\\mkern6mu#1}");
w("\\mod", "\\allowbreak\\mathchoice{\\mkern18mu}{\\mkern12mu}{\\mkern12mu}{\\mkern12mu}{\\rm mod}\\,\\,#1");
w("\\newline", "\\\\\\relax");
w("\\TeX", "\\textrm{\\html@mathml{T\\kern-.1667em\\raisebox{-.5ex}{E}\\kern-.125emX}{TeX}}");
var W2 = G(un["Main-Regular"][84][1] - 0.7 * un["Main-Regular"][65][1]);
w("\\LaTeX", "\\textrm{\\html@mathml{" + ("L\\kern-.36em\\raisebox{" + W2 + "}{\\scriptstyle A}") + "\\kern-.15em\\TeX}{LaTeX}}");
w("\\KaTeX", "\\textrm{\\html@mathml{" + ("K\\kern-.17em\\raisebox{" + W2 + "}{\\scriptstyle A}") + "\\kern-.15em\\TeX}{KaTeX}}");
w("\\hspace", "\\@ifstar\\@hspacer\\@hspace");
w("\\@hspace", "\\hskip #1\\relax");
w("\\@hspacer", "\\rule{0pt}{0pt}\\hskip #1\\relax");
w("\\ordinarycolon", ":");
w("\\vcentcolon", "\\mathrel{\\mathop\\ordinarycolon}");
w("\\dblcolon", '\\html@mathml{\\mathrel{\\vcentcolon\\mathrel{\\mkern-.9mu}\\vcentcolon}}{\\mathop{\\char"2237}}');
w("\\coloneqq", '\\html@mathml{\\mathrel{\\vcentcolon\\mathrel{\\mkern-1.2mu}=}}{\\mathop{\\char"2254}}');
w("\\Coloneqq", '\\html@mathml{\\mathrel{\\dblcolon\\mathrel{\\mkern-1.2mu}=}}{\\mathop{\\char"2237\\char"3d}}');
w("\\coloneq", '\\html@mathml{\\mathrel{\\vcentcolon\\mathrel{\\mkern-1.2mu}\\mathrel{-}}}{\\mathop{\\char"3a\\char"2212}}');
w("\\Coloneq", '\\html@mathml{\\mathrel{\\dblcolon\\mathrel{\\mkern-1.2mu}\\mathrel{-}}}{\\mathop{\\char"2237\\char"2212}}');
w("\\eqqcolon", '\\html@mathml{\\mathrel{=\\mathrel{\\mkern-1.2mu}\\vcentcolon}}{\\mathop{\\char"2255}}');
w("\\Eqqcolon", '\\html@mathml{\\mathrel{=\\mathrel{\\mkern-1.2mu}\\dblcolon}}{\\mathop{\\char"3d\\char"2237}}');
w("\\eqcolon", '\\html@mathml{\\mathrel{\\mathrel{-}\\mathrel{\\mkern-1.2mu}\\vcentcolon}}{\\mathop{\\char"2239}}');
w("\\Eqcolon", '\\html@mathml{\\mathrel{\\mathrel{-}\\mathrel{\\mkern-1.2mu}\\dblcolon}}{\\mathop{\\char"2212\\char"2237}}');
w("\\colonapprox", '\\html@mathml{\\mathrel{\\vcentcolon\\mathrel{\\mkern-1.2mu}\\approx}}{\\mathop{\\char"3a\\char"2248}}');
w("\\Colonapprox", '\\html@mathml{\\mathrel{\\dblcolon\\mathrel{\\mkern-1.2mu}\\approx}}{\\mathop{\\char"2237\\char"2248}}');
w("\\colonsim", '\\html@mathml{\\mathrel{\\vcentcolon\\mathrel{\\mkern-1.2mu}\\sim}}{\\mathop{\\char"3a\\char"223c}}');
w("\\Colonsim", '\\html@mathml{\\mathrel{\\dblcolon\\mathrel{\\mkern-1.2mu}\\sim}}{\\mathop{\\char"2237\\char"223c}}');
w("∷", "\\dblcolon");
w("∹", "\\eqcolon");
w("≔", "\\coloneqq");
w("≕", "\\eqqcolon");
w("⩴", "\\Coloneqq");
w("\\ratio", "\\vcentcolon");
w("\\coloncolon", "\\dblcolon");
w("\\colonequals", "\\coloneqq");
w("\\coloncolonequals", "\\Coloneqq");
w("\\equalscolon", "\\eqqcolon");
w("\\equalscoloncolon", "\\Eqqcolon");
w("\\colonminus", "\\coloneq");
w("\\coloncolonminus", "\\Coloneq");
w("\\minuscolon", "\\eqcolon");
w("\\minuscoloncolon", "\\Eqcolon");
w("\\coloncolonapprox", "\\Colonapprox");
w("\\coloncolonsim", "\\Colonsim");
w("\\simcolon", "\\mathrel{\\sim\\mathrel{\\mkern-1.2mu}\\vcentcolon}");
w("\\simcoloncolon", "\\mathrel{\\sim\\mathrel{\\mkern-1.2mu}\\dblcolon}");
w("\\approxcolon", "\\mathrel{\\approx\\mathrel{\\mkern-1.2mu}\\vcentcolon}");
w("\\approxcoloncolon", "\\mathrel{\\approx\\mathrel{\\mkern-1.2mu}\\dblcolon}");
w("\\notni", "\\html@mathml{\\not\\ni}{\\mathrel{\\char`∌}}");
w("\\limsup", "\\DOTSB\\operatorname*{lim\\,sup}");
w("\\liminf", "\\DOTSB\\operatorname*{lim\\,inf}");
w("\\injlim", "\\DOTSB\\operatorname*{inj\\,lim}");
w("\\projlim", "\\DOTSB\\operatorname*{proj\\,lim}");
w("\\varlimsup", "\\DOTSB\\operatorname*{\\overline{lim}}");
w("\\varliminf", "\\DOTSB\\operatorname*{\\underline{lim}}");
w("\\varinjlim", "\\DOTSB\\operatorname*{\\underrightarrow{lim}}");
w("\\varprojlim", "\\DOTSB\\operatorname*{\\underleftarrow{lim}}");
w("\\gvertneqq", "\\html@mathml{\\@gvertneqq}{≩}");
w("\\lvertneqq", "\\html@mathml{\\@lvertneqq}{≨}");
w("\\ngeqq", "\\html@mathml{\\@ngeqq}{≱}");
w("\\ngeqslant", "\\html@mathml{\\@ngeqslant}{≱}");
w("\\nleqq", "\\html@mathml{\\@nleqq}{≰}");
w("\\nleqslant", "\\html@mathml{\\@nleqslant}{≰}");
w("\\nshortmid", "\\html@mathml{\\@nshortmid}{∤}");
w("\\nshortparallel", "\\html@mathml{\\@nshortparallel}{∦}");
w("\\nsubseteqq", "\\html@mathml{\\@nsubseteqq}{⊈}");
w("\\nsupseteqq", "\\html@mathml{\\@nsupseteqq}{⊉}");
w("\\varsubsetneq", "\\html@mathml{\\@varsubsetneq}{⊊}");
w("\\varsubsetneqq", "\\html@mathml{\\@varsubsetneqq}{⫋}");
w("\\varsupsetneq", "\\html@mathml{\\@varsupsetneq}{⊋}");
w("\\varsupsetneqq", "\\html@mathml{\\@varsupsetneqq}{⫌}");
w("\\imath", "\\html@mathml{\\@imath}{ı}");
w("\\jmath", "\\html@mathml{\\@jmath}{ȷ}");
w("\\llbracket", "\\html@mathml{\\mathopen{[\\mkern-3.2mu[}}{\\mathopen{\\char`⟦}}");
w("\\rrbracket", "\\html@mathml{\\mathclose{]\\mkern-3.2mu]}}{\\mathclose{\\char`⟧}}");
w("⟦", "\\llbracket");
w("⟧", "\\rrbracket");
w("\\lBrace", "\\html@mathml{\\mathopen{\\{\\mkern-3.2mu[}}{\\mathopen{\\char`⦃}}");
w("\\rBrace", "\\html@mathml{\\mathclose{]\\mkern-3.2mu\\}}}{\\mathclose{\\char`⦄}}");
w("⦃", "\\lBrace");
w("⦄", "\\rBrace");
w("\\minuso", "\\mathbin{\\html@mathml{{\\mathrlap{\\mathchoice{\\kern{0.145em}}{\\kern{0.145em}}{\\kern{0.1015em}}{\\kern{0.0725em}}\\circ}{-}}}{\\char`⦵}}");
w("⦵", "\\minuso");
w("\\darr", "\\downarrow");
w("\\dArr", "\\Downarrow");
w("\\Darr", "\\Downarrow");
w("\\lang", "\\langle");
w("\\rang", "\\rangle");
w("\\uarr", "\\uparrow");
w("\\uArr", "\\Uparrow");
w("\\Uarr", "\\Uparrow");
w("\\N", "\\mathbb{N}");
w("\\R", "\\mathbb{R}");
w("\\Z", "\\mathbb{Z}");
w("\\alef", "\\aleph");
w("\\alefsym", "\\aleph");
w("\\Alpha", "\\mathrm{A}");
w("\\Beta", "\\mathrm{B}");
w("\\bull", "\\bullet");
w("\\Chi", "\\mathrm{X}");
w("\\clubs", "\\clubsuit");
w("\\cnums", "\\mathbb{C}");
w("\\Complex", "\\mathbb{C}");
w("\\Dagger", "\\ddagger");
w("\\diamonds", "\\diamondsuit");
w("\\empty", "\\emptyset");
w("\\Epsilon", "\\mathrm{E}");
w("\\Eta", "\\mathrm{H}");
w("\\exist", "\\exists");
w("\\harr", "\\leftrightarrow");
w("\\hArr", "\\Leftrightarrow");
w("\\Harr", "\\Leftrightarrow");
w("\\hearts", "\\heartsuit");
w("\\image", "\\Im");
w("\\infin", "\\infty");
w("\\Iota", "\\mathrm{I}");
w("\\isin", "\\in");
w("\\Kappa", "\\mathrm{K}");
w("\\larr", "\\leftarrow");
w("\\lArr", "\\Leftarrow");
w("\\Larr", "\\Leftarrow");
w("\\lrarr", "\\leftrightarrow");
w("\\lrArr", "\\Leftrightarrow");
w("\\Lrarr", "\\Leftrightarrow");
w("\\Mu", "\\mathrm{M}");
w("\\natnums", "\\mathbb{N}");
w("\\Nu", "\\mathrm{N}");
w("\\Omicron", "\\mathrm{O}");
w("\\plusmn", "\\pm");
w("\\rarr", "\\rightarrow");
w("\\rArr", "\\Rightarrow");
w("\\Rarr", "\\Rightarrow");
w("\\real", "\\Re");
w("\\reals", "\\mathbb{R}");
w("\\Reals", "\\mathbb{R}");
w("\\Rho", "\\mathrm{P}");
w("\\sdot", "\\cdot");
w("\\sect", "\\S");
w("\\spades", "\\spadesuit");
w("\\sub", "\\subset");
w("\\sube", "\\subseteq");
w("\\supe", "\\supseteq");
w("\\Tau", "\\mathrm{T}");
w("\\thetasym", "\\vartheta");
w("\\weierp", "\\wp");
w("\\Zeta", "\\mathrm{Z}");
w("\\argmin", "\\DOTSB\\operatorname*{arg\\,min}");
w("\\argmax", "\\DOTSB\\operatorname*{arg\\,max}");
w("\\plim", "\\DOTSB\\mathop{\\operatorname{plim}}\\limits");
w("\\bra", "\\mathinner{\\langle{#1}|}");
w("\\ket", "\\mathinner{|{#1}\\rangle}");
w("\\braket", "\\mathinner{\\langle{#1}\\rangle}");
w("\\Bra", "\\left\\langle#1\\right|");
w("\\Ket", "\\left|#1\\right\\rangle");
var U2 = (n) => (e) => {
  var t = e.consumeArg().tokens, r = e.consumeArg().tokens, i = e.consumeArg().tokens, s = e.consumeArg().tokens, l = e.macros.get("|"), o = e.macros.get("\\|");
  e.macros.beginGroup();
  var a = (c) => (f) => {
    n && (f.macros.set("|", l), i.length && f.macros.set("\\|", o));
    var m = c;
    if (!c && i.length) {
      var g = f.future();
      g.text === "|" && (f.popToken(), m = !0);
    }
    return {
      tokens: m ? i : r,
      numArgs: 0
    };
  };
  e.macros.set("|", a(!1)), i.length && e.macros.set("\\|", a(!0));
  var u = e.consumeArg().tokens, h = e.expandTokens([
    ...s,
    ...u,
    ...t
    // reversed
  ]);
  return e.macros.endGroup(), {
    tokens: h.reverse(),
    numArgs: 0
  };
};
w("\\bra@ket", U2(!1));
w("\\bra@set", U2(!0));
w("\\Braket", "\\bra@ket{\\left\\langle}{\\,\\middle\\vert\\,}{\\,\\middle\\vert\\,}{\\right\\rangle}");
w("\\Set", "\\bra@set{\\left\\{\\:}{\\;\\middle\\vert\\;}{\\;\\middle\\Vert\\;}{\\:\\right\\}}");
w("\\set", "\\bra@set{\\{\\,}{\\mid}{}{\\,\\}}");
w("\\angln", "{\\angl n}");
w("\\blue", "\\textcolor{##6495ed}{#1}");
w("\\orange", "\\textcolor{##ffa500}{#1}");
w("\\pink", "\\textcolor{##ff00af}{#1}");
w("\\red", "\\textcolor{##df0030}{#1}");
w("\\green", "\\textcolor{##28ae7b}{#1}");
w("\\gray", "\\textcolor{gray}{#1}");
w("\\purple", "\\textcolor{##9d38bd}{#1}");
w("\\blueA", "\\textcolor{##ccfaff}{#1}");
w("\\blueB", "\\textcolor{##80f6ff}{#1}");
w("\\blueC", "\\textcolor{##63d9ea}{#1}");
w("\\blueD", "\\textcolor{##11accd}{#1}");
w("\\blueE", "\\textcolor{##0c7f99}{#1}");
w("\\tealA", "\\textcolor{##94fff5}{#1}");
w("\\tealB", "\\textcolor{##26edd5}{#1}");
w("\\tealC", "\\textcolor{##01d1c1}{#1}");
w("\\tealD", "\\textcolor{##01a995}{#1}");
w("\\tealE", "\\textcolor{##208170}{#1}");
w("\\greenA", "\\textcolor{##b6ffb0}{#1}");
w("\\greenB", "\\textcolor{##8af281}{#1}");
w("\\greenC", "\\textcolor{##74cf70}{#1}");
w("\\greenD", "\\textcolor{##1fab54}{#1}");
w("\\greenE", "\\textcolor{##0d923f}{#1}");
w("\\goldA", "\\textcolor{##ffd0a9}{#1}");
w("\\goldB", "\\textcolor{##ffbb71}{#1}");
w("\\goldC", "\\textcolor{##ff9c39}{#1}");
w("\\goldD", "\\textcolor{##e07d10}{#1}");
w("\\goldE", "\\textcolor{##a75a05}{#1}");
w("\\redA", "\\textcolor{##fca9a9}{#1}");
w("\\redB", "\\textcolor{##ff8482}{#1}");
w("\\redC", "\\textcolor{##f9685d}{#1}");
w("\\redD", "\\textcolor{##e84d39}{#1}");
w("\\redE", "\\textcolor{##bc2612}{#1}");
w("\\maroonA", "\\textcolor{##ffbde0}{#1}");
w("\\maroonB", "\\textcolor{##ff92c6}{#1}");
w("\\maroonC", "\\textcolor{##ed5fa6}{#1}");
w("\\maroonD", "\\textcolor{##ca337c}{#1}");
w("\\maroonE", "\\textcolor{##9e034e}{#1}");
w("\\purpleA", "\\textcolor{##ddd7ff}{#1}");
w("\\purpleB", "\\textcolor{##c6b9fc}{#1}");
w("\\purpleC", "\\textcolor{##aa87ff}{#1}");
w("\\purpleD", "\\textcolor{##7854ab}{#1}");
w("\\purpleE", "\\textcolor{##543b78}{#1}");
w("\\mintA", "\\textcolor{##f5f9e8}{#1}");
w("\\mintB", "\\textcolor{##edf2df}{#1}");
w("\\mintC", "\\textcolor{##e0e5cc}{#1}");
w("\\grayA", "\\textcolor{##f6f7f7}{#1}");
w("\\grayB", "\\textcolor{##f0f1f2}{#1}");
w("\\grayC", "\\textcolor{##e3e5e6}{#1}");
w("\\grayD", "\\textcolor{##d6d8da}{#1}");
w("\\grayE", "\\textcolor{##babec2}{#1}");
w("\\grayF", "\\textcolor{##888d93}{#1}");
w("\\grayG", "\\textcolor{##626569}{#1}");
w("\\grayH", "\\textcolor{##3b3e40}{#1}");
w("\\grayI", "\\textcolor{##21242c}{#1}");
w("\\kaBlue", "\\textcolor{##314453}{#1}");
w("\\kaGreen", "\\textcolor{##71B307}{#1}");
typeof document < "u" && document.compatMode !== "CSS1Compat" && typeof console < "u" && console.warn("Warning: KaTeX doesn't work in quirks mode. Make sure your website has a suitable doctype.");
function uc() {
  return {
    async: !1,
    breaks: !1,
    extensions: null,
    gfm: !0,
    hooks: null,
    pedantic: !1,
    renderer: null,
    silent: !1,
    tokenizer: null,
    walkTokens: null
  };
}
let yi = uc();
function G2(n) {
  yi = n;
}
const j2 = /[&<>"']/, kx = new RegExp(j2.source, "g"), $2 = /[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/, xx = new RegExp($2.source, "g"), Sx = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;"
}, Z1 = (n) => Sx[n];
function zt(n, e) {
  if (e) {
    if (j2.test(n))
      return n.replace(kx, Z1);
  } else if ($2.test(n))
    return n.replace(xx, Z1);
  return n;
}
const Ax = /&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;
function Dx(n) {
  return n.replace(Ax, (e, t) => (t = t.toLowerCase(), t === "colon" ? ":" : t.charAt(0) === "#" ? t.charAt(1) === "x" ? String.fromCharCode(parseInt(t.substring(2), 16)) : String.fromCharCode(+t.substring(1)) : ""));
}
const Cx = /(^|[^\[])\^/g;
function Ee(n, e) {
  let t = typeof n == "string" ? n : n.source;
  e = e || "";
  const r = {
    replace: (i, s) => {
      let l = typeof s == "string" ? s : s.source;
      return l = l.replace(Cx, "$1"), t = t.replace(i, l), r;
    },
    getRegex: () => new RegExp(t, e)
  };
  return r;
}
function J1(n) {
  try {
    n = encodeURI(n).replace(/%25/g, "%");
  } catch {
    return null;
  }
  return n;
}
const Us = { exec: () => null };
function Q1(n, e) {
  const t = n.replace(/\|/g, (s, l, o) => {
    let a = !1, u = l;
    for (; --u >= 0 && o[u] === "\\"; )
      a = !a;
    return a ? "|" : " |";
  }), r = t.split(/ \|/);
  let i = 0;
  if (r[0].trim() || r.shift(), r.length > 0 && !r[r.length - 1].trim() && r.pop(), e)
    if (r.length > e)
      r.splice(e);
    else
      for (; r.length < e; )
        r.push("");
  for (; i < r.length; i++)
    r[i] = r[i].trim().replace(/\\\|/g, "|");
  return r;
}
function no(n, e, t) {
  const r = n.length;
  if (r === 0)
    return "";
  let i = 0;
  for (; i < r; ) {
    const s = n.charAt(r - i - 1);
    if (s === e && !t)
      i++;
    else if (s !== e && t)
      i++;
    else
      break;
  }
  return n.slice(0, r - i);
}
function _x(n, e) {
  if (n.indexOf(e[1]) === -1)
    return -1;
  let t = 0;
  for (let r = 0; r < n.length; r++)
    if (n[r] === "\\")
      r++;
    else if (n[r] === e[0])
      t++;
    else if (n[r] === e[1] && (t--, t < 0))
      return r;
  return -1;
}
function em(n, e, t, r) {
  const i = e.href, s = e.title ? zt(e.title) : null, l = n[1].replace(/\\([\[\]])/g, "$1");
  if (n[0].charAt(0) !== "!") {
    r.state.inLink = !0;
    const o = {
      type: "link",
      raw: t,
      href: i,
      title: s,
      text: l,
      tokens: r.inlineTokens(l)
    };
    return r.state.inLink = !1, o;
  }
  return {
    type: "image",
    raw: t,
    href: i,
    title: s,
    text: zt(l)
  };
}
function Mx(n, e) {
  const t = n.match(/^(\s+)(?:```)/);
  if (t === null)
    return e;
  const r = t[1];
  return e.split(`
`).map((i) => {
    const s = i.match(/^\s+/);
    if (s === null)
      return i;
    const [l] = s;
    return l.length >= r.length ? i.slice(r.length) : i;
  }).join(`
`);
}
class ea {
  options;
  rules;
  // set by the lexer
  lexer;
  // set by the lexer
  constructor(e) {
    this.options = e || yi;
  }
  space(e) {
    const t = this.rules.block.newline.exec(e);
    if (t && t[0].length > 0)
      return {
        type: "space",
        raw: t[0]
      };
  }
  code(e) {
    const t = this.rules.block.code.exec(e);
    if (t) {
      const r = t[0].replace(/^ {1,4}/gm, "");
      return {
        type: "code",
        raw: t[0],
        codeBlockStyle: "indented",
        text: this.options.pedantic ? r : no(r, `
`)
      };
    }
  }
  fences(e) {
    const t = this.rules.block.fences.exec(e);
    if (t) {
      const r = t[0], i = Mx(r, t[3] || "");
      return {
        type: "code",
        raw: r,
        lang: t[2] ? t[2].trim().replace(this.rules.inline.anyPunctuation, "$1") : t[2],
        text: i
      };
    }
  }
  heading(e) {
    const t = this.rules.block.heading.exec(e);
    if (t) {
      let r = t[2].trim();
      if (/#$/.test(r)) {
        const i = no(r, "#");
        (this.options.pedantic || !i || / $/.test(i)) && (r = i.trim());
      }
      return {
        type: "heading",
        raw: t[0],
        depth: t[1].length,
        text: r,
        tokens: this.lexer.inline(r)
      };
    }
  }
  hr(e) {
    const t = this.rules.block.hr.exec(e);
    if (t)
      return {
        type: "hr",
        raw: t[0]
      };
  }
  blockquote(e) {
    const t = this.rules.block.blockquote.exec(e);
    if (t) {
      let r = t[0].replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g, `
    $1`);
      r = no(r.replace(/^ *>[ \t]?/gm, ""), `
`);
      const i = this.lexer.state.top;
      this.lexer.state.top = !0;
      const s = this.lexer.blockTokens(r);
      return this.lexer.state.top = i, {
        type: "blockquote",
        raw: t[0],
        tokens: s,
        text: r
      };
    }
  }
  list(e) {
    let t = this.rules.block.list.exec(e);
    if (t) {
      let r = t[1].trim();
      const i = r.length > 1, s = {
        type: "list",
        raw: "",
        ordered: i,
        start: i ? +r.slice(0, -1) : "",
        loose: !1,
        items: []
      };
      r = i ? `\\d{1,9}\\${r.slice(-1)}` : `\\${r}`, this.options.pedantic && (r = i ? r : "[*+-]");
      const l = new RegExp(`^( {0,3}${r})((?:[	 ][^\\n]*)?(?:\\n|$))`);
      let o = "", a = "", u = !1;
      for (; e; ) {
        let h = !1;
        if (!(t = l.exec(e)) || this.rules.block.hr.test(e))
          break;
        o = t[0], e = e.substring(o.length);
        let c = t[2].split(`
`, 1)[0].replace(/^\t+/, (S) => " ".repeat(3 * S.length)), f = e.split(`
`, 1)[0], m = 0;
        this.options.pedantic ? (m = 2, a = c.trimStart()) : (m = t[2].search(/[^ ]/), m = m > 4 ? 1 : m, a = c.slice(m), m += t[1].length);
        let g = !1;
        if (!c && /^ *$/.test(f) && (o += f + `
`, e = e.substring(f.length + 1), h = !0), !h) {
          const S = new RegExp(`^ {0,${Math.min(3, m - 1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`), x = new RegExp(`^ {0,${Math.min(3, m - 1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`), y = new RegExp(`^ {0,${Math.min(3, m - 1)}}(?:\`\`\`|~~~)`), A = new RegExp(`^ {0,${Math.min(3, m - 1)}}#`);
          for (; e; ) {
            const C = e.split(`
`, 1)[0];
            if (f = C, this.options.pedantic && (f = f.replace(/^ {1,4}(?=( {4})*[^ ])/g, "  ")), y.test(f) || A.test(f) || S.test(f) || x.test(e))
              break;
            if (f.search(/[^ ]/) >= m || !f.trim())
              a += `
` + f.slice(m);
            else {
              if (g || c.search(/[^ ]/) >= 4 || y.test(c) || A.test(c) || x.test(c))
                break;
              a += `
` + f;
            }
            !g && !f.trim() && (g = !0), o += C + `
`, e = e.substring(C.length + 1), c = f.slice(m);
          }
        }
        s.loose || (u ? s.loose = !0 : /\n *\n *$/.test(o) && (u = !0));
        let v = null, k;
        this.options.gfm && (v = /^\[[ xX]\] /.exec(a), v && (k = v[0] !== "[ ] ", a = a.replace(/^\[[ xX]\] +/, ""))), s.items.push({
          type: "list_item",
          raw: o,
          task: !!v,
          checked: k,
          loose: !1,
          text: a,
          tokens: []
        }), s.raw += o;
      }
      s.items[s.items.length - 1].raw = o.trimEnd(), s.items[s.items.length - 1].text = a.trimEnd(), s.raw = s.raw.trimEnd();
      for (let h = 0; h < s.items.length; h++)
        if (this.lexer.state.top = !1, s.items[h].tokens = this.lexer.blockTokens(s.items[h].text, []), !s.loose) {
          const c = s.items[h].tokens.filter((m) => m.type === "space"), f = c.length > 0 && c.some((m) => /\n.*\n/.test(m.raw));
          s.loose = f;
        }
      if (s.loose)
        for (let h = 0; h < s.items.length; h++)
          s.items[h].loose = !0;
      return s;
    }
  }
  html(e) {
    const t = this.rules.block.html.exec(e);
    if (t)
      return {
        type: "html",
        block: !0,
        raw: t[0],
        pre: t[1] === "pre" || t[1] === "script" || t[1] === "style",
        text: t[0]
      };
  }
  def(e) {
    const t = this.rules.block.def.exec(e);
    if (t) {
      const r = t[1].toLowerCase().replace(/\s+/g, " "), i = t[2] ? t[2].replace(/^<(.*)>$/, "$1").replace(this.rules.inline.anyPunctuation, "$1") : "", s = t[3] ? t[3].substring(1, t[3].length - 1).replace(this.rules.inline.anyPunctuation, "$1") : t[3];
      return {
        type: "def",
        tag: r,
        raw: t[0],
        href: i,
        title: s
      };
    }
  }
  table(e) {
    const t = this.rules.block.table.exec(e);
    if (!t || !/[:|]/.test(t[2]))
      return;
    const r = Q1(t[1]), i = t[2].replace(/^\||\| *$/g, "").split("|"), s = t[3] && t[3].trim() ? t[3].replace(/\n[ \t]*$/, "").split(`
`) : [], l = {
      type: "table",
      raw: t[0],
      header: [],
      align: [],
      rows: []
    };
    if (r.length === i.length) {
      for (const o of i)
        /^ *-+: *$/.test(o) ? l.align.push("right") : /^ *:-+: *$/.test(o) ? l.align.push("center") : /^ *:-+ *$/.test(o) ? l.align.push("left") : l.align.push(null);
      for (const o of r)
        l.header.push({
          text: o,
          tokens: this.lexer.inline(o)
        });
      for (const o of s)
        l.rows.push(Q1(o, l.header.length).map((a) => ({
          text: a,
          tokens: this.lexer.inline(a)
        })));
      return l;
    }
  }
  lheading(e) {
    const t = this.rules.block.lheading.exec(e);
    if (t)
      return {
        type: "heading",
        raw: t[0],
        depth: t[2].charAt(0) === "=" ? 1 : 2,
        text: t[1],
        tokens: this.lexer.inline(t[1])
      };
  }
  paragraph(e) {
    const t = this.rules.block.paragraph.exec(e);
    if (t) {
      const r = t[1].charAt(t[1].length - 1) === `
` ? t[1].slice(0, -1) : t[1];
      return {
        type: "paragraph",
        raw: t[0],
        text: r,
        tokens: this.lexer.inline(r)
      };
    }
  }
  text(e) {
    const t = this.rules.block.text.exec(e);
    if (t)
      return {
        type: "text",
        raw: t[0],
        text: t[0],
        tokens: this.lexer.inline(t[0])
      };
  }
  escape(e) {
    const t = this.rules.inline.escape.exec(e);
    if (t)
      return {
        type: "escape",
        raw: t[0],
        text: zt(t[1])
      };
  }
  tag(e) {
    const t = this.rules.inline.tag.exec(e);
    if (t)
      return !this.lexer.state.inLink && /^<a /i.test(t[0]) ? this.lexer.state.inLink = !0 : this.lexer.state.inLink && /^<\/a>/i.test(t[0]) && (this.lexer.state.inLink = !1), !this.lexer.state.inRawBlock && /^<(pre|code|kbd|script)(\s|>)/i.test(t[0]) ? this.lexer.state.inRawBlock = !0 : this.lexer.state.inRawBlock && /^<\/(pre|code|kbd|script)(\s|>)/i.test(t[0]) && (this.lexer.state.inRawBlock = !1), {
        type: "html",
        raw: t[0],
        inLink: this.lexer.state.inLink,
        inRawBlock: this.lexer.state.inRawBlock,
        block: !1,
        text: t[0]
      };
  }
  link(e) {
    const t = this.rules.inline.link.exec(e);
    if (t) {
      const r = t[2].trim();
      if (!this.options.pedantic && /^</.test(r)) {
        if (!/>$/.test(r))
          return;
        const l = no(r.slice(0, -1), "\\");
        if ((r.length - l.length) % 2 === 0)
          return;
      } else {
        const l = _x(t[2], "()");
        if (l > -1) {
          const a = (t[0].indexOf("!") === 0 ? 5 : 4) + t[1].length + l;
          t[2] = t[2].substring(0, l), t[0] = t[0].substring(0, a).trim(), t[3] = "";
        }
      }
      let i = t[2], s = "";
      if (this.options.pedantic) {
        const l = /^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(i);
        l && (i = l[1], s = l[3]);
      } else
        s = t[3] ? t[3].slice(1, -1) : "";
      return i = i.trim(), /^</.test(i) && (this.options.pedantic && !/>$/.test(r) ? i = i.slice(1) : i = i.slice(1, -1)), em(t, {
        href: i && i.replace(this.rules.inline.anyPunctuation, "$1"),
        title: s && s.replace(this.rules.inline.anyPunctuation, "$1")
      }, t[0], this.lexer);
    }
  }
  reflink(e, t) {
    let r;
    if ((r = this.rules.inline.reflink.exec(e)) || (r = this.rules.inline.nolink.exec(e))) {
      const i = (r[2] || r[1]).replace(/\s+/g, " "), s = t[i.toLowerCase()];
      if (!s) {
        const l = r[0].charAt(0);
        return {
          type: "text",
          raw: l,
          text: l
        };
      }
      return em(r, s, r[0], this.lexer);
    }
  }
  emStrong(e, t, r = "") {
    let i = this.rules.inline.emStrongLDelim.exec(e);
    if (!i || i[3] && r.match(/[\p{L}\p{N}]/u))
      return;
    if (!(i[1] || i[2] || "") || !r || this.rules.inline.punctuation.exec(r)) {
      const l = [...i[0]].length - 1;
      let o, a, u = l, h = 0;
      const c = i[0][0] === "*" ? this.rules.inline.emStrongRDelimAst : this.rules.inline.emStrongRDelimUnd;
      for (c.lastIndex = 0, t = t.slice(-1 * e.length + l); (i = c.exec(t)) != null; ) {
        if (o = i[1] || i[2] || i[3] || i[4] || i[5] || i[6], !o)
          continue;
        if (a = [...o].length, i[3] || i[4]) {
          u += a;
          continue;
        } else if ((i[5] || i[6]) && l % 3 && !((l + a) % 3)) {
          h += a;
          continue;
        }
        if (u -= a, u > 0)
          continue;
        a = Math.min(a, a + u + h);
        const f = [...i[0]][0].length, m = e.slice(0, l + i.index + f + a);
        if (Math.min(l, a) % 2) {
          const v = m.slice(1, -1);
          return {
            type: "em",
            raw: m,
            text: v,
            tokens: this.lexer.inlineTokens(v)
          };
        }
        const g = m.slice(2, -2);
        return {
          type: "strong",
          raw: m,
          text: g,
          tokens: this.lexer.inlineTokens(g)
        };
      }
    }
  }
  codespan(e) {
    const t = this.rules.inline.code.exec(e);
    if (t) {
      let r = t[2].replace(/\n/g, " ");
      const i = /[^ ]/.test(r), s = /^ /.test(r) && / $/.test(r);
      return i && s && (r = r.substring(1, r.length - 1)), r = zt(r, !0), {
        type: "codespan",
        raw: t[0],
        text: r
      };
    }
  }
  br(e) {
    const t = this.rules.inline.br.exec(e);
    if (t)
      return {
        type: "br",
        raw: t[0]
      };
  }
  del(e) {
    const t = this.rules.inline.del.exec(e);
    if (t)
      return {
        type: "del",
        raw: t[0],
        text: t[2],
        tokens: this.lexer.inlineTokens(t[2])
      };
  }
  autolink(e) {
    const t = this.rules.inline.autolink.exec(e);
    if (t) {
      let r, i;
      return t[2] === "@" ? (r = zt(t[1]), i = "mailto:" + r) : (r = zt(t[1]), i = r), {
        type: "link",
        raw: t[0],
        text: r,
        href: i,
        tokens: [
          {
            type: "text",
            raw: r,
            text: r
          }
        ]
      };
    }
  }
  url(e) {
    let t;
    if (t = this.rules.inline.url.exec(e)) {
      let r, i;
      if (t[2] === "@")
        r = zt(t[0]), i = "mailto:" + r;
      else {
        let s;
        do
          s = t[0], t[0] = this.rules.inline._backpedal.exec(t[0])?.[0] ?? "";
        while (s !== t[0]);
        r = zt(t[0]), t[1] === "www." ? i = "http://" + t[0] : i = t[0];
      }
      return {
        type: "link",
        raw: t[0],
        text: r,
        href: i,
        tokens: [
          {
            type: "text",
            raw: r,
            text: r
          }
        ]
      };
    }
  }
  inlineText(e) {
    const t = this.rules.inline.text.exec(e);
    if (t) {
      let r;
      return this.lexer.state.inRawBlock ? r = t[0] : r = zt(t[0]), {
        type: "text",
        raw: t[0],
        text: r
      };
    }
  }
}
const Tx = /^(?: *(?:\n|$))+/, Ex = /^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/, Fx = /^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/, vl = /^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/, Bx = /^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/, Y2 = /(?:[*+-]|\d{1,9}[.)])/, K2 = Ee(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g, Y2).replace(/blockCode/g, / {4}/).replace(/fences/g, / {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g, / {0,3}>/).replace(/heading/g, / {0,3}#{1,6}/).replace(/html/g, / {0,3}<[^\n>]+>\n/).getRegex(), hc = /^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/, Ox = /^[^\n]+/, cc = /(?!\s*\])(?:\\.|[^\[\]\\])+/, Rx = Ee(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label", cc).replace("title", /(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(), Lx = Ee(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g, Y2).getRegex(), Da = "address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul", fc = /<!--(?:-?>|[\s\S]*?(?:-->|$))/, Nx = Ee("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))", "i").replace("comment", fc).replace("tag", Da).replace("attribute", / +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(), X2 = Ee(hc).replace("hr", vl).replace("heading", " {0,3}#{1,6}(?:\\s|$)").replace("|lheading", "").replace("|table", "").replace("blockquote", " {0,3}>").replace("fences", " {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list", " {0,3}(?:[*+-]|1[.)]) ").replace("html", "</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag", Da).getRegex(), Ix = Ee(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph", X2).getRegex(), dc = {
  blockquote: Ix,
  code: Ex,
  def: Rx,
  fences: Fx,
  heading: Bx,
  hr: vl,
  html: Nx,
  lheading: K2,
  list: Lx,
  newline: Tx,
  paragraph: X2,
  table: Us,
  text: Ox
}, tm = Ee("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr", vl).replace("heading", " {0,3}#{1,6}(?:\\s|$)").replace("blockquote", " {0,3}>").replace("code", " {4}[^\\n]").replace("fences", " {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list", " {0,3}(?:[*+-]|1[.)]) ").replace("html", "</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag", Da).getRegex(), zx = {
  ...dc,
  table: tm,
  paragraph: Ee(hc).replace("hr", vl).replace("heading", " {0,3}#{1,6}(?:\\s|$)").replace("|lheading", "").replace("table", tm).replace("blockquote", " {0,3}>").replace("fences", " {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list", " {0,3}(?:[*+-]|1[.)]) ").replace("html", "</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag", Da).getRegex()
}, Px = {
  ...dc,
  html: Ee(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment", fc).replace(/tag/g, "(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),
  def: /^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,
  heading: /^(#{1,6})(.*)(?:\n+|$)/,
  fences: Us,
  // fences not supported
  lheading: /^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,
  paragraph: Ee(hc).replace("hr", vl).replace("heading", ` *#{1,6} *[^
]`).replace("lheading", K2).replace("|table", "").replace("blockquote", " {0,3}>").replace("|fences", "").replace("|list", "").replace("|html", "").replace("|tag", "").getRegex()
}, Z2 = /^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/, Hx = /^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/, J2 = /^( {2,}|\\)\n(?!\s*$)/, qx = /^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/, yl = "\\p{P}\\p{S}", Vx = Ee(/^((?![*_])[\spunctuation])/, "u").replace(/punctuation/g, yl).getRegex(), Wx = /\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g, Ux = Ee(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/, "u").replace(/punct/g, yl).getRegex(), Gx = Ee("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])", "gu").replace(/punct/g, yl).getRegex(), jx = Ee("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])", "gu").replace(/punct/g, yl).getRegex(), $x = Ee(/\\([punct])/, "gu").replace(/punct/g, yl).getRegex(), Yx = Ee(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme", /[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email", /[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(), Kx = Ee(fc).replace("(?:-->|$)", "-->").getRegex(), Xx = Ee("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment", Kx).replace("attribute", /\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(), ta = /(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/, Zx = Ee(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label", ta).replace("href", /<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title", /"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(), Q2 = Ee(/^!?\[(label)\]\[(ref)\]/).replace("label", ta).replace("ref", cc).getRegex(), e5 = Ee(/^!?\[(ref)\](?:\[\])?/).replace("ref", cc).getRegex(), Jx = Ee("reflink|nolink(?!\\()", "g").replace("reflink", Q2).replace("nolink", e5).getRegex(), mc = {
  _backpedal: Us,
  // only used for GFM url
  anyPunctuation: $x,
  autolink: Yx,
  blockSkip: Wx,
  br: J2,
  code: Hx,
  del: Us,
  emStrongLDelim: Ux,
  emStrongRDelimAst: Gx,
  emStrongRDelimUnd: jx,
  escape: Z2,
  link: Zx,
  nolink: e5,
  punctuation: Vx,
  reflink: Q2,
  reflinkSearch: Jx,
  tag: Xx,
  text: qx,
  url: Us
}, Qx = {
  ...mc,
  link: Ee(/^!?\[(label)\]\((.*?)\)/).replace("label", ta).getRegex(),
  reflink: Ee(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label", ta).getRegex()
}, Uu = {
  ...mc,
  escape: Ee(Z2).replace("])", "~|])").getRegex(),
  url: Ee(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/, "i").replace("email", /[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),
  _backpedal: /(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,
  del: /^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,
  text: /^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/
}, eS = {
  ...Uu,
  br: Ee(J2).replace("{2,}", "*").getRegex(),
  text: Ee(Uu.text).replace("\\b_", "\\b_| {2,}\\n").replace(/\{2,\}/g, "*").getRegex()
}, io = {
  normal: dc,
  gfm: zx,
  pedantic: Px
}, xs = {
  normal: mc,
  gfm: Uu,
  breaks: eS,
  pedantic: Qx
};
class qr {
  tokens;
  options;
  state;
  tokenizer;
  inlineQueue;
  constructor(e) {
    this.tokens = [], this.tokens.links = /* @__PURE__ */ Object.create(null), this.options = e || yi, this.options.tokenizer = this.options.tokenizer || new ea(), this.tokenizer = this.options.tokenizer, this.tokenizer.options = this.options, this.tokenizer.lexer = this, this.inlineQueue = [], this.state = {
      inLink: !1,
      inRawBlock: !1,
      top: !0
    };
    const t = {
      block: io.normal,
      inline: xs.normal
    };
    this.options.pedantic ? (t.block = io.pedantic, t.inline = xs.pedantic) : this.options.gfm && (t.block = io.gfm, this.options.breaks ? t.inline = xs.breaks : t.inline = xs.gfm), this.tokenizer.rules = t;
  }
  /**
   * Expose Rules
   */
  static get rules() {
    return {
      block: io,
      inline: xs
    };
  }
  /**
   * Static Lex Method
   */
  static lex(e, t) {
    return new qr(t).lex(e);
  }
  /**
   * Static Lex Inline Method
   */
  static lexInline(e, t) {
    return new qr(t).inlineTokens(e);
  }
  /**
   * Preprocessing
   */
  lex(e) {
    e = e.replace(/\r\n|\r/g, `
`), this.blockTokens(e, this.tokens);
    for (let t = 0; t < this.inlineQueue.length; t++) {
      const r = this.inlineQueue[t];
      this.inlineTokens(r.src, r.tokens);
    }
    return this.inlineQueue = [], this.tokens;
  }
  blockTokens(e, t = []) {
    this.options.pedantic ? e = e.replace(/\t/g, "    ").replace(/^ +$/gm, "") : e = e.replace(/^( *)(\t+)/gm, (o, a, u) => a + "    ".repeat(u.length));
    let r, i, s, l;
    for (; e; )
      if (!(this.options.extensions && this.options.extensions.block && this.options.extensions.block.some((o) => (r = o.call({ lexer: this }, e, t)) ? (e = e.substring(r.raw.length), t.push(r), !0) : !1))) {
        if (r = this.tokenizer.space(e)) {
          e = e.substring(r.raw.length), r.raw.length === 1 && t.length > 0 ? t[t.length - 1].raw += `
` : t.push(r);
          continue;
        }
        if (r = this.tokenizer.code(e)) {
          e = e.substring(r.raw.length), i = t[t.length - 1], i && (i.type === "paragraph" || i.type === "text") ? (i.raw += `
` + r.raw, i.text += `
` + r.text, this.inlineQueue[this.inlineQueue.length - 1].src = i.text) : t.push(r);
          continue;
        }
        if (r = this.tokenizer.fences(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.heading(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.hr(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.blockquote(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.list(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.html(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.def(e)) {
          e = e.substring(r.raw.length), i = t[t.length - 1], i && (i.type === "paragraph" || i.type === "text") ? (i.raw += `
` + r.raw, i.text += `
` + r.raw, this.inlineQueue[this.inlineQueue.length - 1].src = i.text) : this.tokens.links[r.tag] || (this.tokens.links[r.tag] = {
            href: r.href,
            title: r.title
          });
          continue;
        }
        if (r = this.tokenizer.table(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.lheading(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (s = e, this.options.extensions && this.options.extensions.startBlock) {
          let o = 1 / 0;
          const a = e.slice(1);
          let u;
          this.options.extensions.startBlock.forEach((h) => {
            u = h.call({ lexer: this }, a), typeof u == "number" && u >= 0 && (o = Math.min(o, u));
          }), o < 1 / 0 && o >= 0 && (s = e.substring(0, o + 1));
        }
        if (this.state.top && (r = this.tokenizer.paragraph(s))) {
          i = t[t.length - 1], l && i.type === "paragraph" ? (i.raw += `
` + r.raw, i.text += `
` + r.text, this.inlineQueue.pop(), this.inlineQueue[this.inlineQueue.length - 1].src = i.text) : t.push(r), l = s.length !== e.length, e = e.substring(r.raw.length);
          continue;
        }
        if (r = this.tokenizer.text(e)) {
          e = e.substring(r.raw.length), i = t[t.length - 1], i && i.type === "text" ? (i.raw += `
` + r.raw, i.text += `
` + r.text, this.inlineQueue.pop(), this.inlineQueue[this.inlineQueue.length - 1].src = i.text) : t.push(r);
          continue;
        }
        if (e) {
          const o = "Infinite loop on byte: " + e.charCodeAt(0);
          if (this.options.silent) {
            console.error(o);
            break;
          } else
            throw new Error(o);
        }
      }
    return this.state.top = !0, t;
  }
  inline(e, t = []) {
    return this.inlineQueue.push({ src: e, tokens: t }), t;
  }
  /**
   * Lexing/Compiling
   */
  inlineTokens(e, t = []) {
    let r, i, s, l = e, o, a, u;
    if (this.tokens.links) {
      const h = Object.keys(this.tokens.links);
      if (h.length > 0)
        for (; (o = this.tokenizer.rules.inline.reflinkSearch.exec(l)) != null; )
          h.includes(o[0].slice(o[0].lastIndexOf("[") + 1, -1)) && (l = l.slice(0, o.index) + "[" + "a".repeat(o[0].length - 2) + "]" + l.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex));
    }
    for (; (o = this.tokenizer.rules.inline.blockSkip.exec(l)) != null; )
      l = l.slice(0, o.index) + "[" + "a".repeat(o[0].length - 2) + "]" + l.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);
    for (; (o = this.tokenizer.rules.inline.anyPunctuation.exec(l)) != null; )
      l = l.slice(0, o.index) + "++" + l.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);
    for (; e; )
      if (a || (u = ""), a = !1, !(this.options.extensions && this.options.extensions.inline && this.options.extensions.inline.some((h) => (r = h.call({ lexer: this }, e, t)) ? (e = e.substring(r.raw.length), t.push(r), !0) : !1))) {
        if (r = this.tokenizer.escape(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.tag(e)) {
          e = e.substring(r.raw.length), i = t[t.length - 1], i && r.type === "text" && i.type === "text" ? (i.raw += r.raw, i.text += r.text) : t.push(r);
          continue;
        }
        if (r = this.tokenizer.link(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.reflink(e, this.tokens.links)) {
          e = e.substring(r.raw.length), i = t[t.length - 1], i && r.type === "text" && i.type === "text" ? (i.raw += r.raw, i.text += r.text) : t.push(r);
          continue;
        }
        if (r = this.tokenizer.emStrong(e, l, u)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.codespan(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.br(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.del(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (r = this.tokenizer.autolink(e)) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (!this.state.inLink && (r = this.tokenizer.url(e))) {
          e = e.substring(r.raw.length), t.push(r);
          continue;
        }
        if (s = e, this.options.extensions && this.options.extensions.startInline) {
          let h = 1 / 0;
          const c = e.slice(1);
          let f;
          this.options.extensions.startInline.forEach((m) => {
            f = m.call({ lexer: this }, c), typeof f == "number" && f >= 0 && (h = Math.min(h, f));
          }), h < 1 / 0 && h >= 0 && (s = e.substring(0, h + 1));
        }
        if (r = this.tokenizer.inlineText(s)) {
          e = e.substring(r.raw.length), r.raw.slice(-1) !== "_" && (u = r.raw.slice(-1)), a = !0, i = t[t.length - 1], i && i.type === "text" ? (i.raw += r.raw, i.text += r.text) : t.push(r);
          continue;
        }
        if (e) {
          const h = "Infinite loop on byte: " + e.charCodeAt(0);
          if (this.options.silent) {
            console.error(h);
            break;
          } else
            throw new Error(h);
        }
      }
    return t;
  }
}
class ra {
  options;
  constructor(e) {
    this.options = e || yi;
  }
  code(e, t, r) {
    const i = (t || "").match(/^\S*/)?.[0];
    return e = e.replace(/\n$/, "") + `
`, i ? '<pre><code class="language-' + zt(i) + '">' + (r ? e : zt(e, !0)) + `</code></pre>
` : "<pre><code>" + (r ? e : zt(e, !0)) + `</code></pre>
`;
  }
  blockquote(e) {
    return `<blockquote>
${e}</blockquote>
`;
  }
  html(e, t) {
    return e;
  }
  heading(e, t, r) {
    return `<h${t}>${e}</h${t}>
`;
  }
  hr() {
    return `<hr>
`;
  }
  list(e, t, r) {
    const i = t ? "ol" : "ul", s = t && r !== 1 ? ' start="' + r + '"' : "";
    return "<" + i + s + `>
` + e + "</" + i + `>
`;
  }
  listitem(e, t, r) {
    return `<li>${e}</li>
`;
  }
  checkbox(e) {
    return "<input " + (e ? 'checked="" ' : "") + 'disabled="" type="checkbox">';
  }
  paragraph(e) {
    return `<p>${e}</p>
`;
  }
  table(e, t) {
    return t && (t = `<tbody>${t}</tbody>`), `<table>
<thead>
` + e + `</thead>
` + t + `</table>
`;
  }
  tablerow(e) {
    return `<tr>
${e}</tr>
`;
  }
  tablecell(e, t) {
    const r = t.header ? "th" : "td";
    return (t.align ? `<${r} align="${t.align}">` : `<${r}>`) + e + `</${r}>
`;
  }
  /**
   * span level renderer
   */
  strong(e) {
    return `<strong>${e}</strong>`;
  }
  em(e) {
    return `<em>${e}</em>`;
  }
  codespan(e) {
    return `<code>${e}</code>`;
  }
  br() {
    return "<br>";
  }
  del(e) {
    return `<del>${e}</del>`;
  }
  link(e, t, r) {
    const i = J1(e);
    if (i === null)
      return r;
    e = i;
    let s = '<a href="' + e + '"';
    return t && (s += ' title="' + t + '"'), s += ">" + r + "</a>", s;
  }
  image(e, t, r) {
    const i = J1(e);
    if (i === null)
      return r;
    e = i;
    let s = `<img src="${e}" alt="${r}"`;
    return t && (s += ` title="${t}"`), s += ">", s;
  }
  text(e) {
    return e;
  }
}
class pc {
  // no need for block level renderers
  strong(e) {
    return e;
  }
  em(e) {
    return e;
  }
  codespan(e) {
    return e;
  }
  del(e) {
    return e;
  }
  html(e) {
    return e;
  }
  text(e) {
    return e;
  }
  link(e, t, r) {
    return "" + r;
  }
  image(e, t, r) {
    return "" + r;
  }
  br() {
    return "";
  }
}
class Vr {
  options;
  renderer;
  textRenderer;
  constructor(e) {
    this.options = e || yi, this.options.renderer = this.options.renderer || new ra(), this.renderer = this.options.renderer, this.renderer.options = this.options, this.textRenderer = new pc();
  }
  /**
   * Static Parse Method
   */
  static parse(e, t) {
    return new Vr(t).parse(e);
  }
  /**
   * Static Parse Inline Method
   */
  static parseInline(e, t) {
    return new Vr(t).parseInline(e);
  }
  /**
   * Parse Loop
   */
  parse(e, t = !0) {
    let r = "";
    for (let i = 0; i < e.length; i++) {
      const s = e[i];
      if (this.options.extensions && this.options.extensions.renderers && this.options.extensions.renderers[s.type]) {
        const l = s, o = this.options.extensions.renderers[l.type].call({ parser: this }, l);
        if (o !== !1 || !["space", "hr", "heading", "code", "table", "blockquote", "list", "html", "paragraph", "text"].includes(l.type)) {
          r += o || "";
          continue;
        }
      }
      switch (s.type) {
        case "space":
          continue;
        case "hr": {
          r += this.renderer.hr();
          continue;
        }
        case "heading": {
          const l = s;
          r += this.renderer.heading(this.parseInline(l.tokens), l.depth, Dx(this.parseInline(l.tokens, this.textRenderer)));
          continue;
        }
        case "code": {
          const l = s;
          r += this.renderer.code(l.text, l.lang, !!l.escaped);
          continue;
        }
        case "table": {
          const l = s;
          let o = "", a = "";
          for (let h = 0; h < l.header.length; h++)
            a += this.renderer.tablecell(this.parseInline(l.header[h].tokens), { header: !0, align: l.align[h] });
          o += this.renderer.tablerow(a);
          let u = "";
          for (let h = 0; h < l.rows.length; h++) {
            const c = l.rows[h];
            a = "";
            for (let f = 0; f < c.length; f++)
              a += this.renderer.tablecell(this.parseInline(c[f].tokens), { header: !1, align: l.align[f] });
            u += this.renderer.tablerow(a);
          }
          r += this.renderer.table(o, u);
          continue;
        }
        case "blockquote": {
          const l = s, o = this.parse(l.tokens);
          r += this.renderer.blockquote(o);
          continue;
        }
        case "list": {
          const l = s, o = l.ordered, a = l.start, u = l.loose;
          let h = "";
          for (let c = 0; c < l.items.length; c++) {
            const f = l.items[c], m = f.checked, g = f.task;
            let v = "";
            if (f.task) {
              const k = this.renderer.checkbox(!!m);
              u ? f.tokens.length > 0 && f.tokens[0].type === "paragraph" ? (f.tokens[0].text = k + " " + f.tokens[0].text, f.tokens[0].tokens && f.tokens[0].tokens.length > 0 && f.tokens[0].tokens[0].type === "text" && (f.tokens[0].tokens[0].text = k + " " + f.tokens[0].tokens[0].text)) : f.tokens.unshift({
                type: "text",
                text: k + " "
              }) : v += k + " ";
            }
            v += this.parse(f.tokens, u), h += this.renderer.listitem(v, g, !!m);
          }
          r += this.renderer.list(h, o, a);
          continue;
        }
        case "html": {
          const l = s;
          r += this.renderer.html(l.text, l.block);
          continue;
        }
        case "paragraph": {
          const l = s;
          r += this.renderer.paragraph(this.parseInline(l.tokens));
          continue;
        }
        case "text": {
          let l = s, o = l.tokens ? this.parseInline(l.tokens) : l.text;
          for (; i + 1 < e.length && e[i + 1].type === "text"; )
            l = e[++i], o += `
` + (l.tokens ? this.parseInline(l.tokens) : l.text);
          r += t ? this.renderer.paragraph(o) : o;
          continue;
        }
        default: {
          const l = 'Token with "' + s.type + '" type was not found.';
          if (this.options.silent)
            return console.error(l), "";
          throw new Error(l);
        }
      }
    }
    return r;
  }
  /**
   * Parse Inline Tokens
   */
  parseInline(e, t) {
    t = t || this.renderer;
    let r = "";
    for (let i = 0; i < e.length; i++) {
      const s = e[i];
      if (this.options.extensions && this.options.extensions.renderers && this.options.extensions.renderers[s.type]) {
        const l = this.options.extensions.renderers[s.type].call({ parser: this }, s);
        if (l !== !1 || !["escape", "html", "link", "image", "strong", "em", "codespan", "br", "del", "text"].includes(s.type)) {
          r += l || "";
          continue;
        }
      }
      switch (s.type) {
        case "escape": {
          const l = s;
          r += t.text(l.text);
          break;
        }
        case "html": {
          const l = s;
          r += t.html(l.text);
          break;
        }
        case "link": {
          const l = s;
          r += t.link(l.href, l.title, this.parseInline(l.tokens, t));
          break;
        }
        case "image": {
          const l = s;
          r += t.image(l.href, l.title, l.text);
          break;
        }
        case "strong": {
          const l = s;
          r += t.strong(this.parseInline(l.tokens, t));
          break;
        }
        case "em": {
          const l = s;
          r += t.em(this.parseInline(l.tokens, t));
          break;
        }
        case "codespan": {
          const l = s;
          r += t.codespan(l.text);
          break;
        }
        case "br": {
          r += t.br();
          break;
        }
        case "del": {
          const l = s;
          r += t.del(this.parseInline(l.tokens, t));
          break;
        }
        case "text": {
          const l = s;
          r += t.text(l.text);
          break;
        }
        default: {
          const l = 'Token with "' + s.type + '" type was not found.';
          if (this.options.silent)
            return console.error(l), "";
          throw new Error(l);
        }
      }
    }
    return r;
  }
}
class So {
  options;
  constructor(e) {
    this.options = e || yi;
  }
  static passThroughHooks = /* @__PURE__ */ new Set([
    "preprocess",
    "postprocess",
    "processAllTokens"
  ]);
  /**
   * Process markdown before marked
   */
  preprocess(e) {
    return e;
  }
  /**
   * Process HTML after marked is finished
   */
  postprocess(e) {
    return e;
  }
  /**
   * Process all tokens before walk tokens
   */
  processAllTokens(e) {
    return e;
  }
}
class tS {
  defaults = uc();
  options = this.setOptions;
  parse = this.#e(qr.lex, Vr.parse);
  parseInline = this.#e(qr.lexInline, Vr.parseInline);
  Parser = Vr;
  Renderer = ra;
  TextRenderer = pc;
  Lexer = qr;
  Tokenizer = ea;
  Hooks = So;
  constructor(...e) {
    this.use(...e);
  }
  /**
   * Run callback for every token
   */
  walkTokens(e, t) {
    let r = [];
    for (const i of e)
      switch (r = r.concat(t.call(this, i)), i.type) {
        case "table": {
          const s = i;
          for (const l of s.header)
            r = r.concat(this.walkTokens(l.tokens, t));
          for (const l of s.rows)
            for (const o of l)
              r = r.concat(this.walkTokens(o.tokens, t));
          break;
        }
        case "list": {
          const s = i;
          r = r.concat(this.walkTokens(s.items, t));
          break;
        }
        default: {
          const s = i;
          this.defaults.extensions?.childTokens?.[s.type] ? this.defaults.extensions.childTokens[s.type].forEach((l) => {
            const o = s[l].flat(1 / 0);
            r = r.concat(this.walkTokens(o, t));
          }) : s.tokens && (r = r.concat(this.walkTokens(s.tokens, t)));
        }
      }
    return r;
  }
  use(...e) {
    const t = this.defaults.extensions || { renderers: {}, childTokens: {} };
    return e.forEach((r) => {
      const i = { ...r };
      if (i.async = this.defaults.async || i.async || !1, r.extensions && (r.extensions.forEach((s) => {
        if (!s.name)
          throw new Error("extension name required");
        if ("renderer" in s) {
          const l = t.renderers[s.name];
          l ? t.renderers[s.name] = function(...o) {
            let a = s.renderer.apply(this, o);
            return a === !1 && (a = l.apply(this, o)), a;
          } : t.renderers[s.name] = s.renderer;
        }
        if ("tokenizer" in s) {
          if (!s.level || s.level !== "block" && s.level !== "inline")
            throw new Error("extension level must be 'block' or 'inline'");
          const l = t[s.level];
          l ? l.unshift(s.tokenizer) : t[s.level] = [s.tokenizer], s.start && (s.level === "block" ? t.startBlock ? t.startBlock.push(s.start) : t.startBlock = [s.start] : s.level === "inline" && (t.startInline ? t.startInline.push(s.start) : t.startInline = [s.start]));
        }
        "childTokens" in s && s.childTokens && (t.childTokens[s.name] = s.childTokens);
      }), i.extensions = t), r.renderer) {
        const s = this.defaults.renderer || new ra(this.defaults);
        for (const l in r.renderer) {
          if (!(l in s))
            throw new Error(`renderer '${l}' does not exist`);
          if (l === "options")
            continue;
          const o = l, a = r.renderer[o], u = s[o];
          s[o] = (...h) => {
            let c = a.apply(s, h);
            return c === !1 && (c = u.apply(s, h)), c || "";
          };
        }
        i.renderer = s;
      }
      if (r.tokenizer) {
        const s = this.defaults.tokenizer || new ea(this.defaults);
        for (const l in r.tokenizer) {
          if (!(l in s))
            throw new Error(`tokenizer '${l}' does not exist`);
          if (["options", "rules", "lexer"].includes(l))
            continue;
          const o = l, a = r.tokenizer[o], u = s[o];
          s[o] = (...h) => {
            let c = a.apply(s, h);
            return c === !1 && (c = u.apply(s, h)), c;
          };
        }
        i.tokenizer = s;
      }
      if (r.hooks) {
        const s = this.defaults.hooks || new So();
        for (const l in r.hooks) {
          if (!(l in s))
            throw new Error(`hook '${l}' does not exist`);
          if (l === "options")
            continue;
          const o = l, a = r.hooks[o], u = s[o];
          So.passThroughHooks.has(l) ? s[o] = (h) => {
            if (this.defaults.async)
              return Promise.resolve(a.call(s, h)).then((f) => u.call(s, f));
            const c = a.call(s, h);
            return u.call(s, c);
          } : s[o] = (...h) => {
            let c = a.apply(s, h);
            return c === !1 && (c = u.apply(s, h)), c;
          };
        }
        i.hooks = s;
      }
      if (r.walkTokens) {
        const s = this.defaults.walkTokens, l = r.walkTokens;
        i.walkTokens = function(o) {
          let a = [];
          return a.push(l.call(this, o)), s && (a = a.concat(s.call(this, o))), a;
        };
      }
      this.defaults = { ...this.defaults, ...i };
    }), this;
  }
  setOptions(e) {
    return this.defaults = { ...this.defaults, ...e }, this;
  }
  lexer(e, t) {
    return qr.lex(e, t ?? this.defaults);
  }
  parser(e, t) {
    return Vr.parse(e, t ?? this.defaults);
  }
  #e(e, t) {
    return (r, i) => {
      const s = { ...i }, l = { ...this.defaults, ...s };
      this.defaults.async === !0 && s.async === !1 && (l.silent || console.warn("marked(): The async option was set to true by an extension. The async: false option sent to parse will be ignored."), l.async = !0);
      const o = this.#t(!!l.silent, !!l.async);
      if (typeof r > "u" || r === null)
        return o(new Error("marked(): input parameter is undefined or null"));
      if (typeof r != "string")
        return o(new Error("marked(): input parameter is of type " + Object.prototype.toString.call(r) + ", string expected"));
      if (l.hooks && (l.hooks.options = l), l.async)
        return Promise.resolve(l.hooks ? l.hooks.preprocess(r) : r).then((a) => e(a, l)).then((a) => l.hooks ? l.hooks.processAllTokens(a) : a).then((a) => l.walkTokens ? Promise.all(this.walkTokens(a, l.walkTokens)).then(() => a) : a).then((a) => t(a, l)).then((a) => l.hooks ? l.hooks.postprocess(a) : a).catch(o);
      try {
        l.hooks && (r = l.hooks.preprocess(r));
        let a = e(r, l);
        l.hooks && (a = l.hooks.processAllTokens(a)), l.walkTokens && this.walkTokens(a, l.walkTokens);
        let u = t(a, l);
        return l.hooks && (u = l.hooks.postprocess(u)), u;
      } catch (a) {
        return o(a);
      }
    };
  }
  #t(e, t) {
    return (r) => {
      if (r.message += `
Please report this to https://github.com/markedjs/marked.`, e) {
        const i = "<p>An error occurred:</p><pre>" + zt(r.message + "", !0) + "</pre>";
        return t ? Promise.resolve(i) : i;
      }
      if (t)
        return Promise.reject(r);
      throw r;
    };
  }
}
const fi = new tS();
function Te(n, e) {
  return fi.parse(n, e);
}
Te.options = Te.setOptions = function(n) {
  return fi.setOptions(n), Te.defaults = fi.defaults, G2(Te.defaults), Te;
};
Te.getDefaults = uc;
Te.defaults = yi;
Te.use = function(...n) {
  return fi.use(...n), Te.defaults = fi.defaults, G2(Te.defaults), Te;
};
Te.walkTokens = function(n, e) {
  return fi.walkTokens(n, e);
};
Te.parseInline = fi.parseInline;
Te.Parser = Vr;
Te.parser = Vr.parse;
Te.Renderer = ra;
Te.TextRenderer = pc;
Te.Lexer = qr;
Te.lexer = qr.lex;
Te.Tokenizer = ea;
Te.Hooks = So;
Te.parse = Te;
Te.options;
Te.setOptions;
Te.use;
Te.walkTokens;
Te.parseInline;
Vr.parse;
qr.lex;
const rS = /[\0-\x1F!-,\.\/:-@\[-\^`\{-\xA9\xAB-\xB4\xB6-\xB9\xBB-\xBF\xD7\xF7\u02C2-\u02C5\u02D2-\u02DF\u02E5-\u02EB\u02ED\u02EF-\u02FF\u0375\u0378\u0379\u037E\u0380-\u0385\u0387\u038B\u038D\u03A2\u03F6\u0482\u0530\u0557\u0558\u055A-\u055F\u0589-\u0590\u05BE\u05C0\u05C3\u05C6\u05C8-\u05CF\u05EB-\u05EE\u05F3-\u060F\u061B-\u061F\u066A-\u066D\u06D4\u06DD\u06DE\u06E9\u06FD\u06FE\u0700-\u070F\u074B\u074C\u07B2-\u07BF\u07F6-\u07F9\u07FB\u07FC\u07FE\u07FF\u082E-\u083F\u085C-\u085F\u086B-\u089F\u08B5\u08C8-\u08D2\u08E2\u0964\u0965\u0970\u0984\u098D\u098E\u0991\u0992\u09A9\u09B1\u09B3-\u09B5\u09BA\u09BB\u09C5\u09C6\u09C9\u09CA\u09CF-\u09D6\u09D8-\u09DB\u09DE\u09E4\u09E5\u09F2-\u09FB\u09FD\u09FF\u0A00\u0A04\u0A0B-\u0A0E\u0A11\u0A12\u0A29\u0A31\u0A34\u0A37\u0A3A\u0A3B\u0A3D\u0A43-\u0A46\u0A49\u0A4A\u0A4E-\u0A50\u0A52-\u0A58\u0A5D\u0A5F-\u0A65\u0A76-\u0A80\u0A84\u0A8E\u0A92\u0AA9\u0AB1\u0AB4\u0ABA\u0ABB\u0AC6\u0ACA\u0ACE\u0ACF\u0AD1-\u0ADF\u0AE4\u0AE5\u0AF0-\u0AF8\u0B00\u0B04\u0B0D\u0B0E\u0B11\u0B12\u0B29\u0B31\u0B34\u0B3A\u0B3B\u0B45\u0B46\u0B49\u0B4A\u0B4E-\u0B54\u0B58-\u0B5B\u0B5E\u0B64\u0B65\u0B70\u0B72-\u0B81\u0B84\u0B8B-\u0B8D\u0B91\u0B96-\u0B98\u0B9B\u0B9D\u0BA0-\u0BA2\u0BA5-\u0BA7\u0BAB-\u0BAD\u0BBA-\u0BBD\u0BC3-\u0BC5\u0BC9\u0BCE\u0BCF\u0BD1-\u0BD6\u0BD8-\u0BE5\u0BF0-\u0BFF\u0C0D\u0C11\u0C29\u0C3A-\u0C3C\u0C45\u0C49\u0C4E-\u0C54\u0C57\u0C5B-\u0C5F\u0C64\u0C65\u0C70-\u0C7F\u0C84\u0C8D\u0C91\u0CA9\u0CB4\u0CBA\u0CBB\u0CC5\u0CC9\u0CCE-\u0CD4\u0CD7-\u0CDD\u0CDF\u0CE4\u0CE5\u0CF0\u0CF3-\u0CFF\u0D0D\u0D11\u0D45\u0D49\u0D4F-\u0D53\u0D58-\u0D5E\u0D64\u0D65\u0D70-\u0D79\u0D80\u0D84\u0D97-\u0D99\u0DB2\u0DBC\u0DBE\u0DBF\u0DC7-\u0DC9\u0DCB-\u0DCE\u0DD5\u0DD7\u0DE0-\u0DE5\u0DF0\u0DF1\u0DF4-\u0E00\u0E3B-\u0E3F\u0E4F\u0E5A-\u0E80\u0E83\u0E85\u0E8B\u0EA4\u0EA6\u0EBE\u0EBF\u0EC5\u0EC7\u0ECE\u0ECF\u0EDA\u0EDB\u0EE0-\u0EFF\u0F01-\u0F17\u0F1A-\u0F1F\u0F2A-\u0F34\u0F36\u0F38\u0F3A-\u0F3D\u0F48\u0F6D-\u0F70\u0F85\u0F98\u0FBD-\u0FC5\u0FC7-\u0FFF\u104A-\u104F\u109E\u109F\u10C6\u10C8-\u10CC\u10CE\u10CF\u10FB\u1249\u124E\u124F\u1257\u1259\u125E\u125F\u1289\u128E\u128F\u12B1\u12B6\u12B7\u12BF\u12C1\u12C6\u12C7\u12D7\u1311\u1316\u1317\u135B\u135C\u1360-\u137F\u1390-\u139F\u13F6\u13F7\u13FE-\u1400\u166D\u166E\u1680\u169B-\u169F\u16EB-\u16ED\u16F9-\u16FF\u170D\u1715-\u171F\u1735-\u173F\u1754-\u175F\u176D\u1771\u1774-\u177F\u17D4-\u17D6\u17D8-\u17DB\u17DE\u17DF\u17EA-\u180A\u180E\u180F\u181A-\u181F\u1879-\u187F\u18AB-\u18AF\u18F6-\u18FF\u191F\u192C-\u192F\u193C-\u1945\u196E\u196F\u1975-\u197F\u19AC-\u19AF\u19CA-\u19CF\u19DA-\u19FF\u1A1C-\u1A1F\u1A5F\u1A7D\u1A7E\u1A8A-\u1A8F\u1A9A-\u1AA6\u1AA8-\u1AAF\u1AC1-\u1AFF\u1B4C-\u1B4F\u1B5A-\u1B6A\u1B74-\u1B7F\u1BF4-\u1BFF\u1C38-\u1C3F\u1C4A-\u1C4C\u1C7E\u1C7F\u1C89-\u1C8F\u1CBB\u1CBC\u1CC0-\u1CCF\u1CD3\u1CFB-\u1CFF\u1DFA\u1F16\u1F17\u1F1E\u1F1F\u1F46\u1F47\u1F4E\u1F4F\u1F58\u1F5A\u1F5C\u1F5E\u1F7E\u1F7F\u1FB5\u1FBD\u1FBF-\u1FC1\u1FC5\u1FCD-\u1FCF\u1FD4\u1FD5\u1FDC-\u1FDF\u1FED-\u1FF1\u1FF5\u1FFD-\u203E\u2041-\u2053\u2055-\u2070\u2072-\u207E\u2080-\u208F\u209D-\u20CF\u20F1-\u2101\u2103-\u2106\u2108\u2109\u2114\u2116-\u2118\u211E-\u2123\u2125\u2127\u2129\u212E\u213A\u213B\u2140-\u2144\u214A-\u214D\u214F-\u215F\u2189-\u24B5\u24EA-\u2BFF\u2C2F\u2C5F\u2CE5-\u2CEA\u2CF4-\u2CFF\u2D26\u2D28-\u2D2C\u2D2E\u2D2F\u2D68-\u2D6E\u2D70-\u2D7E\u2D97-\u2D9F\u2DA7\u2DAF\u2DB7\u2DBF\u2DC7\u2DCF\u2DD7\u2DDF\u2E00-\u2E2E\u2E30-\u3004\u3008-\u3020\u3030\u3036\u3037\u303D-\u3040\u3097\u3098\u309B\u309C\u30A0\u30FB\u3100-\u3104\u3130\u318F-\u319F\u31C0-\u31EF\u3200-\u33FF\u4DC0-\u4DFF\u9FFD-\u9FFF\uA48D-\uA4CF\uA4FE\uA4FF\uA60D-\uA60F\uA62C-\uA63F\uA673\uA67E\uA6F2-\uA716\uA720\uA721\uA789\uA78A\uA7C0\uA7C1\uA7CB-\uA7F4\uA828-\uA82B\uA82D-\uA83F\uA874-\uA87F\uA8C6-\uA8CF\uA8DA-\uA8DF\uA8F8-\uA8FA\uA8FC\uA92E\uA92F\uA954-\uA95F\uA97D-\uA97F\uA9C1-\uA9CE\uA9DA-\uA9DF\uA9FF\uAA37-\uAA3F\uAA4E\uAA4F\uAA5A-\uAA5F\uAA77-\uAA79\uAAC3-\uAADA\uAADE\uAADF\uAAF0\uAAF1\uAAF7-\uAB00\uAB07\uAB08\uAB0F\uAB10\uAB17-\uAB1F\uAB27\uAB2F\uAB5B\uAB6A-\uAB6F\uABEB\uABEE\uABEF\uABFA-\uABFF\uD7A4-\uD7AF\uD7C7-\uD7CA\uD7FC-\uD7FF\uE000-\uF8FF\uFA6E\uFA6F\uFADA-\uFAFF\uFB07-\uFB12\uFB18-\uFB1C\uFB29\uFB37\uFB3D\uFB3F\uFB42\uFB45\uFBB2-\uFBD2\uFD3E-\uFD4F\uFD90\uFD91\uFDC8-\uFDEF\uFDFC-\uFDFF\uFE10-\uFE1F\uFE30-\uFE32\uFE35-\uFE4C\uFE50-\uFE6F\uFE75\uFEFD-\uFF0F\uFF1A-\uFF20\uFF3B-\uFF3E\uFF40\uFF5B-\uFF65\uFFBF-\uFFC1\uFFC8\uFFC9\uFFD0\uFFD1\uFFD8\uFFD9\uFFDD-\uFFFF]|\uD800[\uDC0C\uDC27\uDC3B\uDC3E\uDC4E\uDC4F\uDC5E-\uDC7F\uDCFB-\uDD3F\uDD75-\uDDFC\uDDFE-\uDE7F\uDE9D-\uDE9F\uDED1-\uDEDF\uDEE1-\uDEFF\uDF20-\uDF2C\uDF4B-\uDF4F\uDF7B-\uDF7F\uDF9E\uDF9F\uDFC4-\uDFC7\uDFD0\uDFD6-\uDFFF]|\uD801[\uDC9E\uDC9F\uDCAA-\uDCAF\uDCD4-\uDCD7\uDCFC-\uDCFF\uDD28-\uDD2F\uDD64-\uDDFF\uDF37-\uDF3F\uDF56-\uDF5F\uDF68-\uDFFF]|\uD802[\uDC06\uDC07\uDC09\uDC36\uDC39-\uDC3B\uDC3D\uDC3E\uDC56-\uDC5F\uDC77-\uDC7F\uDC9F-\uDCDF\uDCF3\uDCF6-\uDCFF\uDD16-\uDD1F\uDD3A-\uDD7F\uDDB8-\uDDBD\uDDC0-\uDDFF\uDE04\uDE07-\uDE0B\uDE14\uDE18\uDE36\uDE37\uDE3B-\uDE3E\uDE40-\uDE5F\uDE7D-\uDE7F\uDE9D-\uDEBF\uDEC8\uDEE7-\uDEFF\uDF36-\uDF3F\uDF56-\uDF5F\uDF73-\uDF7F\uDF92-\uDFFF]|\uD803[\uDC49-\uDC7F\uDCB3-\uDCBF\uDCF3-\uDCFF\uDD28-\uDD2F\uDD3A-\uDE7F\uDEAA\uDEAD-\uDEAF\uDEB2-\uDEFF\uDF1D-\uDF26\uDF28-\uDF2F\uDF51-\uDFAF\uDFC5-\uDFDF\uDFF7-\uDFFF]|\uD804[\uDC47-\uDC65\uDC70-\uDC7E\uDCBB-\uDCCF\uDCE9-\uDCEF\uDCFA-\uDCFF\uDD35\uDD40-\uDD43\uDD48-\uDD4F\uDD74\uDD75\uDD77-\uDD7F\uDDC5-\uDDC8\uDDCD\uDDDB\uDDDD-\uDDFF\uDE12\uDE38-\uDE3D\uDE3F-\uDE7F\uDE87\uDE89\uDE8E\uDE9E\uDEA9-\uDEAF\uDEEB-\uDEEF\uDEFA-\uDEFF\uDF04\uDF0D\uDF0E\uDF11\uDF12\uDF29\uDF31\uDF34\uDF3A\uDF45\uDF46\uDF49\uDF4A\uDF4E\uDF4F\uDF51-\uDF56\uDF58-\uDF5C\uDF64\uDF65\uDF6D-\uDF6F\uDF75-\uDFFF]|\uD805[\uDC4B-\uDC4F\uDC5A-\uDC5D\uDC62-\uDC7F\uDCC6\uDCC8-\uDCCF\uDCDA-\uDD7F\uDDB6\uDDB7\uDDC1-\uDDD7\uDDDE-\uDDFF\uDE41-\uDE43\uDE45-\uDE4F\uDE5A-\uDE7F\uDEB9-\uDEBF\uDECA-\uDEFF\uDF1B\uDF1C\uDF2C-\uDF2F\uDF3A-\uDFFF]|\uD806[\uDC3B-\uDC9F\uDCEA-\uDCFE\uDD07\uDD08\uDD0A\uDD0B\uDD14\uDD17\uDD36\uDD39\uDD3A\uDD44-\uDD4F\uDD5A-\uDD9F\uDDA8\uDDA9\uDDD8\uDDD9\uDDE2\uDDE5-\uDDFF\uDE3F-\uDE46\uDE48-\uDE4F\uDE9A-\uDE9C\uDE9E-\uDEBF\uDEF9-\uDFFF]|\uD807[\uDC09\uDC37\uDC41-\uDC4F\uDC5A-\uDC71\uDC90\uDC91\uDCA8\uDCB7-\uDCFF\uDD07\uDD0A\uDD37-\uDD39\uDD3B\uDD3E\uDD48-\uDD4F\uDD5A-\uDD5F\uDD66\uDD69\uDD8F\uDD92\uDD99-\uDD9F\uDDAA-\uDEDF\uDEF7-\uDFAF\uDFB1-\uDFFF]|\uD808[\uDF9A-\uDFFF]|\uD809[\uDC6F-\uDC7F\uDD44-\uDFFF]|[\uD80A\uD80B\uD80E-\uD810\uD812-\uD819\uD824-\uD82B\uD82D\uD82E\uD830-\uD833\uD837\uD839\uD83D\uD83F\uD87B-\uD87D\uD87F\uD885-\uDB3F\uDB41-\uDBFF][\uDC00-\uDFFF]|\uD80D[\uDC2F-\uDFFF]|\uD811[\uDE47-\uDFFF]|\uD81A[\uDE39-\uDE3F\uDE5F\uDE6A-\uDECF\uDEEE\uDEEF\uDEF5-\uDEFF\uDF37-\uDF3F\uDF44-\uDF4F\uDF5A-\uDF62\uDF78-\uDF7C\uDF90-\uDFFF]|\uD81B[\uDC00-\uDE3F\uDE80-\uDEFF\uDF4B-\uDF4E\uDF88-\uDF8E\uDFA0-\uDFDF\uDFE2\uDFE5-\uDFEF\uDFF2-\uDFFF]|\uD821[\uDFF8-\uDFFF]|\uD823[\uDCD6-\uDCFF\uDD09-\uDFFF]|\uD82C[\uDD1F-\uDD4F\uDD53-\uDD63\uDD68-\uDD6F\uDEFC-\uDFFF]|\uD82F[\uDC6B-\uDC6F\uDC7D-\uDC7F\uDC89-\uDC8F\uDC9A-\uDC9C\uDC9F-\uDFFF]|\uD834[\uDC00-\uDD64\uDD6A-\uDD6C\uDD73-\uDD7A\uDD83\uDD84\uDD8C-\uDDA9\uDDAE-\uDE41\uDE45-\uDFFF]|\uD835[\uDC55\uDC9D\uDCA0\uDCA1\uDCA3\uDCA4\uDCA7\uDCA8\uDCAD\uDCBA\uDCBC\uDCC4\uDD06\uDD0B\uDD0C\uDD15\uDD1D\uDD3A\uDD3F\uDD45\uDD47-\uDD49\uDD51\uDEA6\uDEA7\uDEC1\uDEDB\uDEFB\uDF15\uDF35\uDF4F\uDF6F\uDF89\uDFA9\uDFC3\uDFCC\uDFCD]|\uD836[\uDC00-\uDDFF\uDE37-\uDE3A\uDE6D-\uDE74\uDE76-\uDE83\uDE85-\uDE9A\uDEA0\uDEB0-\uDFFF]|\uD838[\uDC07\uDC19\uDC1A\uDC22\uDC25\uDC2B-\uDCFF\uDD2D-\uDD2F\uDD3E\uDD3F\uDD4A-\uDD4D\uDD4F-\uDEBF\uDEFA-\uDFFF]|\uD83A[\uDCC5-\uDCCF\uDCD7-\uDCFF\uDD4C-\uDD4F\uDD5A-\uDFFF]|\uD83B[\uDC00-\uDDFF\uDE04\uDE20\uDE23\uDE25\uDE26\uDE28\uDE33\uDE38\uDE3A\uDE3C-\uDE41\uDE43-\uDE46\uDE48\uDE4A\uDE4C\uDE50\uDE53\uDE55\uDE56\uDE58\uDE5A\uDE5C\uDE5E\uDE60\uDE63\uDE65\uDE66\uDE6B\uDE73\uDE78\uDE7D\uDE7F\uDE8A\uDE9C-\uDEA0\uDEA4\uDEAA\uDEBC-\uDFFF]|\uD83C[\uDC00-\uDD2F\uDD4A-\uDD4F\uDD6A-\uDD6F\uDD8A-\uDFFF]|\uD83E[\uDC00-\uDFEF\uDFFA-\uDFFF]|\uD869[\uDEDE-\uDEFF]|\uD86D[\uDF35-\uDF3F]|\uD86E[\uDC1E\uDC1F]|\uD873[\uDEA2-\uDEAF]|\uD87A[\uDFE1-\uDFFF]|\uD87E[\uDE1E-\uDFFF]|\uD884[\uDF4B-\uDFFF]|\uDB40[\uDC00-\uDCFF\uDDF0-\uDFFF]/g, nS = Object.hasOwnProperty;
class t5 {
  /**
   * Create a new slug class.
   */
  constructor() {
    this.occurrences, this.reset();
  }
  /**
   * Generate a unique slug.
  *
  * Tracks previously generated slugs: repeated calls with the same value
  * will result in different slugs.
  * Use the `slug` function to get same slugs.
   *
   * @param  {string} value
   *   String of text to slugify
   * @param  {boolean} [maintainCase=false]
   *   Keep the current case, otherwise make all lowercase
   * @return {string}
   *   A unique slug string
   */
  slug(e, t) {
    const r = this;
    let i = iS(e, t === !0);
    const s = i;
    for (; nS.call(r.occurrences, i); )
      r.occurrences[s]++, i = s + "-" + r.occurrences[s];
    return r.occurrences[i] = 0, i;
  }
  /**
   * Reset - Forget all previous slugs
   *
   * @return void
   */
  reset() {
    this.occurrences = /* @__PURE__ */ Object.create(null);
  }
}
function iS(n, e) {
  return typeof n != "string" ? "" : (e || (n = n.toLowerCase()), n.replace(rS, "").replace(/ /g, "-"));
}
new t5();
var rm = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, sS = { exports: {} };
(function(n) {
  var e = typeof window < "u" ? window : typeof WorkerGlobalScope < "u" && self instanceof WorkerGlobalScope ? self : {};
  /**
   * Prism: Lightweight, robust, elegant syntax highlighting
   *
   * @license MIT <https://opensource.org/licenses/MIT>
   * @author Lea Verou <https://lea.verou.me>
   * @namespace
   * @public
   */
  var t = function(r) {
    var i = /(?:^|\s)lang(?:uage)?-([\w-]+)(?=\s|$)/i, s = 0, l = {}, o = {
      /**
       * By default, Prism will attempt to highlight all code elements (by calling {@link Prism.highlightAll}) on the
       * current page after the page finished loading. This might be a problem if e.g. you wanted to asynchronously load
       * additional languages or plugins yourself.
       *
       * By setting this value to `true`, Prism will not automatically highlight all code elements on the page.
       *
       * You obviously have to change this value before the automatic highlighting started. To do this, you can add an
       * empty Prism object into the global scope before loading the Prism script like this:
       *
       * ```js
       * window.Prism = window.Prism || {};
       * Prism.manual = true;
       * // add a new <script> to load Prism's script
       * ```
       *
       * @default false
       * @type {boolean}
       * @memberof Prism
       * @public
       */
      manual: r.Prism && r.Prism.manual,
      /**
       * By default, if Prism is in a web worker, it assumes that it is in a worker it created itself, so it uses
       * `addEventListener` to communicate with its parent instance. However, if you're using Prism manually in your
       * own worker, you don't want it to do this.
       *
       * By setting this value to `true`, Prism will not add its own listeners to the worker.
       *
       * You obviously have to change this value before Prism executes. To do this, you can add an
       * empty Prism object into the global scope before loading the Prism script like this:
       *
       * ```js
       * window.Prism = window.Prism || {};
       * Prism.disableWorkerMessageHandler = true;
       * // Load Prism's script
       * ```
       *
       * @default false
       * @type {boolean}
       * @memberof Prism
       * @public
       */
      disableWorkerMessageHandler: r.Prism && r.Prism.disableWorkerMessageHandler,
      /**
       * A namespace for utility methods.
       *
       * All function in this namespace that are not explicitly marked as _public_ are for __internal use only__ and may
       * change or disappear at any time.
       *
       * @namespace
       * @memberof Prism
       */
      util: {
        encode: function x(y) {
          return y instanceof a ? new a(y.type, x(y.content), y.alias) : Array.isArray(y) ? y.map(x) : y.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/\u00a0/g, " ");
        },
        /**
         * Returns the name of the type of the given value.
         *
         * @param {any} o
         * @returns {string}
         * @example
         * type(null)      === 'Null'
         * type(undefined) === 'Undefined'
         * type(123)       === 'Number'
         * type('foo')     === 'String'
         * type(true)      === 'Boolean'
         * type([1, 2])    === 'Array'
         * type({})        === 'Object'
         * type(String)    === 'Function'
         * type(/abc+/)    === 'RegExp'
         */
        type: function(x) {
          return Object.prototype.toString.call(x).slice(8, -1);
        },
        /**
         * Returns a unique number for the given object. Later calls will still return the same number.
         *
         * @param {Object} obj
         * @returns {number}
         */
        objId: function(x) {
          return x.__id || Object.defineProperty(x, "__id", { value: ++s }), x.__id;
        },
        /**
         * Creates a deep clone of the given object.
         *
         * The main intended use of this function is to clone language definitions.
         *
         * @param {T} o
         * @param {Record<number, any>} [visited]
         * @returns {T}
         * @template T
         */
        clone: function x(y, A) {
          A = A || {};
          var C, T;
          switch (o.util.type(y)) {
            case "Object":
              if (T = o.util.objId(y), A[T])
                return A[T];
              C = /** @type {Record<string, any>} */
              {}, A[T] = C;
              for (var M in y)
                y.hasOwnProperty(M) && (C[M] = x(y[M], A));
              return (
                /** @type {any} */
                C
              );
            case "Array":
              return T = o.util.objId(y), A[T] ? A[T] : (C = [], A[T] = C, /** @type {Array} */
              /** @type {any} */
              y.forEach(function(L, R) {
                C[R] = x(L, A);
              }), /** @type {any} */
              C);
            default:
              return y;
          }
        },
        /**
         * Returns the Prism language of the given element set by a `language-xxxx` or `lang-xxxx` class.
         *
         * If no language is set for the element or the element is `null` or `undefined`, `none` will be returned.
         *
         * @param {Element} element
         * @returns {string}
         */
        getLanguage: function(x) {
          for (; x; ) {
            var y = i.exec(x.className);
            if (y)
              return y[1].toLowerCase();
            x = x.parentElement;
          }
          return "none";
        },
        /**
         * Sets the Prism `language-xxxx` class of the given element.
         *
         * @param {Element} element
         * @param {string} language
         * @returns {void}
         */
        setLanguage: function(x, y) {
          x.className = x.className.replace(RegExp(i, "gi"), ""), x.classList.add("language-" + y);
        },
        /**
         * Returns the script element that is currently executing.
         *
         * This does __not__ work for line script element.
         *
         * @returns {HTMLScriptElement | null}
         */
        currentScript: function() {
          if (typeof document > "u")
            return null;
          if ("currentScript" in document)
            return (
              /** @type {any} */
              document.currentScript
            );
          try {
            throw new Error();
          } catch (C) {
            var x = (/at [^(\r\n]*\((.*):[^:]+:[^:]+\)$/i.exec(C.stack) || [])[1];
            if (x) {
              var y = document.getElementsByTagName("script");
              for (var A in y)
                if (y[A].src == x)
                  return y[A];
            }
            return null;
          }
        },
        /**
         * Returns whether a given class is active for `element`.
         *
         * The class can be activated if `element` or one of its ancestors has the given class and it can be deactivated
         * if `element` or one of its ancestors has the negated version of the given class. The _negated version_ of the
         * given class is just the given class with a `no-` prefix.
         *
         * Whether the class is active is determined by the closest ancestor of `element` (where `element` itself is
         * closest ancestor) that has the given class or the negated version of it. If neither `element` nor any of its
         * ancestors have the given class or the negated version of it, then the default activation will be returned.
         *
         * In the paradoxical situation where the closest ancestor contains __both__ the given class and the negated
         * version of it, the class is considered active.
         *
         * @param {Element} element
         * @param {string} className
         * @param {boolean} [defaultActivation=false]
         * @returns {boolean}
         */
        isActive: function(x, y, A) {
          for (var C = "no-" + y; x; ) {
            var T = x.classList;
            if (T.contains(y))
              return !0;
            if (T.contains(C))
              return !1;
            x = x.parentElement;
          }
          return !!A;
        }
      },
      /**
       * This namespace contains all currently loaded languages and the some helper functions to create and modify languages.
       *
       * @namespace
       * @memberof Prism
       * @public
       */
      languages: {
        /**
         * The grammar for plain, unformatted text.
         */
        plain: l,
        plaintext: l,
        text: l,
        txt: l,
        /**
         * Creates a deep copy of the language with the given id and appends the given tokens.
         *
         * If a token in `redef` also appears in the copied language, then the existing token in the copied language
         * will be overwritten at its original position.
         *
         * ## Best practices
         *
         * Since the position of overwriting tokens (token in `redef` that overwrite tokens in the copied language)
         * doesn't matter, they can technically be in any order. However, this can be confusing to others that trying to
         * understand the language definition because, normally, the order of tokens matters in Prism grammars.
         *
         * Therefore, it is encouraged to order overwriting tokens according to the positions of the overwritten tokens.
         * Furthermore, all non-overwriting tokens should be placed after the overwriting ones.
         *
         * @param {string} id The id of the language to extend. This has to be a key in `Prism.languages`.
         * @param {Grammar} redef The new tokens to append.
         * @returns {Grammar} The new language created.
         * @public
         * @example
         * Prism.languages['css-with-colors'] = Prism.languages.extend('css', {
         *     // Prism.languages.css already has a 'comment' token, so this token will overwrite CSS' 'comment' token
         *     // at its original position
         *     'comment': { ... },
         *     // CSS doesn't have a 'color' token, so this token will be appended
         *     'color': /\b(?:red|green|blue)\b/
         * });
         */
        extend: function(x, y) {
          var A = o.util.clone(o.languages[x]);
          for (var C in y)
            A[C] = y[C];
          return A;
        },
        /**
         * Inserts tokens _before_ another token in a language definition or any other grammar.
         *
         * ## Usage
         *
         * This helper method makes it easy to modify existing languages. For example, the CSS language definition
         * not only defines CSS highlighting for CSS documents, but also needs to define highlighting for CSS embedded
         * in HTML through `<style>` elements. To do this, it needs to modify `Prism.languages.markup` and add the
         * appropriate tokens. However, `Prism.languages.markup` is a regular JavaScript object literal, so if you do
         * this:
         *
         * ```js
         * Prism.languages.markup.style = {
         *     // token
         * };
         * ```
         *
         * then the `style` token will be added (and processed) at the end. `insertBefore` allows you to insert tokens
         * before existing tokens. For the CSS example above, you would use it like this:
         *
         * ```js
         * Prism.languages.insertBefore('markup', 'cdata', {
         *     'style': {
         *         // token
         *     }
         * });
         * ```
         *
         * ## Special cases
         *
         * If the grammars of `inside` and `insert` have tokens with the same name, the tokens in `inside`'s grammar
         * will be ignored.
         *
         * This behavior can be used to insert tokens after `before`:
         *
         * ```js
         * Prism.languages.insertBefore('markup', 'comment', {
         *     'comment': Prism.languages.markup.comment,
         *     // tokens after 'comment'
         * });
         * ```
         *
         * ## Limitations
         *
         * The main problem `insertBefore` has to solve is iteration order. Since ES2015, the iteration order for object
         * properties is guaranteed to be the insertion order (except for integer keys) but some browsers behave
         * differently when keys are deleted and re-inserted. So `insertBefore` can't be implemented by temporarily
         * deleting properties which is necessary to insert at arbitrary positions.
         *
         * To solve this problem, `insertBefore` doesn't actually insert the given tokens into the target object.
         * Instead, it will create a new object and replace all references to the target object with the new one. This
         * can be done without temporarily deleting properties, so the iteration order is well-defined.
         *
         * However, only references that can be reached from `Prism.languages` or `insert` will be replaced. I.e. if
         * you hold the target object in a variable, then the value of the variable will not change.
         *
         * ```js
         * var oldMarkup = Prism.languages.markup;
         * var newMarkup = Prism.languages.insertBefore('markup', 'comment', { ... });
         *
         * assert(oldMarkup !== Prism.languages.markup);
         * assert(newMarkup === Prism.languages.markup);
         * ```
         *
         * @param {string} inside The property of `root` (e.g. a language id in `Prism.languages`) that contains the
         * object to be modified.
         * @param {string} before The key to insert before.
         * @param {Grammar} insert An object containing the key-value pairs to be inserted.
         * @param {Object<string, any>} [root] The object containing `inside`, i.e. the object that contains the
         * object to be modified.
         *
         * Defaults to `Prism.languages`.
         * @returns {Grammar} The new grammar object.
         * @public
         */
        insertBefore: function(x, y, A, C) {
          C = C || /** @type {any} */
          o.languages;
          var T = C[x], M = {};
          for (var L in T)
            if (T.hasOwnProperty(L)) {
              if (L == y)
                for (var R in A)
                  A.hasOwnProperty(R) && (M[R] = A[R]);
              A.hasOwnProperty(L) || (M[L] = T[L]);
            }
          var N = C[x];
          return C[x] = M, o.languages.DFS(o.languages, function(W, q) {
            q === N && W != x && (this[W] = M);
          }), M;
        },
        // Traverse a language definition with Depth First Search
        DFS: function x(y, A, C, T) {
          T = T || {};
          var M = o.util.objId;
          for (var L in y)
            if (y.hasOwnProperty(L)) {
              A.call(y, L, y[L], C || L);
              var R = y[L], N = o.util.type(R);
              N === "Object" && !T[M(R)] ? (T[M(R)] = !0, x(R, A, null, T)) : N === "Array" && !T[M(R)] && (T[M(R)] = !0, x(R, A, L, T));
            }
        }
      },
      plugins: {},
      /**
       * This is the most high-level function in Prism’s API.
       * It fetches all the elements that have a `.language-xxxx` class and then calls {@link Prism.highlightElement} on
       * each one of them.
       *
       * This is equivalent to `Prism.highlightAllUnder(document, async, callback)`.
       *
       * @param {boolean} [async=false] Same as in {@link Prism.highlightAllUnder}.
       * @param {HighlightCallback} [callback] Same as in {@link Prism.highlightAllUnder}.
       * @memberof Prism
       * @public
       */
      highlightAll: function(x, y) {
        o.highlightAllUnder(document, x, y);
      },
      /**
       * Fetches all the descendants of `container` that have a `.language-xxxx` class and then calls
       * {@link Prism.highlightElement} on each one of them.
       *
       * The following hooks will be run:
       * 1. `before-highlightall`
       * 2. `before-all-elements-highlight`
       * 3. All hooks of {@link Prism.highlightElement} for each element.
       *
       * @param {ParentNode} container The root element, whose descendants that have a `.language-xxxx` class will be highlighted.
       * @param {boolean} [async=false] Whether each element is to be highlighted asynchronously using Web Workers.
       * @param {HighlightCallback} [callback] An optional callback to be invoked on each element after its highlighting is done.
       * @memberof Prism
       * @public
       */
      highlightAllUnder: function(x, y, A) {
        var C = {
          callback: A,
          container: x,
          selector: 'code[class*="language-"], [class*="language-"] code, code[class*="lang-"], [class*="lang-"] code'
        };
        o.hooks.run("before-highlightall", C), C.elements = Array.prototype.slice.apply(C.container.querySelectorAll(C.selector)), o.hooks.run("before-all-elements-highlight", C);
        for (var T = 0, M; M = C.elements[T++]; )
          o.highlightElement(M, y === !0, C.callback);
      },
      /**
       * Highlights the code inside a single element.
       *
       * The following hooks will be run:
       * 1. `before-sanity-check`
       * 2. `before-highlight`
       * 3. All hooks of {@link Prism.highlight}. These hooks will be run by an asynchronous worker if `async` is `true`.
       * 4. `before-insert`
       * 5. `after-highlight`
       * 6. `complete`
       *
       * Some the above hooks will be skipped if the element doesn't contain any text or there is no grammar loaded for
       * the element's language.
       *
       * @param {Element} element The element containing the code.
       * It must have a class of `language-xxxx` to be processed, where `xxxx` is a valid language identifier.
       * @param {boolean} [async=false] Whether the element is to be highlighted asynchronously using Web Workers
       * to improve performance and avoid blocking the UI when highlighting very large chunks of code. This option is
       * [disabled by default](https://prismjs.com/faq.html#why-is-asynchronous-highlighting-disabled-by-default).
       *
       * Note: All language definitions required to highlight the code must be included in the main `prism.js` file for
       * asynchronous highlighting to work. You can build your own bundle on the
       * [Download page](https://prismjs.com/download.html).
       * @param {HighlightCallback} [callback] An optional callback to be invoked after the highlighting is done.
       * Mostly useful when `async` is `true`, since in that case, the highlighting is done asynchronously.
       * @memberof Prism
       * @public
       */
      highlightElement: function(x, y, A) {
        var C = o.util.getLanguage(x), T = o.languages[C];
        o.util.setLanguage(x, C);
        var M = x.parentElement;
        M && M.nodeName.toLowerCase() === "pre" && o.util.setLanguage(M, C);
        var L = x.textContent, R = {
          element: x,
          language: C,
          grammar: T,
          code: L
        };
        function N(q) {
          R.highlightedCode = q, o.hooks.run("before-insert", R), R.element.innerHTML = R.highlightedCode, o.hooks.run("after-highlight", R), o.hooks.run("complete", R), A && A.call(R.element);
        }
        if (o.hooks.run("before-sanity-check", R), M = R.element.parentElement, M && M.nodeName.toLowerCase() === "pre" && !M.hasAttribute("tabindex") && M.setAttribute("tabindex", "0"), !R.code) {
          o.hooks.run("complete", R), A && A.call(R.element);
          return;
        }
        if (o.hooks.run("before-highlight", R), !R.grammar) {
          N(o.util.encode(R.code));
          return;
        }
        if (y && r.Worker) {
          var W = new Worker(o.filename);
          W.onmessage = function(q) {
            N(q.data);
          }, W.postMessage(JSON.stringify({
            language: R.language,
            code: R.code,
            immediateClose: !0
          }));
        } else
          N(o.highlight(R.code, R.grammar, R.language));
      },
      /**
       * Low-level function, only use if you know what you’re doing. It accepts a string of text as input
       * and the language definitions to use, and returns a string with the HTML produced.
       *
       * The following hooks will be run:
       * 1. `before-tokenize`
       * 2. `after-tokenize`
       * 3. `wrap`: On each {@link Token}.
       *
       * @param {string} text A string with the code to be highlighted.
       * @param {Grammar} grammar An object containing the tokens to use.
       *
       * Usually a language definition like `Prism.languages.markup`.
       * @param {string} language The name of the language definition passed to `grammar`.
       * @returns {string} The highlighted HTML.
       * @memberof Prism
       * @public
       * @example
       * Prism.highlight('var foo = true;', Prism.languages.javascript, 'javascript');
       */
      highlight: function(x, y, A) {
        var C = {
          code: x,
          grammar: y,
          language: A
        };
        if (o.hooks.run("before-tokenize", C), !C.grammar)
          throw new Error('The language "' + C.language + '" has no grammar.');
        return C.tokens = o.tokenize(C.code, C.grammar), o.hooks.run("after-tokenize", C), a.stringify(o.util.encode(C.tokens), C.language);
      },
      /**
       * This is the heart of Prism, and the most low-level function you can use. It accepts a string of text as input
       * and the language definitions to use, and returns an array with the tokenized code.
       *
       * When the language definition includes nested tokens, the function is called recursively on each of these tokens.
       *
       * This method could be useful in other contexts as well, as a very crude parser.
       *
       * @param {string} text A string with the code to be highlighted.
       * @param {Grammar} grammar An object containing the tokens to use.
       *
       * Usually a language definition like `Prism.languages.markup`.
       * @returns {TokenStream} An array of strings and tokens, a token stream.
       * @memberof Prism
       * @public
       * @example
       * let code = `var foo = 0;`;
       * let tokens = Prism.tokenize(code, Prism.languages.javascript);
       * tokens.forEach(token => {
       *     if (token instanceof Prism.Token && token.type === 'number') {
       *         console.log(`Found numeric literal: ${token.content}`);
       *     }
       * });
       */
      tokenize: function(x, y) {
        var A = y.rest;
        if (A) {
          for (var C in A)
            y[C] = A[C];
          delete y.rest;
        }
        var T = new c();
        return f(T, T.head, x), h(x, T, y, T.head, 0), g(T);
      },
      /**
       * @namespace
       * @memberof Prism
       * @public
       */
      hooks: {
        all: {},
        /**
         * Adds the given callback to the list of callbacks for the given hook.
         *
         * The callback will be invoked when the hook it is registered for is run.
         * Hooks are usually directly run by a highlight function but you can also run hooks yourself.
         *
         * One callback function can be registered to multiple hooks and the same hook multiple times.
         *
         * @param {string} name The name of the hook.
         * @param {HookCallback} callback The callback function which is given environment variables.
         * @public
         */
        add: function(x, y) {
          var A = o.hooks.all;
          A[x] = A[x] || [], A[x].push(y);
        },
        /**
         * Runs a hook invoking all registered callbacks with the given environment variables.
         *
         * Callbacks will be invoked synchronously and in the order in which they were registered.
         *
         * @param {string} name The name of the hook.
         * @param {Object<string, any>} env The environment variables of the hook passed to all callbacks registered.
         * @public
         */
        run: function(x, y) {
          var A = o.hooks.all[x];
          if (!(!A || !A.length))
            for (var C = 0, T; T = A[C++]; )
              T(y);
        }
      },
      Token: a
    };
    r.Prism = o;
    function a(x, y, A, C) {
      this.type = x, this.content = y, this.alias = A, this.length = (C || "").length | 0;
    }
    a.stringify = function x(y, A) {
      if (typeof y == "string")
        return y;
      if (Array.isArray(y)) {
        var C = "";
        return y.forEach(function(N) {
          C += x(N, A);
        }), C;
      }
      var T = {
        type: y.type,
        content: x(y.content, A),
        tag: "span",
        classes: ["token", y.type],
        attributes: {},
        language: A
      }, M = y.alias;
      M && (Array.isArray(M) ? Array.prototype.push.apply(T.classes, M) : T.classes.push(M)), o.hooks.run("wrap", T);
      var L = "";
      for (var R in T.attributes)
        L += " " + R + '="' + (T.attributes[R] || "").replace(/"/g, "&quot;") + '"';
      return "<" + T.tag + ' class="' + T.classes.join(" ") + '"' + L + ">" + T.content + "</" + T.tag + ">";
    };
    function u(x, y, A, C) {
      x.lastIndex = y;
      var T = x.exec(A);
      if (T && C && T[1]) {
        var M = T[1].length;
        T.index += M, T[0] = T[0].slice(M);
      }
      return T;
    }
    function h(x, y, A, C, T, M) {
      for (var L in A)
        if (!(!A.hasOwnProperty(L) || !A[L])) {
          var R = A[L];
          R = Array.isArray(R) ? R : [R];
          for (var N = 0; N < R.length; ++N) {
            if (M && M.cause == L + "," + N)
              return;
            var W = R[N], q = W.inside, he = !!W.lookbehind, Z = !!W.greedy, oe = W.alias;
            if (Z && !W.pattern.global) {
              var ve = W.pattern.toString().match(/[imsuy]*$/)[0];
              W.pattern = RegExp(W.pattern.source, ve + "g");
            }
            for (var _e = W.pattern || W, pe = C.next, H = T; pe !== y.tail && !(M && H >= M.reach); H += pe.value.length, pe = pe.next) {
              var fe = pe.value;
              if (y.length > x.length)
                return;
              if (!(fe instanceof a)) {
                var J = 1, re;
                if (Z) {
                  if (re = u(_e, H, x, he), !re || re.index >= x.length)
                    break;
                  var ze = re.index, ae = re.index + re[0].length, de = H;
                  for (de += pe.value.length; ze >= de; )
                    pe = pe.next, de += pe.value.length;
                  if (de -= pe.value.length, H = de, pe.value instanceof a)
                    continue;
                  for (var P = pe; P !== y.tail && (de < ae || typeof P.value == "string"); P = P.next)
                    J++, de += P.value.length;
                  J--, fe = x.slice(H, de), re.index -= H;
                } else if (re = u(_e, 0, fe, he), !re)
                  continue;
                var ze = re.index, Me = re[0], Pe = fe.slice(0, ze), je = fe.slice(ze + Me.length), Ye = H + fe.length;
                M && Ye > M.reach && (M.reach = Ye);
                var Mt = pe.prev;
                Pe && (Mt = f(y, Mt, Pe), H += Pe.length), m(y, Mt, J);
                var Wt = new a(L, q ? o.tokenize(Me, q) : Me, oe, Me);
                if (pe = f(y, Mt, Wt), je && f(y, pe, je), J > 1) {
                  var hr = {
                    cause: L + "," + N,
                    reach: Ye
                  };
                  h(x, y, A, pe.prev, H, hr), M && hr.reach > M.reach && (M.reach = hr.reach);
                }
              }
            }
          }
        }
    }
    function c() {
      var x = { value: null, prev: null, next: null }, y = { value: null, prev: x, next: null };
      x.next = y, this.head = x, this.tail = y, this.length = 0;
    }
    function f(x, y, A) {
      var C = y.next, T = { value: A, prev: y, next: C };
      return y.next = T, C.prev = T, x.length++, T;
    }
    function m(x, y, A) {
      for (var C = y.next, T = 0; T < A && C !== x.tail; T++)
        C = C.next;
      y.next = C, C.prev = y, x.length -= T;
    }
    function g(x) {
      for (var y = [], A = x.head.next; A !== x.tail; )
        y.push(A.value), A = A.next;
      return y;
    }
    if (!r.document)
      return r.addEventListener && (o.disableWorkerMessageHandler || r.addEventListener("message", function(x) {
        var y = JSON.parse(x.data), A = y.language, C = y.code, T = y.immediateClose;
        r.postMessage(o.highlight(C, o.languages[A], A)), T && r.close();
      }, !1)), o;
    var v = o.util.currentScript();
    v && (o.filename = v.src, v.hasAttribute("data-manual") && (o.manual = !0));
    function k() {
      o.manual || o.highlightAll();
    }
    if (!o.manual) {
      var S = document.readyState;
      S === "loading" || S === "interactive" && v && v.defer ? document.addEventListener("DOMContentLoaded", k) : window.requestAnimationFrame ? window.requestAnimationFrame(k) : window.setTimeout(k, 16);
    }
    return o;
  }(e);
  n.exports && (n.exports = t), typeof rm < "u" && (rm.Prism = t), t.languages.markup = {
    comment: {
      pattern: /<!--(?:(?!<!--)[\s\S])*?-->/,
      greedy: !0
    },
    prolog: {
      pattern: /<\?[\s\S]+?\?>/,
      greedy: !0
    },
    doctype: {
      // https://www.w3.org/TR/xml/#NT-doctypedecl
      pattern: /<!DOCTYPE(?:[^>"'[\]]|"[^"]*"|'[^']*')+(?:\[(?:[^<"'\]]|"[^"]*"|'[^']*'|<(?!!--)|<!--(?:[^-]|-(?!->))*-->)*\]\s*)?>/i,
      greedy: !0,
      inside: {
        "internal-subset": {
          pattern: /(^[^\[]*\[)[\s\S]+(?=\]>$)/,
          lookbehind: !0,
          greedy: !0,
          inside: null
          // see below
        },
        string: {
          pattern: /"[^"]*"|'[^']*'/,
          greedy: !0
        },
        punctuation: /^<!|>$|[[\]]/,
        "doctype-tag": /^DOCTYPE/i,
        name: /[^\s<>'"]+/
      }
    },
    cdata: {
      pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
      greedy: !0
    },
    tag: {
      pattern: /<\/?(?!\d)[^\s>\/=$<%]+(?:\s(?:\s*[^\s>\/=]+(?:\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))|(?=[\s/>])))+)?\s*\/?>/,
      greedy: !0,
      inside: {
        tag: {
          pattern: /^<\/?[^\s>\/]+/,
          inside: {
            punctuation: /^<\/?/,
            namespace: /^[^\s>\/:]+:/
          }
        },
        "special-attr": [],
        "attr-value": {
          pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/,
          inside: {
            punctuation: [
              {
                pattern: /^=/,
                alias: "attr-equals"
              },
              {
                pattern: /^(\s*)["']|["']$/,
                lookbehind: !0
              }
            ]
          }
        },
        punctuation: /\/?>/,
        "attr-name": {
          pattern: /[^\s>\/]+/,
          inside: {
            namespace: /^[^\s>\/:]+:/
          }
        }
      }
    },
    entity: [
      {
        pattern: /&[\da-z]{1,8};/i,
        alias: "named-entity"
      },
      /&#x?[\da-f]{1,8};/i
    ]
  }, t.languages.markup.tag.inside["attr-value"].inside.entity = t.languages.markup.entity, t.languages.markup.doctype.inside["internal-subset"].inside = t.languages.markup, t.hooks.add("wrap", function(r) {
    r.type === "entity" && (r.attributes.title = r.content.replace(/&amp;/, "&"));
  }), Object.defineProperty(t.languages.markup.tag, "addInlined", {
    /**
     * Adds an inlined language to markup.
     *
     * An example of an inlined language is CSS with `<style>` tags.
     *
     * @param {string} tagName The name of the tag that contains the inlined language. This name will be treated as
     * case insensitive.
     * @param {string} lang The language key.
     * @example
     * addInlined('style', 'css');
     */
    value: function(i, s) {
      var l = {};
      l["language-" + s] = {
        pattern: /(^<!\[CDATA\[)[\s\S]+?(?=\]\]>$)/i,
        lookbehind: !0,
        inside: t.languages[s]
      }, l.cdata = /^<!\[CDATA\[|\]\]>$/i;
      var o = {
        "included-cdata": {
          pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
          inside: l
        }
      };
      o["language-" + s] = {
        pattern: /[\s\S]+/,
        inside: t.languages[s]
      };
      var a = {};
      a[i] = {
        pattern: RegExp(/(<__[^>]*>)(?:<!\[CDATA\[(?:[^\]]|\](?!\]>))*\]\]>|(?!<!\[CDATA\[)[\s\S])*?(?=<\/__>)/.source.replace(/__/g, function() {
          return i;
        }), "i"),
        lookbehind: !0,
        greedy: !0,
        inside: o
      }, t.languages.insertBefore("markup", "cdata", a);
    }
  }), Object.defineProperty(t.languages.markup.tag, "addAttribute", {
    /**
     * Adds an pattern to highlight languages embedded in HTML attributes.
     *
     * An example of an inlined language is CSS with `style` attributes.
     *
     * @param {string} attrName The name of the tag that contains the inlined language. This name will be treated as
     * case insensitive.
     * @param {string} lang The language key.
     * @example
     * addAttribute('style', 'css');
     */
    value: function(r, i) {
      t.languages.markup.tag.inside["special-attr"].push({
        pattern: RegExp(
          /(^|["'\s])/.source + "(?:" + r + ")" + /\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))/.source,
          "i"
        ),
        lookbehind: !0,
        inside: {
          "attr-name": /^[^\s=]+/,
          "attr-value": {
            pattern: /=[\s\S]+/,
            inside: {
              value: {
                pattern: /(^=\s*(["']|(?!["'])))\S[\s\S]*(?=\2$)/,
                lookbehind: !0,
                alias: [i, "language-" + i],
                inside: t.languages[i]
              },
              punctuation: [
                {
                  pattern: /^=/,
                  alias: "attr-equals"
                },
                /"|'/
              ]
            }
          }
        }
      });
    }
  }), t.languages.html = t.languages.markup, t.languages.mathml = t.languages.markup, t.languages.svg = t.languages.markup, t.languages.xml = t.languages.extend("markup", {}), t.languages.ssml = t.languages.xml, t.languages.atom = t.languages.xml, t.languages.rss = t.languages.xml, function(r) {
    var i = /(?:"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n])*')/;
    r.languages.css = {
      comment: /\/\*[\s\S]*?\*\//,
      atrule: {
        pattern: RegExp("@[\\w-](?:" + /[^;{\s"']|\s+(?!\s)/.source + "|" + i.source + ")*?" + /(?:;|(?=\s*\{))/.source),
        inside: {
          rule: /^@[\w-]+/,
          "selector-function-argument": {
            pattern: /(\bselector\s*\(\s*(?![\s)]))(?:[^()\s]|\s+(?![\s)])|\((?:[^()]|\([^()]*\))*\))+(?=\s*\))/,
            lookbehind: !0,
            alias: "selector"
          },
          keyword: {
            pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/,
            lookbehind: !0
          }
          // See rest below
        }
      },
      url: {
        // https://drafts.csswg.org/css-values-3/#urls
        pattern: RegExp("\\burl\\((?:" + i.source + "|" + /(?:[^\\\r\n()"']|\\[\s\S])*/.source + ")\\)", "i"),
        greedy: !0,
        inside: {
          function: /^url/i,
          punctuation: /^\(|\)$/,
          string: {
            pattern: RegExp("^" + i.source + "$"),
            alias: "url"
          }
        }
      },
      selector: {
        pattern: RegExp(`(^|[{}\\s])[^{}\\s](?:[^{};"'\\s]|\\s+(?![\\s{])|` + i.source + ")*(?=\\s*\\{)"),
        lookbehind: !0
      },
      string: {
        pattern: i,
        greedy: !0
      },
      property: {
        pattern: /(^|[^-\w\xA0-\uFFFF])(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*(?=\s*:)/i,
        lookbehind: !0
      },
      important: /!important\b/i,
      function: {
        pattern: /(^|[^-a-z0-9])[-a-z0-9]+(?=\()/i,
        lookbehind: !0
      },
      punctuation: /[(){};:,]/
    }, r.languages.css.atrule.inside.rest = r.languages.css;
    var s = r.languages.markup;
    s && (s.tag.addInlined("style", "css"), s.tag.addAttribute("style", "css"));
  }(t), t.languages.clike = {
    comment: [
      {
        pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
        lookbehind: !0,
        greedy: !0
      },
      {
        pattern: /(^|[^\\:])\/\/.*/,
        lookbehind: !0,
        greedy: !0
      }
    ],
    string: {
      pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
      greedy: !0
    },
    "class-name": {
      pattern: /(\b(?:class|extends|implements|instanceof|interface|new|trait)\s+|\bcatch\s+\()[\w.\\]+/i,
      lookbehind: !0,
      inside: {
        punctuation: /[.\\]/
      }
    },
    keyword: /\b(?:break|catch|continue|do|else|finally|for|function|if|in|instanceof|new|null|return|throw|try|while)\b/,
    boolean: /\b(?:false|true)\b/,
    function: /\b\w+(?=\()/,
    number: /\b0x[\da-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?/i,
    operator: /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/,
    punctuation: /[{}[\];(),.:]/
  }, t.languages.javascript = t.languages.extend("clike", {
    "class-name": [
      t.languages.clike["class-name"],
      {
        pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$A-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\.(?:constructor|prototype))/,
        lookbehind: !0
      }
    ],
    keyword: [
      {
        pattern: /((?:^|\})\s*)catch\b/,
        lookbehind: !0
      },
      {
        pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|assert(?=\s*\{)|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally(?=\s*(?:\{|$))|for|from(?=\s*(?:['"]|$))|function|(?:get|set)(?=\s*(?:[#\[$\w\xA0-\uFFFF]|$))|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/,
        lookbehind: !0
      }
    ],
    // Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
    function: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/,
    number: {
      pattern: RegExp(
        /(^|[^\w$])/.source + "(?:" + // constant
        (/NaN|Infinity/.source + "|" + // binary integer
        /0[bB][01]+(?:_[01]+)*n?/.source + "|" + // octal integer
        /0[oO][0-7]+(?:_[0-7]+)*n?/.source + "|" + // hexadecimal integer
        /0[xX][\dA-Fa-f]+(?:_[\dA-Fa-f]+)*n?/.source + "|" + // decimal bigint
        /\d+(?:_\d+)*n/.source + "|" + // decimal number (integer or float) but no bigint
        /(?:\d+(?:_\d+)*(?:\.(?:\d+(?:_\d+)*)?)?|\.\d+(?:_\d+)*)(?:[Ee][+-]?\d+(?:_\d+)*)?/.source) + ")" + /(?![\w$])/.source
      ),
      lookbehind: !0
    },
    operator: /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/
  }), t.languages.javascript["class-name"][0].pattern = /(\b(?:class|extends|implements|instanceof|interface|new)\s+)[\w.\\]+/, t.languages.insertBefore("javascript", "keyword", {
    regex: {
      pattern: RegExp(
        // lookbehind
        // eslint-disable-next-line regexp/no-dupe-characters-character-class
        /((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)/.source + // Regex pattern:
        // There are 2 regex patterns here. The RegExp set notation proposal added support for nested character
        // classes if the `v` flag is present. Unfortunately, nested CCs are both context-free and incompatible
        // with the only syntax, so we have to define 2 different regex patterns.
        /\//.source + "(?:" + /(?:\[(?:[^\]\\\r\n]|\\.)*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}/.source + "|" + // `v` flag syntax. This supports 3 levels of nested character classes.
        /(?:\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.)*\])*\])*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}v[dgimyus]{0,7}/.source + ")" + // lookahead
        /(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/.source
      ),
      lookbehind: !0,
      greedy: !0,
      inside: {
        "regex-source": {
          pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/,
          lookbehind: !0,
          alias: "language-regex",
          inside: t.languages.regex
        },
        "regex-delimiter": /^\/|\/$/,
        "regex-flags": /^[a-z]+$/
      }
    },
    // This must be declared before keyword because we use "function" inside the look-forward
    "function-variable": {
      pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/,
      alias: "function"
    },
    parameter: [
      {
        pattern: /(function(?:\s+(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)?\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\))/,
        lookbehind: !0,
        inside: t.languages.javascript
      },
      {
        pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=>)/i,
        lookbehind: !0,
        inside: t.languages.javascript
      },
      {
        pattern: /(\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*=>)/,
        lookbehind: !0,
        inside: t.languages.javascript
      },
      {
        pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*\{)/,
        lookbehind: !0,
        inside: t.languages.javascript
      }
    ],
    constant: /\b[A-Z](?:[A-Z_]|\dx?)*\b/
  }), t.languages.insertBefore("javascript", "string", {
    hashbang: {
      pattern: /^#!.*/,
      greedy: !0,
      alias: "comment"
    },
    "template-string": {
      pattern: /`(?:\\[\s\S]|\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}|(?!\$\{)[^\\`])*`/,
      greedy: !0,
      inside: {
        "template-punctuation": {
          pattern: /^`|`$/,
          alias: "string"
        },
        interpolation: {
          pattern: /((?:^|[^\\])(?:\\{2})*)\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}/,
          lookbehind: !0,
          inside: {
            "interpolation-punctuation": {
              pattern: /^\$\{|\}$/,
              alias: "punctuation"
            },
            rest: t.languages.javascript
          }
        },
        string: /[\s\S]+/
      }
    },
    "string-property": {
      pattern: /((?:^|[,{])[ \t]*)(["'])(?:\\(?:\r\n|[\s\S])|(?!\2)[^\\\r\n])*\2(?=\s*:)/m,
      lookbehind: !0,
      greedy: !0,
      alias: "property"
    }
  }), t.languages.insertBefore("javascript", "operator", {
    "literal-property": {
      pattern: /((?:^|[,{])[ \t]*)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*:)/m,
      lookbehind: !0,
      alias: "property"
    }
  }), t.languages.markup && (t.languages.markup.tag.addInlined("script", "javascript"), t.languages.markup.tag.addAttribute(
    /on(?:abort|blur|change|click|composition(?:end|start|update)|dblclick|error|focus(?:in|out)?|key(?:down|up)|load|mouse(?:down|enter|leave|move|out|over|up)|reset|resize|scroll|select|slotchange|submit|unload|wheel)/.source,
    "javascript"
  )), t.languages.js = t.languages.javascript, function() {
    if (typeof t > "u" || typeof document > "u")
      return;
    Element.prototype.matches || (Element.prototype.matches = Element.prototype.msMatchesSelector || Element.prototype.webkitMatchesSelector);
    var r = "Loading…", i = function(v, k) {
      return "✖ Error " + v + " while fetching file: " + k;
    }, s = "✖ Error: File does not exist or is empty", l = {
      js: "javascript",
      py: "python",
      rb: "ruby",
      ps1: "powershell",
      psm1: "powershell",
      sh: "bash",
      bat: "batch",
      h: "c",
      tex: "latex"
    }, o = "data-src-status", a = "loading", u = "loaded", h = "failed", c = "pre[data-src]:not([" + o + '="' + u + '"]):not([' + o + '="' + a + '"])';
    function f(v, k, S) {
      var x = new XMLHttpRequest();
      x.open("GET", v, !0), x.onreadystatechange = function() {
        x.readyState == 4 && (x.status < 400 && x.responseText ? k(x.responseText) : x.status >= 400 ? S(i(x.status, x.statusText)) : S(s));
      }, x.send(null);
    }
    function m(v) {
      var k = /^\s*(\d+)\s*(?:(,)\s*(?:(\d+)\s*)?)?$/.exec(v || "");
      if (k) {
        var S = Number(k[1]), x = k[2], y = k[3];
        return x ? y ? [S, Number(y)] : [S, void 0] : [S, S];
      }
    }
    t.hooks.add("before-highlightall", function(v) {
      v.selector += ", " + c;
    }), t.hooks.add("before-sanity-check", function(v) {
      var k = (
        /** @type {HTMLPreElement} */
        v.element
      );
      if (k.matches(c)) {
        v.code = "", k.setAttribute(o, a);
        var S = k.appendChild(document.createElement("CODE"));
        S.textContent = r;
        var x = k.getAttribute("data-src"), y = v.language;
        if (y === "none") {
          var A = (/\.(\w+)$/.exec(x) || [, "none"])[1];
          y = l[A] || A;
        }
        t.util.setLanguage(S, y), t.util.setLanguage(k, y);
        var C = t.plugins.autoloader;
        C && C.loadLanguages(y), f(
          x,
          function(T) {
            k.setAttribute(o, u);
            var M = m(k.getAttribute("data-range"));
            if (M) {
              var L = T.split(/\r\n?|\n/g), R = M[0], N = M[1] == null ? L.length : M[1];
              R < 0 && (R += L.length), R = Math.max(0, Math.min(R - 1, L.length)), N < 0 && (N += L.length), N = Math.max(0, Math.min(N, L.length)), T = L.slice(R, N).join(`
`), k.hasAttribute("data-start") || k.setAttribute("data-start", String(R + 1));
            }
            S.textContent = T, t.highlightElement(S);
          },
          function(T) {
            k.setAttribute(o, h), S.textContent = T;
          }
        );
      }
    }), t.plugins.fileHighlight = {
      /**
       * Executes the File Highlight plugin for all matching `pre` elements under the given container.
       *
       * Note: Elements which are already loaded or currently loading will not be touched by this method.
       *
       * @param {ParentNode} [container=document]
       */
      highlight: function(k) {
        for (var S = (k || document).querySelectorAll(c), x = 0, y; y = S[x++]; )
          t.highlightElement(y);
      }
    };
    var g = !1;
    t.fileHighlight = function() {
      g || (console.warn("Prism.fileHighlight is deprecated. Use `Prism.plugins.fileHighlight.highlight` instead."), g = !0), t.plugins.fileHighlight.highlight.apply(this, arguments);
    };
  }();
})(sS);
Prism.languages.python = {
  comment: {
    pattern: /(^|[^\\])#.*/,
    lookbehind: !0,
    greedy: !0
  },
  "string-interpolation": {
    pattern: /(?:f|fr|rf)(?:("""|''')[\s\S]*?\1|("|')(?:\\.|(?!\2)[^\\\r\n])*\2)/i,
    greedy: !0,
    inside: {
      interpolation: {
        // "{" <expression> <optional "!s", "!r", or "!a"> <optional ":" format specifier> "}"
        pattern: /((?:^|[^{])(?:\{\{)*)\{(?!\{)(?:[^{}]|\{(?!\{)(?:[^{}]|\{(?!\{)(?:[^{}])+\})+\})+\}/,
        lookbehind: !0,
        inside: {
          "format-spec": {
            pattern: /(:)[^:(){}]+(?=\}$)/,
            lookbehind: !0
          },
          "conversion-option": {
            pattern: /![sra](?=[:}]$)/,
            alias: "punctuation"
          },
          rest: null
        }
      },
      string: /[\s\S]+/
    }
  },
  "triple-quoted-string": {
    pattern: /(?:[rub]|br|rb)?("""|''')[\s\S]*?\1/i,
    greedy: !0,
    alias: "string"
  },
  string: {
    pattern: /(?:[rub]|br|rb)?("|')(?:\\.|(?!\1)[^\\\r\n])*\1/i,
    greedy: !0
  },
  function: {
    pattern: /((?:^|\s)def[ \t]+)[a-zA-Z_]\w*(?=\s*\()/g,
    lookbehind: !0
  },
  "class-name": {
    pattern: /(\bclass\s+)\w+/i,
    lookbehind: !0
  },
  decorator: {
    pattern: /(^[\t ]*)@\w+(?:\.\w+)*/m,
    lookbehind: !0,
    alias: ["annotation", "punctuation"],
    inside: {
      punctuation: /\./
    }
  },
  keyword: /\b(?:_(?=\s*:)|and|as|assert|async|await|break|case|class|continue|def|del|elif|else|except|exec|finally|for|from|global|if|import|in|is|lambda|match|nonlocal|not|or|pass|print|raise|return|try|while|with|yield)\b/,
  builtin: /\b(?:__import__|abs|all|any|apply|ascii|basestring|bin|bool|buffer|bytearray|bytes|callable|chr|classmethod|cmp|coerce|compile|complex|delattr|dict|dir|divmod|enumerate|eval|execfile|file|filter|float|format|frozenset|getattr|globals|hasattr|hash|help|hex|id|input|int|intern|isinstance|issubclass|iter|len|list|locals|long|map|max|memoryview|min|next|object|oct|open|ord|pow|property|range|raw_input|reduce|reload|repr|reversed|round|set|setattr|slice|sorted|staticmethod|str|sum|super|tuple|type|unichr|unicode|vars|xrange|zip)\b/,
  boolean: /\b(?:False|None|True)\b/,
  number: /\b0(?:b(?:_?[01])+|o(?:_?[0-7])+|x(?:_?[a-f0-9])+)\b|(?:\b\d+(?:_\d+)*(?:\.(?:\d+(?:_\d+)*)?)?|\B\.\d+(?:_\d+)*)(?:e[+-]?\d+(?:_\d+)*)?j?(?!\w)/i,
  operator: /[-+%=]=?|!=|:=|\*\*?=?|\/\/?=?|<[<=>]?|>[=>]?|[&|^~]/,
  punctuation: /[{}[\];(),.:]/
};
Prism.languages.python["string-interpolation"].inside.interpolation.inside.rest = Prism.languages.python;
Prism.languages.py = Prism.languages.python;
(function(n) {
  var e = /\\(?:[^a-z()[\]]|[a-z*]+)/i, t = {
    "equation-command": {
      pattern: e,
      alias: "regex"
    }
  };
  n.languages.latex = {
    comment: /%.*/,
    // the verbatim environment prints whitespace to the document
    cdata: {
      pattern: /(\\begin\{((?:lstlisting|verbatim)\*?)\})[\s\S]*?(?=\\end\{\2\})/,
      lookbehind: !0
    },
    /*
     * equations can be between $$ $$ or $ $ or \( \) or \[ \]
     * (all are multiline)
     */
    equation: [
      {
        pattern: /\$\$(?:\\[\s\S]|[^\\$])+\$\$|\$(?:\\[\s\S]|[^\\$])+\$|\\\([\s\S]*?\\\)|\\\[[\s\S]*?\\\]/,
        inside: t,
        alias: "string"
      },
      {
        pattern: /(\\begin\{((?:align|eqnarray|equation|gather|math|multline)\*?)\})[\s\S]*?(?=\\end\{\2\})/,
        lookbehind: !0,
        inside: t,
        alias: "string"
      }
    ],
    /*
     * arguments which are keywords or references are highlighted
     * as keywords
     */
    keyword: {
      pattern: /(\\(?:begin|cite|documentclass|end|label|ref|usepackage)(?:\[[^\]]+\])?\{)[^}]+(?=\})/,
      lookbehind: !0
    },
    url: {
      pattern: /(\\url\{)[^}]+(?=\})/,
      lookbehind: !0
    },
    /*
     * section or chapter headlines are highlighted as bold so that
     * they stand out more
     */
    headline: {
      pattern: /(\\(?:chapter|frametitle|paragraph|part|section|subparagraph|subsection|subsubparagraph|subsubsection|subsubsubparagraph)\*?(?:\[[^\]]+\])?\{)[^}]+(?=\})/,
      lookbehind: !0,
      alias: "class-name"
    },
    function: {
      pattern: e,
      alias: "selector"
    },
    punctuation: /[[\]{}&]/
  }, n.languages.tex = n.languages.latex, n.languages.context = n.languages.latex;
})(Prism);
(function(n) {
  var e = "\\b(?:BASH|BASHOPTS|BASH_ALIASES|BASH_ARGC|BASH_ARGV|BASH_CMDS|BASH_COMPLETION_COMPAT_DIR|BASH_LINENO|BASH_REMATCH|BASH_SOURCE|BASH_VERSINFO|BASH_VERSION|COLORTERM|COLUMNS|COMP_WORDBREAKS|DBUS_SESSION_BUS_ADDRESS|DEFAULTS_PATH|DESKTOP_SESSION|DIRSTACK|DISPLAY|EUID|GDMSESSION|GDM_LANG|GNOME_KEYRING_CONTROL|GNOME_KEYRING_PID|GPG_AGENT_INFO|GROUPS|HISTCONTROL|HISTFILE|HISTFILESIZE|HISTSIZE|HOME|HOSTNAME|HOSTTYPE|IFS|INSTANCE|JOB|LANG|LANGUAGE|LC_ADDRESS|LC_ALL|LC_IDENTIFICATION|LC_MEASUREMENT|LC_MONETARY|LC_NAME|LC_NUMERIC|LC_PAPER|LC_TELEPHONE|LC_TIME|LESSCLOSE|LESSOPEN|LINES|LOGNAME|LS_COLORS|MACHTYPE|MAILCHECK|MANDATORY_PATH|NO_AT_BRIDGE|OLDPWD|OPTERR|OPTIND|ORBIT_SOCKETDIR|OSTYPE|PAPERSIZE|PATH|PIPESTATUS|PPID|PS1|PS2|PS3|PS4|PWD|RANDOM|REPLY|SECONDS|SELINUX_INIT|SESSION|SESSIONTYPE|SESSION_MANAGER|SHELL|SHELLOPTS|SHLVL|SSH_AUTH_SOCK|TERM|UID|UPSTART_EVENTS|UPSTART_INSTANCE|UPSTART_JOB|UPSTART_SESSION|USER|WINDOWID|XAUTHORITY|XDG_CONFIG_DIRS|XDG_CURRENT_DESKTOP|XDG_DATA_DIRS|XDG_GREETER_DATA_DIR|XDG_MENU_PREFIX|XDG_RUNTIME_DIR|XDG_SEAT|XDG_SEAT_PATH|XDG_SESSION_DESKTOP|XDG_SESSION_ID|XDG_SESSION_PATH|XDG_SESSION_TYPE|XDG_VTNR|XMODIFIERS)\\b", t = {
    pattern: /(^(["']?)\w+\2)[ \t]+\S.*/,
    lookbehind: !0,
    alias: "punctuation",
    // this looks reasonably well in all themes
    inside: null
    // see below
  }, r = {
    bash: t,
    environment: {
      pattern: RegExp("\\$" + e),
      alias: "constant"
    },
    variable: [
      // [0]: Arithmetic Environment
      {
        pattern: /\$?\(\([\s\S]+?\)\)/,
        greedy: !0,
        inside: {
          // If there is a $ sign at the beginning highlight $(( and )) as variable
          variable: [
            {
              pattern: /(^\$\(\([\s\S]+)\)\)/,
              lookbehind: !0
            },
            /^\$\(\(/
          ],
          number: /\b0x[\dA-Fa-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:[Ee]-?\d+)?/,
          // Operators according to https://www.gnu.org/software/bash/manual/bashref.html#Shell-Arithmetic
          operator: /--|\+\+|\*\*=?|<<=?|>>=?|&&|\|\||[=!+\-*/%<>^&|]=?|[?~:]/,
          // If there is no $ sign at the beginning highlight (( and )) as punctuation
          punctuation: /\(\(?|\)\)?|,|;/
        }
      },
      // [1]: Command Substitution
      {
        pattern: /\$\((?:\([^)]+\)|[^()])+\)|`[^`]+`/,
        greedy: !0,
        inside: {
          variable: /^\$\(|^`|\)$|`$/
        }
      },
      // [2]: Brace expansion
      {
        pattern: /\$\{[^}]+\}/,
        greedy: !0,
        inside: {
          operator: /:[-=?+]?|[!\/]|##?|%%?|\^\^?|,,?/,
          punctuation: /[\[\]]/,
          environment: {
            pattern: RegExp("(\\{)" + e),
            lookbehind: !0,
            alias: "constant"
          }
        }
      },
      /\$(?:\w+|[#?*!@$])/
    ],
    // Escape sequences from echo and printf's manuals, and escaped quotes.
    entity: /\\(?:[abceEfnrtv\\"]|O?[0-7]{1,3}|U[0-9a-fA-F]{8}|u[0-9a-fA-F]{4}|x[0-9a-fA-F]{1,2})/
  };
  n.languages.bash = {
    shebang: {
      pattern: /^#!\s*\/.*/,
      alias: "important"
    },
    comment: {
      pattern: /(^|[^"{\\$])#.*/,
      lookbehind: !0
    },
    "function-name": [
      // a) function foo {
      // b) foo() {
      // c) function foo() {
      // but not “foo {”
      {
        // a) and c)
        pattern: /(\bfunction\s+)[\w-]+(?=(?:\s*\(?:\s*\))?\s*\{)/,
        lookbehind: !0,
        alias: "function"
      },
      {
        // b)
        pattern: /\b[\w-]+(?=\s*\(\s*\)\s*\{)/,
        alias: "function"
      }
    ],
    // Highlight variable names as variables in for and select beginnings.
    "for-or-select": {
      pattern: /(\b(?:for|select)\s+)\w+(?=\s+in\s)/,
      alias: "variable",
      lookbehind: !0
    },
    // Highlight variable names as variables in the left-hand part
    // of assignments (“=” and “+=”).
    "assign-left": {
      pattern: /(^|[\s;|&]|[<>]\()\w+(?:\.\w+)*(?=\+?=)/,
      inside: {
        environment: {
          pattern: RegExp("(^|[\\s;|&]|[<>]\\()" + e),
          lookbehind: !0,
          alias: "constant"
        }
      },
      alias: "variable",
      lookbehind: !0
    },
    // Highlight parameter names as variables
    parameter: {
      pattern: /(^|\s)-{1,2}(?:\w+:[+-]?)?\w+(?:\.\w+)*(?=[=\s]|$)/,
      alias: "variable",
      lookbehind: !0
    },
    string: [
      // Support for Here-documents https://en.wikipedia.org/wiki/Here_document
      {
        pattern: /((?:^|[^<])<<-?\s*)(\w+)\s[\s\S]*?(?:\r?\n|\r)\2/,
        lookbehind: !0,
        greedy: !0,
        inside: r
      },
      // Here-document with quotes around the tag
      // → No expansion (so no “inside”).
      {
        pattern: /((?:^|[^<])<<-?\s*)(["'])(\w+)\2\s[\s\S]*?(?:\r?\n|\r)\3/,
        lookbehind: !0,
        greedy: !0,
        inside: {
          bash: t
        }
      },
      // “Normal” string
      {
        // https://www.gnu.org/software/bash/manual/html_node/Double-Quotes.html
        pattern: /(^|[^\\](?:\\\\)*)"(?:\\[\s\S]|\$\([^)]+\)|\$(?!\()|`[^`]+`|[^"\\`$])*"/,
        lookbehind: !0,
        greedy: !0,
        inside: r
      },
      {
        // https://www.gnu.org/software/bash/manual/html_node/Single-Quotes.html
        pattern: /(^|[^$\\])'[^']*'/,
        lookbehind: !0,
        greedy: !0
      },
      {
        // https://www.gnu.org/software/bash/manual/html_node/ANSI_002dC-Quoting.html
        pattern: /\$'(?:[^'\\]|\\[\s\S])*'/,
        greedy: !0,
        inside: {
          entity: r.entity
        }
      }
    ],
    environment: {
      pattern: RegExp("\\$?" + e),
      alias: "constant"
    },
    variable: r.variable,
    function: {
      pattern: /(^|[\s;|&]|[<>]\()(?:add|apropos|apt|apt-cache|apt-get|aptitude|aspell|automysqlbackup|awk|basename|bash|bc|bconsole|bg|bzip2|cal|cargo|cat|cfdisk|chgrp|chkconfig|chmod|chown|chroot|cksum|clear|cmp|column|comm|composer|cp|cron|crontab|csplit|curl|cut|date|dc|dd|ddrescue|debootstrap|df|diff|diff3|dig|dir|dircolors|dirname|dirs|dmesg|docker|docker-compose|du|egrep|eject|env|ethtool|expand|expect|expr|fdformat|fdisk|fg|fgrep|file|find|fmt|fold|format|free|fsck|ftp|fuser|gawk|git|gparted|grep|groupadd|groupdel|groupmod|groups|grub-mkconfig|gzip|halt|head|hg|history|host|hostname|htop|iconv|id|ifconfig|ifdown|ifup|import|install|ip|java|jobs|join|kill|killall|less|link|ln|locate|logname|logrotate|look|lpc|lpr|lprint|lprintd|lprintq|lprm|ls|lsof|lynx|make|man|mc|mdadm|mkconfig|mkdir|mke2fs|mkfifo|mkfs|mkisofs|mknod|mkswap|mmv|more|most|mount|mtools|mtr|mutt|mv|nano|nc|netstat|nice|nl|node|nohup|notify-send|npm|nslookup|op|open|parted|passwd|paste|pathchk|ping|pkill|pnpm|podman|podman-compose|popd|pr|printcap|printenv|ps|pushd|pv|quota|quotacheck|quotactl|ram|rar|rcp|reboot|remsync|rename|renice|rev|rm|rmdir|rpm|rsync|scp|screen|sdiff|sed|sendmail|seq|service|sftp|sh|shellcheck|shuf|shutdown|sleep|slocate|sort|split|ssh|stat|strace|su|sudo|sum|suspend|swapon|sync|sysctl|tac|tail|tar|tee|time|timeout|top|touch|tr|traceroute|tsort|tty|umount|uname|unexpand|uniq|units|unrar|unshar|unzip|update-grub|uptime|useradd|userdel|usermod|users|uudecode|uuencode|v|vcpkg|vdir|vi|vim|virsh|vmstat|wait|watch|wc|wget|whereis|which|who|whoami|write|xargs|xdg-open|yarn|yes|zenity|zip|zsh|zypper)(?=$|[)\s;|&])/,
      lookbehind: !0
    },
    keyword: {
      pattern: /(^|[\s;|&]|[<>]\()(?:case|do|done|elif|else|esac|fi|for|function|if|in|select|then|until|while)(?=$|[)\s;|&])/,
      lookbehind: !0
    },
    // https://www.gnu.org/software/bash/manual/html_node/Shell-Builtin-Commands.html
    builtin: {
      pattern: /(^|[\s;|&]|[<>]\()(?:\.|:|alias|bind|break|builtin|caller|cd|command|continue|declare|echo|enable|eval|exec|exit|export|getopts|hash|help|let|local|logout|mapfile|printf|pwd|read|readarray|readonly|return|set|shift|shopt|source|test|times|trap|type|typeset|ulimit|umask|unalias|unset)(?=$|[)\s;|&])/,
      lookbehind: !0,
      // Alias added to make those easier to distinguish from strings.
      alias: "class-name"
    },
    boolean: {
      pattern: /(^|[\s;|&]|[<>]\()(?:false|true)(?=$|[)\s;|&])/,
      lookbehind: !0
    },
    "file-descriptor": {
      pattern: /\B&\d\b/,
      alias: "important"
    },
    operator: {
      // Lots of redirections here, but not just that.
      pattern: /\d?<>|>\||\+=|=[=~]?|!=?|<<[<-]?|[&\d]?>>|\d[<>]&?|[<>][&=]?|&[>&]?|\|[&|]?/,
      inside: {
        "file-descriptor": {
          pattern: /^\d/,
          alias: "important"
        }
      }
    },
    punctuation: /\$?\(\(?|\)\)?|\.\.|[{}[\];\\]/,
    number: {
      pattern: /(^|\s)(?:[1-9]\d*|0)(?:[.,]\d+)?\b/,
      lookbehind: !0
    }
  }, t.inside = n.languages.bash;
  for (var i = [
    "comment",
    "function-name",
    "for-or-select",
    "assign-left",
    "parameter",
    "string",
    "environment",
    "function",
    "keyword",
    "builtin",
    "boolean",
    "file-descriptor",
    "operator",
    "punctuation",
    "number"
  ], s = r.variable[1].inside, l = 0; l < i.length; l++)
    s[i[l]] = n.languages.bash[i[l]];
  n.languages.sh = n.languages.bash, n.languages.shell = n.languages.bash;
})(Prism);
new t5();
const lS = (n) => {
  const e = {};
  for (let t = 0, r = n.length; t < r; t++) {
    const i = n[t];
    for (const s in i)
      e[s] ? e[s] = e[s].concat(i[s]) : e[s] = i[s];
  }
  return e;
}, oS = [
  "a",
  "abbr",
  "acronym",
  "address",
  "area",
  "article",
  "aside",
  "audio",
  "b",
  "bdi",
  "bdo",
  "bgsound",
  "big",
  "blockquote",
  "body",
  "br",
  "button",
  "canvas",
  "caption",
  "center",
  "cite",
  "code",
  "col",
  "colgroup",
  "datalist",
  "dd",
  "del",
  "details",
  "dfn",
  "dialog",
  "dir",
  "div",
  "dl",
  "dt",
  "em",
  "fieldset",
  "figcaption",
  "figure",
  "font",
  "footer",
  "form",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "head",
  "header",
  "hgroup",
  "hr",
  "html",
  "i",
  "img",
  "input",
  "ins",
  "kbd",
  "keygen",
  "label",
  "layer",
  "legend",
  "li",
  "link",
  "listing",
  "main",
  "map",
  "mark",
  "marquee",
  "menu",
  "meta",
  "meter",
  "nav",
  "nobr",
  "ol",
  "optgroup",
  "option",
  "output",
  "p",
  "picture",
  "popup",
  "pre",
  "progress",
  "q",
  "rb",
  "rp",
  "rt",
  "rtc",
  "ruby",
  "s",
  "samp",
  "section",
  "select",
  "selectmenu",
  "small",
  "source",
  "span",
  "strike",
  "strong",
  "style",
  "sub",
  "summary",
  "sup",
  "table",
  "tbody",
  "td",
  "tfoot",
  "th",
  "thead",
  "time",
  "tr",
  "track",
  "tt",
  "u",
  "ul",
  "var",
  "video",
  "wbr"
], aS = [
  "svg",
  "a",
  "altglyph",
  "altglyphdef",
  "altglyphitem",
  "animatecolor",
  "animatemotion",
  "animatetransform",
  "circle",
  "clippath",
  "defs",
  "desc",
  "ellipse",
  "filter",
  "font",
  "g",
  "glyph",
  "glyphref",
  "hkern",
  "image",
  "line",
  "lineargradient",
  "marker",
  "mask",
  "metadata",
  "mpath",
  "path",
  "pattern",
  "polygon",
  "polyline",
  "radialgradient",
  "rect",
  "stop",
  "style",
  "switch",
  "symbol",
  "text",
  "textpath",
  "title",
  "tref",
  "tspan",
  "view",
  "vkern",
  /* FILTERS */
  "feBlend",
  "feColorMatrix",
  "feComponentTransfer",
  "feComposite",
  "feConvolveMatrix",
  "feDiffuseLighting",
  "feDisplacementMap",
  "feDistantLight",
  "feFlood",
  "feFuncA",
  "feFuncB",
  "feFuncG",
  "feFuncR",
  "feGaussianBlur",
  "feImage",
  "feMerge",
  "feMergeNode",
  "feMorphology",
  "feOffset",
  "fePointLight",
  "feSpecularLighting",
  "feSpotLight",
  "feTile",
  "feTurbulence"
], uS = [
  "math",
  "menclose",
  "merror",
  "mfenced",
  "mfrac",
  "mglyph",
  "mi",
  "mlabeledtr",
  "mmultiscripts",
  "mn",
  "mo",
  "mover",
  "mpadded",
  "mphantom",
  "mroot",
  "mrow",
  "ms",
  "mspace",
  "msqrt",
  "mstyle",
  "msub",
  "msup",
  "msubsup",
  "mtable",
  "mtd",
  "mtext",
  "mtr",
  "munder",
  "munderover"
], hS = [
  "abbr",
  "accept",
  "accept-charset",
  "accesskey",
  "action",
  "align",
  "alink",
  "allow",
  "allowfullscreen",
  "alt",
  "anchor",
  "archive",
  "as",
  "async",
  "autocapitalize",
  "autocomplete",
  "autocorrect",
  "autofocus",
  "autopictureinpicture",
  "autoplay",
  "axis",
  "background",
  "behavior",
  "bgcolor",
  "border",
  "bordercolor",
  "capture",
  "cellpadding",
  "cellspacing",
  "challenge",
  "char",
  "charoff",
  "charset",
  "checked",
  "cite",
  "class",
  "classid",
  "clear",
  "code",
  "codebase",
  "codetype",
  "color",
  "cols",
  "colspan",
  "compact",
  "content",
  "contenteditable",
  "controls",
  "controlslist",
  "conversiondestination",
  "coords",
  "crossorigin",
  "csp",
  "data",
  "datetime",
  "declare",
  "decoding",
  "default",
  "defer",
  "dir",
  "direction",
  "dirname",
  "disabled",
  "disablepictureinpicture",
  "disableremoteplayback",
  "disallowdocumentaccess",
  "download",
  "draggable",
  "elementtiming",
  "enctype",
  "end",
  "enterkeyhint",
  "event",
  "exportparts",
  "face",
  "for",
  "form",
  "formaction",
  "formenctype",
  "formmethod",
  "formnovalidate",
  "formtarget",
  "frame",
  "frameborder",
  "headers",
  "height",
  "hidden",
  "high",
  "href",
  "hreflang",
  "hreftranslate",
  "hspace",
  "http-equiv",
  "id",
  "imagesizes",
  "imagesrcset",
  "importance",
  "impressiondata",
  "impressionexpiry",
  "incremental",
  "inert",
  "inputmode",
  "integrity",
  "invisible",
  "ismap",
  "keytype",
  "kind",
  "label",
  "lang",
  "language",
  "latencyhint",
  "leftmargin",
  "link",
  "list",
  "loading",
  "longdesc",
  "loop",
  "low",
  "lowsrc",
  "manifest",
  "marginheight",
  "marginwidth",
  "max",
  "maxlength",
  "mayscript",
  "media",
  "method",
  "min",
  "minlength",
  "multiple",
  "muted",
  "name",
  "nohref",
  "nomodule",
  "nonce",
  "noresize",
  "noshade",
  "novalidate",
  "nowrap",
  "object",
  "open",
  "optimum",
  "part",
  "pattern",
  "ping",
  "placeholder",
  "playsinline",
  "policy",
  "poster",
  "preload",
  "pseudo",
  "readonly",
  "referrerpolicy",
  "rel",
  "reportingorigin",
  "required",
  "resources",
  "rev",
  "reversed",
  "role",
  "rows",
  "rowspan",
  "rules",
  "sandbox",
  "scheme",
  "scope",
  "scopes",
  "scrollamount",
  "scrolldelay",
  "scrolling",
  "select",
  "selected",
  "shadowroot",
  "shadowrootdelegatesfocus",
  "shape",
  "size",
  "sizes",
  "slot",
  "span",
  "spellcheck",
  "src",
  "srclang",
  "srcset",
  "standby",
  "start",
  "step",
  "style",
  "summary",
  "tabindex",
  "target",
  "text",
  "title",
  "topmargin",
  "translate",
  "truespeed",
  "trusttoken",
  "type",
  "usemap",
  "valign",
  "value",
  "valuetype",
  "version",
  "virtualkeyboardpolicy",
  "vlink",
  "vspace",
  "webkitdirectory",
  "width",
  "wrap"
], cS = [
  "accent-height",
  "accumulate",
  "additive",
  "alignment-baseline",
  "ascent",
  "attributename",
  "attributetype",
  "azimuth",
  "basefrequency",
  "baseline-shift",
  "begin",
  "bias",
  "by",
  "class",
  "clip",
  "clippathunits",
  "clip-path",
  "clip-rule",
  "color",
  "color-interpolation",
  "color-interpolation-filters",
  "color-profile",
  "color-rendering",
  "cx",
  "cy",
  "d",
  "dx",
  "dy",
  "diffuseconstant",
  "direction",
  "display",
  "divisor",
  "dominant-baseline",
  "dur",
  "edgemode",
  "elevation",
  "end",
  "fill",
  "fill-opacity",
  "fill-rule",
  "filter",
  "filterunits",
  "flood-color",
  "flood-opacity",
  "font-family",
  "font-size",
  "font-size-adjust",
  "font-stretch",
  "font-style",
  "font-variant",
  "font-weight",
  "fx",
  "fy",
  "g1",
  "g2",
  "glyph-name",
  "glyphref",
  "gradientunits",
  "gradienttransform",
  "height",
  "href",
  "id",
  "image-rendering",
  "in",
  "in2",
  "k",
  "k1",
  "k2",
  "k3",
  "k4",
  "kerning",
  "keypoints",
  "keysplines",
  "keytimes",
  "lang",
  "lengthadjust",
  "letter-spacing",
  "kernelmatrix",
  "kernelunitlength",
  "lighting-color",
  "local",
  "marker-end",
  "marker-mid",
  "marker-start",
  "markerheight",
  "markerunits",
  "markerwidth",
  "maskcontentunits",
  "maskunits",
  "max",
  "mask",
  "media",
  "method",
  "mode",
  "min",
  "name",
  "numoctaves",
  "offset",
  "operator",
  "opacity",
  "order",
  "orient",
  "orientation",
  "origin",
  "overflow",
  "paint-order",
  "path",
  "pathlength",
  "patterncontentunits",
  "patterntransform",
  "patternunits",
  "points",
  "preservealpha",
  "preserveaspectratio",
  "primitiveunits",
  "r",
  "rx",
  "ry",
  "radius",
  "refx",
  "refy",
  "repeatcount",
  "repeatdur",
  "restart",
  "result",
  "rotate",
  "scale",
  "seed",
  "shape-rendering",
  "specularconstant",
  "specularexponent",
  "spreadmethod",
  "startoffset",
  "stddeviation",
  "stitchtiles",
  "stop-color",
  "stop-opacity",
  "stroke-dasharray",
  "stroke-dashoffset",
  "stroke-linecap",
  "stroke-linejoin",
  "stroke-miterlimit",
  "stroke-opacity",
  "stroke",
  "stroke-width",
  "style",
  "surfacescale",
  "systemlanguage",
  "tabindex",
  "targetx",
  "targety",
  "transform",
  "transform-origin",
  "text-anchor",
  "text-decoration",
  "text-rendering",
  "textlength",
  "type",
  "u1",
  "u2",
  "unicode",
  "values",
  "viewbox",
  "visibility",
  "version",
  "vert-adv-y",
  "vert-origin-x",
  "vert-origin-y",
  "width",
  "word-spacing",
  "wrap",
  "writing-mode",
  "xchannelselector",
  "ychannelselector",
  "x",
  "x1",
  "x2",
  "xmlns",
  "y",
  "y1",
  "y2",
  "z",
  "zoomandpan"
], fS = [
  "accent",
  "accentunder",
  "align",
  "bevelled",
  "close",
  "columnsalign",
  "columnlines",
  "columnspan",
  "denomalign",
  "depth",
  "dir",
  "display",
  "displaystyle",
  "encoding",
  "fence",
  "frame",
  "height",
  "href",
  "id",
  "largeop",
  "length",
  "linethickness",
  "lspace",
  "lquote",
  "mathbackground",
  "mathcolor",
  "mathsize",
  "mathvariant",
  "maxsize",
  "minsize",
  "movablelimits",
  "notation",
  "numalign",
  "open",
  "rowalign",
  "rowlines",
  "rowspacing",
  "rowspan",
  "rspace",
  "rquote",
  "scriptlevel",
  "scriptminsize",
  "scriptsizemultiplier",
  "selection",
  "separator",
  "separators",
  "stretchy",
  "subscriptshift",
  "supscriptshift",
  "symmetric",
  "voffset",
  "width",
  "xmlns"
];
[
  ...oS,
  ...aS.map((n) => `svg:${n}`),
  ...uS.map((n) => `math:${n}`)
], lS([
  Object.fromEntries(hS.map((n) => [n, ["*"]])),
  Object.fromEntries(cS.map((n) => [n, ["svg:*"]])),
  Object.fromEntries(fS.map((n) => [n, ["math:*"]]))
]);
const {
  SvelteComponent: dS,
  append_hydration: B0,
  attr: so,
  children: nm,
  claim_component: mS,
  claim_element: im,
  claim_space: pS,
  claim_text: gS,
  create_component: bS,
  destroy_component: vS,
  detach: O0,
  element: sm,
  init: yS,
  insert_hydration: wS,
  mount_component: kS,
  safe_not_equal: xS,
  set_data: SS,
  space: AS,
  text: DS,
  toggle_class: Sn,
  transition_in: CS,
  transition_out: _S
} = window.__gradio__svelte__internal;
function MS(n) {
  let e, t, r, i, s, l;
  return r = new /*Icon*/
  n[1]({}), {
    c() {
      e = sm("label"), t = sm("span"), bS(r.$$.fragment), i = AS(), s = DS(
        /*label*/
        n[0]
      ), this.h();
    },
    l(o) {
      e = im(o, "LABEL", {
        for: !0,
        "data-testid": !0,
        class: !0
      });
      var a = nm(e);
      t = im(a, "SPAN", { class: !0 });
      var u = nm(t);
      mS(r.$$.fragment, u), u.forEach(O0), i = pS(a), s = gS(
        a,
        /*label*/
        n[0]
      ), a.forEach(O0), this.h();
    },
    h() {
      so(t, "class", "svelte-168uj4v"), so(e, "for", ""), so(e, "data-testid", "block-label"), so(e, "class", "svelte-168uj4v"), Sn(e, "hide", !/*show_label*/
      n[2]), Sn(e, "sr-only", !/*show_label*/
      n[2]), Sn(
        e,
        "float",
        /*float*/
        n[4]
      ), Sn(
        e,
        "hide-label",
        /*disable*/
        n[3]
      );
    },
    m(o, a) {
      wS(o, e, a), B0(e, t), kS(r, t, null), B0(e, i), B0(e, s), l = !0;
    },
    p(o, [a]) {
      (!l || a & /*label*/
      1) && SS(
        s,
        /*label*/
        o[0]
      ), (!l || a & /*show_label*/
      4) && Sn(e, "hide", !/*show_label*/
      o[2]), (!l || a & /*show_label*/
      4) && Sn(e, "sr-only", !/*show_label*/
      o[2]), (!l || a & /*float*/
      16) && Sn(
        e,
        "float",
        /*float*/
        o[4]
      ), (!l || a & /*disable*/
      8) && Sn(
        e,
        "hide-label",
        /*disable*/
        o[3]
      );
    },
    i(o) {
      l || (CS(r.$$.fragment, o), l = !0);
    },
    o(o) {
      _S(r.$$.fragment, o), l = !1;
    },
    d(o) {
      o && O0(e), vS(r);
    }
  };
}
function TS(n, e, t) {
  let { label: r = null } = e, { Icon: i } = e, { show_label: s = !0 } = e, { disable: l = !1 } = e, { float: o = !0 } = e;
  return n.$$set = (a) => {
    "label" in a && t(0, r = a.label), "Icon" in a && t(1, i = a.Icon), "show_label" in a && t(2, s = a.show_label), "disable" in a && t(3, l = a.disable), "float" in a && t(4, o = a.float);
  }, [r, i, s, l, o];
}
class ES extends dS {
  constructor(e) {
    super(), yS(this, e, TS, MS, xS, {
      label: 0,
      Icon: 1,
      show_label: 2,
      disable: 3,
      float: 4
    });
  }
}
const {
  SvelteComponent: FS,
  append_hydration: Gu,
  attr: an,
  bubble: BS,
  check_outros: OS,
  children: ju,
  claim_component: RS,
  claim_element: $u,
  claim_space: LS,
  claim_text: NS,
  construct_svelte_component: lm,
  create_component: om,
  destroy_component: am,
  detach: Gs,
  element: Yu,
  group_outros: IS,
  init: zS,
  insert_hydration: r5,
  listen: PS,
  mount_component: um,
  safe_not_equal: HS,
  set_data: qS,
  set_style: lo,
  space: VS,
  text: WS,
  toggle_class: Ft,
  transition_in: hm,
  transition_out: cm
} = window.__gradio__svelte__internal;
function fm(n) {
  let e, t;
  return {
    c() {
      e = Yu("span"), t = WS(
        /*label*/
        n[1]
      ), this.h();
    },
    l(r) {
      e = $u(r, "SPAN", { class: !0 });
      var i = ju(e);
      t = NS(
        i,
        /*label*/
        n[1]
      ), i.forEach(Gs), this.h();
    },
    h() {
      an(e, "class", "svelte-vk34kx");
    },
    m(r, i) {
      r5(r, e, i), Gu(e, t);
    },
    p(r, i) {
      i & /*label*/
      2 && qS(
        t,
        /*label*/
        r[1]
      );
    },
    d(r) {
      r && Gs(e);
    }
  };
}
function US(n) {
  let e, t, r, i, s, l, o, a = (
    /*show_label*/
    n[2] && fm(n)
  );
  var u = (
    /*Icon*/
    n[0]
  );
  function h(c, f) {
    return {};
  }
  return u && (i = lm(u, h())), {
    c() {
      e = Yu("button"), a && a.c(), t = VS(), r = Yu("div"), i && om(i.$$.fragment), this.h();
    },
    l(c) {
      e = $u(c, "BUTTON", {
        "aria-label": !0,
        "aria-haspopup": !0,
        title: !0,
        class: !0
      });
      var f = ju(e);
      a && a.l(f), t = LS(f), r = $u(f, "DIV", { class: !0 });
      var m = ju(r);
      i && RS(i.$$.fragment, m), m.forEach(Gs), f.forEach(Gs), this.h();
    },
    h() {
      an(r, "class", "svelte-vk34kx"), Ft(
        r,
        "small",
        /*size*/
        n[4] === "small"
      ), Ft(
        r,
        "large",
        /*size*/
        n[4] === "large"
      ), Ft(
        r,
        "medium",
        /*size*/
        n[4] === "medium"
      ), e.disabled = /*disabled*/
      n[7], an(
        e,
        "aria-label",
        /*label*/
        n[1]
      ), an(
        e,
        "aria-haspopup",
        /*hasPopup*/
        n[8]
      ), an(
        e,
        "title",
        /*label*/
        n[1]
      ), an(e, "class", "svelte-vk34kx"), Ft(
        e,
        "pending",
        /*pending*/
        n[3]
      ), Ft(
        e,
        "padded",
        /*padded*/
        n[5]
      ), Ft(
        e,
        "highlight",
        /*highlight*/
        n[6]
      ), Ft(
        e,
        "transparent",
        /*transparent*/
        n[9]
      ), lo(e, "color", !/*disabled*/
      n[7] && /*_color*/
      n[11] ? (
        /*_color*/
        n[11]
      ) : "var(--block-label-text-color)"), lo(e, "--bg-color", /*disabled*/
      n[7] ? "auto" : (
        /*background*/
        n[10]
      ));
    },
    m(c, f) {
      r5(c, e, f), a && a.m(e, null), Gu(e, t), Gu(e, r), i && um(i, r, null), s = !0, l || (o = PS(
        e,
        "click",
        /*click_handler*/
        n[13]
      ), l = !0);
    },
    p(c, [f]) {
      if (/*show_label*/
      c[2] ? a ? a.p(c, f) : (a = fm(c), a.c(), a.m(e, t)) : a && (a.d(1), a = null), f & /*Icon*/
      1 && u !== (u = /*Icon*/
      c[0])) {
        if (i) {
          IS();
          const m = i;
          cm(m.$$.fragment, 1, 0, () => {
            am(m, 1);
          }), OS();
        }
        u ? (i = lm(u, h()), om(i.$$.fragment), hm(i.$$.fragment, 1), um(i, r, null)) : i = null;
      }
      (!s || f & /*size*/
      16) && Ft(
        r,
        "small",
        /*size*/
        c[4] === "small"
      ), (!s || f & /*size*/
      16) && Ft(
        r,
        "large",
        /*size*/
        c[4] === "large"
      ), (!s || f & /*size*/
      16) && Ft(
        r,
        "medium",
        /*size*/
        c[4] === "medium"
      ), (!s || f & /*disabled*/
      128) && (e.disabled = /*disabled*/
      c[7]), (!s || f & /*label*/
      2) && an(
        e,
        "aria-label",
        /*label*/
        c[1]
      ), (!s || f & /*hasPopup*/
      256) && an(
        e,
        "aria-haspopup",
        /*hasPopup*/
        c[8]
      ), (!s || f & /*label*/
      2) && an(
        e,
        "title",
        /*label*/
        c[1]
      ), (!s || f & /*pending*/
      8) && Ft(
        e,
        "pending",
        /*pending*/
        c[3]
      ), (!s || f & /*padded*/
      32) && Ft(
        e,
        "padded",
        /*padded*/
        c[5]
      ), (!s || f & /*highlight*/
      64) && Ft(
        e,
        "highlight",
        /*highlight*/
        c[6]
      ), (!s || f & /*transparent*/
      512) && Ft(
        e,
        "transparent",
        /*transparent*/
        c[9]
      ), f & /*disabled, _color*/
      2176 && lo(e, "color", !/*disabled*/
      c[7] && /*_color*/
      c[11] ? (
        /*_color*/
        c[11]
      ) : "var(--block-label-text-color)"), f & /*disabled, background*/
      1152 && lo(e, "--bg-color", /*disabled*/
      c[7] ? "auto" : (
        /*background*/
        c[10]
      ));
    },
    i(c) {
      s || (i && hm(i.$$.fragment, c), s = !0);
    },
    o(c) {
      i && cm(i.$$.fragment, c), s = !1;
    },
    d(c) {
      c && Gs(e), a && a.d(), i && am(i), l = !1, o();
    }
  };
}
function GS(n, e, t) {
  let r, { Icon: i } = e, { label: s = "" } = e, { show_label: l = !1 } = e, { pending: o = !1 } = e, { size: a = "small" } = e, { padded: u = !0 } = e, { highlight: h = !1 } = e, { disabled: c = !1 } = e, { hasPopup: f = !1 } = e, { color: m = "var(--block-label-text-color)" } = e, { transparent: g = !1 } = e, { background: v = "var(--block-background-fill)" } = e;
  function k(S) {
    BS.call(this, n, S);
  }
  return n.$$set = (S) => {
    "Icon" in S && t(0, i = S.Icon), "label" in S && t(1, s = S.label), "show_label" in S && t(2, l = S.show_label), "pending" in S && t(3, o = S.pending), "size" in S && t(4, a = S.size), "padded" in S && t(5, u = S.padded), "highlight" in S && t(6, h = S.highlight), "disabled" in S && t(7, c = S.disabled), "hasPopup" in S && t(8, f = S.hasPopup), "color" in S && t(12, m = S.color), "transparent" in S && t(9, g = S.transparent), "background" in S && t(10, v = S.background);
  }, n.$$.update = () => {
    n.$$.dirty & /*highlight, color*/
    4160 && t(11, r = h ? "var(--color-accent)" : m);
  }, [
    i,
    s,
    l,
    o,
    a,
    u,
    h,
    c,
    f,
    g,
    v,
    r,
    m,
    k
  ];
}
class jS extends FS {
  constructor(e) {
    super(), zS(this, e, GS, US, HS, {
      Icon: 0,
      label: 1,
      show_label: 2,
      pending: 3,
      size: 4,
      padded: 5,
      highlight: 6,
      disabled: 7,
      hasPopup: 8,
      color: 12,
      transparent: 9,
      background: 10
    });
  }
}
const {
  SvelteComponent: $S,
  append_hydration: YS,
  attr: R0,
  binding_callbacks: KS,
  children: dm,
  claim_element: mm,
  create_slot: XS,
  detach: L0,
  element: pm,
  get_all_dirty_from_scope: ZS,
  get_slot_changes: JS,
  init: QS,
  insert_hydration: eA,
  safe_not_equal: tA,
  toggle_class: An,
  transition_in: rA,
  transition_out: nA,
  update_slot_base: iA
} = window.__gradio__svelte__internal;
function sA(n) {
  let e, t, r;
  const i = (
    /*#slots*/
    n[5].default
  ), s = XS(
    i,
    n,
    /*$$scope*/
    n[4],
    null
  );
  return {
    c() {
      e = pm("div"), t = pm("div"), s && s.c(), this.h();
    },
    l(l) {
      e = mm(l, "DIV", { class: !0, "aria-label": !0 });
      var o = dm(e);
      t = mm(o, "DIV", { class: !0 });
      var a = dm(t);
      s && s.l(a), a.forEach(L0), o.forEach(L0), this.h();
    },
    h() {
      R0(t, "class", "icon svelte-3w3rth"), R0(e, "class", "empty svelte-3w3rth"), R0(e, "aria-label", "Empty value"), An(
        e,
        "small",
        /*size*/
        n[0] === "small"
      ), An(
        e,
        "large",
        /*size*/
        n[0] === "large"
      ), An(
        e,
        "unpadded_box",
        /*unpadded_box*/
        n[1]
      ), An(
        e,
        "small_parent",
        /*parent_height*/
        n[3]
      );
    },
    m(l, o) {
      eA(l, e, o), YS(e, t), s && s.m(t, null), n[6](e), r = !0;
    },
    p(l, [o]) {
      s && s.p && (!r || o & /*$$scope*/
      16) && iA(
        s,
        i,
        l,
        /*$$scope*/
        l[4],
        r ? JS(
          i,
          /*$$scope*/
          l[4],
          o,
          null
        ) : ZS(
          /*$$scope*/
          l[4]
        ),
        null
      ), (!r || o & /*size*/
      1) && An(
        e,
        "small",
        /*size*/
        l[0] === "small"
      ), (!r || o & /*size*/
      1) && An(
        e,
        "large",
        /*size*/
        l[0] === "large"
      ), (!r || o & /*unpadded_box*/
      2) && An(
        e,
        "unpadded_box",
        /*unpadded_box*/
        l[1]
      ), (!r || o & /*parent_height*/
      8) && An(
        e,
        "small_parent",
        /*parent_height*/
        l[3]
      );
    },
    i(l) {
      r || (rA(s, l), r = !0);
    },
    o(l) {
      nA(s, l), r = !1;
    },
    d(l) {
      l && L0(e), s && s.d(l), n[6](null);
    }
  };
}
function lA(n, e, t) {
  let r, { $$slots: i = {}, $$scope: s } = e, { size: l = "small" } = e, { unpadded_box: o = !1 } = e, a;
  function u(c) {
    var f;
    if (!c) return !1;
    const { height: m } = c.getBoundingClientRect(), { height: g } = ((f = c.parentElement) === null || f === void 0 ? void 0 : f.getBoundingClientRect()) || { height: m };
    return m > g + 2;
  }
  function h(c) {
    KS[c ? "unshift" : "push"](() => {
      a = c, t(2, a);
    });
  }
  return n.$$set = (c) => {
    "size" in c && t(0, l = c.size), "unpadded_box" in c && t(1, o = c.unpadded_box), "$$scope" in c && t(4, s = c.$$scope);
  }, n.$$.update = () => {
    n.$$.dirty & /*el*/
    4 && t(3, r = u(a));
  }, [l, o, a, r, s, i, h];
}
class oA extends $S {
  constructor(e) {
    super(), QS(this, e, lA, sA, tA, { size: 0, unpadded_box: 1 });
  }
}
const {
  SvelteComponent: aA,
  append_hydration: ti,
  attr: kr,
  binding_callbacks: gm,
  check_outros: Ku,
  children: Wr,
  claim_component: n5,
  claim_element: Ur,
  claim_space: tr,
  claim_text: Ue,
  create_component: i5,
  create_slot: s5,
  destroy_component: l5,
  destroy_each: o5,
  detach: ne,
  element: Gr,
  empty: lr,
  ensure_array_like: na,
  get_all_dirty_from_scope: a5,
  get_slot_changes: u5,
  group_outros: Xu,
  init: uA,
  insert_hydration: me,
  mount_component: h5,
  noop: Zu,
  safe_not_equal: hA,
  set_data: or,
  set_style: Bn,
  space: rr,
  text: Ge,
  toggle_class: jt,
  transition_in: wr,
  transition_out: jr,
  update_slot_base: c5
} = window.__gradio__svelte__internal, { tick: cA } = window.__gradio__svelte__internal, { onDestroy: fA } = window.__gradio__svelte__internal, { createEventDispatcher: dA } = window.__gradio__svelte__internal, mA = (n) => ({}), bm = (n) => ({}), pA = (n) => ({}), vm = (n) => ({});
function ym(n, e, t) {
  const r = n.slice();
  return r[41] = e[t], r[43] = t, r;
}
function wm(n, e, t) {
  const r = n.slice();
  return r[41] = e[t], r;
}
function gA(n) {
  let e, t, r, i, s = (
    /*i18n*/
    n[1]("common.error") + ""
  ), l, o, a;
  t = new jS({
    props: {
      Icon: Iv,
      label: (
        /*i18n*/
        n[1]("common.clear")
      ),
      disabled: !1
    }
  }), t.$on(
    "click",
    /*click_handler*/
    n[32]
  );
  const u = (
    /*#slots*/
    n[30].error
  ), h = s5(
    u,
    n,
    /*$$scope*/
    n[29],
    bm
  );
  return {
    c() {
      e = Gr("div"), i5(t.$$.fragment), r = rr(), i = Gr("span"), l = Ge(s), o = rr(), h && h.c(), this.h();
    },
    l(c) {
      e = Ur(c, "DIV", { class: !0 });
      var f = Wr(e);
      n5(t.$$.fragment, f), f.forEach(ne), r = tr(c), i = Ur(c, "SPAN", { class: !0 });
      var m = Wr(i);
      l = Ue(m, s), m.forEach(ne), o = tr(c), h && h.l(c), this.h();
    },
    h() {
      kr(e, "class", "clear-status svelte-17v219f"), kr(i, "class", "error svelte-17v219f");
    },
    m(c, f) {
      me(c, e, f), h5(t, e, null), me(c, r, f), me(c, i, f), ti(i, l), me(c, o, f), h && h.m(c, f), a = !0;
    },
    p(c, f) {
      const m = {};
      f[0] & /*i18n*/
      2 && (m.label = /*i18n*/
      c[1]("common.clear")), t.$set(m), (!a || f[0] & /*i18n*/
      2) && s !== (s = /*i18n*/
      c[1]("common.error") + "") && or(l, s), h && h.p && (!a || f[0] & /*$$scope*/
      536870912) && c5(
        h,
        u,
        c,
        /*$$scope*/
        c[29],
        a ? u5(
          u,
          /*$$scope*/
          c[29],
          f,
          mA
        ) : a5(
          /*$$scope*/
          c[29]
        ),
        bm
      );
    },
    i(c) {
      a || (wr(t.$$.fragment, c), wr(h, c), a = !0);
    },
    o(c) {
      jr(t.$$.fragment, c), jr(h, c), a = !1;
    },
    d(c) {
      c && (ne(e), ne(r), ne(i), ne(o)), l5(t), h && h.d(c);
    }
  };
}
function bA(n) {
  let e, t, r, i, s, l, o, a, u, h = (
    /*variant*/
    n[8] === "default" && /*show_eta_bar*/
    n[18] && /*show_progress*/
    n[6] === "full" && km(n)
  );
  function c(y, A) {
    if (
      /*progress*/
      y[7]
    ) return wA;
    if (
      /*queue_position*/
      y[2] !== null && /*queue_size*/
      y[3] !== void 0 && /*queue_position*/
      y[2] >= 0
    ) return yA;
    if (
      /*queue_position*/
      y[2] === 0
    ) return vA;
  }
  let f = c(n), m = f && f(n), g = (
    /*timer*/
    n[5] && Am(n)
  );
  const v = [AA, SA], k = [];
  function S(y, A) {
    return (
      /*last_progress_level*/
      y[15] != null ? 0 : (
        /*show_progress*/
        y[6] === "full" ? 1 : -1
      )
    );
  }
  ~(s = S(n)) && (l = k[s] = v[s](n));
  let x = !/*timer*/
  n[5] && Fm(n);
  return {
    c() {
      h && h.c(), e = rr(), t = Gr("div"), m && m.c(), r = rr(), g && g.c(), i = rr(), l && l.c(), o = rr(), x && x.c(), a = lr(), this.h();
    },
    l(y) {
      h && h.l(y), e = tr(y), t = Ur(y, "DIV", { class: !0 });
      var A = Wr(t);
      m && m.l(A), r = tr(A), g && g.l(A), A.forEach(ne), i = tr(y), l && l.l(y), o = tr(y), x && x.l(y), a = lr(), this.h();
    },
    h() {
      kr(t, "class", "progress-text svelte-17v219f"), jt(
        t,
        "meta-text-center",
        /*variant*/
        n[8] === "center"
      ), jt(
        t,
        "meta-text",
        /*variant*/
        n[8] === "default"
      );
    },
    m(y, A) {
      h && h.m(y, A), me(y, e, A), me(y, t, A), m && m.m(t, null), ti(t, r), g && g.m(t, null), me(y, i, A), ~s && k[s].m(y, A), me(y, o, A), x && x.m(y, A), me(y, a, A), u = !0;
    },
    p(y, A) {
      /*variant*/
      y[8] === "default" && /*show_eta_bar*/
      y[18] && /*show_progress*/
      y[6] === "full" ? h ? h.p(y, A) : (h = km(y), h.c(), h.m(e.parentNode, e)) : h && (h.d(1), h = null), f === (f = c(y)) && m ? m.p(y, A) : (m && m.d(1), m = f && f(y), m && (m.c(), m.m(t, r))), /*timer*/
      y[5] ? g ? g.p(y, A) : (g = Am(y), g.c(), g.m(t, null)) : g && (g.d(1), g = null), (!u || A[0] & /*variant*/
      256) && jt(
        t,
        "meta-text-center",
        /*variant*/
        y[8] === "center"
      ), (!u || A[0] & /*variant*/
      256) && jt(
        t,
        "meta-text",
        /*variant*/
        y[8] === "default"
      );
      let C = s;
      s = S(y), s === C ? ~s && k[s].p(y, A) : (l && (Xu(), jr(k[C], 1, 1, () => {
        k[C] = null;
      }), Ku()), ~s ? (l = k[s], l ? l.p(y, A) : (l = k[s] = v[s](y), l.c()), wr(l, 1), l.m(o.parentNode, o)) : l = null), /*timer*/
      y[5] ? x && (Xu(), jr(x, 1, 1, () => {
        x = null;
      }), Ku()) : x ? (x.p(y, A), A[0] & /*timer*/
      32 && wr(x, 1)) : (x = Fm(y), x.c(), wr(x, 1), x.m(a.parentNode, a));
    },
    i(y) {
      u || (wr(l), wr(x), u = !0);
    },
    o(y) {
      jr(l), jr(x), u = !1;
    },
    d(y) {
      y && (ne(e), ne(t), ne(i), ne(o), ne(a)), h && h.d(y), m && m.d(), g && g.d(), ~s && k[s].d(y), x && x.d(y);
    }
  };
}
function km(n) {
  let e, t = `translateX(${/*eta_level*/
  (n[17] || 0) * 100 - 100}%)`;
  return {
    c() {
      e = Gr("div"), this.h();
    },
    l(r) {
      e = Ur(r, "DIV", { class: !0 }), Wr(e).forEach(ne), this.h();
    },
    h() {
      kr(e, "class", "eta-bar svelte-17v219f"), Bn(e, "transform", t);
    },
    m(r, i) {
      me(r, e, i);
    },
    p(r, i) {
      i[0] & /*eta_level*/
      131072 && t !== (t = `translateX(${/*eta_level*/
      (r[17] || 0) * 100 - 100}%)`) && Bn(e, "transform", t);
    },
    d(r) {
      r && ne(e);
    }
  };
}
function vA(n) {
  let e;
  return {
    c() {
      e = Ge("processing |");
    },
    l(t) {
      e = Ue(t, "processing |");
    },
    m(t, r) {
      me(t, e, r);
    },
    p: Zu,
    d(t) {
      t && ne(e);
    }
  };
}
function yA(n) {
  let e, t = (
    /*queue_position*/
    n[2] + 1 + ""
  ), r, i, s, l;
  return {
    c() {
      e = Ge("queue: "), r = Ge(t), i = Ge("/"), s = Ge(
        /*queue_size*/
        n[3]
      ), l = Ge(" |");
    },
    l(o) {
      e = Ue(o, "queue: "), r = Ue(o, t), i = Ue(o, "/"), s = Ue(
        o,
        /*queue_size*/
        n[3]
      ), l = Ue(o, " |");
    },
    m(o, a) {
      me(o, e, a), me(o, r, a), me(o, i, a), me(o, s, a), me(o, l, a);
    },
    p(o, a) {
      a[0] & /*queue_position*/
      4 && t !== (t = /*queue_position*/
      o[2] + 1 + "") && or(r, t), a[0] & /*queue_size*/
      8 && or(
        s,
        /*queue_size*/
        o[3]
      );
    },
    d(o) {
      o && (ne(e), ne(r), ne(i), ne(s), ne(l));
    }
  };
}
function wA(n) {
  let e, t = na(
    /*progress*/
    n[7]
  ), r = [];
  for (let i = 0; i < t.length; i += 1)
    r[i] = Sm(wm(n, t, i));
  return {
    c() {
      for (let i = 0; i < r.length; i += 1)
        r[i].c();
      e = lr();
    },
    l(i) {
      for (let s = 0; s < r.length; s += 1)
        r[s].l(i);
      e = lr();
    },
    m(i, s) {
      for (let l = 0; l < r.length; l += 1)
        r[l] && r[l].m(i, s);
      me(i, e, s);
    },
    p(i, s) {
      if (s[0] & /*progress*/
      128) {
        t = na(
          /*progress*/
          i[7]
        );
        let l;
        for (l = 0; l < t.length; l += 1) {
          const o = wm(i, t, l);
          r[l] ? r[l].p(o, s) : (r[l] = Sm(o), r[l].c(), r[l].m(e.parentNode, e));
        }
        for (; l < r.length; l += 1)
          r[l].d(1);
        r.length = t.length;
      }
    },
    d(i) {
      i && ne(e), o5(r, i);
    }
  };
}
function xm(n) {
  let e, t = (
    /*p*/
    n[41].unit + ""
  ), r, i, s = " ", l;
  function o(h, c) {
    return (
      /*p*/
      h[41].length != null ? xA : kA
    );
  }
  let a = o(n), u = a(n);
  return {
    c() {
      u.c(), e = rr(), r = Ge(t), i = Ge(" | "), l = Ge(s);
    },
    l(h) {
      u.l(h), e = tr(h), r = Ue(h, t), i = Ue(h, " | "), l = Ue(h, s);
    },
    m(h, c) {
      u.m(h, c), me(h, e, c), me(h, r, c), me(h, i, c), me(h, l, c);
    },
    p(h, c) {
      a === (a = o(h)) && u ? u.p(h, c) : (u.d(1), u = a(h), u && (u.c(), u.m(e.parentNode, e))), c[0] & /*progress*/
      128 && t !== (t = /*p*/
      h[41].unit + "") && or(r, t);
    },
    d(h) {
      h && (ne(e), ne(r), ne(i), ne(l)), u.d(h);
    }
  };
}
function kA(n) {
  let e = Ni(
    /*p*/
    n[41].index || 0
  ) + "", t;
  return {
    c() {
      t = Ge(e);
    },
    l(r) {
      t = Ue(r, e);
    },
    m(r, i) {
      me(r, t, i);
    },
    p(r, i) {
      i[0] & /*progress*/
      128 && e !== (e = Ni(
        /*p*/
        r[41].index || 0
      ) + "") && or(t, e);
    },
    d(r) {
      r && ne(t);
    }
  };
}
function xA(n) {
  let e = Ni(
    /*p*/
    n[41].index || 0
  ) + "", t, r, i = Ni(
    /*p*/
    n[41].length
  ) + "", s;
  return {
    c() {
      t = Ge(e), r = Ge("/"), s = Ge(i);
    },
    l(l) {
      t = Ue(l, e), r = Ue(l, "/"), s = Ue(l, i);
    },
    m(l, o) {
      me(l, t, o), me(l, r, o), me(l, s, o);
    },
    p(l, o) {
      o[0] & /*progress*/
      128 && e !== (e = Ni(
        /*p*/
        l[41].index || 0
      ) + "") && or(t, e), o[0] & /*progress*/
      128 && i !== (i = Ni(
        /*p*/
        l[41].length
      ) + "") && or(s, i);
    },
    d(l) {
      l && (ne(t), ne(r), ne(s));
    }
  };
}
function Sm(n) {
  let e, t = (
    /*p*/
    n[41].index != null && xm(n)
  );
  return {
    c() {
      t && t.c(), e = lr();
    },
    l(r) {
      t && t.l(r), e = lr();
    },
    m(r, i) {
      t && t.m(r, i), me(r, e, i);
    },
    p(r, i) {
      /*p*/
      r[41].index != null ? t ? t.p(r, i) : (t = xm(r), t.c(), t.m(e.parentNode, e)) : t && (t.d(1), t = null);
    },
    d(r) {
      r && ne(e), t && t.d(r);
    }
  };
}
function Am(n) {
  let e, t = (
    /*eta*/
    n[0] ? `/${/*formatted_eta*/
    n[19]}` : ""
  ), r, i;
  return {
    c() {
      e = Ge(
        /*formatted_timer*/
        n[20]
      ), r = Ge(t), i = Ge("s");
    },
    l(s) {
      e = Ue(
        s,
        /*formatted_timer*/
        n[20]
      ), r = Ue(s, t), i = Ue(s, "s");
    },
    m(s, l) {
      me(s, e, l), me(s, r, l), me(s, i, l);
    },
    p(s, l) {
      l[0] & /*formatted_timer*/
      1048576 && or(
        e,
        /*formatted_timer*/
        s[20]
      ), l[0] & /*eta, formatted_eta*/
      524289 && t !== (t = /*eta*/
      s[0] ? `/${/*formatted_eta*/
      s[19]}` : "") && or(r, t);
    },
    d(s) {
      s && (ne(e), ne(r), ne(i));
    }
  };
}
function SA(n) {
  let e, t;
  return e = new ww({
    props: { margin: (
      /*variant*/
      n[8] === "default"
    ) }
  }), {
    c() {
      i5(e.$$.fragment);
    },
    l(r) {
      n5(e.$$.fragment, r);
    },
    m(r, i) {
      h5(e, r, i), t = !0;
    },
    p(r, i) {
      const s = {};
      i[0] & /*variant*/
      256 && (s.margin = /*variant*/
      r[8] === "default"), e.$set(s);
    },
    i(r) {
      t || (wr(e.$$.fragment, r), t = !0);
    },
    o(r) {
      jr(e.$$.fragment, r), t = !1;
    },
    d(r) {
      l5(e, r);
    }
  };
}
function AA(n) {
  let e, t, r, i, s, l = `${/*last_progress_level*/
  n[15] * 100}%`, o = (
    /*progress*/
    n[7] != null && Dm(n)
  );
  return {
    c() {
      e = Gr("div"), t = Gr("div"), o && o.c(), r = rr(), i = Gr("div"), s = Gr("div"), this.h();
    },
    l(a) {
      e = Ur(a, "DIV", { class: !0 });
      var u = Wr(e);
      t = Ur(u, "DIV", { class: !0 });
      var h = Wr(t);
      o && o.l(h), h.forEach(ne), r = tr(u), i = Ur(u, "DIV", { class: !0 });
      var c = Wr(i);
      s = Ur(c, "DIV", { class: !0 }), Wr(s).forEach(ne), c.forEach(ne), u.forEach(ne), this.h();
    },
    h() {
      kr(t, "class", "progress-level-inner svelte-17v219f"), kr(s, "class", "progress-bar svelte-17v219f"), Bn(s, "width", l), kr(i, "class", "progress-bar-wrap svelte-17v219f"), kr(e, "class", "progress-level svelte-17v219f");
    },
    m(a, u) {
      me(a, e, u), ti(e, t), o && o.m(t, null), ti(e, r), ti(e, i), ti(i, s), n[31](s);
    },
    p(a, u) {
      /*progress*/
      a[7] != null ? o ? o.p(a, u) : (o = Dm(a), o.c(), o.m(t, null)) : o && (o.d(1), o = null), u[0] & /*last_progress_level*/
      32768 && l !== (l = `${/*last_progress_level*/
      a[15] * 100}%`) && Bn(s, "width", l);
    },
    i: Zu,
    o: Zu,
    d(a) {
      a && ne(e), o && o.d(), n[31](null);
    }
  };
}
function Dm(n) {
  let e, t = na(
    /*progress*/
    n[7]
  ), r = [];
  for (let i = 0; i < t.length; i += 1)
    r[i] = Em(ym(n, t, i));
  return {
    c() {
      for (let i = 0; i < r.length; i += 1)
        r[i].c();
      e = lr();
    },
    l(i) {
      for (let s = 0; s < r.length; s += 1)
        r[s].l(i);
      e = lr();
    },
    m(i, s) {
      for (let l = 0; l < r.length; l += 1)
        r[l] && r[l].m(i, s);
      me(i, e, s);
    },
    p(i, s) {
      if (s[0] & /*progress_level, progress*/
      16512) {
        t = na(
          /*progress*/
          i[7]
        );
        let l;
        for (l = 0; l < t.length; l += 1) {
          const o = ym(i, t, l);
          r[l] ? r[l].p(o, s) : (r[l] = Em(o), r[l].c(), r[l].m(e.parentNode, e));
        }
        for (; l < r.length; l += 1)
          r[l].d(1);
        r.length = t.length;
      }
    },
    d(i) {
      i && ne(e), o5(r, i);
    }
  };
}
function Cm(n) {
  let e, t, r, i, s = (
    /*i*/
    n[43] !== 0 && DA()
  ), l = (
    /*p*/
    n[41].desc != null && _m(n)
  ), o = (
    /*p*/
    n[41].desc != null && /*progress_level*/
    n[14] && /*progress_level*/
    n[14][
      /*i*/
      n[43]
    ] != null && Mm()
  ), a = (
    /*progress_level*/
    n[14] != null && Tm(n)
  );
  return {
    c() {
      s && s.c(), e = rr(), l && l.c(), t = rr(), o && o.c(), r = rr(), a && a.c(), i = lr();
    },
    l(u) {
      s && s.l(u), e = tr(u), l && l.l(u), t = tr(u), o && o.l(u), r = tr(u), a && a.l(u), i = lr();
    },
    m(u, h) {
      s && s.m(u, h), me(u, e, h), l && l.m(u, h), me(u, t, h), o && o.m(u, h), me(u, r, h), a && a.m(u, h), me(u, i, h);
    },
    p(u, h) {
      /*p*/
      u[41].desc != null ? l ? l.p(u, h) : (l = _m(u), l.c(), l.m(t.parentNode, t)) : l && (l.d(1), l = null), /*p*/
      u[41].desc != null && /*progress_level*/
      u[14] && /*progress_level*/
      u[14][
        /*i*/
        u[43]
      ] != null ? o || (o = Mm(), o.c(), o.m(r.parentNode, r)) : o && (o.d(1), o = null), /*progress_level*/
      u[14] != null ? a ? a.p(u, h) : (a = Tm(u), a.c(), a.m(i.parentNode, i)) : a && (a.d(1), a = null);
    },
    d(u) {
      u && (ne(e), ne(t), ne(r), ne(i)), s && s.d(u), l && l.d(u), o && o.d(u), a && a.d(u);
    }
  };
}
function DA(n) {
  let e;
  return {
    c() {
      e = Ge(" /");
    },
    l(t) {
      e = Ue(t, " /");
    },
    m(t, r) {
      me(t, e, r);
    },
    d(t) {
      t && ne(e);
    }
  };
}
function _m(n) {
  let e = (
    /*p*/
    n[41].desc + ""
  ), t;
  return {
    c() {
      t = Ge(e);
    },
    l(r) {
      t = Ue(r, e);
    },
    m(r, i) {
      me(r, t, i);
    },
    p(r, i) {
      i[0] & /*progress*/
      128 && e !== (e = /*p*/
      r[41].desc + "") && or(t, e);
    },
    d(r) {
      r && ne(t);
    }
  };
}
function Mm(n) {
  let e;
  return {
    c() {
      e = Ge("-");
    },
    l(t) {
      e = Ue(t, "-");
    },
    m(t, r) {
      me(t, e, r);
    },
    d(t) {
      t && ne(e);
    }
  };
}
function Tm(n) {
  let e = (100 * /*progress_level*/
  (n[14][
    /*i*/
    n[43]
  ] || 0)).toFixed(1) + "", t, r;
  return {
    c() {
      t = Ge(e), r = Ge("%");
    },
    l(i) {
      t = Ue(i, e), r = Ue(i, "%");
    },
    m(i, s) {
      me(i, t, s), me(i, r, s);
    },
    p(i, s) {
      s[0] & /*progress_level*/
      16384 && e !== (e = (100 * /*progress_level*/
      (i[14][
        /*i*/
        i[43]
      ] || 0)).toFixed(1) + "") && or(t, e);
    },
    d(i) {
      i && (ne(t), ne(r));
    }
  };
}
function Em(n) {
  let e, t = (
    /*p*/
    (n[41].desc != null || /*progress_level*/
    n[14] && /*progress_level*/
    n[14][
      /*i*/
      n[43]
    ] != null) && Cm(n)
  );
  return {
    c() {
      t && t.c(), e = lr();
    },
    l(r) {
      t && t.l(r), e = lr();
    },
    m(r, i) {
      t && t.m(r, i), me(r, e, i);
    },
    p(r, i) {
      /*p*/
      r[41].desc != null || /*progress_level*/
      r[14] && /*progress_level*/
      r[14][
        /*i*/
        r[43]
      ] != null ? t ? t.p(r, i) : (t = Cm(r), t.c(), t.m(e.parentNode, e)) : t && (t.d(1), t = null);
    },
    d(r) {
      r && ne(e), t && t.d(r);
    }
  };
}
function Fm(n) {
  let e, t, r, i;
  const s = (
    /*#slots*/
    n[30]["additional-loading-text"]
  ), l = s5(
    s,
    n,
    /*$$scope*/
    n[29],
    vm
  );
  return {
    c() {
      e = Gr("p"), t = Ge(
        /*loading_text*/
        n[9]
      ), r = rr(), l && l.c(), this.h();
    },
    l(o) {
      e = Ur(o, "P", { class: !0 });
      var a = Wr(e);
      t = Ue(
        a,
        /*loading_text*/
        n[9]
      ), a.forEach(ne), r = tr(o), l && l.l(o), this.h();
    },
    h() {
      kr(e, "class", "loading svelte-17v219f");
    },
    m(o, a) {
      me(o, e, a), ti(e, t), me(o, r, a), l && l.m(o, a), i = !0;
    },
    p(o, a) {
      (!i || a[0] & /*loading_text*/
      512) && or(
        t,
        /*loading_text*/
        o[9]
      ), l && l.p && (!i || a[0] & /*$$scope*/
      536870912) && c5(
        l,
        s,
        o,
        /*$$scope*/
        o[29],
        i ? u5(
          s,
          /*$$scope*/
          o[29],
          a,
          pA
        ) : a5(
          /*$$scope*/
          o[29]
        ),
        vm
      );
    },
    i(o) {
      i || (wr(l, o), i = !0);
    },
    o(o) {
      jr(l, o), i = !1;
    },
    d(o) {
      o && (ne(e), ne(r)), l && l.d(o);
    }
  };
}
function CA(n) {
  let e, t, r, i, s;
  const l = [bA, gA], o = [];
  function a(u, h) {
    return (
      /*status*/
      u[4] === "pending" ? 0 : (
        /*status*/
        u[4] === "error" ? 1 : -1
      )
    );
  }
  return ~(t = a(n)) && (r = o[t] = l[t](n)), {
    c() {
      e = Gr("div"), r && r.c(), this.h();
    },
    l(u) {
      e = Ur(u, "DIV", { class: !0 });
      var h = Wr(e);
      r && r.l(h), h.forEach(ne), this.h();
    },
    h() {
      kr(e, "class", i = "wrap " + /*variant*/
      n[8] + " " + /*show_progress*/
      n[6] + " svelte-17v219f"), jt(e, "hide", !/*status*/
      n[4] || /*status*/
      n[4] === "complete" || /*show_progress*/
      n[6] === "hidden" || /*status*/
      n[4] == "streaming"), jt(
        e,
        "translucent",
        /*variant*/
        n[8] === "center" && /*status*/
        (n[4] === "pending" || /*status*/
        n[4] === "error") || /*translucent*/
        n[11] || /*show_progress*/
        n[6] === "minimal"
      ), jt(
        e,
        "generating",
        /*status*/
        n[4] === "generating" && /*show_progress*/
        n[6] === "full"
      ), jt(
        e,
        "border",
        /*border*/
        n[12]
      ), Bn(
        e,
        "position",
        /*absolute*/
        n[10] ? "absolute" : "static"
      ), Bn(
        e,
        "padding",
        /*absolute*/
        n[10] ? "0" : "var(--size-8) 0"
      );
    },
    m(u, h) {
      me(u, e, h), ~t && o[t].m(e, null), n[33](e), s = !0;
    },
    p(u, h) {
      let c = t;
      t = a(u), t === c ? ~t && o[t].p(u, h) : (r && (Xu(), jr(o[c], 1, 1, () => {
        o[c] = null;
      }), Ku()), ~t ? (r = o[t], r ? r.p(u, h) : (r = o[t] = l[t](u), r.c()), wr(r, 1), r.m(e, null)) : r = null), (!s || h[0] & /*variant, show_progress*/
      320 && i !== (i = "wrap " + /*variant*/
      u[8] + " " + /*show_progress*/
      u[6] + " svelte-17v219f")) && kr(e, "class", i), (!s || h[0] & /*variant, show_progress, status, show_progress*/
      336) && jt(e, "hide", !/*status*/
      u[4] || /*status*/
      u[4] === "complete" || /*show_progress*/
      u[6] === "hidden" || /*status*/
      u[4] == "streaming"), (!s || h[0] & /*variant, show_progress, variant, status, translucent, show_progress*/
      2384) && jt(
        e,
        "translucent",
        /*variant*/
        u[8] === "center" && /*status*/
        (u[4] === "pending" || /*status*/
        u[4] === "error") || /*translucent*/
        u[11] || /*show_progress*/
        u[6] === "minimal"
      ), (!s || h[0] & /*variant, show_progress, status, show_progress*/
      336) && jt(
        e,
        "generating",
        /*status*/
        u[4] === "generating" && /*show_progress*/
        u[6] === "full"
      ), (!s || h[0] & /*variant, show_progress, border*/
      4416) && jt(
        e,
        "border",
        /*border*/
        u[12]
      ), h[0] & /*absolute*/
      1024 && Bn(
        e,
        "position",
        /*absolute*/
        u[10] ? "absolute" : "static"
      ), h[0] & /*absolute*/
      1024 && Bn(
        e,
        "padding",
        /*absolute*/
        u[10] ? "0" : "var(--size-8) 0"
      );
    },
    i(u) {
      s || (wr(r), s = !0);
    },
    o(u) {
      jr(r), s = !1;
    },
    d(u) {
      u && ne(e), ~t && o[t].d(), n[33](null);
    }
  };
}
var _A = function(n, e, t, r) {
  function i(s) {
    return s instanceof t ? s : new t(function(l) {
      l(s);
    });
  }
  return new (t || (t = Promise))(function(s, l) {
    function o(h) {
      try {
        u(r.next(h));
      } catch (c) {
        l(c);
      }
    }
    function a(h) {
      try {
        u(r.throw(h));
      } catch (c) {
        l(c);
      }
    }
    function u(h) {
      h.done ? s(h.value) : i(h.value).then(o, a);
    }
    u((r = r.apply(n, e || [])).next());
  });
};
let oo = [], N0 = !1;
const MA = typeof window < "u", f5 = MA ? window.requestAnimationFrame : (n) => {
};
function TA(n) {
  return _A(this, arguments, void 0, function* (e, t = !0) {
    if (!(window.__gradio_mode__ === "website" || window.__gradio_mode__ !== "app" && t !== !0)) {
      if (oo.push(e), !N0) N0 = !0;
      else return;
      yield cA(), f5(() => {
        let r = [0, 0];
        for (let i = 0; i < oo.length; i++) {
          const l = oo[i].getBoundingClientRect();
          (i === 0 || l.top + window.scrollY <= r[0]) && (r[0] = l.top + window.scrollY, r[1] = i);
        }
        window.scrollTo({ top: r[0] - 20, behavior: "smooth" }), N0 = !1, oo = [];
      });
    }
  });
}
function EA(n, e, t) {
  let r, { $$slots: i = {}, $$scope: s } = e;
  this && this.__awaiter;
  const l = dA();
  let { i18n: o } = e, { eta: a = null } = e, { queue_position: u } = e, { queue_size: h } = e, { status: c } = e, { scroll_to_output: f = !1 } = e, { timer: m = !0 } = e, { show_progress: g = "full" } = e, { message: v = null } = e, { progress: k = null } = e, { variant: S = "default" } = e, { loading_text: x = "Loading..." } = e, { absolute: y = !0 } = e, { translucent: A = !1 } = e, { border: C = !1 } = e, { autoscroll: T } = e, M, L = !1, R = 0, N = 0, W = null, q = null, he = 0, Z = null, oe, ve = null, _e = !0;
  const pe = () => {
    t(0, a = t(27, W = t(19, J = null))), t(25, R = performance.now()), t(26, N = 0), L = !0, H();
  };
  function H() {
    f5(() => {
      t(26, N = (performance.now() - R) / 1e3), L && H();
    });
  }
  function fe() {
    t(26, N = 0), t(0, a = t(27, W = t(19, J = null))), L && (L = !1);
  }
  fA(() => {
    L && fe();
  });
  let J = null;
  function re(P) {
    gm[P ? "unshift" : "push"](() => {
      ve = P, t(16, ve), t(7, k), t(14, Z), t(15, oe);
    });
  }
  const ae = () => {
    l("clear_status");
  };
  function de(P) {
    gm[P ? "unshift" : "push"](() => {
      M = P, t(13, M);
    });
  }
  return n.$$set = (P) => {
    "i18n" in P && t(1, o = P.i18n), "eta" in P && t(0, a = P.eta), "queue_position" in P && t(2, u = P.queue_position), "queue_size" in P && t(3, h = P.queue_size), "status" in P && t(4, c = P.status), "scroll_to_output" in P && t(22, f = P.scroll_to_output), "timer" in P && t(5, m = P.timer), "show_progress" in P && t(6, g = P.show_progress), "message" in P && t(23, v = P.message), "progress" in P && t(7, k = P.progress), "variant" in P && t(8, S = P.variant), "loading_text" in P && t(9, x = P.loading_text), "absolute" in P && t(10, y = P.absolute), "translucent" in P && t(11, A = P.translucent), "border" in P && t(12, C = P.border), "autoscroll" in P && t(24, T = P.autoscroll), "$$scope" in P && t(29, s = P.$$scope);
  }, n.$$.update = () => {
    n.$$.dirty[0] & /*eta, old_eta, timer_start, eta_from_start*/
    436207617 && (a === null && t(0, a = W), a != null && W !== a && (t(28, q = (performance.now() - R) / 1e3 + a), t(19, J = q.toFixed(1)), t(27, W = a))), n.$$.dirty[0] & /*eta_from_start, timer_diff*/
    335544320 && t(17, he = q === null || q <= 0 || !N ? null : Math.min(N / q, 1)), n.$$.dirty[0] & /*progress*/
    128 && k != null && t(18, _e = !1), n.$$.dirty[0] & /*progress, progress_level, progress_bar, last_progress_level*/
    114816 && (k != null ? t(14, Z = k.map((P) => {
      if (P.index != null && P.length != null)
        return P.index / P.length;
      if (P.progress != null)
        return P.progress;
    })) : t(14, Z = null), Z ? (t(15, oe = Z[Z.length - 1]), ve && (oe === 0 ? t(16, ve.style.transition = "0", ve) : t(16, ve.style.transition = "150ms", ve))) : t(15, oe = void 0)), n.$$.dirty[0] & /*status*/
    16 && (c === "pending" ? pe() : fe()), n.$$.dirty[0] & /*el, scroll_to_output, status, autoscroll*/
    20979728 && M && f && (c === "pending" || c === "complete") && TA(M, T), n.$$.dirty[0] & /*status, message*/
    8388624, n.$$.dirty[0] & /*timer_diff*/
    67108864 && t(20, r = N.toFixed(1));
  }, [
    a,
    o,
    u,
    h,
    c,
    m,
    g,
    k,
    S,
    x,
    y,
    A,
    C,
    M,
    Z,
    oe,
    ve,
    he,
    _e,
    J,
    r,
    l,
    f,
    v,
    T,
    R,
    N,
    W,
    q,
    s,
    i,
    re,
    ae,
    de
  ];
}
class FA extends aA {
  constructor(e) {
    super(), uA(
      this,
      e,
      EA,
      CA,
      hA,
      {
        i18n: 1,
        eta: 0,
        queue_position: 2,
        queue_size: 3,
        status: 4,
        scroll_to_output: 22,
        timer: 5,
        show_progress: 6,
        message: 23,
        progress: 7,
        variant: 8,
        loading_text: 9,
        absolute: 10,
        translucent: 11,
        border: 12,
        autoscroll: 24
      },
      null,
      [-1, -1]
    );
  }
}
/*! @license DOMPurify 3.1.7 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.1.7/LICENSE */
const {
  entries: d5,
  setPrototypeOf: Bm,
  isFrozen: BA,
  getPrototypeOf: OA,
  getOwnPropertyDescriptor: RA
} = Object;
let {
  freeze: Ct,
  seal: ar,
  create: m5
} = Object, {
  apply: Ju,
  construct: Qu
} = typeof Reflect < "u" && Reflect;
Ct || (Ct = function(e) {
  return e;
});
ar || (ar = function(e) {
  return e;
});
Ju || (Ju = function(e, t, r) {
  return e.apply(t, r);
});
Qu || (Qu = function(e, t) {
  return new e(...t);
});
const ao = Ht(Array.prototype.forEach), Om = Ht(Array.prototype.pop), Ss = Ht(Array.prototype.push), Ao = Ht(String.prototype.toLowerCase), I0 = Ht(String.prototype.toString), Rm = Ht(String.prototype.match), As = Ht(String.prototype.replace), LA = Ht(String.prototype.indexOf), NA = Ht(String.prototype.trim), gr = Ht(Object.prototype.hasOwnProperty), wt = Ht(RegExp.prototype.test), Ds = IA(TypeError);
function Ht(n) {
  return function(e) {
    for (var t = arguments.length, r = new Array(t > 1 ? t - 1 : 0), i = 1; i < t; i++)
      r[i - 1] = arguments[i];
    return Ju(n, e, r);
  };
}
function IA(n) {
  return function() {
    for (var e = arguments.length, t = new Array(e), r = 0; r < e; r++)
      t[r] = arguments[r];
    return Qu(n, t);
  };
}
function ke(n, e) {
  let t = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : Ao;
  Bm && Bm(n, null);
  let r = e.length;
  for (; r--; ) {
    let i = e[r];
    if (typeof i == "string") {
      const s = t(i);
      s !== i && (BA(e) || (e[r] = s), i = s);
    }
    n[i] = !0;
  }
  return n;
}
function zA(n) {
  for (let e = 0; e < n.length; e++)
    gr(n, e) || (n[e] = null);
  return n;
}
function Yn(n) {
  const e = m5(null);
  for (const [t, r] of d5(n))
    gr(n, t) && (Array.isArray(r) ? e[t] = zA(r) : r && typeof r == "object" && r.constructor === Object ? e[t] = Yn(r) : e[t] = r);
  return e;
}
function Cs(n, e) {
  for (; n !== null; ) {
    const r = RA(n, e);
    if (r) {
      if (r.get)
        return Ht(r.get);
      if (typeof r.value == "function")
        return Ht(r.value);
    }
    n = OA(n);
  }
  function t() {
    return null;
  }
  return t;
}
const Lm = Ct(["a", "abbr", "acronym", "address", "area", "article", "aside", "audio", "b", "bdi", "bdo", "big", "blink", "blockquote", "body", "br", "button", "canvas", "caption", "center", "cite", "code", "col", "colgroup", "content", "data", "datalist", "dd", "decorator", "del", "details", "dfn", "dialog", "dir", "div", "dl", "dt", "element", "em", "fieldset", "figcaption", "figure", "font", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "img", "input", "ins", "kbd", "label", "legend", "li", "main", "map", "mark", "marquee", "menu", "menuitem", "meter", "nav", "nobr", "ol", "optgroup", "option", "output", "p", "picture", "pre", "progress", "q", "rp", "rt", "ruby", "s", "samp", "section", "select", "shadow", "small", "source", "spacer", "span", "strike", "strong", "style", "sub", "summary", "sup", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "tr", "track", "tt", "u", "ul", "var", "video", "wbr"]), z0 = Ct(["svg", "a", "altglyph", "altglyphdef", "altglyphitem", "animatecolor", "animatemotion", "animatetransform", "circle", "clippath", "defs", "desc", "ellipse", "filter", "font", "g", "glyph", "glyphref", "hkern", "image", "line", "lineargradient", "marker", "mask", "metadata", "mpath", "path", "pattern", "polygon", "polyline", "radialgradient", "rect", "stop", "style", "switch", "symbol", "text", "textpath", "title", "tref", "tspan", "view", "vkern"]), P0 = Ct(["feBlend", "feColorMatrix", "feComponentTransfer", "feComposite", "feConvolveMatrix", "feDiffuseLighting", "feDisplacementMap", "feDistantLight", "feDropShadow", "feFlood", "feFuncA", "feFuncB", "feFuncG", "feFuncR", "feGaussianBlur", "feImage", "feMerge", "feMergeNode", "feMorphology", "feOffset", "fePointLight", "feSpecularLighting", "feSpotLight", "feTile", "feTurbulence"]), PA = Ct(["animate", "color-profile", "cursor", "discard", "font-face", "font-face-format", "font-face-name", "font-face-src", "font-face-uri", "foreignobject", "hatch", "hatchpath", "mesh", "meshgradient", "meshpatch", "meshrow", "missing-glyph", "script", "set", "solidcolor", "unknown", "use"]), H0 = Ct(["math", "menclose", "merror", "mfenced", "mfrac", "mglyph", "mi", "mlabeledtr", "mmultiscripts", "mn", "mo", "mover", "mpadded", "mphantom", "mroot", "mrow", "ms", "mspace", "msqrt", "mstyle", "msub", "msup", "msubsup", "mtable", "mtd", "mtext", "mtr", "munder", "munderover", "mprescripts"]), HA = Ct(["maction", "maligngroup", "malignmark", "mlongdiv", "mscarries", "mscarry", "msgroup", "mstack", "msline", "msrow", "semantics", "annotation", "annotation-xml", "mprescripts", "none"]), Nm = Ct(["#text"]), Im = Ct(["accept", "action", "align", "alt", "autocapitalize", "autocomplete", "autopictureinpicture", "autoplay", "background", "bgcolor", "border", "capture", "cellpadding", "cellspacing", "checked", "cite", "class", "clear", "color", "cols", "colspan", "controls", "controlslist", "coords", "crossorigin", "datetime", "decoding", "default", "dir", "disabled", "disablepictureinpicture", "disableremoteplayback", "download", "draggable", "enctype", "enterkeyhint", "face", "for", "headers", "height", "hidden", "high", "href", "hreflang", "id", "inputmode", "integrity", "ismap", "kind", "label", "lang", "list", "loading", "loop", "low", "max", "maxlength", "media", "method", "min", "minlength", "multiple", "muted", "name", "nonce", "noshade", "novalidate", "nowrap", "open", "optimum", "pattern", "placeholder", "playsinline", "popover", "popovertarget", "popovertargetaction", "poster", "preload", "pubdate", "radiogroup", "readonly", "rel", "required", "rev", "reversed", "role", "rows", "rowspan", "spellcheck", "scope", "selected", "shape", "size", "sizes", "span", "srclang", "start", "src", "srcset", "step", "style", "summary", "tabindex", "title", "translate", "type", "usemap", "valign", "value", "width", "wrap", "xmlns", "slot"]), q0 = Ct(["accent-height", "accumulate", "additive", "alignment-baseline", "amplitude", "ascent", "attributename", "attributetype", "azimuth", "basefrequency", "baseline-shift", "begin", "bias", "by", "class", "clip", "clippathunits", "clip-path", "clip-rule", "color", "color-interpolation", "color-interpolation-filters", "color-profile", "color-rendering", "cx", "cy", "d", "dx", "dy", "diffuseconstant", "direction", "display", "divisor", "dur", "edgemode", "elevation", "end", "exponent", "fill", "fill-opacity", "fill-rule", "filter", "filterunits", "flood-color", "flood-opacity", "font-family", "font-size", "font-size-adjust", "font-stretch", "font-style", "font-variant", "font-weight", "fx", "fy", "g1", "g2", "glyph-name", "glyphref", "gradientunits", "gradienttransform", "height", "href", "id", "image-rendering", "in", "in2", "intercept", "k", "k1", "k2", "k3", "k4", "kerning", "keypoints", "keysplines", "keytimes", "lang", "lengthadjust", "letter-spacing", "kernelmatrix", "kernelunitlength", "lighting-color", "local", "marker-end", "marker-mid", "marker-start", "markerheight", "markerunits", "markerwidth", "maskcontentunits", "maskunits", "max", "mask", "media", "method", "mode", "min", "name", "numoctaves", "offset", "operator", "opacity", "order", "orient", "orientation", "origin", "overflow", "paint-order", "path", "pathlength", "patterncontentunits", "patterntransform", "patternunits", "points", "preservealpha", "preserveaspectratio", "primitiveunits", "r", "rx", "ry", "radius", "refx", "refy", "repeatcount", "repeatdur", "restart", "result", "rotate", "scale", "seed", "shape-rendering", "slope", "specularconstant", "specularexponent", "spreadmethod", "startoffset", "stddeviation", "stitchtiles", "stop-color", "stop-opacity", "stroke-dasharray", "stroke-dashoffset", "stroke-linecap", "stroke-linejoin", "stroke-miterlimit", "stroke-opacity", "stroke", "stroke-width", "style", "surfacescale", "systemlanguage", "tabindex", "tablevalues", "targetx", "targety", "transform", "transform-origin", "text-anchor", "text-decoration", "text-rendering", "textlength", "type", "u1", "u2", "unicode", "values", "viewbox", "visibility", "version", "vert-adv-y", "vert-origin-x", "vert-origin-y", "width", "word-spacing", "wrap", "writing-mode", "xchannelselector", "ychannelselector", "x", "x1", "x2", "xmlns", "y", "y1", "y2", "z", "zoomandpan"]), zm = Ct(["accent", "accentunder", "align", "bevelled", "close", "columnsalign", "columnlines", "columnspan", "denomalign", "depth", "dir", "display", "displaystyle", "encoding", "fence", "frame", "height", "href", "id", "largeop", "length", "linethickness", "lspace", "lquote", "mathbackground", "mathcolor", "mathsize", "mathvariant", "maxsize", "minsize", "movablelimits", "notation", "numalign", "open", "rowalign", "rowlines", "rowspacing", "rowspan", "rspace", "rquote", "scriptlevel", "scriptminsize", "scriptsizemultiplier", "selection", "separator", "separators", "stretchy", "subscriptshift", "supscriptshift", "symmetric", "voffset", "width", "xmlns"]), uo = Ct(["xlink:href", "xml:id", "xlink:title", "xml:space", "xmlns:xlink"]), qA = ar(/\{\{[\w\W]*|[\w\W]*\}\}/gm), VA = ar(/<%[\w\W]*|[\w\W]*%>/gm), WA = ar(/\${[\w\W]*}/gm), UA = ar(/^data-[\-\w.\u00B7-\uFFFF]/), GA = ar(/^aria-[\-\w]+$/), p5 = ar(
  /^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i
  // eslint-disable-line no-useless-escape
), jA = ar(/^(?:\w+script|data):/i), $A = ar(
  /[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g
  // eslint-disable-line no-control-regex
), g5 = ar(/^html$/i), YA = ar(/^[a-z][.\w]*(-[.\w]+)+$/i);
var Pm = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  MUSTACHE_EXPR: qA,
  ERB_EXPR: VA,
  TMPLIT_EXPR: WA,
  DATA_ATTR: UA,
  ARIA_ATTR: GA,
  IS_ALLOWED_URI: p5,
  IS_SCRIPT_OR_DATA: jA,
  ATTR_WHITESPACE: $A,
  DOCTYPE_NAME: g5,
  CUSTOM_ELEMENT: YA
});
const _s = {
  element: 1,
  attribute: 2,
  text: 3,
  cdataSection: 4,
  entityReference: 5,
  // Deprecated
  entityNode: 6,
  // Deprecated
  progressingInstruction: 7,
  comment: 8,
  document: 9,
  documentType: 10,
  documentFragment: 11,
  notation: 12
  // Deprecated
}, KA = function() {
  return typeof window > "u" ? null : window;
}, XA = function(e, t) {
  if (typeof e != "object" || typeof e.createPolicy != "function")
    return null;
  let r = null;
  const i = "data-tt-policy-suffix";
  t && t.hasAttribute(i) && (r = t.getAttribute(i));
  const s = "dompurify" + (r ? "#" + r : "");
  try {
    return e.createPolicy(s, {
      createHTML(l) {
        return l;
      },
      createScriptURL(l) {
        return l;
      }
    });
  } catch {
    return console.warn("TrustedTypes policy " + s + " could not be created."), null;
  }
};
function b5() {
  let n = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : KA();
  const e = (te) => b5(te);
  if (e.version = "3.1.7", e.removed = [], !n || !n.document || n.document.nodeType !== _s.document)
    return e.isSupported = !1, e;
  let {
    document: t
  } = n;
  const r = t, i = r.currentScript, {
    DocumentFragment: s,
    HTMLTemplateElement: l,
    Node: o,
    Element: a,
    NodeFilter: u,
    NamedNodeMap: h = n.NamedNodeMap || n.MozNamedAttrMap,
    HTMLFormElement: c,
    DOMParser: f,
    trustedTypes: m
  } = n, g = a.prototype, v = Cs(g, "cloneNode"), k = Cs(g, "remove"), S = Cs(g, "nextSibling"), x = Cs(g, "childNodes"), y = Cs(g, "parentNode");
  if (typeof l == "function") {
    const te = t.createElement("template");
    te.content && te.content.ownerDocument && (t = te.content.ownerDocument);
  }
  let A, C = "";
  const {
    implementation: T,
    createNodeIterator: M,
    createDocumentFragment: L,
    getElementsByTagName: R
  } = t, {
    importNode: N
  } = r;
  let W = {};
  e.isSupported = typeof d5 == "function" && typeof y == "function" && T && T.createHTMLDocument !== void 0;
  const {
    MUSTACHE_EXPR: q,
    ERB_EXPR: he,
    TMPLIT_EXPR: Z,
    DATA_ATTR: oe,
    ARIA_ATTR: ve,
    IS_SCRIPT_OR_DATA: _e,
    ATTR_WHITESPACE: pe,
    CUSTOM_ELEMENT: H
  } = Pm;
  let {
    IS_ALLOWED_URI: fe
  } = Pm, J = null;
  const re = ke({}, [...Lm, ...z0, ...P0, ...H0, ...Nm]);
  let ae = null;
  const de = ke({}, [...Im, ...q0, ...zm, ...uo]);
  let P = Object.seal(m5(null, {
    tagNameCheck: {
      writable: !0,
      configurable: !1,
      enumerable: !0,
      value: null
    },
    attributeNameCheck: {
      writable: !0,
      configurable: !1,
      enumerable: !0,
      value: null
    },
    allowCustomizedBuiltInElements: {
      writable: !0,
      configurable: !1,
      enumerable: !0,
      value: !1
    }
  })), ze = null, Me = null, Pe = !0, je = !0, Ye = !1, Mt = !0, Wt = !1, hr = !0, bt = !1, Tt = !1, Dr = !1, Cr = !1, tn = !1, rn = !1, gc = !0, bc = !1;
  const v5 = "user-content-";
  let Ca = !0, us = !1, wi = {}, ki = null;
  const vc = ke({}, ["annotation-xml", "audio", "colgroup", "desc", "foreignobject", "head", "iframe", "math", "mi", "mn", "mo", "ms", "mtext", "noembed", "noframes", "noscript", "plaintext", "script", "style", "svg", "template", "thead", "title", "video", "xmp"]);
  let yc = null;
  const wc = ke({}, ["audio", "video", "img", "source", "image", "track"]);
  let _a = null;
  const kc = ke({}, ["alt", "class", "for", "id", "label", "name", "pattern", "placeholder", "role", "summary", "title", "value", "style", "xmlns"]), wl = "http://www.w3.org/1998/Math/MathML", kl = "http://www.w3.org/2000/svg", nn = "http://www.w3.org/1999/xhtml";
  let xi = nn, Ma = !1, Ta = null;
  const y5 = ke({}, [wl, kl, nn], I0);
  let hs = null;
  const w5 = ["application/xhtml+xml", "text/html"], k5 = "text/html";
  let rt = null, Si = null;
  const x5 = t.createElement("form"), xc = function(B) {
    return B instanceof RegExp || B instanceof Function;
  }, Ea = function() {
    let B = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    if (!(Si && Si === B)) {
      if ((!B || typeof B != "object") && (B = {}), B = Yn(B), hs = // eslint-disable-next-line unicorn/prefer-includes
      w5.indexOf(B.PARSER_MEDIA_TYPE) === -1 ? k5 : B.PARSER_MEDIA_TYPE, rt = hs === "application/xhtml+xml" ? I0 : Ao, J = gr(B, "ALLOWED_TAGS") ? ke({}, B.ALLOWED_TAGS, rt) : re, ae = gr(B, "ALLOWED_ATTR") ? ke({}, B.ALLOWED_ATTR, rt) : de, Ta = gr(B, "ALLOWED_NAMESPACES") ? ke({}, B.ALLOWED_NAMESPACES, I0) : y5, _a = gr(B, "ADD_URI_SAFE_ATTR") ? ke(
        Yn(kc),
        // eslint-disable-line indent
        B.ADD_URI_SAFE_ATTR,
        // eslint-disable-line indent
        rt
        // eslint-disable-line indent
      ) : kc, yc = gr(B, "ADD_DATA_URI_TAGS") ? ke(
        Yn(wc),
        // eslint-disable-line indent
        B.ADD_DATA_URI_TAGS,
        // eslint-disable-line indent
        rt
        // eslint-disable-line indent
      ) : wc, ki = gr(B, "FORBID_CONTENTS") ? ke({}, B.FORBID_CONTENTS, rt) : vc, ze = gr(B, "FORBID_TAGS") ? ke({}, B.FORBID_TAGS, rt) : {}, Me = gr(B, "FORBID_ATTR") ? ke({}, B.FORBID_ATTR, rt) : {}, wi = gr(B, "USE_PROFILES") ? B.USE_PROFILES : !1, Pe = B.ALLOW_ARIA_ATTR !== !1, je = B.ALLOW_DATA_ATTR !== !1, Ye = B.ALLOW_UNKNOWN_PROTOCOLS || !1, Mt = B.ALLOW_SELF_CLOSE_IN_ATTR !== !1, Wt = B.SAFE_FOR_TEMPLATES || !1, hr = B.SAFE_FOR_XML !== !1, bt = B.WHOLE_DOCUMENT || !1, Cr = B.RETURN_DOM || !1, tn = B.RETURN_DOM_FRAGMENT || !1, rn = B.RETURN_TRUSTED_TYPE || !1, Dr = B.FORCE_BODY || !1, gc = B.SANITIZE_DOM !== !1, bc = B.SANITIZE_NAMED_PROPS || !1, Ca = B.KEEP_CONTENT !== !1, us = B.IN_PLACE || !1, fe = B.ALLOWED_URI_REGEXP || p5, xi = B.NAMESPACE || nn, P = B.CUSTOM_ELEMENT_HANDLING || {}, B.CUSTOM_ELEMENT_HANDLING && xc(B.CUSTOM_ELEMENT_HANDLING.tagNameCheck) && (P.tagNameCheck = B.CUSTOM_ELEMENT_HANDLING.tagNameCheck), B.CUSTOM_ELEMENT_HANDLING && xc(B.CUSTOM_ELEMENT_HANDLING.attributeNameCheck) && (P.attributeNameCheck = B.CUSTOM_ELEMENT_HANDLING.attributeNameCheck), B.CUSTOM_ELEMENT_HANDLING && typeof B.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements == "boolean" && (P.allowCustomizedBuiltInElements = B.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements), Wt && (je = !1), tn && (Cr = !0), wi && (J = ke({}, Nm), ae = [], wi.html === !0 && (ke(J, Lm), ke(ae, Im)), wi.svg === !0 && (ke(J, z0), ke(ae, q0), ke(ae, uo)), wi.svgFilters === !0 && (ke(J, P0), ke(ae, q0), ke(ae, uo)), wi.mathMl === !0 && (ke(J, H0), ke(ae, zm), ke(ae, uo))), B.ADD_TAGS && (J === re && (J = Yn(J)), ke(J, B.ADD_TAGS, rt)), B.ADD_ATTR && (ae === de && (ae = Yn(ae)), ke(ae, B.ADD_ATTR, rt)), B.ADD_URI_SAFE_ATTR && ke(_a, B.ADD_URI_SAFE_ATTR, rt), B.FORBID_CONTENTS && (ki === vc && (ki = Yn(ki)), ke(ki, B.FORBID_CONTENTS, rt)), Ca && (J["#text"] = !0), bt && ke(J, ["html", "head", "body"]), J.table && (ke(J, ["tbody"]), delete ze.tbody), B.TRUSTED_TYPES_POLICY) {
        if (typeof B.TRUSTED_TYPES_POLICY.createHTML != "function")
          throw Ds('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');
        if (typeof B.TRUSTED_TYPES_POLICY.createScriptURL != "function")
          throw Ds('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');
        A = B.TRUSTED_TYPES_POLICY, C = A.createHTML("");
      } else
        A === void 0 && (A = XA(m, i)), A !== null && typeof C == "string" && (C = A.createHTML(""));
      Ct && Ct(B), Si = B;
    }
  }, Sc = ke({}, ["mi", "mo", "mn", "ms", "mtext"]), Ac = ke({}, ["annotation-xml"]), S5 = ke({}, ["title", "style", "font", "a", "script"]), Dc = ke({}, [...z0, ...P0, ...PA]), Cc = ke({}, [...H0, ...HA]), A5 = function(B) {
    let U = y(B);
    (!U || !U.tagName) && (U = {
      namespaceURI: xi,
      tagName: "template"
    });
    const ee = Ao(B.tagName), Re = Ao(U.tagName);
    return Ta[B.namespaceURI] ? B.namespaceURI === kl ? U.namespaceURI === nn ? ee === "svg" : U.namespaceURI === wl ? ee === "svg" && (Re === "annotation-xml" || Sc[Re]) : !!Dc[ee] : B.namespaceURI === wl ? U.namespaceURI === nn ? ee === "math" : U.namespaceURI === kl ? ee === "math" && Ac[Re] : !!Cc[ee] : B.namespaceURI === nn ? U.namespaceURI === kl && !Ac[Re] || U.namespaceURI === wl && !Sc[Re] ? !1 : !Cc[ee] && (S5[ee] || !Dc[ee]) : !!(hs === "application/xhtml+xml" && Ta[B.namespaceURI]) : !1;
  }, _r = function(B) {
    Ss(e.removed, {
      element: B
    });
    try {
      y(B).removeChild(B);
    } catch {
      k(B);
    }
  }, xl = function(B, U) {
    try {
      Ss(e.removed, {
        attribute: U.getAttributeNode(B),
        from: U
      });
    } catch {
      Ss(e.removed, {
        attribute: null,
        from: U
      });
    }
    if (U.removeAttribute(B), B === "is" && !ae[B])
      if (Cr || tn)
        try {
          _r(U);
        } catch {
        }
      else
        try {
          U.setAttribute(B, "");
        } catch {
        }
  }, _c = function(B) {
    let U = null, ee = null;
    if (Dr)
      B = "<remove></remove>" + B;
    else {
      const it = Rm(B, /^[\r\n\t ]+/);
      ee = it && it[0];
    }
    hs === "application/xhtml+xml" && xi === nn && (B = '<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>' + B + "</body></html>");
    const Re = A ? A.createHTML(B) : B;
    if (xi === nn)
      try {
        U = new f().parseFromString(Re, hs);
      } catch {
      }
    if (!U || !U.documentElement) {
      U = T.createDocument(xi, "template", null);
      try {
        U.documentElement.innerHTML = Ma ? C : Re;
      } catch {
      }
    }
    const ht = U.body || U.documentElement;
    return B && ee && ht.insertBefore(t.createTextNode(ee), ht.childNodes[0] || null), xi === nn ? R.call(U, bt ? "html" : "body")[0] : bt ? U.documentElement : ht;
  }, Mc = function(B) {
    return M.call(
      B.ownerDocument || B,
      B,
      // eslint-disable-next-line no-bitwise
      u.SHOW_ELEMENT | u.SHOW_COMMENT | u.SHOW_TEXT | u.SHOW_PROCESSING_INSTRUCTION | u.SHOW_CDATA_SECTION,
      null
    );
  }, Tc = function(B) {
    return B instanceof c && (typeof B.nodeName != "string" || typeof B.textContent != "string" || typeof B.removeChild != "function" || !(B.attributes instanceof h) || typeof B.removeAttribute != "function" || typeof B.setAttribute != "function" || typeof B.namespaceURI != "string" || typeof B.insertBefore != "function" || typeof B.hasChildNodes != "function");
  }, Ec = function(B) {
    return typeof o == "function" && B instanceof o;
  }, sn = function(B, U, ee) {
    W[B] && ao(W[B], (Re) => {
      Re.call(e, U, ee, Si);
    });
  }, Fc = function(B) {
    let U = null;
    if (sn("beforeSanitizeElements", B, null), Tc(B))
      return _r(B), !0;
    const ee = rt(B.nodeName);
    if (sn("uponSanitizeElement", B, {
      tagName: ee,
      allowedTags: J
    }), B.hasChildNodes() && !Ec(B.firstElementChild) && wt(/<[/\w]/g, B.innerHTML) && wt(/<[/\w]/g, B.textContent) || B.nodeType === _s.progressingInstruction || hr && B.nodeType === _s.comment && wt(/<[/\w]/g, B.data))
      return _r(B), !0;
    if (!J[ee] || ze[ee]) {
      if (!ze[ee] && Oc(ee) && (P.tagNameCheck instanceof RegExp && wt(P.tagNameCheck, ee) || P.tagNameCheck instanceof Function && P.tagNameCheck(ee)))
        return !1;
      if (Ca && !ki[ee]) {
        const Re = y(B) || B.parentNode, ht = x(B) || B.childNodes;
        if (ht && Re) {
          const it = ht.length;
          for (let Et = it - 1; Et >= 0; --Et) {
            const Mr = v(ht[Et], !0);
            Mr.__removalCount = (B.__removalCount || 0) + 1, Re.insertBefore(Mr, S(B));
          }
        }
      }
      return _r(B), !0;
    }
    return B instanceof a && !A5(B) || (ee === "noscript" || ee === "noembed" || ee === "noframes") && wt(/<\/no(script|embed|frames)/i, B.innerHTML) ? (_r(B), !0) : (Wt && B.nodeType === _s.text && (U = B.textContent, ao([q, he, Z], (Re) => {
      U = As(U, Re, " ");
    }), B.textContent !== U && (Ss(e.removed, {
      element: B.cloneNode()
    }), B.textContent = U)), sn("afterSanitizeElements", B, null), !1);
  }, Bc = function(B, U, ee) {
    if (gc && (U === "id" || U === "name") && (ee in t || ee in x5))
      return !1;
    if (!(je && !Me[U] && wt(oe, U))) {
      if (!(Pe && wt(ve, U))) {
        if (!ae[U] || Me[U]) {
          if (
            // First condition does a very basic check if a) it's basically a valid custom element tagname AND
            // b) if the tagName passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.tagNameCheck
            // and c) if the attribute name passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.attributeNameCheck
            !(Oc(B) && (P.tagNameCheck instanceof RegExp && wt(P.tagNameCheck, B) || P.tagNameCheck instanceof Function && P.tagNameCheck(B)) && (P.attributeNameCheck instanceof RegExp && wt(P.attributeNameCheck, U) || P.attributeNameCheck instanceof Function && P.attributeNameCheck(U)) || // Alternative, second condition checks if it's an `is`-attribute, AND
            // the value passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.tagNameCheck
            U === "is" && P.allowCustomizedBuiltInElements && (P.tagNameCheck instanceof RegExp && wt(P.tagNameCheck, ee) || P.tagNameCheck instanceof Function && P.tagNameCheck(ee)))
          ) return !1;
        } else if (!_a[U]) {
          if (!wt(fe, As(ee, pe, ""))) {
            if (!((U === "src" || U === "xlink:href" || U === "href") && B !== "script" && LA(ee, "data:") === 0 && yc[B])) {
              if (!(Ye && !wt(_e, As(ee, pe, "")))) {
                if (ee)
                  return !1;
              }
            }
          }
        }
      }
    }
    return !0;
  }, Oc = function(B) {
    return B !== "annotation-xml" && Rm(B, H);
  }, Rc = function(B) {
    sn("beforeSanitizeAttributes", B, null);
    const {
      attributes: U
    } = B;
    if (!U)
      return;
    const ee = {
      attrName: "",
      attrValue: "",
      keepAttr: !0,
      allowedAttributes: ae
    };
    let Re = U.length;
    for (; Re--; ) {
      const ht = U[Re], {
        name: it,
        namespaceURI: Et,
        value: Mr
      } = ht, cs = rt(it);
      let vt = it === "value" ? Mr : NA(Mr);
      if (ee.attrName = cs, ee.attrValue = vt, ee.keepAttr = !0, ee.forceKeepAttr = void 0, sn("uponSanitizeAttribute", B, ee), vt = ee.attrValue, ee.forceKeepAttr || (xl(it, B), !ee.keepAttr))
        continue;
      if (!Mt && wt(/\/>/i, vt)) {
        xl(it, B);
        continue;
      }
      Wt && ao([q, he, Z], (Nc) => {
        vt = As(vt, Nc, " ");
      });
      const Lc = rt(B.nodeName);
      if (Bc(Lc, cs, vt)) {
        if (bc && (cs === "id" || cs === "name") && (xl(it, B), vt = v5 + vt), hr && wt(/((--!?|])>)|<\/(style|title)/i, vt)) {
          xl(it, B);
          continue;
        }
        if (A && typeof m == "object" && typeof m.getAttributeType == "function" && !Et)
          switch (m.getAttributeType(Lc, cs)) {
            case "TrustedHTML": {
              vt = A.createHTML(vt);
              break;
            }
            case "TrustedScriptURL": {
              vt = A.createScriptURL(vt);
              break;
            }
          }
        try {
          Et ? B.setAttributeNS(Et, it, vt) : B.setAttribute(it, vt), Tc(B) ? _r(B) : Om(e.removed);
        } catch {
        }
      }
    }
    sn("afterSanitizeAttributes", B, null);
  }, D5 = function te(B) {
    let U = null;
    const ee = Mc(B);
    for (sn("beforeSanitizeShadowDOM", B, null); U = ee.nextNode(); )
      sn("uponSanitizeShadowNode", U, null), !Fc(U) && (U.content instanceof s && te(U.content), Rc(U));
    sn("afterSanitizeShadowDOM", B, null);
  };
  return e.sanitize = function(te) {
    let B = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, U = null, ee = null, Re = null, ht = null;
    if (Ma = !te, Ma && (te = "<!-->"), typeof te != "string" && !Ec(te))
      if (typeof te.toString == "function") {
        if (te = te.toString(), typeof te != "string")
          throw Ds("dirty is not a string, aborting");
      } else
        throw Ds("toString is not a function");
    if (!e.isSupported)
      return te;
    if (Tt || Ea(B), e.removed = [], typeof te == "string" && (us = !1), us) {
      if (te.nodeName) {
        const Mr = rt(te.nodeName);
        if (!J[Mr] || ze[Mr])
          throw Ds("root node is forbidden and cannot be sanitized in-place");
      }
    } else if (te instanceof o)
      U = _c("<!---->"), ee = U.ownerDocument.importNode(te, !0), ee.nodeType === _s.element && ee.nodeName === "BODY" || ee.nodeName === "HTML" ? U = ee : U.appendChild(ee);
    else {
      if (!Cr && !Wt && !bt && // eslint-disable-next-line unicorn/prefer-includes
      te.indexOf("<") === -1)
        return A && rn ? A.createHTML(te) : te;
      if (U = _c(te), !U)
        return Cr ? null : rn ? C : "";
    }
    U && Dr && _r(U.firstChild);
    const it = Mc(us ? te : U);
    for (; Re = it.nextNode(); )
      Fc(Re) || (Re.content instanceof s && D5(Re.content), Rc(Re));
    if (us)
      return te;
    if (Cr) {
      if (tn)
        for (ht = L.call(U.ownerDocument); U.firstChild; )
          ht.appendChild(U.firstChild);
      else
        ht = U;
      return (ae.shadowroot || ae.shadowrootmode) && (ht = N.call(r, ht, !0)), ht;
    }
    let Et = bt ? U.outerHTML : U.innerHTML;
    return bt && J["!doctype"] && U.ownerDocument && U.ownerDocument.doctype && U.ownerDocument.doctype.name && wt(g5, U.ownerDocument.doctype.name) && (Et = "<!DOCTYPE " + U.ownerDocument.doctype.name + `>
` + Et), Wt && ao([q, he, Z], (Mr) => {
      Et = As(Et, Mr, " ");
    }), A && rn ? A.createHTML(Et) : Et;
  }, e.setConfig = function() {
    let te = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Ea(te), Tt = !0;
  }, e.clearConfig = function() {
    Si = null, Tt = !1;
  }, e.isValidAttribute = function(te, B, U) {
    Si || Ea({});
    const ee = rt(te), Re = rt(B);
    return Bc(ee, Re, U);
  }, e.addHook = function(te, B) {
    typeof B == "function" && (W[te] = W[te] || [], Ss(W[te], B));
  }, e.removeHook = function(te) {
    if (W[te])
      return Om(W[te]);
  }, e.removeHooks = function(te) {
    W[te] && (W[te] = []);
  }, e.removeAllHooks = function() {
    W = {};
  }, e;
}
b5();
const {
  SvelteComponent: ZA,
  append_hydration: JA,
  attr: QA,
  children: eD,
  claim_element: tD,
  claim_text: rD,
  detach: Hm,
  element: nD,
  init: iD,
  insert_hydration: sD,
  noop: qm,
  safe_not_equal: lD,
  set_data: oD,
  text: aD,
  toggle_class: Ti
} = window.__gradio__svelte__internal;
function uD(n) {
  let e, t = (
    /*value*/
    (n[0] ? (
      /*value*/
      n[0]
    ) : "") + ""
  ), r;
  return {
    c() {
      e = nD("pre"), r = aD(t), this.h();
    },
    l(i) {
      e = tD(i, "PRE", { class: !0 });
      var s = eD(e);
      r = rD(s, t), s.forEach(Hm), this.h();
    },
    h() {
      QA(e, "class", "svelte-1ioyqn2"), Ti(
        e,
        "table",
        /*type*/
        n[1] === "table"
      ), Ti(
        e,
        "gallery",
        /*type*/
        n[1] === "gallery"
      ), Ti(
        e,
        "selected",
        /*selected*/
        n[2]
      );
    },
    m(i, s) {
      sD(i, e, s), JA(e, r);
    },
    p(i, [s]) {
      s & /*value*/
      1 && t !== (t = /*value*/
      (i[0] ? (
        /*value*/
        i[0]
      ) : "") + "") && oD(r, t), s & /*type*/
      2 && Ti(
        e,
        "table",
        /*type*/
        i[1] === "table"
      ), s & /*type*/
      2 && Ti(
        e,
        "gallery",
        /*type*/
        i[1] === "gallery"
      ), s & /*selected*/
      4 && Ti(
        e,
        "selected",
        /*selected*/
        i[2]
      );
    },
    i: qm,
    o: qm,
    d(i) {
      i && Hm(e);
    }
  };
}
function hD(n, e, t) {
  let { value: r } = e, { type: i } = e, { selected: s = !1 } = e;
  return n.$$set = (l) => {
    "value" in l && t(0, r = l.value), "type" in l && t(1, i = l.type), "selected" in l && t(2, s = l.selected);
  }, [r, i, s];
}
class VD extends ZA {
  constructor(e) {
    super(), iD(this, e, hD, uD, lD, { value: 0, type: 1, selected: 2 });
  }
}
const {
  SvelteComponent: cD,
  add_flush_callback: fD,
  assign: dD,
  bind: mD,
  binding_callbacks: pD,
  check_outros: gD,
  claim_component: di,
  claim_space: eh,
  create_component: mi,
  destroy_component: pi,
  detach: Do,
  empty: Vm,
  get_spread_object: bD,
  get_spread_update: vD,
  group_outros: yD,
  init: wD,
  insert_hydration: Co,
  mount_component: gi,
  safe_not_equal: kD,
  space: th,
  transition_in: hn,
  transition_out: cn
} = window.__gradio__svelte__internal, { afterUpdate: xD } = window.__gradio__svelte__internal;
function SD(n) {
  let e, t, r, i, s;
  e = new hw({
    props: {
      language: (
        /*language*/
        n[2]
      ),
      value: (
        /*value*/
        n[0]
      )
    }
  });
  function l(a) {
    n[16](a);
  }
  let o = {
    language: (
      /*language*/
      n[2]
    ),
    lines: (
      /*lines*/
      n[3]
    ),
    dark_mode: (
      /*dark_mode*/
      n[13]
    ),
    highlights: (
      /*highlights*/
      n[11]
    ),
    readonly: !/*interactive*/
    n[12]
  };
  return (
    /*value*/
    n[0] !== void 0 && (o.value = /*value*/
    n[0]), r = new kv({ props: o }), pD.push(() => mD(r, "value", l)), r.$on(
      "blur",
      /*blur_handler*/
      n[17]
    ), r.$on(
      "focus",
      /*focus_handler*/
      n[18]
    ), {
      c() {
        mi(e.$$.fragment), t = th(), mi(r.$$.fragment);
      },
      l(a) {
        di(e.$$.fragment, a), t = eh(a), di(r.$$.fragment, a);
      },
      m(a, u) {
        gi(e, a, u), Co(a, t, u), gi(r, a, u), s = !0;
      },
      p(a, u) {
        const h = {};
        u & /*language*/
        4 && (h.language = /*language*/
        a[2]), u & /*value*/
        1 && (h.value = /*value*/
        a[0]), e.$set(h);
        const c = {};
        u & /*language*/
        4 && (c.language = /*language*/
        a[2]), u & /*lines*/
        8 && (c.lines = /*lines*/
        a[3]), u & /*highlights*/
        2048 && (c.highlights = /*highlights*/
        a[11]), u & /*interactive*/
        4096 && (c.readonly = !/*interactive*/
        a[12]), !i && u & /*value*/
        1 && (i = !0, c.value = /*value*/
        a[0], fD(() => i = !1)), r.$set(c);
      },
      i(a) {
        s || (hn(e.$$.fragment, a), hn(r.$$.fragment, a), s = !0);
      },
      o(a) {
        cn(e.$$.fragment, a), cn(r.$$.fragment, a), s = !1;
      },
      d(a) {
        a && Do(t), pi(e, a), pi(r, a);
      }
    }
  );
}
function AD(n) {
  let e, t;
  return e = new oA({
    props: {
      unpadded_box: !0,
      size: "large",
      $$slots: { default: [DD] },
      $$scope: { ctx: n }
    }
  }), {
    c() {
      mi(e.$$.fragment);
    },
    l(r) {
      di(e.$$.fragment, r);
    },
    m(r, i) {
      gi(e, r, i), t = !0;
    },
    p(r, i) {
      const s = {};
      i & /*$$scope*/
      1048576 && (s.$$scope = { dirty: i, ctx: r }), e.$set(s);
    },
    i(r) {
      t || (hn(e.$$.fragment, r), t = !0);
    },
    o(r) {
      cn(e.$$.fragment, r), t = !1;
    },
    d(r) {
      pi(e, r);
    }
  };
}
function DD(n) {
  let e, t;
  return e = new N4({}), {
    c() {
      mi(e.$$.fragment);
    },
    l(r) {
      di(e.$$.fragment, r);
    },
    m(r, i) {
      gi(e, r, i), t = !0;
    },
    i(r) {
      t || (hn(e.$$.fragment, r), t = !0);
    },
    o(r) {
      cn(e.$$.fragment, r), t = !1;
    },
    d(r) {
      pi(e, r);
    }
  };
}
function CD(n) {
  let e, t, r, i, s, l, o, a;
  const u = [
    { autoscroll: (
      /*gradio*/
      n[1].autoscroll
    ) },
    { i18n: (
      /*gradio*/
      n[1].i18n
    ) },
    /*loading_status*/
    n[9]
  ];
  let h = {};
  for (let g = 0; g < u.length; g += 1)
    h = dD(h, u[g]);
  e = new FA({ props: h }), r = new ES({
    props: {
      Icon: N4,
      show_label: (
        /*show_label*/
        n[8]
      ),
      label: (
        /*label*/
        n[7]
      ),
      float: !1
    }
  });
  const c = [AD, SD], f = [];
  function m(g, v) {
    return !/*value*/
    g[0] && !/*interactive*/
    g[12] ? 0 : 1;
  }
  return s = m(n), l = f[s] = c[s](n), {
    c() {
      mi(e.$$.fragment), t = th(), mi(r.$$.fragment), i = th(), l.c(), o = Vm();
    },
    l(g) {
      di(e.$$.fragment, g), t = eh(g), di(r.$$.fragment, g), i = eh(g), l.l(g), o = Vm();
    },
    m(g, v) {
      gi(e, g, v), Co(g, t, v), gi(r, g, v), Co(g, i, v), f[s].m(g, v), Co(g, o, v), a = !0;
    },
    p(g, v) {
      const k = v & /*gradio, loading_status*/
      514 ? vD(u, [
        v & /*gradio*/
        2 && { autoscroll: (
          /*gradio*/
          g[1].autoscroll
        ) },
        v & /*gradio*/
        2 && { i18n: (
          /*gradio*/
          g[1].i18n
        ) },
        v & /*loading_status*/
        512 && bD(
          /*loading_status*/
          g[9]
        )
      ]) : {};
      e.$set(k);
      const S = {};
      v & /*show_label*/
      256 && (S.show_label = /*show_label*/
      g[8]), v & /*label*/
      128 && (S.label = /*label*/
      g[7]), r.$set(S);
      let x = s;
      s = m(g), s === x ? f[s].p(g, v) : (yD(), cn(f[x], 1, 1, () => {
        f[x] = null;
      }), gD(), l = f[s], l ? l.p(g, v) : (l = f[s] = c[s](g), l.c()), hn(l, 1), l.m(o.parentNode, o));
    },
    i(g) {
      a || (hn(e.$$.fragment, g), hn(r.$$.fragment, g), hn(l), a = !0);
    },
    o(g) {
      cn(e.$$.fragment, g), cn(r.$$.fragment, g), cn(l), a = !1;
    },
    d(g) {
      g && (Do(t), Do(i), Do(o)), pi(e, g), pi(r, g), f[s].d(g);
    }
  };
}
function _D(n) {
  let e, t;
  return e = new Iw({
    props: {
      variant: "solid",
      padding: !1,
      elem_id: (
        /*elem_id*/
        n[4]
      ),
      elem_classes: (
        /*elem_classes*/
        n[5]
      ),
      visible: (
        /*visible*/
        n[6]
      ),
      scale: (
        /*scale*/
        n[10]
      ),
      $$slots: { default: [CD] },
      $$scope: { ctx: n }
    }
  }), {
    c() {
      mi(e.$$.fragment);
    },
    l(r) {
      di(e.$$.fragment, r);
    },
    m(r, i) {
      gi(e, r, i), t = !0;
    },
    p(r, [i]) {
      const s = {};
      i & /*elem_id*/
      16 && (s.elem_id = /*elem_id*/
      r[4]), i & /*elem_classes*/
      32 && (s.elem_classes = /*elem_classes*/
      r[5]), i & /*visible*/
      64 && (s.visible = /*visible*/
      r[6]), i & /*scale*/
      1024 && (s.scale = /*scale*/
      r[10]), i & /*$$scope, value, interactive, language, lines, highlights, gradio, show_label, label, loading_status*/
      1055631 && (s.$$scope = { dirty: i, ctx: r }), e.$set(s);
    },
    i(r) {
      t || (hn(e.$$.fragment, r), t = !0);
    },
    o(r) {
      cn(e.$$.fragment, r), t = !1;
    },
    d(r) {
      pi(e, r);
    }
  };
}
function MD(n, e, t) {
  let { gradio: r } = e, { value: i = "" } = e, { value_is_output: s = !1 } = e, { language: l = "" } = e, { lines: o = 5 } = e, { target: a } = e, { elem_id: u = "" } = e, { elem_classes: h = [] } = e, { visible: c = !0 } = e, { label: f = r.i18n("code.code") } = e, { show_label: m = !0 } = e, { loading_status: g } = e, { scale: v = null } = e, { highlights: k = [] } = e, { interactive: S } = e, x = a.classList.contains("dark");
  function y() {
    r.dispatch("change", i), s || r.dispatch("input");
  }
  xD(() => {
    t(14, s = !1);
  });
  function A(M) {
    i = M, t(0, i);
  }
  const C = () => r.dispatch("blur"), T = () => r.dispatch("focus");
  return n.$$set = (M) => {
    "gradio" in M && t(1, r = M.gradio), "value" in M && t(0, i = M.value), "value_is_output" in M && t(14, s = M.value_is_output), "language" in M && t(2, l = M.language), "lines" in M && t(3, o = M.lines), "target" in M && t(15, a = M.target), "elem_id" in M && t(4, u = M.elem_id), "elem_classes" in M && t(5, h = M.elem_classes), "visible" in M && t(6, c = M.visible), "label" in M && t(7, f = M.label), "show_label" in M && t(8, m = M.show_label), "loading_status" in M && t(9, g = M.loading_status), "scale" in M && t(10, v = M.scale), "highlights" in M && t(11, k = M.highlights), "interactive" in M && t(12, S = M.interactive);
  }, n.$$.update = () => {
    n.$$.dirty & /*value*/
    1 && y();
  }, [
    i,
    r,
    l,
    o,
    u,
    h,
    c,
    f,
    m,
    g,
    v,
    k,
    S,
    x,
    s,
    a,
    A,
    C,
    T
  ];
}
class WD extends cD {
  constructor(e) {
    super(), wD(this, e, MD, _D, kD, {
      gradio: 1,
      value: 0,
      value_is_output: 14,
      language: 2,
      lines: 3,
      target: 15,
      elem_id: 4,
      elem_classes: 5,
      visible: 6,
      label: 7,
      show_label: 8,
      loading_status: 9,
      scale: 10,
      highlights: 11,
      interactive: 12
    });
  }
}
export {
  Ki as A,
  ND as B,
  t9 as C,
  b8 as D,
  I as E,
  Q as F,
  LD as G,
  P7 as H,
  Ve as I,
  g7 as J,
  WD as K,
  Tu as L,
  VD as M,
  ED as N,
  Xy as O,
  pg as P,
  gy as Q,
  kv as R,
  Oi as S,
  $t as T,
  hw as W,
  nt as a,
  V7 as b,
  ID as c,
  RD as d,
  OD as e,
  J7 as f,
  n9 as g,
  PD as h,
  zD as i,
  Dt as j,
  we as k,
  gh as l,
  Le as m,
  rs as n,
  al as o,
  FD as p,
  oa as q,
  Se as r,
  R7 as s,
  E as t,
  Jt as u,
  ua as v,
  vg as w,
  Jn as x,
  Z7 as y,
  wg as z
};
